(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    121697,       3612]
NotebookOptionsPosition[    115538,       3510]
NotebookOutlinePosition[    115874,       3525]
CellTagsIndexPosition[    115831,       3522]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Compiling", " ", "all", " ", "of", " ", "the"}], " ", "-", 
   "Drift", "+", 
   RowBox[{
   "Kepler", " ", "results", " ", "from", " ", "the", " ", "other", " ", 
    RowBox[{"notebooks", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776691265974856*^9, 3.776691283656739*^9}},
 CellLabel->"In[85]:=",ExpressionUUID->"66d95d8a-2d5b-4630-b86a-bba9ba5374c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Defining", " ", "terms", " ", "which", " ", "are", " ", "used", " ", 
    RowBox[{"frequently", ":"}]}], " ", "*)"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.776691423293016*^9, 3.7766914321337957`*^9}},
 CellLabel->"In[88]:=",ExpressionUUID->"0c68b6db-41b8-4681-98f9-b85cce6aa12d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c1", " ", "=", " ", 
  RowBox[{"d", "-", 
   RowBox[{"r0", " ", "g3"}]}]}]], "Input",
 CellChangeTimes->{{3.776691465508732*^9, 3.776691472797203*^9}, {
  3.776691697521482*^9, 3.7766917009578867`*^9}},
 CellLabel->"In[94]:=",ExpressionUUID->"5e50fe82-9cbc-4d37-92a4-b9b6432d73af"],

Cell[BoxData[
 RowBox[{"d", "-", 
  RowBox[{"g3", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.7766914736771717`*^9, 3.776691701516733*^9},
 CellLabel->"Out[94]=",ExpressionUUID->"cf228877-6822-4c35-9393-6c0e42ffdde2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"dlnfdot", " ", "=", " ", 
   RowBox[{
    RowBox[{"dk", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", "k"], "-", 
       FractionBox["1", 
        RowBox[{"beta", " ", "r0"}]], "+", 
       FractionBox[
        RowBox[{"g0", " ", 
         RowBox[{"(", 
          RowBox[{"d", "-", 
           RowBox[{"r0", " ", "g3"}]}], ")"}]}], 
        RowBox[{"g1", " ", "r", " ", "r0"}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"g2", " ", "k"}], "+", "r", "-", "r0"}], 
        RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{"d", "-", 
           RowBox[{"r0", " ", "g3"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "g0"}], "+", 
           RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
        RowBox[{
         SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
    RowBox[{"dx0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{" ", "g2"}], 
            RowBox[{"g1", " ", "r"}]]}], "-", 
          FractionBox[
           RowBox[{"g2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["k", 
           RowBox[{"beta", " ", 
            SuperscriptBox["r0", "3"]}]], "-", 
          FractionBox["1", 
           SuperscriptBox["r0", "2"]], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g1"}], "+", 
              RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}]}], 
           RowBox[{"beta", " ", "r", " ", 
            SuperscriptBox["r0", "3"]}]], "+", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "-", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"eta", " ", "g0"}], "+", 
                 RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "-", 
              RowBox[{"g0", " ", "r"}]}], " ", ")"}]}], 
           RowBox[{"g1", " ", 
            SuperscriptBox["r", "2"], " ", 
            SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{"dh", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["g0", 
        RowBox[{"g1", " ", "r"}]], "-", 
       FractionBox[
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], 
        SuperscriptBox["r", "2"]], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "beta"}], "+", 
          FractionBox[
           RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"g0", " ", "g2"}], 
            RowBox[{"g1", " ", "r"}]]}], "+", 
          FractionBox[
           SuperscriptBox["g1", "2"], 
           RowBox[{"g1", " ", "r"}]], "+", 
          FractionBox[
           RowBox[{"g2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
       RowBox[{"eta", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["k", 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "3"]}]]}], "+", 
          FractionBox["1", 
           SuperscriptBox["r0", "2"]], "+", 
          FractionBox[
           RowBox[{"g0", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "-", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}]}], 
           RowBox[{"g1", " ", "r", " ", 
            SuperscriptBox["r0", "3"]}]], "+", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g1"}], "+", 
              RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}]}], 
           RowBox[{"beta", " ", "r", " ", 
            SuperscriptBox["r0", "3"]}]], "-", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "-", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", 
            SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{"dv0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", "beta"], "-", 
          FractionBox[
           RowBox[{"d", " ", "g0"}], 
           RowBox[{"g1", " ", "r"}]], "-", 
          FractionBox[
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g2", " ", "k"}]}], 
           RowBox[{"beta", " ", "r"}]], "+", 
          FractionBox[
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           SuperscriptBox["r", "2"]], "-", 
          RowBox[{"h", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"g0", " ", "g2"}], 
              RowBox[{"g1", " ", "r"}]], "-", 
             FractionBox[
              RowBox[{
               RowBox[{"g1", " ", "r"}], "+", 
               RowBox[{"g2", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"eta", " ", "g0"}], "+", 
                  RowBox[{"g1", " ", "zeta"}]}], ")"}]}]}], 
              SuperscriptBox["r", "2"]]}], ")"}]}]}], ")"}]}], "+", 
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["g1", "r"]}], "+", 
          FractionBox[
           RowBox[{"g0", " ", "g2"}], 
           RowBox[{"g1", " ", "r"}]], "-", 
          FractionBox[
           RowBox[{"g2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           SuperscriptBox["r", "2"]], "-", 
          RowBox[{"h", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox["k", 
              RowBox[{"beta", " ", 
               SuperscriptBox["r0", "3"]}]], "-", 
             FractionBox["1", 
              SuperscriptBox["r0", "2"]], "-", 
             FractionBox[
              RowBox[{"g0", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", " ", "k"}], "-", 
                 RowBox[{"g1", " ", 
                  SuperscriptBox["r0", "2"]}]}], ")"}]}], 
              RowBox[{"g1", " ", "r", " ", 
               SuperscriptBox["r0", "3"]}]], "-", 
             FractionBox[
              RowBox[{"k", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"eta", " ", "g1"}], "+", 
                 RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}]}], 
              RowBox[{"beta", " ", "r", " ", 
               SuperscriptBox["r0", "3"]}]], "+", 
             FractionBox[
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", " ", "k"}], "-", 
                 RowBox[{"g1", " ", 
                  SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"eta", " ", "g0"}], "+", 
                 RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r", "2"], " ", 
               SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}], 
      ")"}]}]}]}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{
  3.776691332932624*^9, 3.7766913935329933`*^9, {3.7766915659546947`*^9, 
   3.776691586061574*^9}, {3.776691705071649*^9, 3.776691705334216*^9}},
 CellLabel->"In[90]:=",ExpressionUUID->"cb606c02-a60e-4d23-ad2c-371cb5cfe5d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "k"], "-", 
     FractionBox["1", 
      RowBox[{"beta", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g2", " ", "k"}], "+", "r", "-", "r0"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"g1", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["g0", 
      RowBox[{"g1", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", "zeta"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "beta"}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["g1", "r"], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["k", 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]]}], "+", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"g0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g1", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g2", 
          RowBox[{"g1", " ", "r"}]]}], "-", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "g0"}], " ", "r"}], "+", 
            RowBox[{"g1", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}]}], ")"}]}], 
         RowBox[{"g1", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "+", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "-", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox["k", 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox["1", 
            SuperscriptBox["r0", "2"]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g1"}], "+", 
               RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{"g0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "-", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"g1", " ", "r", " ", 
             SuperscriptBox["r0", "3"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "-", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", "beta"], "-", 
        FractionBox[
         RowBox[{"d", " ", "g0"}], 
         RowBox[{"g1", " ", "r"}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"eta", " ", "g1"}], "+", 
          RowBox[{"2", " ", "g2", " ", "k"}]}], 
         RowBox[{"beta", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"g0", " ", "g2"}], 
            RowBox[{"g1", " ", "r"}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{"g1", " ", "r"}], "+", 
             RowBox[{"g2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}]}], 
            SuperscriptBox["r", "2"]]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.776691638718503*^9},
 CellLabel->"Out[90]=",ExpressionUUID->"9a04da87-0853-4cfd-952a-1ce497564724"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dlnf", " ", "=", " ", 
  RowBox[{
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["g1", 
       RowBox[{"g2", " ", "r"}]], "+", 
      FractionBox[
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", "  ", "k"}], "-", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], "-", 
          RowBox[{"g2", " ", 
           SuperscriptBox["r0", "2"], 
           RowBox[{"(", 
            RowBox[{"k", "+", "zeta"}], " ", ")"}]}]}], ")"}]}], 
       RowBox[{"g2", " ", "r", " ", 
        SuperscriptBox["r0", "3"]}]], "-", 
      FractionBox[
       RowBox[{"2", " ", "eta", " ", "k"}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "3"]}]], "+", 
      FractionBox["eta", 
       SuperscriptBox["r0", "2"]]}], ")"}]}], "+", 
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", "k"], "+", 
      FractionBox[
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"r0", " ", "g3"}]}], ")"}]}], 
       RowBox[{"g2", " ", "r", " ", "r0"}]], "-", 
      FractionBox["2", 
       RowBox[{"beta", " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g1", " ", "v0"}], "r"], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "  ", "k"}], "-", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}]}], 
           RowBox[{"g2", " ", "r", " ", 
            SuperscriptBox["r0", "3"]}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", "k"}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox["1", 
          SuperscriptBox["r0", "2"]]}], ")"}], " ", "x0"}]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["2", "beta"], "-", 
         FractionBox[
          RowBox[{"d", " ", "g1"}], 
          RowBox[{"g2", " ", "r"}]], "-", 
         FractionBox[
          RowBox[{"g1", " ", "h"}], "r"]}], ")"}], " ", "v0"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["g1", "r"], "+", 
         FractionBox[
          RowBox[{"g1", " ", "h", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "-", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{"g2", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{"2", " ", "h", " ", "k"}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox["h", 
          SuperscriptBox["r0", "2"]]}], ")"}], " ", "x0"}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776691320999022*^9, 3.77669133015523*^9}, 
   3.776691631208848*^9},
 CellLabel->"In[91]:=",ExpressionUUID->"00e8da88-ebd2-4017-a133-efbfb080bdda"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "k"], "-", 
     FractionBox["2", 
      RowBox[{"beta", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g1", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"g2", " ", "r", " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "v0"}], "r"], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"2", " ", "k"}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"g1", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g2", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}], " ", "x0"}]}], ")"}]}], "+", 
  
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["2", "beta"], "-", 
        FractionBox[
         RowBox[{"d", " ", "g1"}], 
         RowBox[{"g2", " ", "r"}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "h"}], "r"]}], ")"}], " ", "v0"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["g1", "r"], "-", 
        FractionBox[
         RowBox[{"2", " ", "h", " ", "k"}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox["h", 
         SuperscriptBox["r0", "2"]], "+", 
        FractionBox[
         RowBox[{"g1", " ", "h", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g2", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}], " ", "x0"}]}], ")"}]}], "+", 
  
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["g1", 
      RowBox[{"g2", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{"2", " ", "eta", " ", "k"}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox["eta", 
      SuperscriptBox["r0", "2"]], "+", 
     FractionBox[
      RowBox[{"g1", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], "-", 
         RowBox[{"g2", " ", 
          SuperscriptBox["r0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"k", "+", "zeta"}], ")"}]}]}], ")"}]}], 
      RowBox[{"g2", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776691641739093*^9},
 CellLabel->"Out[91]=",ExpressionUUID->"87cf5d4e-ab81-45eb-8dd3-3810fb8be834"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"dgdotmhfdotm1", " ", "=", "  ", 
   RowBox[{
    RowBox[{"dk", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{"d", "-", 
           RowBox[{"r0", " ", "g3"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g0", " ", "h"}], "-", 
           RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
        RowBox[{
         SuperscriptBox["r", "2"], " ", 
         SuperscriptBox["r0", "2"]}]], "-", 
       FractionBox[
        RowBox[{" ", 
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"2", "g2", " ", "r0"}]}], ")"}]}]}], 
        RowBox[{"beta", " ", "r", " ", 
         SuperscriptBox["r0", "2"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], 
        RowBox[{"r", " ", "r0"}]], "-", 
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], 
         " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "h"}], "-", 
           RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
        RowBox[{"beta", " ", 
         SuperscriptBox["r", "2"], " ", 
         SuperscriptBox["r0", "2"]}]], "-", 
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{"d", "-", 
           RowBox[{"r0", " ", "g3"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "h"}], "-", 
           RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "g0"}], "+", 
           RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
        RowBox[{
         SuperscriptBox["r", "3"], " ", 
         SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
    RowBox[{"dh", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"g1", " ", "k"}], 
        RowBox[{"r", " ", "r0"}]], "+", 
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g0", " ", "h"}], "-", 
           RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
        RowBox[{
         SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "h"}], "-", 
           RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "g0"}], "+", 
           RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
        RowBox[{
         SuperscriptBox["r", "3"], " ", "r0"}]], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "beta"}], "+", 
          FractionBox[
           RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"g2", " ", "k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g0", " ", "h"}], "-", 
               RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", "r0"}]]}], "+", 
          FractionBox[
           RowBox[{"g1", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
       RowBox[{"eta", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"g2", " ", "k"}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "2"]}]], "+", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "-", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", 
            SuperscriptBox["r0", "4"]}]], "-", 
          FractionBox[
           RowBox[{" ", 
            RowBox[{
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"2", "g2", " ", "r0"}]}], ")"}]}]}], 
           RowBox[{"beta", " ", "r", " ", 
            SuperscriptBox["r0", "4"]}]], "+", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "3"]}]], "+", 
          FractionBox[
           RowBox[{
            SuperscriptBox["k", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g1"}], "+", 
              RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{"beta", " ", 
            SuperscriptBox["r", "2"], " ", 
            SuperscriptBox["r0", "4"]}]], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "-", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "3"], " ", 
            SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{"dx0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
          FractionBox[
           RowBox[{"g1", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"g2", " ", "k"}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "2"]}]]}], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "-", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", 
            SuperscriptBox["r0", "4"]}]], "+", 
          FractionBox[
           RowBox[{" ", 
            RowBox[{
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"2", "g2", " ", "r0"}]}], ")"}]}]}], 
           RowBox[{"beta", " ", "r", " ", 
            SuperscriptBox["r0", "4"]}]], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "3"]}]], "-", 
          FractionBox[
           RowBox[{
            SuperscriptBox["k", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g1"}], "+", 
              RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{"beta", " ", 
            SuperscriptBox["r", "2"], " ", 
            SuperscriptBox["r0", "4"]}]], "+", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "-", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "3"], " ", 
            SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{"dv0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"d", " ", "k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g0", " ", "h"}], "-", 
               RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
          FractionBox[
           RowBox[{"g2", " ", "h", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
          FractionBox[
           RowBox[{" ", 
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"2", "g2", " ", "r0"}]}], ")"}]}]}], 
           RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
          FractionBox[
           RowBox[{"g1", " ", "h", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g1"}], "+", 
              RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{"beta", " ", 
            SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
          FractionBox[
           RowBox[{"d", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "3"], " ", "r0"}]], "+", 
          FractionBox[
           RowBox[{"g2", " ", "h", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"g2", " ", "h", " ", "k"}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "2"]}]], "+", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
          FractionBox[
           RowBox[{"h", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "-", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", 
            SuperscriptBox["r0", "4"]}]], "-", 
          FractionBox[
           RowBox[{" ", 
            RowBox[{"h", " ", 
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"2", "g2", " ", "r0"}]}], ")"}]}]}], 
           RowBox[{"beta", " ", "r", " ", 
            SuperscriptBox["r0", "4"]}]], "+", 
          FractionBox[
           RowBox[{"h", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "3"]}]], "-", 
          FractionBox[
           RowBox[{"g1", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
          FractionBox[
           RowBox[{"h", " ", 
            SuperscriptBox["k", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g1"}], "+", 
              RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{"beta", " ", 
            SuperscriptBox["r", "2"], " ", 
            SuperscriptBox["r0", "4"]}]], "-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
          FractionBox[
           RowBox[{"h", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "-", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "3"], " ", 
            SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.776691310735848*^9, 3.7766913185542307`*^9}, {
  3.77669144218925*^9, 3.776691447381774*^9}},
 CellLabel->"In[92]:=",ExpressionUUID->"85ce4305-8ca9-4e99-a9c5-b28b351de8b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"2", " ", "g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g1", " ", "h"}], "-", 
       RowBox[{"g2", " ", "r0"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "beta"}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "+", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"g2", " ", "k"}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "2"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"2", " ", "g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"2", " ", "g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g2", " ", "h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"2", " ", "g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g1", " ", "h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"g2", " ", "h", " ", "k"}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "2"]}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"h", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"2", " ", "g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"h", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776691644792139*^9},
 CellLabel->"Out[92]=",ExpressionUUID->"c8c5ca50-a29c-4421-a2d2-a6db14db5808"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgmhf", " ", "=", 
  RowBox[{
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"eta", " ", "g3", " ", "k"}], 
       SuperscriptBox["r0", "2"]], "+", 
      FractionBox[
       RowBox[{"g2", " ", "k"}], "r0"], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "-", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], "-", 
          RowBox[{"g2", " ", 
           SuperscriptBox["r0", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "beta"}], " ", "r0"}], "+", 
             RowBox[{"2", " ", "k"}]}], ")"}]}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", 
        SuperscriptBox["r0", "4"]}]], "+", 
      FractionBox[
       RowBox[{"eta", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g2", " ", "h"}], "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       SuperscriptBox["r0", "3"]], "-", 
      FractionBox[
       RowBox[{" ", 
        RowBox[{"eta", " ", 
         SuperscriptBox["k", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "g2", " ", "h"}], "+", 
           RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "4"]}]]}], ")"}]}], "+", 
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", 
        SuperscriptBox["r0", "2"]}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"g2", " ", "h"}], "-", 
        RowBox[{"g3", " ", "r0"}]}], "r0"], "-", 
      FractionBox[
       RowBox[{" ", 
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "g2", " ", "h"}], "+", 
           RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "v0"}], 
       RowBox[{"r", " ", "r0"}]], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g3", " ", "k"}], 
           SuperscriptBox["r0", "2"]]}], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "-", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "h"}], "-", 
             RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
          SuperscriptBox["r0", "3"]], "+", 
         FractionBox[
          RowBox[{
           SuperscriptBox["k", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", "g2", " ", "h"}], "+", 
             RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "4"]}]]}], ")"}], " ", "x0"}]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"d", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{"r", " ", "r0"}]]}], "-", 
         FractionBox[
          RowBox[{"g2", " ", "h", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{" ", 
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "g2", " ", "h"}], "+", 
              RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}]}], 
          RowBox[{"beta", " ", "r0"}]]}], ")"}], " ", "v0"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"g3", " ", "h", " ", "k"}], 
          SuperscriptBox["r0", "2"]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"h", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "-", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "4"]}]], "+", 
         FractionBox[
          RowBox[{"h", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "h"}], "-", 
             RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
          SuperscriptBox["r0", "3"]], "-", 
         FractionBox[
          RowBox[{"h", " ", 
           SuperscriptBox["k", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", "g2", " ", "h"}], "+", 
             RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "4"]}]]}], ")"}], " ", "x0"}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{3.776691308162664*^9, 3.7767116794838543`*^9},
 CellLabel->
  "In[204]:=",ExpressionUUID->"4fbe6a8f-800f-4fc4-9f53-ab19878a91c8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g2", " ", "h"}], "-", 
       RowBox[{"g3", " ", "r0"}]}], "r0"], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "h"}], "+", 
         RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"eta", " ", "g3", " ", "k"}], 
      SuperscriptBox["r0", "2"]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k"}], "r0"], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"eta", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "h"}], "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      SuperscriptBox["r0", "3"]], "-", 
     FractionBox[
      RowBox[{"eta", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "h"}], "+", 
         RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "4"]}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", 
          SuperscriptBox["r0", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "k"}], "-", 
            RowBox[{"beta", " ", "r0"}]}], ")"}]}], "+", 
         RowBox[{"eta", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "4"]}]]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "v0"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "+", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}], " ", "x0"}]}], ")"}]}], "+", 
  
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g2", " ", "h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "+", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r0"}]]}], ")"}], " ", "v0"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"g3", " ", "h", " ", "k"}], 
         SuperscriptBox["r0", "2"]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"h", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "+", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}], " ", "x0"}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.776691646975541*^9, 3.7767116811872873`*^9},
 CellLabel->
  "Out[204]=",ExpressionUUID->"97ccf9d4-1e4c-46d5-9d61-2aeb46d705b6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["dlnfdot"], "Input",
 CellChangeTimes->{{3.776691718207993*^9, 3.776691719670343*^9}},
 CellLabel->"In[95]:=",ExpressionUUID->"af26e4c8-2a3a-44a3-b66a-2256535154ff"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "k"], "-", 
     FractionBox["1", 
      RowBox[{"beta", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g2", " ", "k"}], "+", "r", "-", "r0"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"g1", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["g0", 
      RowBox[{"g1", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", "zeta"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "beta"}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["g1", "r"], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["k", 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]]}], "+", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"g0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g1", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g2", 
          RowBox[{"g1", " ", "r"}]]}], "-", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "-", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "g0"}], " ", "r"}], "+", 
            RowBox[{"g1", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}]}], ")"}]}], 
         RowBox[{"g1", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "+", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "-", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox["k", 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox["1", 
            SuperscriptBox["r0", "2"]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g1"}], "+", 
               RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{"g0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "-", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"g1", " ", "r", " ", 
             SuperscriptBox["r0", "3"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "-", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", "beta"], "-", 
        FractionBox[
         RowBox[{"d", " ", "g0"}], 
         RowBox[{"g1", " ", "r"}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"eta", " ", "g1"}], "+", 
          RowBox[{"2", " ", "g2", " ", "k"}]}], 
         RowBox[{"beta", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"g0", " ", "g2"}], 
            RowBox[{"g1", " ", "r"}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{"g1", " ", "r"}], "+", 
             RowBox[{"g2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}]}], 
            SuperscriptBox["r", "2"]]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.776691720408148*^9},
 CellLabel->"Out[95]=",ExpressionUUID->"c9f26b1c-554a-475a-a95b-ebfc71e8b43b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Using", " ", "newly", " ", "defined", " ", "constants", " ", "to", " ", 
    "simplify", " ", "expression", " ", "for", " ", 
    RowBox[{"dlnfdot", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776691746171131*^9, 3.776691759748068*^9}, {
  3.7767091376394167`*^9, 
  3.77670914060669*^9}},ExpressionUUID->"9b5ba98d-3226-4c6b-ad4b-\
95ec6a9691b5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"c1", " ", "=", " ", 
   RowBox[{"d", "-", 
    RowBox[{"r0", " ", "g3"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776702768844173*^9, 3.7767027692112207`*^9}},
 CellLabel->
  "In[108]:=",ExpressionUUID->"37294438-ec61-4768-868c-052f5b9b4015"],

Cell[BoxData[
 RowBox[{"d", "-", 
  RowBox[{"g3", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.776702770205141*^9},
 CellLabel->
  "Out[108]=",ExpressionUUID->"bcd3161c-cce7-4c1b-b27c-38fb93c05e5d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c2", " ", "=", " ", 
  RowBox[{
   RowBox[{"eta", " ", "g0"}], " ", "+", " ", 
   RowBox[{"g1", " ", "zeta"}]}]}]], "Input",
 CellChangeTimes->{{3.7766917612683*^9, 3.776691765907963*^9}},
 CellLabel->"In[97]:=",ExpressionUUID->"67727f8d-e0b2-42ef-bebc-e5b79422da65"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g0"}], "+", 
  RowBox[{"g1", " ", "zeta"}]}]], "Output",
 CellChangeTimes->{3.7766917672931147`*^9},
 CellLabel->"Out[97]=",ExpressionUUID->"0c56eeaf-dcc6-48f5-ac28-2a4c1c2a6e67"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c3", " ", "=", " ", 
  RowBox[{
   RowBox[{"d", " ", "k"}], " ", "+", " ", 
   RowBox[{"g1", " ", 
    SuperscriptBox["r0", "2"]}]}]}]], "Input",
 CellChangeTimes->{{3.776691768556645*^9, 3.7766917752512693`*^9}, 
   3.776691862860627*^9, {3.776947845216449*^9, 
   3.776947845941228*^9}},ExpressionUUID->"8d4a5417-5ad0-4fda-bd6f-\
7fad6442e326"],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", " ", "k"}], "-", 
  RowBox[{"g1", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.776691775681072*^9, 3.776691868137331*^9},
 CellLabel->
  "Out[100]=",ExpressionUUID->"9645d858-c2ab-4574-94ca-4003e9bf8a61"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"c4", " ", "=", " ", 
  RowBox[{
   RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
   RowBox[{"2", " ", "g0", " ", "r0"}]}]}]], "Input",
 CellChangeTimes->{{3.776691777227771*^9, 3.7766917779953203`*^9}, {
  3.776691838538612*^9, 3.776691841986711*^9}},
 CellLabel->"In[99]:=",ExpressionUUID->"1a12d5c2-6a55-408c-8789-7f3ba71f1acf"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"eta", " ", "g1"}], "+", 
  RowBox[{"2", " ", "g0", " ", "r0"}]}], "\[IndentingNewLine]", 
 RowBox[{"c5", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g0", " "}], "g1"], "-", 
     FractionBox[
      RowBox[{" ", "c2"}], "r"]}], ")"}], " ", "=", 
   RowBox[{"(", 
    FractionBox[
     RowBox[{"r0", " ", "-", " ", 
      RowBox[{"k", " ", "g2", " "}]}], 
     RowBox[{"g1", " ", "r"}]], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.776702547863584*^9, 3.776702553552957*^9}, {
  3.776702785506572*^9, 3.77670278631488*^9}},
 CellLabel->
  "In[109]:=",ExpressionUUID->"8ceb8549-b6e1-434a-9fcb-8e8dcda1757f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g1"}], "+", 
  RowBox[{"2", " ", "g0", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.7767025542222233`*^9, 3.776702787836104*^9},
 CellLabel->
  "Out[109]=",ExpressionUUID->"775a4633-76f7-4dd5-a2e3-eb6c7676b30d"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "g2"}], " ", "k"}], "+", "r0"}], 
  RowBox[{"g1", " ", "r"}]]], "Output",
 CellChangeTimes->{3.7767025542222233`*^9, 3.776702787837757*^9},
 CellLabel->
  "Out[110]=",ExpressionUUID->"7bb6575e-746f-400f-9292-2368f0635cbc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c6", " ", "=", 
  FractionBox[
   RowBox[{
    RowBox[{"r0", " ", "g0"}], "-", " ", 
    RowBox[{"k", " ", "g2"}]}], "beta"]}]], "Input",
 CellChangeTimes->{{3.7767025551759644`*^9, 3.776702556063239*^9}, {
  3.776702781881503*^9, 3.7767027829700317`*^9}, {3.7767038159517317`*^9, 
  3.776703824217421*^9}},
 CellLabel->
  "In[111]:=",ExpressionUUID->"1725cc11-a84e-4c19-86eb-a86fb824c97e"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "g2"}], " ", "k"}], "+", 
   RowBox[{"g0", " ", "r0"}]}], "beta"]], "Output",
 CellChangeTimes->{3.776703825085602*^9},
 CellLabel->
  "Out[111]=",ExpressionUUID->"39318e36-7472-467b-bcaa-56ac9cdf558d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"c7", " ", "=", " ", 
  RowBox[{"g2", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "g1"], "+", 
     FractionBox["c2", "r"]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.776703870639513*^9, 3.7767038757198963`*^9}, {
  3.776704333027095*^9, 3.7767043332339993`*^9}},
 CellLabel->
  "In[124]:=",ExpressionUUID->"bcf8b2d4-6b39-4cd5-b7f1-a75099e7dd54"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"g2", " ", 
  RowBox[{"(", 
   RowBox[{
    FractionBox["1", "g1"], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], "r"]}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{"c8", " ", "=", " ", 
  FractionBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"k", " ", "c6"}], "+", " ", 
     RowBox[{"r", " ", "r0"}], "+", 
     RowBox[{"c3", " ", "c5"}]}], ")"}], 
   SuperscriptBox["r0", "3"]]}]}], "Input",
 CellChangeTimes->{{3.77670756703423*^9, 3.7767075836894217`*^9}},
 CellLabel->
  "In[178]:=",ExpressionUUID->"e0bce0a9-78eb-4178-9a56-a0a4ef578eb7"],

Cell[BoxData[
 RowBox[{"g2", " ", 
  RowBox[{"(", 
   RowBox[{
    FractionBox["1", "g1"], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], "r"]}], ")"}]}]], "Output",
 CellChangeTimes->{3.776707586519827*^9},
 CellLabel->
  "Out[178]=",ExpressionUUID->"3d9a5c98-115a-4fe1-bd77-ecb9a8ed2359"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"r", " ", "r0"}], "+", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}], "beta"], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "k"}], "+", "r0"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"d", " ", "k"}], "-", 
       RowBox[{"g1", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}]}], 
    RowBox[{"g1", " ", "r"}]]}], 
  SuperscriptBox["r0", "3"]]], "Output",
 CellChangeTimes->{3.776707586525078*^9},
 CellLabel->
  "Out[179]=",ExpressionUUID->"d7b1ff9e-35d7-4adc-9d54-b237314cdea2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"dlnfdot2", "=", " ", 
  RowBox[{
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", "k"], "-", 
      FractionBox[
       RowBox[{"g1", " ", "c5"}], 
       RowBox[{"beta", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"c1", " ", "c5"}], 
       RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dh", "r"], " ", 
    RowBox[{"(", 
     RowBox[{"c5", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"2", " ", "k", " "}], "r0"], "-", "beta"}], ")"}], " ", 
       "c7"}], "+", 
      RowBox[{"eta", " ", "c8"}]}], ")"}]}], "-", 
   RowBox[{
    FractionBox["dx0", "r"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", "c7"}], "+", 
      RowBox[{"x0", " ", "c8"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dv0", "r"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "x0"}], " ", 
       RowBox[{"(", " ", 
        RowBox[{"c7", "-", 
         RowBox[{"h", " ", "c8"}]}], ")"}]}], "+", 
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{"c6", "+", 
         RowBox[{"h", " ", "c7"}], "-", 
         RowBox[{"d", " ", "c5"}]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776691729783072*^9, 3.776691739131878*^9}, {
   3.7766917949395037`*^9, 3.7766918861620398`*^9}, {3.776691975310884*^9, 
   3.776691985893449*^9}, {3.7766920556257877`*^9, 3.776692069824437*^9}, {
   3.7766921015857477`*^9, 3.776692231827675*^9}, {3.776692391634923*^9, 
   3.77669242271068*^9}, {3.776692474911634*^9, 3.7766925114554*^9}, {
   3.776692572106443*^9, 3.776692596610045*^9}, {3.7766926518509197`*^9, 
   3.776692973916613*^9}, {3.776693056402398*^9, 3.7766931554042673`*^9}, {
   3.776693194394102*^9, 3.776693242613844*^9}, {3.776701466555531*^9, 
   3.7767015629886837`*^9}, {3.7767016013354473`*^9, 3.77670167746452*^9}, {
   3.7767017091465397`*^9, 3.776701728025323*^9}, {3.776701759166603*^9, 
   3.776701779193314*^9}, {3.7767018122986526`*^9, 3.77670185600673*^9}, {
   3.776701899423542*^9, 3.776702076666629*^9}, {3.776702111273798*^9, 
   3.7767022302736273`*^9}, {3.776702305236182*^9, 3.776702363457801*^9}, {
   3.776702398577669*^9, 3.776702513501821*^9}, {3.776702739203247*^9, 
   3.776702746180407*^9}, {3.7767027988292418`*^9, 3.7767028087408323`*^9}, {
   3.776702841229972*^9, 3.776702873143045*^9}, {3.776702910728636*^9, 
   3.776702941704483*^9}, {3.77670338231505*^9, 3.776703479283317*^9}, {
   3.776703522239962*^9, 3.776703595841824*^9}, 3.776703645873591*^9, {
   3.776703702555336*^9, 3.776703715428442*^9}, {3.7767037486267023`*^9, 
   3.776703899360273*^9}, {3.776704336651758*^9, 3.776704343266019*^9}, {
   3.7767051772323227`*^9, 3.7767051807500362`*^9}, {3.776706822644452*^9, 
   3.7767068408038177`*^9}, {3.776707043287675*^9, 3.7767070632774143`*^9}, {
   3.776707244680345*^9, 3.776707249000114*^9}, {3.776707393836131*^9, 
   3.776707394451705*^9}, {3.7767074850486317`*^9, 3.776707528937662*^9}, {
   3.776707595290024*^9, 3.776707616047817*^9}, {3.776707674120593*^9, 
   3.776707679195024*^9}},ExpressionUUID->"9882cfaa-3b61-4e03-a453-\
832a4cd9792f"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"The", " ", "following", " ", "gives", " ", "zero"}], ",", " ", 
    RowBox[{"so", " ", "this", " ", "seems", " ", "to", " ", 
     RowBox[{"work", "!"}]}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776709148852672*^9, 
  3.77670915662204*^9}},ExpressionUUID->"825d7c33-30ae-462f-bb2b-\
bd59ba93f218"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"dlnfdot", " ", "-", " ", "dlnfdot2"}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"(", 
          RowBox[{"k", "-", " ", 
           RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], "/.", " ", 
       RowBox[{"r", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
         RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
         RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"d", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"h", "+", 
          RowBox[{"eta", " ", "g2"}], "+", 
          RowBox[{"2", " ", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], 
     "  ", "/.", " ", 
     RowBox[{"h", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
       RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g0", " ", "\[Rule]", " ", 
     RowBox[{"Cos", "[", "gamma", "]"}]}]}], " ", "/.", " ", 
   RowBox[{"g1", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"Sin", "[", "gamma", "]"}], "/", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
  RowBox[{"g2", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}]], "Input",\

 CellChangeTimes->{{3.7767052307441683`*^9, 3.7767053254887543`*^9}},
 CellLabel->
  "In[182]:=",ExpressionUUID->"76e93013-27d4-4bc8-8c96-fe219f1cd379"],

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"dk", ",", "dh", ",", "dx0", ",", "dv0"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.776705352057817*^9, 3.7767053586324377`*^9}},
 CellLabel->
  "In[171]:=",ExpressionUUID->"36351a7f-e7e6-49ac-b77b-3d7deb0c3f6d"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "]"}]], "Input",
 CellChangeTimes->{{3.7767071936579857`*^9, 
  3.77670719777605*^9}},ExpressionUUID->"ae8f9d17-617e-4be9-90a1-\
f8c780806317"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Next", ",", " ", 
   RowBox[{
    RowBox[{"try", " ", "to", " ", "simplify", " ", "d", 
     RowBox[{"(", 
      RowBox[{"g", "-", 
       RowBox[{"h", "*", "f"}]}], ")"}]}], ":"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.7767091656386557`*^9, 
  3.776709185639222*^9}},ExpressionUUID->"4a6448e5-e47e-461d-9ba9-\
12d44ddddb11"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"First", ",", " ", 
    RowBox[{
    "see", " ", "if", " ", "we", " ", "can", " ", "simplify", " ", "some", 
     " ", 
     RowBox[{"expressions", "."}]}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{
  3.776709191066565*^9, {3.776709268264399*^9, 3.776709277919703*^9}},
 CellLabel->
  "In[184]:=",ExpressionUUID->"712d9fd8-0acb-412e-9fda-a6393e248e86"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"g1", " ", "h"}], " ", "-", " ", 
   RowBox[{"g2", " ", "r0"}]}], " ", "=", " ", 
  RowBox[{
   RowBox[{"g1", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
      RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
      RowBox[{"k", " ", "g3"}]}], ")"}]}], " ", "-", " ", 
   RowBox[{"g2", " ", "r0"}]}]}]], "Input",
 CellChangeTimes->{{3.776709278736858*^9, 3.776709298505795*^9}},
 CellLabel->
  "In[185]:=",ExpressionUUID->"501db47b-c80d-42a7-b736-8237a782a5dd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"r0", " ", "g0", " ", "g2"}], " ", "+", " ", 
   RowBox[{"eta", " ", "g1", " ", "g2"}], "+", 
   RowBox[{"g1", " ", "g3", " ", "k"}]}], " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"g2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g1"}]}], ")"}]}], "+", 
    RowBox[{"g1", " ", "g3", " ", "k"}]}], " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"g2", 
      RowBox[{"(", 
       RowBox[{"r", "-", " ", 
        RowBox[{"k", " ", "g2"}]}], ")"}]}], " ", "+", " ", 
     RowBox[{"g1", " ", "g3", " ", "k"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{"g2", " ", "r"}], " ", "-", 
     RowBox[{"h1", " ", "k"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.776709322832116*^9, 3.776709408267242*^9}, {
  3.776709453208743*^9, 3.776709481030877*^9}, {3.776709548229508*^9, 
  3.7767095492869663`*^9}},
 CellLabel->
  "In[205]:=",ExpressionUUID->"7fbb4a6e-3f16-4201-af6d-1819b0514b09"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "h1"}], " ", "k"}], "+", 
  RowBox[{"g2", " ", "r"}]}]], "Output",
 CellChangeTimes->{3.7767117016736927`*^9},
 CellLabel->
  "Out[205]=",ExpressionUUID->"3e60c2af-b831-4066-9cb8-00b26e59af52"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c9", " ", "=", " ", 
  RowBox[{
   RowBox[{"g2", " ", "r"}], " ", "-", " ", 
   RowBox[{"h1", " ", "k"}]}]}]], "Input",
 CellChangeTimes->{{3.776712815446405*^9, 3.776712819405871*^9}},
 CellLabel->
  "In[206]:=",ExpressionUUID->"8ce00df0-580c-4899-b2fe-9e66ab736eda"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "h1"}], " ", "k"}], "+", 
  RowBox[{"g2", " ", "r"}]}]], "Output",
 CellChangeTimes->{3.7767128203622913`*^9},
 CellLabel->
  "Out[206]=",ExpressionUUID->"834d3c65-1e08-416a-b0e3-8ce76ad561b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c10", " ", "=", " ", 
  RowBox[{
   FractionBox[
    RowBox[{"c3", " ", "c9"}], "r"], "+", 
   RowBox[{"g2", " ", "r0", " ", "h"}], "-", 
   FractionBox[
    RowBox[{" ", 
     RowBox[{"k", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "g2", " ", "h"}], "+", 
        RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}]}], 
    "beta"]}]}]], "Input",
 CellChangeTimes->{{3.776713475232999*^9, 3.7767134828980217`*^9}},
 CellLabel->
  "In[207]:=",ExpressionUUID->"4c05a68c-d9ea-4037-a161-1ac2cac8850b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g2", " ", "h", " ", "r0"}], "-", 
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "g2", " ", "h"}], "+", 
      RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], "beta"], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "h1"}], " ", "k"}], "+", 
      RowBox[{"g2", " ", "r"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"d", " ", "k"}], "-", 
      RowBox[{"g1", " ", 
       SuperscriptBox["r0", "2"]}]}], ")"}]}], "r"]}]], "Output",
 CellChangeTimes->{3.776713483702394*^9},
 CellLabel->
  "Out[207]=",ExpressionUUID->"68bed066-67e0-4b9e-bf65-f4e8b17e88a6"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"dgmhf2", " ", "=", 
  RowBox[{
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"2", "g2", " ", "k"}], "r0"], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["k", "2"], " ", "h1"}], 
       RowBox[{"r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{" ", 
        RowBox[{"g2", " ", "k", " ", "c9", 
         RowBox[{"(", 
          RowBox[{"k", "+", "zeta"}], ")"}], " "}]}], 
       RowBox[{"r", " ", 
        SuperscriptBox["r0", "2"]}]], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"eta", " ", "k"}], 
        SuperscriptBox["r0", "4"]], "c10"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dk", 
     SuperscriptBox["r0", "2"]], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", 
           SuperscriptBox["r0", "2"]}], "-", 
          RowBox[{"r0", " ", "k", " ", "g3"}]}], ")"}], " ", "c9"}], "r"], 
      "-", 
      RowBox[{"g3", " ", 
       SuperscriptBox["r0", "2"]}], "+", "c10"}], ")"}]}], "+", 
   RowBox[{
    FractionBox[
     RowBox[{"dx0", " ", "k"}], "r0"], 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g2", "  ", "c9", " ", "v0"}], 
       RowBox[{"r", " "}]], "-", 
      RowBox[{"c10", " ", 
       FractionBox["x0", 
        SuperscriptBox["r0", "3"]]}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox[
     RowBox[{"dv0", "  ", "k"}], "r0"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{"d", "+", 
              RowBox[{"g2", " ", "h"}]}], ")"}], "c9"}], "r"]}], "+", 
         FractionBox[
          RowBox[{" ", 
           RowBox[{
            RowBox[{"2", "g2", " ", "h"}], "+", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}]}], "beta"]}], ")"}], " ", 
       "v0"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"g2", " ", "c9"}], "r"], "+", 
         RowBox[{
          FractionBox["h", 
           SuperscriptBox["r0", "3"]], "c10"}]}], ")"}], " ", "x0"}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7767091656386557`*^9, 3.776709205340872*^9}, {
   3.7767095770007887`*^9, 3.776709623754099*^9}, {3.776709671451326*^9, 
   3.7767099117284613`*^9}, {3.7767099895677767`*^9, 3.776710002603879*^9}, {
   3.77671054528476*^9, 3.776710567082855*^9}, {3.776710853755413*^9, 
   3.776710979550313*^9}, {3.77671172218443*^9, 3.77671179814534*^9}, {
   3.776711875621098*^9, 3.776711941524364*^9}, {3.7767120297990503`*^9, 
   3.776712034781104*^9}, {3.7767122142802277`*^9, 3.776712310286336*^9}, {
   3.776712374895905*^9, 3.776712411468004*^9}, {3.7767127392323313`*^9, 
   3.776712747816139*^9}, {3.776712806085458*^9, 3.77671287963589*^9}, {
   3.776712950663349*^9, 3.776712959621538*^9}, {3.776712995239088*^9, 
   3.776713075396824*^9}, 3.776713110876556*^9, 3.776713144578516*^9, {
   3.77671317830881*^9, 3.77671351407833*^9}, {3.7767143387605667`*^9, 
   3.7767143615248938`*^9}},
 CellLabel->
  "In[217]:=",ExpressionUUID->"376fe43f-defe-4caa-b0d9-bd92e37a9865"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"dgmhf", " ", "-", " ", "dgmhf2"}], "  ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"(", 
          RowBox[{"k", "-", " ", 
           RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], "/.", " ", 
       RowBox[{"r", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
         RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
         RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"d", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"h", "+", 
          RowBox[{"eta", " ", "g2"}], "+", 
          RowBox[{"2", " ", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], 
     "  ", "/.", " ", 
     RowBox[{"h", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
       RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g0", " ", "\[Rule]", " ", 
     RowBox[{"Cos", "[", "gamma", "]"}]}]}], " ", "/.", " ", 
   RowBox[{"g1", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"Sin", "[", "gamma", "]"}], "/", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
  RowBox[{"g2", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta", 
    " "}]}]}]], "Input",
 CellChangeTimes->{{3.7767136881524487`*^9, 3.776713699328803*^9}, {
  3.776713765744384*^9, 3.776713821027521*^9}, {3.776713895277336*^9, 
  3.776713919529546*^9}},ExpressionUUID->"0a707780-996c-45ba-bf2c-\
23b1d27d30c8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Next", ",", " ", 
    RowBox[{"work", " ", "on", " ", 
     RowBox[{"dlnf", ":"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"c11", " ", "=", " ", 
   RowBox[{
    FractionBox[
     RowBox[{"g1", "  ", "c3"}], 
     RowBox[{"g2", " ", "r", " ", 
      SuperscriptBox["r0", "3"]}]], "-", 
    FractionBox[
     RowBox[{"2", "  ", "k"}], 
     RowBox[{"beta", " ", 
      SuperscriptBox["r0", "3"]}]], "+", 
    FractionBox["1", 
     SuperscriptBox["r0", "2"]]}]}]}]], "Input",
 CellChangeTimes->{{3.776713964196665*^9, 3.77671396921833*^9}, {
  3.776714270405583*^9, 
  3.776714276966325*^9}},ExpressionUUID->"1690a552-09d6-469d-a993-\
132d0b02a83e"],

Cell[BoxData[
 RowBox[{"dlnf2", " ", "=", " ", 
  RowBox[{
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["g1", 
       RowBox[{"g2", " ", "r"}]], "-", 
      FractionBox[
       RowBox[{"g1", 
        RowBox[{"(", 
         RowBox[{"k", "+", "zeta"}], " ", ")"}]}], 
       RowBox[{" ", 
        RowBox[{"r", " ", "r0"}]}]], "+", 
      RowBox[{"eta", " ", "c11"}]}], ")"}]}], "+", 
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", "k"], "+", 
      FractionBox[
       RowBox[{"g1", " ", "c1"}], 
       RowBox[{"g2", " ", "r", " ", "r0"}]], "-", 
      FractionBox["2", 
       RowBox[{"beta", " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g1", " ", "v0"}], "r"], "-", 
      RowBox[{"c11", " ", "x0"}]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["2", "beta"], "-", 
         FractionBox[
          RowBox[{"d", " ", "g1"}], 
          RowBox[{"g2", " ", "r"}]], "-", 
         FractionBox[
          RowBox[{"g1", " ", "h"}], "r"]}], ")"}], " ", "v0"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["g1", "r"], "+", 
         RowBox[{"h", " ", "c11"}]}], ")"}], " ", "x0"}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776713986050543*^9, 3.776714001442732*^9}, {
  3.776714068324239*^9, 3.776714088026724*^9}, {3.7767141310328407`*^9, 
  3.776714314284542*^9}},ExpressionUUID->"58a361e1-f98c-4528-8b53-\
27f745a9b24f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Okay", ",", " ", 
    RowBox[{"finally", " ", 
     RowBox[{"dgdotmhfdotm1", ":"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"c12", " ", "=", " ", 
   RowBox[{
    RowBox[{"g0", " ", "h"}], " ", "-", " ", 
    RowBox[{"g1", " ", "r0"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7767144681239357`*^9, 3.776714493210115*^9}, {
  3.776715590237748*^9, 3.776715594574127*^9}},
 CellLabel->
  "In[218]:=",ExpressionUUID->"78916221-f436-40ce-9c4c-b6f20e2d69e2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g0", " ", "h"}], "-", 
  RowBox[{"g1", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.776715594969315*^9},
 CellLabel->
  "Out[218]=",ExpressionUUID->"0c3bbda3-c16c-4bae-8cc0-2a1549ab817d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c13", " ", "=", " ", 
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", "g2"}], 
    RowBox[{"beta", " ", "r0"}]], "+", "g2", "+", 
   FractionBox[
    RowBox[{"c3", " ", "c12"}], 
    RowBox[{"r", " ", 
     SuperscriptBox["r0", "2"]}]], "-", 
   FractionBox[
    RowBox[{" ", 
     RowBox[{"k", " ", "c9"}]}], 
    RowBox[{"beta", " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox["c9", "r0"], "+", 
   FractionBox[
    RowBox[{"k", " ", "c4", " ", "c9"}], 
    RowBox[{"beta", " ", "r", " ", 
     SuperscriptBox["r0", "2"]}]], "-", 
   FractionBox[
    RowBox[{" ", 
     RowBox[{"c3", " ", "c9", " ", "c2"}]}], 
    RowBox[{
     SuperscriptBox["r", "2"], " ", 
     SuperscriptBox["r0", "2"]}]]}]}]], "Input",
 CellChangeTimes->{{3.776718240729148*^9, 3.776718246392173*^9}},
 CellLabel->
  "In[225]:=",ExpressionUUID->"bca72913-3d64-49a9-b0ba-642afbc6dff6"],

Cell[BoxData[
 RowBox[{"g2", "-", 
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "h1"}], " ", "k"}], "+", 
      RowBox[{"g2", " ", "r"}]}], ")"}]}], 
   RowBox[{"beta", " ", 
    SuperscriptBox["r0", "2"]}]], "+", 
  FractionBox[
   RowBox[{"g2", " ", "k"}], 
   RowBox[{"beta", " ", "r0"}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "h1"}], " ", "k"}], "+", 
    RowBox[{"g2", " ", "r"}]}], "r0"], "+", 
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "h1"}], " ", "k"}], "+", 
      RowBox[{"g2", " ", "r"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"2", " ", "g0", " ", "r0"}]}], ")"}]}], 
   RowBox[{"beta", " ", "r", " ", 
    SuperscriptBox["r0", "2"]}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g0", " ", "h"}], "-", 
      RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"d", " ", "k"}], "-", 
      RowBox[{"g1", " ", 
       SuperscriptBox["r0", "2"]}]}], ")"}]}], 
   RowBox[{"r", " ", 
    SuperscriptBox["r0", "2"]}]], "-", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "h1"}], " ", "k"}], "+", 
      RowBox[{"g2", " ", "r"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"d", " ", "k"}], "-", 
      RowBox[{"g1", " ", 
       SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
   RowBox[{
    SuperscriptBox["r", "2"], " ", 
    SuperscriptBox["r0", "2"]}]]}]], "Output",
 CellChangeTimes->{3.776718247472336*^9},
 CellLabel->
  "Out[225]=",ExpressionUUID->"51151d26-0240-4138-8e21-2d1fa43e2f82"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"dgdotmhfdotm1", " ", "=", "  ", 
  RowBox[{
   RowBox[{
    FractionBox["dk", "r0"], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"k", " ", "c1", " ", "c12"}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{" ", 
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{"c9", "-", 
           RowBox[{"g2", " ", "r0"}]}], ")"}]}]}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
      FractionBox["c9", "r"], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ",
         "c9"}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", "c1", " ", "c9", " ", "c2"}], 
       RowBox[{
        SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dh", 
     RowBox[{"r", " ", "r0"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", "k"}], "+", 
      FractionBox[
       RowBox[{"k", " ", "c12"}], "r"], "-", 
      FractionBox[
       RowBox[{"k", " ", "c9", " ", "c2"}], 
       SuperscriptBox["r", "2"]], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"g2", " ", "k", " "}], 
        RowBox[{
         SuperscriptBox["r", "2"], "r0"}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "k"}], "-", 
         RowBox[{"beta", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", " ", 
        RowBox[{
         RowBox[{"h", " ", "r"}], "+", " ", 
         RowBox[{"c9", " ", "c2"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"eta", " ", "k"}], "r0"], " ", "c13"}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "v0"}], " ", 
       FractionBox[
        RowBox[{"g2", " ", "k"}], 
        RowBox[{
         SuperscriptBox["r", "3"], "r0"}]], " ", 
       RowBox[{"(", " ", 
        RowBox[{
         RowBox[{"h", " ", "r"}], "+", 
         RowBox[{"c9", " ", "c2"}]}], ")"}]}], "-", 
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "x0"}], 
        RowBox[{"r", " ", 
         SuperscriptBox["r0", "2"]}]], " ", "c13"}]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["v0", 
        RowBox[{
         SuperscriptBox["r", "2"], " ", "r0"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "d"}], " ", "k", " ", "c12"}], "+", 
         RowBox[{"g2", " ", "k", " ", 
          SuperscriptBox["h", "2"]}], "+", 
         FractionBox[
          RowBox[{" ", 
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"c9", " ", 
               RowBox[{"(", 
                RowBox[{"r", "-", "c2"}], ")"}]}], "-", 
              RowBox[{"g2", " ", "r", " ", "r0"}]}], ")"}]}]}], "beta"], "+", 
         
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{"d", "+", 
             RowBox[{"g2", " ", "h"}]}], ")"}], " ", "k", " ", "c9", " ", 
           "c2"}], "r"]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["x0", 
        RowBox[{"r", " ", "r0"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"g2", " ", "h", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{"r", "-", "r0"}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"h", " ", "k", " ", "c3", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"c12", " ", "r"}], "-", 
             RowBox[{"c2", " ", "c9"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{" ", 
           RowBox[{"h", " ", 
            SuperscriptBox["k", "2"], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"c9", " ", 
               RowBox[{"(", 
                RowBox[{"r", "-", "c2"}], ")"}]}], "-", 
              RowBox[{"g2", " ", "r", " ", "r0"}]}], ")"}]}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox[
          RowBox[{"h", " ", "k", " ", "c9"}], 
          SuperscriptBox["r0", "2"]], "-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", "c9", " ", "c2"}], 
          SuperscriptBox["r", "2"]]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7767145461863203`*^9, 3.7767147942909718`*^9}, {
   3.776715547515938*^9, 3.7767156662050533`*^9}, {3.776715837422112*^9, 
   3.77671592588382*^9}, {3.77671596918196*^9, 3.776716015300721*^9}, {
   3.7767160847600393`*^9, 3.776716129452058*^9}, {3.776716224618239*^9, 
   3.776716233199389*^9}, {3.776716352788043*^9, 3.7767163568599033`*^9}, {
   3.7767164217300253`*^9, 3.776716423189013*^9}, {3.7767164577564697`*^9, 
   3.7767164624235077`*^9}, {3.776716508477015*^9, 3.776716552179969*^9}, {
   3.7767166998223867`*^9, 3.776716839915941*^9}, {3.7767168890137663`*^9, 
   3.776717265621983*^9}, {3.776717320902586*^9, 3.776717343356661*^9}, {
   3.776717386458021*^9, 3.776717431440074*^9}, {3.776717477412157*^9, 
   3.7767174983477297`*^9}, {3.7767175397266083`*^9, 3.7767176312780933`*^9}, 
   3.776718209649678*^9, {3.776718251033676*^9, 
   3.776718263664241*^9}},ExpressionUUID->"d0d5a7f4-fe2f-4c77-9ba6-\
59157138e099"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"We", " ", "forgot", " ", "to", " ", "do", " ", 
    RowBox[{"dlnf", ":", " ", 
     RowBox[{"finish", " ", "up", " ", 
      RowBox[{"later", "."}]}]}]}], " ", "*)"}], 
  "\[AliasDelimiter]"}]], "Input",
 CellChangeTimes->{{3.776719824123232*^9, 
  3.776719833651709*^9}},ExpressionUUID->"8fc2e79c-b83a-4ad6-b8e1-\
d2b3e11af47f"],

Cell[BoxData[
 RowBox[{"dlnf2", " ", "=", " ", 
  RowBox[{
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["g1", 
       RowBox[{"g2", " ", "r"}]], "+", 
      FractionBox[
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "c3"}], "-", 
          RowBox[{"g2", " ", 
           SuperscriptBox["r0", "2"], 
           RowBox[{"(", 
            RowBox[{"k", "+", "zeta"}], " ", ")"}]}]}], ")"}]}], 
       RowBox[{"g2", " ", "r", " ", 
        SuperscriptBox["r0", "3"]}]], "-", 
      FractionBox[
       RowBox[{"2", " ", "eta", " ", "k"}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "3"]}]], "+", 
      FractionBox["eta", 
       SuperscriptBox["r0", "2"]]}], ")"}]}], "+", 
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", "k"], "+", 
      FractionBox[
       RowBox[{"g1", " ", "c1"}], 
       RowBox[{"g2", " ", "r", " ", "r0"}]], "-", 
      FractionBox["2", 
       RowBox[{"beta", " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g1", " ", "v0"}], "r"], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g1", " ", "c3"}], 
           RowBox[{"g2", " ", "r", " "}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", "k"}], 
          RowBox[{"beta", " "}]], "-", "r0"}], ")"}], " ", 
       FractionBox["x0", 
        SuperscriptBox["r0", "3"]]}]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["2", "beta"], "-", 
         FractionBox[
          RowBox[{"d", " ", "g1"}], 
          RowBox[{"g2", " ", "r"}]], "-", 
         FractionBox[
          RowBox[{"g1", " ", "h"}], "r"]}], ")"}], " ", "v0"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["g1", "r"], "+", 
         FractionBox[
          RowBox[{"g1", " ", "h", " ", "c3"}], 
          RowBox[{"g2", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{"2", " ", "h", " ", "k"}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox["h", 
          SuperscriptBox["r0", "2"]]}], ")"}], " ", "x0"}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{
  3.776719847634221*^9, {3.776724149478097*^9, 3.77672417469228*^9}, {
   3.776725489606967*^9, 
   3.7767255068574944`*^9}},ExpressionUUID->"27727c3a-ced6-41db-88e3-\
24e37700b917"]
},
WindowSize->{1003, 855},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 425, 9, 30, "Input",ExpressionUUID->"66d95d8a-2d5b-4630-b86a-bba9ba5374c9"],
Cell[986, 31, 364, 8, 52, "Input",ExpressionUUID->"0c68b6db-41b8-4681-98f9-b85cce6aa12d"],
Cell[CellGroupData[{
Cell[1375, 43, 305, 6, 30, "Input",ExpressionUUID->"5e50fe82-9cbc-4d37-92a4-b9b6432d73af"],
Cell[1683, 51, 220, 4, 34, "Output",ExpressionUUID->"cf228877-6822-4c35-9393-6c0e42ffdde2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1940, 60, 8680, 249, 439, "Input",ExpressionUUID->"cb606c02-a60e-4d23-ad2c-371cb5cfe5d2"],
Cell[10623, 311, 7910, 242, 347, "Output",ExpressionUUID->"9a04da87-0853-4cfd-952a-1ce497564724"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18570, 558, 3263, 100, 158, "Input",ExpressionUUID->"00e8da88-ebd2-4017-a133-efbfb080bdda"],
Cell[21836, 660, 3050, 98, 160, "Output",ExpressionUUID->"87cf5d4e-ab81-45eb-8dd3-3810fb8be834"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24923, 763, 16885, 480, 740, "Input",ExpressionUUID->"85ce4305-8ca9-4e99-a9c5-b28b351de8b3"],
Cell[41811, 1245, 15684, 472, 622, "Output",ExpressionUUID->"c8c5ca50-a29c-4421-a2d2-a6db14db5808"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57532, 1722, 6788, 205, 277, "Input",ExpressionUUID->"4fbe6a8f-800f-4fc4-9f53-ab19878a91c8"],
Cell[64323, 1929, 6497, 202, 299, "Output",ExpressionUUID->"97ccf9d4-1e4c-46d5-9d61-2aeb46d705b6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[70857, 2136, 178, 2, 30, "Input",ExpressionUUID->"af26e4c8-2a3a-44a3-b66a-2256535154ff"],
Cell[71038, 2140, 7910, 242, 347, "Output",ExpressionUUID->"c9f26b1c-554a-475a-a95b-ebfc71e8b43b"]
}, Open  ]],
Cell[78963, 2385, 443, 10, 52, "Input",ExpressionUUID->"9b5ba98d-3226-4c6b-ad4b-95ec6a9691b5"],
Cell[CellGroupData[{
Cell[79431, 2399, 298, 7, 52, "Input",ExpressionUUID->"37294438-ec61-4768-868c-052f5b9b4015"],
Cell[79732, 2408, 200, 5, 34, "Output",ExpressionUUID->"bcd3161c-cce7-4c1b-b27c-38fb93c05e5d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[79969, 2418, 291, 6, 30, "Input",ExpressionUUID->"67727f8d-e0b2-42ef-bebc-e5b79422da65"],
Cell[80263, 2426, 226, 5, 34, "Output",ExpressionUUID->"0c56eeaf-dcc6-48f5-ac28-2a4c1c2a6e67"]
}, Open  ]],
Cell[CellGroupData[{
Cell[80526, 2436, 370, 9, 30, "Input",ExpressionUUID->"8d4a5417-5ad0-4fda-bd6f-7fad6442e326"],
Cell[80899, 2447, 270, 7, 34, "Output",ExpressionUUID->"9645d858-c2ab-4574-94ca-4003e9bf8a61"]
}, Open  ]],
Cell[81184, 2457, 352, 7, 30, "Input",ExpressionUUID->"1a12d5c2-6a55-408c-8789-7f3ba71f1acf"],
Cell[CellGroupData[{
Cell[81561, 2468, 686, 20, 73, "Input",ExpressionUUID->"8ceb8549-b6e1-434a-9fcb-8e8dcda1757f"],
Cell[82250, 2490, 260, 6, 34, "Output",ExpressionUUID->"775a4633-76f7-4dd5-a2e3-eb6c7676b30d"],
Cell[82513, 2498, 290, 8, 54, "Output",ExpressionUUID->"7bb6575e-746f-400f-9292-2368f0635cbc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[82840, 2511, 414, 10, 49, "Input",ExpressionUUID->"1725cc11-a84e-4c19-86eb-a86fb824c97e"],
Cell[83257, 2523, 270, 8, 52, "Output",ExpressionUUID->"39318e36-7472-467b-bcaa-56ac9cdf558d"]
}, Open  ]],
Cell[83542, 2534, 380, 10, 50, "Input",ExpressionUUID->"bcf8b2d4-6b39-4cd5-b7f1-a75099e7dd54"],
Cell[CellGroupData[{
Cell[83947, 2548, 637, 19, 93, "Input",ExpressionUUID->"e0bce0a9-78eb-4178-9a56-a0a4ef578eb7"],
Cell[84587, 2569, 357, 11, 53, "Output",ExpressionUUID->"3d9a5c98-115a-4fe1-bd77-ecb9a8ed2359"],
Cell[84947, 2582, 763, 26, 70, "Output",ExpressionUUID->"d7b1ff9e-35d7-4adc-9d54-b237314cdea2"]
}, Open  ]],
Cell[85725, 2611, 3181, 70, 89, "Input",ExpressionUUID->"9882cfaa-3b61-4e03-a453-832a4cd9792f"],
Cell[88909, 2683, 401, 9, 52, "Input",ExpressionUUID->"825d7c33-30ae-462f-bb2b-bd59ba93f218"],
Cell[89313, 2694, 1620, 44, 52, "Input",ExpressionUUID->"76e93013-27d4-4bc8-8c96-fe219f1cd379"],
Cell[90936, 2740, 312, 8, 30, "Input",ExpressionUUID->"36351a7f-e7e6-49ac-b77b-3d7deb0c3f6d"],
Cell[91251, 2750, 183, 4, 30, "Input",ExpressionUUID->"ae8f9d17-617e-4be9-90a1-f8c780806317"],
Cell[91437, 2756, 375, 10, 30, "Input",ExpressionUUID->"4a6448e5-e47e-461d-9ba9-12d44ddddb11"],
Cell[91815, 2768, 437, 11, 52, "Input",ExpressionUUID->"712d9fd8-0acb-412e-9fda-a6393e248e86"],
Cell[92255, 2781, 544, 15, 30, "Input",ExpressionUUID->"501db47b-c80d-42a7-b736-8237a782a5dd"],
Cell[CellGroupData[{
Cell[92824, 2800, 1009, 28, 30, "Input",ExpressionUUID->"7fbb4a6e-3f16-4201-af6d-1819b0514b09"],
Cell[93836, 2830, 244, 7, 34, "Output",ExpressionUUID->"3e60c2af-b831-4066-9cb8-00b26e59af52"]
}, Open  ]],
Cell[CellGroupData[{
Cell[94117, 2842, 292, 7, 30, "Input",ExpressionUUID->"8ce00df0-580c-4899-b2fe-9e66ab736eda"],
Cell[94412, 2851, 244, 7, 34, "Output",ExpressionUUID->"834d3c65-1e08-416a-b0e3-8ce76ad561b8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[94693, 2863, 537, 16, 49, "Input",ExpressionUUID->"4c05a68c-d9ea-4037-a161-1ac2cac8850b"],
Cell[95233, 2881, 707, 23, 56, "Output",ExpressionUUID->"68bed066-67e0-4b9e-bf65-f4e8b17e88a6"]
}, Open  ]],
Cell[95955, 2907, 3235, 92, 100, "Input",ExpressionUUID->"376fe43f-defe-4caa-b0d9-bd92e37a9865"],
Cell[99193, 3001, 1882, 50, 73, "Input",ExpressionUUID->"0a707780-996c-45ba-bf2c-23b1d27d30c8"],
Cell[101078, 3053, 717, 21, 74, "Input",ExpressionUUID->"1690a552-09d6-469d-a993-132d0b02a83e"],
Cell[101798, 3076, 1602, 51, 95, "Input",ExpressionUUID->"58a361e1-f98c-4528-8b53-27f745a9b24f"],
Cell[CellGroupData[{
Cell[103425, 3131, 520, 13, 52, "Input",ExpressionUUID->"78916221-f436-40ce-9c4c-b6f20e2d69e2"],
Cell[103948, 3146, 224, 6, 34, "Output",ExpressionUUID->"0c3bbda3-c16c-4bae-8cc0-2a1549ab817d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[104209, 3157, 899, 28, 50, "Input",ExpressionUUID->"bca72913-3d64-49a9-b0ba-642afbc6dff6"],
Cell[105111, 3187, 1867, 66, 100, "Output",ExpressionUUID->"51151d26-0240-4138-8e21-2d1fa43e2f82"]
}, Open  ]],
Cell[106993, 3256, 5541, 156, 185, "Input",ExpressionUUID->"d0d5a7f4-fe2f-4c77-9ba6-59157138e099"],
Cell[112537, 3414, 387, 10, 30, "Input",ExpressionUUID->"8fc2e79c-b83a-4ad6-b8e1-d2b3e11af47f"],
Cell[112927, 3426, 2607, 82, 102, "Input",ExpressionUUID->"27727c3a-ced6-41db-88e3-24e37700b917"]
}
]
*)

