(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     38462,       1013]
NotebookOptionsPosition[     35519,        972]
NotebookOutlinePosition[     35854,        987]
CellTagsIndexPosition[     35811,        984]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Compiling", " ", "all", " ", "of", " ", "the"}], " ", "-", 
   "Drift", "+", 
   RowBox[{
   "Kepler", " ", "results", " ", "from", " ", "the", " ", "other", " ", 
    RowBox[{"notebooks", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776691265974856*^9, 3.776691283656739*^9}},
 CellLabel->"In[85]:=",ExpressionUUID->"66d95d8a-2d5b-4630-b86a-bba9ba5374c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Defining", " ", "terms", " ", "which", " ", "are", " ", "used", " ", 
    RowBox[{"frequently", ":"}]}], " ", "*)"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.776691423293016*^9, 3.7766914321337957`*^9}},
 CellLabel->"In[88]:=",ExpressionUUID->"0c68b6db-41b8-4681-98f9-b85cce6aa12d"],

Cell[BoxData[
 RowBox[{"c1", " ", "=", " ", 
  RowBox[{"d", "-", 
   RowBox[{"r0", " ", "g3"}]}]}]], "Input",
 CellChangeTimes->{{3.776691465508732*^9, 3.776691472797203*^9}, {
   3.776691697521482*^9, 3.7766917009578867`*^9}, 3.776947658461258*^9, 
   3.77694778649223*^9},ExpressionUUID->"5e50fe82-9cbc-4d37-92a4-\
b9b6432d73af"],

Cell[BoxData[{
 RowBox[{"c2", " ", "=", " ", 
  RowBox[{
   RowBox[{"eta", " ", "g0"}], " ", "+", " ", 
   RowBox[{"g1", " ", "zeta"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c3", " ", "=", " ", 
  RowBox[{
   RowBox[{"d", " ", "k"}], " ", "+", " ", 
   RowBox[{"g1", " ", 
    SuperscriptBox["r0", "2"]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c4", " ", "=", " ", 
  RowBox[{
   RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
   RowBox[{"2", " ", "g0", " ", "r0"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c5", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g0", " "}], "g1"], "-", 
     FractionBox[
      RowBox[{" ", "c2"}], "r"]}], ")"}], " ", "=", 
   RowBox[{"(", 
    FractionBox[
     RowBox[{"r0", " ", "-", " ", 
      RowBox[{"k", " ", "g2", " "}]}], 
     RowBox[{"g1", " ", "r"}]], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c6", " ", "=", 
  FractionBox[
   RowBox[{
    RowBox[{"r0", " ", "g0"}], "-", " ", 
    RowBox[{"k", " ", "g2"}]}], "beta"]}], "\[IndentingNewLine]", 
 RowBox[{"c7", " ", "=", " ", 
  RowBox[{"g2", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "g1"], "+", 
     FractionBox["c2", "r"]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c8", " ", "=", " ", 
  FractionBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"k", " ", "c6"}], "+", " ", 
     RowBox[{"r", " ", "r0"}], "+", 
     RowBox[{"c3", " ", "c5"}]}], ")"}], 
   SuperscriptBox["r0", "3"]]}], "\[IndentingNewLine]", 
 RowBox[{"c9", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"g1", " ", "h"}], " ", "-", " ", 
    RowBox[{"g2", " ", "r0"}]}], " ", "=", " ", 
   RowBox[{
    RowBox[{"g2", " ", "r"}], " ", "-", " ", 
    RowBox[{"h1", " ", "k"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c10", " ", "=", " ", 
  RowBox[{
   FractionBox[
    RowBox[{"c3", " ", "c9"}], "r"], "+", 
   RowBox[{"g2", " ", "r0", " ", "h"}], "-", 
   FractionBox[
    RowBox[{" ", 
     RowBox[{"k", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "g2", " ", "h"}], "+", 
        RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}]}], 
    "beta"]}]}], "\[IndentingNewLine]", 
 RowBox[{"c11", " ", "=", " ", 
  RowBox[{
   FractionBox[
    RowBox[{"g1", "  ", "c3"}], 
    RowBox[{"g2", " ", "r", " ", 
     SuperscriptBox["r0", "3"]}]], "-", 
   FractionBox[
    RowBox[{"2", "  ", "k"}], 
    RowBox[{"beta", " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   FractionBox["1", 
    SuperscriptBox["r0", "2"]]}]}], "\[IndentingNewLine]", 
 RowBox[{"c12", " ", "=", " ", 
  RowBox[{
   RowBox[{"g0", " ", "h"}], " ", "-", " ", 
   RowBox[{"g1", " ", "r0"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c13", " ", "=", " ", 
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", "g2"}], 
    RowBox[{"beta", " ", "r0"}]], "+", "g2", "+", 
   FractionBox[
    RowBox[{"c3", " ", "c12"}], 
    RowBox[{"r", " ", 
     SuperscriptBox["r0", "2"]}]], "-", 
   FractionBox[
    RowBox[{" ", 
     RowBox[{"k", " ", "c9"}]}], 
    RowBox[{"beta", " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox["c9", "r0"], "+", 
   FractionBox[
    RowBox[{"k", " ", "c4", " ", "c9"}], 
    RowBox[{"beta", " ", "r", " ", 
     SuperscriptBox["r0", "2"]}]], "-", 
   FractionBox[
    RowBox[{" ", 
     RowBox[{"c3", " ", "c9", " ", "c2"}]}], 
    RowBox[{
     SuperscriptBox["r", "2"], " ", 
     SuperscriptBox["r0", "2"]}]]}]}], "\[IndentingNewLine]", 
 RowBox[{"c14", " ", "=", " ", 
  RowBox[{
   RowBox[{"r0", " ", "g2"}], "  ", "-", " ", 
   RowBox[{"k", " ", "h1"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c15", " ", "=", " ", 
  RowBox[{
   RowBox[{"eta", " ", "h1"}], "+", 
   RowBox[{"h2", " ", "r0"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c16", " ", "=", " ", 
  RowBox[{
   RowBox[{"eta", " ", "h2"}], "+", 
   RowBox[{"g1", " ", "gamma", " ", "r0"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c17", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", 
   "r0"}]}], "\[IndentingNewLine]", 
 RowBox[{"c18", " ", "=", " ", 
  RowBox[{
   RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
   RowBox[{"2", " ", "g2", " ", "k"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c19", " ", "=", " ", 
  RowBox[{
   RowBox[{"4", " ", "eta", " ", "h1"}], " ", "+", " ", 
   RowBox[{"3", " ", "h2", " ", "r0", " "}]}]}]}], "Input",
 CellChangeTimes->{{3.7767369076373262`*^9, 3.776736907643396*^9}, {
   3.776736976907648*^9, 3.776737181665717*^9}, {3.776737572531062*^9, 
   3.776737587090602*^9}, {3.77673828315909*^9, 3.7767382860880117`*^9}, {
   3.7767383600077953`*^9, 3.7767383622810373`*^9}, {3.776738437817255*^9, 
   3.776738440010479*^9}, {3.77673862639879*^9, 3.776738633895483*^9}, {
   3.7767390391985893`*^9, 3.776739048056197*^9}, 
   3.77694766250918*^9},ExpressionUUID->"cf228877-6822-4c35-9393-\
6c0e42ffdde2"],

Cell[BoxData[
 RowBox[{"dlnfdot2", " ", "=", " ", 
  RowBox[{
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["g0", 
       RowBox[{"g1", " ", "r"}]], "-", 
      FractionBox["c2", 
       SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", "k"], "+", 
      RowBox[{"c1", 
       FractionBox[
        RowBox[{
         RowBox[{"g0", " ", "r"}], " ", "-", 
         RowBox[{"g1", " ", "c2"}]}], 
        RowBox[{"g1", " ", "r0", " ", 
         SuperscriptBox["r", "2"]}]]}], "-", 
      FractionBox["1", 
       RowBox[{"beta", " ", "r0"}]], "-", 
      FractionBox["c17", 
       RowBox[{"beta", " ", "r", " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", "beta"], "-", 
         FractionBox[
          RowBox[{"d", " ", "g0"}], 
          RowBox[{"g1", " ", "r"}]], "-", 
         FractionBox["c18", 
          RowBox[{"beta", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", "c2"}], 
          SuperscriptBox["r", "2"]]}], ")"}], " ", "v0"}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{" ", 
           RowBox[{"g2", " ", "r"}]}], 
          RowBox[{"g1", " ", 
           SuperscriptBox["r", "2"]}]], "+", 
         FractionBox[
          RowBox[{" ", 
           RowBox[{
            RowBox[{"k", " ", "g3"}], "+", 
            RowBox[{"g1", " ", "r"}], "-", "h"}]}], 
          RowBox[{" ", 
           SuperscriptBox["r", "2"]}]]}], ")"}], " ", "x0"}]}], ")"}]}], "+", 
   
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{" ", 
            RowBox[{"g2", " ", "r"}]}], 
           RowBox[{"g1", " ", 
            SuperscriptBox["r", "2"]}]], "+", 
          FractionBox[
           RowBox[{" ", 
            RowBox[{
             RowBox[{"k", " ", "g3"}], "+", 
             RowBox[{"g1", " ", "r"}], "-", "h"}]}], 
           RowBox[{" ", 
            SuperscriptBox["r", "2"]}]]}], ")"}]}], " ", "v0"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["k", 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox["1", 
          SuperscriptBox["r0", "2"]], "-", 
         FractionBox[
          RowBox[{"k", " ", "c4"}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         RowBox[{"c3", 
          FractionBox[
           RowBox[{" ", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "-", "r0"}]}], 
           RowBox[{"g1", " ", 
            SuperscriptBox["r", "2"], 
            SuperscriptBox["r0", "3"]}]]}]}], ")"}], " ", "x0"}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{
  3.776691332932624*^9, 3.7766913935329933`*^9, {3.7766915659546947`*^9, 
   3.776691586061574*^9}, {3.776691705071649*^9, 3.776691705334216*^9}, {
   3.7767368736561832`*^9, 3.776736888514717*^9}, {3.776737481822403*^9, 
   3.776737522365251*^9}, {3.7767377221209097`*^9, 3.7767377409758463`*^9}, {
   3.77673844368981*^9, 3.776738478450181*^9}, {3.776738687893662*^9, 
   3.776738688271596*^9}, 
   3.77678030617198*^9},ExpressionUUID->"cb606c02-a60e-4d23-ad2c-\
371cb5cfe5d2"],

Cell[BoxData[
 RowBox[{"dfm1mhfdot2", " ", "=", 
  RowBox[{
   RowBox[{
    FractionBox["dh", 
     SuperscriptBox["r", "2"]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", "k"}], "-", 
      FractionBox[
       RowBox[{"h2", " ", 
        SuperscriptBox["k", "2"]}], 
       RowBox[{" ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", "c14", " ", "c2"}], 
       RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dk", 
     RowBox[{"r", " ", "r0"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g1", " ", "k", " ", "c1"}], 
       RowBox[{"r0", " ", "r"}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "h1", " ", 
         SuperscriptBox["k", 
          RowBox[{"2", " "}]]}], "-", 
        RowBox[{"2", " ", "k", " ", "c14"}]}], 
       RowBox[{"beta", " ", "r0"}]], "-", 
      RowBox[{"h1", " ", "k"}], "-", 
      FractionBox[
       RowBox[{"h2", " ", 
        SuperscriptBox["k", "2"], " ", "c1"}], 
       RowBox[{"r", " ", "r0"}]], "+", "c14", "-", 
      FractionBox[
       RowBox[{"k", " ", "c17", "  ", "c14"}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", "c1", " ", "c14", "  ", "c2"}], 
       RowBox[{
        SuperscriptBox["r", "2"], "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["v0", "r"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"d", " ", "g1", " ", "k"}], "r"]}], "+", 
         FractionBox[
          RowBox[{"2", " ", "g2", " ", "k"}], "beta"], "+", 
         FractionBox[
          RowBox[{"d", " ", "h2", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{"r", " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"4", " ", "h1", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{"beta", " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"k", " ", "c18", " ", "c14"}], 
          RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", "c14", " ", "c2"}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["x0", 
        SuperscriptBox["r", "2"]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "g2", " ", "k"}], "-", 
         FractionBox[
          RowBox[{"g2", " ", "h2", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{" ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", "c14"}], "r0"], "-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", "c14", " ", "c2"}], 
          RowBox[{"r", " ", "r0"}]]}], ")"}]}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["v0", 
        SuperscriptBox["r", "2"]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "g2", " ", "k"}], "-", 
         FractionBox[
          RowBox[{"g2", " ", "h2", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{" ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", "c14"}], "r0"], "-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", "c14", " ", "c2"}], 
          RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["x0", 
        RowBox[{"r", " ", 
         SuperscriptBox["r0", "3"]}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g1", " ", "k", " ", "c3"}], "r"]}], "-", 
         FractionBox[
          RowBox[{"4", " ", "h1", " ", 
           SuperscriptBox["k", "3"]}], 
          RowBox[{"beta", " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"2", " ", "g2", " ", 
           SuperscriptBox["k", "2"]}], "beta"], "+", 
         RowBox[{"h1", " ", 
          SuperscriptBox["k", "2"]}], "+", 
         FractionBox[
          RowBox[{"h2", " ", 
           SuperscriptBox["k", "2"], " ", "c3"}], 
          RowBox[{"r", " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["k", "2"], " ", "c4", " ", "c14"}], 
          RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"k", " ", "c3", " ", "c14", " ", "c2"}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776691320999022*^9, 3.77669133015523*^9}, 
   3.776691631208848*^9, {3.7767369453506327`*^9, 3.776736970096547*^9}, {
   3.776737534139628*^9, 3.776737557564481*^9}, {3.776737593801382*^9, 
   3.776737708687437*^9}, {3.77673778392033*^9, 3.776737801384687*^9}, {
   3.776738085232239*^9, 3.77673808684127*^9}, {3.776738449913919*^9, 
   3.776738453850074*^9}, {3.776738674038329*^9, 3.776738674415222*^9}, {
   3.776738731171372*^9, 3.776738831997349*^9}, 3.7767803073344803`*^9, {
   3.77678250566646*^9, 3.776782548210917*^9}, {3.7767826839677343`*^9, 
   3.7767827814676647`*^9}, {3.776782868215633*^9, 3.7767828822349253`*^9}, {
   3.7767830049506893`*^9, 
   3.776783077940921*^9}},ExpressionUUID->"00e8da88-ebd2-4017-a133-\
efbfb080bdda"],

Cell[BoxData[
 RowBox[{"dgdotm12", " ", "=", " ", 
  RowBox[{
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"g1", " ", "k"}], 
        SuperscriptBox["r", "2"]]}], "+", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", "c2"}], 
       SuperscriptBox["r", "3"]]}], ")"}]}], "+", 
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["g2", "r"]}], "-", 
      FractionBox[
       RowBox[{"g1", " ", "k", " ", "c1"}], 
       RowBox[{"r0", " ", 
        SuperscriptBox["r", "2"]}]], "+", 
      FractionBox[
       RowBox[{"2", " ", "g2", " ", "k"}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", "c17"}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", "c1", " ", "c2"}], 
       RowBox[{"r0", " ", 
        SuperscriptBox["r", "3"]}]]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        SuperscriptBox["g2", "2"], " ", "k", " ", "x0", " ", "c2"}], 
       SuperscriptBox["r", "3"]], "+", 
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"d", " ", "g1", " ", "k"}], 
          SuperscriptBox["r", "2"]], "-", 
         FractionBox[
          RowBox[{"2", " ", "g2", " ", "k"}], 
          RowBox[{"beta", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", "c18"}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"]}]], "-", 
         FractionBox[
          RowBox[{"d", " ", "g2", " ", "k", " ", "c2"}], 
          SuperscriptBox["r", "3"]]}], ")"}]}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        SuperscriptBox["g2", "2"], " ", "k", " ", "v0", " ", "c2"}], 
       SuperscriptBox["r", "3"]], "+", 
      RowBox[{
       FractionBox["x0", 
        SuperscriptBox["r0", "3"]], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"g1", " ", "k", " ", "c3"}], 
          SuperscriptBox["r", "2"]], "-", 
         FractionBox[
          RowBox[{"2", " ", "g2", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{"beta", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           SuperscriptBox["k", "2"], "c18", " "}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " "}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           SuperscriptBox["k", "2"], "2", " ", "c6"}], 
          RowBox[{
           SuperscriptBox["r", "2"], " "}]], "-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", "c3", " ", "c2"}], 
          SuperscriptBox["r", "3"]]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7767369285249643`*^9, 3.776736928537046*^9}, 
   3.776737300821974*^9, {3.776737821791153*^9, 3.776737901620905*^9}, {
   3.776738017977585*^9, 3.776738045450495*^9}, {3.776738525818439*^9, 
   3.776738526385788*^9}, {3.7767386371422567`*^9, 3.7767386376156282`*^9}, {
   3.776739156905024*^9, 3.77673924906153*^9}, 
   3.776780308521928*^9},ExpressionUUID->"c8c5ca50-a29c-4421-a2d2-\
a6db14db5808"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"dgmhgdot2", "=", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", "dh"}], 
      SuperscriptBox["r", "3"]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"r", " ", "c16"}], "-", 
       RowBox[{"c15", " ", "c2"}]}], ")"}]}], "+", 
    RowBox[{
     FractionBox["dk", "r"], " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "c1", " ", "c16"}], 
        RowBox[{"r0", " ", "r"}]], "+", "c15", "-", 
       FractionBox[
        RowBox[{"k", " ", "c17", " ", "c15"}], 
        RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
       FractionBox[
        RowBox[{" ", 
         RowBox[{"k", " ", "c19"}]}], 
        RowBox[{"beta", " ", "r0"}]], "-", 
       FractionBox[
        RowBox[{"k", " ", "c1", " ", "c15", " ", "c2"}], 
        SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
    RowBox[{"dv0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["v0", "r"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"d", " ", "k", " ", "c16"}], "r"]}], "-", 
          FractionBox[
           RowBox[{"k", " ", "c18", " ", "c15"}], 
           RowBox[{"beta", " ", "r"}]], "+", 
          FractionBox[
           RowBox[{" ", 
            RowBox[{"k", " ", "c19"}]}], "beta"], "+", 
          FractionBox[
           RowBox[{"d", " ", "k", " ", "c15", " ", "c2"}], 
           SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
       RowBox[{
        FractionBox["x0", "r"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"h1", " ", "k"}], "+", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", "c16"}], "r"], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "r"}], " ", "+", 
              RowBox[{"g2", "  ", "c2"}]}], ")"}], "c15"}], 
           SuperscriptBox["r", "2"]]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{"dx0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["v0", "r"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"h1", " ", "k"}], "+", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", "c16"}], "r"], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "r"}], " ", "+", 
              RowBox[{"g2", "  ", "c2"}]}], ")"}], "c15"}], 
           SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
       RowBox[{
        FractionBox["x0", 
         RowBox[{"r", " ", "r0"}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"h2", " ", "k"}], "-", 
          FractionBox[
           RowBox[{"k", " ", "c3", " ", "c16"}], 
           RowBox[{
            SuperscriptBox["r0", "2"], " ", "r"}]], "-", 
          FractionBox[
           RowBox[{
            SuperscriptBox["k", "2"], " ", "c18", " ", "c15"}], 
           RowBox[{"beta", " ", "r", " ", 
            SuperscriptBox["r0", "2"]}]], "-", 
          FractionBox[
           RowBox[{
            SuperscriptBox["k", "2"], " ", "2", " ", "c6", " ", "c15"}], 
           RowBox[{" ", 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "2"]}]}]], "+", 
          FractionBox[
           RowBox[{" ", 
            RowBox[{
             SuperscriptBox["k", "2"], " ", "c19"}]}], 
           RowBox[{"beta", " ", 
            SuperscriptBox["r0", "2"]}]], "+", 
          FractionBox[
           RowBox[{"k", " ", "c3", " ", "c15", " ", "c2"}], 
           RowBox[{
            SuperscriptBox["r0", "2"], 
            SuperscriptBox["r", "2"]}]]}], ")"}]}]}], ")"}]}]}]}]}]], "Input",\

 CellChangeTimes->{
  3.776691308162664*^9, 3.7767116794838543`*^9, 3.77673692408749*^9, 
   3.7767373280867157`*^9, {3.776737375223014*^9, 3.7767374481601543`*^9}, {
   3.7767379095670567`*^9, 3.776737971103703*^9}, {3.776738144056405*^9, 
   3.776738250909285*^9}, {3.776738298490622*^9, 3.7767383956882763`*^9}, {
   3.7767385329475117`*^9, 3.776738533713043*^9}, {3.776738647230747*^9, 
   3.776738648525469*^9}, {3.776739054431713*^9, 3.7767390662838993`*^9}, {
   3.776739286205522*^9, 3.7767393368858128`*^9}, {3.7767803094429483`*^9, 
   3.7767803109776*^9}, {3.776783173882262*^9, 3.776783203834745*^9}, {
   3.776783382736424*^9, 3.776783403745323*^9}, {3.776783441929647*^9, 
   3.776783450319281*^9}, {3.7767834990726213`*^9, 
   3.776783510765407*^9}},ExpressionUUID->"4fbe6a8f-800f-4fc4-9f53-\
ab19878a91c8"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.776736920357217*^9, 
  3.776736920369054*^9}},ExpressionUUID->"97ccf9d4-1e4c-46d5-9d61-\
2aeb46d705b6"],

Cell[BoxData["dlnfdot"], "Input",
 CellChangeTimes->{{3.776691718207993*^9, 3.776691719670343*^9}},
 CellLabel->"In[95]:=",ExpressionUUID->"af26e4c8-2a3a-44a3-b66a-2256535154ff"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.776736916236463*^9, 
  3.776736916247624*^9}},ExpressionUUID->"c9f26b1c-554a-475a-a95b-\
ebfc71e8b43b"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Using", " ", "newly", " ", "defined", " ", "constants", " ", "to", " ", 
    "simplify", " ", "expression", " ", "for", " ", 
    RowBox[{"dlnfdot", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776691746171131*^9, 3.776691759748068*^9}, {
  3.7767091376394167`*^9, 
  3.77670914060669*^9}},ExpressionUUID->"9b5ba98d-3226-4c6b-ad4b-\
95ec6a9691b5"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.776703870639513*^9, 3.7767038757198963`*^9}, {
   3.776704333027095*^9, 3.7767043332339993`*^9}, 
   3.776737055597505*^9},ExpressionUUID->"bcf8b2d4-6b39-4cd5-b7f1-\
a75099e7dd54"],

Cell[BoxData[
 RowBox[{"dlnfdot2", "=", " "}]], "Input",
 CellChangeTimes->{{3.776691729783072*^9, 3.776691739131878*^9}, {
   3.7766917949395037`*^9, 3.7766918861620398`*^9}, {3.776691975310884*^9, 
   3.776691985893449*^9}, {3.7766920556257877`*^9, 3.776692069824437*^9}, {
   3.7766921015857477`*^9, 3.776692231827675*^9}, {3.776692391634923*^9, 
   3.77669242271068*^9}, {3.776692474911634*^9, 3.7766925114554*^9}, {
   3.776692572106443*^9, 3.776692596610045*^9}, {3.7766926518509197`*^9, 
   3.776692973916613*^9}, {3.776693056402398*^9, 3.7766931554042673`*^9}, {
   3.776693194394102*^9, 3.776693242613844*^9}, {3.776701466555531*^9, 
   3.7767015629886837`*^9}, {3.7767016013354473`*^9, 3.77670167746452*^9}, {
   3.7767017091465397`*^9, 3.776701728025323*^9}, {3.776701759166603*^9, 
   3.776701779193314*^9}, {3.7767018122986526`*^9, 3.77670185600673*^9}, {
   3.776701899423542*^9, 3.776702076666629*^9}, {3.776702111273798*^9, 
   3.7767022302736273`*^9}, {3.776702305236182*^9, 3.776702363457801*^9}, {
   3.776702398577669*^9, 3.776702513501821*^9}, {3.776702739203247*^9, 
   3.776702746180407*^9}, {3.7767027988292418`*^9, 3.7767028087408323`*^9}, {
   3.776702841229972*^9, 3.776702873143045*^9}, {3.776702910728636*^9, 
   3.776702941704483*^9}, {3.77670338231505*^9, 3.776703479283317*^9}, {
   3.776703522239962*^9, 3.776703595841824*^9}, 3.776703645873591*^9, {
   3.776703702555336*^9, 3.776703715428442*^9}, {3.7767037486267023`*^9, 
   3.776703899360273*^9}, {3.776704336651758*^9, 3.776704343266019*^9}, {
   3.7767051772323227`*^9, 3.7767051807500362`*^9}, {3.776706822644452*^9, 
   3.7767068408038177`*^9}, {3.776707043287675*^9, 3.7767070632774143`*^9}, {
   3.776707244680345*^9, 3.776707249000114*^9}, {3.776707393836131*^9, 
   3.776707394451705*^9}, {3.7767074850486317`*^9, 3.776707528937662*^9}, {
   3.776707595290024*^9, 3.776707616047817*^9}, {3.776707674120593*^9, 
   3.776707679195024*^9}, 
   3.7767370806818666`*^9},ExpressionUUID->"9882cfaa-3b61-4e03-a453-\
832a4cd9792f"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"The", " ", "following", " ", "gives", " ", "zero"}], ",", " ", 
    RowBox[{"so", " ", "this", " ", "seems", " ", "to", " ", 
     RowBox[{"work", "!"}]}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776709148852672*^9, 
  3.77670915662204*^9}},ExpressionUUID->"825d7c33-30ae-462f-bb2b-\
bd59ba93f218"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"dlnfdot", " ", "-", " ", "dlnfdot2"}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"(", 
          RowBox[{"k", "-", " ", 
           RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], "/.", " ", 
       RowBox[{"r", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
         RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
         RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"d", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"h", "+", 
          RowBox[{"eta", " ", "g2"}], "+", 
          RowBox[{"2", " ", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], 
     "  ", "/.", " ", 
     RowBox[{"h", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
       RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g0", " ", "\[Rule]", " ", 
     RowBox[{"Cos", "[", "gamma", "]"}]}]}], " ", "/.", " ", 
   RowBox[{"g1", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"Sin", "[", "gamma", "]"}], "/", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
  RowBox[{"g2", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}]], "Input",\

 CellChangeTimes->{{3.7767052307441683`*^9, 3.7767053254887543`*^9}},
 CellLabel->
  "In[182]:=",ExpressionUUID->"76e93013-27d4-4bc8-8c96-fe219f1cd379"],

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"dk", ",", "dh", ",", "dx0", ",", "dv0"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.776705352057817*^9, 3.7767053586324377`*^9}},
 CellLabel->
  "In[171]:=",ExpressionUUID->"36351a7f-e7e6-49ac-b77b-3d7deb0c3f6d"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "]"}]], "Input",
 CellChangeTimes->{{3.7767071936579857`*^9, 
  3.77670719777605*^9}},ExpressionUUID->"ae8f9d17-617e-4be9-90a1-\
f8c780806317"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Next", ",", " ", 
   RowBox[{
    RowBox[{"try", " ", "to", " ", "simplify", " ", "d", 
     RowBox[{"(", 
      RowBox[{"g", "-", 
       RowBox[{"h", "*", "f"}]}], ")"}]}], ":"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.7767091656386557`*^9, 
  3.776709185639222*^9}},ExpressionUUID->"4a6448e5-e47e-461d-9ba9-\
12d44ddddb11"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"First", ",", " ", 
    RowBox[{
    "see", " ", "if", " ", "we", " ", "can", " ", "simplify", " ", "some", 
     " ", 
     RowBox[{"expressions", "."}]}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{
  3.776709191066565*^9, {3.776709268264399*^9, 3.776709277919703*^9}},
 CellLabel->
  "In[184]:=",ExpressionUUID->"712d9fd8-0acb-412e-9fda-a6393e248e86"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.776713475232999*^9, 3.7767134828980217`*^9}, 
   3.7767371348997097`*^9},ExpressionUUID->"4c05a68c-d9ea-4037-a161-\
1ac2cac8850b"],

Cell[BoxData[
 RowBox[{"dgmhf2", " ", "="}]], "Input",
 CellChangeTimes->{{3.7767091656386557`*^9, 3.776709205340872*^9}, {
   3.7767095770007887`*^9, 3.776709623754099*^9}, {3.776709671451326*^9, 
   3.7767099117284613`*^9}, {3.7767099895677767`*^9, 3.776710002603879*^9}, {
   3.77671054528476*^9, 3.776710567082855*^9}, {3.776710853755413*^9, 
   3.776710979550313*^9}, {3.77671172218443*^9, 3.77671179814534*^9}, {
   3.776711875621098*^9, 3.776711941524364*^9}, {3.7767120297990503`*^9, 
   3.776712034781104*^9}, {3.7767122142802277`*^9, 3.776712310286336*^9}, {
   3.776712374895905*^9, 3.776712411468004*^9}, {3.7767127392323313`*^9, 
   3.776712747816139*^9}, {3.776712806085458*^9, 3.77671287963589*^9}, {
   3.776712950663349*^9, 3.776712959621538*^9}, {3.776712995239088*^9, 
   3.776713075396824*^9}, 3.776713110876556*^9, 3.776713144578516*^9, {
   3.77671317830881*^9, 3.77671351407833*^9}, {3.7767143387605667`*^9, 
   3.7767143615248938`*^9}, 
   3.7767371425858583`*^9},ExpressionUUID->"376fe43f-defe-4caa-b0d9-\
bd92e37a9865"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"dgmhf", " ", "-", " ", "dgmhf2"}], "  ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"(", 
          RowBox[{"k", "-", " ", 
           RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], "/.", " ", 
       RowBox[{"r", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
         RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
         RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"d", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"h", "+", 
          RowBox[{"eta", " ", "g2"}], "+", 
          RowBox[{"2", " ", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], 
     "  ", "/.", " ", 
     RowBox[{"h", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
       RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g0", " ", "\[Rule]", " ", 
     RowBox[{"Cos", "[", "gamma", "]"}]}]}], " ", "/.", " ", 
   RowBox[{"g1", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"Sin", "[", "gamma", "]"}], "/", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
  RowBox[{"g2", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta", 
    " "}]}]}]], "Input",
 CellChangeTimes->{{3.7767136881524487`*^9, 3.776713699328803*^9}, {
  3.776713765744384*^9, 3.776713821027521*^9}, {3.776713895277336*^9, 
  3.776713919529546*^9}},ExpressionUUID->"0a707780-996c-45ba-bf2c-\
23b1d27d30c8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Next", ",", " ", 
    RowBox[{"work", " ", "on", " ", 
     RowBox[{"dlnf", ":"}]}]}], " ", "*)"}], "\[IndentingNewLine]"}]], "Input",\

 CellChangeTimes->{{3.776713964196665*^9, 3.77671396921833*^9}, {
   3.776714270405583*^9, 3.776714276966325*^9}, 
   3.776737151328971*^9},ExpressionUUID->"1690a552-09d6-469d-a993-\
132d0b02a83e"],

Cell[BoxData[
 RowBox[{"dlnf2", " ", "=", " "}]], "Input",
 CellChangeTimes->{{3.776713986050543*^9, 3.776714001442732*^9}, {
   3.776714068324239*^9, 3.776714088026724*^9}, {3.7767141310328407`*^9, 
   3.776714314284542*^9}, 
   3.7767371488312397`*^9},ExpressionUUID->"58a361e1-f98c-4528-8b53-\
27f745a9b24f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Okay", ",", " ", 
    RowBox[{"finally", " ", 
     RowBox[{"dgdotmhfdotm1", ":"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.7767144681239357`*^9, 3.776714493210115*^9}, {
   3.776715590237748*^9, 3.776715594574127*^9}, 
   3.776737160754388*^9},ExpressionUUID->"78916221-f436-40ce-9c4c-\
b6f20e2d69e2"],

Cell[BoxData[
 RowBox[{"dgdotmhfdotm1", " ", "=", "  "}]], "Input",
 CellChangeTimes->{{3.7767145461863203`*^9, 3.7767147942909718`*^9}, {
   3.776715547515938*^9, 3.7767156662050533`*^9}, {3.776715837422112*^9, 
   3.77671592588382*^9}, {3.77671596918196*^9, 3.776716015300721*^9}, {
   3.7767160847600393`*^9, 3.776716129452058*^9}, {3.776716224618239*^9, 
   3.776716233199389*^9}, {3.776716352788043*^9, 3.7767163568599033`*^9}, {
   3.7767164217300253`*^9, 3.776716423189013*^9}, {3.7767164577564697`*^9, 
   3.7767164624235077`*^9}, {3.776716508477015*^9, 3.776716552179969*^9}, {
   3.7767166998223867`*^9, 3.776716839915941*^9}, {3.7767168890137663`*^9, 
   3.776717265621983*^9}, {3.776717320902586*^9, 3.776717343356661*^9}, {
   3.776717386458021*^9, 3.776717431440074*^9}, {3.776717477412157*^9, 
   3.7767174983477297`*^9}, {3.7767175397266083`*^9, 3.7767176312780933`*^9}, 
   3.776718209649678*^9, {3.776718251033676*^9, 3.776718263664241*^9}, 
   3.776737170231802*^9},ExpressionUUID->"d0d5a7f4-fe2f-4c77-9ba6-\
59157138e099"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"We", " ", "forgot", " ", "to", " ", "do", " ", 
    RowBox[{"dlnf", ":", " ", 
     RowBox[{"finish", " ", "up", " ", 
      RowBox[{"later", "."}]}]}]}], " ", "*)"}], 
  "\[AliasDelimiter]"}]], "Input",
 CellChangeTimes->{{3.776719824123232*^9, 
  3.776719833651709*^9}},ExpressionUUID->"8fc2e79c-b83a-4ad6-b8e1-\
d2b3e11af47f"],

Cell[BoxData[
 RowBox[{"dlnf2", " ", "=", " "}]], "Input",
 CellChangeTimes->{
  3.776719847634221*^9, {3.776724149478097*^9, 3.77672417469228*^9}, {
   3.776725489606967*^9, 3.7767255068574944`*^9}, 
   3.776737173102687*^9},ExpressionUUID->"27727c3a-ced6-41db-88e3-\
24e37700b917"]
},
WindowSize->{974, 855},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 425, 9, 30, "Input",ExpressionUUID->"66d95d8a-2d5b-4630-b86a-bba9ba5374c9"],
Cell[986, 31, 364, 8, 52, "Input",ExpressionUUID->"0c68b6db-41b8-4681-98f9-b85cce6aa12d"],
Cell[1353, 41, 331, 7, 30, "Input",ExpressionUUID->"5e50fe82-9cbc-4d37-92a4-b9b6432d73af"],
Cell[1687, 50, 4772, 140, 543, "Input",ExpressionUUID->"cf228877-6822-4c35-9393-6c0e42ffdde2"],
Cell[6462, 192, 3423, 104, 144, "Input",ExpressionUUID->"cb606c02-a60e-4d23-ad2c-371cb5cfe5d2"],
Cell[9888, 298, 5254, 145, 217, "Input",ExpressionUUID->"00e8da88-ebd2-4017-a133-efbfb080bdda"],
Cell[15145, 445, 3325, 94, 144, "Input",ExpressionUUID->"c8c5ca50-a29c-4421-a2d2-a6db14db5808"],
Cell[18473, 541, 4562, 124, 160, "Input",ExpressionUUID->"4fbe6a8f-800f-4fc4-9f53-ab19878a91c8"],
Cell[23038, 667, 152, 3, 30, "Input",ExpressionUUID->"97ccf9d4-1e4c-46d5-9d61-2aeb46d705b6"],
Cell[23193, 672, 178, 2, 30, "Input",ExpressionUUID->"af26e4c8-2a3a-44a3-b66a-2256535154ff"],
Cell[23374, 676, 152, 3, 30, "Input",ExpressionUUID->"c9f26b1c-554a-475a-a95b-ebfc71e8b43b"],
Cell[23529, 681, 443, 10, 52, "Input",ExpressionUUID->"9b5ba98d-3226-4c6b-ad4b-95ec6a9691b5"],
Cell[23975, 693, 229, 4, 30, "Input",ExpressionUUID->"bcf8b2d4-6b39-4cd5-b7f1-a75099e7dd54"],
Cell[24207, 699, 2017, 29, 30, "Input",ExpressionUUID->"9882cfaa-3b61-4e03-a453-832a4cd9792f"],
Cell[26227, 730, 401, 9, 52, "Input",ExpressionUUID->"825d7c33-30ae-462f-bb2b-bd59ba93f218"],
Cell[26631, 741, 1620, 44, 52, "Input",ExpressionUUID->"76e93013-27d4-4bc8-8c96-fe219f1cd379"],
Cell[28254, 787, 312, 8, 30, "Input",ExpressionUUID->"36351a7f-e7e6-49ac-b77b-3d7deb0c3f6d"],
Cell[28569, 797, 183, 4, 30, "Input",ExpressionUUID->"ae8f9d17-617e-4be9-90a1-f8c780806317"],
Cell[28755, 803, 375, 10, 30, "Input",ExpressionUUID->"4a6448e5-e47e-461d-9ba9-12d44ddddb11"],
Cell[29133, 815, 437, 11, 52, "Input",ExpressionUUID->"712d9fd8-0acb-412e-9fda-a6393e248e86"],
Cell[29573, 828, 179, 3, 30, "Input",ExpressionUUID->"4c05a68c-d9ea-4037-a161-1ac2cac8850b"],
Cell[29755, 833, 1045, 16, 30, "Input",ExpressionUUID->"376fe43f-defe-4caa-b0d9-bd92e37a9865"],
Cell[30803, 851, 1882, 50, 73, "Input",ExpressionUUID->"0a707780-996c-45ba-bf2c-23b1d27d30c8"],
Cell[32688, 903, 392, 10, 52, "Input",ExpressionUUID->"1690a552-09d6-469d-a993-132d0b02a83e"],
Cell[33083, 915, 311, 6, 30, "Input",ExpressionUUID->"58a361e1-f98c-4528-8b53-27f745a9b24f"],
Cell[33397, 923, 397, 10, 52, "Input",ExpressionUUID->"78916221-f436-40ce-9c4c-b6f20e2d69e2"],
Cell[33797, 935, 1042, 15, 30, "Input",ExpressionUUID->"d0d5a7f4-fe2f-4c77-9ba6-59157138e099"],
Cell[34842, 952, 387, 10, 30, "Input",ExpressionUUID->"8fc2e79c-b83a-4ad6-b8e1-d2b3e11af47f"],
Cell[35232, 964, 283, 6, 30, "Input",ExpressionUUID->"27727c3a-ced6-41db-88e3-24e37700b917"]
}
]
*)

