(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    188249,       5569]
NotebookOptionsPosition[    173954,       5339]
NotebookOutlinePosition[    174291,       5354]
CellTagsIndexPosition[    174248,       5351]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Trying", " ", "to", " ", "compute", " ", "differentials", " ", 
     RowBox[{"of", " ", "\\", "dot"}], " ", "f"}], ",", " ", 
    RowBox[{"g", "-", "h"}], ",", " ", 
    RowBox[{
     RowBox[{
     "and", " ", "other", " ", "quantities", " ", "needed", " ", "in", " ", 
      "Drift"}], " ", "+", " ", 
     RowBox[{"Kepler", " ", 
      RowBox[{"problem", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Note", ":", "  ", 
     RowBox[{"below", "  ", "d"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", "*", "g2"}], "+", 
         RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}], 
      "\[IndentingNewLine]", "  ", "r"}], " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
       RowBox[{"k", " ", "g2", "\[IndentingNewLine]", "h"}]}], " ", "=", " ", 
      
      RowBox[{
       RowBox[{
        RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
        RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
        RowBox[{"k", " ", "g3", "\[IndentingNewLine]", "g0"}]}], " ", "=", 
       " ", 
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2", " ", "\[IndentingNewLine]", "g3"}]}], " ",
         "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"s", "-", "g1"}], ")"}], "/", "beta"}], " ", 
           "\[IndentingNewLine]", "g0", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g1", "^", "2"}]}], " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"-", "g2"}], "\[IndentingNewLine]", 
            RowBox[{"g0", "^", "2"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"g1", "^", "2"}], " ", "beta"}]}], " ", "=", " ", 
          RowBox[{
           RowBox[{"1", "\[IndentingNewLine]", "zeta"}], " ", "=", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}]}]}]}]}]}]}], 
   "\[IndentingNewLine]", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
  3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
  3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
  3.776520393320311*^9, 3.776520404710821*^9}, {3.776542972077035*^9, 
  3.7765429875095453`*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"53329b6c-a80c-45ac-ae62-f6fb243392bd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgamma", " ", "=", " ", 
  RowBox[{
   FractionBox["sqb", "r"], " ", 
   RowBox[{"(", 
    RowBox[{"dh", " ", "+", "  ", 
     RowBox[{
      FractionBox["dk", "r0"], 
      RowBox[{"(", 
       RowBox[{"d", "-", " ", 
        RowBox[{"r0", " ", "g3"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"k", " ", "d"}], "+", 
           RowBox[{"g1", " ", 
            SuperscriptBox["r0", "2"]}]}], ")"}], 
         FractionBox["x0", 
          SuperscriptBox["r0", "3"]]}], "+", 
        RowBox[{"g2", " ", "v0"}]}], ")"}]}], "-", 
     RowBox[{"dv0", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", "  ", "v0"}], " ", "+", " ", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
   3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
   3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
   3.776520393320311*^9, 3.776520404710821*^9}, {3.776542972077035*^9, 
   3.7765429875095453`*^9}, 3.776947603146037*^9, 3.776947915246524*^9, 
   3.7770325938065453`*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"b55f3b19-1b6b-49b6-9b71-fd1ea829ac9b"],

Cell[BoxData[
 FractionBox[
  RowBox[{"sqb", " ", 
   RowBox[{"(", 
    RowBox[{"dh", "+", 
     FractionBox[
      RowBox[{"dk", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
     RowBox[{"dv0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", " ", "v0"}], "+", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g2", " ", "v0"}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
         SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"]], "Output",
 CellChangeTimes->{3.776202160614881*^9, 3.7765429926826963`*^9, 
  3.776547955990848*^9, 3.777032597283903*^9, 3.777041903500513*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"7a726e8c-5ea0-4fea-896d-c5d0fc36e696"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Corrected", " ", "expression", " ", "for", " ", 
   RowBox[{"dr", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776198428651246*^9, 3.7761985237438927`*^9}, {
  3.776543018148497*^9, 3.776543018579586*^9}, {3.776543081746882*^9, 
  3.776543083706243*^9}, {3.7765480676340427`*^9, 3.776548073216248*^9}, {
  3.77703257816824*^9, 3.777032584230543*^9}},
 CellLabel->"In[61]:=",ExpressionUUID->"ec64950c-8ed3-4bc5-92a5-293069313a0b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr", " ", "=", " ", 
  RowBox[{
   RowBox[{
    FractionBox["dgamma", "sqb"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"zeta", " ", "g1"}], "+", 
      RowBox[{"eta", " ", "g0"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dk", 
     RowBox[{"beta", " ", "r0", " "}]], 
    RowBox[{"(", 
     RowBox[{"r0", "-", "r", "-", 
      RowBox[{"k", " ", "g2"}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["1", 
        RowBox[{"beta", " ", 
         SuperscriptBox["r0", "3"]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", 
          RowBox[{"(", 
           RowBox[{"r", "+", 
            RowBox[{"k", " ", "g2"}]}], ")"}]}], "-", 
         RowBox[{"zeta", " ", "r0", " ", "g0"}]}], ")"}], "x0"}], " ", "+", 
      " ", 
      RowBox[{"g1", "  ", "v0"}]}], ")"}]}], " ", "+", " ", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "k", " ", "g2"}]}], ")"}], " ", 
       FractionBox["v0", "beta"]}], " ", "+", " ", 
      RowBox[{"g1", " ", "x0"}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776198428651246*^9, 3.7761985237438927`*^9}, {
  3.776543018148497*^9, 3.776543018579586*^9}, {3.776543081746882*^9, 
  3.776543083706243*^9}, {3.7765480676340427`*^9, 3.776548073216248*^9}, {
  3.77703257816824*^9, 3.777032584230543*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"545c77c0-9ece-4359-98ca-7287482c53c9"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}]}], 
   RowBox[{"beta", " ", "r0"}]], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], "beta"], 
     "+", 
     RowBox[{"g1", " ", "x0"}]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"dh", "+", 
      FractionBox[
       RowBox[{"dk", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
      RowBox[{"dv0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
      RowBox[{"dx0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "v0"}], "+", 
     FractionBox[
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776202167353901*^9, 3.776543108866024*^9, 
  3.776548130862543*^9, 3.777032601518371*^9, 3.77704190676597*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"19a28e86-af8a-4042-b3b4-3e1e8a402f59"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dbeta", " ", "=", " ", 
  RowBox[{
   RowBox[{"2", "*", 
    RowBox[{"dk", "/", "r0"}]}], "-", 
   RowBox[{"2", "*", 
    RowBox[{"k", "/", 
     RowBox[{"r0", "^", "3"}]}], "*", " ", 
    RowBox[{"(", 
     RowBox[{"dx0", " ", "*", " ", "x0"}], ")"}]}], " ", "-", " ", 
   RowBox[{"2", "*", "v0", " ", "*", " ", "dv0"}]}]}]], "Input",
 CellChangeTimes->{{3.776198629796771*^9, 3.776198668928054*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"95296aac-8480-48bf-b720-90060933f9ed"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", "dk"}], "r0"], "-", 
  RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
  FractionBox[
   RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
   SuperscriptBox["r0", "3"]]}]], "Output",
 CellChangeTimes->{3.776198669836025*^9, 3.7762021775425386`*^9, 
  3.776543116034196*^9, 3.7765482498332253`*^9, 3.777032628692597*^9, 
  3.777041909993692*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"c24bdd1b-bc30-449a-9403-41f5b8f3cdc8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr0", " ", "=", " ", 
  RowBox[{"dx0", " ", "*", " ", 
   RowBox[{"x0", " ", "/", " ", "r0"}]}]}]], "Input",
 CellChangeTimes->{{3.776198724170291*^9, 3.776198736866087*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"6e130959-e5af-4389-aed5-d86ced425512"],

Cell[BoxData[
 FractionBox[
  RowBox[{"dx0", " ", "x0"}], "r0"]], "Output",
 CellChangeTimes->{3.776198740240225*^9, 3.776202183604251*^9, 
  3.776543117838472*^9, 3.776548257251302*^9, 3.7770326322563353`*^9, 
  3.777041913226234*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"2d498a40-0364-4c1f-b249-b369c6b280b4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"This", " ", "is", " ", 
     RowBox[{"dfdot", "/", "fdot"}]}], ",", " ", 
    RowBox[{
     RowBox[{"where", " ", "fdot"}], " ", "=", "  ", 
     RowBox[{
      RowBox[{
       RowBox[{"-", " ", "k"}], " ", 
       RowBox[{"G1", "/", 
        RowBox[{"(", 
         RowBox[{"r", " ", "r0"}], ")"}]}]}], ":"}]}]}], " ", 
   "*)"}]}]], "Input",
 CellChangeTimes->{{3.776545003903981*^9, 
  3.776545047257028*^9}},ExpressionUUID->"db7adf01-a7ab-46c1-a1a8-\
4d1abacc17e0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dlnfdot", "  ", "=", " ", 
  RowBox[{
   FractionBox["dk", "k"], "+", 
   FractionBox[
    RowBox[{"g0", " ", "dgamma"}], 
    RowBox[{"sqb", " ", "g1"}]], "-", 
   FractionBox["dbeta", 
    RowBox[{"2", " ", "beta"}]], "-", 
   FractionBox["dr", "r"], "-", 
   FractionBox["dr0", "r0"]}]}]], "Input",
 CellChangeTimes->{{3.7761987614783087`*^9, 3.776198796331312*^9}, {
  3.776201640154704*^9, 3.776201653535412*^9}, {3.776201731432234*^9, 
  3.776201735838003*^9}, {3.776543124922838*^9, 3.776543125953054*^9}, {
  3.77703264367472*^9, 3.777032721080167*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"16859656-b551-41b8-8148-c43961c8e68f"],

Cell[BoxData[
 RowBox[{
  FractionBox["dk", "k"], "-", 
  FractionBox[
   RowBox[{"dx0", " ", "x0"}], 
   SuperscriptBox["r0", "2"]], "-", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"2", " ", "dk"}], "r0"], "-", 
    RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
    FractionBox[
     RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
     SuperscriptBox["r0", "3"]]}], 
   RowBox[{"2", " ", "beta"}]], "+", 
  FractionBox[
   RowBox[{"g0", " ", 
    RowBox[{"(", 
     RowBox[{"dh", "+", 
      FractionBox[
       RowBox[{"dk", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
      RowBox[{"dv0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
      RowBox[{"dx0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], 
   RowBox[{"g1", " ", "r"}]], "-", 
  RowBox[{
   FractionBox["1", "r"], 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"dk", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}]}], 
      RowBox[{"beta", " ", "r0"}]], "+", 
     RowBox[{"dv0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], "beta"],
         "+", 
        RowBox[{"g1", " ", "x0"}]}], ")"}]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"dh", "+", 
         FractionBox[
          RowBox[{"dk", " ", 
           RowBox[{"(", 
            RowBox[{"d", "-", 
             RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
         RowBox[{"dv0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "v0"}], "+", 
            RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
         RowBox[{"dx0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "v0"}], "+", 
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
             SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "v0"}], "+", 
        FractionBox[
         RowBox[{"x0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7761988031696577`*^9, 3.7762016540022697`*^9, 
  3.776201736415719*^9, 3.776202188176824*^9, 3.776543134524659*^9, 
  3.776548264356183*^9, 3.7770327283199263`*^9, 3.777041919084366*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"0a054210-c316-44cb-b62d-860930e28318"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"dx0", ",", "dv0", ",", "dk", ",", "dh"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.776198885108611*^9, 3.776198910466971*^9}, {
   3.776199517362957*^9, 3.776199518824484*^9}, {3.776201661432477*^9, 
   3.776201662262883*^9}, {3.7762017413840237`*^9, 3.776201741469623*^9}, 
   3.776202194227912*^9, {3.776543140746441*^9, 3.776543143848097*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"c9449310-0549-409c-8d84-122d3e9eb019"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["g0", 
      RowBox[{"g1", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", "zeta"}]}], 
      SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "k"], "-", 
     FractionBox["1", 
      RowBox[{"beta", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"g1", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["v0", "beta"], "-", 
     FractionBox[
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "g1"}], "+", 
           RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], "beta"], 
       "+", 
       RowBox[{"g1", " ", "x0"}]}], "r"], "-", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      RowBox[{"g1", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", "x0"}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox["x0", 
      SuperscriptBox["r0", "2"]], "-", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      RowBox[{"g1", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"g1", " ", "v0"}], "+", 
       FractionBox[
        RowBox[{"x0", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
           RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
        RowBox[{"beta", " ", 
         SuperscriptBox["r0", "3"]}]]}], "r"]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776198913115247*^9, 3.776199519889267*^9, 
  3.77620166323871*^9, 3.776201742801187*^9, 3.7762021968404827`*^9, 
  3.776543145710002*^9, 3.776548268588169*^9, 3.777032734264369*^9, 
  3.777041923828339*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"7b7e2b56-ea5a-44f4-8821-019898e70ff2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"dlnfdot", " ", "term", " ", "for", " ", 
    RowBox[{"dv0", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776257440751553*^9, 
  3.7762574623583508`*^9}},ExpressionUUID->"0024ca85-75bc-42db-9780-\
7ef811ba4904"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["v0", "beta"], "-", 
     FractionBox[
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "g1"}], "+", 
           RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], "beta"], 
       "+", 
       RowBox[{"g1", " ", "x0"}]}], "r"], "-", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      RowBox[{"g1", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.776202368462758*^9, 3.7762023755675898`*^9}, 
   3.776543164075507*^9, 3.776548298263785*^9, 3.777032760077211*^9, 
   3.777041939080062*^9},
 CellLabel->"In[7]:=",ExpressionUUID->"84d7cdcb-e510-4ee9-9876-bdc3d993ed03"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "beta"], "-", 
     FractionBox[
      RowBox[{"d", " ", "g0"}], 
      RowBox[{"g1", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"2", " ", "g2", " ", "k"}]}], 
      RowBox[{"beta", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{"d", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["g1", "r"]}], "-", 
     FractionBox[
      RowBox[{"g0", " ", "g2"}], 
      RowBox[{"g1", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776202376445676*^9, 3.776543164843587*^9, 
  3.776548298841008*^9, 3.777032761910604*^9, 3.777041939881143*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"2015ee81-5d6a-4a17-bce6-716083c58e9c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"dlnfdot", " ", "term", " ", "for", " ", 
   RowBox[{"dx0", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776257472488208*^9, 
  3.776257478893918*^9}},ExpressionUUID->"a7b20bff-3044-4ace-9f7a-\
f98294f2f3d3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", "x0"}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox["x0", 
      SuperscriptBox["r0", "2"]], "-", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      RowBox[{"g1", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"g1", " ", "v0"}], "+", 
       FractionBox[
        RowBox[{"x0", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
           RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
        RowBox[{"beta", " ", 
         SuperscriptBox["r0", "3"]}]]}], "r"]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.776202504490386*^9, 3.776202517130032*^9}, 
   3.776543174276142*^9, 3.776548306248135*^9, 3.777032770041986*^9, 
   3.7770419476982*^9},
 CellLabel->"In[8]:=",ExpressionUUID->"0633086c-1d3f-49d2-b185-58412eb4c62b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["g1", "r"]}], "-", 
     FractionBox[
      RowBox[{"g0", " ", "g2"}], 
      RowBox[{"g1", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["k", 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox["1", 
      SuperscriptBox["r0", "2"]], "-", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], 
      RowBox[{"g1", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
       RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776202518775846*^9, 3.776543175176969*^9, 
  3.776548306807123*^9, 3.777032770746455*^9, 3.777041948388438*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"2e23a40e-e8f2-4512-a1d2-7e90367ce44f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
      "Working", " ", "out", " ", "full", " ", "dlnfdot", " ", "term", " ", 
       "for", " ", "drift"}], "-", 
      RowBox[{
      "first", " ", "case", " ", "by", " ", "replacing", " ", "dx0", " ", 
       "by", " ", 
       RowBox[{"(", 
        RowBox[{"dx0", "-", 
         RowBox[{"dh", "*", "v0"}], "-", 
         RowBox[{"h", "*", "dv0"}]}], ")"}]}]}], " ", "&"}], " ", "x0"}], " ",
    "\[Rule]", " ", 
   RowBox[{"x0", " ", "-", " ", 
    RowBox[{"h", " ", "v0", " ", "in", " ", "non"}], "-", 
    RowBox[{"scalar", " ", "differential", " ", 
     RowBox[{"terms", ":"}]}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7762575707238703`*^9, 3.776257611745723*^9}, {
  3.7770328408242407`*^9, 3.777032851727029*^9}, {3.7770329422410316`*^9, 
  3.77703294394442*^9}},ExpressionUUID->"48e0a9bb-0e03-4980-a9fa-\
2d51e48ea77e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dlnfdot", " ", "=", 
  RowBox[{
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["g0", 
       RowBox[{"g1", " ", "r"}]], "-", 
      FractionBox[
       RowBox[{
        RowBox[{"eta", " ", "g0"}], "+", 
        RowBox[{"g1", " ", "zeta"}]}], 
       SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", "k"], "-", 
      FractionBox["1", 
       RowBox[{"beta", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"g0", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{"g1", " ", "r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", "beta"], "-", 
         FractionBox[
          RowBox[{"d", " ", "g0"}], 
          RowBox[{"g1", " ", "r"}]], "-", 
         FractionBox[
          RowBox[{
           RowBox[{"eta", " ", "g1"}], "+", 
           RowBox[{"2", " ", "g2", " ", "k"}]}], 
          RowBox[{"beta", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x0", "-", 
         RowBox[{"h", " ", "v0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["g1", "r"]}], "-", 
         FractionBox[
          RowBox[{"g0", " ", "g2"}], 
          RowBox[{"g1", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          SuperscriptBox["r", "2"]]}], ")"}]}]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"dx0", "-", 
      RowBox[{"h", " ", "dv0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["g1", "r"]}], "-", 
         FractionBox[
          RowBox[{"g0", " ", "g2"}], 
          RowBox[{"g1", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x0", "-", 
         RowBox[{"h", " ", "v0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["k", 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox["1", 
          SuperscriptBox["r0", "2"]], "-", 
         FractionBox[
          RowBox[{"g0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{"g1", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
           RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
   RowBox[{"dh", "  ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"2", "k"}], "r0"], "-", "beta"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["g1", "r"]}], "-", 
         FractionBox[
          RowBox[{"g0", " ", "g2"}], 
          RowBox[{"g1", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["k", 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox["1", 
          SuperscriptBox["r0", "2"]], "-", 
         FractionBox[
          RowBox[{"g0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{"g1", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
           RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776257603307942*^9, 3.776257649380403*^9}, {
  3.776543236643553*^9, 3.776543284094349*^9}, {3.776543354978094*^9, 
  3.77654336066322*^9}, {3.776548320681609*^9, 3.7765483646108418`*^9}, {
  3.777032776906926*^9, 3.777032835018344*^9}, {3.7770328681643963`*^9, 
  3.777032956255336*^9}, {3.7770419657231607`*^9, 3.7770421004419413`*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"f786cdbb-b924-4eb2-838b-2dc638305375"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["g0", 
      RowBox[{"g1", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", "zeta"}]}], 
      SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "k"], "-", 
     FractionBox["1", 
      RowBox[{"beta", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"g1", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", "beta"], "-", 
        FractionBox[
         RowBox[{"d", " ", "g0"}], 
         RowBox[{"g1", " ", "r"}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"eta", " ", "g1"}], "+", 
          RowBox[{"2", " ", "g2", " ", "k"}]}], 
         RowBox[{"beta", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "beta"}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"g0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g1", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"dx0", "-", 
     RowBox[{"dv0", " ", "h"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"g0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g1", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.776543365542399*^9, {3.776548339482252*^9, 3.7765483659985933`*^9}, 
   3.777032975471601*^9, 3.777042101811715*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"82cc75a0-85b7-409b-a825-e00af83a1b63"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{
    "dx0", " ", ",", " ", "dv0", " ", ",", " ", "dk", ",", " ", "dh"}], 
    "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7762576589894037`*^9, 3.776257696602296*^9}, {
  3.776257736314624*^9, 3.776257742527274*^9}, {3.776543288717697*^9, 
  3.776543291579955*^9}, {3.776543338511224*^9, 3.776543369015685*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"a2953db8-00f4-416e-aad9-2cacfd70dbaa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "k"], "-", 
     FractionBox["1", 
      RowBox[{"beta", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"g1", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["g0", 
      RowBox[{"g1", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", "zeta"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "beta"}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"g0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g1", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"g0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g1", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", "beta"], "-", 
        FractionBox[
         RowBox[{"d", " ", "g0"}], 
         RowBox[{"g1", " ", "r"}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"eta", " ", "g1"}], "+", 
          RowBox[{"2", " ", "g2", " ", "k"}]}], 
         RowBox[{"beta", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "-", 
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"v0", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox["g1", "r"]}], "-", 
           FractionBox[
            RowBox[{"g0", " ", "g2"}], 
            RowBox[{"g1", " ", "r"}]], "+", 
           FractionBox[
            RowBox[{"g2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox["k", 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox["1", 
            SuperscriptBox["r0", "2"]], "-", 
           FractionBox[
            RowBox[{"g0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"g1", " ", "r", " ", 
             SuperscriptBox["r0", "3"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.7762576993941383`*^9, 3.77625774340796*^9, {3.776543293609583*^9, 
   3.776543369591444*^9}, {3.7765483419425993`*^9, 3.776548369871394*^9}, 
   3.777032978490081*^9, 3.777042108227921*^9, 3.777042149428628*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"af5afa91-4a82-40fe-ac2b-7e98d7713769"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"dx0", " ", "term", " ", "for", " ", "drift"}], "-", 
   RowBox[{"first", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776257755217338*^9, 
  3.776257767351172*^9}},ExpressionUUID->"9260977b-b0de-461c-996a-\
71c3b228e64d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"g0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g1", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.77625777115823*^9, 3.776257777064658*^9}, 
   3.7765433878250513`*^9, {3.7765483787946177`*^9, 3.776548388522747*^9}, 
   3.777032998880533*^9, 3.777042164851063*^9},
 CellLabel->"In[12]:=",ExpressionUUID->"95eab631-9a82-4215-a749-57272e016382"],

Cell[BoxData[
 RowBox[{
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["k", 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox["1", 
      SuperscriptBox["r0", "2"]], "-", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], 
      RowBox[{"g1", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
       RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}]}], "+", 
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["g1", "r"]}], "-", 
     FractionBox[
      RowBox[{"g0", " ", "g2"}], 
      RowBox[{"g1", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "-", 
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"g0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g1", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776257777606966*^9, 3.776543389565988*^9, 
  3.776548390191777*^9, 3.77703300017483*^9, 3.7770421657188053`*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"f004e70b-0613-4a56-a2c2-26953d9b0565"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"dv0", " ", "term", " ", "for", " ", "drift"}], "-", 
    RowBox[{"first", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", "beta"], "-", 
         FractionBox[
          RowBox[{"d", " ", "g0"}], 
          RowBox[{"g1", " ", "r"}]], "-", 
         FractionBox[
          RowBox[{
           RowBox[{"eta", " ", "g1"}], "+", 
           RowBox[{"2", " ", "g2", " ", "k"}]}], 
          RowBox[{"beta", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["g1", "r"]}], "-", 
         FractionBox[
          RowBox[{"g0", " ", "g2"}], 
          RowBox[{"g1", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          SuperscriptBox["r", "2"]]}], ")"}]}], "-", 
      RowBox[{"h", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"v0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox["g1", "r"]}], "-", 
            FractionBox[
             RowBox[{"g0", " ", "g2"}], 
             RowBox[{"g1", " ", "r"}]], "+", 
            FractionBox[
             RowBox[{"g2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox["k", 
             RowBox[{"beta", " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox["1", 
             SuperscriptBox["r0", "2"]], "-", 
            FractionBox[
             RowBox[{"g0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{"g1", " ", "r", " ", 
              SuperscriptBox["r0", "3"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{"k", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
              RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
             RowBox[{"beta", " ", "r", " ", 
              SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}], ")"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.776257788456625*^9, 3.776257804208694*^9}, 
   3.776543405969071*^9, {3.7765484011889877`*^9, 3.776548417666394*^9}, 
   3.777033008257079*^9, 3.777042176806293*^9},
 CellLabel->"In[13]:=",ExpressionUUID->"2564f2f9-eac0-4d13-8f0e-36dad0184aae"],

Cell[BoxData[
 RowBox[{
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["g1", "r"]}], "-", 
     FractionBox[
      RowBox[{"g0", " ", "g2"}], 
      RowBox[{"g1", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "-", 
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"g0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g1", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "beta"], "-", 
     FractionBox[
      RowBox[{"d", " ", "g0"}], 
      RowBox[{"g1", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"2", " ", "g2", " ", "k"}]}], 
      RowBox[{"beta", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{"d", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "-", 
     RowBox[{"2", " ", "h", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["h", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"g0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g1", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776257805016603*^9, 3.776543407196722*^9, 
  3.776548418246152*^9, 3.777033008856132*^9, 3.777042177687237*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"3fdc1a72-072e-44b9-8b6b-8d0c4dc00d6c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "Putting", " ", "all", " ", "of", " ", "these", " ", "terms", " ", 
    "together"}], ",", " ", 
   RowBox[{
    RowBox[{
    "here", " ", "is", " ", "the", " ", "final", " ", "expression", " ", 
     "for", " ", "dlnfdot", " ", "in", " ", "drift"}], "-", 
    RowBox[{"first", " ", 
     RowBox[{"case", ":"}]}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776259074516508*^9, 3.776259140965694*^9}, {
  3.7762591940897903`*^9, 3.776259194438386*^9}, {3.776543493224435*^9, 
  3.77654349440338*^9}},ExpressionUUID->"7ed18ad0-c39b-4759-bd10-\
029e2967f8e5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dlnfdot", " ", "=", 
  RowBox[{
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", "k"], "-", 
      FractionBox["1", 
       RowBox[{"beta", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"g0", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{"g1", " ", "r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["g0", 
       RowBox[{"g1", " ", "r"}]], "-", 
      FractionBox[
       RowBox[{
        RowBox[{"eta", " ", "g0"}], "+", 
        RowBox[{"g1", " ", "zeta"}]}], 
       SuperscriptBox["r", "2"]], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "beta"}], "+", 
         FractionBox[
          RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["g1", "r"]}], "-", 
         FractionBox[
          RowBox[{"g0", " ", "g2"}], 
          RowBox[{"g1", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["k", 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox["1", 
          SuperscriptBox["r0", "2"]], "-", 
         FractionBox[
          RowBox[{"g0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{"g1", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
           RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["k", 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox["1", 
          SuperscriptBox["r0", "2"]], "-", 
         FractionBox[
          RowBox[{"g0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{"g1", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
           RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}], "+", 
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["g1", "r"]}], "-", 
         FractionBox[
          RowBox[{"g0", " ", "g2"}], 
          RowBox[{"g1", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          SuperscriptBox["r", "2"]], "-", 
         RowBox[{"h", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox["k", 
             RowBox[{"beta", " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox["1", 
             SuperscriptBox["r0", "2"]], "-", 
            FractionBox[
             RowBox[{"g0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{"g1", " ", "r", " ", 
              SuperscriptBox["r0", "3"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{"k", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
              RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
             RowBox[{"beta", " ", "r", " ", 
              SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
   "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["g1", "r"]}], "-", 
         FractionBox[
          RowBox[{"g0", " ", "g2"}], 
          RowBox[{"g1", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          SuperscriptBox["r", "2"]], "-", 
         RowBox[{"h", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox["k", 
             RowBox[{"beta", " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox["1", 
             SuperscriptBox["r0", "2"]], "-", 
            FractionBox[
             RowBox[{"g0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{"g1", " ", "r", " ", 
              SuperscriptBox["r0", "3"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{"k", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
              RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
             RowBox[{"beta", " ", "r", " ", 
              SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", "beta"], "-", 
         FractionBox[
          RowBox[{"d", " ", "g0"}], 
          RowBox[{"g1", " ", "r"}]], "-", 
         FractionBox[
          RowBox[{
           RowBox[{"eta", " ", "g1"}], "+", 
           RowBox[{"2", " ", "g2", " ", "k"}]}], 
          RowBox[{"beta", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          SuperscriptBox["r", "2"]], "-", 
         RowBox[{"2", " ", "h", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox["g1", "r"]}], "-", 
            FractionBox[
             RowBox[{"g0", " ", "g2"}], 
             RowBox[{"g1", " ", "r"}]], "+", 
            FractionBox[
             RowBox[{"g2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["h", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox["k", 
             RowBox[{"beta", " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox["1", 
             SuperscriptBox["r0", "2"]], "-", 
            FractionBox[
             RowBox[{"g0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{"g1", " ", "r", " ", 
              SuperscriptBox["r0", "3"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{"k", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
              RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
             RowBox[{"beta", " ", "r", " ", 
              SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776259142991139*^9, 3.776259145021975*^9}, 
   3.7762592917822437`*^9, 3.776543484769848*^9, {3.7765435176956873`*^9, 
   3.77654354253555*^9}, {3.7765435747777233`*^9, 3.776543604097143*^9}, {
   3.776548479904228*^9, 3.776548549080544*^9}, 3.77703304178043*^9, {
   3.777033127163121*^9, 3.777033160862507*^9}, {3.7770421952495527`*^9, 
   3.777042221245*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"09f05ab5-fb26-4fb3-8d38-faed241e3432"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "k"], "-", 
     FractionBox["1", 
      RowBox[{"beta", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"g1", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["g0", 
      RowBox[{"g1", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", "zeta"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "beta"}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"g0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g1", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox["1", 
         SuperscriptBox["r0", "2"]], "-", 
        FractionBox[
         RowBox[{"g0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"g1", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}], "+", 
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox["k", 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox["1", 
            SuperscriptBox["r0", "2"]], "-", 
           FractionBox[
            RowBox[{"g0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"g1", " ", "r", " ", 
             SuperscriptBox["r0", "3"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
  "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["g1", "r"]}], "-", 
        FractionBox[
         RowBox[{"g0", " ", "g2"}], 
         RowBox[{"g1", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox["k", 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox["1", 
            SuperscriptBox["r0", "2"]], "-", 
           FractionBox[
            RowBox[{"g0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"g1", " ", "r", " ", 
             SuperscriptBox["r0", "3"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", "beta"], "-", 
        FractionBox[
         RowBox[{"d", " ", "g0"}], 
         RowBox[{"g1", " ", "r"}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"eta", " ", "g1"}], "+", 
          RowBox[{"2", " ", "g2", " ", "k"}]}], 
         RowBox[{"beta", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]], "-", 
        RowBox[{"2", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox["g1", "r"]}], "-", 
           FractionBox[
            RowBox[{"g0", " ", "g2"}], 
            RowBox[{"g1", " ", "r"}]], "+", 
           FractionBox[
            RowBox[{"g2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            SuperscriptBox["r", "2"]]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["h", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox["k", 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox["1", 
            SuperscriptBox["r0", "2"]], "-", 
           FractionBox[
            RowBox[{"g0", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"g1", " ", "r", " ", 
             SuperscriptBox["r0", "3"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.777033162654759*^9, 3.7770422228083887`*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"ea4abd9c-b278-46b5-8989-05ad3c9c74c1"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", ",", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"see", " ", "if", " ", "we", " ", "can", " ", "simplify"}], " ", 
     "-", " ", 
     RowBox[{"note", " ", "that", " ", "this", " ", "term", " ", "is", " ", 
      RowBox[{"df", "/", 
       RowBox[{"(", 
        RowBox[{"f", "-", "1"}], ")"}]}]}]}], ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776543638084257*^9, 3.776543653674282*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"2119f5f3-760c-487a-9160-ca0c499ad8ce"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"c1", "=", 
  RowBox[{"d", "-", 
   RowBox[{"r0", " ", "g3"}]}]}], "\n", 
 RowBox[{"c2", "=", 
  RowBox[{
   RowBox[{"eta", " ", "g0"}], "+", 
   RowBox[{"g1", " ", "zeta"}]}]}], "\n", 
 RowBox[{"c3", "=", 
  RowBox[{
   RowBox[{"d", " ", "k"}], "+", 
   RowBox[{"g1", " ", 
    SuperscriptBox["r0", "2"]}]}]}], "\n", 
 RowBox[{"c4", "=", 
  RowBox[{
   RowBox[{"eta", " ", "g1"}], "+", 
   RowBox[{"2", " ", "g0", " ", "r0"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c17", "=", 
  RowBox[{"r0", "-", "r", "-", 
   RowBox[{"g2", " ", "k"}]}]}], "\n", 
 RowBox[{"c18", "=", 
  RowBox[{
   RowBox[{"eta", " ", "g1"}], "+", 
   RowBox[{"2", " ", "g2", " ", "k"}]}]}], "\n", 
 RowBox[{"zeta", " ", "=", " ", 
  RowBox[{"k", "-", 
   RowBox[{"r0", " ", "beta"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c20", "=", 
  RowBox[{
   RowBox[{"k", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
   RowBox[{"g0", " ", "r0", " ", "zeta"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c21", " ", "=", " ", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g2", " ", "k"}], "-", "r0"}], ")"}], 
      RowBox[{"(", " ", 
       RowBox[{
        RowBox[{"beta", " ", "c3"}], "-", 
        RowBox[{"k", " ", "g1", " ", "r"}]}], ")"}]}], 
     RowBox[{"g1", " ", "beta", " ", 
      SuperscriptBox["r", "2"], " ", 
      SuperscriptBox["r0", "3"]}]], "+", 
    FractionBox[
     RowBox[{"eta", " ", "g1", " "}], 
     RowBox[{" ", 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "2"]}]}]], "-", 
    FractionBox["2", 
     SuperscriptBox["r0", "2"]]}]}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"=", " ", 
    RowBox[{
     FractionBox["k", 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox["1", 
      SuperscriptBox["r0", "2"]], "-", 
     FractionBox[
      RowBox[{"g0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], 
      RowBox[{"g1", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
       RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]]}]}], " ", "*)"}]}], "\n"}], "Input",
 CellChangeTimes->{{3.777033192310821*^9, 3.7770332614179373`*^9}, {
  3.777033334761894*^9, 3.7770333438247137`*^9}, {3.777038058858369*^9, 
  3.777038066082013*^9}, {3.777042921231328*^9, 3.777042936696539*^9}, {
  3.777043149894318*^9, 3.777043152703107*^9}},
 CellLabel->
  "In[220]:=",ExpressionUUID->"8ed8e21c-eb37-4c5c-b54b-17944470a79a"],

Cell[BoxData[
 RowBox[{"d", "-", 
  RowBox[{"g3", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.77704315371078*^9, 3.778169544396599*^9},
 CellLabel->
  "Out[220]=",ExpressionUUID->"021326ee-d6ef-4a01-a339-6762861252a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g0"}], "+", 
  RowBox[{"g1", " ", "zeta"}]}]], "Output",
 CellChangeTimes->{3.77704315371078*^9, 3.778169544398547*^9},
 CellLabel->
  "Out[221]=",ExpressionUUID->"21527c67-75c8-48ae-a1e5-5db32aabb65b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", " ", "k"}], "+", 
  RowBox[{"g1", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.77704315371078*^9, 3.778169544400441*^9},
 CellLabel->
  "Out[222]=",ExpressionUUID->"c65059e8-9575-4f29-8722-eed3ba5e5d7b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g1"}], "+", 
  RowBox[{"2", " ", "g0", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.77704315371078*^9, 3.778169544402584*^9},
 CellLabel->
  "Out[223]=",ExpressionUUID->"de403294-e27c-4d40-8985-459030cabb2f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}]], "Output",
 CellChangeTimes->{3.77704315371078*^9, 3.778169544404512*^9},
 CellLabel->
  "Out[224]=",ExpressionUUID->"e400ab09-bb08-4e46-9c81-4a4cbb061e76"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g1"}], "+", 
  RowBox[{"2", " ", "g2", " ", "k"}]}]], "Output",
 CellChangeTimes->{3.77704315371078*^9, 3.778169544406487*^9},
 CellLabel->
  "Out[225]=",ExpressionUUID->"fa43ee5f-f18e-4ec9-b56c-7d69265e2d11"],

Cell[BoxData[
 RowBox[{"k", "-", 
  RowBox[{"beta", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.77704315371078*^9, 3.77816954440835*^9},
 CellLabel->
  "Out[226]=",ExpressionUUID->"cbf5d476-dbe4-4261-b1c7-6f1dbdf2cd0c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"k", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
  RowBox[{"g0", " ", "r0", " ", 
   RowBox[{"(", 
    RowBox[{"k", "-", 
     RowBox[{"beta", " ", "r0"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.77704315371078*^9, 3.778169544410256*^9},
 CellLabel->
  "Out[227]=",ExpressionUUID->"158de7d4-1d07-45ea-84dc-0d8b7cc63563"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["2", 
    SuperscriptBox["r0", "2"]]}], "+", 
  FractionBox[
   RowBox[{"eta", " ", "g1"}], 
   RowBox[{"r", " ", 
    SuperscriptBox["r0", "2"]}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g2", " ", "k"}], "-", "r0"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g1"}], " ", "k", " ", "r"}], "+", 
      RowBox[{"beta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}]}], ")"}]}], 
   RowBox[{"beta", " ", "g1", " ", 
    SuperscriptBox["r", "2"], " ", 
    SuperscriptBox["r0", "3"]}]]}]], "Output",
 CellChangeTimes->{3.77704315371078*^9, 3.778169544412354*^9},
 CellLabel->
  "Out[228]=",ExpressionUUID->"c3095e09-505b-4c9f-a51e-90d2f7f5c38c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c22", " ", "=", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["g1", "r"]}], "-", 
    FractionBox[
     RowBox[{"g0", " ", "g2"}], 
     RowBox[{"g1", " ", "r"}]], "+", 
    FractionBox[
     RowBox[{"g2", " ", "c2"}], 
     SuperscriptBox["r", "2"]]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.777038130403325*^9, 3.7770381371746597`*^9}},
 CellLabel->
  "In[219]:=",ExpressionUUID->"84407b82-614b-49cd-a13e-7386e3ee7154"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["g1", "r"]}], "-", 
  FractionBox[
   RowBox[{"g0", " ", "g2"}], 
   RowBox[{"g1", " ", "r"}]], "+", 
  FractionBox[
   RowBox[{"g2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
   SuperscriptBox["r", "2"]]}]], "Output",
 CellChangeTimes->{3.777033262687039*^9, 3.777033349858609*^9, 
  3.77703806704806*^9, 3.777038138249126*^9, 3.77704318098053*^9, 
  3.778169542296404*^9},
 CellLabel->
  "Out[219]=",ExpressionUUID->"00ece74e-5f4f-438c-8acc-5ded8c25bd32"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"dlnfdot2", "  ", "=", 
   RowBox[{
    RowBox[{"dk", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", "k"], "-", 
       FractionBox["1", 
        RowBox[{"beta", " ", "r0"}]], "-", 
       FractionBox["c17", 
        RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
       FractionBox[
        RowBox[{"c1", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "c2"}], "-", 
           RowBox[{"g0", " ", "r"}]}], ")"}]}], 
        RowBox[{"g1", " ", 
         SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
    RowBox[{"dh", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["g0", 
        RowBox[{"g1", " ", "r"}]], "-", 
       FractionBox["c2", 
        SuperscriptBox["r", "2"]], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "beta"}], "+", 
          FractionBox[
           RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", "c22"}], "-", 
       RowBox[{"eta", " ", "c21"}]}], ")"}]}], "+", 
    RowBox[{"dx0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x0", " ", "c21"}], "+", 
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{"c22", "-", 
          RowBox[{"h", " ", "c21"}]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{"dv0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{"c22", "-", 
          RowBox[{"h", " ", "c21"}]}], ")"}]}], "+", 
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", "beta"], "-", 
          FractionBox["c18", 
           RowBox[{"beta", " ", "r"}]], "+", 
          FractionBox[
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "c2"}], "-", 
              RowBox[{"g0", " ", "r"}]}], ")"}]}], 
           RowBox[{"g1", " ", 
            SuperscriptBox["r", "2"]}]], "-", 
          RowBox[{"h", " ", "c22"}], "+", 
          RowBox[{
           SuperscriptBox["h", "2"], " ", "c21"}]}], ")"}]}]}], ")"}]}]}]}], 
  " ", "*)"}]], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQBGIQfcRBvUxf+Y3jg55XM0F05Pmzc0H0Pze+5SD65NqL
a0D0xkrFtSD6XN/2TSB6EY/aVhB94ti73WD1wSvPguig+h0XQXRM5sXrIHrf
goV3QfSF3RvAdJZdyiMQHZGUw2AApF/cdWMF0ZPkWthAtKXFDy4QbefFzg0W
50+4ZQikJcOnfwfR6q3rOI2ANKfTU24Q3ZbSNqkcSCdffDwFRBudyKyRU3nj
qFI/qxZENzzUbQfRCyccnwOi4/bdWQiireY7bAbRBSyZ20H0Nv2gSyDa7jnv
XRCdWpv5AERf3L/tPYjOc5jzCUSHhN2PkwfSevP4EkD08+C7KSA6b9GVdBB9
IEB+LYgWvyqxHkQ/KBO5rACkXdNUboDoe7e/3wPRepF530G0PV9SnjLIPZG7
wDQAdNW0Aw==
  "],ExpressionUUID->"c8a99fc7-b978-4a9a-a398-87873f6f0597"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"dlnfdot3", " ", "=", 
   RowBox[{
    RowBox[{"dk", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", "k"], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g2", " ", "k"}], "-", "r0"}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "r"}], "-", 
           RowBox[{"c1", " ", "beta"}]}], ")"}]}], 
        RowBox[{"beta", "  ", "g1", " ", 
         SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
    RowBox[{"dh", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["g0", 
        RowBox[{"g1", " ", "r"}]], "-", 
       FractionBox["c2", 
        SuperscriptBox["r", "2"]], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "beta"}], "+", 
          FractionBox[
           RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", "c22"}], "+", 
       RowBox[{"eta", " ", 
        RowBox[{"(", "c21", ")"}]}]}], ")"}]}], "+", 
    RowBox[{"dx0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x0", " ", 
        RowBox[{"(", "c21", ")"}]}], "+", 
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{"c22", "-", 
          RowBox[{"h", " ", 
           RowBox[{"(", "c21", ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{"dv0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{"c22", "-", 
          RowBox[{"h", " ", 
           RowBox[{"(", "c21", ")"}]}]}], ")"}]}], "+", 
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", "beta"], "-", 
          FractionBox[
           RowBox[{"d", " ", "g0"}], 
           RowBox[{"g1", " ", "r"}]], "-", 
          FractionBox["c18", 
           RowBox[{"beta", " ", "r"}]], "+", 
          FractionBox[
           RowBox[{"d", " ", "c2"}], 
           SuperscriptBox["r", "2"]], "-", 
          RowBox[{"2", " ", "h", " ", 
           RowBox[{"(", "c22", ")"}]}], "+", 
          RowBox[{
           SuperscriptBox["h", "2"], " ", 
           RowBox[{"(", "c21", ")"}]}]}], ")"}]}]}], ")"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.777042237261261*^9, 3.777042605676095*^9}, {
  3.7770426418308992`*^9, 3.777042843897764*^9}, {3.777042946305418*^9, 
  3.777043093674561*^9}, {3.777043124757115*^9, 3.77704312514369*^9}, {
  3.777045357789413*^9, 3.7770453900271473`*^9}, {3.7770455506849537`*^9, 
  3.777045555427536*^9}, {3.7770459502238483`*^9, 
  3.777046001708427*^9}},ExpressionUUID->"efeb017a-78fd-46c6-853c-\
3a768373ecc0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"TeXForm", "[", 
   RowBox[{
    RowBox[{"dk", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", "k"], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g2", " ", "k"}], "-", "r0"}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "r"}], "-", 
           RowBox[{"c1", " ", "beta"}]}], ")"}]}], 
        RowBox[{"beta", "  ", "g1", " ", 
         SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
    RowBox[{"dh", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["g0", 
        RowBox[{"g1", " ", "r"}]], "-", 
       FractionBox["c2", 
        SuperscriptBox["r", "2"]], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "beta"}], "+", 
          FractionBox[
           RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", "c22"}], "+", 
       RowBox[{"eta", " ", 
        RowBox[{"(", "c21", ")"}]}]}], ")"}]}], "+", 
    RowBox[{"dx0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x0", " ", 
        RowBox[{"(", "c21", ")"}]}], "+", 
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{"c22", "-", 
          RowBox[{"h", " ", 
           RowBox[{"(", "c21", ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{"dv0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{"c22", "-", 
          RowBox[{"h", " ", 
           RowBox[{"(", "c21", ")"}]}]}], ")"}]}], "+", 
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", "beta"], "-", 
          FractionBox[
           RowBox[{"d", " ", "g0"}], 
           RowBox[{"g1", " ", "r"}]], "-", 
          FractionBox["c18", 
           RowBox[{"beta", " ", "r"}]], "+", 
          FractionBox[
           RowBox[{"d", " ", "c2"}], 
           SuperscriptBox["r", "2"]], "-", 
          RowBox[{"2", " ", "h", " ", 
           RowBox[{"(", "c22", ")"}]}], "+", 
          RowBox[{
           SuperscriptBox["h", "2"], " ", 
           RowBox[{"(", "c21", ")"}]}]}], ")"}]}]}], ")"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.777311115047338*^9, 3.777311123513008*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"33cc97c9-fb73-465c-966a-21999b6bc903"],

Cell["\<\
\\text{dk} \\left(\\frac{(\\text{g2} k-\\text{r0}) (\\text{g1} r-\\beta  \
\\text{c1})}{\\beta  \\text{g1} r^2
   \\text{r0}}+\\frac{1}{k}\\right)+\\text{dv0} \\left(\\text{v0} \
\\left(-\\frac{\\text{c18}}{\\beta 
   r}+\\frac{1}{\\beta }+\\frac{\\text{c2} d}{r^2}+\\text{c21} h^2-2 \
\\text{c22} h-\\frac{d
   \\text{g0}}{\\text{g1} r}\\right)+\\text{x0} (\\text{c22}-\\text{c21} \
h)\\right)+\\text{dh} \\left(\\text{c22}
   \\left(\\frac{2 k}{\\text{r0}}-\\beta \
\\right)-\\frac{\\text{c2}}{r^2}+\\text{c21} \\eta
   +\\frac{\\text{g0}}{\\text{g1} r}\\right)+\\text{dx0} (\\text{v0} \
(\\text{c22}-\\text{c21} h)+\\text{c21}
   \\text{x0})\
\>", "Output",
 CellChangeTimes->{3.777311123906454*^9},
 CellLabel->
  "Out[3]//TeXForm=",ExpressionUUID->"503d0ece-1505-495e-9b7f-cb25684048a6"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"dlnfdot", " ", "-", " ", "dlnfdot3"}], " ", "/.", " ", 
   RowBox[{"r", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
     RowBox[{"k", " ", "g2"}]}]}]}], "/.", " ", 
  RowBox[{"g0", " ", "\[Rule]", " ", 
   RowBox[{"1", "-", 
    RowBox[{"beta", " ", "g2", " "}]}]}]}]], "Input",
 CellChangeTimes->{{3.77703487277141*^9, 3.77703487683364*^9}, {
  3.777043129447711*^9, 3.77704312961368*^9}, {3.777043199146802*^9, 
  3.777043229385984*^9}},
 CellLabel->"In[39]:=",ExpressionUUID->"e4f8e573-1973-4a70-bfad-3186a0446200"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.77704329303411*^9, 3.777043294337253*^9}},
 CellLabel->"In[40]:=",ExpressionUUID->"df732fbf-6d95-47fb-8638-d4427663f90e"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "See", " ", "if", " ", "we", " ", "can", " ", "simplify", " ", "this", " ", 
   
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777035098691114*^9, 3.777035106001926*^9}},
 CellLabel->"In[98]:=",ExpressionUUID->"42b0f722-3a8a-441b-ae89-fc79762b7847"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox["zeta", 
   RowBox[{"beta", " ", 
    SuperscriptBox["r0", "3"]}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g2", " ", "k"}], " ", "-", " ", "r0"}], ")"}], " ", "c3"}], 
   RowBox[{"g1", " ", 
    SuperscriptBox["r", "2"], " ", 
    SuperscriptBox["r0", "3"]}]], "-", 
  FractionBox["c20", 
   RowBox[{"beta", " ", "r", " ", 
    SuperscriptBox["r0", "3"]}]]}]], "Input",
 CellChangeTimes->{{3.77703560824754*^9, 3.77703560975032*^9}},
 CellLabel->
  "In[102]:=",ExpressionUUID->"2433579e-280e-4356-b9f3-d4fcaa4b1ffc"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"k", "-", 
    RowBox[{"beta", " ", "r0"}]}], 
   RowBox[{"beta", " ", 
    SuperscriptBox["r0", "3"]}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g2", " ", "k"}], "-", "r0"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"d", " ", "k"}], "+", 
      RowBox[{"g1", " ", 
       SuperscriptBox["r0", "2"]}]}], ")"}]}], 
   RowBox[{"g1", " ", 
    SuperscriptBox["r", "2"], " ", 
    SuperscriptBox["r0", "3"]}]], "-", 
  FractionBox[
   RowBox[{
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
    RowBox[{"g0", " ", "r0", " ", 
     RowBox[{"(", 
      RowBox[{"k", "-", 
       RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], 
   RowBox[{"beta", " ", "r", " ", 
    SuperscriptBox["r0", "3"]}]]}]], "Output",
 CellChangeTimes->{3.777035107343175*^9, 3.77703687963412*^9},
 CellLabel->
  "Out[102]=",ExpressionUUID->"a23d65fe-3a9b-42b4-ae28-dd97c5f209a6"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Together", "[", 
  RowBox[{"Out", "[", "99", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.777035118496771*^9, 3.777035122419456*^9}},
 CellLabel->"",ExpressionUUID->"2d19423a-5dd2-4fb2-ae7d-f52abffad484"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "-", 
     RowBox[{"2", "r"}]}]}], 
   RowBox[{" ", 
    RowBox[{"r", " ", 
     SuperscriptBox["r0", "2"]}]}]], "-", 
  FractionBox[
   RowBox[{" ", 
    RowBox[{"k", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g2", " ", "k"}], "-", "r0"}], ")"}]}]}], 
   RowBox[{"beta", " ", "g1", " ", 
    SuperscriptBox["r", "2"], " ", 
    SuperscriptBox["r0", "3"]}]], "+", 
  FractionBox[
   RowBox[{"c3", "  ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g2", " ", "k"}], "-", " ", "r0"}], ")"}]}], 
   RowBox[{"g1", " ", 
    SuperscriptBox["r", "2"], " ", 
    SuperscriptBox["r0", "3"]}]]}]], "Input",
 CellChangeTimes->{{3.777035143618178*^9, 3.777035267404037*^9}, {
  3.777035350411647*^9, 3.777035355698903*^9}, {3.7770354434102087`*^9, 
  3.777035581653647*^9}, {3.777035697429659*^9, 3.7770357877102547`*^9}, {
  3.777035861504243*^9, 3.777036157004562*^9}, {3.777036197151724*^9, 
  3.777036211446925*^9}, {3.777036249383148*^9, 3.777036717532857*^9}, {
  3.7770368213941603`*^9, 
  3.777036833242152*^9}},ExpressionUUID->"2f8cd126-19b1-4a7e-bc65-\
7e24de80a81e"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{"-", "  ", 
     SuperscriptBox["r", "2"]}], "+", "r", "-", 
    RowBox[{"eta", " ", "g1"}]}], 
   RowBox[{" ", 
    RowBox[{"r", " ", 
     SuperscriptBox["r0", "2"]}]}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g2", " ", "k"}], "-", "r0"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"d", " ", "k"}], "+", 
      RowBox[{"g1", " ", 
       SuperscriptBox["r0", "2"]}]}], ")"}]}], 
   RowBox[{"g1", " ", 
    SuperscriptBox["r", "2"], " ", 
    SuperscriptBox["r0", "3"]}]], "-", 
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g2", " ", "k"}], " ", "-", "r0"}], ")"}]}], 
   RowBox[{"beta", " ", "r", " ", 
    SuperscriptBox["r0", "3"]}]]}]], "Input",
 CellChangeTimes->{{3.777036894322782*^9, 3.777036984667729*^9}, {
   3.777037015195483*^9, 3.7770370214505587`*^9}, {3.7770370784165287`*^9, 
   3.7770371126354027`*^9}, 3.777037151758717*^9, {3.7770371900076313`*^9, 
   3.77703735875677*^9}},ExpressionUUID->"aa0100bd-8805-427a-99cb-\
5d081c8658ce"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g2", " ", "k"}], "-", "r0"}], ")"}], 
    RowBox[{"(", " ", 
     RowBox[{
      RowBox[{"beta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], "-", 
      RowBox[{"k", " ", "g1", " ", "r"}]}], ")"}]}], 
   RowBox[{"g1", " ", "beta", " ", 
    SuperscriptBox["r", "2"], " ", 
    SuperscriptBox["r0", "3"]}]], "-", 
  FractionBox[
   RowBox[{"eta", " ", "g1", " "}], 
   RowBox[{" ", 
    RowBox[{"r", " ", 
     SuperscriptBox["r0", "2"]}]}]]}]], "Input",
 CellChangeTimes->{{3.7770374135692787`*^9, 3.777037518841663*^9}, {
  3.77703755863839*^9, 3.777037600612083*^9}, {3.777037964507688*^9, 
  3.777037967344138*^9}},ExpressionUUID->"447afdd9-3a53-4b2b-b5d4-\
701309fb97bc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"beta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", " ", "k"}], "+", 
        RowBox[{"g1", " ", 
         SuperscriptBox["r0", "2"]}]}], ")"}]}], "-", 
     RowBox[{"k", " ", "g1", " ", "r"}]}], " ", "/.", " ", 
    RowBox[{"r", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
      RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
      RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
   RowBox[{"d", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"h", "+", 
       RowBox[{"eta", "*", "g2"}], "+", 
       RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"h", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
    RowBox[{"k", " ", "g3"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777037612020382*^9, 3.777037631406493*^9}},
 CellLabel->
  "In[103]:=",ExpressionUUID->"7ab8cfd1-b40a-46e4-8fe4-7a0572c5f4dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g1"}], " ", "k", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{"beta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", 
      SuperscriptBox["r0", "2"]}], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
         RowBox[{"3", " ", "g3", " ", "k"}], "+", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}], "beta"]}], ")"}]}]}]], "Output",\

 CellChangeTimes->{3.7770376322037373`*^9},
 CellLabel->
  "Out[103]=",ExpressionUUID->"00aea938-a724-491f-bd64-5e9a469188c4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Together", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777037638783312*^9, 3.7770376411832657`*^9}},
 CellLabel->
  "In[104]:=",ExpressionUUID->"9389d838-e116-4775-b061-ab81669d887b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "eta"}], " ", 
   SuperscriptBox["g1", "2"], " ", "k"}], "+", 
  RowBox[{"2", " ", "eta", " ", "g2", " ", "k"}], "-", 
  RowBox[{"g1", " ", "g2", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"3", " ", "g3", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"g1", " ", "k", " ", "r0"}], "-", 
  RowBox[{"g0", " ", "g1", " ", "k", " ", "r0"}], "+", 
  RowBox[{"beta", " ", "g1", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.7770376415342693`*^9},
 CellLabel->
  "Out[104]=",ExpressionUUID->"e8148586-258a-4cb9-8caa-421c5d2e7723"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777037643316689*^9, 3.7770376454950123`*^9}},
 CellLabel->
  "In[105]:=",ExpressionUUID->"7127c3bd-49aa-4561-9b83-085c3c46227c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "eta"}], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["g1", "2"], "-", 
     RowBox[{"2", " ", "g2"}]}], ")"}], " ", "k"}], "-", 
  RowBox[{"g1", " ", "g2", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"3", " ", "g3", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"g1", " ", "r0", " ", 
   RowBox[{"(", 
    RowBox[{"k", "-", 
     RowBox[{"g0", " ", "k"}], "+", 
     RowBox[{"beta", " ", "r0"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.777037645965144*^9},
 CellLabel->
  "Out[105]=",ExpressionUUID->"864a91da-b1d6-49c7-a1d3-13263247496b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", "g0"}], ")"}], " ", "k", 
   RowBox[{"(", 
    RowBox[{"h", "-", 
     RowBox[{"k", " ", "g3"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", "g3"}], "-", 
     RowBox[{"g1", " ", "g2"}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "   ", "+", " ", 
  RowBox[{"beta", " ", "g1", " ", "r0", " ", "r0"}]}]], "Input",
 CellChangeTimes->{{3.777037658683215*^9, 3.777037740352713*^9}, {
  3.777037829271106*^9, 
  3.7770379089043503`*^9}},ExpressionUUID->"28ce6728-fe74-4044-949f-\
63f128cc07b0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"c2", " ", "g1"}], " ", "-", " ", 
    RowBox[{"g0", " ", "r"}]}], " ", "/.", " ", 
   RowBox[{"r", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
     RowBox[{"k", " ", "g2"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.777045558681016*^9, 3.77704557138733*^9}},
 CellLabel->"In[42]:=",ExpressionUUID->"3408af21-5409-4940-afb2-9b2d8467156d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g0"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{"g1", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"g1", " ", 
      RowBox[{"(", 
       RowBox[{"k", "-", 
        RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.777045573108679*^9},
 CellLabel->"Out[42]=",ExpressionUUID->"2da3340a-06c1-44d5-b067-46d7ab9b0d03"]
}, Open  ]],

Cell[BoxData[" "], "Input",
 CellChangeTimes->{{3.777045584458137*^9, 3.7770457595459213`*^9}, 
   3.7770458176769733`*^9},ExpressionUUID->"0baac78e-ae3c-485e-b9a4-\
83af48184bc2"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"g2", " ", "k"}], "-", "r0", " "}]}]], "Input",
 CellChangeTimes->{{3.777045823442398*^9, 
  3.7770459407753277`*^9}},ExpressionUUID->"76abbfed-95ef-4341-aa56-\
5acd3f3aebb1"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "See", " ", "if", " ", "I", " ", "can", " ", "simplify", " ", "this", " ", 
    "term", " ", "in", " ", 
    RowBox[{"dk", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.777841220320939*^9, 3.777841231704035*^9}},
 CellLabel->
  "In[120]:=",ExpressionUUID->"029022c0-5b98-4f88-b184-f57ab3e1ffa8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"g1", " ", "r"}], "-", " ", 
     RowBox[{"beta", " ", "c1"}]}], " ", "/.", " ", 
    RowBox[{"r", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
      RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
      RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
   RowBox[{"d", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"h", "+", 
       RowBox[{"eta", "*", "g2"}], "+", 
       RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"h", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
    RowBox[{"k", " ", "g3"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777841233546164*^9, 3.777841263144968*^9}},
 CellLabel->
  "In[122]:=",ExpressionUUID->"8652bf01-3db1-457f-8ca1-441f93d239a5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g1", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}]}], "-", 
  RowBox[{"beta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g3"}], " ", "r0"}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
       RowBox[{"3", " ", "g3", " ", "k"}], "+", 
       RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.777841248706613*^9, 3.7778412637538977`*^9}},
 CellLabel->
  "Out[122]=",ExpressionUUID->"049a6154-fe46-43a8-a090-22c665f2a97a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "beta"}], " ", "eta", " ", 
   SuperscriptBox["g2", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "g2"}], "-", 
     RowBox[{"3", "g3"}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"g3", "-", 
     RowBox[{"g2", " ", "g1"}]}], ")"}], "beta", " ", "r0"}]}]], "Input",
 CellChangeTimes->{{3.777841271778063*^9, 3.7778414622856627`*^9}, {
  3.777841546980216*^9, 3.777841549666481*^9}, {3.777841595497794*^9, 
  3.777841599961755*^9}, {3.777841874969727*^9, 
  3.777841880395987*^9}},ExpressionUUID->"7da4d760-7ce2-4a6f-ab5d-\
74cc6c57b09b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"g2", "*", 
        RowBox[{"(", 
         RowBox[{"g0", "-", "1"}], ")"}]}], "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7778416252191153`*^9, 3.777841637199823*^9}},
 CellLabel->
  "In[123]:=",ExpressionUUID->"a582debe-3d8f-451a-bfae-5bbe0875e033"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "4"], 
     RowBox[{"4", " ", "beta"}]]}], "+", 
   FractionBox[
    SuperscriptBox["gamma", "6"], 
    RowBox[{"24", " ", "beta"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 4]/$CellContext`beta, 0, Rational[1, 24]/$CellContext`beta}, 
   4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7778416374873238`*^9},
 CellLabel->
  "Out[123]=",ExpressionUUID->"dfdb049f-45cb-46f0-b170-2c2ffe6b1d99"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "-", 
        RowBox[{"3", "g3"}]}], "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7778416463219748`*^9, 3.7778416521051617`*^9}},
 CellLabel->
  "In[124]:=",ExpressionUUID->"b2a5145b-b177-4675-8c4d-56d6911536cb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "5"], 
     RowBox[{"10", " ", 
      SuperscriptBox["beta", 
       RowBox[{"3", "/", "2"}]]}]]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 10] $CellContext`beta^Rational[-3, 2]}, 5, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7778416529511747`*^9},
 CellLabel->
  "Out[124]=",ExpressionUUID->"73214494-b69c-4f51-9db2-771cca5c7dae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"g3", "-", 
        RowBox[{"g2", " ", "g1"}]}], "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7778416634840813`*^9, 3.777841669939477*^9}},
 CellLabel->
  "In[125]:=",ExpressionUUID->"75631d46-257e-4193-9476-9101fdd4290e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "3"], 
     RowBox[{"3", " ", 
      SuperscriptBox["beta", 
       RowBox[{"3", "/", "2"}]]}]]}], "+", 
   FractionBox[
    RowBox[{"7", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"60", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 3] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[7, 60] $CellContext`beta^Rational[-3, 2]}, 3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777841670460104*^9},
 CellLabel->
  "Out[125]=",ExpressionUUID->"07a14147-5537-4848-9306-8f49b699c2ad"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"g1", " ", "g2"}], "-", 
      RowBox[{"3", "g3"}]}], "/.", " ", 
     RowBox[{"g0", " ", "\[Rule]", " ", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sin", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}]], "Input",
 CellLabel->
  "In[126]:=",ExpressionUUID->"9cb71ade-cebe-4708-abb7-e9b230c4acb1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"3", " ", 
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}], 
    SuperscriptBox["beta", 
     RowBox[{"3", "/", "2"}]]]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sin", "[", "gamma", "]"}]}], 
   SuperscriptBox["beta", 
    RowBox[{"3", "/", "2"}]]]}]], "Output",
 CellChangeTimes->{3.7778416995028563`*^9},
 CellLabel->
  "Out[126]=",ExpressionUUID->"8403651c-a1ae-426b-b3bd-2144ff2a0145"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777841701166148*^9, 3.777841702733056*^9}},
 CellLabel->
  "In[127]:=",ExpressionUUID->"dc946d67-41f6-410b-bdd0-51befcf18bb3"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "3"}], " ", "gamma"}], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "4"}], "+", 
      RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sin", "[", "gamma", "]"}]}]}], 
  SuperscriptBox["beta", 
   RowBox[{"3", "/", "2"}]]]], "Output",
 CellChangeTimes->{3.777841703058462*^9},
 CellLabel->
  "Out[127]=",ExpressionUUID->"0eeffa95-a26f-4f53-8430-9beb6308dfa7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "3"}], " ", "gamma"}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
     RowBox[{"Sin", "[", "gamma", "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777842381698107*^9, 3.777842394863346*^9}},
 CellLabel->
  "In[128]:=",ExpressionUUID->"9ed1d6a9-b0b2-4701-92d6-300db1e9b5eb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "5"], "10"]}], "+", 
   FractionBox[
    SuperscriptBox["gamma", "7"], "84"], "-", 
   FractionBox[
    SuperscriptBox["gamma", "9"], "1440"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "11"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 11, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
    Rational[-1, 10], 0, 
    Rational[1, 84], 0, 
    Rational[-1, 1440]}, 5, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777842395126293*^9},
 CellLabel->
  "Out[128]=",ExpressionUUID->"fb1744c3-1f71-4165-be31-f2c205624f3a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SeriesCoefficient", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "3"}], " ", "gamma"}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
     RowBox[{"Sin", "[", "gamma", "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7778424018318872`*^9, 3.777842414324567*^9}},
 CellLabel->
  "In[129]:=",ExpressionUUID->"d0e73ff9-8f45-4aa8-bdce-2b14e32684ce"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {"0", 
        RowBox[{"n", "\[Equal]", "1"}]},
       {
        RowBox[{"-", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "\[ImaginaryI]"}], ")"}], "n"], "-", 
             SuperscriptBox["\[ImaginaryI]", "n"]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "8"}], "+", 
             SuperscriptBox["2", "n"]}], ")"}]}], 
          RowBox[{"4", " ", 
           RowBox[{"n", "!"}]}]]}], 
        RowBox[{
         RowBox[{"n", "\[Equal]", "0"}], "||", 
         RowBox[{"n", ">", "1"}]}]},
       {"0", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}},
      Selectable->True]}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False,
  StripWrapperBoxes->True]], "Output",
 CellChangeTimes->{3.7778424149696493`*^9},
 CellLabel->
  "Out[129]=",ExpressionUUID->"48ef9b2e-7144-41c6-a81f-e2e7cc56df65"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"g1", " ", "g2"}], "-", 
      RowBox[{"3", "g3"}]}], "/.", " ", 
     RowBox[{"g0", " ", "\[Rule]", " ", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sinh", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"-", "beta"}], "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"-", "beta"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777842633690977*^9, 3.777842649138229*^9}},
 CellLabel->
  "In[130]:=",ExpressionUUID->"5dd9ffb5-80ef-49ea-b26d-765779fe158b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"3", " ", 
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}]}], 
    RowBox[{
     SqrtBox[
      RowBox[{"-", "beta"}]], " ", "beta"}]]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sinh", "[", "gamma", "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"-", "beta"}]], " ", "beta"}]]}]], "Output",
 CellChangeTimes->{3.777842652420882*^9},
 CellLabel->
  "Out[130]=",ExpressionUUID->"eb0f484f-a0db-44bb-aefe-1d44e917fe8b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777842654819639*^9, 3.777842656867594*^9}},
 CellLabel->
  "In[131]:=",ExpressionUUID->"0ae64a84-0448-41a8-b493-3ecc30bfa43b"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"6", " ", "gamma"}], "-", 
   RowBox[{"8", " ", 
    RowBox[{"Sinh", "[", "gamma", "]"}]}], "+", 
   RowBox[{"Sinh", "[", 
    RowBox[{"2", " ", "gamma"}], "]"}]}], 
  RowBox[{"2", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", "beta"}], ")"}], 
    RowBox[{"3", "/", "2"}]]}]]], "Output",
 CellChangeTimes->{3.777842657384323*^9},
 CellLabel->
  "Out[131]=",ExpressionUUID->"b73aa2bc-339c-488c-aad7-917020b78134"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "4"}], "*", 
    RowBox[{"gamma", "^", "5"}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "^", 
     RowBox[{"(", "n", ")"}]}], "*", 
    RowBox[{"gamma", "^", 
     RowBox[{"(", 
      RowBox[{"2", "n"}], ")"}]}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"4", "^", 
        RowBox[{"(", 
         RowBox[{"n", "+", "1"}], ")"}]}], "-", "1"}], ")"}], "/", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"5", "+", 
        RowBox[{"2", "*", "n"}]}], ")"}], "!"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777843222387763*^9, 3.777843318843454*^9}},
 CellLabel->
  "In[135]:=",ExpressionUUID->"47e26e6e-be59-40f5-9dfe-34d6532e24c1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "5"], "10"]}], ",", 
   FractionBox[
    SuperscriptBox["gamma", "7"], "84"], ",", 
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "9"], "1440"]}], ",", 
   FractionBox[
    RowBox[{"17", " ", 
     SuperscriptBox["gamma", "11"]}], "665280"], ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"31", " ", 
      SuperscriptBox["gamma", "13"]}], "47174400"]}], ",", 
   FractionBox[
    SuperscriptBox["gamma", "15"], "79833600"]}], "}"}]], "Output",
 CellChangeTimes->{{3.77784326269355*^9, 3.777843319295822*^9}},
 CellLabel->
  "Out[135]=",ExpressionUUID->"d60fb35c-a56c-451c-9e77-db21de2a34e8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"5", "!"}]], "Input",
 CellChangeTimes->{{3.777843388700914*^9, 3.7778433904510593`*^9}},
 CellLabel->
  "In[136]:=",ExpressionUUID->"af35d3f1-0066-46d3-a785-99c6a42b554f"],

Cell[BoxData["120"], "Output",
 CellChangeTimes->{3.777843390764721*^9},
 CellLabel->
  "Out[136]=",ExpressionUUID->"7b37fd49-0c74-4c59-acf6-c693c0322760"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Now", " ", "work", " ", "on", " ", 
    RowBox[{"dv0", ".", "v0"}], " ", 
    RowBox[{"term", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.77816951728738*^9, 3.7781695243892612`*^9}, {
  3.7781695719165487`*^9, 3.778169573211767*^9}},
 CellLabel->
  "In[231]:=",ExpressionUUID->"9dd0199d-2379-4351-8605-75ee75fa66bb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              FractionBox["1", "beta"], "-", 
              FractionBox[
               RowBox[{"d", " ", "g0"}], 
               RowBox[{"g1", " ", "r"}]], "-", 
              FractionBox["c18", 
               RowBox[{"beta", " ", "r"}]], "+", 
              FractionBox[
               RowBox[{"d", " ", "c2"}], 
               SuperscriptBox["r", "2"]], "-", 
              RowBox[{"2", " ", "h", " ", 
               RowBox[{"(", "c22", ")"}]}], "+", 
              RowBox[{
               SuperscriptBox["h", "2"], " ", 
               RowBox[{"(", "c21", ")"}]}]}], ")"}], "/.", " ", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778169549180251*^9, 3.778169569549472*^9}},
 CellLabel->
  "In[257]:=",ExpressionUUID->"301725ae-dc09-4bbf-b54b-3616fa0d3883"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "2"], "beta"]}], "-", 
   FractionBox[
    RowBox[{"5", " ", "eta", " ", 
     SuperscriptBox["gamma", "3"]}], 
    RowBox[{"4", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"3", "/", "2"}]], " ", "r0"}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "15"}], " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"66", " ", "k", " ", "r0"}], "+", 
       RowBox[{"35", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"60", " ", 
     SuperscriptBox["beta", "2"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "11"}], " ", "eta", " ", "k"}], "+", 
       RowBox[{"45", " ", "beta", " ", "eta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"120", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "756"}], " ", 
        SuperscriptBox["eta", "2"], " ", "k"}], "+", 
       RowBox[{"105", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", "r0"}], "+", 
       RowBox[{"966", " ", 
        SuperscriptBox["k", "2"], " ", "r0"}], "-", 
       RowBox[{"306", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"217", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "3"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"2520", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 2, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {(-1)/$CellContext`beta, 
    Rational[-5, 4] $CellContext`beta^
     Rational[-3, 2] $CellContext`eta/$CellContext`r0, 
    Rational[1, 
      60] $CellContext`beta^(-2) $CellContext`r0^(-2) ((-15) \
$CellContext`eta^2 - 66 $CellContext`k $CellContext`r0 + 
     35 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 120] $CellContext`beta^
     Rational[-5, 
       2] $CellContext`r0^(-2) ((-11) $CellContext`eta $CellContext`k + 
     45 $CellContext`beta $CellContext`eta $CellContext`r0), 
    Rational[1, 
      2520] $CellContext`beta^(-3) $CellContext`r0^(-3) ((-756) \
$CellContext`eta^2 $CellContext`k + 
     105 $CellContext`beta $CellContext`eta^2 $CellContext`r0 + 
     966 $CellContext`k^2 $CellContext`r0 - 
     306 $CellContext`beta $CellContext`k $CellContext`r0^2 - 
     217 $CellContext`beta^2 $CellContext`r0^3)}, 2, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.778169558136746*^9, 3.778169570268591*^9}, 
   3.778169987549028*^9, 3.778170030019886*^9},
 CellLabel->
  "Out[257]=",ExpressionUUID->"15c951bd-209e-4040-b76e-f101113da5ce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
                    RowBox[{"2", " ", "eta", " ", "g2"}], " ", "+", " ", 
                    RowBox[{"3", " ", "k", " ", "g3"}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"eta", " ", "g0"}], "+", 
                    RowBox[{"k", " ", "g1"}], " ", "-", 
                    RowBox[{"beta", " ", "r0", " ", "g1"}]}], ")"}]}], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"eta", " ", "g1"}], "+", 
                    RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
                    RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
                    RowBox[{"k", " ", "g2"}]}], ")"}]}]}], 
                RowBox[{"beta", " ", 
                 SuperscriptBox["r", "2"]}]], "+", 
               FractionBox[
                RowBox[{"eta", "  ", 
                 SuperscriptBox["g2", "2"]}], 
                RowBox[{" ", 
                 RowBox[{"g1", " ", "r"}]}]], "+", 
               FractionBox[
                RowBox[{"k", " ", "h8"}], 
                RowBox[{"beta", " ", "g1", " ", "r"}]], "-", 
               RowBox[{"2", " ", "h", " ", 
                RowBox[{"(", "c22", ")"}]}], "+", 
               RowBox[{
                SuperscriptBox["h", "2"], " ", 
                RowBox[{"(", "c21", ")"}]}]}], ")"}], "/.", " ", 
             RowBox[{"h8", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
               RowBox[{"3", " ", "g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778169589406543*^9, 3.7781696285391827`*^9}, {
  3.778169659497447*^9, 3.778169694747571*^9}, {3.778169731547572*^9, 
  3.778169978246663*^9}, {3.778170037931342*^9, 3.778170111772015*^9}, {
  3.77817015277586*^9, 3.778170241869769*^9}, {3.778170282393375*^9, 
  3.7781703158660507`*^9}},
 CellLabel->
  "In[274]:=",ExpressionUUID->"9785a19d-601a-4b08-a8b2-78a57fb03c59"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "2"], "beta"]}], "-", 
   FractionBox[
    RowBox[{"5", " ", "eta", " ", 
     SuperscriptBox["gamma", "3"]}], 
    RowBox[{"4", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"3", "/", "2"}]], " ", "r0"}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "15"}], " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"66", " ", "k", " ", "r0"}], "+", 
       RowBox[{"35", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"60", " ", 
     SuperscriptBox["beta", "2"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "11"}], " ", "eta", " ", "k"}], "+", 
       RowBox[{"45", " ", "beta", " ", "eta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"120", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "756"}], " ", 
        SuperscriptBox["eta", "2"], " ", "k"}], "+", 
       RowBox[{"105", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", "r0"}], "+", 
       RowBox[{"966", " ", 
        SuperscriptBox["k", "2"], " ", "r0"}], "-", 
       RowBox[{"306", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"217", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "3"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"2520", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 2, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {(-1)/$CellContext`beta, 
    Rational[-5, 4] $CellContext`beta^
     Rational[-3, 2] $CellContext`eta/$CellContext`r0, 
    Rational[1, 
      60] $CellContext`beta^(-2) $CellContext`r0^(-2) ((-15) \
$CellContext`eta^2 - 66 $CellContext`k $CellContext`r0 + 
     35 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 120] $CellContext`beta^
     Rational[-5, 
       2] $CellContext`r0^(-2) ((-11) $CellContext`eta $CellContext`k + 
     45 $CellContext`beta $CellContext`eta $CellContext`r0), 
    Rational[1, 
      2520] $CellContext`beta^(-3) $CellContext`r0^(-3) ((-756) \
$CellContext`eta^2 $CellContext`k + 
     105 $CellContext`beta $CellContext`eta^2 $CellContext`r0 + 
     966 $CellContext`k^2 $CellContext`r0 - 
     306 $CellContext`beta $CellContext`k $CellContext`r0^2 - 
     217 $CellContext`beta^2 $CellContext`r0^3)}, 2, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.778169614254238*^9, {3.778169724433139*^9, 3.7781698547737093`*^9}, {
   3.778169900896071*^9, 3.778169918351287*^9}, 3.7781700389252996`*^9, {
   3.778170074785282*^9, 3.778170107202694*^9}, {3.778170193936583*^9, 
   3.7781702425476227`*^9}, {3.7781703005115957`*^9, 3.778170316693521*^9}},
 CellLabel->
  "Out[274]=",ExpressionUUID->"fe16b0a6-e305-4b32-b97f-6f61eb0a3a09"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Work", " ", "on", " ", "the", " ", "numerator", " ", "of", " ", "the", " ",
    "first", " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.778170324054962*^9, 3.778170330076757*^9}},
 CellLabel->
  "In[275]:=",ExpressionUUID->"51da333c-ad93-4b20-87a3-e04b9f3d9262"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
     RowBox[{"2", " ", "eta", " ", "g2"}], " ", "+", " ", 
     RowBox[{"3", " ", "k", " ", "g3"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"k", " ", "g1"}], " ", "-", 
     RowBox[{"beta", " ", "r0", " ", "g1"}]}], ")"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
     RowBox[{"k", " ", "g2"}]}], ")"}]}]}]], "Input",
 CellLabel->
  "In[276]:=",ExpressionUUID->"55ab1281-ed6f-4942-aa4d-526979e4cc8b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}]}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
     RowBox[{"3", " ", "g3", " ", "k"}], "+", 
     RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"g1", " ", "k"}], "-", 
     RowBox[{"beta", " ", "g1", " ", "r0"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7781703354439993`*^9},
 CellLabel->
  "Out[276]=",ExpressionUUID->"8bd81b52-0f22-4972-acf8-2e63fae6a25a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778170339489113*^9, 3.778170351090357*^9}},
 CellLabel->
  "In[277]:=",ExpressionUUID->"a744452e-ed64-4a5c-b818-02e49ca49bd0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["eta", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["g1", "2"]}], "+", 
     RowBox[{"2", " ", "g0", " ", "g2"}]}], ")"}]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g1"}], " ", "g2"}], "+", 
     RowBox[{"3", " ", "g0", " ", "g3"}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "beta", " ", "eta", " ", "g1", " ", "g2"}], 
     "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g1", "2"], "-", 
        RowBox[{"2", " ", "g0", " ", "g2"}], "-", 
        RowBox[{"3", " ", "beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
      "k"}]}], ")"}], " ", "r0"}], "-", 
  RowBox[{"beta", " ", 
   SuperscriptBox["g1", "2"], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.778170351487399*^9},
 CellLabel->
  "Out[277]=",ExpressionUUID->"1ea644af-72f1-4178-b3d3-2fc6a9726883"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", " ", "beta"}], " ", 
   SuperscriptBox["eta", "2"], " ", 
   SuperscriptBox["g2", "2"]}], "-", 
  RowBox[{"eta", " ", "k", " ", "h8"}], " ", "-", 
  RowBox[{"h6", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"-", "2"}], " ", "beta", " ", "eta", "  ", "r0", " ", "g1", " ", 
   "g2"}], "+", 
  RowBox[{
   RowBox[{"(", " ", 
    RowBox[{
     SuperscriptBox["g2", "2"], " ", "-", 
     RowBox[{"3", "  ", "g1", " ", "g3"}]}], ")"}], " ", "beta", " ", "k", 
   " ", "r0"}], "-", 
  RowBox[{"beta", " ", 
   SuperscriptBox["g1", "2"], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{{3.778170363603037*^9, 
  3.778170456750187*^9}},ExpressionUUID->"cce66867-2809-4396-9168-\
f6ba88dea0e3"],

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{
                  RowBox[{"-", " ", "beta"}], " ", 
                  SuperscriptBox["eta", "2"], " ", 
                  SuperscriptBox["g2", "2"]}], "-", 
                 RowBox[{"eta", " ", "k", " ", "h8"}], " ", "-", 
                 RowBox[{"h6", " ", 
                  SuperscriptBox["k", "2"]}], "-", 
                 RowBox[{
                 "2", " ", "beta", " ", "eta", "  ", "r0", " ", "g1", " ", 
                  "g2"}], "+", 
                 RowBox[{
                  RowBox[{"(", " ", 
                   RowBox[{
                    SuperscriptBox["g2", "2"], " ", "-", 
                    RowBox[{"3", "  ", "g1", " ", "g3"}]}], ")"}], " ", 
                  "beta", " ", "k", " ", "r0"}], "-", 
                 RowBox[{"beta", " ", 
                  SuperscriptBox["g1", "2"], " ", 
                  SuperscriptBox["r0", "2"]}]}], 
                RowBox[{"beta", " ", 
                 SuperscriptBox["r", "2"]}]], "+", 
               FractionBox[
                RowBox[{"eta", "  ", 
                 SuperscriptBox["g2", "2"]}], 
                RowBox[{" ", 
                 RowBox[{"g1", " ", "r"}]}]], "+", 
               FractionBox[
                RowBox[{"k", " ", "h8"}], 
                RowBox[{"beta", " ", "g1", " ", "r"}]], "-", 
               RowBox[{"2", " ", "h", " ", 
                RowBox[{"(", "c22", ")"}]}], "+", 
               RowBox[{
                SuperscriptBox["h", "2"], " ", 
                RowBox[{"(", "c21", ")"}]}]}], ")"}], "/.", " ", 
             RowBox[{"h8", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
               RowBox[{"3", " ", "g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.77817048663035*^9, 3.778170516396426*^9}, 
   3.778172489482958*^9},ExpressionUUID->"9d45bb40-3ded-47b1-be4b-\
10c873547cd4"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Work", " ", "out", " ", "the", " ", "function", " ", "H_", "8"}],
     " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"G_", "1", " ", "G_", "2"}], " ", "-", " ", 
      RowBox[{"3", " ", "G_", "0", " ", "G_", "3"}]}], " ", ":"}]}], " ", 
   "*)"}]}]], "Input",
 CellChangeTimes->{{3.778170554018371*^9, 3.778170574590008*^9}},
 CellLabel->
  "In[280]:=",ExpressionUUID->"4ed3a306-232c-43c1-bec9-11cd26808bce"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Sin", "[", "gamma", "]"}], "*", 
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"Cos", "[", "gamma", "]"}], "*", 
   RowBox[{"(", 
    RowBox[{"gamma", "-", 
     RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.778170580526822*^9, 3.778170607820302*^9}, {
  3.778170807404047*^9, 3.77817080985093*^9}},
 CellLabel->
  "In[287]:=",ExpressionUUID->"ff39e175-e95a-4ca8-b782-8a7024583bad"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "3"}], " ", 
   RowBox[{"Cos", "[", "gamma", "]"}], " ", 
   RowBox[{"(", 
    RowBox[{"gamma", "-", 
     RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
   RowBox[{"Sin", "[", "gamma", "]"}]}]}]], "Output",
 CellChangeTimes->{3.778170608129992*^9, 3.778170810280223*^9},
 CellLabel->
  "Out[287]=",ExpressionUUID->"fae461a9-8a69-48b6-b45c-d7eb1e084afb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TrigReduce", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.778170609949491*^9, 3.778170611836124*^9}},
 CellLabel->
  "In[288]:=",ExpressionUUID->"1bc0a82e-5c39-4b3d-a600-679a799f48eb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "3"}], " ", "gamma", " ", 
   RowBox[{"Cos", "[", "gamma", "]"}]}], "+", 
  RowBox[{"Sin", "[", "gamma", "]"}], "+", 
  RowBox[{"Sin", "[", 
   RowBox[{"2", " ", "gamma"}], "]"}]}]], "Output",
 CellChangeTimes->{3.778170612114493*^9, 3.77817081209562*^9},
 CellLabel->
  "Out[288]=",ExpressionUUID->"c0089faf-bda4-4993-8c8f-6ee3661dcd32"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SeriesCoefficient", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778170816092833*^9, 3.778170825466514*^9}},
 CellLabel->
  "In[289]:=",ExpressionUUID->"aecc9c78-30a6-4538-a271-96e1e0612089"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {"0", 
        RowBox[{"n", "\[Equal]", "0"}]},
       {
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "\[ImaginaryI]"}], ")"}], "n"], "-", 
            SuperscriptBox["\[ImaginaryI]", "n"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               SuperscriptBox["2", "n"]}], ")"}], " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", "n"}], ")"}], "!"}]}], "-", 
            RowBox[{"3", " ", 
             RowBox[{"n", "!"}]}]}], ")"}]}], 
         RowBox[{"2", " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "n"}], ")"}], "!"}], " ", 
          RowBox[{"n", "!"}]}]], 
        RowBox[{"n", "\[GreaterEqual]", "1"}]},
       {"0", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}},
      Selectable->True]}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False,
  StripWrapperBoxes->True]], "Output",
 CellChangeTimes->{3.778170825946248*^9},
 CellLabel->
  "Out[289]=",ExpressionUUID->"3cac46f9-9d31-4ae9-89f7-73a253734bea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "3"}], " ", "gamma", " ", 
     RowBox[{"Cos", "[", "gamma", "]"}]}], "+", 
    RowBox[{"Sin", "[", "gamma", "]"}], "+", 
    RowBox[{"Sin", "[", 
     RowBox[{"2", " ", "gamma"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "7"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7781709191026087`*^9, 3.7781709290600863`*^9}},
 CellLabel->
  "In[292]:=",ExpressionUUID->"f7b53ea1-7371-4e60-a22f-0e5d842fd075"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "5"]}], "20"], "-", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "7"]}], "140"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "8"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 8, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
    Rational[3, 20], 0, 
    Rational[-3, 140]}, 5, 8, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.778170929432394*^9},
 CellLabel->
  "Out[292]=",ExpressionUUID->"e8d41d41-1f42-4011-a0d0-2f7ab9bda40c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Sinh", "[", "gamma", "]"}], "*", 
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}]}], "-", " ", 
  RowBox[{"3", " ", "*", " ", 
   RowBox[{"Cosh", "[", "gamma", "]"}], "*", 
   RowBox[{"(", 
    RowBox[{"gamma", "-", 
     RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.7781706876301727`*^9, 3.778170715979368*^9}, {
  3.7781707503497066`*^9, 3.7781707546029778`*^9}},
 CellLabel->
  "In[285]:=",ExpressionUUID->"96800115-c2fb-48d2-96d6-a86481494415"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", "3"}], " ", 
    RowBox[{"Cosh", "[", "gamma", "]"}], " ", 
    RowBox[{"(", 
     RowBox[{"gamma", "-", 
      RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sinh", "[", "gamma", "]"}]}]}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.778170799300501*^9, 
  3.778170801979389*^9}},ExpressionUUID->"d0847b6a-a369-4661-9839-\
b36e9179d396"],

Cell[BoxData[
 RowBox[{"TrigReduce", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7781707178278112`*^9, 3.778170719900038*^9}},
 CellLabel->
  "In[286]:=",ExpressionUUID->"746cd1b8-8f82-4f4e-98e9-39ae9df4f63f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "3"}], " ", "gamma", " ", 
   RowBox[{"Cosh", "[", "gamma", "]"}]}], "+", 
  RowBox[{"Sinh", "[", "gamma", "]"}], "+", 
  RowBox[{"Sinh", "[", 
   RowBox[{"2", " ", "gamma"}], "]"}]}]], "Input",
 CellChangeTimes->{3.7781708382445307`*^9},
 CellLabel->
  "In[290]:=",ExpressionUUID->"b2ceeacf-b235-4ec4-943e-ba33aa58c19d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "3"}], " ", "gamma", " ", 
   RowBox[{"Cosh", "[", "gamma", "]"}]}], "+", 
  RowBox[{"Sinh", "[", "gamma", "]"}], "+", 
  RowBox[{"Sinh", "[", 
   RowBox[{"2", " ", "gamma"}], "]"}]}]], "Output",
 CellChangeTimes->{3.7781708383211327`*^9},
 CellLabel->
  "Out[290]=",ExpressionUUID->"5838f2a5-8ca5-4b3f-9105-48d6ad8e37af"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.778170835916244*^9, 
  3.778170836513761*^9}},ExpressionUUID->"f6f57778-2902-40b5-950d-\
86c13b8e96ec"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SeriesCoefficient", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7781708394588623`*^9, 3.778170847097968*^9}},
 CellLabel->
  "In[291]:=",ExpressionUUID->"df9168aa-088e-4028-9f0c-acb2f4bbf568"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {"0", 
        RowBox[{"n", "\[Equal]", "0"}]},
       {
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], "n"]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox["2", "n"]}], ")"}], " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "1"}], "+", "n"}], ")"}], "!"}]}], "-", 
             RowBox[{"3", " ", 
              RowBox[{"n", "!"}]}]}], ")"}]}], 
          RowBox[{"2", " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "n"}], ")"}], "!"}], " ", 
           RowBox[{"n", "!"}]}]]}], 
        RowBox[{"n", "\[GreaterEqual]", "1"}]},
       {"0", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}},
      Selectable->True]}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False,
  StripWrapperBoxes->True]], "Output",
 CellChangeTimes->{3.778170847414756*^9},
 CellLabel->
  "Out[291]=",ExpressionUUID->"720436e5-0b9f-4f20-a919-f5c0166dfc64"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "3"}], " ", "gamma", " ", 
     RowBox[{"Cosh", "[", "gamma", "]"}]}], "+", 
    RowBox[{"Sinh", "[", "gamma", "]"}], "+", 
    RowBox[{"Sinh", "[", 
     RowBox[{"2", " ", "gamma"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "7"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.77817094276095*^9, 3.778170943345181*^9}},
 CellLabel->
  "In[293]:=",ExpressionUUID->"1d055dac-58b0-4dad-8f71-4bab2e682746"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "5"]}], "20"], "+", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "7"]}], "140"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "8"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 8, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
    Rational[3, 20], 0, 
    Rational[3, 140]}, 5, 8, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.778170943914989*^9},
 CellLabel->
  "Out[293]=",ExpressionUUID->"ff439459-0a2b-4b6b-9bd4-229d8561cb9e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", "^", "5"}], "-", "14"}], ")"}], "/", 
  RowBox[{"5", "!"}]}]], "Input",
 CellChangeTimes->{{3.778171165855217*^9, 3.778171207165236*^9}, {
   3.7781715325990887`*^9, 3.77817154398164*^9}, 3.778171592452496*^9, {
   3.778171752840953*^9, 3.778171778552381*^9}},
 CellLabel->
  "In[304]:=",ExpressionUUID->"00bc3100-2782-4766-936f-540c6a187b30"],

Cell[BoxData[
 FractionBox["3", "20"]], "Output",
 CellChangeTimes->{
  3.778171167617947*^9, {3.778171198962791*^9, 3.778171207511888*^9}, 
   3.778171544496585*^9, 3.778171592791543*^9, {3.778171758136015*^9, 
   3.7781717789612827`*^9}},
 CellLabel->
  "Out[304]=",ExpressionUUID->"eb22e4ac-7390-4037-8bc0-48de6c957774"]
}, Open  ]]
},
WindowSize->{927, 793},
WindowMargins->{{76, Automatic}, {19, Automatic}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 2607, 66, 241, "Input",ExpressionUUID->"53329b6c-a80c-45ac-ae62-f6fb243392bd"],
Cell[CellGroupData[{
Cell[3190, 90, 1308, 34, 50, "Input",ExpressionUUID->"b55f3b19-1b6b-49b6-9b71-fd1ea829ac9b"],
Cell[4501, 126, 1012, 29, 68, "Output",ExpressionUUID->"7a726e8c-5ea0-4fea-896d-c5d0fc36e696"]
}, Open  ]],
Cell[5528, 158, 484, 8, 30, "Input",ExpressionUUID->"ec64950c-8ed3-4bc5-92a5-293069313a0b"],
Cell[CellGroupData[{
Cell[6037, 170, 1552, 45, 91, "Input",ExpressionUUID->"545c77c0-9ece-4359-98ca-7287482c53c9"],
Cell[7592, 217, 2111, 67, 154, "Output",ExpressionUUID->"19a28e86-af8a-4042-b3b4-3e1e8a402f59"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9740, 289, 503, 12, 30, "Input",ExpressionUUID->"95296aac-8480-48bf-b720-90060933f9ed"],
Cell[10246, 303, 477, 11, 53, "Output",ExpressionUUID->"c24bdd1b-bc30-449a-9403-41f5b8f3cdc8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10760, 319, 276, 5, 30, "Input",ExpressionUUID->"6e130959-e5af-4389-aed5-d86ced425512"],
Cell[11039, 326, 313, 6, 52, "Output",ExpressionUUID->"2d498a40-0364-4c1f-b249-b369c6b280b4"]
}, Open  ]],
Cell[11367, 335, 562, 17, 52, "Input",ExpressionUUID->"db7adf01-a7ab-46c1-a1a8-4d1abacc17e0"],
Cell[CellGroupData[{
Cell[11954, 356, 663, 15, 51, "Input",ExpressionUUID->"16859656-b551-41b8-8148-c43961c8e68f"],
Cell[12620, 373, 3683, 112, 293, "Output",ExpressionUUID->"0a054210-c316-44cb-b62d-860930e28318"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16340, 490, 525, 10, 30, "Input",ExpressionUUID->"c9449310-0549-409c-8d84-122d3e9eb019"],
Cell[16868, 502, 4118, 131, 193, "Output",ExpressionUUID->"7b7e2b56-ea5a-44f4-8821-019898e70ff2"]
}, Open  ]],
Cell[21001, 636, 302, 7, 52, "Input",ExpressionUUID->"0024ca85-75bc-42db-9780-7ef811ba4904"],
Cell[CellGroupData[{
Cell[21328, 647, 1283, 39, 64, "Input",ExpressionUUID->"84d7cdcb-e510-4ee9-9876-bdc3d993ed03"],
Cell[22614, 688, 1230, 38, 54, "Output",ExpressionUUID->"2015ee81-5d6a-4a17-bce6-716083c58e9c"]
}, Open  ]],
Cell[23859, 729, 262, 6, 30, "Input",ExpressionUUID->"a7b20bff-3044-4ace-9f7a-f98294f2f3d3"],
Cell[CellGroupData[{
Cell[24146, 739, 2050, 62, 185, "Input",ExpressionUUID->"0633086c-1d3f-49d2-b185-58412eb4c62b"],
Cell[26199, 803, 1882, 59, 102, "Output",ExpressionUUID->"2e23a40e-e8f2-4512-a1d2-7e90367ce44f"]
}, Open  ]],
Cell[28096, 865, 938, 24, 52, "Input",ExpressionUUID->"48e0a9bb-0e03-4980-a9fa-2d51e48ea77e"],
Cell[CellGroupData[{
Cell[29059, 893, 7086, 212, 354, "Input",ExpressionUUID->"f786cdbb-b924-4eb2-838b-2dc638305375"],
Cell[36148, 1107, 6707, 212, 292, "Output",ExpressionUUID->"82cc75a0-85b7-409b-a825-e00af83a1b63"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42892, 1324, 484, 10, 30, "Input",ExpressionUUID->"a2953db8-00f4-416e-aad9-2cacfd70dbaa"],
Cell[43379, 1336, 8832, 270, 395, "Output",ExpressionUUID->"af5afa91-4a82-40fe-ac2b-7e98d7713769"]
}, Open  ]],
Cell[52226, 1609, 288, 7, 30, "Input",ExpressionUUID->"9260977b-b0de-461c-996a-71c3b228e64d"],
Cell[CellGroupData[{
Cell[52539, 1620, 2347, 69, 163, "Input",ExpressionUUID->"95eab631-9a82-4215-a749-57272e016382"],
Cell[54889, 1691, 3219, 99, 158, "Output",ExpressionUUID->"f004e70b-0613-4a56-a2c2-26953d9b0565"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58145, 1795, 4085, 116, 251, "Input",ExpressionUUID->"2564f2f9-eac0-4d13-8f0e-36dad0184aae"],
Cell[62233, 1913, 4408, 134, 205, "Output",ExpressionUUID->"3fdc1a72-072e-44b9-8b6b-8d0c4dc00d6c"]
}, Open  ]],
Cell[66656, 2050, 623, 15, 52, "Input",ExpressionUUID->"7ed18ad0-c39b-4759-bd10-029e2967f8e5"],
Cell[CellGroupData[{
Cell[67304, 2069, 11884, 340, 514, "Input",ExpressionUUID->"09f05ab5-fb26-4fb3-8d38-faed241e3432"],
Cell[79191, 2411, 11201, 334, 497, "Output",ExpressionUUID->"ea4abd9c-b278-46b5-8989-05ad3c9c74c1"]
}, Open  ]],
Cell[90407, 2748, 529, 12, 30, "Input",ExpressionUUID->"2119f5f3-760c-487a-9160-ca0c499ad8ce"],
Cell[CellGroupData[{
Cell[90961, 2764, 3250, 101, 284, "Input",ExpressionUUID->"8ed8e21c-eb37-4c5c-b54b-17944470a79a"],
Cell[94214, 2867, 221, 5, 34, "Output",ExpressionUUID->"021326ee-d6ef-4a01-a339-6762861252a3"],
Cell[94438, 2874, 249, 6, 34, "Output",ExpressionUUID->"21527c67-75c8-48ae-a1e5-5db32aabb65b"],
Cell[94690, 2882, 269, 7, 34, "Output",ExpressionUUID->"c65059e8-9575-4f29-8722-eed3ba5e5d7b"],
Cell[94962, 2891, 257, 6, 34, "Output",ExpressionUUID->"de403294-e27c-4d40-8985-459030cabb2f"],
Cell[95222, 2899, 250, 6, 34, "Output",ExpressionUUID->"e400ab09-bb08-4e46-9c81-4a4cbb061e76"],
Cell[95475, 2907, 256, 6, 34, "Output",ExpressionUUID->"fa43ee5f-f18e-4ec9-b56c-7d69265e2d11"],
Cell[95734, 2915, 222, 5, 34, "Output",ExpressionUUID->"cbf5d476-dbe4-4261-b1c7-6f1dbdf2cd0c"],
Cell[95959, 2922, 409, 12, 34, "Output",ExpressionUUID->"158de7d4-1d07-45ea-84dc-0d8b7cc63563"],
Cell[96371, 2936, 891, 29, 59, "Output",ExpressionUUID->"c3095e09-505b-4c9f-a51e-90d2f7f5c38c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[97299, 2970, 470, 14, 50, "Input",ExpressionUUID->"84407b82-614b-49cd-a13e-7386e3ee7154"],
Cell[97772, 2986, 595, 18, 53, "Output",ExpressionUUID->"00ece74e-5f4f-438c-8acc-5ded8c25bd32"]
}, Open  ]],
Cell[98382, 3007, 2633, 76, 78, "Input",ExpressionUUID->"c8a99fc7-b978-4a9a-a398-87873f6f0597"],
Cell[101018, 3085, 2601, 75, 119, "Input",ExpressionUUID->"efeb017a-78fd-46c6-853c-3a768373ecc0"],
Cell[CellGroupData[{
Cell[103644, 3164, 2327, 71, 140, "Input",ExpressionUUID->"33cc97c9-fb73-465c-966a-21999b6bc903"],
Cell[105974, 3237, 802, 17, 153, "Output",ExpressionUUID->"503d0ece-1505-495e-9b7f-cb25684048a6"]
}, Open  ]],
Cell[106791, 3257, 653, 15, 30, "Input",ExpressionUUID->"e4f8e573-1973-4a70-bfad-3186a0446200"],
Cell[107447, 3274, 205, 3, 30, "Input",ExpressionUUID->"df732fbf-6d95-47fb-8638-d4427663f90e"],
Cell[107655, 3279, 324, 7, 30, "Input",ExpressionUUID->"42b0f722-3a8a-441b-ae89-fc79762b7847"],
Cell[CellGroupData[{
Cell[108004, 3290, 595, 18, 52, "Input",ExpressionUUID->"2433579e-280e-4356-b9f3-d4fcaa4b1ffc"],
Cell[108602, 3310, 1021, 34, 59, "Output",ExpressionUUID->"a23d65fe-3a9b-42b4-ae28-dd97c5f209a6"]
}, Open  ]],
Cell[109638, 3347, 229, 4, 30, "Input",ExpressionUUID->"2d19423a-5dd2-4fb2-ae7d-f52abffad484"],
Cell[109870, 3353, 1179, 34, 52, "Input",ExpressionUUID->"2f8cd126-19b1-4a7e-bc65-7e24de80a81e"],
Cell[111052, 3389, 1112, 34, 56, "Input",ExpressionUUID->"aa0100bd-8805-427a-99cb-5d081c8658ce"],
Cell[112167, 3425, 892, 27, 56, "Input",ExpressionUUID->"447afdd9-3a53-4b2b-b5d4-701309fb97bc"],
Cell[CellGroupData[{
Cell[113084, 3456, 1077, 31, 54, "Input",ExpressionUUID->"7ab8cfd1-b40a-46e4-8fe4-7a0572c5f4dd"],
Cell[114164, 3489, 743, 24, 52, "Output",ExpressionUUID->"00aea938-a724-491f-bd64-5e9a469188c4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[114944, 3518, 212, 4, 30, "Input",ExpressionUUID->"9389d838-e116-4775-b061-ab81669d887b"],
Cell[115159, 3524, 616, 16, 34, "Output",ExpressionUUID->"e8148586-258a-4cb9-8caa-421c5d2e7723"]
}, Open  ]],
Cell[CellGroupData[{
Cell[115812, 3545, 212, 4, 30, "Input",ExpressionUUID->"7127c3bd-49aa-4561-9b83-085c3c46227c"],
Cell[116027, 3551, 623, 19, 37, "Output",ExpressionUUID->"864a91da-b1d6-49c7-a1d3-13263247496b"]
}, Open  ]],
Cell[116665, 3573, 603, 18, 30, "Input",ExpressionUUID->"28ce6728-fe74-4044-949f-63f128cc07b0"],
Cell[CellGroupData[{
Cell[117293, 3595, 506, 12, 52, "Input",ExpressionUUID->"3408af21-5409-4940-afb2-9b2d8467156d"],
Cell[117802, 3609, 574, 18, 34, "Output",ExpressionUUID->"2da3340a-06c1-44d5-b067-46d7ab9b0d03"]
}, Open  ]],
Cell[118391, 3630, 180, 3, 30, "Input",ExpressionUUID->"0baac78e-ae3c-485e-b9a4-83af48184bc2"],
Cell[118574, 3635, 226, 6, 30, "Input",ExpressionUUID->"76abbfed-95ef-4341-aa56-5acd3f3aebb1"],
Cell[118803, 3643, 389, 9, 52, "Input",ExpressionUUID->"029022c0-5b98-4f88-b184-f57ab3e1ffa8"],
Cell[CellGroupData[{
Cell[119217, 3656, 927, 26, 30, "Input",ExpressionUUID->"8652bf01-3db1-457f-8ca1-441f93d239a5"],
Cell[120147, 3684, 667, 20, 52, "Output",ExpressionUUID->"049a6154-fe46-43a8-a090-22c665f2a97a"]
}, Open  ]],
Cell[120829, 3707, 646, 18, 30, "Input",ExpressionUUID->"7da4d760-7ce2-4a6f-ab5d-74cc6c57b09b"],
Cell[CellGroupData[{
Cell[121500, 3729, 1195, 34, 52, "Input",ExpressionUUID->"a582debe-3d8f-451a-bfae-5bbe0875e033"],
Cell[122698, 3765, 697, 21, 54, "Output",ExpressionUUID->"dfdb049f-45cb-46f0-b170-2c2ffe6b1d99"]
}, Open  ]],
Cell[CellGroupData[{
Cell[123432, 3791, 1192, 34, 52, "Input",ExpressionUUID->"b2a5145b-b177-4675-8c4d-56d6911536cb"],
Cell[124627, 3827, 638, 19, 55, "Output",ExpressionUUID->"73214494-b69c-4f51-9db2-771cca5c7dae"]
}, Open  ]],
Cell[CellGroupData[{
Cell[125302, 3851, 1166, 33, 52, "Input",ExpressionUUID->"75631d46-257e-4193-9476-9101fdd4290e"],
Cell[126471, 3886, 864, 26, 55, "Output",ExpressionUUID->"07a14147-5537-4848-9306-8f49b699c2ad"]
}, Open  ]],
Cell[CellGroupData[{
Cell[127372, 3917, 950, 29, 52, "Input",ExpressionUUID->"9cb71ade-cebe-4708-abb7-e9b230c4acb1"],
Cell[128325, 3948, 616, 20, 53, "Output",ExpressionUUID->"8403651c-a1ae-426b-b3bd-2144ff2a0145"]
}, Open  ]],
Cell[CellGroupData[{
Cell[128978, 3973, 210, 4, 30, "Input",ExpressionUUID->"dc946d67-41f6-410b-bdd0-51befcf18bb3"],
Cell[129191, 3979, 466, 15, 53, "Output",ExpressionUUID->"0eeffa95-a26f-4f53-8430-9beb6308dfa7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129694, 3999, 546, 16, 30, "Input",ExpressionUUID->"9ed1d6a9-b0b2-4701-92d6-300db1e9b5eb"],
Cell[130243, 4017, 702, 22, 54, "Output",ExpressionUUID->"fb1744c3-1f71-4165-be31-f2c205624f3a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[130982, 4044, 558, 16, 30, "Input",ExpressionUUID->"d0e73ff9-8f45-4aa8-bdce-2b14e32684ce"],
Cell[131543, 4062, 1960, 59, 81, "Output",ExpressionUUID->"48ef9b2e-7144-41c6-a81f-e2e7cc56df65"]
}, Open  ]],
Cell[CellGroupData[{
Cell[133540, 4126, 1063, 32, 52, "Input",ExpressionUUID->"5dd9ffb5-80ef-49ea-b26d-765779fe158b"],
Cell[134606, 4160, 642, 22, 55, "Output",ExpressionUUID->"eb0f484f-a0db-44bb-aefe-1d44e917fe8b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[135285, 4187, 210, 4, 30, "Input",ExpressionUUID->"0ae64a84-0448-41a8-b493-3ecc30bfa43b"],
Cell[135498, 4193, 478, 15, 55, "Output",ExpressionUUID->"b73aa2bc-339c-488c-aad7-917020b78134"]
}, Open  ]],
Cell[CellGroupData[{
Cell[136013, 4213, 838, 27, 30, "Input",ExpressionUUID->"47e26e6e-be59-40f5-9dfe-34d6532e24c1"],
Cell[136854, 4242, 718, 22, 54, "Output",ExpressionUUID->"d60fb35c-a56c-451c-9e77-db21de2a34e8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[137609, 4269, 195, 4, 30, "Input",ExpressionUUID->"af35d3f1-0066-46d3-a785-99c6a42b554f"],
Cell[137807, 4275, 155, 3, 34, "Output",ExpressionUUID->"7b37fd49-0c74-4c59-acf6-c693c0322760"]
}, Open  ]],
Cell[137977, 4281, 409, 9, 52, "Input",ExpressionUUID->"9dd0199d-2379-4351-8605-75ee75fa66bb"],
Cell[CellGroupData[{
Cell[138411, 4294, 2934, 77, 151, "Input",ExpressionUUID->"301725ae-dc09-4bbf-b54b-3616fa0d3883"],
Cell[141348, 4373, 3188, 88, 109, "Output",ExpressionUUID->"15c951bd-209e-4040-b76e-f101113da5ce"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144573, 4466, 4514, 110, 199, "Input",ExpressionUUID->"9785a19d-601a-4b08-a8b2-78a57fb03c59"],
Cell[149090, 4578, 3391, 91, 109, "Output",ExpressionUUID->"fe16b0a6-e305-4b32-b97f-6f61eb0a3a09"]
}, Open  ]],
Cell[152496, 4672, 343, 8, 30, "Input",ExpressionUUID->"51da333c-ad93-4b20-87a3-e04b9f3d9262"],
Cell[CellGroupData[{
Cell[152864, 4684, 795, 24, 30, "Input",ExpressionUUID->"55ab1281-ed6f-4942-aa4d-526979e4cc8b"],
Cell[153662, 4710, 823, 26, 34, "Output",ExpressionUUID->"8bd81b52-0f22-4972-acf8-2e63fae6a25a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[154522, 4741, 294, 7, 30, "Input",ExpressionUUID->"a744452e-ed64-4a5c-b818-02e49ca49bd0"],
Cell[154819, 4750, 1252, 41, 60, "Output",ExpressionUUID->"1ea644af-72f1-4178-b3d3-2fc6a9726883"]
}, Open  ]],
Cell[156086, 4794, 778, 23, 33, "Input",ExpressionUUID->"cce66867-2809-4396-9168-f6ba88dea0e3"],
Cell[156867, 4819, 4162, 104, 207, "Input",ExpressionUUID->"9d45bb40-3ded-47b1-be4b-10c873547cd4"],
Cell[161032, 4925, 513, 13, 52, "Input",ExpressionUUID->"4ed3a306-232c-43c1-bec9-11cd26808bce"],
Cell[CellGroupData[{
Cell[161570, 4942, 548, 15, 30, "Input",ExpressionUUID->"ff39e175-e95a-4ca8-b782-8a7024583bad"],
Cell[162121, 4959, 518, 15, 34, "Output",ExpressionUUID->"fae461a9-8a69-48b6-b45c-d7eb1e084afb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[162676, 4979, 212, 4, 30, "Input",ExpressionUUID->"1bc0a82e-5c39-4b3d-a600-679a799f48eb"],
Cell[162891, 4985, 389, 10, 34, "Output",ExpressionUUID->"c0089faf-bda4-4993-8c8f-6ee3661dcd32"]
}, Open  ]],
Cell[CellGroupData[{
Cell[163317, 5000, 305, 7, 30, "Input",ExpressionUUID->"aecc9c78-30a6-4538-a271-96e1e0612089"],
Cell[163625, 5009, 2267, 68, 83, "Output",ExpressionUUID->"3cac46f9-9d31-4ae9-89f7-73a253734bea"]
}, Open  ]],
Cell[CellGroupData[{
Cell[165929, 5082, 527, 14, 30, "Input",ExpressionUUID->"f7b53ea1-7371-4e60-a22f-0e5d842fd075"],
Cell[166459, 5098, 639, 20, 54, "Output",ExpressionUUID->"e8d41d41-1f42-4011-a0d0-2f7ab9bda40c"]
}, Open  ]],
Cell[167113, 5121, 574, 15, 30, "Input",ExpressionUUID->"96800115-c2fb-48d2-96d6-a86481494415"],
Cell[167690, 5138, 547, 16, 52, InheritFromParent,ExpressionUUID->"d0847b6a-a369-4661-9839-b36e9179d396"],
Cell[168240, 5156, 214, 4, 30, "Input",ExpressionUUID->"746cd1b8-8f82-4f4e-98e9-39ae9df4f63f"],
Cell[168457, 5162, 372, 10, 30, InheritFromParent,ExpressionUUID->"b2ceeacf-b235-4ec4-943e-ba33aa58c19d"],
Cell[168832, 5174, 373, 10, 34, "Output",ExpressionUUID->"5838f2a5-8ca5-4b3f-9105-48d6ad8e37af"],
Cell[169208, 5186, 152, 3, 30, "Input",ExpressionUUID->"f6f57778-2902-40b5-950d-86c13b8e96ec"],
Cell[CellGroupData[{
Cell[169385, 5193, 307, 7, 30, "Input",ExpressionUUID->"df9168aa-088e-4028-9f0c-acb2f4bbf568"],
Cell[169695, 5202, 2265, 69, 83, "Output",ExpressionUUID->"720436e5-0b9f-4f20-a919-f5c0166dfc64"]
}, Open  ]],
Cell[CellGroupData[{
Cell[171997, 5276, 525, 14, 30, "Input",ExpressionUUID->"1d055dac-58b0-4dad-8f71-4bab2e682746"],
Cell[172525, 5292, 638, 20, 54, "Output",ExpressionUUID->"ff439459-0a2b-4b6b-9bd4-229d8561cb9e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[173200, 5317, 412, 10, 30, "Input",ExpressionUUID->"00bc3100-2782-4766-936f-540c6a187b30"],
Cell[173615, 5329, 323, 7, 51, "Output",ExpressionUUID->"eb22e4ac-7390-4037-8bc0-48de6c957774"]
}, Open  ]]
}
]
*)

