(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    335593,       9557]
NotebookOptionsPosition[    322742,       9353]
NotebookOutlinePosition[    323081,       9368]
CellTagsIndexPosition[    323038,       9365]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Trying", " ", "to", " ", "compute", " ", "differential", " ", "gdot"}], 
    "-", 
    RowBox[{"h", "*", "fdot"}], "-", 
    RowBox[{"1", " ", "for"}], " ", "-", "Drift", " ", "+", " ", 
    RowBox[{"Kepler", " ", 
     RowBox[{"problem", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Note", ":", "  ", 
     RowBox[{"below", "  ", "d"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", "*", "g2"}], "+", 
         RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}], 
      "\[IndentingNewLine]", "  ", "r"}], " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
       RowBox[{"k", " ", "g2", "\[IndentingNewLine]", "h"}]}], " ", "=", " ", 
      
      RowBox[{
       RowBox[{
        RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
        RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
        RowBox[{"k", " ", "g3", "\[IndentingNewLine]", "g0"}]}], " ", "=", 
       " ", 
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2", " ", "\[IndentingNewLine]", "g3"}]}], " ",
         "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"s", "-", "g1"}], ")"}], "/", "beta"}], " ", 
           "\[IndentingNewLine]", "g0", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g1", "^", "2"}]}], " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"-", "g2"}], "\[IndentingNewLine]", 
            RowBox[{"g0", "^", "2"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"g1", "^", "2"}], " ", "beta"}]}], " ", "=", " ", 
          RowBox[{
           RowBox[{"1", "\[IndentingNewLine]", "zeta"}], " ", "=", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}]}]}]}]}]}]}], 
   "\[IndentingNewLine]", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
  3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
  3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
  3.776520393320311*^9, 3.776520404710821*^9}, {3.776542972077035*^9, 
  3.7765429875095453`*^9}, {3.776629227102131*^9, 3.776629244140903*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"53329b6c-a80c-45ac-ae62-f6fb243392bd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgamma", " ", "=", " ", 
  RowBox[{
   FractionBox["sqb", "r"], " ", 
   RowBox[{"(", 
    RowBox[{"dh", " ", "+", "  ", 
     RowBox[{
      FractionBox["dk", "r0"], 
      RowBox[{"(", 
       RowBox[{"d", "-", " ", 
        RowBox[{"r0", " ", "g3"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"k", " ", "d"}], "+", 
           RowBox[{"g1", " ", 
            SuperscriptBox["r0", "2"]}]}], ")"}], 
         FractionBox["x0", 
          SuperscriptBox["r0", "3"]]}], "+", 
        RowBox[{"g2", " ", "v0"}]}], ")"}]}], "-", 
     RowBox[{"dv0", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", "  ", "v0"}], " ", "+", " ", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
   3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
   3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
   3.776520393320311*^9, 3.776520404710821*^9}, {3.776542972077035*^9, 
   3.7765429875095453`*^9}, 3.776947621577579*^9, 3.776947891743079*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"b55f3b19-1b6b-49b6-9b71-fd1ea829ac9b"],

Cell[BoxData[
 FractionBox[
  RowBox[{"sqb", " ", 
   RowBox[{"(", 
    RowBox[{"dh", "+", 
     FractionBox[
      RowBox[{"dk", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
     RowBox[{"dv0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", " ", "v0"}], "+", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g2", " ", "v0"}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
         SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"]], "Output",
 CellChangeTimes->{3.777070190481556*^9, 3.777118235919181*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"378db069-cd51-4eb3-8da1-e0fadf714dda"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", ",", " ", 
   RowBox[{"expression", " ", "for", " ", 
    RowBox[{"dr", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7765481188719683`*^9, 3.7765481245821543`*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"afacd7f7-dfe4-40dc-8f60-4ae14d5e9d79"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr", " ", "=", " ", 
  RowBox[{
   RowBox[{
    FractionBox["dgamma", "sqb"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"zeta", " ", "g1"}], "+", 
      RowBox[{"eta", " ", "g0"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dk", 
     RowBox[{"beta", " ", "r0", " "}]], 
    RowBox[{"(", 
     RowBox[{"r0", "-", "r", "-", 
      RowBox[{"k", " ", "g2"}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["1", 
        RowBox[{"beta", " ", 
         SuperscriptBox["r0", "3"]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", 
          RowBox[{"(", 
           RowBox[{"r", "+", 
            RowBox[{"k", " ", "g2"}]}], ")"}]}], "-", 
         RowBox[{"zeta", " ", "r0", " ", "g0"}]}], ")"}], "x0"}], " ", "+", 
      " ", 
      RowBox[{"g1", "  ", "v0"}]}], ")"}]}], " ", "+", " ", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "k", " ", "g2"}]}], ")"}], " ", 
       FractionBox["v0", "beta"]}], " ", "+", " ", 
      RowBox[{"g1", " ", "x0"}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776198428651246*^9, 3.7761985237438927`*^9}, {
   3.776543018148497*^9, 3.776543018579586*^9}, {3.776543081746882*^9, 
   3.776543083706243*^9}, {3.7765480676340427`*^9, 3.776548073216248*^9}, 
   3.777057485907671*^9},
 CellLabel->"In[2]:=",ExpressionUUID->"ec64950c-8ed3-4bc5-92a5-293069313a0b"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}]}], 
   RowBox[{"beta", " ", "r0"}]], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], "beta"], 
     "+", 
     RowBox[{"g1", " ", "x0"}]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"dh", "+", 
      FractionBox[
       RowBox[{"dk", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
      RowBox[{"dv0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
      RowBox[{"dx0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "v0"}], "+", 
     FractionBox[
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.777070194512973*^9, 3.777118236166028*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"d6f8e9c8-0e25-45e6-bcac-3d730d6a9115"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dbeta", " ", "=", " ", 
  RowBox[{
   RowBox[{"2", "*", 
    RowBox[{"dk", "/", "r0"}]}], "-", 
   RowBox[{"2", "*", 
    RowBox[{"k", "/", 
     RowBox[{"r0", "^", "3"}]}], "*", " ", 
    RowBox[{"(", 
     RowBox[{"dx0", " ", "*", " ", "x0"}], ")"}]}], " ", "-", " ", 
   RowBox[{"2", "*", "v0", " ", "*", " ", "dv0"}]}]}]], "Input",
 CellChangeTimes->{{3.776198629796771*^9, 3.776198668928054*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"95296aac-8480-48bf-b720-90060933f9ed"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", "dk"}], "r0"], "-", 
  RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
  FractionBox[
   RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
   SuperscriptBox["r0", "3"]]}]], "Output",
 CellChangeTimes->{3.777070196477304*^9, 3.777118238368865*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"90d5d5e6-44b6-41c8-9744-68f6f7ea0ed1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr0", " ", "=", " ", 
  RowBox[{"dx0", " ", "*", " ", 
   RowBox[{"x0", " ", "/", " ", "r0"}]}]}]], "Input",
 CellChangeTimes->{{3.776198724170291*^9, 3.776198736866087*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"6e130959-e5af-4389-aed5-d86ced425512"],

Cell[BoxData[
 FractionBox[
  RowBox[{"dx0", " ", "x0"}], "r0"]], "Output",
 CellChangeTimes->{3.777070198846757*^9, 3.777118240774639*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"36f339f8-d78f-400f-af3f-07113ec3dda2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"This", " ", "is", " ", "d", 
     RowBox[{"(", 
      RowBox[{"gdot", "-", 
       RowBox[{"h", "*", "fdot"}], "-", "1"}], ")"}]}], ":"}], " ", 
   "*)"}]}]], "Input",
 CellChangeTimes->{{3.776545003903981*^9, 3.776545047257028*^9}, {
  3.776629293562078*^9, 
  3.776629301002075*^9}},ExpressionUUID->"db7adf01-a7ab-46c1-a1a8-\
4d1abacc17e0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgdotmhfdotm1", "  ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox["dk", 
       RowBox[{"r0", " ", "r"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", "dr0"}], 
       RowBox[{
        SuperscriptBox["r0", "2"], "r"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", "dr"}], 
       RowBox[{"r0", " ", 
        SuperscriptBox["r", "2"]}]]}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"h", " ", "g1"}], " ", "-", " ", 
      RowBox[{"r0", " ", "g2"}]}], ")"}]}], " ", "+", " ", 
   RowBox[{
    FractionBox["k", 
     RowBox[{"r0", " ", "r"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"dh", " ", "g1"}], " ", "-", " ", 
      RowBox[{"dr0", " ", "g2"}], " ", "-", " ", 
      RowBox[{
       FractionBox["dbeta", "beta"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          FractionBox["h", "2"], "g1"}], " ", "-", " ", 
         RowBox[{"r0", " ", "g2"}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"h", " ", "g0"}], " ", "-", " ", 
         RowBox[{"r0", " ", "g1"}]}], ")"}], 
       FractionBox["dgamma", "sqb"]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7761987614783087`*^9, 3.776198796331312*^9}, {
  3.776201640154704*^9, 3.776201653535412*^9}, {3.776201731432234*^9, 
  3.776201735838003*^9}, {3.776543124922838*^9, 3.776543125953054*^9}, {
  3.776629303971946*^9, 3.776629308809947*^9}, {3.776629529977047*^9, 
  3.776629620495075*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"16859656-b551-41b8-8148-c43961c8e68f"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"dh", " ", "g1"}], "-", 
      FractionBox[
       RowBox[{"dx0", " ", "g2", " ", "x0"}], "r0"], "-", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"g1", " ", "h"}], "2"], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"2", " ", "dk"}], "r0"], "-", 
          RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
          FractionBox[
           RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
           SuperscriptBox["r0", "3"]]}], ")"}]}], "beta"], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"dh", "+", 
          FractionBox[
           RowBox[{"dk", " ", 
            RowBox[{"(", 
             RowBox[{"d", "-", 
              RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
          RowBox[{"dv0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "v0"}], "+", 
             RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
          RowBox[{"dx0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "v0"}], "+", 
             FractionBox[
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", " ", "k"}], "+", 
                 RowBox[{"g1", " ", 
                  SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
              SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"]}], 
     ")"}]}], 
   RowBox[{"r", " ", "r0"}]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "h"}], "-", 
     RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["dk", 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"dx0", " ", "k", " ", "x0"}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]], 
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"dk", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}]}], 
          RowBox[{"beta", " ", "r0"}]], "+", 
         RowBox[{"dv0", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g1"}], "+", 
                RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], 
             "beta"], "+", 
            RowBox[{"g1", " ", "x0"}]}], ")"}]}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{"dh", "+", 
             FractionBox[
              RowBox[{"dk", " ", 
               RowBox[{"(", 
                RowBox[{"d", "-", 
                 RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
             RowBox[{"dv0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "v0"}], "+", 
                RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
             RowBox[{"dx0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "v0"}], "+", 
                FractionBox[
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"d", " ", "k"}], "+", 
                    RowBox[{"g1", " ", 
                    SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
                 SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
         RowBox[{"dx0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "v0"}], "+", 
            FractionBox[
             RowBox[{"x0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
                RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.777070201789345*^9, 3.7771182425799227`*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"b9cc61d5-41eb-4299-a35b-f63b8b0aa8ca"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"dx0", ",", "dv0", ",", "dk", ",", "dh"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.776198885108611*^9, 3.776198910466971*^9}, {
   3.776199517362957*^9, 3.776199518824484*^9}, {3.776201661432477*^9, 
   3.776201662262883*^9}, {3.7762017413840237`*^9, 3.776201741469623*^9}, 
   3.776202194227912*^9, {3.776543140746441*^9, 3.776543143848097*^9}, {
   3.777118246078496*^9, 3.777118246850657*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"c9449310-0549-409c-8d84-122d3e9eb019"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"g1", " ", "h"}], "2"], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g1", " ", "h"}], "-", 
       RowBox[{"g2", " ", "r0"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"g1", " ", "h"}], "2"], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "v0"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], 
          "beta"], "+", 
         RowBox[{"g1", " ", "x0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", "x0"}], 
       RowBox[{"r", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"g1", " ", "h"}], "2"], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "x0"}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "x0"}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{"x0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776198913115247*^9, 3.776199519889267*^9, 
  3.77620166323871*^9, 3.776201742801187*^9, 3.7762021968404827`*^9, 
  3.776543145710002*^9, 3.776548268588169*^9, 3.776629631807775*^9, 
  3.7770574968006268`*^9, 3.777070206461042*^9, 3.777118247460223*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"718091bc-05b7-483c-8485-9abedbcd0273"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "Collect", " ", "dx0", " ", "term", " ", "in", " ", "terms", " ", "of", 
    " ", 
    RowBox[{"{", 
     RowBox[{"x0", ",", "v0"}], "}"}]}], ":"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777057519792725*^9, 3.777057528174282*^9}},
 CellLabel->"In[40]:=",ExpressionUUID->"78dbf34d-7636-4bda-8c1a-993c8f7bf42f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", "x0"}], 
       RowBox[{"r", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"g1", " ", "h"}], "2"], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "x0"}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "x0"}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{"x0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777057529830511*^9, 3.77705753998374*^9}, 
   3.7770702196871243`*^9},
 CellLabel->"In[7]:=",ExpressionUUID->"96ddbaed-9cd8-4c12-a9c8-06525d3abe90"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k"}], 
       RowBox[{"r", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"g1", " ", "h"}], "2"], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "4"]}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "4"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.777057540304867*^9, 3.777070220366983*^9, 
  3.777118253166074*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"c32c2bce-9af2-4341-a712-1e8eb81232dc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Collect", " ", "dv0", " ", "in", " ", "terms", " ", "of", " ", 
     RowBox[{"{", 
      RowBox[{"x0", ",", "v0"}], "}"}]}], ":"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"g1", " ", "h"}], "2"], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "v0"}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g1"}], "+", 
              RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], 
           "beta"], "+", 
          RowBox[{"g1", " ", "x0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"d", " ", "v0"}], "+", 
          RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"d", " ", "v0"}], "+", 
          RowBox[{"g2", " ", "x0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}], ",", 
    RowBox[{"{", 
     RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777057546510138*^9, 3.777057575822649*^9}, 
   3.777070232829939*^9},
 CellLabel->"In[8]:=",ExpressionUUID->"6c206a31-2c86-461c-8c14-d78a4dfdf157"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"d", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"g1", " ", "h"}], "2"], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"d", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.777057576140991*^9, 3.777070233556782*^9, 
  3.7771182562272*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"c9cc91e7-3194-447f-ad5a-1743ca093372"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
      "Working", " ", "out", " ", "full", " ", "dgdotmhfdotm1", " ", "term", 
       " ", "for", " ", "drift"}], "-", 
      RowBox[{
      "first", " ", "case", " ", "by", " ", "replacing", " ", "dx0", " ", 
       "by", " ", 
       RowBox[{"(", 
        RowBox[{"dx0", "-", 
         RowBox[{"dh", "*", "v0"}], "-", 
         RowBox[{"h", "*", "dv0"}]}], ")"}]}]}], " ", "&"}], " ", "x0", " ", 
    "by", " ", "x0"}], "-", 
   RowBox[{"h", " ", "v0", " ", "in", " ", "vector", " ", 
    RowBox[{"terms", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7762575707238703`*^9, 3.776257611745723*^9}, 
   3.776629673936701*^9, {3.777057502302299*^9, 
   3.777057511990964*^9}},ExpressionUUID->"48e0a9bb-0e03-4980-a9fa-\
2d51e48ea77e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgdotmhfdotm1", " ", "=", " ", 
  RowBox[{
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g1", " ", "k"}], 
       RowBox[{"r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", "k", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"g1", " ", "h"}], "2"], "-", 
           RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
        RowBox[{"beta", " ", "r", " ", 
         SuperscriptBox["r0", "2"]}]]}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"g1", " ", "h"}], "-", 
        RowBox[{"g2", " ", "r0"}]}], 
       RowBox[{"r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox["r0", "2"]}]], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox["r0", "2"]}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "3"], " ", 
        SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"d", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"g1", " ", "h"}], "2"], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x0", "-", 
         RowBox[{"h", " ", "v0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}]}], ")"}]}], "+", 
   
   RowBox[{
    RowBox[{"(", 
     RowBox[{"dx0", " ", "-", " ", 
      RowBox[{"h", " ", "dv0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x0", "-", 
         RowBox[{"h", " ", "v0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k"}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "2"]}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", 
           SuperscriptBox["k", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"g1", " ", "h"}], "2"], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "-", " ", 
   RowBox[{"dh", "  ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"2", "k"}], "r0"], "-", "beta"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k"}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "2"]}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", 
           SuperscriptBox["k", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"g1", " ", "h"}], "2"], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776257603307942*^9, 3.776257649380403*^9}, {
  3.776543236643553*^9, 3.776543284094349*^9}, {3.776543354978094*^9, 
  3.77654336066322*^9}, {3.776548320681609*^9, 3.7765483646108418`*^9}, {
  3.7766296803509207`*^9, 3.776629706087818*^9}, {3.7770575844379587`*^9, 
  3.777057681773313*^9}, {3.7770702513941298`*^9, 3.7770702697423573`*^9}, {
  3.777079741284772*^9, 3.77707982413732*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"f786cdbb-b924-4eb2-838b-2dc638305375"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"g1", " ", "h"}], "2"], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g1", " ", "h"}], "-", 
       RowBox[{"g2", " ", "r0"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}]}], ")"}]}], "-", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "beta"}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"dx0", "-", 
     RowBox[{"dv0", " ", "h"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.776543365542399*^9, {3.776548339482252*^9, 3.7765483659985933`*^9}, 
   3.776629707020363*^9, 3.777057689939497*^9, 3.777070286644169*^9, 
   3.777079837990076*^9, 3.777118258807613*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"9b200416-b8e4-40b9-b112-dc4144f04150"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{
    "dx0", " ", ",", " ", "dv0", " ", ",", " ", "dk", ",", " ", "dh"}], 
    "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7762576589894037`*^9, 3.776257696602296*^9}, {
  3.776257736314624*^9, 3.776257742527274*^9}, {3.776543288717697*^9, 
  3.776543291579955*^9}, {3.776543338511224*^9, 3.776543369015685*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"a2953db8-00f4-416e-aad9-2cacfd70dbaa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"g1", " ", "h"}], "2"], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g1", " ", "h"}], "-", 
       RowBox[{"g2", " ", "r0"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "beta"}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "-", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "-", 
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"v0", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g2", " ", "k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g0", " ", "h"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
           FractionBox[
            RowBox[{"g1", " ", "k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
           FractionBox[
            RowBox[{"g2", " ", "k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g2", " ", "k"}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "2"]}]]}], "+", 
           FractionBox[
            RowBox[{"2", " ", 
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"g1", " ", "h"}], "2"], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g0", " ", "h"}], "-", 
               RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]], "+", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "3"], " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"k", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
               RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.7762576993941383`*^9, 3.77625774340796*^9, {3.776543293609583*^9, 
   3.776543369591444*^9}, {3.7765483419425993`*^9, 3.776548369871394*^9}, 
   3.776629711963174*^9, 3.777057692734312*^9, 3.7770798423317623`*^9, 
   3.777118261871776*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"438872e2-8c39-460c-a00f-7e0eb6f2d162"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"dx0", " ", "term", " ", "for", " ", "drift"}], "-", 
   RowBox[{"first", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776257755217338*^9, 
  3.776257767351172*^9}},ExpressionUUID->"9260977b-b0de-461c-996a-\
71c3b228e64d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.77625777115823*^9, 3.776257777064658*^9}, 
   3.7765433878250513`*^9, {3.7765483787946177`*^9, 3.776548388522747*^9}, 
   3.776629727223802*^9, 3.7770577043351603`*^9, 3.777079854130116*^9},
 CellLabel->"In[11]:=",ExpressionUUID->"95eab631-9a82-4215-a749-57272e016382"],

Cell[BoxData[
 RowBox[{
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k"}], 
       RowBox[{"r", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"g1", " ", "h"}], "2"], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "4"]}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "4"]}]]}], ")"}]}], "+", 
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776257777606966*^9, 3.776543389565988*^9, 
  3.776548390191777*^9, 3.776629728572426*^9, 3.777057705018099*^9, 
  3.7770798561499166`*^9, 3.777118265487138*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"62de25df-488a-41db-b534-8fcb55eaa53f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"dv0", " ", "term", " ", "for", " ", "drift"}], "-", 
    RowBox[{"first", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"d", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"g1", " ", "h"}], "2"], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "-", 
      RowBox[{"h", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"v0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g2", " ", "k", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"g0", " ", "h"}], "-", 
                 RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
            FractionBox[
             RowBox[{"g1", " ", "k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
            FractionBox[
             RowBox[{"g2", " ", "k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g2", " ", "k"}], 
              RowBox[{"r", " ", 
               SuperscriptBox["r0", "2"]}]]}], "+", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["k", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox[
                 RowBox[{"g1", " ", "h"}], "2"], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"beta", " ", "r", " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g0", " ", "h"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "3"], " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
                RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}], ")"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.776257788456625*^9, 3.776257804208694*^9}, 
   3.776543405969071*^9, {3.7765484011889877`*^9, 3.776548417666394*^9}, 
   3.77662974776993*^9, 3.7770577135316153`*^9, 3.7770798666419992`*^9},
 CellLabel->"In[12]:=",ExpressionUUID->"2564f2f9-eac0-4d13-8f0e-36dad0184aae"],

Cell[BoxData[
 RowBox[{
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"d", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"g1", " ", "h"}], "2"], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"d", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
     RowBox[{"2", " ", "h", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["h", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776257805016603*^9, 3.776543407196722*^9, 
  3.776548418246152*^9, 3.776629748677977*^9, 3.777057714270533*^9, 
  3.7770798677975492`*^9, 3.77711826825913*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"385d804f-fd79-4a9d-95c9-9312932815a3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgdotmhfdotm1", " ", "=", " ", 
  RowBox[{
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", "k", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"g1", " ", "h"}], "2"], "-", 
           RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
        RowBox[{"beta", " ", "r", " ", 
         SuperscriptBox["r0", "2"]}]]}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"g1", " ", "h"}], "-", 
        RowBox[{"g2", " ", "r0"}]}], 
       RowBox[{"r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox["r0", "2"]}]], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox["r0", "2"]}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "3"], " ", 
        SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g1", " ", "k"}], 
       RowBox[{"r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "beta"}], "+", 
         FractionBox[
          RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "-", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k"}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "2"]}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", 
           SuperscriptBox["k", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"g1", " ", "h"}], "2"], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k"}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "2"]}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", 
           SuperscriptBox["k", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"g1", " ", "h"}], "2"], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]]}], ")"}]}], "+", 
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
         RowBox[{"h", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g2", " ", "k"}], 
              RowBox[{"r", " ", 
               SuperscriptBox["r0", "2"]}]]}], "+", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["k", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox[
                 RowBox[{"g1", " ", "h"}], "2"], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"beta", " ", "r", " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g0", " ", "h"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "3"], " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
                RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
   "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
         RowBox[{"h", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g2", " ", "k"}], 
              RowBox[{"r", " ", 
               SuperscriptBox["r0", "2"]}]]}], "+", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["k", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox[
                 RowBox[{"g1", " ", "h"}], "2"], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"beta", " ", "r", " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g0", " ", "h"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "3"], " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
                RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"d", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"g1", " ", "h"}], "2"], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
         RowBox[{"2", " ", "h", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g2", " ", "k", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"g0", " ", "h"}], "-", 
                 RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
            FractionBox[
             RowBox[{"g1", " ", "k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
            FractionBox[
             RowBox[{"g2", " ", "k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["h", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g2", " ", "k"}], 
              RowBox[{"r", " ", 
               SuperscriptBox["r0", "2"]}]]}], "+", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["k", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox[
                 RowBox[{"g1", " ", "h"}], "2"], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"beta", " ", "r", " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g0", " ", "h"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "3"], " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
                RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776629854375856*^9, 3.776629926884266*^9}, {
  3.777057759020142*^9, 3.777057790504159*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"130b5757-e946-4425-9ade-8ac37a9eecd0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"g1", " ", "h"}], "2"], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g1", " ", "h"}], "-", 
       RowBox[{"g2", " ", "r0"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "beta"}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "-", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}], "+", 
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g2", " ", "k"}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "2"]}]]}], "+", 
           FractionBox[
            RowBox[{"2", " ", 
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"g1", " ", "h"}], "2"], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g0", " ", "h"}], "-", 
               RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]], "+", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "3"], " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"k", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
               RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
  "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g2", " ", "k"}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "2"]}]]}], "+", 
           FractionBox[
            RowBox[{"2", " ", 
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"g1", " ", "h"}], "2"], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g0", " ", "h"}], "-", 
               RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]], "+", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "3"], " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"k", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
               RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
        RowBox[{"2", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g2", " ", "k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g0", " ", "h"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
           FractionBox[
            RowBox[{"g1", " ", "k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
           FractionBox[
            RowBox[{"g2", " ", "k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["h", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g2", " ", "k"}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "2"]}]]}], "+", 
           FractionBox[
            RowBox[{"2", " ", 
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"g1", " ", "h"}], "2"], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g0", " ", "h"}], "-", 
               RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]], "+", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "3"], " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"k", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
               RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.777057794323419*^9, 3.77711827089375*^9, 
  3.777390193616253*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"755920af-fe01-4a9c-b483-3c03e8f68e49"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Revisiting", " ", 
   RowBox[{"formula", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777079881745914*^9, 3.777079889219089*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"22aa7730-d16c-4517-8167-2f0fe6f1fa6f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgdotmhfdotm13", " ", "=", " ", 
  RowBox[{
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", "k", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"g1", " ", "h"}], "2"], "-", 
           RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
        RowBox[{"beta", " ", "r", " ", 
         SuperscriptBox["r0", "2"]}]]}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"g1", " ", "h"}], "-", 
        RowBox[{"g2", " ", "r0"}]}], 
       RowBox[{"r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox["r0", "2"]}]], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox["r0", "2"]}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "3"], " ", 
        SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g1", " ", "k"}], 
       RowBox[{"r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g0", " ", "h"}], "-", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "beta"}], "+", 
         FractionBox[
          RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "-", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k"}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "2"]}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", 
           SuperscriptBox["k", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"g1", " ", "h"}], "2"], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k"}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "2"]}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", 
           SuperscriptBox["k", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"g1", " ", "h"}], "2"], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "3"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]]}], ")"}]}], "+", 
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
         RowBox[{"h", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g2", " ", "k"}], 
              RowBox[{"r", " ", 
               SuperscriptBox["r0", "2"]}]]}], "+", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["k", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox[
                 RowBox[{"g1", " ", "h"}], "2"], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"beta", " ", "r", " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g0", " ", "h"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "3"], " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
                RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
   "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
         RowBox[{"h", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g2", " ", "k"}], 
              RowBox[{"r", " ", 
               SuperscriptBox["r0", "2"]}]]}], "+", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["k", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox[
                 RowBox[{"g1", " ", "h"}], "2"], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"beta", " ", "r", " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g0", " ", "h"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "3"], " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
                RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"d", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g0", " ", "h"}], "-", 
              RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", "r0"}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"g1", " ", "h"}], "2"], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
         RowBox[{"2", " ", "h", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g2", " ", "k", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"g0", " ", "h"}], "-", 
                 RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
            FractionBox[
             RowBox[{"g1", " ", "k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
            FractionBox[
             RowBox[{"g2", " ", "k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["h", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g2", " ", "k"}], 
              RowBox[{"r", " ", 
               SuperscriptBox["r0", "2"]}]]}], "+", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["k", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox[
                 RowBox[{"g1", " ", "h"}], "2"], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"beta", " ", "r", " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "3"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g0", " ", "h"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "3"], " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
                RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r", "2"], " ", 
              SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777079911954574*^9, 3.777079960866137*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"50d4eff4-5266-4b0e-90a6-fbbdba0ecbcc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"g1", " ", "h"}], "2"], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g1", " ", "h"}], "-", 
       RowBox[{"g2", " ", "r0"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g0", " ", "h"}], "-", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "beta"}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "-", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g0", " ", "h"}], "-", 
            RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}], "+", 
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g2", " ", "k"}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "2"]}]]}], "+", 
           FractionBox[
            RowBox[{"2", " ", 
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"g1", " ", "h"}], "2"], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g0", " ", "h"}], "-", 
               RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]], "+", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "3"], " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"k", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
               RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
  "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g2", " ", "k"}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "2"]}]]}], "+", 
           FractionBox[
            RowBox[{"2", " ", 
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"g1", " ", "h"}], "2"], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g0", " ", "h"}], "-", 
               RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]], "+", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "3"], " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"k", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
               RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g0", " ", "h"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"g1", " ", "h"}], "2"], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
        RowBox[{"2", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g2", " ", "k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g0", " ", "h"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r", "2"], " ", "r0"}]]}], "-", 
           FractionBox[
            RowBox[{"g1", " ", "k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
           FractionBox[
            RowBox[{"g2", " ", "k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["h", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g2", " ", "k"}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "2"]}]]}], "+", 
           FractionBox[
            RowBox[{"2", " ", 
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"g1", " ", "h"}], "2"], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", "r", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "3"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g0", " ", "h"}], "-", 
               RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]], "+", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g0"}], "+", 
               RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox["r", "3"], " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"k", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
               RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r", "2"], " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.777079967421817*^9, 3.77711827594176*^9, 
  3.777390204437354*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"0cd0a4ff-c124-418c-9c5e-0ee997d7812e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgdotmhfdotm1", "-", " ", "dgdotmhfdotm13"}]], "Input",
 CellChangeTimes->{{3.7770799706888733`*^9, 3.777079974720048*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"b835859b-58e3-4e24-b96e-4689972511d3"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.777118280696748*^9, 3.777390207120864*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"33a207a4-2e3e-4e83-9e4c-e5c5e656a4f6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777079978593341*^9, 3.777079980919626*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"c7d41539-34f6-41b2-9684-c33cee6475f5"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7770799813106327`*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"ed6829f5-8af3-43f7-b776-7a2058e8d1fb"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.776259142991139*^9, 3.776259145021975*^9}, 
   3.7762592917822437`*^9, 3.776543484769848*^9, {3.7765435176956873`*^9, 
   3.77654354253555*^9}, {3.7765435747777233`*^9, 3.776543604097143*^9}, {
   3.776548479904228*^9, 3.776548549080544*^9}, 
   3.776629810434248*^9},ExpressionUUID->"09f05ab5-fb26-4fb3-8d38-\
faed241e3432"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", ",", " ", 
   RowBox[{"see", " ", "if", " ", "we", " ", "can", " ", 
    RowBox[{"simplify", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776543638084257*^9, 3.776543653674282*^9}, {
  3.776629819761155*^9, 3.776629822311648*^9}, {3.776630162413381*^9, 
  3.776630162703115*^9}},ExpressionUUID->"2119f5f3-760c-487a-9160-\
ca0c499ad8ce"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"c1", "=", 
  RowBox[{"d", "-", 
   RowBox[{"r0", " ", "g3"}]}]}], "\n", 
 RowBox[{"c2", "=", 
  RowBox[{
   RowBox[{"eta", " ", "g0"}], "+", 
   RowBox[{"g1", " ", "zeta"}]}]}], "\n", 
 RowBox[{
  RowBox[{"c3", "=", 
   RowBox[{
    RowBox[{"d", " ", "k"}], "+", 
    RowBox[{"g1", " ", 
     SuperscriptBox["r0", "2"]}]}]}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"c12", " ", "=", " ", 
  RowBox[{
   RowBox[{"g0", " ", "h"}], "-", 
   RowBox[{"g1", " ", "r0"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c13", " ", "=", " ", 
  RowBox[{
   RowBox[{"g1", " ", "h"}], "-", 
   RowBox[{"g2", " ", "r0"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c17", "=", 
  RowBox[{"r0", "-", "r", "-", 
   RowBox[{"g2", " ", "k"}]}]}], "\n", 
 RowBox[{"c18", " ", "=", " ", 
  RowBox[{
   RowBox[{"eta", " ", "g1"}], "+", 
   RowBox[{"2", "g2", " ", "k"}]}]}], "\n", 
 RowBox[{"c25", " ", "=", " ", 
  RowBox[{
   FractionBox["1", "r0"], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "g2"}], "-", 
     FractionBox[
      RowBox[{" ", 
       RowBox[{"k", " ", "g2"}]}], 
      RowBox[{"beta", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{" ", "c13"}], "r0"], "-", 
     FractionBox[
      RowBox[{" ", 
       RowBox[{"c12", " ", "c3"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"c13", " ", "c3", " ", "c2"}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{" ", 
       RowBox[{"c13", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox["k", "2"], " ", "g2"}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c26", " ", "=", " ", 
  RowBox[{
   FractionBox["1", "r"], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g2"}], " ", "c12"}], "-", 
     RowBox[{"g1", " ", "c13"}], "+", 
     FractionBox[
      RowBox[{"g2", " ", "c13", " ", "c2"}], "r"]}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.777058187589596*^9, 3.77705819971176*^9}, {
   3.7770582328414507`*^9, 3.7770582338504477`*^9}, {3.777058311256476*^9, 
   3.777058312376573*^9}, {3.777058683833926*^9, 3.777058702782065*^9}, {
   3.7770588058052797`*^9, 3.7770588122461967`*^9}, {3.777058952445508*^9, 
   3.777058979394581*^9}, 3.777080080747107*^9, {3.777390613863493*^9, 
   3.777390624428035*^9}, {3.777391519706758*^9, 3.7773917436898727`*^9}, {
   3.777392716370132*^9, 3.7773927257846527`*^9}, {3.777393146578918*^9, 
   3.777393168340376*^9}, {3.777393275822494*^9, 3.7773933698353033`*^9}, {
   3.7773934424547567`*^9, 3.777393448207053*^9}, {3.777393481516726*^9, 
   3.7773935276989117`*^9}},
 CellLabel->
  "In[438]:=",ExpressionUUID->"bfcce50b-4714-45f1-9486-ecb8ca0f6248"],

Cell[BoxData[
 RowBox[{"d", "-", 
  RowBox[{"g3", " ", "r0"}]}]], "Output",
 CellChangeTimes->{
  3.777058856000297*^9, {3.777058956838357*^9, 3.7770589815016537`*^9}, 
   3.777063776054989*^9, 3.777080012432098*^9, 3.777080081612184*^9, 
   3.7771182897149563`*^9, 3.777390210079041*^9, 3.777390628754615*^9, 
   3.77739167237751*^9, 3.777391745006133*^9, 3.7773928053470697`*^9, 
   3.777393192348156*^9, 3.777393327675419*^9, 3.777393452771744*^9, 
   3.777393530116107*^9, 3.778172765801091*^9, 3.778212576822077*^9},
 CellLabel->
  "Out[438]=",ExpressionUUID->"2160108a-75fd-45b7-a2c9-e6007a66fd2d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g0"}], "+", 
  RowBox[{"g1", " ", 
   RowBox[{"(", 
    RowBox[{"k", "-", 
     RowBox[{"beta", " ", "r0"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.777058856000297*^9, {3.777058956838357*^9, 3.7770589815016537`*^9}, 
   3.777063776054989*^9, 3.777080012432098*^9, 3.777080081612184*^9, 
   3.7771182897149563`*^9, 3.777390210079041*^9, 3.777390628754615*^9, 
   3.77739167237751*^9, 3.777391745006133*^9, 3.7773928053470697`*^9, 
   3.777393192348156*^9, 3.777393327675419*^9, 3.777393452771744*^9, 
   3.777393530116107*^9, 3.778172765801091*^9, 3.7782125768239326`*^9},
 CellLabel->
  "Out[439]=",ExpressionUUID->"85e10364-8be7-4525-b6fd-5ce54fb7018d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", " ", "k"}], "+", 
  RowBox[{"g1", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{
  3.777058856000297*^9, {3.777058956838357*^9, 3.7770589815016537`*^9}, 
   3.777063776054989*^9, 3.777080012432098*^9, 3.777080081612184*^9, 
   3.7771182897149563`*^9, 3.777390210079041*^9, 3.777390628754615*^9, 
   3.77739167237751*^9, 3.777391745006133*^9, 3.7773928053470697`*^9, 
   3.777393192348156*^9, 3.777393327675419*^9, 3.777393452771744*^9, 
   3.777393530116107*^9, 3.778172765801091*^9, 3.778212576825574*^9},
 CellLabel->
  "Out[440]=",ExpressionUUID->"25d8f56d-fc24-4fe4-9add-32f950800745"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g0", " ", "h"}], "-", 
  RowBox[{"g1", " ", "r0"}]}]], "Output",
 CellChangeTimes->{
  3.777058856000297*^9, {3.777058956838357*^9, 3.7770589815016537`*^9}, 
   3.777063776054989*^9, 3.777080012432098*^9, 3.777080081612184*^9, 
   3.7771182897149563`*^9, 3.777390210079041*^9, 3.777390628754615*^9, 
   3.77739167237751*^9, 3.777391745006133*^9, 3.7773928053470697`*^9, 
   3.777393192348156*^9, 3.777393327675419*^9, 3.777393452771744*^9, 
   3.777393530116107*^9, 3.778172765801091*^9, 3.778212576827183*^9},
 CellLabel->
  "Out[441]=",ExpressionUUID->"79634ba9-c6d8-43f1-978a-aa247fdfcc06"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g1", " ", "h"}], "-", 
  RowBox[{"g2", " ", "r0"}]}]], "Output",
 CellChangeTimes->{
  3.777058856000297*^9, {3.777058956838357*^9, 3.7770589815016537`*^9}, 
   3.777063776054989*^9, 3.777080012432098*^9, 3.777080081612184*^9, 
   3.7771182897149563`*^9, 3.777390210079041*^9, 3.777390628754615*^9, 
   3.77739167237751*^9, 3.777391745006133*^9, 3.7773928053470697`*^9, 
   3.777393192348156*^9, 3.777393327675419*^9, 3.777393452771744*^9, 
   3.777393530116107*^9, 3.778172765801091*^9, 3.778212576828788*^9},
 CellLabel->
  "Out[442]=",ExpressionUUID->"a3ad9f1e-984f-4710-be5e-7dd32df11656"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}]], "Output",
 CellChangeTimes->{
  3.777058856000297*^9, {3.777058956838357*^9, 3.7770589815016537`*^9}, 
   3.777063776054989*^9, 3.777080012432098*^9, 3.777080081612184*^9, 
   3.7771182897149563`*^9, 3.777390210079041*^9, 3.777390628754615*^9, 
   3.77739167237751*^9, 3.777391745006133*^9, 3.7773928053470697`*^9, 
   3.777393192348156*^9, 3.777393327675419*^9, 3.777393452771744*^9, 
   3.777393530116107*^9, 3.778172765801091*^9, 3.778212576830577*^9},
 CellLabel->
  "Out[443]=",ExpressionUUID->"484d090e-01eb-4516-bcbc-f34e580fde42"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g1"}], "+", 
  RowBox[{"2", " ", "g2", " ", "k"}]}]], "Output",
 CellChangeTimes->{
  3.777058856000297*^9, {3.777058956838357*^9, 3.7770589815016537`*^9}, 
   3.777063776054989*^9, 3.777080012432098*^9, 3.777080081612184*^9, 
   3.7771182897149563`*^9, 3.777390210079041*^9, 3.777390628754615*^9, 
   3.77739167237751*^9, 3.777391745006133*^9, 3.7773928053470697`*^9, 
   3.777393192348156*^9, 3.777393327675419*^9, 3.777393452771744*^9, 
   3.777393530116107*^9, 3.778172765801091*^9, 3.77821257683237*^9},
 CellLabel->
  "Out[444]=",ExpressionUUID->"bed097ae-a981-491b-a27f-bbf6366c7ac9"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "g2"}], "-", 
   FractionBox[
    RowBox[{"g2", " ", "k"}], 
    RowBox[{"beta", " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"g1", " ", "h"}], "-", 
     RowBox[{"g2", " ", "r0"}]}], "r0"], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g0", " ", "h"}], "-", 
       RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"d", " ", "k"}], "+", 
       RowBox[{"g1", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}]}], 
    RowBox[{"r", " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g1", " ", "h"}], "-", 
       RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"d", " ", "k"}], "+", 
       RowBox[{"g1", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}], 
    RowBox[{
     SuperscriptBox["r", "2"], " ", 
     SuperscriptBox["r0", "2"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g1", " ", "h"}], "-", 
       RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g2", " ", 
        SuperscriptBox["k", "2"]}], "-", 
       RowBox[{"g0", " ", "r0", " ", 
        RowBox[{"(", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}], 
    RowBox[{"beta", " ", "r", " ", 
     SuperscriptBox["r0", "2"]}]]}], "r0"]], "Output",
 CellChangeTimes->{
  3.777058856000297*^9, {3.777058956838357*^9, 3.7770589815016537`*^9}, 
   3.777063776054989*^9, 3.777080012432098*^9, 3.777080081612184*^9, 
   3.7771182897149563`*^9, 3.777390210079041*^9, 3.777390628754615*^9, 
   3.77739167237751*^9, 3.777391745006133*^9, 3.7773928053470697`*^9, 
   3.777393192348156*^9, 3.777393327675419*^9, 3.777393452771744*^9, 
   3.777393530116107*^9, 3.778172765801091*^9, 3.7782125768344316`*^9},
 CellLabel->
  "Out[445]=",ExpressionUUID->"b52cc112-120f-4735-ae3a-f2f7e9eddaa8"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "g2"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g0", " ", "h"}], "-", 
      RowBox[{"g1", " ", "r0"}]}], ")"}]}], "-", 
   RowBox[{"g1", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", "h"}], "-", 
      RowBox[{"g2", " ", "r0"}]}], ")"}]}], "+", 
   FractionBox[
    RowBox[{"g2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g1", " ", "h"}], "-", 
       RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}], "r"]}], 
  "r"]], "Output",
 CellChangeTimes->{
  3.777058856000297*^9, {3.777058956838357*^9, 3.7770589815016537`*^9}, 
   3.777063776054989*^9, 3.777080012432098*^9, 3.777080081612184*^9, 
   3.7771182897149563`*^9, 3.777390210079041*^9, 3.777390628754615*^9, 
   3.77739167237751*^9, 3.777391745006133*^9, 3.7773928053470697`*^9, 
   3.777393192348156*^9, 3.777393327675419*^9, 3.777393452771744*^9, 
   3.777393530116107*^9, 3.778172765801091*^9, 3.778212576836481*^9},
 CellLabel->
  "Out[446]=",ExpressionUUID->"7ba24f98-c78e-4fb5-a9ef-cfd8b4959cdc"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"dgdotmhfdotm12", " ", "=", "  ", 
    RowBox[{
     RowBox[{"dk", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{" ", 
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{"c13", "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "2"]}]]}], "+", 
        FractionBox["c13", 
         RowBox[{"r", " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"k", " ", "c17", " ", "c13"}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "2"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", "c12", " ", "c1"}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "2"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", "c13", " ", "c1", " ", "c2"}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
     RowBox[{"dh", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"g1", " ", "k"}], 
         RowBox[{"r", " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"k", " ", "c12"}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"k", " ", "c13", " ", "c2"}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "beta"}], "+", 
           FractionBox[
            RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", "c26"}], "-", 
        RowBox[{"eta", " ", "c25"}]}], ")"}]}], "+", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x0", " ", "c25"}], "+", 
        RowBox[{"v0", " ", 
         RowBox[{"(", 
          RowBox[{"c26", "-", 
           RowBox[{"h", " ", "c25"}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{"dv0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x0", " ", 
         RowBox[{"(", 
          RowBox[{"c26", "-", " ", 
           RowBox[{"h", " ", "c25"}]}], ")"}]}], "+", 
        RowBox[{"v0", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            FractionBox[
             RowBox[{"d", " ", "k"}], 
             RowBox[{
              SuperscriptBox["r", "3"], "r0"}]], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"c13", " ", "c2"}], "-", 
              RowBox[{"r", " ", "c12"}]}], ")"}]}], "+", 
           FractionBox[
            RowBox[{" ", 
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"c13", " ", 
                 RowBox[{"(", " ", 
                  RowBox[{
                   RowBox[{"r0", " ", "g0"}], "-", " ", 
                   RowBox[{"k", " ", "g2"}]}], ")"}]}], "-", 
                RowBox[{"g2", "  ", "r", " ", "r0"}]}], ")"}]}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
           RowBox[{"2", " ", "h", " ", "c26"}], "+", " ", 
           RowBox[{
            SuperscriptBox["h", "2"], " ", "c25"}]}], ")"}]}]}], ")"}]}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"dgdotmhfdotm12", " ", "=", "  ", 
   RowBox[{
    RowBox[{
     FractionBox["dk", 
      RowBox[{"r", " ", "r0"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{" ", 
         RowBox[{"k", " ", "g2"}]}], "beta"], "+", 
       FractionBox[
        RowBox[{"k", " ", "c1", " ", "c12"}], 
        RowBox[{"r", " ", "r0"}]], "+", 
       RowBox[{"c13", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           FractionBox["k", 
            RowBox[{"r", " ", "r0"}]], 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{" ", 
               RowBox[{"r0", "-", 
                RowBox[{"k", " ", "g2"}]}]}], 
              RowBox[{"beta", " "}]], "+", 
             FractionBox[
              RowBox[{"c1", " ", "c2"}], "r"]}], ")"}]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", "dh"}], 
      RowBox[{"r", " ", "r0"}]], " ", 
     RowBox[{"(", 
      RowBox[{"g1", " ", "+", 
       FractionBox[
        RowBox[{" ", "c12"}], "r"], "-", 
       FractionBox[
        RowBox[{" ", 
         RowBox[{"c13", " ", "c2"}]}], 
        SuperscriptBox["r", "2"]], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "beta"}], "+", 
          FractionBox[
           RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", "c26"}], "-", 
       RowBox[{"eta", " ", "c25"}]}], ")"}]}], "+", 
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", "dx0"}], 
      RowBox[{"r", " ", "r0"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x0", " ", "c25"}], "+", 
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{"c26", "-", 
          RowBox[{"h", " ", "c25"}]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", "dv0"}], 
      RowBox[{"r", " ", "r0"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{"c26", "-", " ", 
          RowBox[{"h", " ", "c25"}]}], ")"}]}], "+", 
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox[
            RowBox[{"d", " "}], 
            SuperscriptBox["r", "2"]], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"c13", " ", "c2"}], "-", 
             RowBox[{"r", " ", "c12"}]}], ")"}]}], "+", 
          FractionBox[
           RowBox[{"  ", 
            RowBox[{
             RowBox[{"c13", 
              RowBox[{"(", " ", 
               RowBox[{
                RowBox[{"r0", " ", "g0"}], "-", 
                RowBox[{"k", " ", "g2"}]}], ")"}]}], "-", 
             RowBox[{"g2", " ", "r", " ", "r0"}]}]}], 
           RowBox[{"beta", " ", "r"}]], "-", 
          RowBox[{"2", " ", "h", " ", "c26"}], "+", " ", 
          RowBox[{
           SuperscriptBox["h", "2"], " ", "c25"}]}], ")"}]}]}], 
      ")"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.776629942067974*^9, 3.776629981266651*^9}, {
  3.77663002414202*^9, 3.77663014376624*^9}, {3.777057810219636*^9, 
  3.7770579300632963`*^9}, {3.777058317136301*^9, 3.777058433895061*^9}, {
  3.777058465072423*^9, 3.7770587523758163`*^9}, {3.777058815718402*^9, 
  3.777058835878228*^9}, {3.7770589181912603`*^9, 3.777058948525567*^9}, {
  3.777058997609282*^9, 3.777059029681713*^9}, {3.777059199242634*^9, 
  3.7770593861307917`*^9}, {3.7773111843772097`*^9, 3.7773111861908197`*^9}, {
  3.777390218411021*^9, 3.77739022660737*^9}, {3.7773902835992203`*^9, 
  3.7773904839043417`*^9}, {3.7773906065039463`*^9, 3.777390608549162*^9}, {
  3.777392736467587*^9, 3.777392801917666*^9}, {3.777393222621585*^9, 
  3.7773932340182667`*^9}},
 CellLabel->
  "In[111]:=",ExpressionUUID->"8cf6c5b4-2f61-4490-ad60-eb4d417594d0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dgdotmhfdotm1", "-", "dgdotmhfdotm12"}], " ", "/.", " ", 
  RowBox[{"r", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
    RowBox[{"k", " ", "g2"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7770588682723293`*^9, 3.7770588694908333`*^9}, {
  3.777063799573851*^9, 3.77706380666077*^9}},
 CellLabel->
  "In[112]:=",ExpressionUUID->"73089f60-413f-4e22-8f27-54e5e6f9cb65"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777058873105668*^9, 3.7770588752871428`*^9}},
 CellLabel->
  "In[113]:=",ExpressionUUID->"141f92bf-29f7-46e2-829f-ca31ddbab7b7"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7770588756475277`*^9, {3.777063785033244*^9, 3.777063811490015*^9}, 
   3.7770800252671547`*^9, 3.77708009567379*^9, 3.777118300731941*^9, 
   3.7773905041416693`*^9, 3.777390997449396*^9, 3.777391686685479*^9, 
   3.777391758002262*^9, 3.777392817911148*^9, 3.777393202455985*^9, 
   3.7773933376216908`*^9, 3.777393461685219*^9, 3.777393538057027*^9},
 CellLabel->
  "Out[113]=",ExpressionUUID->"74fe83e8-1009-4218-91a0-403d964535f6"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Examine", " ", "dk", " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7781888488745413`*^9, 3.7781888499389057`*^9}, {
  3.77821251205057*^9, 3.778212517007551*^9}},
 CellLabel->
  "In[436]:=",ExpressionUUID->"128b1f6c-5ecc-47f1-a3c7-dfff0a3c4d7a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               FractionBox[
                RowBox[{" ", 
                 RowBox[{"c1", " ", "c12"}]}], 
                RowBox[{"r", " ", "r0"}]], "+", 
               FractionBox[
                RowBox[{"  ", "g2"}], "beta"], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"-", 
                  FractionBox[
                   RowBox[{"c13", " "}], 
                   RowBox[{"r", " ", "r0"}]]}], ")"}], 
                FractionBox[
                 RowBox[{" ", 
                  RowBox[{"r0", "-", 
                   RowBox[{"k", " ", "g2"}]}]}], 
                 RowBox[{"beta", " "}]]}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"-", 
                  FractionBox[
                   RowBox[{"c13", " "}], 
                   RowBox[{"r", " ", "r0"}]]}], ")"}], 
                FractionBox[
                 RowBox[{"c1", " ", "c2"}], "r"]}]}], "/.", " ", 
              RowBox[{"h8", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
                RowBox[{"3", " ", "g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
             RowBox[{"h6", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"2", 
                SuperscriptBox["g2", "2"]}], "-", 
               RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
            RowBox[{"d", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"h", "+", 
                RowBox[{"eta", "*", "g2"}], "+", 
                RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
              "beta"}]}]}], "  ", "/.", " ", 
           RowBox[{"h", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
             RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
          RowBox[{"r", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
            RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
         RowBox[{"zeta", " ", "\[Rule]", " ", 
          RowBox[{"k", "-", 
           RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"1", "-", " ", 
          RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.778212518961073*^9, 3.778212537528633*^9}, {
  3.778212595272764*^9, 3.778212772754365*^9}, {3.778213106824897*^9, 
  3.778213116672179*^9}, {3.778216352267666*^9, 3.778216359634758*^9}},
 CellLabel->
  "In[502]:=",ExpressionUUID->"1e782768-a448-4981-8777-838eddd2d72a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"k", " ", 
      SuperscriptBox["gamma", "6"]}], 
     RowBox[{"9", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["beta", "3"], " ", "r0"}], ")"}]}]]}], "+", 
   FractionBox[
    RowBox[{"eta", " ", "k", " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"18", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "15"}], " ", 
        SuperscriptBox["eta", "2"], " ", "k"}], "+", 
       RowBox[{"12", " ", 
        SuperscriptBox["k", "2"], " ", "r0"}], "-", 
       RowBox[{"8", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"240", " ", 
     SuperscriptBox["beta", "4"], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 6, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 9] $CellContext`beta^(-3) $CellContext`k/$CellContext`r0, 
    Rational[1, 18] $CellContext`beta^
     Rational[-7, 2] $CellContext`eta $CellContext`k $CellContext`r0^(-2), 
    Rational[1, 
      240] $CellContext`beta^(-4) $CellContext`r0^(-3) ((-15) \
$CellContext`eta^2 $CellContext`k + 12 $CellContext`k^2 $CellContext`r0 - 
     8 $CellContext`beta $CellContext`k $CellContext`r0^2)}, 6, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.7782131198789*^9, 3.778215662354128*^9, {3.778216353262495*^9, 
   3.77821636012786*^9}},
 CellLabel->
  "Out[502]=",ExpressionUUID->"a7d56cd7-829a-4960-87e5-20369deabac0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "See", " ", "if", " ", "the", " ", "combined", " ", "term", " ", "is", " ", 
    RowBox[{"correct", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 FractionBox[
                  RowBox[{" ", 
                   RowBox[{"c1", " ", "c12"}]}], 
                  RowBox[{"r", " ", "r0"}]], "+", 
                 FractionBox[
                  RowBox[{"  ", "g2"}], "beta"], "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{"c13", " "}], 
                    RowBox[{"r", " ", "r0"}]]}], ")"}], 
                  FractionBox[
                   RowBox[{" ", 
                    RowBox[{"r0", "-", 
                    RowBox[{"k", " ", "g2"}]}]}], 
                   RowBox[{"beta", " "}]]}], "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{"c13", " "}], 
                    RowBox[{"r", " ", "r0"}]]}], ")"}], 
                  FractionBox[
                   RowBox[{"c1", " ", "c2"}], "r"]}], "-", 
                 RowBox[{
                  FractionBox["k", 
                   RowBox[{"beta", " ", 
                    SuperscriptBox["r", "2"], " ", "r0"}]], 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", " ", "beta"}], " ", 
                    SuperscriptBox["eta", "2"], " ", 
                    SuperscriptBox["g2", "4"]}], "+", 
                    RowBox[{"eta", " ", "g2", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", " ", 
                    SuperscriptBox["g2", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["g1", "2"], "  ", "g3"}], "-", 
                    RowBox[{"5", " ", "g2", " ", "g3"}]}], ")"}], " ", "k"}], 
                    "-", 
                    RowBox[{"g2", " ", "g3", " ", "h9", " ", 
                    SuperscriptBox["k", "2"]}], "+", 
                    RowBox[{"2", " ", "eta", " ", "r0", " ", "beta", " ", 
                    SuperscriptBox["g2", "2"], 
                    RowBox[{"(", 
                    RowBox[{"g3", "-", 
                    RowBox[{"g1", " ", "g2"}]}], ")"}]}], " ", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", "g3"}], "-", 
                    RowBox[{"g0", " ", "g3"}], "-", 
                    RowBox[{"g1", " ", "g2"}]}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{"g3", "-", 
                    RowBox[{"g1", " ", "g2"}]}], ")"}], "  ", "r0", " ", 
                    "k"}], "+", 
                    RowBox[{"beta", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", "g1", " ", "g3", " ", "g2"}], "-", 
                    RowBox[{
                    SuperscriptBox["g1", "2"], 
                    SuperscriptBox["g2", "2"]}], "-", 
                    SuperscriptBox["g3", "2"]}], ")"}], "  ", 
                    SuperscriptBox["r0", "2"]}]}], ")"}]}]}], "/.", " ", 
                RowBox[{"h9", " ", "\[Rule]", " ", 
                 RowBox[{
                  RowBox[{"3", " ", "g3"}], " ", "-", " ", 
                  RowBox[{"g1", " ", "g2"}]}]}]}], "/.", " ", 
               RowBox[{"h8", " ", "\[Rule]", " ", 
                RowBox[{
                 RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
                 RowBox[{"3", " ", "g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
              RowBox[{"h6", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"2", 
                 SuperscriptBox["g2", "2"]}], "-", 
                RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"g0", " ", "\[Rule]", " ", 
          RowBox[{"1", "-", " ", 
           RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g1", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"Sin", "[", "gamma", "]"}], "/", 
          RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g2", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], 
      " ", "/.", " ", 
      RowBox[{"g3", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"gamma", "-", 
           RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"gamma", ",", "0", ",", "14"}], "}"}]}], "]"}], " ", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Wow", ",", " ", 
     RowBox[{
      RowBox[{"that", "'"}], "s", " ", "quite", " ", "a", " ", "bit", " ", 
      "of", " ", 
      RowBox[{"cancellation", "!"}], "  ", "The", " ", "new", " ", 
      "expression", " ", "seems", " ", "to", " ", "do", " ", "the", " ", 
      RowBox[{"trick", "!"}]}]}], " ", "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.7782127923912*^9, 3.7782128039977922`*^9}, {
  3.778215357157013*^9, 3.778215405797576*^9}, {3.778215453919039*^9, 
  3.778215479759734*^9}, {3.778215626517088*^9, 3.778215632627141*^9}, {
  3.7782157054438887`*^9, 3.7782157240096273`*^9}, {3.7782163490839653`*^9, 
  3.7782163625848093`*^9}, {3.7782164673083467`*^9, 3.778216487872596*^9}, {
  3.778216701081129*^9, 
  3.7782167076633263`*^9}},ExpressionUUID->"764d6ffe-2f26-47a5-8a0b-\
451884ef392b"],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", "gamma", "]"}], "15"],
  SeriesData[$CellContext`gamma, 0, {}, 15, 15, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.7782128044746857`*^9, {3.778215406591411*^9, 3.778215457956462*^9}, 
   3.778215633147634*^9, 3.778215725492111*^9, 3.7782163630508432`*^9, {
   3.7782164758581333`*^9, 3.778216489539393*^9}},
 CellLabel->
  "Out[508]=",ExpressionUUID->"c30e0654-7e5d-41dc-87e2-9674d3f0e889"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"So", ",", " ", 
   RowBox[{
   "I", " ", "need", " ", "to", " ", "combine", " ", "the", " ", "dk", " ", 
    RowBox[{"terms", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7782128334302483`*^9, 3.7782128392314253`*^9}},
 CellLabel->
  "In[462]:=",ExpressionUUID->"b1792c88-8a5d-4d76-92b4-424cea5d9324"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{" ", 
    RowBox[{"c1", " ", "c12"}]}], 
   RowBox[{"r", " ", "r0"}]], "+", 
  FractionBox[
   RowBox[{"  ", "g2"}], "beta"], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"c13", " "}], 
      RowBox[{"r", " ", "r0"}]]}], ")"}], 
   FractionBox[
    RowBox[{" ", 
     RowBox[{"r0", "-", 
      RowBox[{"k", " ", "g2"}]}]}], 
    RowBox[{"beta", " "}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"c13", " "}], 
      RowBox[{"r", " ", "r0"}]]}], ")"}], 
   FractionBox[
    RowBox[{"c1", " ", "c2"}], "r"]}]}]], "Input",
 CellChangeTimes->{{3.778213129363428*^9, 3.778213134854903*^9}},
 CellLabel->
  "In[473]:=",ExpressionUUID->"4e646826-0903-44d4-a8ba-659e54a3d17d"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"g2", " ", 
    SuperscriptBox["r", "2"], " ", "r0"}], 
   RowBox[{"beta", " ", 
    SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
  FractionBox[
   RowBox[{"r", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g2"}], " ", "k"}], "+", "r0"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", "h"}], "-", 
      RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
   RowBox[{"beta", " ", 
    SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
  RowBox[{
   FractionBox[
    RowBox[{"(", 
     RowBox[{"d", "-", 
      RowBox[{"g3", " ", "r0"}]}], ")"}], 
    RowBox[{
     SuperscriptBox["r", "2"], " ", "r0"}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g0", " ", "h"}], "-", 
        RowBox[{"g1", " ", "r0"}]}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"r0", " ", "g0"}], "+", " ", 
        RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
        RowBox[{"k", " ", "g2"}]}], ")"}]}], " ", "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "h"}], "-", 
        RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", "g0"}], "+", 
        RowBox[{"k", " ", "g1"}], " ", "-", 
        RowBox[{"beta", " ", "g1", " ", "r0"}]}], ")"}]}]}], ")"}]}]}]], \
"Input",
 CellChangeTimes->{{3.778213145575902*^9, 
  3.778213333096985*^9}},ExpressionUUID->"509cdcb4-a2cd-4892-941f-\
e7b12f974532"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"This", " ", "is", " ", "the", " ", "numerator"}], ",", " ", 
    RowBox[{"denominator", " ", "is", " ", "beta", " ", 
     RowBox[{"r", "^", "2"}], " ", 
     RowBox[{"r0", ":"}]}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.778212985719717*^9, 3.778212995648369*^9}},
 CellLabel->
  "In[467]:=",ExpressionUUID->"b2de240f-789f-4681-a3ca-8c03d626e8f9"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"First", ",", " ", 
   RowBox[{
    RowBox[{"I", "'"}], "ll", " ", "work", " ", "on", " ", "the", " ", "c1", 
    " ", "term", " ", 
    RowBox[{"numerator", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.778212867155178*^9, 3.778212946283022*^9}, {
  3.778213014653428*^9, 3.778213051155251*^9}, {3.778213338858279*^9, 
  3.778213361927176*^9}},
 CellLabel->
  "In[474]:=",ExpressionUUID->"4d60c59a-8ea9-41ad-8aa8-8faff17196a3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g0", " ", "h"}], "-", 
     RowBox[{"g1", " ", "r0"}]}], ")"}], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"r0", " ", "g0"}], "+", " ", 
     RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
     RowBox[{"k", " ", "g2"}]}], ")"}]}], " ", "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "h"}], "-", 
     RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"k", " ", "g1"}], " ", "-", 
     RowBox[{"beta", " ", "g1", " ", "r0"}]}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Okay", ",", " ", 
    RowBox[{"look", " ", "at", " ", "the", " ", 
     RowBox[{"dv0", ".", "v0"}], " ", 
     RowBox[{"term", ":"}]}]}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.7781727342009363`*^9, 3.778172750552896*^9}, {
   3.7781728799799547`*^9, 3.778172880322278*^9}, 3.7782133669307613`*^9},
 CellLabel->
  "In[475]:=",ExpressionUUID->"0b62a6bb-3fd8-4bba-a487-a3f9dd5f7317"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g0", " ", "h"}], "-", 
     RowBox[{"g1", " ", "r0"}]}], ")"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"g1", " ", "k"}], "-", 
     RowBox[{"beta", " ", "g1", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "h"}], "-", 
     RowBox[{"g2", " ", "r0"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.778213367825082*^9},
 CellLabel->
  "Out[475]=",ExpressionUUID->"0b9fd9d1-1256-466b-9720-4519133df273"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", " ", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778213369409223*^9, 3.778213374488784*^9}},
 CellLabel->
  "In[476]:=",ExpressionUUID->"a5edfc4e-4139-4670-964f-ecc0c19301d9"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"h", " ", 
   RowBox[{"(", 
    RowBox[{"r0", "-", 
     RowBox[{"g2", " ", "k"}]}], ")"}]}], "-", 
  RowBox[{"eta", " ", "r0", " ", "g2"}], "-", 
  RowBox[{"g1", " ", 
   SuperscriptBox["r0", "2"]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Okay", ",", " ", 
    RowBox[{"so", " ", "now", " ", "for", " ", "the", " ", "larger", " ", 
     RowBox[{"term", ":"}]}]}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.7782133819202023`*^9, 3.778213572269476*^9}},
 CellLabel->
  "In[477]:=",ExpressionUUID->"84121ccc-d44d-4bda-8e90-74c0a75f3330"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"g2", " ", 
    SuperscriptBox["r", "2"], " ", "r0"}], 
   RowBox[{"beta", " ", 
    SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
  FractionBox[
   RowBox[{"r", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g2"}], " ", "k"}], "+", "r0"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", "h"}], "-", 
      RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
   RowBox[{"beta", " ", 
    SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
  RowBox[{
   FractionBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
      RowBox[{"2", " ", "eta", " ", "g2"}], " ", "+", " ", 
      RowBox[{"3", " ", "k", " ", "g3"}], "-", 
      RowBox[{"g3", " ", "beta", "  ", "r0"}]}], ")"}], 
    RowBox[{"beta", " ", 
     SuperscriptBox["r", "2"], " ", "r0"}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{"r0", "-", 
        RowBox[{"g2", " ", "k"}]}], ")"}]}], "-", 
     RowBox[{"r0", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", "  ", "g2"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.778213579303982*^9, 3.778213586239513*^9}, {
  3.778213617223543*^9, 
  3.778213705503724*^9}},ExpressionUUID->"2dfbb8fc-779a-46e1-90de-\
9f8bca45f4e6"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Now", " ", "for", " ", "the", " ", "full", " ", 
    RowBox[{"numerator", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.778213898897059*^9, 3.778213908790308*^9}},
 CellLabel->
  "In[478]:=",ExpressionUUID->"fb6800f7-77d5-4772-be2b-16a90c8915c9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"g2", " ", 
     SuperscriptBox["r", "2"], " ", "r0"}], " ", "-", 
    RowBox[{"r", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "k"}], "+", "r0"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g1", " ", "h"}], "-", 
       RowBox[{"g2", " ", "r0"}]}], ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
       RowBox[{"2", " ", "eta", " ", "g2"}], " ", "+", " ", 
       RowBox[{"3", " ", "k", " ", "g3"}], "-", 
       RowBox[{"g3", " ", "beta", "  ", "r0"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"h", " ", 
        RowBox[{"(", 
         RowBox[{"r0", "-", 
          RowBox[{"g2", " ", "k"}]}], ")"}]}], "-", 
       RowBox[{"r0", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", "  ", "g2"}], "+", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}]}]}], " ", "/.", " ", 
   RowBox[{"h", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
     RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
  RowBox[{"r", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
    RowBox[{"k", " ", "g2"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7782139166543007`*^9, 3.778213946687977*^9}, {
  3.778213982034758*^9, 3.778213999878512*^9}},
 CellLabel->
  "In[481]:=",ExpressionUUID->"7916ad87-d953-4d74-9993-4dc4bfe85254"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g2", " ", "r0", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}], "2"]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g2"}], " ", "k"}], "+", "r0"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g2"}], " ", "r0"}], "+", 
     RowBox[{"g1", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", "g2"}], "+", 
        RowBox[{"g3", " ", "k"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
     RowBox[{"3", " ", "g3", " ", "k"}], "+", 
     RowBox[{"g1", " ", "r0"}], "-", 
     RowBox[{"beta", " ", "g3", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "r0"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", "g2"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "g2"}], " ", "k"}], "+", "r0"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", "g2"}], "+", 
        RowBox[{"g3", " ", "k"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.77821394768181*^9, 3.778214000189073*^9},
 CellLabel->
  "Out[481]=",ExpressionUUID->"6e3a304a-0981-45aa-9266-c47b6d90a206"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778213951118443*^9, 3.7782139671215754`*^9}},
 CellLabel->
  "In[482]:=",ExpressionUUID->"db3c11ba-dbed-4462-817d-8d4b20d326d2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SuperscriptBox["eta", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["g1", "2"], " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "3"]}]}], ")"}], " ", "k"}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", 
      SuperscriptBox["g2", "3"]}], "+", 
     RowBox[{
      SuperscriptBox["g1", "2"], " ", "g2", " ", "g3"}], "-", 
     RowBox[{"5", " ", 
      SuperscriptBox["g2", "2"], " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", 
      SuperscriptBox["g2", "2"], " ", "g3"}], "-", 
     RowBox[{"3", " ", "g2", " ", 
      SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
   SuperscriptBox["k", "3"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["g1", "3"], " ", "g2"}], "-", 
        RowBox[{"3", " ", "g1", " ", 
         SuperscriptBox["g2", "2"]}], "+", 
        RowBox[{"g0", " ", "g1", " ", 
         SuperscriptBox["g2", "2"]}], "-", 
        RowBox[{
         SuperscriptBox["g1", "2"], " ", "g3"}], "+", 
        RowBox[{"2", " ", "g2", " ", "g3"}], "+", 
        RowBox[{"beta", " ", 
         SuperscriptBox["g2", "2"], " ", "g3"}]}], ")"}], " ", "k"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["g1", "2"], " ", 
         SuperscriptBox["g2", "2"]}], "-", 
        RowBox[{"5", " ", "g1", " ", "g2", " ", "g3"}], "+", 
        RowBox[{"g0", " ", "g1", " ", "g2", " ", "g3"}], "+", 
        RowBox[{"3", " ", 
         SuperscriptBox["g3", "2"]}], "+", 
        RowBox[{"beta", " ", "g2", " ", 
         SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
      SuperscriptBox["k", "2"]}]}], ")"}], " ", "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["g1", "3"]}], "+", 
        RowBox[{"g1", " ", "g2"}], "+", 
        RowBox[{"g0", " ", "g1", " ", "g2"}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         SuperscriptBox["g1", "2"], " ", "g2"}], "+", 
        RowBox[{"g0", " ", 
         SuperscriptBox["g1", "2"], " ", "g2"}], "+", 
        SuperscriptBox["g2", "2"], "+", 
        RowBox[{"g0", " ", 
         SuperscriptBox["g2", "2"]}], "+", 
        RowBox[{"g1", " ", "g3"}], "-", 
        RowBox[{"g0", " ", "g1", " ", "g3"}], "+", 
        RowBox[{"beta", " ", "g1", " ", "g2", " ", "g3"}], "-", 
        RowBox[{"beta", " ", 
         SuperscriptBox["g3", "2"]}]}], ")"}], " ", "k"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g0"}], " ", 
      SuperscriptBox["g1", "2"]}], "+", 
     RowBox[{"g0", " ", "g2"}], "+", 
     RowBox[{
      SuperscriptBox["g0", "2"], " ", "g2"}]}], ")"}], " ", 
   SuperscriptBox["r0", "3"]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Now", " ", "see", " ", "if", " ", "we", " ", "can", " ", 
    RowBox[{"simplify", ":"}]}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.7782140127429934`*^9, 3.7782140207495127`*^9}},
 CellLabel->
  "In[483]:=",ExpressionUUID->"fbacd3a2-5ad5-442b-849a-6aa75ded4534"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", " ", "beta"}], " ", 
    SuperscriptBox["eta", "2"], " ", 
    SuperscriptBox["g2", "4"], " ", "k"}], "+", 
   RowBox[{"eta", " ", "g2", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", 
       SuperscriptBox["g2", "2"]}], "+", 
      RowBox[{
       SuperscriptBox["g1", "2"], "  ", "g3"}], "-", 
      RowBox[{"5", " ", "g2", " ", "g3"}]}], ")"}], " ", 
    SuperscriptBox["k", "2"]}], "-", 
   RowBox[{"g2", " ", "g3", " ", "h9", " ", 
    SuperscriptBox["k", "3"]}], "+", 
   RowBox[{"2", " ", "eta", " ", "r0", " ", "beta", " ", 
    SuperscriptBox["g2", "2"], 
    RowBox[{"(", 
     RowBox[{"g3", "-", 
      RowBox[{"g1", " ", "g2"}]}], ")"}], " ", "k"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", "g3"}], "-", 
      RowBox[{"g0", " ", "g3"}], "-", 
      RowBox[{"g1", " ", "g2"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"g3", "-", 
      RowBox[{"g1", " ", "g2"}]}], ")"}], "  ", "r0", " ", 
    SuperscriptBox["k", "2"]}], "+", 
   RowBox[{"beta", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", "g1", " ", "g3", " ", "g2"}], "-", 
      RowBox[{
       SuperscriptBox["g1", "2"], 
       SuperscriptBox["g2", "2"]}], "-", 
      SuperscriptBox["g3", "2"]}], ")"}], " ", "k", " ", 
    SuperscriptBox["r0", "2"]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Figure", " ", "out", " ", "which", " ", "term", " ", "has", " ", "the", 
    " ", 
    RowBox[{"error", ":"}]}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.7782140292858553`*^9, 3.778214130765011*^9}, {
  3.778214183815631*^9, 3.778214185089011*^9}, {3.778214225479495*^9, 
  3.778214539459255*^9}, {3.778214592981084*^9, 3.778214643563547*^9}, {
  3.778214677171994*^9, 3.778214925995639*^9}, {3.77821500958595*^9, 
  3.7782150126722717`*^9}, {3.778215080241185*^9, 3.778215312390628*^9}, {
  3.778215509749789*^9, 3.778215517676663*^9}},
 CellLabel->
  "In[492]:=",ExpressionUUID->"0ccb1371-003f-45f5-b53a-7103a687b4aa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.778215574676749*^9, 3.778215576627698*^9}},
 CellLabel->
  "In[496]:=",ExpressionUUID->"a5d5a9cf-0998-4ff2-a79a-876e30d85795"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.778215576900525*^9, 3.778215606723997*^9}},
 CellLabel->
  "Out[496]=",ExpressionUUID->"65caea14-bb94-425b-9cc4-a546f0f8e235"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                FractionBox[
                 RowBox[{"d", " "}], 
                 SuperscriptBox["r", "2"]], 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"c13", " ", "c2"}], "-", 
                  RowBox[{"r", " ", "c12"}]}], ")"}]}], "+", 
               FractionBox[
                RowBox[{"  ", 
                 RowBox[{
                  RowBox[{"c13", 
                   RowBox[{"(", " ", 
                    RowBox[{
                    RowBox[{"r0", " ", "g0"}], "-", 
                    RowBox[{"k", " ", "g2"}]}], ")"}]}], "-", 
                  RowBox[{"g2", " ", "r", " ", "r0"}]}]}], 
                RowBox[{"beta", " ", "r"}]], "-", 
               RowBox[{"2", " ", "h", " ", "c26"}], "+", " ", 
               RowBox[{
                SuperscriptBox["h", "2"], " ", "c25"}]}], ")"}], "/.", " ", 
             RowBox[{"h8", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
               RowBox[{"3", " ", "g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7781727591625223`*^9, 3.7781727764255466`*^9}, {
   3.7781728858844233`*^9, 3.778172888699259*^9}, 3.778173170933135*^9, {
   3.778173582031457*^9, 3.778173591292492*^9}, {3.778188834641397*^9, 
   3.7781888420249863`*^9}},
 CellLabel->
  "In[390]:=",ExpressionUUID->"ec2611cc-028e-401e-a44d-22450e0b4e40"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", "r0", " ", 
      SuperscriptBox["gamma", "4"]}], 
     RowBox[{"4", " ", 
      SuperscriptBox["beta", "2"]}]]}], "-", 
   FractionBox[
    RowBox[{"3", " ", "eta", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "7"}], " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"5", " ", "k", " ", "r0"}], "+", 
       RowBox[{"6", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"8", " ", 
     SuperscriptBox["beta", "3"], " ", "r0"}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["eta", "3"]}], "-", 
       RowBox[{"6", " ", "eta", " ", "k", " ", "r0"}], "+", 
       RowBox[{"9", " ", "beta", " ", "eta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"8", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "60"}], " ", 
        SuperscriptBox["eta", "2"], " ", "k"}], "+", 
       RowBox[{"150", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", "r0"}], "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["k", "2"], " ", "r0"}], "+", 
       RowBox[{"138", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"93", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "3"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"320", " ", 
     SuperscriptBox["beta", "4"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-3, 4] $CellContext`beta^(-2) $CellContext`r0, 
    Rational[-3, 2] $CellContext`beta^Rational[-5, 2] $CellContext`eta, 
    Rational[1, 
      8] $CellContext`beta^(-3) $CellContext`r0^(-1) ((-7) $CellContext`eta^2 - 
     5 $CellContext`k $CellContext`r0 + 
     6 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 8] $CellContext`beta^
     Rational[-7, 2] $CellContext`r0^(-2) (-$CellContext`eta^3 - 
     6 $CellContext`eta $CellContext`k $CellContext`r0 + 
     9 $CellContext`beta $CellContext`eta $CellContext`r0^2), 
    Rational[1, 
      320] $CellContext`beta^(-4) $CellContext`r0^(-2) ((-60) \
$CellContext`eta^2 $CellContext`k + 
     150 $CellContext`beta $CellContext`eta^2 $CellContext`r0 + 
     4 $CellContext`k^2 $CellContext`r0 + 
     138 $CellContext`beta $CellContext`k $CellContext`r0^2 - 
     93 $CellContext`beta^2 $CellContext`r0^3)}, 4, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.778172777951912*^9, 3.77817288909188*^9, 3.77817317590559*^9, {
   3.778173585026615*^9, 3.778173591856008*^9}, 3.778188815724368*^9},
 CellLabel->
  "Out[390]=",ExpressionUUID->"2cb8b7d9-0aea-4697-951c-a654d41111f1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                FractionBox[
                 RowBox[{"d", " ", "k"}], 
                 SuperscriptBox["r", "2"]], 
                RowBox[{"(", " ", 
                 RowBox[{
                  RowBox[{"r0", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", " ", "g2"}], " ", "-", " ", "g3"}], ")"}]}],
                   " ", "+", " ", 
                  RowBox[{"eta", " ", 
                   SuperscriptBox["g2", "2"]}], "+", 
                  RowBox[{"k", " ", "g2", " ", "g3"}]}], ")"}]}], "+", " ", 
               RowBox[{
                SuperscriptBox["h", "2"], " ", "c25"}], "-", 
               RowBox[{"2", " ", "h", " ", "c26"}], "+", 
               FractionBox[
                RowBox[{"  ", 
                 RowBox[{
                  RowBox[{"c13", 
                   RowBox[{"(", " ", 
                    RowBox[{
                    RowBox[{"r0", " ", "g0"}], "-", 
                    RowBox[{"k", " ", "g2"}]}], ")"}]}], "-", 
                  RowBox[{"g2", " ", "r", " ", "r0"}]}]}], 
                RowBox[{"beta", " ", "r"}]]}], ")"}], "/.", " ", 
             RowBox[{"h8", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
               RowBox[{"3", " ", "g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7781728049066973`*^9, 3.778172945285099*^9}, 
   3.778173079575227*^9, 3.778173337469146*^9, {3.7781734154042807`*^9, 
   3.7781734187470217`*^9}, {3.778173594933506*^9, 3.7781735952365017`*^9}, 
   3.778173638170175*^9, 3.778173680289288*^9, {3.778173830900127*^9, 
   3.778173854403961*^9}, 3.778173944043831*^9},
 CellLabel->
  "In[357]:=",ExpressionUUID->"bbdade29-5256-4845-8cf4-32ffe9d2bca1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", "r0", " ", 
      SuperscriptBox["gamma", "4"]}], 
     RowBox[{"4", " ", 
      SuperscriptBox["beta", "2"]}]]}], "-", 
   FractionBox[
    RowBox[{"3", " ", "eta", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "7"}], " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"5", " ", "k", " ", "r0"}], "+", 
       RowBox[{"6", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"8", " ", 
     SuperscriptBox["beta", "3"], " ", "r0"}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["eta", "3"]}], "-", 
       RowBox[{"6", " ", "eta", " ", "k", " ", "r0"}], "+", 
       RowBox[{"9", " ", "beta", " ", "eta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"8", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "60"}], " ", 
        SuperscriptBox["eta", "2"], " ", "k"}], "+", 
       RowBox[{"150", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", "r0"}], "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["k", "2"], " ", "r0"}], "+", 
       RowBox[{"138", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"93", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "3"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"320", " ", 
     SuperscriptBox["beta", "4"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-3, 4] $CellContext`beta^(-2) $CellContext`r0, 
    Rational[-3, 2] $CellContext`beta^Rational[-5, 2] $CellContext`eta, 
    Rational[1, 
      8] $CellContext`beta^(-3) $CellContext`r0^(-1) ((-7) $CellContext`eta^2 - 
     5 $CellContext`k $CellContext`r0 + 
     6 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 8] $CellContext`beta^
     Rational[-7, 2] $CellContext`r0^(-2) (-$CellContext`eta^3 - 
     6 $CellContext`eta $CellContext`k $CellContext`r0 + 
     9 $CellContext`beta $CellContext`eta $CellContext`r0^2), 
    Rational[1, 
      320] $CellContext`beta^(-4) $CellContext`r0^(-2) ((-60) \
$CellContext`eta^2 $CellContext`k + 
     150 $CellContext`beta $CellContext`eta^2 $CellContext`r0 + 
     4 $CellContext`k^2 $CellContext`r0 + 
     138 $CellContext`beta $CellContext`k $CellContext`r0^2 - 
     93 $CellContext`beta^2 $CellContext`r0^3)}, 4, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.778172815661537*^9, 3.778172823507174*^9}, {
   3.778172891390312*^9, 3.7781729237230053`*^9}, 3.778173082817911*^9, 
   3.778173338661997*^9, 3.7781734195576982`*^9, 3.7781735956473227`*^9, 
   3.778173945148135*^9},
 CellLabel->
  "Out[357]=",ExpressionUUID->"bf094a51-4297-4bfa-931c-a13050168150"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "The", " ", "only", " ", "term", " ", "we", " ", "need", " ", "to", " ", 
   "deal", " ", "with", " ", "is", " ", "the", " ", 
   RowBox[{"following", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7781729502812557`*^9, 3.778172961607698*^9}},
 CellLabel->
  "In[336]:=",ExpressionUUID->"8c35ff22-5a2b-4b00-90c0-f90e268f1d8b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"c13", " ", "c2"}], " ", "-", " ", 
  RowBox[{"r", " ", "c12"}]}]], "Input",
 CellChangeTimes->{{3.778172963432982*^9, 3.778172966535508*^9}},
 CellLabel->
  "In[337]:=",ExpressionUUID->"a21554cd-b753-485e-9edd-5a8f125b589b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "r"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g0", " ", "h"}], "-", 
     RowBox[{"g1", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "h"}], "-", 
     RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"g1", " ", 
      RowBox[{"(", 
       RowBox[{"k", "-", 
        RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.778172966903431*^9},
 CellLabel->
  "Out[337]=",ExpressionUUID->"df0ef154-bbd9-4325-9a03-0610c9ebed9e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
      RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
      RowBox[{"k", " ", "g2"}]}], ")"}]}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g0", " ", "h"}], "-", 
     RowBox[{"g1", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "h"}], "-", 
     RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"g1", " ", 
      RowBox[{"(", 
       RowBox[{"k", "-", 
        RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.77817298553896*^9, 3.7781729908146887`*^9}},
 CellLabel->
  "In[338]:=",ExpressionUUID->"8f7b2628-686f-4f38-a0c8-68d81e9152fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "eta"}], " ", "g1"}], "-", 
     RowBox[{"g2", " ", "k"}], "-", 
     RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g0", " ", "h"}], "-", 
     RowBox[{"g1", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "h"}], "-", 
     RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"g1", " ", 
      RowBox[{"(", 
       RowBox[{"k", "-", 
        RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7781729912127953`*^9},
 CellLabel->
  "Out[338]=",ExpressionUUID->"05df8f60-d82b-405b-aef5-79f08a53c5c1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778172994856638*^9, 3.778173000381027*^9}},
 CellLabel->
  "In[339]:=",ExpressionUUID->"fe0cebff-4666-431b-ab80-eadd9b8473b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["g1", "2"], " ", "h"}], "-", 
     RowBox[{"g0", " ", "g2", " ", "h"}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g1", "2"], "-", 
        RowBox[{"g0", " ", "g2"}]}], ")"}]}], "-", 
     RowBox[{
      SuperscriptBox["g0", "2"], " ", "h"}], "-", 
     RowBox[{"beta", " ", 
      SuperscriptBox["g1", "2"], " ", "h"}]}], ")"}], " ", "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g0", " ", "g1"}], "+", 
     RowBox[{"beta", " ", "g1", " ", "g2"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.778173000683037*^9},
 CellLabel->
  "Out[339]=",ExpressionUUID->"c5bc09e4-5f5a-4f99-99da-26465930bcc3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"g2", " ", "h", " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g2"}], "-", " ", "h"}], ")"}], " ", "r0"}], "+", 
  RowBox[{"g1", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{{3.778173013334499*^9, 3.778173072362358*^9}},
 CellLabel->
  "In[340]:=",ExpressionUUID->"e692f2e5-9b2d-4706-8396-cc750b9a84b9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g2", " ", "h", " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g2"}], "-", "h"}], ")"}], " ", "r0"}], "+", 
  RowBox[{"g1", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.77817307291671*^9},
 CellLabel->
  "Out[340]=",ExpressionUUID->"4d4f252a-5c51-4c59-aecc-7ce450584525"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"k", "  ", "h", " ", "g2"}], "-", 
   RowBox[{"r0", " ", "k", " ", "g3"}]}]}]], "Input",
 CellChangeTimes->{{3.778173199008346*^9, 3.778173318170405*^9}},
 CellLabel->
  "In[344]:=",ExpressionUUID->"e2309822-fd5a-44ca-ad77-1ec3cb11f985"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g2", " ", "h", " ", "k"}], "-", 
  RowBox[{"g3", " ", "k", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.778173319256689*^9},
 CellLabel->
  "Out[344]=",ExpressionUUID->"2ecb04ff-9e9f-454a-a0d8-fb570b2b9511"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.77817372931408*^9, 
  3.77817375557649*^9}},ExpressionUUID->"bb366d0b-cad3-4fc1-8760-\
d6be0ebd16fe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
      RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
      RowBox[{"k", " ", "g3"}]}], ")"}], " ", "g2"}], "-", 
   RowBox[{"r0", " ", "g3"}]}]}]], "Input",
 CellChangeTimes->{{3.7781737681534433`*^9, 3.7781738233747883`*^9}, {
  3.7781738700478067`*^9, 3.778173879845602*^9}, {3.778173928569251*^9, 
  3.7781739315588417`*^9}},ExpressionUUID->"175b75b2-dfb8-47b6-b296-\
fd2f4cd340af"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g3"}], " ", "k", " ", "r0"}], "+", 
  RowBox[{"g2", " ", "k", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g2"}], "+", 
     RowBox[{"g3", " ", "k"}], "+", 
     RowBox[{"g1", " ", "r0"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.778173870993775*^9, 3.778173880709008*^9}},
 CellLabel->
  "Out[355]=",ExpressionUUID->"3ce7923d-a7ce-4c41-8e36-fbb6ade41249"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"r0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "g2"}], " ", "-", " ", "g3"}], ")"}]}], " ", "+", " ", 
  RowBox[{"eta", " ", 
   SuperscriptBox["g2", "2"]}], "+", 
  RowBox[{"k", " ", "g2", " ", "g3"}]}]], "Input",
 CellChangeTimes->{{3.7781738876229553`*^9, 
  3.778173937405744*^9}},ExpressionUUID->"1b859a88-a678-418b-bcb2-\
537a09bda768"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", 
   SuperscriptBox["g2", "2"], " ", "k"}], "+", 
  RowBox[{"g2", " ", "g3", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "g2"}], "-", "g3"}], ")"}], " ", "k", " ", 
   "r0"}]}]], "Output",
 CellChangeTimes->{3.7781739110902243`*^9},
 CellLabel->
  "Out[356]=",ExpressionUUID->"9038c462-7d93-417c-a656-bd2567b040f2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Alright", ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
      "I", " ", "forgot", " ", "to", " ", "examine", " ", "the", " ", "c25"}],
       " ", "&"}], " ", "c26", " ", 
     RowBox[{"terms", ":"}]}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.778188851841853*^9, 3.778188861882832*^9}},
 CellLabel->
  "In[393]:=",ExpressionUUID->"49b6cb2a-fca5-490f-9dbf-2d46b7268514"],

Cell[BoxData[
 RowBox[{"Series", "[", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              FractionBox["1", "r0"], 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "g2"}], "-", 
                FractionBox[
                 RowBox[{" ", 
                  RowBox[{"k", " ", "g2"}]}], 
                 RowBox[{"beta", " ", "r0"}]], "-", 
                FractionBox[
                 RowBox[{" ", "c13"}], "r0"], "-", 
                FractionBox[
                 RowBox[{" ", 
                  RowBox[{"c12", " ", "c3"}]}], 
                 RowBox[{"r", " ", 
                  SuperscriptBox["r0", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"c13", " ", "c3", " ", "c2"}], 
                 RowBox[{
                  SuperscriptBox["r", "2"], " ", 
                  SuperscriptBox["r0", "2"]}]], "-", 
                FractionBox[
                 RowBox[{" ", 
                  RowBox[{"c13", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox["k", "2"], " ", "g2"}], "-", 
                    RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}]}], 
                 RowBox[{"beta", " ", "r", " ", 
                  SuperscriptBox["r0", "2"]}]]}], ")"}]}], "/.", " ", 
             RowBox[{"h8", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
               RowBox[{"3", " ", "g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778188872204482*^9, 3.7781888725961943`*^9}, {
  3.778188911699638*^9, 3.778188927354822*^9}},
 CellLabel->
  "In[395]:=",ExpressionUUID->"cb05ef87-f687-4105-ae64-a86c489eb2fa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              FractionBox["1", "r"], 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "g2"}], " ", "c12"}], "+", 
                FractionBox[
                 RowBox[{"g2", " ", "c13", " ", "c2"}], "r"], "-", 
                RowBox[{"g1", " ", "c13"}]}], ")"}]}], "/.", " ", 
             RowBox[{"h8", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
               RowBox[{"3", " ", "g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7781889397259912`*^9, 3.778189025275631*^9}},
 CellLabel->"",ExpressionUUID->"7eececec-f1c6-4a2e-88a8-e3630ab4fe37"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "3"], 
     RowBox[{"2", " ", 
      SuperscriptBox["beta", 
       RowBox[{"3", "/", "2"}]]}]]}], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "k"}], "+", 
       RowBox[{"beta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"8", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{"7", " ", 
     RowBox[{"(", 
      RowBox[{"eta", " ", "k"}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"24", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"80", " ", 
        SuperscriptBox["eta", "2"], " ", "k"}], "-", 
       RowBox[{"40", " ", 
        SuperscriptBox["k", "2"], " ", "r0"}], "+", 
       RowBox[{"28", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"3", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "3"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"240", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "60"}], " ", 
        SuperscriptBox["eta", "3"], " ", "k"}], "+", 
       RowBox[{"60", " ", "eta", " ", 
        SuperscriptBox["k", "2"], " ", "r0"}], "-", 
       RowBox[{"41", " ", "beta", " ", "eta", " ", "k", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"160", " ", 
     SuperscriptBox["beta", "4"], " ", 
     SuperscriptBox["r0", "4"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 2] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[1, 8] $CellContext`beta^Rational[-5, 2] $CellContext`r0^(-1) (
     2 $CellContext`k + $CellContext`beta $CellContext`r0), 
    Rational[-7, 
      24] $CellContext`beta^(-3) $CellContext`eta $CellContext`k \
$CellContext`r0^(-2), 
    Rational[1, 240] $CellContext`beta^Rational[-7, 2] $CellContext`r0^(-3) (
     80 $CellContext`eta^2 $CellContext`k - 
     40 $CellContext`k^2 $CellContext`r0 + 
     28 $CellContext`beta $CellContext`k $CellContext`r0^2 - 
     3 $CellContext`beta^2 $CellContext`r0^3), 
    Rational[1, 
      160] $CellContext`beta^(-4) $CellContext`r0^(-4) ((-60) \
$CellContext`eta^3 $CellContext`k + 
     60 $CellContext`eta $CellContext`k^2 $CellContext`r0 - 
     41 $CellContext`beta $CellContext`eta $CellContext`k $CellContext`r0^2)},
    3, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.778188942884647*^9, 3.778188983649951*^9}},
 CellLabel->
  "Out[401]=",ExpressionUUID->"fd12bd7c-59f3-4c34-87b8-3273c743752c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Look", " ", "at", " ", "the", " ", "entire", " ", "dv0", " ", 
    RowBox[{"term", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Series", "[", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                FractionBox[
                 RowBox[{"k", " ", "dv0"}], 
                 RowBox[{"r", " ", "r0"}]], " ", 
                RowBox[{"(", 
                 RowBox[{"v0", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    FractionBox[
                    RowBox[{"d", " "}], 
                    SuperscriptBox["r", "2"]], 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"c13", " ", "c2"}], "-", 
                    RowBox[{"r", " ", "c12"}]}], ")"}]}], "+", 
                    FractionBox[
                    RowBox[{"  ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "eta"}], " ", "g1", " ", 
                    SuperscriptBox["g2", "2"], " ", "k"}], "-", 
                    RowBox[{"g1", " ", "g2", " ", "g3", " ", 
                    SuperscriptBox["k", "2"]}], "-", " ", 
                    RowBox[{"r0", " ", "eta", " ", "beta", " ", "g1", " ", 
                    SuperscriptBox["g2", "2"]}], "-", 
                    RowBox[{"r0", " ", "k", " ", "g1", " ", "h2"}], "-", " ", 
                    
                    RowBox[{"beta", "  ", 
                    SuperscriptBox["g2", "2"], " ", "g0", " ", 
                    SuperscriptBox["r0", "2"]}]}]}], 
                    RowBox[{"beta", " ", "r"}]], "-", 
                    RowBox[{"2", " ", "h", " ", "c26"}], "+", " ", 
                    RowBox[{
                    SuperscriptBox["h", "2"], " ", "c25"}]}], ")"}]}], 
                 ")"}]}], "/.", " ", 
               RowBox[{"h8", " ", "\[Rule]", " ", 
                RowBox[{
                 RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
                 RowBox[{"3", " ", "g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
              RowBox[{"h6", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"2", 
                 SuperscriptBox["g2", "2"]}], "-", 
                RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
             RowBox[{"h2", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
               RowBox[{"g0", " ", "g3"}]}]}]}], "/.", " ", 
            RowBox[{"d", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"h", "+", 
                RowBox[{"eta", "*", "g2"}], "+", 
                RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
              "beta"}]}]}], "  ", "/.", " ", 
           RowBox[{"h", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
             RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
          RowBox[{"r", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
            RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
         RowBox[{"zeta", " ", "\[Rule]", " ", 
          RowBox[{"k", "-", 
           RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"1", "-", " ", 
          RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.778189600132634*^9, 3.778189607084148*^9}, {
  3.778189672325591*^9, 3.778189684223276*^9}, {3.778190325619419*^9, 
  3.7781903424942503`*^9}, {3.7781904085988617`*^9, 3.778190424614723*^9}},
 CellLabel->
  "In[427]:=",ExpressionUUID->"9f093520-a5d0-44f5-a9c2-20915b618a85"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", 
      RowBox[{"(", 
       RowBox[{"dv0", " ", "k", " ", "v0"}], ")"}], " ", 
      SuperscriptBox["gamma", "4"]}], 
     RowBox[{"4", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["beta", "2"], " ", "r0"}], ")"}]}]]}], "-", 
   FractionBox[
    RowBox[{"3", " ", 
     RowBox[{"(", 
      RowBox[{"dv0", " ", "eta", " ", "k", " ", "v0"}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"4", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"5", "/", "2"}]], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"dv0", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["eta", "2"], "+", 
         RowBox[{"2", " ", "k", " ", "r0"}], "-", 
         RowBox[{"3", " ", "beta", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}], " ", "v0"}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"8", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", 
       SuperscriptBox["r0", "3"]}], ")"}]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"dv0", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "k"}], "-", 
         RowBox[{"2", " ", "beta", " ", "eta", " ", "r0"}]}], ")"}], " ", 
       "v0"}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"8", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"7", "/", "2"}]], " ", 
       SuperscriptBox["r0", "3"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{"dv0", " ", "k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"10", " ", "beta", " ", 
        SuperscriptBox["eta", "2"]}], "+", 
       RowBox[{"44", " ", 
        SuperscriptBox["k", "2"]}], "+", 
       RowBox[{"28", " ", "beta", " ", "k", " ", "r0"}], "-", 
       RowBox[{"23", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", "v0", " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"320", " ", 
     SuperscriptBox["beta", "4"], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-3, 
      4] $CellContext`beta^(-2) $CellContext`dv0 $CellContext`k \
$CellContext`r0^(-1) $CellContext`v0, 
    Rational[-3, 4] $CellContext`beta^
     Rational[-5, 
       2] $CellContext`dv0 $CellContext`eta $CellContext`k \
$CellContext`r0^(-2) $CellContext`v0, 
    Rational[-1, 
      8] $CellContext`beta^(-3) $CellContext`dv0 $CellContext`k \
$CellContext`r0^(-3) ($CellContext`eta^2 + 2 $CellContext`k $CellContext`r0 - 
     3 $CellContext`beta $CellContext`r0^2) $CellContext`v0, 
    Rational[-1, 8] $CellContext`beta^
     Rational[-7, 
       2] $CellContext`dv0 $CellContext`k $CellContext`r0^(-3) \
($CellContext`eta $CellContext`k - 
     2 $CellContext`beta $CellContext`eta $CellContext`r0) $CellContext`v0, 
    Rational[1, 
      320] $CellContext`beta^(-4) $CellContext`dv0 $CellContext`k \
$CellContext`r0^(-3) (10 $CellContext`beta $CellContext`eta^2 + 
     44 $CellContext`k^2 + 
     28 $CellContext`beta $CellContext`k $CellContext`r0 - 
     23 $CellContext`beta^2 $CellContext`r0^2) $CellContext`v0}, 4, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.7781896850843353`*^9, {3.7781903275106697`*^9, 3.778190347093541*^9}, {
   3.778190409224766*^9, 3.77819043241212*^9}},
 CellLabel->
  "Out[427]=",ExpressionUUID->"1e32c2e0-6c15-4744-a662-bb7fe47a792a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              FractionBox[
               RowBox[{"k", " ", "dv0"}], 
               RowBox[{"r", " ", "r0"}]], " ", 
              RowBox[{"(", 
               RowBox[{"v0", " ", 
                RowBox[{"(", 
                 FractionBox[
                  RowBox[{"  ", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", " ", "h"}], "-", 
                    RowBox[{"g2", " ", "r0"}]}], ")"}], 
                    RowBox[{"(", " ", 
                    RowBox[{
                    RowBox[{"r0", " ", "g0"}], "-", 
                    RowBox[{"k", " ", "g2"}]}], ")"}]}], "-", 
                    RowBox[{"g2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g0", " ", "r0"}], " ", "+", " ", 
                    RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
                    RowBox[{"k", " ", "g2"}]}], ")"}], " ", "r0"}]}]}], 
                  RowBox[{"beta", " ", "r"}]], ")"}]}], ")"}]}], "/.", " ", 
             RowBox[{"h8", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
               RowBox[{"3", " ", "g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778189708110195*^9, 3.7781898072723827`*^9}, {
  3.778189911839732*^9, 3.778189922828917*^9}},
 CellLabel->
  "In[419]:=",ExpressionUUID->"d1581ea5-d0e0-4e6e-a2f1-58488dcbe9a1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"dv0", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"4", " ", "k"}], "+", 
          RowBox[{"3", " ", "beta", " ", "r0"}]}], ")"}], " ", "v0"}], ")"}], 
      " ", 
      SuperscriptBox["gamma", "4"]}], 
     RowBox[{"12", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["beta", "3"], " ", 
        SuperscriptBox["r0", "2"]}], ")"}]}]]}], "+", 
   FractionBox[
    RowBox[{"dv0", " ", "eta", " ", "k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"5", " ", "k"}], "+", 
       RowBox[{"3", " ", "beta", " ", "r0"}]}], ")"}], " ", "v0", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"12", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "3"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"dv0", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"90", " ", 
          SuperscriptBox["eta", "2"], " ", "k"}], "+", 
         RowBox[{"45", " ", "beta", " ", 
          SuperscriptBox["eta", "2"], " ", "r0"}], "-", 
         RowBox[{"45", " ", 
          SuperscriptBox["k", "2"], " ", "r0"}], "-", 
         RowBox[{"beta", " ", "k", " ", 
          SuperscriptBox["r0", "2"]}], "+", 
         RowBox[{"15", " ", 
          SuperscriptBox["beta", "2"], " ", 
          SuperscriptBox["r0", "3"]}]}], ")"}], " ", "v0"}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"180", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "4"], " ", 
       SuperscriptBox["r0", "4"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{"dv0", " ", "eta", " ", "k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"105", " ", 
        SuperscriptBox["eta", "2"], " ", "k"}], "+", 
       RowBox[{"45", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", "r0"}], "-", 
       RowBox[{"105", " ", 
        SuperscriptBox["k", "2"], " ", "r0"}], "+", 
       RowBox[{"8", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{"30", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "3"]}]}], ")"}], " ", "v0", " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"180", " ", 
     SuperscriptBox["beta", 
      RowBox[{"9", "/", "2"}]], " ", 
     SuperscriptBox["r0", "5"]}]], "-", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"6720", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["beta", "5"], " ", 
        SuperscriptBox["r0", "6"]}], ")"}]}]], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"dv0", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"4480", " ", 
          SuperscriptBox["eta", "4"], " ", "k"}], "+", 
         RowBox[{"1680", " ", "beta", " ", 
          SuperscriptBox["eta", "4"], " ", "r0"}], "-", 
         RowBox[{"6720", " ", 
          SuperscriptBox["eta", "2"], " ", 
          SuperscriptBox["k", "2"], " ", "r0"}], "+", 
         RowBox[{"1008", " ", "beta", " ", 
          SuperscriptBox["eta", "2"], " ", "k", " ", 
          SuperscriptBox["r0", "2"]}], "+", 
         RowBox[{"1120", " ", 
          SuperscriptBox["k", "3"], " ", 
          SuperscriptBox["r0", "2"]}], "+", 
         RowBox[{"1680", " ", 
          SuperscriptBox["beta", "2"], " ", 
          SuperscriptBox["eta", "2"], " ", 
          SuperscriptBox["r0", "3"]}], "-", 
         RowBox[{"924", " ", "beta", " ", 
          SuperscriptBox["k", "2"], " ", 
          SuperscriptBox["r0", "3"]}], "-", 
         RowBox[{"300", " ", 
          SuperscriptBox["beta", "2"], " ", "k", " ", 
          SuperscriptBox["r0", "4"]}], "+", 
         RowBox[{"231", " ", 
          SuperscriptBox["beta", "3"], " ", 
          SuperscriptBox["r0", "5"]}]}], ")"}], " ", "v0"}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 
      12] $CellContext`beta^(-3) $CellContext`dv0 $CellContext`k \
$CellContext`r0^(-2) (4 $CellContext`k + 
     3 $CellContext`beta $CellContext`r0) $CellContext`v0, 
    Rational[1, 12] $CellContext`beta^
     Rational[-7, 
       2] $CellContext`dv0 $CellContext`eta $CellContext`k \
$CellContext`r0^(-3) (5 $CellContext`k + 
     3 $CellContext`beta $CellContext`r0) $CellContext`v0, 
    Rational[-1, 
      180] $CellContext`beta^(-4) $CellContext`dv0 $CellContext`k \
$CellContext`r0^(-4) (90 $CellContext`eta^2 $CellContext`k + 
     45 $CellContext`beta $CellContext`eta^2 $CellContext`r0 - 
     45 $CellContext`k^2 $CellContext`r0 - $CellContext`beta $CellContext`k \
$CellContext`r0^2 + 15 $CellContext`beta^2 $CellContext`r0^3) $CellContext`v0,
     Rational[1, 180] $CellContext`beta^
     Rational[-9, 
       2] $CellContext`dv0 $CellContext`eta $CellContext`k \
$CellContext`r0^(-5) (105 $CellContext`eta^2 $CellContext`k + 
     45 $CellContext`beta $CellContext`eta^2 $CellContext`r0 - 
     105 $CellContext`k^2 $CellContext`r0 + 
     8 $CellContext`beta $CellContext`k $CellContext`r0^2 + 
     30 $CellContext`beta^2 $CellContext`r0^3) $CellContext`v0, 
    Rational[-1, 
      6720] $CellContext`beta^(-5) $CellContext`dv0 $CellContext`k \
$CellContext`r0^(-6) (4480 $CellContext`eta^4 $CellContext`k + 
     1680 $CellContext`beta $CellContext`eta^4 $CellContext`r0 - 
     6720 $CellContext`eta^2 $CellContext`k^2 $CellContext`r0 + 
     1008 $CellContext`beta $CellContext`eta^2 $CellContext`k \
$CellContext`r0^2 + 1120 $CellContext`k^3 $CellContext`r0^2 + 
     1680 $CellContext`beta^2 $CellContext`eta^2 $CellContext`r0^3 - 
     924 $CellContext`beta $CellContext`k^2 $CellContext`r0^3 - 
     300 $CellContext`beta^2 $CellContext`k $CellContext`r0^4 + 
     231 $CellContext`beta^3 $CellContext`r0^5) $CellContext`v0}, 4, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.778189708656494*^9, 3.7781897363658113`*^9}, {
   3.778189783392115*^9, 3.778189808397991*^9}, 3.778189923722879*^9},
 CellLabel->
  "Out[419]=",ExpressionUUID->"2c932030-b0bc-4b2e-8e6d-7cc324ea180d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Ahhh", "..."}], "  ", "I", " ", "think", " ", "I", " ", "need", 
   " ", "to", " ", "deal", " ", "with", " ", "numerator", " ", "of", " ", 
   "second", " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.778189861261188*^9, 3.778189873283093*^9}},
 CellLabel->
  "In[416]:=",ExpressionUUID->"7fff66a2-46f7-43e2-9cb1-bb66bfa47d38"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", "h"}], "-", 
      RowBox[{"g2", " ", "r0"}]}], ")"}], 
    RowBox[{"(", " ", 
     RowBox[{
      RowBox[{"r0", " ", "g0"}], "-", 
      RowBox[{"k", " ", "g2"}]}], ")"}]}], "-", 
   RowBox[{"g2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g0", " ", "r0"}], " ", "+", " ", 
      RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
      RowBox[{"k", " ", "g2"}]}], ")"}], " ", "r0"}]}], "/.", " ", 
  RowBox[{"h", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
    RowBox[{"k", " ", "g3", " "}]}]}]}]], "Input",
 CellChangeTimes->{3.778189942022944*^9},
 CellLabel->
  "In[420]:=",ExpressionUUID->"64d1b526-75e9-46a1-81e6-e98de13776cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g2"}], " ", "r0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g2"}], " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g2"}], " ", "r0"}], "+", 
     RowBox[{"g1", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", "g2"}], "+", 
        RowBox[{"g3", " ", "k"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.778189883419159*^9, 3.7781899426049347`*^9},
 CellLabel->
  "Out[420]=",ExpressionUUID->"327952b8-12dd-4ec2-9bb1-cd3b7d8396e7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778189950114704*^9, 3.778189954538486*^9}},
 CellLabel->
  "In[422]:=",ExpressionUUID->"a4f601cc-83df-4383-bd96-ffaf05737492"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "eta"}], " ", "g1", " ", 
   SuperscriptBox["g2", "2"], " ", "k"}], "-", 
  RowBox[{"g1", " ", "g2", " ", "g3", " ", 
   SuperscriptBox["k", "2"]}], "-", " ", 
  RowBox[{"r0", " ", "eta", " ", "beta", " ", "g1", " ", 
   SuperscriptBox["g2", "2"]}], "-", 
  RowBox[{"r0", " ", "k", " ", "g1", " ", "h2"}], "-", " ", 
  RowBox[{"beta", "  ", 
   SuperscriptBox["g2", "2"], " ", "g0", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{{3.778189965931356*^9, 3.778190022994602*^9}, {
  3.778190120184883*^9, 
  3.77819017827598*^9}},ExpressionUUID->"c0ab5592-90ec-4c18-9781-\
456cd09f2c85"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Weird", "..."}], " ", "not", " ", "sure", " ", "why", " ", "new",
     " ", "expression", " ", 
    RowBox[{"isn", "'"}], "t", " ", "working", " ", 
    RowBox[{"well", ".", " ", "See"}], " ", "if", " ", "it", " ", "has", " ", 
    "an", " ", 
    RowBox[{"error", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.778190545186977*^9, 3.778190562245001*^9}},
 CellLabel->
  "In[428]:=",ExpressionUUID->"6ce964b6-c758-47ce-8b24-b6fdfbe97580"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"d", "*", 
               RowBox[{"k", "/", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"r", "^", "3"}], "*", "r0"}], ")"}]}], "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"c13", "*", "c2"}], "-", 
                 RowBox[{"r", "*", "c12"}]}], ")"}]}], "+", 
              RowBox[{"k", "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"c13", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"r0", "*", "g0"}], "-", 
                    RowBox[{"k", "*", "g2"}]}], ")"}]}], "-", 
                  RowBox[{"g2", "*", "r", "*", "r0"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{"beta", "*", 
                  RowBox[{"r", "^", "2"}], "*", "r0"}], ")"}]}]}], "-", 
              RowBox[{"2", "*", "h", "*", "c26"}], "+", 
              RowBox[{
               RowBox[{"h", "^", "2"}], "*", "c25"}]}], " ", "/.", " ", 
             RowBox[{"h8", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
               RowBox[{"3", " ", "g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7781905744263573`*^9, 3.778190613953125*^9}},
 CellLabel->
  "In[429]:=",ExpressionUUID->"adc22187-9df5-4b69-a33b-d994e8e309a5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "k"}], "-", 
       RowBox[{"2", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "2"], " ", "r0"}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "k"}], "-", 
       RowBox[{"6", " ", "eta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "6"}], " ", 
        SuperscriptBox["eta", "2"], " ", "k"}], "+", 
       RowBox[{"8", " ", 
        SuperscriptBox["k", "2"], " ", "r0"}], "-", 
       RowBox[{"21", " ", 
        SuperscriptBox["eta", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"2", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"20", " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "+", 
       RowBox[{"17", " ", "beta", " ", 
        SuperscriptBox["r0", "4"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"6", " ", 
        SuperscriptBox["eta", "3"], " ", "k"}], "-", 
       RowBox[{"15", " ", "eta", " ", 
        SuperscriptBox["k", "2"], " ", "r0"}], "-", 
       RowBox[{"3", " ", 
        SuperscriptBox["eta", "3"], " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{"4", " ", "beta", " ", "eta", " ", "k", " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"14", " ", "eta", " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "+", 
       RowBox[{"27", " ", "beta", " ", "eta", " ", 
        SuperscriptBox["r0", "4"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "4"]}]], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"960", " ", 
      SuperscriptBox["beta", "4"], " ", 
      SuperscriptBox["r0", "5"]}]], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "240"}], " ", 
        SuperscriptBox["eta", "4"], " ", "k"}], "+", 
       RowBox[{"900", " ", 
        SuperscriptBox["eta", "2"], " ", 
        SuperscriptBox["k", "2"], " ", "r0"}], "-", 
       RowBox[{"240", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", "k", " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"268", " ", 
        SuperscriptBox["k", "3"], " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"360", " ", 
        SuperscriptBox["eta", "2"], " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "+", 
       RowBox[{"268", " ", "beta", " ", 
        SuperscriptBox["k", "2"], " ", 
        SuperscriptBox["r0", "3"]}], "+", 
       RowBox[{"450", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", 
        SuperscriptBox["r0", "4"]}], "-", 
       RowBox[{"33", " ", 
        SuperscriptBox["beta", "2"], " ", "k", " ", 
        SuperscriptBox["r0", "4"]}], "+", 
       RowBox[{"120", " ", 
        SuperscriptBox["k", "2"], " ", 
        SuperscriptBox["r0", "4"]}], "+", 
       RowBox[{"336", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "5"]}], "-", 
       RowBox[{"276", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "6"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 
      4] $CellContext`beta^(-2) $CellContext`r0^(-1) (-$CellContext`k - 
     2 $CellContext`r0^2), 
    Rational[1, 4] $CellContext`beta^
     Rational[-5, 2] $CellContext`r0^(-2) ($CellContext`eta $CellContext`k - 
     6 $CellContext`eta $CellContext`r0^2), 
    Rational[1, 
      24] $CellContext`beta^(-3) $CellContext`r0^(-3) ((-6) \
$CellContext`eta^2 $CellContext`k + 8 $CellContext`k^2 $CellContext`r0 - 
     21 $CellContext`eta^2 $CellContext`r0^2 - 
     2 $CellContext`beta $CellContext`k $CellContext`r0^2 - 
     20 $CellContext`k $CellContext`r0^3 + 
     17 $CellContext`beta $CellContext`r0^4), 
    Rational[1, 24] $CellContext`beta^Rational[-7, 2] $CellContext`r0^(-4) (
     6 $CellContext`eta^3 $CellContext`k - 
     15 $CellContext`eta $CellContext`k^2 $CellContext`r0 - 
     3 $CellContext`eta^3 $CellContext`r0^2 + 
     4 $CellContext`beta $CellContext`eta $CellContext`k $CellContext`r0^2 - 
     14 $CellContext`eta $CellContext`k $CellContext`r0^3 + 
     27 $CellContext`beta $CellContext`eta $CellContext`r0^4), 
    Rational[1, 
      960] $CellContext`beta^(-4) $CellContext`r0^(-5) ((-240) \
$CellContext`eta^4 $CellContext`k + 
     900 $CellContext`eta^2 $CellContext`k^2 $CellContext`r0 - 
     240 $CellContext`beta $CellContext`eta^2 $CellContext`k \
$CellContext`r0^2 - 268 $CellContext`k^3 $CellContext`r0^2 - 
     360 $CellContext`eta^2 $CellContext`k $CellContext`r0^3 + 
     268 $CellContext`beta $CellContext`k^2 $CellContext`r0^3 + 
     450 $CellContext`beta $CellContext`eta^2 $CellContext`r0^4 - 
     33 $CellContext`beta^2 $CellContext`k $CellContext`r0^4 + 
     120 $CellContext`k^2 $CellContext`r0^4 + 
     336 $CellContext`beta $CellContext`k $CellContext`r0^5 - 
     276 $CellContext`beta^2 $CellContext`r0^6)}, 4, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.778190614830577*^9},
 CellLabel->
  "Out[429]=",ExpressionUUID->"5789ba20-758b-4a6c-b893-4cd96c813902"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"d", "*", 
                RowBox[{"k", "/", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"r", "^", "3"}], "*", "r0"}], ")"}]}], "*", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"c13", "*", "c2"}], "-", 
                  RowBox[{"r", "*", "c12"}]}], ")"}]}], "+", 
               RowBox[{"k", "*", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"c13", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"r0", "*", "g0"}], "-", 
                    RowBox[{"k", "*", "g2"}]}], ")"}]}], "-", 
                   RowBox[{"g2", "*", "r", "*", "r0"}]}], ")"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"beta", "*", 
                   RowBox[{"r", "^", "2"}], "*", "r0"}], ")"}]}]}], "-", 
               RowBox[{"2", "*", "h", "*", "c26"}], "+", 
               RowBox[{
                RowBox[{"h", "^", "2"}], "*", "c25"}], "-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", 
                  RowBox[{"k", "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"r", "^", "3"}], "*", "r0"}], ")"}]}], "*", "k", 
                  "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"r0", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", "*", "g2"}], "-", "g3"}], ")"}]}], "+", 
                    RowBox[{"eta", "*", 
                    RowBox[{"g2", "^", "2"}]}], "+", 
                    RowBox[{"k", "*", "g2", "*", "g3"}]}], ")"}]}], "+", 
                 RowBox[{"k", "*", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "eta"}], "*", "k", "*", "g1", "*", 
                    RowBox[{"g2", "^", "2"}]}], "-", 
                    RowBox[{"g1", "*", "g2", "*", "g3", "*", 
                    RowBox[{"k", "^", "2"}]}], "-", 
                    RowBox[{"r0", "*", "eta", "*", "beta", "*", "g1", "*", 
                    RowBox[{"g2", "^", "2"}]}], "-", 
                    RowBox[{"r0", "*", "k", "*", "g1", "*", "h2"}], "-", " ", 
                    
                    RowBox[{"beta", "*", 
                    RowBox[{"g2", "^", "2"}], "*", "g0", "*", 
                    RowBox[{"r0", "^", "2"}]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"beta", "*", 
                    RowBox[{"r", "^", "2"}], "*", "r0"}], ")"}]}]}], "-", 
                 RowBox[{"2", "*", "h", "*", "c26"}], "+", 
                 RowBox[{
                  RowBox[{"h", "^", "2"}], "*", "c25"}]}], ")"}]}], "\n", "/.",
               " ", 
              RowBox[{"h8", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
                RowBox[{"3", " ", "g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
             RowBox[{"h2", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
               RowBox[{"g0", " ", "g3"}]}]}]}], "/.", " ", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "12"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778190644517967*^9, 3.77819070981555*^9}, {
  3.7781921162972393`*^9, 3.778192152774405*^9}},
 CellLabel->
  "In[435]:=",ExpressionUUID->"a97ad1e4-6c64-49c4-99cd-a135361e4c9a"],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", "gamma", "]"}], "13"],
  SeriesData[$CellContext`gamma, 0, {}, 13, 13, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.778190678890704*^9, 3.77819071018626*^9, {3.778192128639983*^9, 
   3.778192153387786*^9}},
 CellLabel->
  "Out[435]=",ExpressionUUID->"638bafd9-36ac-4621-9ed2-809b61b6d16e"]
}, Open  ]]
},
WindowSize->{1097, 606},
WindowMargins->{{13, Automatic}, {Automatic, 103}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 2538, 64, 220, "Input",ExpressionUUID->"53329b6c-a80c-45ac-ae62-f6fb243392bd"],
Cell[CellGroupData[{
Cell[3121, 88, 1280, 33, 50, "Input",ExpressionUUID->"b55f3b19-1b6b-49b6-9b71-fd1ea829ac9b"],
Cell[4404, 123, 941, 28, 68, "Output",ExpressionUUID->"378db069-cd51-4eb3-8da1-e0fadf714dda"]
}, Open  ]],
Cell[5360, 154, 305, 6, 30, "Input",ExpressionUUID->"afacd7f7-dfe4-40dc-8f60-4ae14d5e9d79"],
Cell[CellGroupData[{
Cell[5690, 164, 1532, 45, 91, "Input",ExpressionUUID->"ec64950c-8ed3-4bc5-92a5-293069313a0b"],
Cell[7225, 211, 2043, 66, 113, "Output",ExpressionUUID->"d6f8e9c8-0e25-45e6-bcac-3d730d6a9115"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9305, 282, 503, 12, 30, "Input",ExpressionUUID->"95296aac-8480-48bf-b720-90060933f9ed"],
Cell[9811, 296, 379, 9, 53, "Output",ExpressionUUID->"90d5d5e6-44b6-41c8-9744-68f6f7ea0ed1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10227, 310, 276, 5, 30, "Input",ExpressionUUID->"6e130959-e5af-4389-aed5-d86ced425512"],
Cell[10506, 317, 217, 4, 52, "Output",ExpressionUUID->"36f339f8-d78f-400f-af3f-07113ec3dda2"]
}, Open  ]],
Cell[10738, 324, 436, 12, 52, "Input",ExpressionUUID->"db7adf01-a7ab-46c1-a1a8-4d1abacc17e0"],
Cell[CellGroupData[{
Cell[11199, 340, 1581, 45, 51, "Input",ExpressionUUID->"16859656-b551-41b8-8148-c43961c8e68f"],
Cell[12783, 387, 4811, 141, 272, "Output",ExpressionUUID->"b9cc61d5-41eb-4299-a35b-f63b8b0aa8ca"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17631, 533, 575, 11, 30, "Input",ExpressionUUID->"c9449310-0549-409c-8d84-122d3e9eb019"],
Cell[18209, 546, 7585, 239, 391, "Output",ExpressionUUID->"718091bc-05b7-483c-8485-9abedbcd0273"]
}, Open  ]],
Cell[25809, 788, 377, 9, 30, "Input",ExpressionUUID->"78dbf34d-7636-4bda-8c1a-993c8f7bf42f"],
Cell[CellGroupData[{
Cell[26211, 801, 3126, 96, 188, "Input",ExpressionUUID->"96ddbaed-9cd8-4c12-a9c8-06525d3abe90"],
Cell[29340, 899, 3443, 110, 166, "Output",ExpressionUUID->"c32c2bce-9af2-4341-a712-1e8eb81232dc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32820, 1014, 2324, 70, 151, "Input",ExpressionUUID->"6c206a31-2c86-461c-8c14-d78a4dfdf157"],
Cell[35147, 1086, 2543, 80, 110, "Output",ExpressionUUID->"c9cc91e7-3194-447f-ad5a-1743ca093372"]
}, Open  ]],
Cell[37705, 1169, 841, 22, 52, "Input",ExpressionUUID->"48e0a9bb-0e03-4980-a9fa-2d51e48ea77e"],
Cell[CellGroupData[{
Cell[38571, 1195, 13806, 405, 664, "Input",ExpressionUUID->"f786cdbb-b924-4eb2-838b-2dc638305375"],
Cell[52380, 1602, 13234, 405, 618, "Output",ExpressionUUID->"9b200416-b8e4-40b9-b112-dc4144f04150"]
}, Open  ]],
Cell[CellGroupData[{
Cell[65651, 2012, 484, 10, 30, "Input",ExpressionUUID->"a2953db8-00f4-416e-aad9-2cacfd70dbaa"],
Cell[66138, 2024, 17228, 514, 730, "Output",ExpressionUUID->"438872e2-8c39-460c-a00f-7e0eb6f2d162"]
}, Open  ]],
Cell[83381, 2541, 288, 7, 30, "Input",ExpressionUUID->"9260977b-b0de-461c-996a-71c3b228e64d"],
Cell[CellGroupData[{
Cell[83694, 2552, 4129, 120, 187, "Input",ExpressionUUID->"95eab631-9a82-4215-a749-57272e016382"],
Cell[87826, 2674, 6031, 185, 236, "Output",ExpressionUUID->"62de25df-488a-41db-b534-8fcb55eaa53f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93894, 2864, 7599, 209, 318, "Input",ExpressionUUID->"2564f2f9-eac0-4d13-8f0e-36dad0184aae"],
Cell[101496, 3075, 8732, 262, 294, "Output",ExpressionUUID->"385d804f-fd79-4a9d-95c9-9312932815a3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[110265, 3342, 22816, 646, 1141, "Input",ExpressionUUID->"130b5757-e946-4425-9ade-8ac37a9eecd0"],
Cell[133084, 3990, 22112, 646, 805, "Output",ExpressionUUID->"755920af-fe01-4a9c-b483-3c03e8f68e49"]
}, Open  ]],
Cell[155211, 4639, 263, 5, 30, "Input",ExpressionUUID->"22aa7730-d16c-4517-8167-2f0fe6f1fa6f"],
Cell[CellGroupData[{
Cell[155499, 4648, 22768, 645, 1141, "Input",ExpressionUUID->"50d4eff4-5266-4b0e-90a6-fbbdba0ecbcc"],
Cell[178270, 5295, 22112, 646, 805, "Output",ExpressionUUID->"0cd0a4ff-c124-418c-9c5e-0ee997d7812e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[200419, 5946, 225, 3, 30, "Input",ExpressionUUID->"b835859b-58e3-4e24-b96e-4689972511d3"],
Cell[200647, 5951, 170, 2, 34, "Output",ExpressionUUID->"33a207a4-2e3e-4e83-9e4c-e5c5e656a4f6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[200854, 5958, 206, 3, 30, "Input",ExpressionUUID->"c7d41539-34f6-41b2-9684-c33cee6475f5"],
Cell[201063, 5963, 151, 2, 34, "Output",ExpressionUUID->"ed6829f5-8af3-43f7-b776-7a2058e8d1fb"]
}, Open  ]],
Cell[201229, 5968, 374, 6, 30, "Input",ExpressionUUID->"09f05ab5-fb26-4fb3-8d38-faed241e3432"],
Cell[201606, 5976, 399, 8, 30, "Input",ExpressionUUID->"2119f5f3-760c-487a-9160-ca0c499ad8ce"],
Cell[CellGroupData[{
Cell[202030, 5988, 2912, 82, 266, "Input",ExpressionUUID->"bfcce50b-4714-45f1-9486-ecb8ca0f6248"],
Cell[204945, 6072, 604, 11, 34, "Output",ExpressionUUID->"2160108a-75fd-45b7-a2c9-e6007a66fd2d"],
Cell[205552, 6085, 710, 15, 34, "Output",ExpressionUUID->"85e10364-8be7-4525-b6fd-5ce54fb7018d"],
Cell[206265, 6102, 652, 13, 34, "Output",ExpressionUUID->"25d8f56d-fc24-4fe4-9add-32f950800745"],
Cell[206920, 6117, 628, 12, 34, "Output",ExpressionUUID->"79634ba9-c6d8-43f1-978a-aa247fdfcc06"],
Cell[207551, 6131, 628, 12, 34, "Output",ExpressionUUID->"a3ad9f1e-984f-4710-be5e-7dd32df11656"],
Cell[208182, 6145, 633, 12, 34, "Output",ExpressionUUID->"484d090e-01eb-4516-bcbc-f34e580fde42"],
Cell[208818, 6159, 638, 12, 34, "Output",ExpressionUUID->"bed097ae-a981-491b-a27f-bbf6366c7ac9"],
Cell[209459, 6173, 2264, 69, 67, "Output",ExpressionUUID->"b52cc112-120f-4735-ae3a-f2f7e9eddaa8"],
Cell[211726, 6244, 1276, 36, 58, "Output",ExpressionUUID->"7ba24f98-c78e-4fb5-a9ef-cfd8b4959cdc"]
}, Open  ]],
Cell[213017, 6283, 7099, 205, 150, "Input",ExpressionUUID->"8cf6c5b4-2f61-4490-ad60-eb4d417594d0"],
Cell[220119, 6490, 483, 11, 30, "Input",ExpressionUUID->"73089f60-413f-4e22-8f27-54e5e6f9cb65"],
Cell[CellGroupData[{
Cell[220627, 6505, 212, 4, 30, "Input",ExpressionUUID->"141f92bf-29f7-46e2-829f-ca31ddbab7b7"],
Cell[220842, 6511, 489, 8, 34, "Output",ExpressionUUID->"74fe83e8-1009-4218-91a0-403d964535f6"]
}, Open  ]],
Cell[221346, 6522, 324, 7, 30, "Input",ExpressionUUID->"128b1f6c-5ecc-47f1-a3c7-dfff0a3c4d7a"],
Cell[CellGroupData[{
Cell[221695, 6533, 3726, 95, 149, "Input",ExpressionUUID->"1e782768-a448-4981-8777-838eddd2d72a"],
Cell[225424, 6630, 1829, 51, 62, "Output",ExpressionUUID->"a7d56cd7-829a-4960-87e5-20369deabac0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[227290, 6686, 6882, 162, 238, InheritFromParent,ExpressionUUID->"764d6ffe-2f26-47a5-8a0b-451884ef392b"],
Cell[234175, 6850, 478, 11, 34, "Output",ExpressionUUID->"c30e0654-7e5d-41dc-87e2-9674d3f0e889"]
}, Open  ]],
Cell[234668, 6864, 358, 8, 30, "Input",ExpressionUUID->"b1792c88-8a5d-4d76-92b4-424cea5d9324"],
Cell[235029, 6874, 801, 29, 49, "Input",ExpressionUUID->"4e646826-0903-44d4-a8ba-659e54a3d17d"],
Cell[235833, 6905, 1514, 51, 52, InheritFromParent,ExpressionUUID->"509cdcb4-a2cd-4892-941f-e7b12f974532"],
Cell[237350, 6958, 451, 10, 52, "Input",ExpressionUUID->"b2de240f-789f-4681-a3ca-8c03d626e8f9"],
Cell[237804, 6970, 478, 11, 30, InheritFromParent,ExpressionUUID->"4d60c59a-8ea9-41ad-8aa8-8faff17196a3"],
Cell[CellGroupData[{
Cell[238307, 6985, 1077, 32, 52, "Input",ExpressionUUID->"0b62a6bb-3fd8-4bba-a487-a3f9dd5f7317"],
Cell[239387, 7019, 728, 24, 34, "Output",ExpressionUUID->"0b9fd9d1-1256-466b-9720-4519133df273"]
}, Open  ]],
Cell[240130, 7046, 299, 7, 30, "Input",ExpressionUUID->"a5edfc4e-4139-4670-964f-ecc0c19301d9"],
Cell[240432, 7055, 607, 16, 52, InheritFromParent,ExpressionUUID->"84121ccc-d44d-4bda-8e90-74c0a75f3330"],
Cell[241042, 7073, 1355, 43, 52, InheritFromParent,ExpressionUUID->"2dfbb8fc-779a-46e1-90de-9f8bca45f4e6"],
Cell[242400, 7118, 337, 7, 52, "Input",ExpressionUUID->"fb6800f7-77d5-4772-be2b-16a90c8915c9"],
Cell[CellGroupData[{
Cell[242762, 7129, 1590, 46, 52, "Input",ExpressionUUID->"7916ad87-d953-4d74-9993-4dc4bfe85254"],
Cell[244355, 7177, 1721, 56, 56, "Output",ExpressionUUID->"6e3a304a-0981-45aa-9266-c47b6d90a206"]
}, Open  ]],
Cell[246091, 7236, 296, 7, 30, "Input",ExpressionUUID->"db3c11ba-dbed-4462-817d-8d4b20d326d2"],
Cell[246390, 7245, 3454, 102, 123, InheritFromParent,ExpressionUUID->"fbacd3a2-5ad5-442b-849a-6aa75ded4534"],
Cell[249847, 7349, 2063, 56, 98, InheritFromParent,ExpressionUUID->"0ccb1371-003f-45f5-b53a-7103a687b4aa"],
Cell[CellGroupData[{
Cell[251935, 7409, 210, 4, 30, "Input",ExpressionUUID->"a5d5a9cf-0998-4ff2-a79a-876e30d85795"],
Cell[252148, 7415, 177, 3, 34, "Output",ExpressionUUID->"65caea14-bb94-425b-9cc4-a546f0f8e235"]
}, Open  ]],
Cell[CellGroupData[{
Cell[252362, 7423, 3638, 92, 150, "Input",ExpressionUUID->"ec2611cc-028e-401e-a44d-22450e0b4e40"],
Cell[256003, 7517, 3345, 90, 104, "Output",ExpressionUUID->"2cb8b7d9-0aea-4697-951c-a654d41111f1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[259385, 7612, 4005, 99, 150, "Input",ExpressionUUID->"bbdade29-5256-4845-8cf4-32ffe9d2bca1"],
Cell[263393, 7713, 3426, 91, 104, "Output",ExpressionUUID->"bf094a51-4297-4bfa-931c-a13050168150"]
}, Open  ]],
Cell[266834, 7807, 381, 8, 30, "Input",ExpressionUUID->"8c35ff22-5a2b-4b00-90c0-f90e268f1d8b"],
Cell[CellGroupData[{
Cell[267240, 7819, 259, 6, 30, "Input",ExpressionUUID->"a21554cd-b753-485e-9edd-5a8f125b589b"],
Cell[267502, 7827, 641, 22, 34, "Output",ExpressionUUID->"df0ef154-bbd9-4325-9a03-0610c9ebed9e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[268180, 7854, 833, 27, 30, "Input",ExpressionUUID->"8f7b2628-686f-4f38-a0c8-68d81e9152fa"],
Cell[269016, 7883, 789, 27, 34, "Output",ExpressionUUID->"05df8f60-d82b-405b-aef5-79f08a53c5c1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[269842, 7915, 294, 7, 30, "Input",ExpressionUUID->"fe0cebff-4666-431b-ab80-eadd9b8473b3"],
Cell[270139, 7924, 868, 28, 37, "Output",ExpressionUUID->"c5bc09e4-5f5a-4f99-99da-26465930bcc3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[271044, 7957, 399, 11, 30, "Input",ExpressionUUID->"e692f2e5-9b2d-4706-8396-cc750b9a84b9"],
Cell[271446, 7970, 370, 11, 34, "Output",ExpressionUUID->"4d4f252a-5c51-4c59-aecc-7ce450584525"]
}, Open  ]],
Cell[CellGroupData[{
Cell[271853, 7986, 288, 7, 30, "Input",ExpressionUUID->"e2309822-fd5a-44ca-ad77-1ec3cb11f985"],
Cell[272144, 7995, 244, 6, 34, "Output",ExpressionUUID->"2ecb04ff-9e9f-454a-a0d8-fb570b2b9511"]
}, Open  ]],
Cell[272403, 8004, 150, 3, 30, "Input",ExpressionUUID->"bb366d0b-cad3-4fc1-8760-d6be0ebd16fe"],
Cell[CellGroupData[{
Cell[272578, 8011, 515, 13, 30, "Input",ExpressionUUID->"175b75b2-dfb8-47b6-b296-fd2f4cd340af"],
Cell[273096, 8026, 430, 12, 34, "Output",ExpressionUUID->"3ce7923d-a7ce-4c41-8e36-fbb6ade41249"]
}, Open  ]],
Cell[CellGroupData[{
Cell[273563, 8043, 395, 11, 30, "Input",ExpressionUUID->"1b859a88-a678-418b-bcb2-537a09bda768"],
Cell[273961, 8056, 424, 13, 34, "Output",ExpressionUUID->"9038c462-7d93-417c-a656-bd2567b040f2"]
}, Open  ]],
Cell[274400, 8072, 466, 12, 52, "Input",ExpressionUUID->"49b6cb2a-fca5-490f-9dbf-2d46b7268514"],
Cell[274869, 8086, 3837, 98, 158, "Input",ExpressionUUID->"cb05ef87-f687-4105-ae64-a86c489eb2fa"],
Cell[CellGroupData[{
Cell[278731, 8188, 2875, 74, 145, "Input",ExpressionUUID->"7eececec-f1c6-4a2e-88a8-e3630ab4fe37"],
Cell[281609, 8264, 3160, 88, 107, "Output",ExpressionUUID->"fd12bd7c-59f3-4c34-87b8-3273c743752c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[284806, 8357, 4773, 113, 196, "Input",ExpressionUUID->"9f093520-a5d0-44f5-a9c2-20915b618a85"],
Cell[289582, 8472, 3790, 105, 115, "Output",ExpressionUUID->"1e32c2e0-6c15-4744-a662-bb7fe47a792a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[293409, 8582, 3665, 93, 149, "Input",ExpressionUUID->"d1581ea5-d0e0-4e6e-a2f1-58488dcbe9a1"],
Cell[297077, 8677, 6292, 156, 231, "Output",ExpressionUUID->"2c932030-b0bc-4b2e-8e6d-7cc324ea180d"]
}, Open  ]],
Cell[303384, 8836, 416, 9, 30, "Input",ExpressionUUID->"7fff66a2-46f7-43e2-9cb1-bb66bfa47d38"],
Cell[CellGroupData[{
Cell[303825, 8849, 826, 25, 30, "Input",ExpressionUUID->"64d1b526-75e9-46a1-81e6-e98de13776cf"],
Cell[304654, 8876, 829, 27, 34, "Output",ExpressionUUID->"327952b8-12dd-4ec2-9bb1-cd3b7d8396e7"]
}, Open  ]],
Cell[305498, 8906, 294, 7, 30, "Input",ExpressionUUID->"a4f601cc-83df-4383-bd96-ffaf05737492"],
Cell[305795, 8915, 657, 16, 30, "Input",ExpressionUUID->"c0ab5592-90ec-4c18-9781-456cd09f2c85"],
Cell[306455, 8933, 564, 12, 73, "Input",ExpressionUUID->"6ce964b6-c758-47ce-8b24-b6fdfbe97580"],
Cell[CellGroupData[{
Cell[307044, 8949, 3599, 92, 119, "Input",ExpressionUUID->"adc22187-9df5-4b69-a33b-d994e8e309a5"],
Cell[310646, 9043, 5964, 152, 171, "Output",ExpressionUUID->"5789ba20-758b-4a6c-b893-4cd96c813902"]
}, Open  ]],
Cell[CellGroupData[{
Cell[316647, 9200, 5699, 138, 182, "Input",ExpressionUUID->"a97ad1e4-6c64-49c4-99cd-a135361e4c9a"],
Cell[322349, 9340, 377, 10, 34, "Output",ExpressionUUID->"638bafd9-36ac-4621-9ed2-809b61b6d16e"]
}, Open  ]]
}
]
*)

