(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    369797,      10653]
NotebookOptionsPosition[    343933,      10217]
NotebookOutlinePosition[    344269,      10232]
CellTagsIndexPosition[    344226,      10229]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Trying", " ", "to", " ", "compute", " ", "differentials", " ", "of", " ",
      "g"}], "-", 
    RowBox[{"h", "*", "f", " ", "in"}], " ", "-", "Drift", " ", "+", " ", 
    RowBox[{"Kepler", " ", 
     RowBox[{"problem", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Note", ":", "  ", 
     RowBox[{"below", "  ", "d"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", "*", "g2"}], "+", 
         RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}], " ", 
      "\[IndentingNewLine]", "r"}], " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
       RowBox[{"k", " ", "g2", "\[IndentingNewLine]", "h"}]}], " ", "=", " ", 
      
      RowBox[{
       RowBox[{
        RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
        RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
        RowBox[{"k", " ", "g3", "\[IndentingNewLine]", "g0"}]}], " ", "=", 
       " ", 
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2", " ", "\[IndentingNewLine]", "g3"}]}], " ",
         "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"s", "-", "g1"}], ")"}], "/", "beta"}], " ", 
           "\[IndentingNewLine]", "g0", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g1", "^", "2"}]}], " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"-", "g2"}], "\[IndentingNewLine]", 
            RowBox[{"g0", "^", "2"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"g1", "^", "2"}], " ", "beta"}]}], " ", "=", " ", 
          RowBox[{
           RowBox[{"1", "\[IndentingNewLine]", "zeta"}], " ", "=", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}]}]}]}]}]}]}], 
   "\[IndentingNewLine]", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
   3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
   3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
   3.776525175923255*^9, 3.776525176235034*^9}, {3.776525240482662*^9, 
   3.776525240962843*^9}, 3.776526153428337*^9, {3.776628563725472*^9, 
   3.776628570139529*^9}, 3.77694761771982*^9, 3.776947897543344*^9, 
   3.777133148624723*^9},ExpressionUUID->"53329b6c-a80c-45ac-ae62-\
f6fb243392bd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgamma", " ", "=", " ", 
  RowBox[{
   FractionBox["sqb", "r"], " ", 
   RowBox[{"(", 
    RowBox[{"dh", " ", "+", "  ", 
     RowBox[{
      FractionBox["dk", "r0"], 
      RowBox[{"(", 
       RowBox[{"d", "-", " ", 
        RowBox[{"r0", " ", "g3"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"k", " ", "d"}], "+", 
           RowBox[{"g1", " ", 
            SuperscriptBox["r0", "2"]}]}], ")"}], 
         FractionBox["x0", 
          SuperscriptBox["r0", "3"]]}], "+", 
        RowBox[{"g2", " ", "v0"}]}], ")"}]}], "-", 
     RowBox[{"dv0", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", "  ", "v0"}], " ", "+", " ", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
   3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
   3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
   3.776525175923255*^9, 3.776525176235034*^9}, {3.776525240482662*^9, 
   3.776525240962843*^9}, 3.776526153428337*^9, {3.776628563725472*^9, 
   3.776628570139529*^9}, 3.77694761771982*^9, 3.776947897543344*^9, 
   3.777133148624723*^9},
 CellLabel->"In[10]:=",ExpressionUUID->"599cae75-96f6-4e35-a7da-01caf6fb2f55"],

Cell[BoxData[
 FractionBox[
  RowBox[{"sqb", " ", 
   RowBox[{"(", 
    RowBox[{"dh", "+", 
     FractionBox[
      RowBox[{"dk", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
     RowBox[{"dv0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", " ", "v0"}], "+", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g2", " ", "v0"}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
         SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"]], "Output",
 CellChangeTimes->{3.776202160614881*^9, 3.7765252981388903`*^9, 
  3.777119561211062*^9, 3.7771226949929237`*^9, 3.777128858509432*^9, 
  3.777133152310174*^9, 3.777333027435947*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"b1dcd199-656f-4674-bb12-88cd6ae21b23"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dbeta", " ", "=", " ", 
  RowBox[{
   RowBox[{"2", "*", 
    RowBox[{"dk", "/", "r0"}]}], "-", 
   RowBox[{"2", "*", 
    RowBox[{"k", "/", 
     RowBox[{"r0", "^", "3"}]}], "*", " ", 
    RowBox[{"(", 
     RowBox[{"dx0", " ", "*", " ", "x0"}], ")"}]}], " ", "-", " ", 
   RowBox[{"2", "*", "v0", " ", "*", " ", "dv0"}]}]}]], "Input",
 CellChangeTimes->{{3.776198629796771*^9, 3.776198668928054*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"95296aac-8480-48bf-b720-90060933f9ed"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", "dk"}], "r0"], "-", 
  RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
  FractionBox[
   RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
   SuperscriptBox["r0", "3"]]}]], "Output",
 CellChangeTimes->{3.776198669836025*^9, 3.7762021775425386`*^9, 
  3.776525299673205*^9, 3.77711956296929*^9, 3.7771226952004023`*^9, 
  3.777128858738678*^9, 3.7771331537986794`*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"dbb0f0af-98a2-4a33-9d76-72e16a90574f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr0", " ", "=", " ", 
  RowBox[{"dx0", " ", "*", " ", 
   RowBox[{"x0", " ", "/", " ", "r0"}]}]}]], "Input",
 CellChangeTimes->{{3.776198724170291*^9, 3.776198736866087*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"6e130959-e5af-4389-aed5-d86ced425512"],

Cell[BoxData[
 FractionBox[
  RowBox[{"dx0", " ", "x0"}], "r0"]], "Output",
 CellChangeTimes->{3.776198740240225*^9, 3.776202183604251*^9, 
  3.7765253032315493`*^9, 3.777119564517047*^9, 3.777122696290498*^9, 
  3.7771288600481253`*^9, 3.777133155655081*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"4c5a08d5-5efc-4afa-8692-91191f71e628"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Now", " ", "for", " ", "d", 
    RowBox[{"(", 
     RowBox[{"g", "-", 
      RowBox[{"h", "*", "f"}]}], ")"}], " ", "for", " ", "drift"}], "-", 
   RowBox[{"first", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776258566484967*^9, 3.776258574345611*^9}, {
   3.7762590835501537`*^9, 3.7762590836374397`*^9}, {3.776259116907651*^9, 
   3.7762591197329206`*^9}, 3.776521078478303*^9, 3.7765253307790813`*^9, {
   3.776617109650201*^9, 3.7766171225517597`*^9}, {3.776628592067607*^9, 
   3.776628599420455*^9}},ExpressionUUID->"2d884b31-7a55-4520-bbb8-\
26a9cd31ce07"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgmhf", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox["dk", "r0"], "-", 
      FractionBox[
       RowBox[{"k", " ", "dr0"}], 
       SuperscriptBox["r0", "2"]]}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"h", " ", "g2"}], " ", "-", " ", 
      RowBox[{"r0", " ", "g3"}]}], ")"}]}], " ", "+", " ", 
   RowBox[{
    FractionBox["k", "r0"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g2", " ", "dh"}], " ", "-", " ", 
      RowBox[{"dr0", " ", "g3"}], " ", "+", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"h", " ", "g1"}], " ", "-", " ", 
         RowBox[{"r0", " ", "g2"}]}], ")"}], 
       RowBox[{"dgamma", "/", "sqb"}]}], " ", "-", " ", 
      RowBox[{
       FractionBox["dbeta", 
        RowBox[{"2", " ", "beta"}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "h", " ", "g2"}], " ", "-", " ", 
         RowBox[{"3", "r0", " ", "g3"}]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7762585761216097`*^9, 3.77625860781793*^9}, {
   3.776259100727673*^9, 3.776259100829246*^9}, {3.7765252487139378`*^9, 
   3.776525259881138*^9}, {3.776628588405992*^9, 3.776628685498967*^9}, 
   3.776711187200655*^9, {3.7771226390536003`*^9, 3.7771226429688272`*^9}, 
   3.777133093840005*^9},
 CellLabel->"In[4]:=",ExpressionUUID->"a6c48c41-52a5-424e-8082-2ada96dd916c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g2", " ", "h"}], "-", 
     RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["dk", "r0"], "-", 
     FractionBox[
      RowBox[{"dx0", " ", "k", " ", "x0"}], 
      SuperscriptBox["r0", "3"]]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"dh", " ", "g2"}], "-", 
      FractionBox[
       RowBox[{"dx0", " ", "g3", " ", "x0"}], "r0"], "-", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "g2", " ", "h"}], "-", 
          RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"2", " ", "dk"}], "r0"], "-", 
          RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
          FractionBox[
           RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
           SuperscriptBox["r0", "3"]]}], ")"}]}], 
       RowBox[{"2", " ", "beta"}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"dh", "+", 
          FractionBox[
           RowBox[{"dk", " ", 
            RowBox[{"(", 
             RowBox[{"d", "-", 
              RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
          RowBox[{"dv0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "v0"}], "+", 
             RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
          RowBox[{"dx0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "v0"}], "+", 
             FractionBox[
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", " ", "k"}], "+", 
                 RowBox[{"g1", " ", 
                  SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
              SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"]}], 
     ")"}]}], "r0"]}]], "Output",
 CellChangeTimes->{3.776258608902561*^9, 3.7765253080119057`*^9, 
  3.776628687109683*^9, 3.776711206756096*^9, 3.7771195672331953`*^9, 
  3.777122698099163*^9, 3.7771288614713306`*^9, 3.777133095901432*^9, 
  3.7771331575804577`*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"c3cb023c-09cb-4b1b-9870-e7d643ee1bfc"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.777133120768692*^9, 3.7771331218649073`*^9}, 
   3.7771331600826807`*^9},ExpressionUUID->"004650bd-f43e-499e-861e-\
d29d34e0ac57"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"dx0", ",", "dv0", ",", "dk", ",", "dh"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.776258616039044*^9, 3.776258625845273*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"c50ee62d-22cf-45d5-85af-1fc4bc50ccb2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g2", " ", "k"}], "r0"], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "g2", " ", "h"}], "-", 
          RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g2", " ", "h"}], "-", 
       RowBox[{"g3", " ", "r0"}]}], "r0"]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "h"}], "-", 
         RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}], " ", "v0"}], 
      RowBox[{"beta", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g3", " ", "k", " ", "x0"}], 
       SuperscriptBox["r0", "2"]]}], "+", 
     FractionBox[
      RowBox[{
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "h"}], "-", 
         RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}], " ", "x0"}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "h"}], "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", "x0"}], 
      SuperscriptBox["r0", "3"]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776258626371228*^9, 3.776525309618307*^9, 
  3.7766287024513817`*^9, 3.776711208876161*^9, 3.776711243572094*^9, 
  3.7771195725285397`*^9, 3.77712270164426*^9, 3.777128864519684*^9, 
  3.777133161966061*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"2c8936c0-e679-4519-a66c-008f4c419289"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Collect", " ", "dx0", " ", 
    RowBox[{"{", 
     RowBox[{"x0", ",", "v0"}], "}"}]}], ":"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777119582499116*^9, 3.777119588913188*^9}},
 CellLabel->"In[28]:=",ExpressionUUID->"4cfaaa76-44ec-4daf-a4b4-a197eb8005e7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g3", " ", "k", " ", "x0"}], 
       SuperscriptBox["r0", "2"]]}], "+", 
     FractionBox[
      RowBox[{
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "h"}], "-", 
         RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}], " ", "x0"}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "h"}], "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", "x0"}], 
      SuperscriptBox["r0", "3"]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777119590474258*^9, 3.777119597810857*^9}, 
   3.7771227195808907`*^9, 3.7771288755558443`*^9, 3.777133178601433*^9},
 CellLabel->"In[6]:=",ExpressionUUID->"25b93094-0eb0-47de-b80e-74801c31e5ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"g2", " ", "k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g1", " ", "h"}], "-", 
       RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "v0"}], 
    RowBox[{"r", " ", "r0"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g3", " ", "k"}], 
       SuperscriptBox["r0", "2"]]}], "+", 
     FractionBox[
      RowBox[{
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "h"}], "-", 
         RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "h"}], "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      SuperscriptBox["r0", "3"]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "4"]}]]}], ")"}], " ", "x0"}]}]], "Output",
 CellChangeTimes->{3.777119598439581*^9, 3.77712273240821*^9, 
  3.777128876772382*^9, 3.7771331799635487`*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"61e2deb7-332a-413f-9a98-946f2eb7fe6c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Collect", " ", "dv0", " ", 
    RowBox[{"{", 
     RowBox[{"x0", ",", "v0"}], "}"}]}], ":"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7771196000498734`*^9, 3.777119606776208*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"503115b3-a2e2-4043-97f2-8b243c3e7beb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "h"}], "-", 
         RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}], " ", "v0"}], 
      RowBox[{"beta", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777119608425557*^9, 3.7771196151458073`*^9}, 
   3.777122740323695*^9, 3.777128887123887*^9, 3.777133190256426*^9},
 CellLabel->"In[7]:=",ExpressionUUID->"8adf5d1c-282b-455b-96df-f6459d945d78"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"d", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]]}], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "h"}], "-", 
         RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", "r0"}]]}], ")"}], " ", "v0"}], "-", 
  FractionBox[
   RowBox[{"g2", " ", "k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", "h"}], "-", 
      RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "x0"}], 
   RowBox[{"r", " ", "r0"}]]}]], "Output",
 CellChangeTimes->{3.7771196156997557`*^9, 3.777122740995043*^9, 
  3.7771288880334272`*^9, 3.777133190874845*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"e78fa3f5-12c6-4a7a-99d4-4fc17bc2950e"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.7771196175850687`*^9, 
  3.7771196209764853`*^9}},ExpressionUUID->"7a8f6d3f-4d55-4131-87d7-\
d7dbeac9f082"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Substitute", " ", "dx0"}], " ", "\[Rule]", " ", 
    RowBox[{"dx0", " ", "-", " ", 
     RowBox[{"h", " ", "dv0"}], " ", "-", " ", 
     RowBox[{"dh", " ", 
      RowBox[{"v0", ":"}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"dgmhf", " ", "=", 
   RowBox[{
    RowBox[{"dh", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"g2", " ", "k"}], "r0"], "+", 
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "h"}], "-", 
           RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
        RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
    RowBox[{"dk", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "2"]}]]}], "+", 
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "h"}], "-", 
           RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"d", "-", 
           RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
        RowBox[{"r", " ", 
         SuperscriptBox["r0", "2"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"g2", " ", "h"}], "-", 
         RowBox[{"g3", " ", "r0"}]}], "r0"]}], ")"}]}], "+", 
    RowBox[{"dv0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"d", " ", "k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"r", " ", "r0"}]]}], "+", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "g2", " ", "h"}], "-", 
              RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
           RowBox[{"beta", " ", "r0"}]]}], ")"}], " ", "v0"}], "-", 
       FractionBox[
        RowBox[{"g2", " ", "k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "h"}], "-", 
           RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"x0", "-", 
           RowBox[{"h", " ", "v0"}]}], ")"}]}], 
        RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"dx0", "-", " ", 
       RowBox[{"h", " ", "dv0"}]}], " ", ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "v0"}], 
         RowBox[{"r", " ", "r0"}]]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"g3", " ", "k"}], 
            SuperscriptBox["r0", "2"]]}], "+", 
          FractionBox[
           RowBox[{
            SuperscriptBox["k", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "g2", " ", "h"}], "-", 
              RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
           RowBox[{"beta", " ", 
            SuperscriptBox["r0", "4"]}]], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g2", " ", "h"}], "-", 
              RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
           SuperscriptBox["r0", "3"]], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "+", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}]}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "4"]}]]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"x0", "-", " ", 
          RowBox[{"h", " ", "v0"}]}], " ", ")"}]}]}], ")"}]}], " ", "-", " ", 
    
    RowBox[{"dh", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"2", "k"}], "r0"], "-", "beta"}], ")"}]}], 
         RowBox[{"r", " ", "r0"}]]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"g3", " ", "k"}], 
            SuperscriptBox["r0", "2"]]}], "+", 
          FractionBox[
           RowBox[{
            SuperscriptBox["k", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "g2", " ", "h"}], "-", 
              RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
           RowBox[{"beta", " ", 
            SuperscriptBox["r0", "4"]}]], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g2", " ", "h"}], "-", 
              RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
           SuperscriptBox["r0", "3"]], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "+", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}]}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "4"]}]]}], ")"}], " ", "eta"}]}], ")"}], 
     " "}]}]}]}]], "Input",
 CellChangeTimes->{{3.776258919746063*^9, 3.776258947304412*^9}, {
   3.7765253393602*^9, 3.7765253980191402`*^9}, {3.7765254342404957`*^9, 
   3.776525437382782*^9}, 3.776525747045329*^9, {3.776628709315301*^9, 
   3.776628736362604*^9}, {3.77671126860012*^9, 3.776711277556809*^9}, {
   3.777119625025812*^9, 3.777119757414764*^9}, {3.7771228100990343`*^9, 
   3.777122880938849*^9}, {3.777128897413686*^9, 3.777128988995863*^9}, {
   3.777133201066596*^9, 3.7771332764428797`*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"5016d470-2559-42c7-9097-a15b73e2e0c2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g2", " ", "k"}], "r0"], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "g2", " ", "h"}], "-", 
          RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g2", " ", "h"}], "-", 
       RowBox[{"g3", " ", "r0"}]}], "r0"]}], ")"}]}], "-", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "beta"}], "+", 
          FractionBox[
           RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]]}], "+", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r0"}]]}], ")"}], " ", "v0"}], "-", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"dx0", "-", 
     RowBox[{"dv0", " ", "h"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "v0"}], 
       RowBox[{"r", " ", "r0"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.776525750774577*^9, 3.776628738011199*^9, 
  3.7767112463060303`*^9, 3.776711278464267*^9, 3.777119759534395*^9, 
  3.777122894491768*^9, 3.777128993013028*^9, 3.777133277230385*^9, 
  3.777333034569511*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"8d9e4bf4-9b6e-42d7-aa9c-46858b286459"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Recollect", " ", 
    RowBox[{"terms", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Collect", "[", 
   RowBox[{"%", ",", 
    RowBox[{"{", 
     RowBox[{"dx0", ",", "dv0", ",", "dk", ",", "dh"}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.776258919746063*^9, 3.776258947304412*^9}, {
  3.7765253393602*^9, 3.7765253980191402`*^9}, {3.7765254342404957`*^9, 
  3.776525437382782*^9}, {3.776525747045329*^9, 3.776525756684986*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"7059d59a-422c-4fa8-8a97-619f047bef25"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "g2", " ", "h"}], "-", 
          RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g2", " ", "h"}], "-", 
       RowBox[{"g3", " ", "r0"}]}], "r0"]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g2", " ", "k"}], "r0"], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "beta"}], "+", 
         FractionBox[
          RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "v0"}], 
       RowBox[{"r", " ", "r0"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}]}]}], ")"}]}], 
  "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r0"}]]}], ")"}], " ", "v0"}], "-", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "v0"}], 
          RowBox[{"r", " ", "r0"}]]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g3", " ", "k"}], 
             SuperscriptBox["r0", "2"]]}], "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", "g2", " ", "h"}], "-", 
               RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "h"}], "-", 
               RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
            SuperscriptBox["r0", "3"]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}]}]}], 
       ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776525757939495*^9, 3.776628745541733*^9, 
  3.776711281560452*^9, 3.777119762498486*^9, 3.7771289962599487`*^9, 
  3.777133279653492*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"7d743469-b282-427c-a47e-3a45afce828d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Collect", " ", "x0"}], " ", "&"}], " ", "v0", " ", "in", " ", 
      "dv0"}], " ", "&"}], " ", "dx0", " ", 
    RowBox[{"terms", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"First", " ", 
    RowBox[{"dx0", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776258919746063*^9, 3.776258947304412*^9}, {
  3.7765253393602*^9, 3.7765253980191402`*^9}, {3.7765254342404957`*^9, 
  3.776525437382782*^9}, {3.776525747045329*^9, 
  3.776525756684986*^9}},ExpressionUUID->"2d2780f5-7883-466a-8a23-\
8bc50de57f16"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "v0"}], 
       RowBox[{"r", " ", "r0"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}]}]}], ")"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7762589351786823`*^9, 3.7762589524160213`*^9}, 
   3.776525060098572*^9, 3.776525794229862*^9, 3.776628762355691*^9, {
   3.776711295805737*^9, 3.7767113105415287`*^9}, 3.777119770946062*^9, 
   3.777129007207326*^9, 3.777133293454023*^9},
 CellLabel->"In[10]:=",ExpressionUUID->"86606400-4dcd-4a36-bd1d-3a1e6bba1e6b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]]}], "-", 
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], " ", "v0"}], "+", 
  
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g3", " ", "k"}], 
       SuperscriptBox["r0", "2"]]}], "+", 
     FractionBox[
      RowBox[{
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "h"}], "-", 
         RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "h"}], "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      SuperscriptBox["r0", "3"]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "4"]}]]}], ")"}], " ", "x0"}]}]], "Output",
 CellChangeTimes->{
  3.776258952843275*^9, 3.776525061251594*^9, 3.776525316177684*^9, 
   3.776525795094637*^9, 3.7766287630992203`*^9, {3.776711296450212*^9, 
   3.776711311266932*^9}, 3.777119771655649*^9, 3.777129008387281*^9, 
   3.777133294095991*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"a9bcab77-bc8a-404d-abc5-bc0090747836"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Next", ",", " ", 
   RowBox[{"dv0", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776258958098084*^9, 3.77625896130404*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"93376667-ae79-4f2c-bce9-f4e105374de8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r0"}]]}], ")"}], " ", "v0"}], "-", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", "v0"}], 
          RowBox[{"r", " ", "r0"}]]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g3", " ", "k"}], 
             SuperscriptBox["r0", "2"]]}], "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", "g2", " ", "h"}], "-", 
               RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "h"}], "-", 
               RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
            SuperscriptBox["r0", "3"]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "h"}], " ", "v0"}], "+", "x0"}], ")"}]}]}], 
       ")"}]}]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.776258972640501*^9, 3.7762589774726753`*^9}, 
   3.776525074370203*^9, 3.776525804142207*^9, 3.776628775515748*^9, 
   3.776711324323279*^9, 3.7771197795485697`*^9, 3.777129015087801*^9, 
   3.7771333021574287`*^9},
 CellLabel->"In[11]:=",ExpressionUUID->"4c137373-3aac-4897-9d22-41fe9976ebba"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"d", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "h", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "h"}], "-", 
         RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", "r0"}]], "+", 
     RowBox[{
      SuperscriptBox["h", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], " ", "v0"}], "+", 
  
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]]}], "-", 
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], " ", 
   "x0"}]}]], "Output",
 CellChangeTimes->{3.776258978080896*^9, 3.77652507511236*^9, 
  3.776525321528337*^9, 3.776525804776061*^9, 3.776628776135713*^9, 
  3.7767113251092854`*^9, 3.777119780445573*^9, 3.777129015736492*^9, 
  3.7771333028324223`*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"9f2fcefe-0022-4a70-b687-a125d4fe1548"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Final", " ", "dgmhf", " ", 
   RowBox[{"term", ":"}]}], "  ", "*)"}]], "Input",
 CellChangeTimes->{{3.776258980760725*^9, 3.776258984807379*^9}, {
  3.776259093949028*^9, 3.7762590940371437`*^9}, {3.7766171318481617`*^9, 
  3.776617143201799*^9}, {3.776628883331504*^9, 
  3.776628888002441*^9}},ExpressionUUID->"d4d207ae-e603-472b-bd2a-\
7645ab9a44c9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgmhf", "  ", "=", 
  RowBox[{
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "g2", " ", "h"}], "-", 
           RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
        RowBox[{"beta", " ", 
         SuperscriptBox["r0", "2"]}]]}], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", 
        SuperscriptBox["r0", "2"]}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"g2", " ", "h"}], "-", 
        RowBox[{"g3", " ", "r0"}]}], "r0"]}], ")"}]}], "+", 
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g2", " ", "k"}], "r0"], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"g2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "beta"}], "+", 
          FractionBox[
           RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h"}], "-", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]], "-", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g3", " ", "k"}], 
           SuperscriptBox["r0", "2"]]}], "+", 
         FractionBox[
          RowBox[{
           SuperscriptBox["k", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "g2", " ", "h"}], "-", 
             RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "h"}], "-", 
             RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
          SuperscriptBox["r0", "3"]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{"r", " ", "r0"}]]}], "-", 
         RowBox[{"h", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g3", " ", "k"}], 
              SuperscriptBox["r0", "2"]]}], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["k", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "g2", " ", "h"}], "-", 
                RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "h"}], "-", 
                RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
             SuperscriptBox["r0", "3"]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], " ", "v0"}], 
      "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g3", " ", "k"}], 
           SuperscriptBox["r0", "2"]]}], "+", 
         FractionBox[
          RowBox[{
           SuperscriptBox["k", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "g2", " ", "h"}], "-", 
             RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "h"}], "-", 
             RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
          SuperscriptBox["r0", "3"]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "4"]}]]}], ")"}], " ", "x0"}]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"d", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{"r", " ", "r0"}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", "g2", " ", "h", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "g2", " ", "h"}], "-", 
             RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r0"}]], "+", 
         RowBox[{
          SuperscriptBox["h", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g3", " ", "k"}], 
              SuperscriptBox["r0", "2"]]}], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["k", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "g2", " ", "h"}], "-", 
                RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "h"}], "-", 
                RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
             SuperscriptBox["r0", "3"]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], " ", "v0"}], 
      "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "h"}], "-", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
           RowBox[{"r", " ", "r0"}]]}], "-", 
         RowBox[{"h", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g3", " ", "k"}], 
              SuperscriptBox["r0", "2"]]}], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["k", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "g2", " ", "h"}], "-", 
                RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r0", "4"]}]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "h"}], "-", 
                RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
             SuperscriptBox["r0", "3"]], "-", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], " ", "x0"}]}],
      ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776258995599614*^9, 3.776259029056012*^9}, {
   3.7762590959366198`*^9, 3.77625909602941*^9}, {3.776525082199473*^9, 
   3.776525111599989*^9}, {3.776525922906755*^9, 3.776525957206614*^9}, 
   3.776526096217079*^9, {3.776628889805566*^9, 3.776628954742577*^9}, {
   3.776711420276924*^9, 3.776711469008601*^9}, {3.777119790231962*^9, 
   3.777119817339427*^9}, {3.777129026650125*^9, 3.7771290494867353`*^9}, {
   3.77713331476926*^9, 3.777133353509532*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"71c53a07-8e97-43ef-b6c9-30d71d21b7fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "g2", " ", "h"}], "-", 
          RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g2", " ", "h"}], "-", 
       RowBox[{"g3", " ", "r0"}]}], "r0"]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g2", " ", "k"}], "r0"], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "beta"}], "+", 
         FractionBox[
          RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g3", " ", "k"}], 
             SuperscriptBox["r0", "2"]]}], "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", "g2", " ", "h"}], "-", 
               RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "h"}], "-", 
               RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
            SuperscriptBox["r0", "3"]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], " ", "v0"}], 
     "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}], " ", "x0"}]}], ")"}]}], "+", 
  
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "g2", " ", "h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r0"}]], "+", 
        RowBox[{
         SuperscriptBox["h", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g3", " ", "k"}], 
             SuperscriptBox["r0", "2"]]}], "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", "g2", " ", "h"}], "-", 
               RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "h"}], "-", 
               RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
            SuperscriptBox["r0", "3"]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], " ", "v0"}], 
     "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g3", " ", "k"}], 
             SuperscriptBox["r0", "2"]]}], "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", "g2", " ", "h"}], "-", 
               RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "h"}], "-", 
               RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
            SuperscriptBox["r0", "3"]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], " ", "x0"}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.7766289557071123`*^9, 3.776711470447338*^9, 
  3.77711982009918*^9, 3.777129051786704*^9, 3.7771333547686253`*^9, 
  3.777333039961913*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"6e761827-de11-4175-a87b-506cf36f7583"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.776628903794265*^9, 
  3.77662890379998*^9}},ExpressionUUID->"b06ac194-483e-4554-96dc-\
68188fd2cee1"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"See", " ", "if", " ", "I", " ", "can", " ", "simplify", " ", 
   RowBox[{"further", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776525150636251*^9, 3.776525156739154*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"cd0464f3-29a9-4cb8-8b4a-c7b30bf6369f"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"c1", " ", "=", " ", 
  RowBox[{"d", " ", "-", " ", 
   RowBox[{"r0", " ", "g3"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c3", "=", 
   RowBox[{
    RowBox[{"d", " ", "k"}], "+", 
    RowBox[{"g1", " ", 
     SuperscriptBox["r0", "2"]}]}]}], "\n"}], "\n", 
 RowBox[{"c9", " ", "=", " ", 
  RowBox[{
   RowBox[{"2", "g2", " ", "h"}], "-", 
   RowBox[{"3", " ", "g3", " ", "r0"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c10", " ", "=", 
  RowBox[{
   FractionBox["k", 
    SuperscriptBox["r0", "4"]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", " ", "g2"}], " ", "r0", " ", "h"}], "+", 
     FractionBox[
      RowBox[{"k", " ", "c9"}], "beta"], "-", 
     FractionBox[
      RowBox[{"c13", " ", "c3"}], "r"]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c13", "=", 
  RowBox[{
   RowBox[{"g1", " ", "h"}], "-", 
   RowBox[{"g2", " ", "r0"}]}]}]}], "Input",
 CellChangeTimes->{{3.7765261076056643`*^9, 3.776526108528695*^9}, {
   3.776527280600696*^9, 3.7765273644049187`*^9}, {3.7765273971972437`*^9, 
   3.776527431043559*^9}, 3.776628900673327*^9, {3.777119832738532*^9, 
   3.777119865247117*^9}, {3.777119909828548*^9, 3.777119916884719*^9}, {
   3.777120007546422*^9, 3.777120008507166*^9}, {3.777120057504154*^9, 
   3.777120064203487*^9}, 3.777120172047001*^9, {3.77712026702011*^9, 
   3.7771203113498163`*^9}, {3.777120441669745*^9, 3.777120521200045*^9}, 
   3.777133361808103*^9},
 CellLabel->
  "In[164]:=",ExpressionUUID->"02caa98e-227a-41a9-a2b1-d150f70a6341"],

Cell[BoxData[
 RowBox[{"d", "-", 
  RowBox[{"g3", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.777120175771681*^9, 3.7771206539125547`*^9, 
  3.7771227649067802`*^9, 3.777129054459234*^9, 3.7771333698435373`*^9, 
  3.777144529861396*^9, 3.7771671909938297`*^9, 3.777333042159895*^9, 
  3.777814072729142*^9, 3.7781674543845587`*^9},
 CellLabel->
  "Out[164]=",ExpressionUUID->"38ba11af-be2f-4671-b4ea-336cac2a8805"],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", " ", "k"}], "+", 
  RowBox[{"g1", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.777120175771681*^9, 3.7771206539125547`*^9, 
  3.7771227649067802`*^9, 3.777129054459234*^9, 3.7771333698435373`*^9, 
  3.777144529861396*^9, 3.7771671909938297`*^9, 3.777333042159895*^9, 
  3.777814072729142*^9, 3.778167454388906*^9},
 CellLabel->
  "Out[165]=",ExpressionUUID->"32949255-2beb-41be-bcc2-9054b8c1d54d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", "g2", " ", "h"}], "-", 
  RowBox[{"3", " ", "g3", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.777120175771681*^9, 3.7771206539125547`*^9, 
  3.7771227649067802`*^9, 3.777129054459234*^9, 3.7771333698435373`*^9, 
  3.777144529861396*^9, 3.7771671909938297`*^9, 3.777333042159895*^9, 
  3.777814072729142*^9, 3.7781674543905888`*^9},
 CellLabel->
  "Out[166]=",ExpressionUUID->"b7b9bf6f-64df-4f95-892c-66bf030f7c9c"],

Cell[BoxData[
 FractionBox[
  RowBox[{"k", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g2"}], " ", "h", " ", "r0"}], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "h"}], "-", 
         RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], "beta"], "-", 
     FractionBox[
      RowBox[{"c13", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], "r"]}], ")"}]}], 
  SuperscriptBox["r0", "4"]]], "Output",
 CellChangeTimes->{3.777120175771681*^9, 3.7771206539125547`*^9, 
  3.7771227649067802`*^9, 3.777129054459234*^9, 3.7771333698435373`*^9, 
  3.777144529861396*^9, 3.7771671909938297`*^9, 3.777333042159895*^9, 
  3.777814072729142*^9, 3.778167454392295*^9},
 CellLabel->
  "Out[167]=",ExpressionUUID->"c00d2355-add9-42e6-b846-25972d64312f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g1", " ", "h"}], "-", 
  RowBox[{"g2", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.777120175771681*^9, 3.7771206539125547`*^9, 
  3.7771227649067802`*^9, 3.777129054459234*^9, 3.7771333698435373`*^9, 
  3.777144529861396*^9, 3.7771671909938297`*^9, 3.777333042159895*^9, 
  3.777814072729142*^9, 3.7781674543940372`*^9},
 CellLabel->
  "Out[168]=",ExpressionUUID->"34198899-8bed-49b5-9283-8b95e182918b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "The", " ", "italicized", " ", "term", " ", "in", " ", "the", " ", 
   "following", " ", "needs", " ", "to", " ", "be", " ", "dealt", " ", 
   RowBox[{"with", ":", "  ", 
    RowBox[{"two", " ", "terms", " ", "of", " ", "order", " ", 
     RowBox[{"gamma", "^", "3"}], " ", "cancel", "\[IndentingNewLine]", "to", 
     " ", "give", " ", "an", " ", "order", " ", 
     RowBox[{"gamma", "^", "5"}], " ", 
     RowBox[{"result", ".", "  ", "A"}], " ", "long", " ", "expression", " ", 
     
     RowBox[{"(", 
      RowBox[{"which", " ", "simplifies"}], ")"}], " ", "is", " ", "worked", 
     " ", "out", " ", "at", " ", "the", " ", "end", "\[IndentingNewLine]", 
     "which", " ", "contains", " ", "combinations", " ", "of", " ", "the", 
     " ", "G_n", " ", "functions", " ", "which", " ", "cancel", " ", "out", 
     " ", "significantly", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"similar", " ", "to", " ", "h1"}], " ", "&"}], " ", "h2"}], 
       ")"}], "."}]}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7765261076056643`*^9, 3.776526108528695*^9}, {
   3.776527280600696*^9, 3.7765273644049187`*^9}, {3.7765273971972437`*^9, 
   3.776527431043559*^9}, 3.776628900673327*^9, {3.777119832738532*^9, 
   3.777119865247117*^9}, {3.777119909828548*^9, 3.777119916884719*^9}, {
   3.777120007546422*^9, 3.777120008507166*^9}, {3.777120057504154*^9, 
   3.777120064203487*^9}, 3.777120172047001*^9, {3.777150822741194*^9, 
   3.777150907401649*^9}},ExpressionUUID->"7764e67b-80f4-4df8-b0a1-\
32adf9790e91"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgmhf2", " ", "=", 
  RowBox[{
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"k", " ", "c13", " ", "c1"}], 
       RowBox[{"r", " ", 
        SuperscriptBox["r0", "2"]}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"g2", " ", "h"}], "-", 
        RowBox[{"g3", " ", "r0"}]}], "r0"], "-", 
      FractionBox[
       RowBox[{"k", " ", "c9"}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g2", " ", "k"}], "r0"], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"2", " ", "k", " ", "g2"}]}], ")"}], " ", "c13"}], 
       RowBox[{"r", " ", 
        SuperscriptBox["r0", "2"]}]], "-", 
      RowBox[{"eta", " ", "c10"}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"g2", " ", "k", " ", "c13"}], 
           RowBox[{"r", " ", "r0"}]], "+", 
          RowBox[{"h", " ", "c10"}]}], ")"}]}], " ", "v0"}], "+", 
      RowBox[{"c10", " ", "x0"}]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         StyleBox[
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"k", " ", "c9"}], 
             RowBox[{"beta", " ", "r0"}]], "-", 
            FractionBox[
             RowBox[{"d", " ", "k", " ", "c13"}], 
             RowBox[{"r", " ", "r0"}]]}], ")"}],
          FontSlant->"Italic",
          FontColor->GrayLevel[0]], "+", 
         FractionBox[
          RowBox[{"2", " ", "g2", " ", "h", " ", "k", " ", "c13"}], 
          RowBox[{"r", " ", "r0"}]], "+", 
         RowBox[{
          SuperscriptBox["h", "2"], " ", "c10"}]}], ")"}], " ", "v0"}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"g2", " ", "k", " ", "c13"}], 
          RowBox[{"r", " ", "r0"}]], "+", 
         RowBox[{"h", " ", "c10"}]}], ")"}], " ", "x0"}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776628961768914*^9, 3.7766290441101*^9}, {
   3.776711481050329*^9, 3.7767116177430573`*^9}, 3.7771198272758503`*^9, {
   3.777119896119321*^9, 3.7771199977786913`*^9}, {3.777120071777752*^9, 
   3.7771200944991207`*^9}, {3.7771204893607388`*^9, 
   3.7771204991442337`*^9}, {3.777120530350605*^9, 3.777120554476741*^9}, {
   3.777150715149225*^9, 3.777150724126251*^9}, {3.777332985042694*^9, 
   3.777333021020335*^9}, {3.777333081405156*^9, 3.7773330946917467`*^9}, {
   3.778167462798285*^9, 
   3.7781674630878468`*^9}},ExpressionUUID->"1f16c967-d72d-40ee-b17b-\
f7d752098f67"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "g2", " ", "h"}], "-", 
          RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"g2", " ", "h"}], "-", 
       RowBox[{"g3", " ", "r0"}]}], "r0"]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g2", " ", "k"}], "r0"], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "k"}], "+", 
         RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"eta", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "h", " ", "r0"}], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "g2", " ", "h"}], "-", 
             RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], "beta"], "-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], "r"]}], ")"}]}], 
      SuperscriptBox["r0", "4"]]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "g2"}], " ", "h", " ", "r0"}], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "g2", " ", "h"}], "-", 
                RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], "beta"], "-", 
            
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], "r"]}], ")"}]}], 
         SuperscriptBox["r0", "4"]]}], ")"}], " ", "v0"}], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "h", " ", "r0"}], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "g2", " ", "h"}], "-", 
             RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], "beta"], "-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], "r"]}], ")"}], " ", 
       "x0"}], 
      SuperscriptBox["r0", "4"]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "g2", " ", "h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["h", "2"], " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "g2"}], " ", "h", " ", "r0"}], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "g2", " ", "h"}], "-", 
                RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], "beta"], "-", 
            
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], "r"]}], ")"}]}], 
         SuperscriptBox["r0", "4"]]}], ")"}], " ", "v0"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "g2"}], " ", "h", " ", "r0"}], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "g2", " ", "h"}], "-", 
                RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], "beta"], "-", 
            
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], "r"]}], ")"}]}], 
         SuperscriptBox["r0", "4"]]}], ")"}], " ", "x0"}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.7771333842931643`*^9, 3.777333044478284*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"c36af7f3-4c19-4d17-bc2d-743e3dc3b2e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"TeXForm", "[", 
   RowBox[{
    RowBox[{"dk", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "c13", " ", "c1"}], 
        RowBox[{"r", " ", 
         SuperscriptBox["r0", "2"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"g2", " ", "h"}], "-", 
         RowBox[{"g3", " ", "r0"}]}], "r0"], "-", 
       FractionBox[
        RowBox[{"k", " ", "c9"}], 
        RowBox[{"beta", " ", 
         SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
    RowBox[{"dh", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"g2", " ", "k"}], "r0"], "+", 
       FractionBox[
        RowBox[{"k", " ", "c13"}], 
        RowBox[{"r", " ", "r0"}]], "+", 
       FractionBox[
        RowBox[{"g2", " ", "k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "beta"}], "+", 
           FractionBox[
            RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", "c13"}], 
        RowBox[{"r", " ", "r0"}]], "-", 
       RowBox[{"eta", " ", "c10"}]}], ")"}]}], "+", 
    RowBox[{"dx0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"g2", " ", "k", " ", "c13"}], 
            RowBox[{"r", " ", "r0"}]]}], "-", 
          RowBox[{"h", " ", "c10"}]}], ")"}], " ", "v0"}], "+", 
       RowBox[{"c10", " ", "x0"}]}], ")"}]}], "+", 
    RowBox[{"dv0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          StyleBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"k", " ", "c9"}], 
              RowBox[{"beta", " ", "r0"}]], "-", 
             FractionBox[
              RowBox[{"d", " ", "k", " ", "c13"}], 
              RowBox[{"r", " ", "r0"}]]}], ")"}],
           FontSlant->"Italic",
           FontColor->GrayLevel[0]], "+", 
          FractionBox[
           RowBox[{"2", " ", "g2", " ", "h", " ", "k", " ", "c13"}], 
           RowBox[{"r", " ", "r0"}]], "+", 
          RowBox[{
           SuperscriptBox["h", "2"], " ", "c10"}]}], ")"}], " ", "v0"}], "+", 
       
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"g2", " ", "k", " ", "c13"}], 
            RowBox[{"r", " ", "r0"}]]}], "-", 
          RowBox[{"h", " ", "c10"}]}], ")"}], " ", "x0"}]}], ")"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7773110087151537`*^9, 3.777311017004108*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"29de0093-8b3b-43b3-a83e-06aa1f8448cc"],

Cell["\<\
\\text{dk} \\left(-\\frac{\\text{c9} k}{\\beta  \
\\text{r0}^2}+\\frac{\\text{c1} \\text{c13} k}{r \
\\text{r0}^2}+\\frac{\\text{g2}
   h-\\text{g3} \\text{r0}}{\\text{r0}}\\right)+\\text{dv0} \\left(\\text{v0} \
\\left(\\frac{\\text{c9} k}{\\beta 
   \\text{r0}}+\\text{c10} h^2-\\frac{\\text{c13} d k}{r \\text{r0}}+\\frac{2 \
\\text{c13} \\text{g2} h k}{r
   \\text{r0}}\\right)+\\text{x0} \\left(-\\text{c10} h-\\frac{\\text{c13} \
\\text{g2} k}{r \\text{r0}}\\right)\\right)+\\text{dh}
   \\left(\\frac{\\text{c13} \\text{g2} k \\left(\\frac{2 \
k}{\\text{r0}}-\\beta \\right)}{r \\text{r0}}-\\text{c10} \\eta
   +\\frac{\\text{c13} k}{r \\text{r0}}+\\frac{\\text{g2} \
k}{\\text{r0}}\\right)+\\text{dx0} \\left(\\text{v0} \\left(-\\text{c10}
   h-\\frac{\\text{c13} \\text{g2} k}{r \\text{r0}}\\right)+\\text{c10} \
\\text{x0}\\right)\
\>", "Output",
 CellChangeTimes->{3.777311017963681*^9},
 CellLabel->
  "Out[2]//TeXForm=",ExpressionUUID->"89ecec00-37ff-447d-8164-a885c12c1593"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"dgmhf", "-", "dgmhf2"}], " ", "/.", " ", 
  RowBox[{"g0", " ", "\[Rule]", " ", 
   RowBox[{"1", "-", 
    RowBox[{"beta", " ", "g2"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777120616379983*^9, 3.7771206264524813`*^9}, {
  3.77733306380396*^9, 3.77733306884333*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"afffa04e-4607-4f53-a2b2-4167649063c7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "dh"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g2", " ", "k"}], "r0"], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g2", " ", "k"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"eta", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "h", " ", "r0"}], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "g2", " ", "h"}], "-", 
             RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], "beta"], "-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], "r"]}], ")"}]}], 
      SuperscriptBox["r0", "4"]]}], ")"}]}], "+", 
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g2", " ", "k"}], "r0"], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "beta"}], "+", 
         FractionBox[
          RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "h"}], "-", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "-", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "g2"}], " ", "h", " ", "r0"}], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "g2", " ", "h"}], "-", 
                RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], "beta"], "-", 
            
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], "r"]}], ")"}]}], 
         SuperscriptBox["r0", "4"]]}], ")"}], " ", "v0"}], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "h", " ", "r0"}], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "g2", " ", "h"}], "-", 
             RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], "beta"], "-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], "r"]}], ")"}], " ", 
       "x0"}], 
      SuperscriptBox["r0", "4"]]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g3", " ", "k"}], 
             SuperscriptBox["r0", "2"]]}], "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", "g2", " ", "h"}], "-", 
               RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "h"}], "-", 
               RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
            SuperscriptBox["r0", "3"]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], " ", "v0"}], 
     "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g3", " ", "k"}], 
          SuperscriptBox["r0", "2"]]}], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h"}], "-", 
            RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r0", "3"]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}], " ", "x0"}]}], ")"}]}], "-", 
  
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "g2", " ", "h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["h", "2"], " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "g2"}], " ", "h", " ", "r0"}], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "g2", " ", "h"}], "-", 
                RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], "beta"], "-", 
            
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], "r"]}], ")"}]}], 
         SuperscriptBox["r0", "4"]]}], ")"}], " ", "v0"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "-", 
        FractionBox[
         RowBox[{"h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "g2"}], " ", "h", " ", "r0"}], "+", 
            FractionBox[
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "g2", " ", "h"}], "-", 
                RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], "beta"], "-", 
            
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", " ", "h"}], "-", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "k"}], "+", 
                RowBox[{"g1", " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}]}], "r"]}], ")"}]}], 
         SuperscriptBox["r0", "4"]]}], ")"}], " ", "x0"}]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "g2", " ", "h", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h"}], "-", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"r", " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "h"}], "-", 
            RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", "r0"}]], "+", 
        RowBox[{
         SuperscriptBox["h", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g3", " ", "k"}], 
             SuperscriptBox["r0", "2"]]}], "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", "g2", " ", "h"}], "-", 
               RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "h"}], "-", 
               RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
            SuperscriptBox["r0", "3"]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], " ", "v0"}], 
     "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "h"}], "-", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"g3", " ", "k"}], 
             SuperscriptBox["r0", "2"]]}], "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox["k", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", "g2", " ", "h"}], "-", 
               RowBox[{"3", " ", "g3", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r0", "4"]}]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "h"}], "-", 
               RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
            SuperscriptBox["r0", "3"]], "-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g1", " ", "h"}], "-", 
               RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", " ", "k"}], "+", 
               RowBox[{"g1", " ", 
                SuperscriptBox["r0", "2"]}]}], ")"}]}], 
            RowBox[{"r", " ", 
             SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}], " ", "x0"}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.777133386888022*^9, {3.777333047958289*^9, 3.77733306917607*^9}},
 CellLabel->"Out[21]=",ExpressionUUID->"259503a6-0148-4860-b116-fe7355d03a24"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777122771727023*^9, 3.777122774405879*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"43aa630a-e7ce-4256-af68-8e40c9c6ec93"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7771227749524612`*^9, 3.777122910748768*^9, 3.777129063392268*^9, 
   3.777133388830286*^9, {3.777333050269085*^9, 3.777333071250106*^9}},
 CellLabel->"Out[22]=",ExpressionUUID->"c6f18da8-de47-464d-bc4e-28ab976e90f7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Okay", ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"let", "'"}], "s", " ", "go", " ", "term"}], "-", "by", "-", 
       "term"}], " ", "&"}], " ", "Taylor", " ", "expand", " ", "in", " ", 
     "gamma", " ", "to", " ", "see", " ", "whether", " ", "there", " ", "is", 
     "\[IndentingNewLine]", "cancellation", " ", "in", " ", "some", " ", 
     RowBox[{"terms", ":"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"We", "'"}], "ll", " ", "start", " ", "with", " ", 
    RowBox[{"dk", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.777144322783677*^9, 3.7771443481868477`*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"4336da56-ade9-4e2d-bb64-5f5f3bf4b6d6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"k", " ", "c13", " ", "c1"}], 
              RowBox[{"r", " "}]], "-", 
             FractionBox[
              RowBox[{"k", " ", "c9"}], 
              RowBox[{"beta", " "}]]}], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7771443608188257`*^9, 3.7771445184117727`*^9}, {
  3.77714482881096*^9, 3.7771448417936707`*^9}, {3.777145011134482*^9, 
  3.777145018132366*^9}, {3.777814057083021*^9, 3.777814080280467*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"0ad12f9c-911d-421b-a2d2-1c8b254d5fb3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", "r0", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"60", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"49", " ", "k"}], "+", 
         RowBox[{"2", " ", "beta", " ", "r0"}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"2520", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", 
     SuperscriptBox["k", "2"], " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"144", " ", 
     SuperscriptBox["beta", "4"], " ", "r0"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 60] $CellContext`beta^
     Rational[-5, 2] $CellContext`k $CellContext`r0, 0, 
    Rational[-1, 2520] $CellContext`beta^Rational[-7, 2] $CellContext`k (
     49 $CellContext`k + 2 $CellContext`beta $CellContext`r0), 
    Rational[1, 
      144] $CellContext`beta^(-4) $CellContext`eta \
$CellContext`k^2/$CellContext`r0}, 5, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.777144479589797*^9, 3.777144532885117*^9}, 
   3.777144843747774*^9, 3.777145018879149*^9, 3.7771470206729918`*^9, {
   3.777814065657707*^9, 3.777814080648066*^9}},
 CellLabel->"Out[27]=",ExpressionUUID->"cf988364-0e18-41fd-8f8d-17be9a5203d5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            FractionBox[
             RowBox[{"k", " ", "c13", " ", "c1"}], 
             RowBox[{"r", " ", 
              SuperscriptBox["r0", "2"]}]], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.7771470268063307`*^9},
 CellLabel->"In[36]:=",ExpressionUUID->"81d05af4-3b76-43c9-88e8-7ed34c5224d7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "3"]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", "k", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "5"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 5, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 2] $CellContext`beta^
     Rational[-5, 2] $CellContext`k/$CellContext`r0, 
    Rational[1, 
      2] $CellContext`beta^(-3) $CellContext`eta $CellContext`k \
$CellContext`r0^(-2)}, 3, 5, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7771470274956408`*^9},
 CellLabel->"Out[36]=",ExpressionUUID->"d1e11339-7206-4b44-90c9-14e279dfec84"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            FractionBox[
             RowBox[{
              RowBox[{"g2", " ", "h"}], "-", 
              RowBox[{"g3", " ", "r0"}]}], "r0"], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7771470368220673`*^9, 3.777147039165324*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"e4fb7760-72d8-4670-aa27-1ee0a57e56da"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "3"], 
    RowBox[{"3", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "2"], " ", "r0"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "5"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 5, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 3] $CellContext`beta^Rational[-3, 2], 
    Rational[1, 4] $CellContext`beta^(-2) $CellContext`eta/$CellContext`r0}, 
   3, 5, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777147039924736*^9},
 CellLabel->"Out[37]=",ExpressionUUID->"6031f999-6573-466d-bba4-95ea25d33a56"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"-", 
             FractionBox[
              RowBox[{"k", " ", "c9"}], 
              RowBox[{"beta", " ", 
               SuperscriptBox["r0", "2"]}]]}], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.7771470530931873`*^9},
 CellLabel->"In[38]:=",ExpressionUUID->"a9303ec7-a042-42aa-99a8-74419d4110db"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"k", " ", 
      SuperscriptBox["gamma", "3"]}], 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["beta", 
         RowBox[{"5", "/", "2"}]], " ", "r0"}], ")"}]}]]}], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", "k"}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "5"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 5, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 2] $CellContext`beta^
     Rational[-5, 2] $CellContext`k/$CellContext`r0, 
    Rational[-1, 
      2] $CellContext`beta^(-3) $CellContext`eta $CellContext`k \
$CellContext`r0^(-2)}, 3, 5, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777147053745447*^9},
 CellLabel->"Out[38]=",ExpressionUUID->"4df0fdfa-f09f-4a2d-b1d8-1979eabeb020"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"k", " ", "c13", " ", "c1"}], 
              RowBox[{"r", " ", 
               SuperscriptBox["r0", "2"]}]], "-", 
             FractionBox[
              RowBox[{"k", " ", "c9"}], 
              RowBox[{"beta", " ", 
               SuperscriptBox["r0", "2"]}]]}], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777147071555058*^9, 3.7771470787371273`*^9}},
 CellLabel->"In[40]:=",ExpressionUUID->"57d5efc0-c8b2-424a-bf25-f7f8c2d8f052"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"60", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 60] $CellContext`beta^
     Rational[-5, 2] $CellContext`k/$CellContext`r0}, 5, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.777147072336253*^9, 3.777147079162262*^9}},
 CellLabel->"Out[40]=",ExpressionUUID->"019ed7b7-b3be-4d20-8d18-08a83ea8450c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "c13", " ", "c1"}], 
        RowBox[{"r", " ", 
         SuperscriptBox["r0", "2"]}]], "-", 
       FractionBox[
        RowBox[{"k", " ", "c9"}], 
        RowBox[{"beta", " ", 
         SuperscriptBox["r0", "2"]}]]}], ")"}], "  ", "/.", " ", 
     RowBox[{"d", " ", "->", "  ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", " ", "g2"}], "+", 
         RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
     " ", 
    RowBox[{"zeta", " ", "\[Rule]", " ", 
     RowBox[{"k", "-", 
      RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
   RowBox[{"h", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
     RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
  RowBox[{"r", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
    RowBox[{"k", " ", "g2"}]}]}]}]], "Input",
 CellLabel->"In[41]:=",ExpressionUUID->"a4e0d5f5-906e-4e2c-8552-1c96e1528ea3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "3"}], " ", "g3", " ", "r0"}], "+", 
       RowBox[{"2", " ", "g2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g2"}], "+", 
          RowBox[{"g3", " ", "k"}], "+", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}]}], 
    RowBox[{"beta", " ", 
     SuperscriptBox["r0", "2"]}]]}], "+", 
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g2"}], " ", "r0"}], "+", 
      RowBox[{"g1", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g2"}], "+", 
         RowBox[{"g3", " ", "k"}], "+", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g3"}], " ", "r0"}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
        RowBox[{"3", " ", "g3", " ", "k"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}], 
   RowBox[{
    SuperscriptBox["r0", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{3.7771471041440277`*^9},
 CellLabel->"Out[41]=",ExpressionUUID->"4774699f-72f8-45a1-bfa1-0ce0023c5ba6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "3"}], " ", "g3", " ", "r0"}], "+", 
       RowBox[{"2", " ", "g2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g2"}], "+", 
          RowBox[{"g3", " ", "k"}], "+", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}]}], 
    RowBox[{"beta", " ", 
     SuperscriptBox["r0", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}], "+", 
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g2"}], " ", "r0"}], "+", 
      RowBox[{"g1", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g2"}], "+", 
         RowBox[{"g3", " ", "k"}], "+", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "beta"}], " ", "g3", " ", "r0"}], "+", 
      RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
      RowBox[{"3", " ", "g3", " ", "k"}], "+", 
      RowBox[{"g1", " ", "r0"}]}], ")"}]}], 
   RowBox[{
    SuperscriptBox["r0", "2"], " ", "beta", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}]], "Input",
 CellChangeTimes->{{3.777147112051366*^9, 3.777147132386804*^9}},
 CellLabel->"In[42]:=",ExpressionUUID->"8cf887cb-f59b-4352-a5da-3c6cc97f1a67"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
      RowBox[{"3", " ", "g3", " ", "k"}], "+", 
      RowBox[{"g1", " ", "r0"}], "-", 
      RowBox[{"beta", " ", "g3", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g2"}], " ", "r0"}], "+", 
      RowBox[{"g1", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g2"}], "+", 
         RowBox[{"g3", " ", "k"}], "+", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}]}], 
   RowBox[{"beta", " ", 
    SuperscriptBox["r0", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "3"}], " ", "g3", " ", "r0"}], "+", 
      RowBox[{"2", " ", "g2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g2"}], "+", 
         RowBox[{"g3", " ", "k"}], "+", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}]}], 
   RowBox[{"beta", " ", 
    SuperscriptBox["r0", "2"]}]]}]], "Output",
 CellChangeTimes->{3.777147133764215*^9},
 CellLabel->"Out[42]=",ExpressionUUID->"cd8c7fad-4c32-4f6c-82ea-e3104c1a2800"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Together", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777147144052038*^9, 3.777147145659536*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"925c512c-9f8f-4ca9-af57-6184aec2b95d"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"beta", " ", 
     SuperscriptBox["r0", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}]], 
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "eta", " ", 
       SuperscriptBox["g2", "3"], " ", "k"}], "-", 
      RowBox[{"3", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "k"}], 
      "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["g2", "2"], " ", "g3", " ", 
       SuperscriptBox["k", "2"]}], "-", 
      RowBox[{"3", " ", "g1", " ", 
       SuperscriptBox["g3", "2"], " ", 
       SuperscriptBox["k", "2"]}], "-", 
      RowBox[{"eta", " ", 
       SuperscriptBox["g1", "2"], " ", "g2", " ", "r0"}], "+", 
      RowBox[{"2", " ", "eta", " ", 
       SuperscriptBox["g2", "2"], " ", "r0"}], "+", 
      RowBox[{"2", " ", "eta", " ", "g0", " ", 
       SuperscriptBox["g2", "2"], " ", "r0"}], "-", 
      RowBox[{"3", " ", "eta", " ", "g1", " ", "g3", " ", "r0"}], "+", 
      RowBox[{
      "beta", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "r0"}], "+", 
      RowBox[{"2", " ", "g1", " ", 
       SuperscriptBox["g2", "2"], " ", "k", " ", "r0"}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["g1", "2"], " ", "g3", " ", "k", " ", "r0"}], "+", 
      RowBox[{"2", " ", "g0", " ", "g2", " ", "g3", " ", "k", " ", "r0"}], 
      "+", 
      RowBox[{"beta", " ", "g1", " ", 
       SuperscriptBox["g3", "2"], " ", "k", " ", "r0"}], "-", 
      RowBox[{
       SuperscriptBox["g1", "3"], " ", 
       SuperscriptBox["r0", "2"]}], "+", 
      RowBox[{"g1", " ", "g2", " ", 
       SuperscriptBox["r0", "2"]}], "+", 
      RowBox[{"2", " ", "g0", " ", "g1", " ", "g2", " ", 
       SuperscriptBox["r0", "2"]}], "-", 
      RowBox[{"3", " ", "g0", " ", "g3", " ", 
       SuperscriptBox["r0", "2"]}], "+", 
      RowBox[{"beta", " ", 
       SuperscriptBox["g1", "2"], " ", "g3", " ", 
       SuperscriptBox["r0", "2"]}], "-", 
      RowBox[{"beta", " ", "g2", " ", "g3", " ", 
       SuperscriptBox["r0", "2"]}]}], ")"}]}]}]}]], "Output",
 CellChangeTimes->{3.777147145942965*^9},
 CellLabel->"Out[43]=",ExpressionUUID->"d99648c5-f2cf-4f21-ae95-c8c187af7af0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "eta", " ", 
      SuperscriptBox["g2", "3"], " ", "k"}], "-", 
     RowBox[{"3", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "k"}], 
     "+", 
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"], " ", "g3", " ", 
      SuperscriptBox["k", "2"]}], "-", 
     RowBox[{"3", " ", "g1", " ", 
      SuperscriptBox["g3", "2"], " ", 
      SuperscriptBox["k", "2"]}], "-", 
     RowBox[{"eta", " ", 
      SuperscriptBox["g1", "2"], " ", "g2", " ", "r0"}], "+", 
     RowBox[{"2", " ", "eta", " ", 
      SuperscriptBox["g2", "2"], " ", "r0"}], "+", 
     RowBox[{"2", " ", "eta", " ", "g0", " ", 
      SuperscriptBox["g2", "2"], " ", "r0"}], "-", 
     RowBox[{"3", " ", "eta", " ", "g1", " ", "g3", " ", "r0"}], "+", 
     RowBox[{"beta", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "r0"}],
      "+", 
     RowBox[{"2", " ", "g1", " ", 
      SuperscriptBox["g2", "2"], " ", "k", " ", "r0"}], "-", 
     RowBox[{"4", " ", 
      SuperscriptBox["g1", "2"], " ", "g3", " ", "k", " ", "r0"}], "+", 
     RowBox[{"2", " ", "g0", " ", "g2", " ", "g3", " ", "k", " ", "r0"}], "+", 
     RowBox[{"beta", " ", "g1", " ", 
      SuperscriptBox["g3", "2"], " ", "k", " ", "r0"}], "-", 
     RowBox[{
      SuperscriptBox["g1", "3"], " ", 
      SuperscriptBox["r0", "2"]}], "+", 
     RowBox[{"g1", " ", "g2", " ", 
      SuperscriptBox["r0", "2"]}], "+", 
     RowBox[{"2", " ", "g0", " ", "g1", " ", "g2", " ", 
      SuperscriptBox["r0", "2"]}], "-", 
     RowBox[{"3", " ", "g0", " ", "g3", " ", 
      SuperscriptBox["r0", "2"]}], "+", 
     RowBox[{"beta", " ", 
      SuperscriptBox["g1", "2"], " ", "g3", " ", 
      SuperscriptBox["r0", "2"]}], "-", 
     RowBox[{"beta", " ", "g2", " ", "g3", " ", 
      SuperscriptBox["r0", "2"]}]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"eta", ",", "k", ",", 
     SuperscriptBox["r0", "2"]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777147153939155*^9, 3.777147161178846*^9}, {
  3.777147201110815*^9, 3.777147203705152*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"a56c4eb4-7af8-4a94-ab2f-55e7ca27a5fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"], " ", "g3"}], "-", 
     RowBox[{"3", " ", "g1", " ", 
      SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "g1", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"4", " ", 
      SuperscriptBox["g1", "2"], " ", "g3"}], "+", 
     RowBox[{"2", " ", "g0", " ", "g2", " ", "g3"}], "+", 
     RowBox[{"beta", " ", "g1", " ", 
      SuperscriptBox["g3", "2"]}]}], ")"}], " ", "k", " ", "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["g1", "3"]}], "+", 
     RowBox[{"g1", " ", "g2"}], "+", 
     RowBox[{"2", " ", "g0", " ", "g1", " ", "g2"}], "-", 
     RowBox[{"3", " ", "g0", " ", "g3"}], "+", 
     RowBox[{"beta", " ", 
      SuperscriptBox["g1", "2"], " ", "g3"}], "-", 
     RowBox[{"beta", " ", "g2", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", 
         SuperscriptBox["g2", "3"]}], "-", 
        RowBox[{"3", " ", "g1", " ", "g2", " ", "g3"}]}], ")"}], " ", "k"}], 
     "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox["g1", "2"]}], " ", "g2"}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["g2", "2"]}], "+", 
        RowBox[{"2", " ", "g0", " ", 
         SuperscriptBox["g2", "2"]}], "-", 
        RowBox[{"3", " ", "g1", " ", "g3"}], "+", 
        RowBox[{"beta", " ", "g1", " ", "g2", " ", "g3"}]}], ")"}], " ", 
      "r0"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.777147161583881*^9, 3.7771472041658497`*^9},
 CellLabel->"Out[45]=",ExpressionUUID->"ae8d0aa7-2315-4bf8-9ecd-02fff6b2f38a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       SuperscriptBox["g2", "3"]}], "-", 
      RowBox[{"3", " ", "g1", " ", "g2", " ", "g3"}]}], ")"}], " ", "/.", " ", 
    RowBox[{"g2", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
    " ", 
   RowBox[{"g1", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"Sin", "[", "gamma", "]"}], "/", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777147215012599*^9, 3.777147247226646*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"c18c66f8-9efc-4116-8e14-f91704c16293"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "3"]}], 
   SuperscriptBox["beta", "3"]], "-", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"gamma", "-", 
      RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sin", "[", "gamma", "]"}]}], 
   SuperscriptBox["beta", "3"]]}]], "Output",
 CellChangeTimes->{3.777147248223639*^9},
 CellLabel->"Out[46]=",ExpressionUUID->"752554c8-cf61-4416-9709-9027271f412b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"Out", "[", "46", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777147279810199*^9, 3.777147300232751*^9}, {
  3.777147345504785*^9, 3.7771473457189913`*^9}},
 CellLabel->"In[54]:=",ExpressionUUID->"2defd221-78ef-4679-9e81-5f9c2044b560"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "8"], 
    RowBox[{"80", " ", 
     SuperscriptBox["beta", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 8, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {Rational[1, 80] $CellContext`beta^(-3)}, 
   8, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.77714728388734*^9, 3.7771473006081247`*^9}, 
   3.7771473461777487`*^9},
 CellLabel->"Out[54]=",ExpressionUUID->"40a5c627-5309-4792-9807-77673e1a998b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", 
         SuperscriptBox["g2", "2"], " ", "g3"}], "-", 
        RowBox[{"3", " ", "g1", " ", 
         SuperscriptBox["g3", "2"]}]}], ")"}], "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g1", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "gamma", "]"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777147361919284*^9, 3.7771473830082083`*^9}},
 CellLabel->"In[56]:=",ExpressionUUID->"d3201130-3c76-4061-9ce4-475056c837a6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "9"], 
    RowBox[{"240", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "11"],
    SeriesData[$CellContext`gamma, 0, {}, 9, 11, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 240] $CellContext`beta^Rational[-7, 2]}, 9, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.777147373925515*^9, 3.777147383337078*^9}},
 CellLabel->"Out[56]=",ExpressionUUID->"1ae349f7-50fe-4f5a-ac23-5f8e9abc31b9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "g1", " ", 
          SuperscriptBox["g2", "2"]}], "-", 
         RowBox[{"4", " ", 
          SuperscriptBox["g1", "2"], " ", "g3"}], "+", 
         RowBox[{"2", " ", "g0", " ", "g2", " ", "g3"}], "+", 
         RowBox[{"beta", " ", "g1", " ", 
          SuperscriptBox["g3", "2"]}]}], ")"}], "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g1", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "gamma", "]"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.77714740520656*^9, 3.777147421821056*^9}},
 CellLabel->"In[58]:=",ExpressionUUID->"facff28c-fecd-41a0-9413-b418de533def"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "7"], 
    RowBox[{"90", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "-", 
   FractionBox[
    RowBox[{"79", " ", 
     SuperscriptBox["gamma", "9"]}], 
    RowBox[{"15120", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "11"],
    SeriesData[$CellContext`gamma, 0, {}, 7, 11, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 90] $CellContext`beta^Rational[-5, 2], 0, 
    Rational[-79, 15120] $CellContext`beta^Rational[-5, 2]}, 7, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.77714740579674*^9, 3.777147422262813*^9}},
 CellLabel->"Out[58]=",ExpressionUUID->"db9df37a-0324-4608-aebf-d29f014553b0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox["g1", "3"]}], "+", 
         RowBox[{"g1", " ", "g2"}], "+", 
         RowBox[{"2", " ", "g0", " ", "g1", " ", "g2"}], "-", 
         RowBox[{"3", " ", "g0", " ", "g3"}], "+", 
         RowBox[{"beta", " ", 
          SuperscriptBox["g1", "2"], " ", "g3"}], "-", 
         RowBox[{"beta", " ", "g2", " ", "g3"}]}], ")"}], "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g1", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "gamma", "]"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.777147447182577*^9},
 CellLabel->"In[59]:=",ExpressionUUID->"b00a7211-f5f3-4e86-913d-151f531adb6a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "5"], 
     RowBox[{"60", " ", 
      SuperscriptBox["beta", 
       RowBox[{"3", "/", "2"}]]}]]}], "+", 
   FractionBox[
    RowBox[{"23", " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"2520", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "-", 
   FractionBox[
    RowBox[{"67", " ", 
     SuperscriptBox["gamma", "9"]}], 
    RowBox[{"60480", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "11"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 11, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 60] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[23, 2520] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[-67, 60480] $CellContext`beta^Rational[-3, 2]}, 5, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777147447866583*^9},
 CellLabel->"Out[59]=",ExpressionUUID->"917dbca0-e2c8-4ee3-9180-84f1ccee710a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["g1", "2"]}], " ", "g2"}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["g2", "2"]}], "+", 
         RowBox[{"2", " ", "g0", " ", 
          SuperscriptBox["g2", "2"]}], "-", 
         RowBox[{"3", " ", "g1", " ", "g3"}], "+", 
         RowBox[{"beta", " ", "g1", " ", "g2", " ", "g3"}]}], ")"}], "/.", 
       " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g1", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "gamma", "]"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.777147474661696*^9},
 CellLabel->"In[60]:=",ExpressionUUID->"b1341a42-d448-441f-85a0-96e8885c5e0d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "6"], 
     RowBox[{"60", " ", 
      SuperscriptBox["beta", "2"]}]]}], "+", 
   FractionBox[
    SuperscriptBox["gamma", "8"], 
    RowBox[{"280", " ", 
     SuperscriptBox["beta", "2"]}]], "-", 
   FractionBox[
    RowBox[{"29", " ", 
     SuperscriptBox["gamma", "10"]}], 
    RowBox[{"100800", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "11"],
    SeriesData[$CellContext`gamma, 0, {}, 6, 11, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 60] $CellContext`beta^(-2), 0, 
    Rational[1, 280] $CellContext`beta^(-2), 0, 
    Rational[-29, 100800] $CellContext`beta^(-2)}, 6, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777147475533559*^9},
 CellLabel->"Out[60]=",ExpressionUUID->"c520c2dc-4625-4161-8d91-6f7591be20b4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SuperscriptBox["g2", "2"], " ", "g3"}], "-", 
           RowBox[{"3", " ", "g1", " ", 
            SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
         SuperscriptBox["k", "2"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "g1", " ", 
            SuperscriptBox["g2", "2"]}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["g1", "2"], " ", "g3"}], "+", 
           RowBox[{"2", " ", "g0", " ", "g2", " ", "g3"}], "+", 
           RowBox[{"beta", " ", "g1", " ", 
            SuperscriptBox["g3", "2"]}]}], ")"}], " ", "k", " ", "r0"}], "+", 
        
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["g1", "3"]}], "+", 
           RowBox[{"g1", " ", "g2"}], "+", 
           RowBox[{"2", " ", "g0", " ", "g1", " ", "g2"}], "-", 
           RowBox[{"3", " ", "g0", " ", "g3"}], "+", 
           RowBox[{"beta", " ", 
            SuperscriptBox["g1", "2"], " ", "g3"}], "-", 
           RowBox[{"beta", " ", "g2", " ", "g3"}]}], ")"}], " ", 
         SuperscriptBox["r0", "2"]}], "+", 
        RowBox[{"eta", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               SuperscriptBox["g2", "3"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g2", " ", "g3"}]}], ")"}], " ", 
            "k"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["g1", "2"]}], " ", "g2"}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["g2", "2"]}], "+", 
              RowBox[{"2", " ", "g0", " ", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g3"}], "+", 
              RowBox[{"beta", " ", "g1", " ", "g2", " ", "g3"}]}], ")"}], " ",
             "r0"}]}], ")"}]}]}], "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g1", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "gamma", "]"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7771474973097773`*^9, 3.7771475042038107`*^9}},
 CellLabel->"In[62]:=",ExpressionUUID->"71ecaf4f-2cc1-461f-bcd4-06af3b298ea8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      SuperscriptBox["r0", "2"], " ", 
      SuperscriptBox["gamma", "5"]}], 
     RowBox[{"60", " ", 
      SuperscriptBox["beta", 
       RowBox[{"3", "/", "2"}]]}]]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "6"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 6, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 60] $CellContext`beta^Rational[-3, 2] $CellContext`r0^2}, 5, 
   6, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.777147500097369*^9, 3.777147504638085*^9}},
 CellLabel->"Out[62]=",ExpressionUUID->"e3158220-8f33-4a6c-a2bd-de061bbb968d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Moving", " ", "on", " ", "to", " ", "dh", " ", 
    RowBox[{"term", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.777147984158415*^9, 3.777147992056254*^9}},
 CellLabel->"In[63]:=",ExpressionUUID->"8b2f4841-bfb9-4ca9-b0b7-131b09edaceb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"g2", " ", "k"}], "r0"], "+", 
             FractionBox[
              RowBox[{"k", " ", "c13"}], 
              RowBox[{"r", " ", "r0"}]], "+", 
             FractionBox[
              RowBox[{"g2", " ", "k", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "beta"}], "+", 
                 FractionBox[
                  RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", "c13"}], 
              RowBox[{"r", " ", "r0"}]], "-", 
             RowBox[{"eta", " ", "c10"}]}], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.7771480091154623`*^9},
 CellLabel->"In[64]:=",ExpressionUUID->"f2352cd0-ff7f-47ca-8b9c-df39ec744830"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "2"]}], 
    RowBox[{"beta", " ", "r0"}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", "k", " ", 
     SuperscriptBox["gamma", "3"]}], 
    RowBox[{
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]], " ", 
     SuperscriptBox["r0", "2"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          SuperscriptBox["eta", "2"]}], "-", 
         RowBox[{"5", " ", "k", " ", "r0"}], "+", 
         RowBox[{"4", " ", "beta", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"12", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "2"], " ", 
       SuperscriptBox["r0", "3"]}], ")"}]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "11"}], " ", 
          SuperscriptBox["k", "2"]}], "+", 
         RowBox[{"15", " ", "beta", " ", "k", " ", "r0"}]}], ")"}]}], ")"}], 
     " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"60", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"5", "/", "2"}]], " ", 
       SuperscriptBox["r0", "3"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "15"}], " ", "beta", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"15", " ", 
        SuperscriptBox["k", "2"]}], "-", 
       RowBox[{"28", " ", "beta", " ", "k", " ", "r0"}], "+", 
       RowBox[{"16", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"360", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 2, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {$CellContext`beta^(-1) $CellContext`k/$CellContext`r0, \
$CellContext`beta^
     Rational[-3, 2] $CellContext`eta $CellContext`k $CellContext`r0^(-2), 
    Rational[-1, 
      12] $CellContext`beta^(-2) $CellContext`k $CellContext`r0^(-3) ((-3) \
$CellContext`eta^2 - 5 $CellContext`k $CellContext`r0 + 
     4 $CellContext`beta $CellContext`r0^2), 
    Rational[-1, 60] $CellContext`beta^
     Rational[-5, 
       2] $CellContext`eta $CellContext`r0^(-3) ((-11) $CellContext`k^2 + 
     15 $CellContext`beta $CellContext`k $CellContext`r0), 
    Rational[1, 
      360] $CellContext`beta^(-3) $CellContext`k $CellContext`r0^(-3) ((-15) \
$CellContext`beta $CellContext`eta^2 - 15 $CellContext`k^2 - 
     28 $CellContext`beta $CellContext`k $CellContext`r0 + 
     16 $CellContext`beta^2 $CellContext`r0^2)}, 2, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7771480098117647`*^9},
 CellLabel->"Out[64]=",ExpressionUUID->"b3640090-2af8-41ba-90ed-6f06b25dad1b"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{
  3.777148007056919*^9},ExpressionUUID->"3abd8fe3-5f4f-4ba8-b50c-\
b4bb51f115b9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            FractionBox[
             RowBox[{"g2", " ", "k"}], "r0"], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.777148079266013*^9},
 CellLabel->"In[65]:=",ExpressionUUID->"13f47c66-1a92-46f1-acdb-21f014e2fc96"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "2"]}], 
    RowBox[{"2", " ", "beta", " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"24", " ", 
     RowBox[{"(", 
      RowBox[{"beta", " ", "r0"}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"720", " ", "beta", " ", "r0"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 2, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 2] $CellContext`beta^(-1) $CellContext`k/$CellContext`r0, 0, 
    Rational[-1, 24] $CellContext`beta^(-1) $CellContext`k/$CellContext`r0, 0,
     Rational[1, 720] $CellContext`beta^(-1) $CellContext`k/$CellContext`r0}, 
   2, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148080669916*^9},
 CellLabel->"Out[65]=",ExpressionUUID->"872fc813-a9f7-447a-a546-e4870721f029"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            FractionBox[
             RowBox[{"k", " ", "c13"}], 
             RowBox[{"r", " ", "r0"}]], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777148094785429*^9, 3.777148100880722*^9}},
 CellLabel->"In[66]:=",ExpressionUUID->"7304d6b2-0f93-4486-8d8c-15af85813aab"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "2"]}], 
    RowBox[{"2", " ", "beta", " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "k"}], "+", 
         RowBox[{"beta", " ", "r0"}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"24", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "2"], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", 
     SuperscriptBox["k", "2"], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"12", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "60"}], " ", 
        SuperscriptBox["eta", "2"], " ", "k"}], "+", 
       RowBox[{"30", " ", 
        SuperscriptBox["k", "2"], " ", "r0"}], "-", 
       RowBox[{"26", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "3"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"720", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "4"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 2, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 2] $CellContext`beta^(-1) $CellContext`k/$CellContext`r0, 0, 
    Rational[-1, 
      24] $CellContext`beta^(-2) $CellContext`k $CellContext`r0^(-2) (
     2 $CellContext`k + $CellContext`beta $CellContext`r0), 
    Rational[1, 12] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta $CellContext`k^2 $CellContext`r0^(-3), 
    Rational[1, 
      720] $CellContext`beta^(-3) $CellContext`k $CellContext`r0^(-4) ((-60) \
$CellContext`eta^2 $CellContext`k + 30 $CellContext`k^2 $CellContext`r0 - 
     26 $CellContext`beta $CellContext`k $CellContext`r0^2 + \
$CellContext`beta^2 $CellContext`r0^3)}, 2, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148101422533*^9},
 CellLabel->"Out[66]=",ExpressionUUID->"5cdb5760-dc4b-4eb8-910e-e3e8bba01bf7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            FractionBox[
             RowBox[{"g2", " ", "k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "beta"}], "+", 
                FractionBox[
                 RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", "c13"}], 
             RowBox[{"r", " ", "r0"}]], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777148114904785*^9, 3.777148117264184*^9}},
 CellLabel->"In[67]:=",ExpressionUUID->"12b18faf-c4a1-4ec8-a682-8e33f9cf2387"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "2"}], " ", "k"}], "+", 
          RowBox[{"beta", " ", "r0"}]}], ")"}]}], ")"}], " ", 
      SuperscriptBox["gamma", "4"]}], 
     RowBox[{"4", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "2"]}], ")"}]}]]}], "+", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "k"}], "+", 
       RowBox[{"beta", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"k", "+", 
       RowBox[{"beta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 
      4] $CellContext`beta^(-2) $CellContext`k $CellContext`r0^(-2) ((-2) \
$CellContext`k + $CellContext`beta $CellContext`r0), 0, 
    Rational[1, 
      24] $CellContext`beta^(-3) $CellContext`k $CellContext`r0^(-3) ((-2) \
$CellContext`k + $CellContext`beta $CellContext`r0) ($CellContext`k + \
$CellContext`beta $CellContext`r0)}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148117990967*^9},
 CellLabel->"Out[67]=",ExpressionUUID->"8da9ff3e-645d-408f-a92d-24dc5789b39b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "eta"}], " ", "c10"}], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.777148132856077*^9},
 CellLabel->"In[68]:=",ExpressionUUID->"307edaa9-a985-4d9e-8d25-53dccec330d4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"eta", " ", "k", " ", 
     SuperscriptBox["gamma", "3"]}], 
    RowBox[{
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     SuperscriptBox["eta", "2"], " ", "k", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "2"], " ", 
     SuperscriptBox["r0", "3"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", "k"}], "+", 
         RowBox[{"5", " ", "beta", " ", "r0"}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"20", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"5", "/", "2"}]], " ", 
       SuperscriptBox["r0", "3"]}], ")"}]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["eta", "2"], " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", "k"}], "+", 
         RowBox[{"beta", " ", "r0"}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"24", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", 
       SuperscriptBox["r0", "4"]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {$CellContext`beta^
     Rational[-3, 2] $CellContext`eta $CellContext`k $CellContext`r0^(-2), 
    Rational[1, 
      4] $CellContext`beta^(-2) $CellContext`eta^2 $CellContext`k \
$CellContext`r0^(-3), 
    Rational[-1, 20] $CellContext`beta^
     Rational[-5, 
       2] $CellContext`eta $CellContext`k $CellContext`r0^(-3) ((-2) \
$CellContext`k + 5 $CellContext`beta $CellContext`r0), 
    Rational[-1, 
      24] $CellContext`beta^(-3) $CellContext`eta^2 $CellContext`k \
$CellContext`r0^(-4) ((-2) $CellContext`k + $CellContext`beta \
$CellContext`r0)}, 3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.77714813353231*^9},
 CellLabel->"Out[68]=",ExpressionUUID->"caa8d69f-4df5-4059-ad6c-f5997cc0dc20"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Let", "'"}], "s", " ", "examine", " ", "c10", " ", 
    RowBox[{"term", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.777148189466587*^9, 3.77714819893983*^9}},
 CellLabel->"In[69]:=",ExpressionUUID->"463660b4-ef2e-4c47-b1c0-81abfe9ad33c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", " ", "g2"}], " ", "r0", " ", "h"}], "+", 
             FractionBox[
              RowBox[{"k", " ", "c9"}], "beta"], "-", 
             FractionBox[
              RowBox[{"c13", " ", "c3"}], "r"]}], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.7771482103330307`*^9},
 CellLabel->"In[70]:=",ExpressionUUID->"32c4b847-2c7b-4c4d-9dbf-dbdc2e557eb9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      SuperscriptBox["r0", "2"], " ", 
      SuperscriptBox["gamma", "3"]}], 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]]}], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", "r0"}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "k", " ", "r0"}], "+", 
       RowBox[{"5", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"20", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "k"}], "+", 
       RowBox[{"beta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {-$CellContext`beta^Rational[-3, 2] $CellContext`r0^2, 
    Rational[-1, 4] $CellContext`beta^(-2) $CellContext`eta $CellContext`r0, 
    Rational[1, 20] $CellContext`beta^
     Rational[-5, 2] ((-2) $CellContext`k $CellContext`r0 + 
     5 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 
      24] $CellContext`beta^(-3) $CellContext`eta ((-2) $CellContext`k + \
$CellContext`beta $CellContext`r0)}, 3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148210867839*^9},
 CellLabel->"Out[70]=",ExpressionUUID->"29a3ccb8-3aed-407d-8412-70a928a3097e"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{
  3.7771482087493896`*^9},ExpressionUUID->"2246bbc1-f052-4de4-b62a-\
b4a6b7f37482"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", " ", "g2"}], " ", "r0", " ", "h"}], ")"}], "  ", "/.",
            " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.777148219115857*^9},
 CellLabel->"In[71]:=",ExpressionUUID->"f0b5b712-2c5e-4564-83f7-7a57ea6f4dd1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      SuperscriptBox["r0", "2"], " ", 
      SuperscriptBox["gamma", "3"]}], 
     RowBox[{"2", " ", 
      SuperscriptBox["beta", 
       RowBox[{"3", "/", "2"}]]}]]}], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", "r0"}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   FractionBox[
    RowBox[{"r0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "k"}], "+", 
       RowBox[{"3", " ", "beta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", "r0", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 2] $CellContext`beta^Rational[-3, 2] $CellContext`r0^2, 
    Rational[-1, 4] $CellContext`beta^(-2) $CellContext`eta $CellContext`r0, 
    Rational[1, 24] $CellContext`beta^
     Rational[-5, 2] $CellContext`r0 ((-2) $CellContext`k + 
     3 $CellContext`beta $CellContext`r0), 
    Rational[1, 24] $CellContext`beta^(-2) $CellContext`eta $CellContext`r0}, 
   3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148219645678*^9},
 CellLabel->"Out[71]=",ExpressionUUID->"e5afc625-59de-4e6c-871f-6d9b1f6a6314"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            FractionBox[
             RowBox[{"k", " ", "c9"}], "beta"], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777148232029467*^9, 3.777148233956427*^9}},
 CellLabel->"In[72]:=",ExpressionUUID->"8f41473e-aede-4ea9-b4d8-34e45eec293f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", "r0", " ", 
     SuperscriptBox["gamma", "3"]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", "k", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", "3"]}]], "+", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"20", " ", "k"}], "-", 
       RowBox[{"27", " ", "beta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"120", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", "k"}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"12", " ", 
     SuperscriptBox["beta", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 2] $CellContext`beta^
     Rational[-5, 2] $CellContext`k $CellContext`r0, 
    Rational[1, 2] $CellContext`beta^(-3) $CellContext`eta $CellContext`k, 
    Rational[1, 120] $CellContext`beta^Rational[-7, 2] $CellContext`k (
     20 $CellContext`k - 27 $CellContext`beta $CellContext`r0), 
    Rational[-1, 12] $CellContext`beta^(-3) $CellContext`eta $CellContext`k}, 
   3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7771482344325647`*^9},
 CellLabel->"Out[72]=",ExpressionUUID->"ed1a6c32-25f7-48c6-9630-9ac539075be7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"-", 
             FractionBox[
              RowBox[{"c13", " ", "c3"}], "r"]}], ")"}], "  ", "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777148245037331*^9, 3.777148249460513*^9}},
 CellLabel->"In[73]:=",ExpressionUUID->"4e3f68e3-95a2-46b4-b0c2-5d28de4eb4d0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", "r0"}], "+", 
        RowBox[{"beta", " ", 
         SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
      SuperscriptBox["gamma", "3"]}], 
     RowBox[{"2", " ", 
      SuperscriptBox["beta", 
       RowBox[{"5", "/", "2"}]]}]]}], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", "k"}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", "3"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        SuperscriptBox["k", "2"]}], "+", 
       RowBox[{"5", " ", "beta", " ", "k", " ", "r0"}], "+", 
       RowBox[{"3", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 2] $CellContext`beta^
     Rational[-5, 
       2] ($CellContext`k $CellContext`r0 + $CellContext`beta \
$CellContext`r0^2), 
    Rational[-1, 2] $CellContext`beta^(-3) $CellContext`eta $CellContext`k, 
    Rational[1, 24] $CellContext`beta^Rational[-7, 2] ((-4) $CellContext`k^2 + 
     5 $CellContext`beta $CellContext`k $CellContext`r0 + 
     3 $CellContext`beta^2 $CellContext`r0^2)}, 3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7771482499349937`*^9},
 CellLabel->"Out[73]=",ExpressionUUID->"67b53371-8a34-447c-ab0a-a0bff79f827c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Next", ",", " ", 
    RowBox[{"examine", " ", 
     RowBox[{
      RowBox[{"dx0", ".", "v0"}], " ", "/", " ", 
      RowBox[{"dv0", ".", "x0"}]}], " ", 
     RowBox[{"term", ":"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"g2", " ", "k", " ", "c13"}], 
                RowBox[{"r", " ", "r0"}]]}], "-", 
              RowBox[{"h", " ", "c10"}]}], ")"}], "/.", " ", 
            RowBox[{"d", " ", "->", "  ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"h", "+", 
                RowBox[{"eta", " ", "g2"}], "+", 
                RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], 
           " ", "/.", " ", 
           RowBox[{"zeta", " ", "\[Rule]", " ", 
            RowBox[{"k", "-", 
             RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"1", "-", 
          RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7771483963245697`*^9, 3.777148422565332*^9}},
 CellLabel->"In[74]:=",ExpressionUUID->"cfedc785-9022-4fd5-b868-55e886c1232e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"3", " ", "k", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "2"], " ", "r0"}]], "+", 
   FractionBox[
    RowBox[{"3", " ", "eta", " ", "k", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", 
     SuperscriptBox["r0", "2"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "15"}], " ", 
          SuperscriptBox["eta", "2"]}], "-", 
         RowBox[{"37", " ", "k", " ", "r0"}], "+", 
         RowBox[{"45", " ", "beta", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"120", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", 
       SuperscriptBox["r0", "3"]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[3, 4] $CellContext`beta^(-2) $CellContext`k/$CellContext`r0, 
    Rational[3, 4] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta $CellContext`k $CellContext`r0^(-2), 
    Rational[-1, 
      120] $CellContext`beta^(-3) $CellContext`k $CellContext`r0^(-3) ((-15) \
$CellContext`eta^2 - 37 $CellContext`k $CellContext`r0 + 
     45 $CellContext`beta $CellContext`r0^2)}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148423326192*^9},
 CellLabel->"Out[74]=",ExpressionUUID->"6c860076-74a0-4a91-a688-b7c6f82fe522"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"-", 
             FractionBox[
              RowBox[{"g2", " ", "k", " ", "c13"}], 
              RowBox[{"r", " ", "r0"}]]}], ")"}], "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.777148433859825*^9},
 CellLabel->"In[75]:=",ExpressionUUID->"f3483aa2-3cb5-45ed-881d-47433b4a1252"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"k", " ", 
      SuperscriptBox["gamma", "4"]}], 
     RowBox[{"4", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["beta", "2"], " ", "r0"}], ")"}]}]]}], "+", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{"k", "+", 
       RowBox[{"beta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 4] $CellContext`beta^(-2) $CellContext`k/$CellContext`r0, 0, 
    Rational[1, 
      24] $CellContext`beta^(-3) $CellContext`k $CellContext`r0^(-2) \
($CellContext`k + $CellContext`beta $CellContext`r0)}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148434415374*^9},
 CellLabel->"Out[75]=",ExpressionUUID->"e58ed949-b99d-44b6-8ec3-1eadf9d42b1e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "h"}], " ", "c10"}], ")"}], "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.777148443995846*^9},
 CellLabel->"In[76]:=",ExpressionUUID->"fa8f5937-b618-4aa3-a75d-43f8c3669e5d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{
     SuperscriptBox["beta", "2"], " ", "r0"}]], "+", 
   FractionBox[
    RowBox[{"3", " ", "eta", " ", "k", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"15", " ", 
        SuperscriptBox["eta", "2"]}], "+", 
       RowBox[{"32", " ", "k", " ", "r0"}], "-", 
       RowBox[{"50", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"120", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {$CellContext`beta^(-2) $CellContext`k/$CellContext`r0, 
    Rational[3, 4] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta $CellContext`k $CellContext`r0^(-2), 
    Rational[1, 
      120] $CellContext`beta^(-3) $CellContext`k $CellContext`r0^(-3) (
     15 $CellContext`eta^2 + 32 $CellContext`k $CellContext`r0 - 
     50 $CellContext`beta $CellContext`r0^2)}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148444515561*^9},
 CellLabel->"Out[76]=",ExpressionUUID->"362c746e-45ff-4556-a92f-5442cad760a2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Finally", ",", " ", 
    RowBox[{
     RowBox[{"dv0", ".", "v0"}], " ", 
     RowBox[{"term", ":"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"d", " ", "k", " ", "c13"}], 
                RowBox[{"r", " ", "r0"}]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "g2", " ", "h", " ", "k", " ", "c13"}], 
               RowBox[{"r", " ", "r0"}]], "+", 
              FractionBox[
               RowBox[{"k", " ", "c9"}], 
               RowBox[{"beta", " ", "r0"}]], "+", 
              RowBox[{
               SuperscriptBox["h", "2"], " ", "c10"}]}], ")"}], "/.", " ", 
            RowBox[{"d", " ", "->", "  ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"h", "+", 
                RowBox[{"eta", " ", "g2"}], "+", 
                RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], 
           " ", "/.", " ", 
           RowBox[{"zeta", " ", "\[Rule]", " ", 
            RowBox[{"k", "-", 
             RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"1", "-", 
          RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777148505737908*^9, 3.77714852499618*^9}},
 CellLabel->"In[77]:=",ExpressionUUID->"a0d248b4-0a15-44ae-8252-4c2eb3598f4f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", "k", " ", 
      SuperscriptBox["gamma", "5"]}], 
     RowBox[{"5", " ", 
      SuperscriptBox["beta", 
       RowBox[{"5", "/", "2"}]]}]]}], "-", 
   FractionBox[
    RowBox[{"eta", " ", "k", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{
     SuperscriptBox["beta", "3"], " ", "r0"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-3, 5] $CellContext`beta^
     Rational[-5, 
       2] $CellContext`k, -$CellContext`beta^(-3) $CellContext`eta \
$CellContext`k/$CellContext`r0}, 5, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148525587256*^9},
 CellLabel->"Out[77]=",ExpressionUUID->"a9ba4979-6452-4cf5-9e1d-501d55bd40e0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"-", 
             FractionBox[
              RowBox[{"d", " ", "k", " ", "c13"}], 
              RowBox[{"r", " ", "r0"}]]}], ")"}], "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.777148532873973*^9},
 CellLabel->"In[78]:=",ExpressionUUID->"80bdb8b0-6e76-4447-8838-4a3a05ad2017"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"k", " ", 
      SuperscriptBox["gamma", "3"]}], 
     RowBox[{"2", " ", 
      SuperscriptBox["beta", 
       RowBox[{"5", "/", "2"}]]}]]}], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", "k"}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", "r0"}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "k"}], "+", 
       RowBox[{"3", " ", "beta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", "r0"}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", "k", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"12", " ", 
     SuperscriptBox["beta", "3"], " ", "r0"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 2] $CellContext`beta^Rational[-5, 2] $CellContext`k, 
    Rational[-1, 
      2] $CellContext`beta^(-3) $CellContext`eta \
$CellContext`k/$CellContext`r0, 
    Rational[1, 24] $CellContext`beta^
     Rational[-7, 2] $CellContext`k $CellContext`r0^(-1) ((-4) $CellContext`k + 
     3 $CellContext`beta $CellContext`r0), 
    Rational[1, 
      12] $CellContext`beta^(-3) $CellContext`eta \
$CellContext`k/$CellContext`r0}, 3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7771485333645144`*^9},
 CellLabel->"Out[78]=",ExpressionUUID->"14f454ad-ff43-4b5f-b271-abb2e41c0629"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            FractionBox[
             RowBox[{"2", " ", "g2", " ", "h", " ", "k", " ", "c13"}], 
             RowBox[{"r", " ", "r0"}]], ")"}], "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.7771485509866133`*^9},
 CellLabel->"In[79]:=",ExpressionUUID->"3e6d816e-9850-490b-a9ea-5ed1e5e803fe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", "k", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "3"], " ", "r0"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 2] $CellContext`beta^Rational[-5, 2] $CellContext`k, 
    Rational[1, 
      4] $CellContext`beta^(-3) $CellContext`eta \
$CellContext`k/$CellContext`r0}, 5, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148551523528*^9},
 CellLabel->"Out[79]=",ExpressionUUID->"0dbe6b70-2af7-4047-87b3-fdd0a873ff69"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            FractionBox[
             RowBox[{"k", " ", "c9"}], 
             RowBox[{"beta", " ", "r0"}]], ")"}], "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777148562673967*^9, 3.777148571271742*^9}},
 CellLabel->"In[80]:=",ExpressionUUID->"1792bf80-24f4-45cb-b0e1-54acfbd38e34"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "3"]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", "k", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", "3"], " ", "r0"}]], "+", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"20", " ", "k"}], "-", 
       RowBox[{"27", " ", "beta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"120", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", "k"}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"12", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", "r0"}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 2] $CellContext`beta^Rational[-5, 2] $CellContext`k, 
    Rational[1, 
      2] $CellContext`beta^(-3) $CellContext`eta \
$CellContext`k/$CellContext`r0, 
    Rational[1, 120] $CellContext`beta^
     Rational[-7, 2] $CellContext`k $CellContext`r0^(-1) (20 $CellContext`k - 
     27 $CellContext`beta $CellContext`r0), 
    Rational[-1, 
      12] $CellContext`beta^(-3) $CellContext`eta \
$CellContext`k/$CellContext`r0}, 3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148571804885*^9},
 CellLabel->"Out[80]=",ExpressionUUID->"69916188-30fe-4e02-b1d4-f760c0577fc2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["h", "2"], " ", "c10"}], ")"}], "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777148589840487*^9, 3.777148590144063*^9}},
 CellLabel->"In[81]:=",ExpressionUUID->"b72d8403-ad23-46e1-9348-90247b425acc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"k", " ", 
      SuperscriptBox["gamma", "5"]}], 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]]}], "-", 
   FractionBox[
    RowBox[{"5", " ", 
     RowBox[{"(", 
      RowBox[{"eta", " ", "k"}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"4", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", "r0"}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {-$CellContext`beta^Rational[-5, 2] $CellContext`k, 
    Rational[-5, 
      4] $CellContext`beta^(-3) $CellContext`eta \
$CellContext`k/$CellContext`r0}, 5, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148590646845*^9},
 CellLabel->"Out[81]=",ExpressionUUID->"fab7e503-3fad-40ae-8d29-bf913d224803"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               RowBox[{"d", " ", "k", " ", "c13"}], 
               RowBox[{"r", " ", "r0"}]]}], "+", 
             FractionBox[
              RowBox[{"k", " ", "c9"}], 
              RowBox[{"beta", " ", "r0"}]]}], ")"}], "/.", " ", 
           RowBox[{"d", " ", "->", "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", " ", "g2"}], "+", 
               RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ",
           "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7771486031445103`*^9, 3.777148606430785*^9}},
 CellLabel->"In[82]:=",ExpressionUUID->"ae6f33b4-9016-4dc6-94b8-790c00529af8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"k", " ", 
      SuperscriptBox["gamma", "5"]}], 
     RowBox[{"10", " ", 
      SuperscriptBox["beta", 
       RowBox[{"5", "/", "2"}]]}]]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 10] $CellContext`beta^Rational[-5, 2] $CellContext`k}, 5, 7, 
   1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777148606942251*^9},
 CellLabel->"Out[82]=",ExpressionUUID->"558d4be6-c4f5-425a-bc48-062f9a97f968"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"d", " ", "k", " ", "c13"}], 
         RowBox[{"r", " ", "r0"}]]}], "+", 
       FractionBox[
        RowBox[{"k", " ", "c9"}], 
        RowBox[{"beta", " ", "r0"}]]}], ")"}], "/.", " ", 
     RowBox[{"d", " ", "->", "  ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", " ", "g2"}], "+", 
         RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
     " ", 
    RowBox[{"zeta", " ", "\[Rule]", " ", 
     RowBox[{"k", "-", 
      RowBox[{"r0", " ", "beta"}]}]}]}], "/.", " ", 
   RowBox[{"h", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
     RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
  RowBox[{"r", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
    RowBox[{"k", " ", "g2", " "}]}]}]}]], "Input",
 CellChangeTimes->{3.777148788073629*^9},
 CellLabel->"In[88]:=",ExpressionUUID->"916e1615-63c8-47b6-9043-27396f7831b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
       RowBox[{"3", " ", "g3", " ", "k"}], "+", 
       RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "r0"}], "+", 
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g2"}], "+", 
          RowBox[{"g3", " ", "k"}], "+", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}]}], 
    RowBox[{"beta", " ", "r0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}], "+", 
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "3"}], " ", "g3", " ", "r0"}], "+", 
      RowBox[{"2", " ", "g2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g2"}], "+", 
         RowBox[{"g3", " ", "k"}], "+", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}]}], 
   RowBox[{"beta", " ", "r0"}]]}]], "Output",
 CellChangeTimes->{3.777148624808963*^9, 3.777148788817173*^9},
 CellLabel->"Out[88]=",ExpressionUUID->"75b701e5-c2d2-4829-a03b-c8caed7d7f90"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Together", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777148795694627*^9, 3.777148797078994*^9}},
 CellLabel->"In[89]:=",ExpressionUUID->"13a99036-8c52-4fde-8aa8-02dabec370d5"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"beta", " ", "r0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}]], 
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", "eta", " ", 
       SuperscriptBox["g2", "3"], " ", "k"}], "+", 
      RowBox[{"3", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "k"}], 
      "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["g2", "2"], " ", "g3", " ", 
       SuperscriptBox["k", "2"]}], "+", 
      RowBox[{"3", " ", "g1", " ", 
       SuperscriptBox["g3", "2"], " ", 
       SuperscriptBox["k", "2"]}], "+", 
      RowBox[{"eta", " ", 
       SuperscriptBox["g1", "2"], " ", "g2", " ", "r0"}], "-", 
      RowBox[{"2", " ", "eta", " ", 
       SuperscriptBox["g2", "2"], " ", "r0"}], "-", 
      RowBox[{"2", " ", "eta", " ", "g0", " ", 
       SuperscriptBox["g2", "2"], " ", "r0"}], "+", 
      RowBox[{"3", " ", "eta", " ", "g1", " ", "g3", " ", "r0"}], "-", 
      RowBox[{"2", " ", "g1", " ", 
       SuperscriptBox["g2", "2"], " ", "k", " ", "r0"}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["g1", "2"], " ", "g3", " ", "k", " ", "r0"}], "-", 
      RowBox[{"2", " ", "g0", " ", "g2", " ", "g3", " ", "k", " ", "r0"}], 
      "+", 
      RowBox[{
       SuperscriptBox["g1", "3"], " ", 
       SuperscriptBox["r0", "2"]}], "-", 
      RowBox[{"g1", " ", "g2", " ", 
       SuperscriptBox["r0", "2"]}], "-", 
      RowBox[{"2", " ", "g0", " ", "g1", " ", "g2", " ", 
       SuperscriptBox["r0", "2"]}], "+", 
      RowBox[{"3", " ", "g0", " ", "g3", " ", 
       SuperscriptBox["r0", "2"]}]}], ")"}]}]}]}]], "Output",
 CellChangeTimes->{3.777148797359964*^9},
 CellLabel->"Out[89]=",ExpressionUUID->"f6f75456-c5fe-46af-b777-cb4aa4b0275a"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.7771488004542933`*^9, 
  3.777148800966033*^9}},ExpressionUUID->"11ec78d7-46c8-4a3a-a140-\
a1f105a6db16"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "eta", " ", 
      SuperscriptBox["g2", "3"], " ", "k"}], "+", 
     RowBox[{"3", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "k"}], 
     "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"], " ", "g3", " ", 
      SuperscriptBox["k", "2"]}], "+", 
     RowBox[{"3", " ", "g1", " ", 
      SuperscriptBox["g3", "2"], " ", 
      SuperscriptBox["k", "2"]}], "+", 
     RowBox[{"eta", " ", 
      SuperscriptBox["g1", "2"], " ", "g2", " ", "r0"}], "-", 
     RowBox[{"2", " ", "eta", " ", 
      SuperscriptBox["g2", "2"], " ", "r0"}], "-", 
     RowBox[{"2", " ", "eta", " ", "g0", " ", 
      SuperscriptBox["g2", "2"], " ", "r0"}], "+", 
     RowBox[{"3", " ", "eta", " ", "g1", " ", "g3", " ", "r0"}], "-", 
     RowBox[{"2", " ", "g1", " ", 
      SuperscriptBox["g2", "2"], " ", "k", " ", "r0"}], "+", 
     RowBox[{"4", " ", 
      SuperscriptBox["g1", "2"], " ", "g3", " ", "k", " ", "r0"}], "-", 
     RowBox[{"2", " ", "g0", " ", "g2", " ", "g3", " ", "k", " ", "r0"}], "+", 
     RowBox[{
      SuperscriptBox["g1", "3"], " ", 
      SuperscriptBox["r0", "2"]}], "-", 
     RowBox[{"g1", " ", "g2", " ", 
      SuperscriptBox["r0", "2"]}], "-", 
     RowBox[{"2", " ", "g0", " ", "g1", " ", "g2", " ", 
      SuperscriptBox["r0", "2"]}], "+", 
     RowBox[{"3", " ", "g0", " ", "g3", " ", 
      SuperscriptBox["r0", "2"]}]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"eta", ",", "k", ",", "r0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777148805017516*^9, 3.777148811526183*^9}},
 CellLabel->"In[90]:=",ExpressionUUID->"ae5ca8a0-f924-465e-9504-25fee631636a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      SuperscriptBox["g2", "2"], " ", "g3"}], "+", 
     RowBox[{"3", " ", "g1", " ", 
      SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "g1", " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"4", " ", 
      SuperscriptBox["g1", "2"], " ", "g3"}], "-", 
     RowBox[{"2", " ", "g0", " ", "g2", " ", "g3"}]}], ")"}], " ", "k", " ", 
   "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["g1", "3"], "-", 
     RowBox[{"g1", " ", "g2"}], "-", 
     RowBox[{"2", " ", "g0", " ", "g1", " ", "g2"}], "+", 
     RowBox[{"3", " ", "g0", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         SuperscriptBox["g2", "3"]}], "+", 
        RowBox[{"3", " ", "g1", " ", "g2", " ", "g3"}]}], ")"}], " ", "k"}], 
     "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["g1", "2"], " ", "g2"}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["g2", "2"]}], "-", 
        RowBox[{"2", " ", "g0", " ", 
         SuperscriptBox["g2", "2"]}], "+", 
        RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}], " ", "r0"}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.7771488118707123`*^9},
 CellLabel->"Out[90]=",ExpressionUUID->"78a6101c-aea5-4204-bddb-7969b4afd19e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["g1", "3"], "-", 
         RowBox[{"g1", " ", "g2"}], "-", 
         RowBox[{"2", " ", "g0", " ", "g1", " ", "g2"}], "+", 
         RowBox[{"3", " ", "g0", " ", "g3"}]}], ")"}], "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g1", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "gamma", "]"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777148953557516*^9, 3.777149008913744*^9}, {
  3.777149075713122*^9, 3.7771491280415707`*^9}},
 CellLabel->"In[96]:=",ExpressionUUID->"2b7c3b17-c7d2-41c6-b014-1c1b9ed6078d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "5"], 
    RowBox[{"10", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "-", 
   FractionBox[
    RowBox[{"13", " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"210", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{"109", " ", 
     SuperscriptBox["gamma", "9"]}], 
    RowBox[{"10080", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "11"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 11, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 10] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[-13, 210] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[109, 10080] $CellContext`beta^Rational[-3, 2]}, 5, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.777149083160866*^9, 3.7771491285489492`*^9}},
 CellLabel->"Out[96]=",ExpressionUUID->"87d9c929-d211-421a-b893-13531e851cfe"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"g0", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"3", " ", "g3"}], "-", 
    RowBox[{"g1", "  ", "g2"}]}], ")"}], " "}]], "Input",
 CellChangeTimes->{{3.7771491407896233`*^9, 3.777149198105216*^9}, {
  3.7771492586719303`*^9, 
  3.777149315025141*^9}},ExpressionUUID->"d718f27c-569c-4859-a990-\
c94b48e0517b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"3", " ", "g3"}], "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g1", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "gamma", "]"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777149451937354*^9, 3.777149453112463*^9}},
 CellLabel->
  "In[100]:=",ExpressionUUID->"f6e4f9b8-014b-48de-b2f7-a8d748375411"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "3"], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "-", 
   FractionBox[
    SuperscriptBox["gamma", "5"], 
    RowBox[{"40", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "+", 
   FractionBox[
    SuperscriptBox["gamma", "7"], 
    RowBox[{"1680", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "-", 
   FractionBox[
    SuperscriptBox["gamma", "9"], 
    RowBox[{"120960", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "11"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 11, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 2] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[-1, 40] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[1, 1680] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[-1, 120960] $CellContext`beta^Rational[-3, 2]}, 3, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777149454084618*^9},
 CellLabel->
  "Out[100]=",ExpressionUUID->"ebcaab61-b1bc-4b25-80f8-f6a51a9e3dce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"3", " ", "g1", " ", "g3"}], "-", 
        RowBox[{"2", 
         SuperscriptBox["g2", "2"]}]}], "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g1", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "gamma", "]"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777149462039625*^9, 3.777149464583941*^9}, 
   3.7771501189648037`*^9},
 CellLabel->
  "In[109]:=",ExpressionUUID->"352e602d-ce9b-4792-b967-108235b8d850"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "6"], 
     RowBox[{"40", " ", 
      SuperscriptBox["beta", "2"]}]]}], "+", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"1120", " ", 
     SuperscriptBox["beta", "2"]}]], "-", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "10"]}], 
    RowBox[{"22400", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "11"],
    SeriesData[$CellContext`gamma, 0, {}, 6, 11, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 40] $CellContext`beta^(-2), 0, 
    Rational[3, 1120] $CellContext`beta^(-2), 0, 
    Rational[-3, 22400] $CellContext`beta^(-2)}, 6, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7771494654417887`*^9, 3.777150120066308*^9},
 CellLabel->
  "Out[109]=",ExpressionUUID->"a1062021-77a1-4e49-b20d-a4b7b79f2874"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", "g3"}], "+", 
     RowBox[{"g0", " ", "g3"}], "-", 
     RowBox[{"g1", " ", "g2"}]}], ")"}], " ", "2", "g2", " ", "k", " ", 
   "r0"}], "+", 
  RowBox[{"r0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"r0", " ", "g0"}], "+", 
     RowBox[{"eta", " ", "g1"}]}], ")"}], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", "g3"}], "-", 
     RowBox[{"g1", "  ", "g2"}]}], ")"}]}], " ", "+", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", "g1", " ", "g3"}], "-", 
     RowBox[{"2", 
      SuperscriptBox["g2", "2"]}]}], ")"}], "k", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
     RowBox[{"g3", " ", "k"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{
  3.777149556235796*^9, {3.777149859169716*^9, 3.777149909503461*^9}, {
   3.7771499865714407`*^9, 3.777150000411409*^9}, {3.777150033726178*^9, 
   3.77715011059276*^9}, {3.7771501497033653`*^9, 3.77715030627524*^9}, {
   3.777150397053166*^9, 3.7771504143565693`*^9}, {3.7771504469666157`*^9, 
   3.777150549992907*^9}, {3.777150587460092*^9, 3.7771505941870737`*^9}, {
   3.7771582440529737`*^9, 
   3.777158245501403*^9}},ExpressionUUID->"7fd56983-de84-492a-b4f4-\
a708d2ffd877"],

Cell[BoxData[
 RowBox[{"k", 
  RowBox[{"(", 
   FractionBox[
    RowBox[{
     RowBox[{"2", "g2", " ", "h"}], "-", 
     RowBox[{"3", " ", "g3", " ", "r0"}], "-", 
     RowBox[{"r", 
      RowBox[{"(", 
       RowBox[{"h", "+", 
        RowBox[{"eta", " ", "g2"}], "+", 
        RowBox[{"2", "k", " ", "g3"}]}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "h"}], "-", 
        RowBox[{"g2", " ", "r0"}]}], ")"}]}]}], 
    RowBox[{"beta", " ", "r", " ", "r0"}]], ")"}]}]], "Input",
 CellChangeTimes->{{3.7771583557713413`*^9, 3.777158502988497*^9}, {
  3.777158577887064*^9, 
  3.7771585800393467`*^9}},ExpressionUUID->"fb993b67-9616-4ee4-9991-\
e8d51c58184c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", "h", " ", "g2"}], " ", "+", 
  RowBox[{"h", " ", "r", " ", "g2", " ", "r0"}], " ", "-", 
  RowBox[{"3", " ", "g3", " ", "r0"}], "-", 
  RowBox[{
   SuperscriptBox["h", "2"], " ", "r", " ", "g1"}], "-", 
  RowBox[{"eta", " ", "r", " ", "g2", " ", "h", " ", "g1"}], "+", 
  RowBox[{"2", "k", " ", "r", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"r0", " ", "g2", "  ", "g3"}], "-", " ", 
     RowBox[{"h", " ", "g1", " ", "g3"}]}], ")"}]}], "+", 
  RowBox[{"eta", " ", "g2", " ", "r", " ", "g2", " ", "r0"}]}]], "Input",
 CellChangeTimes->{{3.777166940027096*^9, 
  3.777167090232258*^9}},ExpressionUUID->"b48ab1eb-e8f2-4a4a-b72b-\
8c1f0cc2f8b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"d", " ", "k", " ", "c13"}], 
    RowBox[{"r", " ", "r0"}]]}], "+", 
  FractionBox[
   RowBox[{"k", " ", "c9"}], 
   RowBox[{"beta", " ", "r0"}]]}]], "Input",
 CellLabel->"In[7]:=",ExpressionUUID->"204129e9-9ec0-42a4-9220-e6d8dc401b9d"],

Cell[BoxData[
 RowBox[{"k", 
  FractionBox[
   RowBox[{
    RowBox[{"2", " ", "g2", " ", "h", " ", "r"}], "-", 
    RowBox[{"3", " ", "g3", " ", "r", " ", "r0"}], "-", 
    RowBox[{"h", " ", "g1", " ", "h"}], " ", "-", 
    RowBox[{"eta", " ", "g2", " ", "g1", " ", "h"}], " ", "-", 
    RowBox[{"2", "k", " ", "g3", " ", "g1", " ", "h"}], "   ", "+", " ", 
    RowBox[{"h", " ", "g2", " ", "r0"}], "+", 
    RowBox[{"eta", " ", "g2", " ", "g2", " ", "r0"}], "+", 
    RowBox[{"2", "k", " ", "g3", " ", "g2", " ", "r0", " "}]}], 
   RowBox[{"beta", " ", "r", " ", "r0"}]]}]], "Input",
 CellChangeTimes->{{3.777167201152327*^9, 3.777167225767178*^9}, {
  3.7771672823010197`*^9, 
  3.777167392706958*^9}},ExpressionUUID->"558cfb6d-ef63-4d81-818b-\
e33a7e80221a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"2", " ", "g2", " ", "h", " ", "r"}], "-", 
    RowBox[{"3", " ", "g3", " ", "r", " ", "r0"}], "-", 
    RowBox[{"h", " ", "g1", " ", "h"}], " ", "-", 
    RowBox[{"eta", " ", "g2", " ", "g1", " ", "h"}], " ", "-", 
    RowBox[{"2", "k", " ", "g3", " ", "g1", " ", "h"}], "   ", "+", " ", 
    RowBox[{"h", " ", "g2", " ", "r0"}], "+", 
    RowBox[{"eta", " ", "g2", " ", "g2", " ", "r0"}], "+", 
    RowBox[{"2", "k", " ", "g3", " ", "g2", " ", "r0"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"h", ",", "eta", ",", "r0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777167433576429*^9, 3.777167441595416*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"385d9cae-2bba-477c-b7b5-b957c1ea806a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g1"}], " ", 
   SuperscriptBox["h", "2"]}], "+", 
  RowBox[{"eta", " ", 
   SuperscriptBox["g2", "2"], " ", "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "g2", " ", "g3", " ", "k"}], "-", 
     RowBox[{"3", " ", "g3", " ", "r"}]}], ")"}], " ", "r0"}], "+", 
  RowBox[{"h", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "eta"}], " ", "g1", " ", "g2"}], "-", 
     RowBox[{"2", " ", "g1", " ", "g3", " ", "k"}], "+", 
     RowBox[{"2", " ", "g2", " ", "r"}], "+", 
     RowBox[{"g2", " ", "r0"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.777167442010956*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"97e2f43a-3a49-4ed0-ad00-9be22292a42e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Let", "'"}], "s", " ", "return", " ", "to", " ", "dk", " ", 
    RowBox[{"term", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.7778141531013117`*^9, 3.777814158173334*^9}},
 CellLabel->"In[28]:=",ExpressionUUID->"59f4694e-10f9-4617-9cc8-8f75b0900c49"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "c13", " ", "c1"}], 
        RowBox[{"r", " "}]], "-", 
       FractionBox[
        RowBox[{"k", " ", "c9"}], 
        RowBox[{"beta", " "}]]}], ")"}], "  ", "/.", " ", 
     RowBox[{"d", " ", "->", "  ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", " ", "g2"}], "+", 
         RowBox[{"2", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
     " ", 
    RowBox[{"zeta", " ", "\[Rule]", " ", 
     RowBox[{"k", "-", 
      RowBox[{"r0", " ", "beta"}]}]}]}], " ", "/.", " ", 
   RowBox[{"h", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
     RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
  RowBox[{"r", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
    RowBox[{"k", " ", "g2"}]}]}]}]], "Input",
 CellLabel->"In[29]:=",ExpressionUUID->"e2c0656d-d036-4b5f-b912-05bc80fc9104"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "3"}], " ", "g3", " ", "r0"}], "+", 
       RowBox[{"2", " ", "g2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g2"}], "+", 
          RowBox[{"g3", " ", "k"}], "+", 
          RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}]}], "beta"]}], "+", 
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g2"}], " ", "r0"}], "+", 
      RowBox[{"g1", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g2"}], "+", 
         RowBox[{"g3", " ", "k"}], "+", 
         RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g3"}], " ", "r0"}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
        RowBox[{"3", " ", "g3", " ", "k"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}], 
   RowBox[{
    RowBox[{"eta", " ", "g1"}], "+", 
    RowBox[{"g2", " ", "k"}], "+", 
    RowBox[{"g0", " ", "r0"}]}]]}]], "Output",
 CellChangeTimes->{3.777814159798513*^9},
 CellLabel->"Out[29]=",ExpressionUUID->"26285467-1e3e-4716-b111-3657382d1d11"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Together", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7778141619914513`*^9, 3.7778141648863773`*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"04387773-739b-4f16-a0d2-1e72d5de57db"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"beta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}]], 
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "eta", " ", 
       SuperscriptBox["g2", "3"], " ", "k"}], "-", 
      RowBox[{"3", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "k"}], 
      "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["g2", "2"], " ", "g3", " ", 
       SuperscriptBox["k", "2"]}], "-", 
      RowBox[{"3", " ", "g1", " ", 
       SuperscriptBox["g3", "2"], " ", 
       SuperscriptBox["k", "2"]}], "-", 
      RowBox[{"eta", " ", 
       SuperscriptBox["g1", "2"], " ", "g2", " ", "r0"}], "+", 
      RowBox[{"2", " ", "eta", " ", 
       SuperscriptBox["g2", "2"], " ", "r0"}], "+", 
      RowBox[{"2", " ", "eta", " ", "g0", " ", 
       SuperscriptBox["g2", "2"], " ", "r0"}], "-", 
      RowBox[{"3", " ", "eta", " ", "g1", " ", "g3", " ", "r0"}], "+", 
      RowBox[{
      "beta", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "r0"}], "+", 
      RowBox[{"2", " ", "g1", " ", 
       SuperscriptBox["g2", "2"], " ", "k", " ", "r0"}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["g1", "2"], " ", "g3", " ", "k", " ", "r0"}], "+", 
      RowBox[{"2", " ", "g0", " ", "g2", " ", "g3", " ", "k", " ", "r0"}], 
      "+", 
      RowBox[{"beta", " ", "g1", " ", 
       SuperscriptBox["g3", "2"], " ", "k", " ", "r0"}], "-", 
      RowBox[{
       SuperscriptBox["g1", "3"], " ", 
       SuperscriptBox["r0", "2"]}], "+", 
      RowBox[{"g1", " ", "g2", " ", 
       SuperscriptBox["r0", "2"]}], "+", 
      RowBox[{"2", " ", "g0", " ", "g1", " ", "g2", " ", 
       SuperscriptBox["r0", "2"]}], "-", 
      RowBox[{"3", " ", "g0", " ", "g3", " ", 
       SuperscriptBox["r0", "2"]}], "+", 
      RowBox[{"beta", " ", 
       SuperscriptBox["g1", "2"], " ", "g3", " ", 
       SuperscriptBox["r0", "2"]}], "-", 
      RowBox[{"beta", " ", "g2", " ", "g3", " ", 
       SuperscriptBox["r0", "2"]}]}], ")"}]}]}]}]], "Output",
 CellChangeTimes->{3.777814165378851*^9},
 CellLabel->"Out[30]=",ExpressionUUID->"d9d92ff1-085c-4bf8-b0a2-ef1f419cc236"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "eta", " ", 
      SuperscriptBox["g2", "3"], " ", "k"}], "-", 
     RowBox[{"3", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "k"}], 
     "+", 
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"], " ", "g3", " ", 
      SuperscriptBox["k", "2"]}], "-", 
     RowBox[{"3", " ", "g1", " ", 
      SuperscriptBox["g3", "2"], " ", 
      SuperscriptBox["k", "2"]}], "-", 
     RowBox[{"eta", " ", 
      SuperscriptBox["g1", "2"], " ", "g2", " ", "r0"}], "+", 
     RowBox[{"2", " ", "eta", " ", 
      SuperscriptBox["g2", "2"], " ", "r0"}], "+", 
     RowBox[{"2", " ", "eta", " ", "g0", " ", 
      SuperscriptBox["g2", "2"], " ", "r0"}], "-", 
     RowBox[{"3", " ", "eta", " ", "g1", " ", "g3", " ", "r0"}], "+", 
     RowBox[{"beta", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "r0"}],
      "+", 
     RowBox[{"2", " ", "g1", " ", 
      SuperscriptBox["g2", "2"], " ", "k", " ", "r0"}], "-", 
     RowBox[{"4", " ", 
      SuperscriptBox["g1", "2"], " ", "g3", " ", "k", " ", "r0"}], "+", 
     RowBox[{"2", " ", "g0", " ", "g2", " ", "g3", " ", "k", " ", "r0"}], "+", 
     RowBox[{"beta", " ", "g1", " ", 
      SuperscriptBox["g3", "2"], " ", "k", " ", "r0"}], "-", 
     RowBox[{
      SuperscriptBox["g1", "3"], " ", 
      SuperscriptBox["r0", "2"]}], "+", 
     RowBox[{"g1", " ", "g2", " ", 
      SuperscriptBox["r0", "2"]}], "+", 
     RowBox[{"2", " ", "g0", " ", "g1", " ", "g2", " ", 
      SuperscriptBox["r0", "2"]}], "-", 
     RowBox[{"3", " ", "g0", " ", "g3", " ", 
      SuperscriptBox["r0", "2"]}], "+", 
     RowBox[{"beta", " ", 
      SuperscriptBox["g1", "2"], " ", "g3", " ", 
      SuperscriptBox["r0", "2"]}], "-", 
     RowBox[{"beta", " ", "g2", " ", "g3", " ", 
      SuperscriptBox["r0", "2"]}]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "eta", ",", "r0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7778141701355658`*^9, 3.777814177783095*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"d30dfde5-c276-4a9d-ace1-76506cf6d88b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"], " ", "g3"}], "-", 
     RowBox[{"3", " ", "g1", " ", 
      SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["g1", "2"]}], " ", "g2"}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"2", " ", "g0", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"3", " ", "g1", " ", "g3"}], "+", 
     RowBox[{"beta", " ", "g1", " ", "g2", " ", "g3"}]}], ")"}], " ", "r0"}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["g1", "3"]}], "+", 
     RowBox[{"g1", " ", "g2"}], "+", 
     RowBox[{"2", " ", "g0", " ", "g1", " ", "g2"}], "-", 
     RowBox[{"3", " ", "g0", " ", "g3"}], "+", 
     RowBox[{"beta", " ", 
      SuperscriptBox["g1", "2"], " ", "g3"}], "-", 
     RowBox[{"beta", " ", "g2", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}], "+", 
  RowBox[{"k", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", 
         SuperscriptBox["g2", "3"]}], "-", 
        RowBox[{"3", " ", "g1", " ", "g2", " ", "g3"}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "g1", " ", 
         SuperscriptBox["g2", "2"]}], "-", 
        RowBox[{"4", " ", 
         SuperscriptBox["g1", "2"], " ", "g3"}], "+", 
        RowBox[{"2", " ", "g0", " ", "g2", " ", "g3"}], "+", 
        RowBox[{"beta", " ", "g1", " ", 
         SuperscriptBox["g3", "2"]}]}], ")"}], " ", "r0"}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.777814178097714*^9},
 CellLabel->"Out[31]=",ExpressionUUID->"bbb91854-ed0c-4020-8420-31d15f083196"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}], " ", "g3", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"3", " ", "g1", " ", "g3"}], "+", 
     RowBox[{"g2", 
      RowBox[{"(", " ", 
       RowBox[{
        RowBox[{"g0", " ", "g2"}], "-", "g2", "+", 
        RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}]}]}], ")"}], " ", 
   "r0"}], "+", 
  RowBox[{"g0", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "g2"}], "-", 
     RowBox[{"2", " ", "g3"}], "-", 
     RowBox[{"g0", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}], "+", " ", 
  RowBox[{"k", " ", "eta", " ", "g2", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "g1", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"3", " ", 
      SuperscriptBox["g1", "2"], "g3"}], "+", 
     RowBox[{"g3", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g0", " ", "g2"}], "-", "g2", "+", 
        RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}]}]}], ")"}], " ", "k", 
   " ", "r0"}]}]], "Input",
 CellChangeTimes->{{3.777814203037511*^9, 3.777814207956332*^9}, {
  3.777814239497244*^9, 3.7778142834554873`*^9}, {3.777814358695076*^9, 
  3.777814430900375*^9}, {3.777814464123423*^9, 3.777814534915791*^9}, {
  3.777814565073629*^9, 3.777814567960643*^9}, {3.777815146362609*^9, 
  3.777815163798127*^9}, {3.7778152009377203`*^9, 3.7778152301783447`*^9}, {
  3.7778152652961073`*^9, 3.777815349911952*^9}, {3.7778157716721363`*^9, 
  3.77781578570874*^9}, {3.777815842566824*^9, 
  3.777815972624638*^9}},ExpressionUUID->"414fc202-ce15-42d6-b793-\
fa00f72d56ab"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Here", " ", "is", " ", "our", " ", 
     RowBox[{"(", "nearly", ")"}], " ", "final", " ", "term"}], " ", "-", " ", 
    RowBox[{
     RowBox[{"r0", "^", "2"}], " ", "term", " ", "is", " ", "different", " ", 
     "in", " ", 
     RowBox[{"code", ":"}]}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.7782174719449778`*^9, 3.778217479009138*^9}, {
  3.778217733441868*^9, 
  3.778217743696701*^9}},ExpressionUUID->"c89e0602-c851-413b-9091-\
161e6a1bf354"],

Cell[BoxData[
 RowBox[{
  RowBox[{"h6", " ", "g3", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{"h6", "+", 
     RowBox[{"g2", " ", "h4"}]}], ")"}], " ", "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "h4"}], "+", 
     RowBox[{"g1", " ", "g2"}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "g0"}], "+", "1"}], ")"}], " ", "g3"}]}], ")"}], 
   " ", 
   SuperscriptBox["r0", "2"]}], "+", " ", 
  RowBox[{"k", " ", "eta", " ", "g2", " ", "h6"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "h6"}], "+", 
     RowBox[{"g3", " ", "h4"}]}], ")"}], " ", "k", " ", "r0"}]}]], "Input",
 CellChangeTimes->{{3.7778154345549*^9, 
  3.777815521185301*^9}},ExpressionUUID->"5c202389-d2ac-46fa-b5a5-\
30fc09713359"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Check", " ", "that", " ", "it", " ", "is", " ", 
    RowBox[{"correct", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.778217492670804*^9, 3.778217500288396*^9}},
 CellLabel->
  "In[509]:=",ExpressionUUID->"cf8dc6e2-6168-41c6-b41a-d634cf235b79"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                FractionBox[
                 RowBox[{"c13", " ", "c1"}], 
                 RowBox[{"r", " "}]], "-", 
                FractionBox[
                 RowBox[{" ", "c9"}], 
                 RowBox[{"beta", " "}]]}], ")"}], "+", 
              RowBox[{
               FractionBox["1", 
                RowBox[{"beta", " ", "r"}]], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"h6", " ", "g3", " ", 
                  SuperscriptBox["k", "2"]}], "+", 
                 RowBox[{"eta", " ", 
                  RowBox[{"(", 
                   RowBox[{"h6", "+", 
                    RowBox[{"g2", " ", "h4"}]}], ")"}], " ", "r0"}], "+", 
                 RowBox[{"g0", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
                    RowBox[{"2", " ", "g3"}], " ", "-", " ", 
                    RowBox[{"g0", " ", "g3"}]}], ")"}], " ", 
                  SuperscriptBox["r0", "2"]}], "+", " ", 
                 RowBox[{"k", " ", "eta", " ", "g2", " ", "h6"}], "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"g1", " ", "h6"}], "+", 
                    RowBox[{"g3", " ", "h4"}]}], ")"}], " ", "k", " ", 
                  "r0"}]}], ")"}]}]}], " ", "/.", " ", 
             RowBox[{"h6", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"2", " ", 
                SuperscriptBox["g2", "2"]}], " ", "-", " ", 
               RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"h4", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"-", "beta"}], " ", "h1"}]}]}], " ", "/.", " ", 
           RowBox[{"h1", " ", "\[Rule]", " ", 
            RowBox[{
             SuperscriptBox["g2", "2"], " ", "-", " ", 
             RowBox[{"g1", " ", "g3"}]}]}]}], "  ", "/.", " ", 
          RowBox[{"d", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"h", "+", 
              RowBox[{"eta", " ", "g2"}], "+", 
              RowBox[{"2", " ", "k", " ", "g3"}]}], ")"}], "/", "beta"}]}]}], 
         " ", "/.", " ", 
         RowBox[{"h", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", "  ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g1", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "gamma", "]"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778217522458063*^9, 3.778217560391029*^9}, {
  3.7782178248660517`*^9, 3.778217895122398*^9}, {3.778217928276029*^9, 
  3.778218003840767*^9}, {3.7782180340260487`*^9, 3.778218091833638*^9}},
 CellLabel->
  "In[515]:=",ExpressionUUID->"0323ac2f-40b2-4c0d-9a7d-142a1b701981"],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", "gamma", "]"}], "9"],
  SeriesData[$CellContext`gamma, 0, {}, 9, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.778217974141137*^9, 3.778218004219172*^9, {3.7782180353666058`*^9, 
   3.778218055830648*^9}, {3.778218088211413*^9, 3.778218092209998*^9}},
 CellLabel->
  "Out[515]=",ExpressionUUID->"b5fa3bfb-75dc-42c9-8e06-179a2944dca0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SuperscriptBox["g2", "2"], " ", "g3"}], "-", 
           RowBox[{"3", " ", "g1", " ", 
            SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
         SuperscriptBox["k", "2"]}], "+", 
        RowBox[{"eta", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             SuperscriptBox["g1", "2"]}], " ", "g2"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["g2", "2"]}], "+", 
           RowBox[{"2", " ", "g0", " ", 
            SuperscriptBox["g2", "2"]}], "-", 
           RowBox[{"3", " ", "g1", " ", "g3"}], "+", 
           RowBox[{"beta", " ", "g1", " ", "g2", " ", "g3"}]}], ")"}], " ", 
         "r0"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["g1", "3"]}], "+", 
           RowBox[{"g1", " ", "g2"}], "+", 
           RowBox[{"2", " ", "g0", " ", "g1", " ", "g2"}], "-", 
           RowBox[{"3", " ", "g0", " ", "g3"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", 
              SuperscriptBox["g0", "2"]}], ")"}], " ", "g3"}], "-", 
           RowBox[{"beta", " ", "g2", " ", "g3"}]}], ")"}], " ", 
         SuperscriptBox["r0", "2"]}], "+", 
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               SuperscriptBox["g2", "3"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g2", " ", "g3"}]}], ")"}]}], "+", 
           
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "g1", " ", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"4", " ", 
               SuperscriptBox["g1", "2"], " ", "g3"}], "+", 
              RowBox[{"2", " ", "g0", " ", "g2", " ", "g3"}], "+", 
              RowBox[{"beta", " ", "g1", " ", 
               SuperscriptBox["g3", "2"]}]}], ")"}], " ", "r0"}]}], ")"}]}]}],
        "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", "*", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}], " ", ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.77781561530893*^9, 3.777815641371196*^9}, {
  3.777815812775503*^9, 
  3.7778158189710627`*^9}},ExpressionUUID->"33394da7-124f-480f-9e7a-\
9950d8ff3fe6"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      SuperscriptBox["r0", "2"], " ", 
      SuperscriptBox["gamma", "5"]}], 
     RowBox[{"60", " ", 
      SuperscriptBox["beta", 
       RowBox[{"3", "/", "2"}]]}]]}], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", "r0"}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"60", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"28", " ", "k", " ", "r0"}], "+", 
       RowBox[{"23", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"2520", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"7", " ", "k"}], "+", 
       RowBox[{"2", " ", "beta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"560", " ", 
     SuperscriptBox["beta", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 60] $CellContext`beta^Rational[-3, 2] $CellContext`r0^2, 
    Rational[-1, 60] $CellContext`beta^(-2) $CellContext`eta $CellContext`r0, 
    Rational[1, 2520] $CellContext`beta^Rational[-5, 2] (
     28 $CellContext`k $CellContext`r0 + 
     23 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 560] $CellContext`beta^(-3) $CellContext`eta (
     7 $CellContext`k + 2 $CellContext`beta $CellContext`r0)}, 5, 9, 1],
  Editable->False]], "Input",
 CellChangeTimes->{3.777816088614526*^9},
 CellLabel->"In[38]:=",ExpressionUUID->"eac0cf92-31dc-456f-8e4f-a802787093a1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      SuperscriptBox["r0", "2"], " ", 
      SuperscriptBox["gamma", "5"]}], 
     RowBox[{"60", " ", 
      SuperscriptBox["beta", 
       RowBox[{"3", "/", "2"}]]}]]}], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", "r0"}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"60", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"28", " ", "k", " ", "r0"}], "+", 
       RowBox[{"23", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"2520", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"7", " ", "k"}], "+", 
       RowBox[{"2", " ", "beta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"560", " ", 
     SuperscriptBox["beta", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 60] $CellContext`beta^Rational[-3, 2] $CellContext`r0^2, 
    Rational[-1, 60] $CellContext`beta^(-2) $CellContext`eta $CellContext`r0, 
    Rational[1, 2520] $CellContext`beta^Rational[-5, 2] (
     28 $CellContext`k $CellContext`r0 + 
     23 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 560] $CellContext`beta^(-3) $CellContext`eta (
     7 $CellContext`k + 2 $CellContext`beta $CellContext`r0)}, 5, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777816088684641*^9},
 CellLabel->"Out[38]=",ExpressionUUID->"d00f4e4e-1a25-4f8e-ae3f-fafd34b8fa40"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", "+", "g0"}], ")"}], "g3"}]}], " ", "/.", " ", 
     RowBox[{"g0", " ", "\[Rule]", " ", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sin", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7778159979673853`*^9, 3.7778160650058537`*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"169be312-56dd-45bc-a3f5-c942a2fb4597"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", "+", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}], 
    SuperscriptBox["beta", 
     RowBox[{"3", "/", "2"}]]]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sin", "[", "gamma", "]"}]}], 
   SuperscriptBox["beta", 
    RowBox[{"3", "/", "2"}]]]}]], "Output",
 CellChangeTimes->{{3.777816040067885*^9, 3.777816065345331*^9}},
 CellLabel->"Out[35]=",ExpressionUUID->"5aaf801e-f86e-4fcc-be55-d0a64112642b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7778160417676163`*^9, 3.777816042783475*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"51e3f225-afea-4b3b-b291-9fc48bc4a042"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{"2", " ", "gamma"}], "+", 
    RowBox[{"gamma", " ", 
     RowBox[{"Cos", "[", "gamma", "]"}]}], "-", 
    RowBox[{"3", " ", 
     RowBox[{"Sin", "[", "gamma", "]"}]}]}], 
   SuperscriptBox["beta", 
    RowBox[{"3", "/", "2"}]]]}]], "Output",
 CellChangeTimes->{{3.7778160430986567`*^9, 3.7778160676999817`*^9}},
 CellLabel->"Out[36]=",ExpressionUUID->"e3351028-324c-44cc-99d9-eac5759bef05"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"Out", "[", "36", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "15"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777816071087365*^9, 3.777816075605392*^9}, {
  3.777826342449856*^9, 3.777826350495405*^9}},
 CellLabel->"In[71]:=",ExpressionUUID->"b4ecb821-596e-458c-b475-f3e3c0c666ee"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "5"], 
     RowBox[{"60", " ", 
      SuperscriptBox["beta", 
       RowBox[{"3", "/", "2"}]]}]]}], "+", 
   FractionBox[
    SuperscriptBox["gamma", "7"], 
    RowBox[{"1260", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "-", 
   FractionBox[
    SuperscriptBox["gamma", "9"], 
    RowBox[{"60480", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "+", 
   FractionBox[
    SuperscriptBox["gamma", "11"], 
    RowBox[{"4989600", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "-", 
   FractionBox[
    SuperscriptBox["gamma", "13"], 
    RowBox[{"622702080", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "+", 
   FractionBox[
    SuperscriptBox["gamma", "15"], 
    RowBox[{"108972864000", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "16"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 16, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 60] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[1, 1260] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[-1, 60480] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[1, 4989600] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[-1, 622702080] $CellContext`beta^Rational[-3, 2], 0, 
    Rational[1, 108972864000] $CellContext`beta^Rational[-3, 2]}, 5, 16, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.7778160760405083`*^9, {3.777826343236351*^9, 3.777826350834175*^9}},
 CellLabel->"Out[71]=",ExpressionUUID->"0079b22f-751d-4734-afd5-68a0729a28b9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SeriesCoefficient", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", "gamma"}], "-", 
    RowBox[{"gamma", " ", 
     RowBox[{"Cos", "[", "gamma", "]"}]}], "+", 
    RowBox[{"3", " ", 
     RowBox[{"Sin", "[", "gamma", "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777825046307534*^9, 3.777825074216175*^9}, {
  3.777825236162166*^9, 3.777825258543426*^9}, {3.777825290333385*^9, 
  3.777825294244239*^9}, {3.777825515827766*^9, 3.777825523745183*^9}, {
  3.777825568016955*^9, 3.7778255811066027`*^9}, {3.777825663450053*^9, 
  3.77782566939933*^9}, {3.777825879755726*^9, 3.777825903593656*^9}},
 CellLabel->"In[63]:=",ExpressionUUID->"77673415-b61e-4dd0-b2e6-3f70729c8295"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {"0", 
        RowBox[{
         RowBox[{"n", "\[Equal]", "1"}], "||", 
         RowBox[{"n", "\[Equal]", "0"}]}]},
       {
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "\[ImaginaryI]"}], ")"}], "n"], "-", 
            SuperscriptBox["\[ImaginaryI]", "n"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"3", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", "n"}], ")"}], "!"}]}], "-", 
            RowBox[{"n", "!"}]}], ")"}]}], 
         RowBox[{"2", " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "n"}], ")"}], "!"}], " ", 
          RowBox[{"n", "!"}]}]], 
        RowBox[{"n", ">", "1"}]},
       {"0", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}},
      Selectable->True]}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False,
  StripWrapperBoxes->True]], "Output",
 CellChangeTimes->{{3.777825896449317*^9, 3.777825904068739*^9}},
 CellLabel->"Out[63]=",ExpressionUUID->"6f2d6c69-8422-4250-9d7c-d1a46a37bf55"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777825925836257*^9, 3.77782592752354*^9}},
 CellLabel->"In[64]:=",ExpressionUUID->"033a4d97-2160-48d5-be37-a051cc30fff8"],

Cell["\<\
Piecewise[{{0, n == 1 || n == 0}, {((I/2)*((-I)^n - I^n)*(3*(-1 + n)! - \
n!))/((-1 + n)!*n!), n > 1}}, 0]\
\>", "Output",
 CellChangeTimes->{3.777825927821968*^9},
 CellLabel->
  "Out[64]//InputForm=",ExpressionUUID->"a6192f44-1d69-4e72-b466-\
caed3f6a1be3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gamma", "^", "5"}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "^", "n"}], "*", 
    RowBox[{"gamma", "^", 
     RowBox[{"(", 
      RowBox[{"2", "n"}], ")"}]}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "n"}], "+", "4"}], ")"}], "!"}]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "n"}], "+", "5"}], ")"}], "!"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "n"}], "+", "4"}], ")"}], "!"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "n"}], "+", "5"}], ")"}], "!"}]}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777826167587747*^9, 3.777826250165639*^9}, {
  3.777826304130108*^9, 3.777826325840439*^9}, {3.777826359551386*^9, 
  3.7778263609314404`*^9}},
 CellLabel->"In[72]:=",ExpressionUUID->"71f863f2-519c-49eb-ad97-fc42f60090e5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "5"], "60"]}], ",", 
   FractionBox[
    SuperscriptBox["gamma", "7"], "1260"], ",", 
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "9"], "60480"]}], ",", 
   FractionBox[
    SuperscriptBox["gamma", "11"], "4989600"], ",", 
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "13"], "622702080"]}], ",", 
   FractionBox[
    SuperscriptBox["gamma", "15"], "108972864000"]}], "}"}]], "Output",
 CellChangeTimes->{{3.777826221344946*^9, 3.7778262510226707`*^9}, {
   3.7778263100345287`*^9, 3.777826326524663*^9}, 3.77782636166424*^9},
 CellLabel->"Out[72]=",ExpressionUUID->"ce79fc86-0ea7-44a1-9825-4af6b871adf6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SeriesCoefficient", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", 
        SuperscriptBox["g2", "2"]}], "-", 
       RowBox[{"3", " ", "g1", " ", "g3"}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777831975680221*^9, 3.777832014862817*^9}, {
  3.777832128725518*^9, 3.7778321446746387`*^9}},
 CellLabel->"In[80]:=",ExpressionUUID->"109ce624-cce5-4b2c-8063-0e17760f1334"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "\[ImaginaryI]"}], ")"}], "n"], "+", 
             SuperscriptBox["\[ImaginaryI]", "n"]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"8", "+", 
                SuperscriptBox["2", "n"]}], ")"}], " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "1"}], "+", "n"}], ")"}], "!"}]}], "-", 
             RowBox[{"6", " ", 
              RowBox[{"n", "!"}]}]}], ")"}]}], 
          RowBox[{"4", " ", 
           SuperscriptBox["beta", "2"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "n"}], ")"}], "!"}], " ", 
           RowBox[{"n", "!"}]}]]}], 
        RowBox[{"n", "\[GreaterEqual]", "1"}]},
       {"0", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}},
      Selectable->True]}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False,
  StripWrapperBoxes->True]], "Output",
 CellChangeTimes->{{3.777831997579102*^9, 3.777832015575223*^9}, 
   3.7778321453297043`*^9},
 CellLabel->"Out[80]=",ExpressionUUID->"03c34d69-b0cf-4f26-bf08-6749027759d6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", 
        SuperscriptBox["g2", "2"]}], "-", 
       RowBox[{"3", " ", "g1", " ", "g3"}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "15"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7778324038249063`*^9, 3.777832407847941*^9}},
 CellLabel->"In[81]:=",ExpressionUUID->"c2ea9429-cb44-4ff7-ba65-85f7442f4c26"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "6"], 
    RowBox[{"40", " ", 
     SuperscriptBox["beta", "2"]}]], "-", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"1120", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "10"]}], 
    RowBox[{"22400", " ", 
     SuperscriptBox["beta", "2"]}]], "-", 
   FractionBox[
    SuperscriptBox["gamma", "12"], 
    RowBox[{"237600", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   FractionBox[
    RowBox[{"151", " ", 
     SuperscriptBox["gamma", "14"]}], 
    RowBox[{"1614412800", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "16"],
    SeriesData[$CellContext`gamma, 0, {}, 6, 16, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 40] $CellContext`beta^(-2), 0, 
    Rational[-3, 1120] $CellContext`beta^(-2), 0, 
    Rational[3, 22400] $CellContext`beta^(-2), 0, 
    Rational[-1, 237600] $CellContext`beta^(-2), 0, 
    Rational[151, 1614412800] $CellContext`beta^(-2)}, 6, 16, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777832408532402*^9},
 CellLabel->"Out[81]=",ExpressionUUID->"b5bba0fe-d788-4a1b-bcb4-9f31be7698e4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gamma", "^", "6"}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "^", "n"}], "*", 
    RowBox[{"gamma", "^", 
     RowBox[{"(", 
      RowBox[{"2", "n"}], ")"}]}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"8", "+", 
          RowBox[{"2", "^", 
           RowBox[{"(", 
            RowBox[{"6", "+", 
             RowBox[{"2", "*", "n"}]}], ")"}]}]}], ")"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "n"}], "+", "5"}], ")"}], "!"}]}], "-", 
       RowBox[{"6", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "n"}], "+", "6"}], ")"}], "!"}]}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"2", "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "n"}], "+", "5"}], ")"}], "!"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "n"}], "+", "6"}], ")"}], "!"}]}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777832531461635*^9, 3.777832601977481*^9}, {
  3.777832727160256*^9, 3.777832745460576*^9}},
 CellLabel->"In[84]:=",ExpressionUUID->"272a7f4f-adc7-49f8-9995-8adffccf665a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "6"], "40"], ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox["gamma", "8"]}], "1120"]}], ",", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "10"]}], "22400"], ",", 
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "12"], "237600"]}], ",", 
   FractionBox[
    RowBox[{"151", " ", 
     SuperscriptBox["gamma", "14"]}], "1614412800"], ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"101", " ", 
      SuperscriptBox["gamma", "16"]}], "64576512000"]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.777832603390297*^9, {3.777832731487974*^9, 3.777832745912631*^9}},
 CellLabel->"Out[84]=",ExpressionUUID->"9d990bf9-3f42-4352-856a-3ffc5f36f9e1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"g0", " ", "g2"}], " ", "-", " ", "g2", " ", "-", " ", 
        RowBox[{"beta", " ", "g1", " ", "g3"}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "15"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777832902060526*^9, 3.777832926310268*^9}},
 CellLabel->"In[87]:=",ExpressionUUID->"9e68f909-299b-4f68-af69-d5329e92ec20"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"5", " ", 
      SuperscriptBox["gamma", "4"]}], 
     RowBox[{"12", " ", "beta"}]]}], "+", 
   FractionBox[
    RowBox[{"7", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"90", " ", "beta"}]], "-", 
   FractionBox[
    RowBox[{"41", " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"6720", " ", "beta"}]], "+", 
   FractionBox[
    RowBox[{"253", " ", 
     SuperscriptBox["gamma", "10"]}], 
    RowBox[{"907200", " ", "beta"}]], "-", 
   FractionBox[
    RowBox[{"2041", " ", 
     SuperscriptBox["gamma", "12"]}], 
    RowBox[{"239500800", " ", "beta"}]], "+", 
   FractionBox[
    RowBox[{"31", " ", 
     SuperscriptBox["gamma", "14"]}], 
    RowBox[{"165110400", " ", "beta"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "16"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 16, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-5, 12]/$CellContext`beta, 0, Rational[7, 90]/$CellContext`beta, 
    0, Rational[-41, 6720]/$CellContext`beta, 0, 
    Rational[253, 907200]/$CellContext`beta, 0, 
    Rational[-2041, 239500800]/$CellContext`beta, 0, 
    Rational[31, 165110400]/$CellContext`beta}, 4, 16, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.777832912335752*^9, 3.7778329266886873`*^9}},
 CellLabel->"Out[87]=",ExpressionUUID->"068ea942-edb3-4d91-9955-ae401ac00dc6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SeriesCoefficient", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"g0", " ", "g2"}], " ", "-", " ", "g2", " ", "-", " ", 
        RowBox[{"beta", " ", "g1", " ", "g3"}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777832940494916*^9, 3.777832965296462*^9}},
 CellLabel->"In[89]:=",ExpressionUUID->"c8a3b52a-5395-4cda-82e8-8a8d25abe6bd"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "\[ImaginaryI]"}], ")"}], "n"], "+", 
             SuperscriptBox["\[ImaginaryI]", "n"]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "2"}], "+", 
                SuperscriptBox["2", "n"]}], ")"}], " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "1"}], "+", "n"}], ")"}], "!"}]}], "-", 
             RowBox[{"n", "!"}]}], ")"}]}], 
          RowBox[{"2", " ", "beta", " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "n"}], ")"}], "!"}], " ", 
           RowBox[{"n", "!"}]}]]}], 
        RowBox[{"n", "\[GreaterEqual]", "1"}]},
       {"0", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}},
      Selectable->True]}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False,
  StripWrapperBoxes->True]], "Output",
 CellChangeTimes->{{3.7778329443238688`*^9, 3.777832965868865*^9}},
 CellLabel->"Out[89]=",ExpressionUUID->"023cf413-c668-4e77-8ed5-c21c89762e22"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"gamma", "^", "4"}]}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "^", "n"}], "*", 
    RowBox[{"gamma", "^", 
     RowBox[{"(", 
      RowBox[{"2", "n"}], ")"}]}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "^", 
           RowBox[{"(", 
            RowBox[{"4", "+", 
             RowBox[{"2", "*", "n"}]}], ")"}]}], "-", "2"}], ")"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "n"}], "+", "3"}], ")"}], "!"}]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "n"}], "+", "4"}], ")"}], "!"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "n"}], "+", "3"}], ")"}], "!"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "n"}], "+", "4"}], ")"}], "!"}]}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.77783303510093*^9, 3.777833064917438*^9}},
 CellLabel->"In[91]:=",ExpressionUUID->"a3db8592-f7f7-41b0-ac48-0ec72cee4152"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"5", " ", 
      SuperscriptBox["gamma", "4"]}], "12"]}], ",", 
   FractionBox[
    RowBox[{"7", " ", 
     SuperscriptBox["gamma", "6"]}], "90"], ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"41", " ", 
      SuperscriptBox["gamma", "8"]}], "6720"]}], ",", 
   FractionBox[
    RowBox[{"253", " ", 
     SuperscriptBox["gamma", "10"]}], "907200"], ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"2041", " ", 
      SuperscriptBox["gamma", "12"]}], "239500800"]}], ",", 
   FractionBox[
    RowBox[{"31", " ", 
     SuperscriptBox["gamma", "14"]}], "165110400"]}], "}"}]], "Output",
 CellChangeTimes->{{3.777833059248272*^9, 3.777833065352541*^9}},
 CellLabel->"Out[91]=",ExpressionUUID->"2b02d18a-93cf-4cf8-b98b-d34a0110e101"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"g0", " ", "g2"}], " ", "-", " ", "g2", " ", "-", " ", 
        RowBox[{"beta", " ", "g1", " ", "g3"}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sinh", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"-", "beta"}], "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
     "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"-", "beta"}], "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "15"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7778339794100924`*^9, 3.777833994353511*^9}, {
  3.777834028109456*^9, 3.777834034558448*^9}},
 CellLabel->"In[92]:=",ExpressionUUID->"ef5fff28-0a5b-40e9-a8fd-68f72eb90b79"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"5", " ", 
      SuperscriptBox["gamma", "4"]}], 
     RowBox[{"12", " ", "beta"}]]}], "-", 
   FractionBox[
    RowBox[{"7", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"90", " ", "beta"}]], "-", 
   FractionBox[
    RowBox[{"41", " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"6720", " ", "beta"}]], "-", 
   FractionBox[
    RowBox[{"253", " ", 
     SuperscriptBox["gamma", "10"]}], 
    RowBox[{"907200", " ", "beta"}]], "-", 
   FractionBox[
    RowBox[{"2041", " ", 
     SuperscriptBox["gamma", "12"]}], 
    RowBox[{"239500800", " ", "beta"}]], "-", 
   FractionBox[
    RowBox[{"31", " ", 
     SuperscriptBox["gamma", "14"]}], 
    RowBox[{"165110400", " ", "beta"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "16"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 16, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-5, 12]/$CellContext`beta, 0, Rational[-7, 90]/$CellContext`beta, 
    0, Rational[-41, 6720]/$CellContext`beta, 0, 
    Rational[-253, 907200]/$CellContext`beta, 0, 
    Rational[-2041, 239500800]/$CellContext`beta, 0, 
    Rational[-31, 165110400]/$CellContext`beta}, 4, 16, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.77783403552782*^9},
 CellLabel->"Out[92]=",ExpressionUUID->"670beea1-552b-45c3-a6c8-f59d20bca488"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"g0", " ", "g2"}], " ", "-", " ", "g2", " ", "-", " ", 
      RowBox[{"beta", " ", "g1", " ", "g3"}]}], " ", "/.", " ", 
     RowBox[{"g0", " ", "\[Rule]", " ", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sinh", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"-", "beta"}], "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"-", "beta"}], "]"}]}]}]}]], "Input",
 CellLabel->"In[93]:=",ExpressionUUID->"61be4839-4c0f-4ae1-ab56-336286909500"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"1", "-", 
     RowBox[{"Cosh", "[", "gamma", "]"}]}], "beta"]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Cosh", "[", "gamma", "]"}]}], "beta"], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"gamma", "-", 
      RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sinh", "[", "gamma", "]"}]}], "beta"]}]], "Output",
 CellChangeTimes->{3.777834071816897*^9},
 CellLabel->"Out[93]=",ExpressionUUID->"89fdb873-74ec-46c2-b8ce-5a6897202b18"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777834073374131*^9, 3.7778340775416183`*^9}},
 CellLabel->"In[94]:=",ExpressionUUID->"509a16a4-4a44-4024-b77a-1d240300c6be"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"1", "-", 
    RowBox[{"2", " ", 
     RowBox[{"Cosh", "[", "gamma", "]"}]}], "+", 
    SuperscriptBox[
     RowBox[{"Cosh", "[", "gamma", "]"}], "2"], "-", 
    RowBox[{"gamma", " ", 
     RowBox[{"Sinh", "[", "gamma", "]"}]}], "+", 
    SuperscriptBox[
     RowBox[{"Sinh", "[", "gamma", "]"}], "2"]}], "beta"]}]], "Output",
 CellChangeTimes->{3.777834077921155*^9},
 CellLabel->"Out[94]=",ExpressionUUID->"7fdb9b8d-8914-4ad0-8aef-e6bf811088c3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"3", " ", "g1", " ", "g3"}]}], " ", "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sinh", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"-", "beta"}], "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"-", "beta"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7778341711615562`*^9, 3.777834183528399*^9}},
 CellLabel->"In[95]:=",ExpressionUUID->"e23362bf-e9b4-4ef9-8e28-058674320e1a"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], "2"]}], 
   SuperscriptBox["beta", "2"]], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"(", 
     RowBox[{"gamma", "-", 
      RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sinh", "[", "gamma", "]"}]}], 
   SuperscriptBox["beta", "2"]]}]], "Output",
 CellChangeTimes->{3.7778341856323967`*^9},
 CellLabel->"Out[95]=",ExpressionUUID->"8963c7ff-166b-4093-a9ba-1849be0f5022"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7778341874490623`*^9, 3.777834188960495*^9}},
 CellLabel->"In[96]:=",ExpressionUUID->"50f09dee-36b5-4589-b29e-2766cba844d4"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", "-", 
   RowBox[{"4", " ", 
    RowBox[{"Cosh", "[", "gamma", "]"}]}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"Cosh", "[", "gamma", "]"}], "2"]}], "+", 
   RowBox[{"3", " ", "gamma", " ", 
    RowBox[{"Sinh", "[", "gamma", "]"}]}], "-", 
   RowBox[{"3", " ", 
    SuperscriptBox[
     RowBox[{"Sinh", "[", "gamma", "]"}], "2"]}]}], 
  SuperscriptBox["beta", "2"]]], "Output",
 CellChangeTimes->{3.777834189269227*^9},
 CellLabel->"Out[96]=",ExpressionUUID->"e7326b49-74d4-4125-9c3e-97b25f2d0c19"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"3", " ", "g1", " ", "g3"}]}], " ", "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sin", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}]], "Input",
 CellLabel->"In[97]:=",ExpressionUUID->"db7e0ae3-10aa-4535-9478-e3879d419525"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "2"]}], 
   SuperscriptBox["beta", "2"]], "-", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"(", 
     RowBox[{"gamma", "-", 
      RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sin", "[", "gamma", "]"}]}], 
   SuperscriptBox["beta", "2"]]}]], "Output",
 CellChangeTimes->{3.7778342276507397`*^9},
 CellLabel->"Out[97]=",ExpressionUUID->"6b9cc579-dbec-4ee1-aa1d-f9bdcbf7cc46"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7778342286780863`*^9, 3.77783422976493*^9}},
 CellLabel->"In[98]:=",ExpressionUUID->"99ba2f77-c4a9-47ed-b6e7-aab2e7d8d3b4"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", "-", 
   RowBox[{"4", " ", 
    RowBox[{"Cos", "[", "gamma", "]"}]}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"Cos", "[", "gamma", "]"}], "2"]}], "-", 
   RowBox[{"3", " ", "gamma", " ", 
    RowBox[{"Sin", "[", "gamma", "]"}]}], "+", 
   RowBox[{"3", " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", "gamma", "]"}], "2"]}]}], 
  SuperscriptBox["beta", "2"]]], "Output",
 CellChangeTimes->{3.7778342300373793`*^9},
 CellLabel->"Out[98]=",ExpressionUUID->"368c5995-8a15-44a7-8722-c234563953b1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", "+", "g0"}], ")"}], " ", "g3"}]}], " ", "/.", " ", 
     RowBox[{"g0", " ", "\[Rule]", " ", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sinh", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"-", "beta"}], "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"-", "beta"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7778343922618313`*^9, 3.777834398514717*^9}},
 CellLabel->
  "In[103]:=",ExpressionUUID->"7a0e1a49-b694-43ac-900b-8edc6355b2ef"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", "+", 
       RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}]}], 
    RowBox[{
     SqrtBox[
      RowBox[{"-", "beta"}]], " ", "beta"}]]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sinh", "[", "gamma", "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"-", "beta"}]], " ", "beta"}]]}]], "Output",
 CellChangeTimes->{3.7778342833702917`*^9, 3.777834400002787*^9},
 CellLabel->
  "Out[103]=",ExpressionUUID->"b17f7e38-badf-4072-94d7-edca4e5acbd7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777834284762782*^9, 3.777834286321533*^9}},
 CellLabel->
  "In[104]:=",ExpressionUUID->"91949695-8d45-4b19-bb06-0470a5c9e202"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"2", " ", "gamma"}], "+", 
   RowBox[{"gamma", " ", 
    RowBox[{"Cosh", "[", "gamma", "]"}]}], "-", 
   RowBox[{"3", " ", 
    RowBox[{"Sinh", "[", "gamma", "]"}]}]}], 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"-", "beta"}], ")"}], 
   RowBox[{"3", "/", "2"}]]]], "Output",
 CellChangeTimes->{3.777834286565629*^9, 3.777834402750478*^9},
 CellLabel->
  "Out[104]=",ExpressionUUID->"89bc7ed8-51d1-44bf-91dd-618541edb0b7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", "+", "g0"}], ")"}], " ", "g3"}]}], " ", "/.", " ", 
     RowBox[{"g0", " ", "\[Rule]", " ", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sin", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777834338345312*^9, 3.777834347312921*^9}, {
  3.777834405572945*^9, 3.777834409922477*^9}},
 CellLabel->
  "In[105]:=",ExpressionUUID->"4b2d9a31-dff4-40f2-a8a4-e97ad92d179c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", "+", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}], 
    SuperscriptBox["beta", 
     RowBox[{"3", "/", "2"}]]]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sin", "[", "gamma", "]"}]}], 
   SuperscriptBox["beta", 
    RowBox[{"3", "/", "2"}]]]}]], "Output",
 CellChangeTimes->{3.777834347733089*^9, 3.777834410573415*^9},
 CellLabel->
  "Out[105]=",ExpressionUUID->"5c208fee-79de-424d-ac90-64c5e9613735"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.77783434857628*^9, 3.777834350656776*^9}},
 CellLabel->
  "In[106]:=",ExpressionUUID->"3befd2ab-6129-48ba-8c70-7eb34c6f6efb"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{"2", " ", "gamma"}], "+", 
    RowBox[{"gamma", " ", 
     RowBox[{"Cos", "[", "gamma", "]"}]}], "-", 
    RowBox[{"3", " ", 
     RowBox[{"Sin", "[", "gamma", "]"}]}]}], 
   SuperscriptBox["beta", 
    RowBox[{"3", "/", "2"}]]]}]], "Output",
 CellChangeTimes->{3.77783435098178*^9, 3.777834413080777*^9},
 CellLabel->
  "Out[106]=",ExpressionUUID->"b4d33aef-cdfb-4252-81c1-308f2f19e5f3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], "*", 
    RowBox[{"gamma", "^", "5"}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "^", "n"}], "*", 
    RowBox[{"gamma", "^", 
     RowBox[{"(", 
      RowBox[{"2", "n"}], ")"}]}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"n", "+", "1"}], ")"}], "/", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "n"}], "+", "5"}], ")"}], "!"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777834361415374*^9, 3.77783436218346*^9}, {
  3.7778357147622423`*^9, 3.7778357472712717`*^9}},
 CellLabel->
  "In[107]:=",ExpressionUUID->"a6d6ac4f-f3d7-45fb-bec9-b53f46f90d8d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "5"], "60"]}], ",", 
   FractionBox[
    SuperscriptBox["gamma", "7"], "1260"], ",", 
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "9"], "60480"]}], ",", 
   FractionBox[
    SuperscriptBox["gamma", "11"], "4989600"], ",", 
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "13"], "622702080"]}], ",", 
   FractionBox[
    SuperscriptBox["gamma", "15"], "108972864000"]}], "}"}]], "Output",
 CellChangeTimes->{3.777835747772736*^9},
 CellLabel->
  "Out[107]=",ExpressionUUID->"623cb2ec-b9c9-472f-a880-a007718a1192"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"2", "/", 
  RowBox[{"5", "!"}]}]], "Input",
 CellChangeTimes->{{3.7778357900203123`*^9, 3.777835791098672*^9}},
 CellLabel->
  "In[108]:=",ExpressionUUID->"008111af-7934-4b81-8e7e-f92241b5fa5c"],

Cell[BoxData[
 FractionBox["1", "60"]], "Output",
 CellChangeTimes->{3.777835791494652*^9},
 CellLabel->
  "Out[108]=",ExpressionUUID->"8ac09ba1-6cb9-47d5-858f-151db9efa31b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"2", "*", 
    RowBox[{"gamma", "^", "6"}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "^", "n"}], "*", 
    RowBox[{"gamma", "^", 
     RowBox[{"(", 
      RowBox[{"2", "n"}], ")"}]}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"4", "^", 
        RowBox[{"(", 
         RowBox[{"n", "+", "2"}], ")"}]}], "-", 
       RowBox[{"3", "*", "n"}], "-", "7"}], ")"}], "/", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "n"}], "+", "6"}], ")"}], "!"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.77783617633457*^9, 3.777836206189781*^9}},
 CellLabel->
  "In[110]:=",ExpressionUUID->"d77683fb-f5d0-43c5-a9ee-9c48ff144e3d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "6"], "40"], ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox["gamma", "8"]}], "1120"]}], ",", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "10"]}], "22400"], ",", 
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "12"], "237600"]}], ",", 
   FractionBox[
    RowBox[{"151", " ", 
     SuperscriptBox["gamma", "14"]}], "1614412800"], ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"101", " ", 
      SuperscriptBox["gamma", "16"]}], "64576512000"]}]}], "}"}]], "Output",
 CellChangeTimes->{3.77783620667734*^9},
 CellLabel->
  "Out[110]=",ExpressionUUID->"25b59c9c-afff-4b87-8507-04668575dea8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", 
        SuperscriptBox["g2", "2"]}], "-", 
       RowBox[{"3", " ", "g1", " ", "g3"}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "15"}], "}"}]}], "]"}]], "Input",
 CellLabel->
  "In[111]:=",ExpressionUUID->"7a8a43a5-f2b3-46b6-b0c2-af1fa826d2dd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "6"], 
    RowBox[{"40", " ", 
     SuperscriptBox["beta", "2"]}]], "-", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"1120", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "10"]}], 
    RowBox[{"22400", " ", 
     SuperscriptBox["beta", "2"]}]], "-", 
   FractionBox[
    SuperscriptBox["gamma", "12"], 
    RowBox[{"237600", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   FractionBox[
    RowBox[{"151", " ", 
     SuperscriptBox["gamma", "14"]}], 
    RowBox[{"1614412800", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "16"],
    SeriesData[$CellContext`gamma, 0, {}, 6, 16, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 40] $CellContext`beta^(-2), 0, 
    Rational[-3, 1120] $CellContext`beta^(-2), 0, 
    Rational[3, 22400] $CellContext`beta^(-2), 0, 
    Rational[-1, 237600] $CellContext`beta^(-2), 0, 
    Rational[151, 1614412800] $CellContext`beta^(-2)}, 6, 16, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777836225366055*^9},
 CellLabel->
  "Out[111]=",ExpressionUUID->"3e142a8d-8f54-47a5-8306-3535d5c1df7c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"2", " ", 
       SuperscriptBox["g2", "2"]}], " ", "-", " ", 
      RowBox[{"3", "g1", " ", "g3"}]}], " ", "/.", " ", 
     RowBox[{"g0", " ", "\[Rule]", " ", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sinh", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"-", "beta"}], "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"-", "beta"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777836349279951*^9, 3.777836388583021*^9}},
 CellLabel->
  "In[114]:=",ExpressionUUID->"6a697d00-0cf6-4953-bbf8-718e0fc0554b"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], "2"]}], 
   SuperscriptBox["beta", "2"]], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"(", 
     RowBox[{"gamma", "-", 
      RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sinh", "[", "gamma", "]"}]}], 
   SuperscriptBox["beta", "2"]]}]], "Output",
 CellChangeTimes->{{3.777836361955089*^9, 3.777836389525388*^9}},
 CellLabel->
  "Out[114]=",ExpressionUUID->"19b85f35-5ea4-4c81-86b8-6014721d13e8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7778363635443773`*^9, 3.7778363660473127`*^9}},
 CellLabel->
  "In[115]:=",ExpressionUUID->"f37c1b70-4671-4fcd-ad5e-0adb2686c2dc"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{"-", "9"}], "+", 
    RowBox[{"8", " ", 
     RowBox[{"Cosh", "[", "gamma", "]"}]}], "+", 
    RowBox[{"Cosh", "[", 
     RowBox[{"2", " ", "gamma"}], "]"}], "-", 
    RowBox[{"6", " ", "gamma", " ", 
     RowBox[{"Sinh", "[", "gamma", "]"}]}]}], 
   RowBox[{"2", " ", 
    SuperscriptBox["beta", "2"]}]]}]], "Output",
 CellChangeTimes->{{3.777836366411017*^9, 3.7778363913810253`*^9}},
 CellLabel->
  "Out[115]=",ExpressionUUID->"0ecd15bc-b697-4e5e-94f2-085532c899d0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"2", " ", 
       SuperscriptBox["g2", "2"]}], " ", "-", " ", 
      RowBox[{"3", "g1", " ", "g3"}]}], " ", "/.", " ", 
     RowBox[{"g0", " ", "\[Rule]", " ", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}]}]}], "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sin", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.77783648424117*^9, 3.777836492680894*^9}},
 CellLabel->
  "In[116]:=",ExpressionUUID->"731c6846-a669-48a4-9e17-1f75524b3400"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "2"]}], 
   SuperscriptBox["beta", "2"]], "-", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"(", 
     RowBox[{"gamma", "-", 
      RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sin", "[", "gamma", "]"}]}], 
   SuperscriptBox["beta", "2"]]}]], "Output",
 CellChangeTimes->{3.7778364931121902`*^9},
 CellLabel->
  "Out[116]=",ExpressionUUID->"2817a1da-941c-4704-82ba-1a04b53a91a0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777836493880334*^9, 3.777836495704783*^9}},
 CellLabel->
  "In[117]:=",ExpressionUUID->"c8203e85-bb2c-4405-8f82-10f0e6d6b21e"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{"-", "9"}], "+", 
    RowBox[{"8", " ", 
     RowBox[{"Cos", "[", "gamma", "]"}]}], "+", 
    RowBox[{"Cos", "[", 
     RowBox[{"2", " ", "gamma"}], "]"}], "+", 
    RowBox[{"6", " ", "gamma", " ", 
     RowBox[{"Sin", "[", "gamma", "]"}]}]}], 
   RowBox[{"2", " ", 
    SuperscriptBox["beta", "2"]}]]}]], "Output",
 CellChangeTimes->{3.777836496041841*^9},
 CellLabel->
  "Out[117]=",ExpressionUUID->"b748b4e8-c0bb-4afa-b914-f759b8a74982"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"9", "-", 
      RowBox[{"8", 
       RowBox[{"Cosh", "[", "gamma", "]"}]}], "-", 
      RowBox[{"Cosh", "[", 
       RowBox[{"2", "*", "gamma"}], "]"}], "+", 
      RowBox[{"6", "*", "gamma", "*", 
       RowBox[{"Sinh", "[", "gamma", "]"}]}]}], ")"}], "/", "2"}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "15"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7778376713877487`*^9, 3.777837725139045*^9}},
 CellLabel->
  "In[119]:=",ExpressionUUID->"16eaeb0b-b52e-443c-a442-31ce6c6d7109"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "6"], "40"]}], "-", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "8"]}], "1120"], "-", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["gamma", "10"]}], "22400"], "-", 
   FractionBox[
    SuperscriptBox["gamma", "12"], "237600"], "-", 
   FractionBox[
    RowBox[{"151", " ", 
     SuperscriptBox["gamma", "14"]}], "1614412800"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "16"],
    SeriesData[$CellContext`gamma, 0, {}, 6, 16, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
    Rational[-1, 40], 0, 
    Rational[-3, 1120], 0, 
    Rational[-3, 22400], 0, 
    Rational[-1, 237600], 0, 
    Rational[-151, 1614412800]}, 6, 16, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7778376949327393`*^9, 3.777837725485283*^9},
 CellLabel->
  "Out[119]=",ExpressionUUID->"0c289efd-d060-4636-905b-e2dfd71e7cd2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Now", " ", "work", " ", "on", " ", 
    RowBox[{"dv0", ".", "v0"}], " ", 
    RowBox[{"term", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.7781674458223553`*^9, 3.778167450630095*^9}, {
  3.778167522884901*^9, 
  3.778167523196487*^9}},ExpressionUUID->"61f9f3cc-91c2-4467-af26-\
c5f1fc046c6c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             FractionBox["k", 
              RowBox[{"beta", " ", "r", " ", "r0"}]], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                SuperscriptBox["r0", "2"], 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"g1", " ", "g2"}], "-", 
                  RowBox[{"3", " ", "g3", " ", "g0"}]}], ")"}]}], "-", 
               RowBox[{"beta", " ", "h", " ", "r0", " ", 
                SuperscriptBox["g2", "2"]}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"h", " ", "k"}], " ", "+", 
                  RowBox[{"eta", " ", "r0"}]}], " ", ")"}], "h6"}]}], ")"}]}],
             "/.", " ", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "9"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778167476103513*^9, 3.778167596884054*^9}, {
  3.778167627501717*^9, 3.778167686682469*^9}, {3.778167749340626*^9, 
  3.778167765872919*^9}, {3.778167825953019*^9, 3.778167846413826*^9}, {
  3.7781679215989933`*^9, 3.778168037771049*^9}, {3.778168079578497*^9, 
  3.778168460659008*^9}},ExpressionUUID->"e76f5a33-5914-483f-8f8f-\
30601a27b9fd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"k", " ", 
      SuperscriptBox["gamma", "5"]}], 
     RowBox[{"10", " ", 
      SuperscriptBox["beta", 
       RowBox[{"5", "/", "2"}]]}]]}], "+", 
   FractionBox[
    RowBox[{"k", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"14", " ", "k"}], "+", 
       RowBox[{"5", " ", "beta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"420", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", 
       SuperscriptBox["k", "2"]}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"48", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "4"], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "210"}], " ", 
          SuperscriptBox["eta", "2"], " ", "k"}], "+", 
         RowBox[{"126", " ", 
          SuperscriptBox["k", "2"], " ", "r0"}], "-", 
         RowBox[{"88", " ", "beta", " ", "k", " ", 
          SuperscriptBox["r0", "2"]}], "+", 
         RowBox[{"7", " ", 
          SuperscriptBox["beta", "2"], " ", 
          SuperscriptBox["r0", "3"]}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "9"]}], 
    RowBox[{"10080", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"9", "/", "2"}]], " ", 
       SuperscriptBox["r0", "3"]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "10"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 10, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 10] $CellContext`beta^Rational[-5, 2] $CellContext`k, 0, 
    Rational[1, 420] $CellContext`beta^
     Rational[-7, 2] $CellContext`k $CellContext`r0^(-1) (14 $CellContext`k + 
     5 $CellContext`beta $CellContext`r0), 
    Rational[-1, 
      48] $CellContext`beta^(-4) $CellContext`eta $CellContext`k^2 \
$CellContext`r0^(-2), 
    Rational[-1, 10080] $CellContext`beta^
     Rational[-9, 
       2] $CellContext`k $CellContext`r0^(-3) ((-210) $CellContext`eta^2 \
$CellContext`k + 126 $CellContext`k^2 $CellContext`r0 - 
     88 $CellContext`beta $CellContext`k $CellContext`r0^2 + 
     7 $CellContext`beta^2 $CellContext`r0^3)}, 5, 10, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.778167492845169*^9, 3.778167537772945*^9}, {
   3.7781676282988377`*^9, 3.778167648083179*^9}, {3.7781676817204237`*^9, 
   3.778167687059536*^9}, 3.778167770775608*^9, 3.778167847975019*^9, 
   3.77816795294304*^9, {3.778167993208951*^9, 3.7781680220249367`*^9}, {
   3.778168093251988*^9, 3.778168182780604*^9}, {3.778168223988571*^9, 
   3.7781682326353493`*^9}, 3.778168275151628*^9, 3.778168315239398*^9, {
   3.7781683766614647`*^9, 3.7781683886384783`*^9}, {3.778168422875937*^9, 
   3.7781684336504374`*^9}},
 CellLabel->
  "Out[212]=",ExpressionUUID->"c72ec603-d92d-4c5b-acba-8805b9910ebf"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       StyleBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"k", " ", "c9"}], 
           RowBox[{"beta", " ", "r0"}]], "-", 
          FractionBox[
           RowBox[{"d", " ", "k", " ", "c13"}], 
           RowBox[{"r", " ", "r0"}]]}], ")"}],
        FontSlant->"Italic",
        FontColor->GrayLevel[0]], 
       StyleBox["-",
        FontSlant->"Italic",
        FontColor->GrayLevel[0]], 
       RowBox[{
        FractionBox["k", 
         RowBox[{"beta", " ", "r", " ", "r0"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox["r0", "2"], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g1", " ", "g2"}], "-", 
             RowBox[{"3", " ", "g3", " ", "g0"}]}], ")"}]}], "-", 
          RowBox[{"beta", " ", "h", " ", "r0", " ", 
           SuperscriptBox["g2", "2"]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"h", " ", "k"}], " ", "+", 
             RowBox[{"eta", " ", "r0"}]}], " ", ")"}], "h6"}]}], ")"}]}]}], "/.",
       " ", 
      RowBox[{"h6", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"2", 
         SuperscriptBox["g2", "2"]}], "-", 
        RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
     RowBox[{"d", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", "*", "g2"}], "+", 
         RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], "  ",
     "/.", " ", 
    RowBox[{"h", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
      RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
      RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
   RowBox[{"r", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
     RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
  RowBox[{"zeta", " ", "\[Rule]", " ", 
   RowBox[{"k", "-", 
    RowBox[{"beta", " ", "r0", " "}]}]}]}]], "Input",
 CellChangeTimes->{
  3.7781677184266*^9, {3.778168496441242*^9, 3.778168513445612*^9}},
 CellLabel->
  "In[215]:=",ExpressionUUID->"521cd013-c876-4a23-a448-9db228a20511"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"g2", "^", "2"}], "-", 
        RowBox[{"3", " ", "g1", " ", "g3"}]}], "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778168880709174*^9, 3.7781689119465437`*^9}},
 CellLabel->
  "In[217]:=",ExpressionUUID->"1df43e2b-7836-4c63-8c05-add0bc50c43c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "4"], 
     RowBox[{"4", " ", 
      SuperscriptBox["beta", "2"]}]]}], "+", 
   FractionBox[
    SuperscriptBox["gamma", "6"], 
    RowBox[{"15", " ", 
     SuperscriptBox["beta", "2"]}]], "-", 
   FractionBox[
    RowBox[{"13", " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"2240", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 4] $CellContext`beta^(-2), 0, 
    Rational[1, 15] $CellContext`beta^(-2), 0, 
    Rational[-13, 2240] $CellContext`beta^(-2)}, 4, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.77816891234906*^9},
 CellLabel->
  "Out[217]=",ExpressionUUID->"a76bb739-a4fa-4f86-be5a-217121d29b28"]
}, Open  ]]
},
WindowSize->{1091, 572},
WindowMargins->{{3, Automatic}, {Automatic, 0}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 2594, 65, 220, "Input",ExpressionUUID->"53329b6c-a80c-45ac-ae62-f6fb243392bd"],
Cell[CellGroupData[{
Cell[3177, 89, 1376, 35, 50, "Input",ExpressionUUID->"599cae75-96f6-4e35-a7da-01caf6fb2f55"],
Cell[4556, 126, 1062, 30, 68, "Output",ExpressionUUID->"b1dcd199-656f-4674-bb12-88cd6ae21b23"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5655, 161, 503, 12, 30, "Input",ExpressionUUID->"95296aac-8480-48bf-b720-90060933f9ed"],
Cell[6161, 175, 500, 11, 53, "Output",ExpressionUUID->"dbb0f0af-98a2-4a33-9d76-72e16a90574f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6698, 191, 276, 5, 30, "Input",ExpressionUUID->"6e130959-e5af-4389-aed5-d86ced425512"],
Cell[6977, 198, 337, 6, 52, "Output",ExpressionUUID->"4c5a08d5-5efc-4afa-8692-91191f71e628"]
}, Open  ]],
Cell[7329, 207, 631, 13, 30, "Input",ExpressionUUID->"2d884b31-7a55-4520-bbb8-26a9cd31ce07"],
Cell[CellGroupData[{
Cell[7985, 224, 1405, 38, 50, "Input",ExpressionUUID->"a6c48c41-52a5-424e-8082-2ada96dd916c"],
Cell[9393, 264, 2423, 70, 105, "Output",ExpressionUUID->"c3cb023c-09cb-4b1b-9870-e7d643ee1bfc"]
}, Open  ]],
Cell[11831, 337, 179, 3, 30, "Input",ExpressionUUID->"004650bd-f43e-499e-861e-d29d34e0ac57"],
Cell[CellGroupData[{
Cell[12035, 344, 305, 7, 30, "Input",ExpressionUUID->"c50ee62d-22cf-45d5-85af-1fc4bc50ccb2"],
Cell[12343, 353, 3414, 107, 174, "Output",ExpressionUUID->"2c8936c0-e679-4519-a66c-008f4c419289"]
}, Open  ]],
Cell[15772, 463, 319, 7, 30, "Input",ExpressionUUID->"4cfaaa76-44ec-4daf-a4b4-a197eb8005e7"],
Cell[CellGroupData[{
Cell[16116, 474, 1601, 47, 92, "Input",ExpressionUUID->"25b93094-0eb0-47de-b80e-74801c31e5ad"],
Cell[17720, 523, 1532, 48, 60, "Output",ExpressionUUID->"61e2deb7-332a-413f-9a98-946f2eb7fe6c"]
}, Open  ]],
Cell[19267, 574, 321, 7, 30, "Input",ExpressionUUID->"503115b3-a2e2-4043-97f2-8b243c3e7beb"],
Cell[CellGroupData[{
Cell[19613, 585, 961, 27, 49, "Input",ExpressionUUID->"8adf5d1c-282b-455b-96df-f6459d945d78"],
Cell[20577, 614, 975, 29, 52, "Output",ExpressionUUID->"e78fa3f5-12c6-4a7a-99d4-4fc17bc2950e"]
}, Open  ]],
Cell[21567, 646, 156, 3, 30, "Input",ExpressionUUID->"7a8f6d3f-4d55-4131-87d7-d7dbeac9f082"],
Cell[CellGroupData[{
Cell[21748, 653, 6728, 194, 223, "Input",ExpressionUUID->"5016d470-2559-42c7-9097-a15b73e2e0c2"],
Cell[28479, 849, 5846, 184, 201, "Output",ExpressionUUID->"8d9e4bf4-9b6e-42d7-aa9c-46858b286459"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34362, 1038, 587, 13, 52, "Input",ExpressionUUID->"7059d59a-422c-4fa8-8a97-619f047bef25"],
Cell[34952, 1053, 7378, 228, 270, "Output",ExpressionUUID->"7d743469-b282-427c-a47e-3a45afce828d"]
}, Open  ]],
Cell[42345, 1284, 663, 17, 52, "Input",ExpressionUUID->"2d2780f5-7883-466a-8a23-8bc50de57f16"],
Cell[CellGroupData[{
Cell[43033, 1305, 2062, 60, 86, "Input",ExpressionUUID->"86606400-4dcd-4a36-bd1d-3a1e6bba1e6b"],
Cell[45098, 1367, 2943, 91, 110, "Output",ExpressionUUID->"a9bcab77-bc8a-404d-abc5-bc0090747836"]
}, Open  ]],
Cell[48056, 1461, 257, 5, 30, "Input",ExpressionUUID->"93376667-ae79-4f2c-bce9-f4e105374de8"],
Cell[CellGroupData[{
Cell[48338, 1470, 3198, 92, 163, "Input",ExpressionUUID->"4c137373-3aac-4897-9d22-41fe9976ebba"],
Cell[51539, 1564, 3835, 117, 157, "Output",ExpressionUUID->"9f2fcefe-0022-4a70-b687-a125d4fe1548"]
}, Open  ]],
Cell[55389, 1684, 399, 8, 30, "Input",ExpressionUUID->"d4d207ae-e603-472b-bd2a-7645ab9a44c9"],
Cell[CellGroupData[{
Cell[55813, 1696, 10400, 298, 439, "Input",ExpressionUUID->"71c53a07-8e97-43ef-b6c9-30d71d21b7fa"],
Cell[66216, 1996, 9762, 294, 370, "Output",ExpressionUUID->"6e761827-de11-4175-a87b-506cf36f7583"]
}, Open  ]],
Cell[75993, 2293, 151, 3, 30, "Input",ExpressionUUID->"b06ac194-483e-4554-96dc-68188fd2cee1"],
Cell[76147, 2298, 306, 5, 30, "Input",ExpressionUUID->"cd0464f3-29a9-4cb8-8b4a-c7b30bf6369f"],
Cell[CellGroupData[{
Cell[76478, 2307, 1528, 39, 159, "Input",ExpressionUUID->"02caa98e-227a-41a9-a2b1-d150f70a6341"],
Cell[78009, 2348, 417, 8, 34, "Output",ExpressionUUID->"38ba11af-be2f-4671-b4ea-336cac2a8805"],
Cell[78429, 2358, 463, 10, 34, "Output",ExpressionUUID->"32949255-2beb-41be-bcc2-9054b8c1d54d"],
Cell[78895, 2370, 461, 9, 34, "Output",ExpressionUUID->"b7b9bf6f-64df-4f95-892c-66bf030f7c9c"],
Cell[79359, 2381, 953, 26, 71, "Output",ExpressionUUID->"c00d2355-add9-42e6-b846-25972d64312f"],
Cell[80315, 2409, 441, 9, 34, "Output",ExpressionUUID->"34198899-8bed-49b5-9283-8b95e182918b"]
}, Open  ]],
Cell[80771, 2421, 1608, 31, 73, "Input",ExpressionUUID->"7764e67b-80f4-4df8-b0a1-32adf9790e91"],
Cell[CellGroupData[{
Cell[82404, 2456, 2898, 83, 92, "Input",ExpressionUUID->"1f16c967-d72d-40ee-b17b-f7d752098f67"],
Cell[85305, 2541, 7561, 226, 389, "Output",ExpressionUUID->"c36af7f3-4c19-4d17-bc2d-743e3dc3b2e5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92903, 2772, 2688, 81, 152, "Input",ExpressionUUID->"29de0093-8b3b-43b3-a83e-06aa1f8448cc"],
Cell[95594, 2855, 998, 19, 153, "Output",ExpressionUUID->"89ecec00-37ff-447d-8164-a885c12c1593"]
}, Open  ]],
Cell[CellGroupData[{
Cell[96629, 2879, 379, 8, 30, "Input",ExpressionUUID->"afffa04e-4607-4f53-a2b2-4167649063c7"],
Cell[97011, 2889, 15568, 465, 707, "Output",ExpressionUUID->"259503a6-0148-4860-b116-fe7355d03a24"]
}, Open  ]],
Cell[CellGroupData[{
Cell[112616, 3359, 206, 3, 30, "Input",ExpressionUUID->"43aa630a-e7ce-4256-af68-8e40c9c6ec93"],
Cell[112825, 3364, 270, 4, 34, "Output",ExpressionUUID->"c6f18da8-de47-464d-bc4e-28ab976e90f7"]
}, Open  ]],
Cell[113110, 3371, 832, 19, 94, "Input",ExpressionUUID->"4336da56-ade9-4e2d-bb64-5f5f3bf4b6d6"],
Cell[CellGroupData[{
Cell[113967, 3394, 2482, 64, 128, "Input",ExpressionUUID->"0ad12f9c-911d-421b-a2d2-1c8b254d5fb3"],
Cell[116452, 3460, 1626, 44, 55, "Output",ExpressionUUID->"cf988364-0e18-41fd-8f8d-17be9a5203d5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[118115, 3509, 2216, 59, 130, "Input",ExpressionUUID->"81d05af4-3b76-43c9-88e8-7ed34c5224d7"],
Cell[120334, 3570, 980, 28, 55, "Output",ExpressionUUID->"d1e11339-7206-4b44-90c9-14e279dfec84"]
}, Open  ]],
Cell[CellGroupData[{
Cell[121351, 3603, 2230, 59, 128, "Input",ExpressionUUID->"e4fb7760-72d8-4670-aa27-1ee0a57e56da"],
Cell[123584, 3664, 842, 24, 55, "Output",ExpressionUUID->"6031f999-6573-466d-bba4-95ea25d33a56"]
}, Open  ]],
Cell[CellGroupData[{
Cell[124463, 3693, 2239, 60, 130, "Input",ExpressionUUID->"a9303ec7-a042-42aa-99a8-74419d4110db"],
Cell[126705, 3755, 1144, 35, 60, "Output",ExpressionUUID->"4df0fdfa-f09f-4a2d-b1d8-1979eabeb020"]
}, Open  ]],
Cell[CellGroupData[{
Cell[127886, 3795, 2421, 64, 130, "Input",ExpressionUUID->"57d5efc0-c8b2-424a-bf25-f7f8c2d8f052"],
Cell[130310, 3861, 705, 19, 55, "Output",ExpressionUUID->"019ed7b7-b3be-4d20-8d18-08a83ea8450c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[131052, 3885, 1210, 35, 74, "Input",ExpressionUUID->"a4e0d5f5-906e-4e2c-8552-1c96e1528ea3"],
Cell[132265, 3922, 1448, 46, 63, "Output",ExpressionUUID->"4774699f-72f8-45a1-bfa1-0ce0023c5ba6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[133750, 3973, 1764, 54, 52, "Input",ExpressionUUID->"8cf887cb-f59b-4352-a5da-3c6cc97f1a67"],
Cell[135517, 4029, 1365, 42, 55, "Output",ExpressionUUID->"cd8c7fad-4c32-4f6c-82ea-e3104c1a2800"]
}, Open  ]],
Cell[CellGroupData[{
Cell[136919, 4076, 206, 3, 30, "Input",ExpressionUUID->"925c512c-9f8f-4ca9-af57-6184aec2b95d"],
Cell[137128, 4081, 2305, 56, 123, "Output",ExpressionUUID->"d99648c5-f2cf-4f21-ae95-c8c187af7af0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[139470, 4142, 2173, 50, 77, "Input",ExpressionUUID->"a56c4eb4-7af8-4a94-ab2f-55e7ca27a5fe"],
Cell[141646, 4194, 1920, 56, 60, "Output",ExpressionUUID->"ae8d0aa7-2315-4bf8-9ecd-02fff6b2f38a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[143603, 4255, 966, 27, 33, "Input",ExpressionUUID->"c18c66f8-9efc-4116-8e14-f91704c16293"],
Cell[144572, 4284, 673, 20, 55, "Output",ExpressionUUID->"752554c8-cf61-4416-9709-9027271f412b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[145282, 4309, 373, 8, 30, "Input",ExpressionUUID->"2defd221-78ef-4679-9e81-5f9c2044b560"],
Cell[145658, 4319, 622, 17, 55, "Output",ExpressionUUID->"40a5c627-5309-4792-9807-77673e1a998b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[146317, 4341, 1163, 32, 56, "Input",ExpressionUUID->"d3201130-3c76-4061-9ce4-475056c837a6"],
Cell[147483, 4375, 636, 17, 55, "Output",ExpressionUUID->"1ae349f7-50fe-4f5a-ac23-5f8e9abc31b9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[148156, 4397, 1457, 39, 56, "Input",ExpressionUUID->"facff28c-fecd-41a0-9413-b418de533def"],
Cell[149616, 4438, 872, 24, 55, "Output",ExpressionUUID->"db9df37a-0324-4608-aebf-d29f014553b0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[150525, 4467, 1483, 40, 56, "Input",ExpressionUUID->"b00a7211-f5f3-4e86-913d-151f531adb6a"],
Cell[152011, 4509, 1110, 32, 55, "Output",ExpressionUUID->"917dbca0-e2c8-4ee3-9180-84f1ccee710a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[153158, 4546, 1500, 42, 56, "Input",ExpressionUUID->"b1341a42-d448-441f-85a0-96e8885c5e0d"],
Cell[154661, 4590, 968, 28, 55, "Output",ExpressionUUID->"c520c2dc-4625-4161-8d91-6f7591be20b4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[155666, 4623, 3187, 85, 123, "Input",ExpressionUUID->"71ecaf4f-2cc1-461f-bcd4-06af3b298ea8"],
Cell[158856, 4710, 734, 21, 55, "Output",ExpressionUUID->"e3158220-8f33-4a6c-a2bd-de061bbb968d"]
}, Open  ]],
Cell[159605, 4734, 327, 6, 52, "Input",ExpressionUUID->"8b2f4841-bfb9-4ca9-b0b7-131b09edaceb"],
Cell[CellGroupData[{
Cell[159957, 4744, 2643, 70, 146, "Input",ExpressionUUID->"f2352cd0-ff7f-47ca-8b9c-df39ec744830"],
Cell[162603, 4816, 3205, 91, 115, "Output",ExpressionUUID->"b3640090-2af8-41ba-90ed-6f06b25dad1b"]
}, Open  ]],
Cell[165823, 4910, 128, 3, 30, "Input",ExpressionUUID->"3abd8fe3-5f4f-4ba8-b50c-b4bb51f115b9"],
Cell[CellGroupData[{
Cell[165976, 4917, 2132, 57, 128, "Input",ExpressionUUID->"13f47c66-1a92-46f1-acdb-21f014e2fc96"],
Cell[168111, 4976, 1072, 29, 55, "Output",ExpressionUUID->"872fc813-a9f7-447a-a546-e4870721f029"]
}, Open  ]],
Cell[CellGroupData[{
Cell[169220, 5010, 2191, 58, 128, "Input",ExpressionUUID->"7304d6b2-0f93-4486-8d8c-15af85813aab"],
Cell[171414, 5070, 2410, 66, 62, "Output",ExpressionUUID->"5cdb5760-dc4b-4eb8-910e-e3e8bba01bf7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[173861, 5141, 2392, 63, 146, "Input",ExpressionUUID->"12b18faf-c4a1-4ec8-a682-8e33f9cf2387"],
Cell[176256, 5206, 1646, 48, 60, "Output",ExpressionUUID->"8da9ff3e-645d-408f-a92d-24dc5789b39b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[177939, 5259, 2131, 57, 94, "Input",ExpressionUUID->"307edaa9-a985-4d9e-8d25-53dccec330d4"],
Cell[180073, 5318, 2348, 70, 62, "Output",ExpressionUUID->"caa8d69f-4df5-4059-ad6c-f5997cc0dc20"]
}, Open  ]],
Cell[182436, 5391, 343, 7, 52, "Input",ExpressionUUID->"463660b4-ef2e-4c47-b1c0-81abfe9ad33c"],
Cell[CellGroupData[{
Cell[182804, 5402, 2332, 62, 128, "Input",ExpressionUUID->"32c4b847-2c7b-4c4d-9dbf-dbdc2e557eb9"],
Cell[185139, 5466, 1865, 55, 57, "Output",ExpressionUUID->"29a3ccb8-3aed-407d-8412-70a928a3097e"]
}, Open  ]],
Cell[187019, 5524, 130, 3, 30, "Input",ExpressionUUID->"2246bbc1-f052-4de4-b62a-b4a6b7f37482"],
Cell[CellGroupData[{
Cell[187174, 5531, 2156, 58, 94, "Input",ExpressionUUID->"f0b5b712-2c5e-4564-83f7-7a57ea6f4dd1"],
Cell[189333, 5591, 1693, 49, 55, "Output",ExpressionUUID->"e5afc625-59de-4e6c-871f-6d9b1f6a6314"]
}, Open  ]],
Cell[CellGroupData[{
Cell[191063, 5645, 2158, 57, 128, "Input",ExpressionUUID->"8f41473e-aede-4ea9-b4d8-34e45eec293f"],
Cell[193224, 5704, 1637, 46, 55, "Output",ExpressionUUID->"ed1a6c32-25f7-48c6-9630-9ac539075be7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[194898, 5755, 2187, 58, 124, "Input",ExpressionUUID->"4e3f68e3-95a2-46b4-b0c2-5d28de4eb4d0"],
Cell[197088, 5815, 1827, 53, 57, "Output",ExpressionUUID->"67b53371-8a34-447c-ab0a-a0bff79f827c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[198952, 5873, 2629, 69, 149, "Input",ExpressionUUID->"cfedc785-9022-4fd5-b868-55e886c1232e"],
Cell[201584, 5944, 1751, 48, 62, "Output",ExpressionUUID->"6c860076-74a0-4a91-a688-b7c6f82fe522"]
}, Open  ]],
Cell[CellGroupData[{
Cell[203372, 5997, 2203, 59, 128, "Input",ExpressionUUID->"f3483aa2-3cb5-45ed-881d-47433b4a1252"],
Cell[205578, 6058, 1130, 32, 60, "Output",ExpressionUUID->"e58ed949-b99d-44b6-8ec3-1eadf9d42b1e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[206745, 6095, 2123, 57, 94, "Input",ExpressionUUID->"fa8f5937-b618-4aa3-a75d-43f8c3669e5d"],
Cell[208871, 6154, 1586, 43, 57, "Output",ExpressionUUID->"362c746e-45ff-4556-a92f-5442cad760a2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[210494, 6202, 2851, 74, 149, "Input",ExpressionUUID->"a0d248b4-0a15-44ae-8252-4c2eb3598f4f"],
Cell[213348, 6278, 927, 27, 55, "Output",ExpressionUUID->"a9ba4979-6452-4cf5-9e1d-501d55bd40e0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[214312, 6310, 2202, 59, 128, "Input",ExpressionUUID->"80bdb8b0-6e76-4447-8838-4a3a05ad2017"],
Cell[216517, 6371, 1802, 53, 60, "Output",ExpressionUUID->"14f454ad-ff43-4b5f-b271-abb2e41c0629"]
}, Open  ]],
Cell[CellGroupData[{
Cell[218356, 6429, 2194, 58, 128, "Input",ExpressionUUID->"3e6d816e-9850-490b-a9ea-5ed1e5e803fe"],
Cell[220553, 6489, 913, 26, 55, "Output",ExpressionUUID->"0dbe6b70-2af7-4047-87b3-fdd0a873ff69"]
}, Open  ]],
Cell[CellGroupData[{
Cell[221503, 6520, 2187, 58, 128, "Input",ExpressionUUID->"1792bf80-24f4-45cb-b0e1-54acfbd38e34"],
Cell[223693, 6580, 1753, 51, 60, "Output",ExpressionUUID->"69916188-30fe-4e02-b1d4-f760c0577fc2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[225483, 6636, 2153, 57, 100, "Input",ExpressionUUID->"b72d8403-ad23-46e1-9348-90247b425acc"],
Cell[227639, 6695, 995, 30, 60, "Output",ExpressionUUID->"fab7e503-3fad-40ae-8d29-bf913d224803"]
}, Open  ]],
Cell[CellGroupData[{
Cell[228671, 6730, 2372, 63, 128, "Input",ExpressionUUID->"ae6f33b4-9016-4dc6-94b8-790c00529af8"],
Cell[231046, 6795, 678, 20, 55, "Output",ExpressionUUID->"558d4be6-c4f5-425a-bc48-062f9a97f968"]
}, Open  ]],
Cell[CellGroupData[{
Cell[231761, 6820, 1209, 35, 72, "Input",ExpressionUUID->"916e1615-63c8-47b6-9043-27396f7831b5"],
Cell[232973, 6857, 1324, 40, 54, "Output",ExpressionUUID->"75b701e5-c2d2-4829-a03b-c8caed7d7f90"]
}, Open  ]],
Cell[CellGroupData[{
Cell[234334, 6902, 206, 3, 30, "Input",ExpressionUUID->"13a99036-8c52-4fde-8aa8-02dabec370d5"],
Cell[234543, 6907, 1893, 47, 100, "Output",ExpressionUUID->"f6f75456-c5fe-46af-b777-cb4aa4b0275a"]
}, Open  ]],
Cell[236451, 6957, 154, 3, 30, "Input",ExpressionUUID->"11ec78d7-46c8-4a3a-a140-a1f105a6db16"],
Cell[CellGroupData[{
Cell[236630, 6964, 1720, 40, 56, "Input",ExpressionUUID->"ae5ca8a0-f924-465e-9504-25fee631636a"],
Cell[238353, 7006, 1647, 52, 60, "Output",ExpressionUUID->"78a6101c-aea5-4204-bddb-7969b4afd19e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[240037, 7063, 1390, 37, 56, "Input",ExpressionUUID->"2b7c3b17-c7d2-41c6-b014-1c1b9ed6078d"],
Cell[241430, 7102, 1111, 31, 55, "Output",ExpressionUUID->"87d9c929-d211-421a-b893-13531e851cfe"]
}, Open  ]],
Cell[242556, 7136, 330, 9, 30, "Input",ExpressionUUID->"d718f27c-569c-4859-a990-c94b48e0517b"],
Cell[CellGroupData[{
Cell[242911, 7149, 1136, 32, 52, "Input",ExpressionUUID->"f6e4f9b8-014b-48de-b2f7-a8d748375411"],
Cell[244050, 7183, 1238, 36, 55, "Output",ExpressionUUID->"ebcaab61-b1bc-4b25-80f8-f6a51a9e3dce"]
}, Open  ]],
Cell[CellGroupData[{
Cell[245325, 7224, 1260, 36, 56, "Input",ExpressionUUID->"352e602d-ce9b-4792-b967-108235b8d850"],
Cell[246588, 7262, 1020, 30, 55, "Output",ExpressionUUID->"a1062021-77a1-4e49-b20d-a4b7b79f2874"]
}, Open  ]],
Cell[247623, 7295, 1279, 36, 33, "Input",ExpressionUUID->"7fd56983-de84-492a-b4f4-a708d2ffd877"],
Cell[248905, 7333, 686, 20, 49, "Input",ExpressionUUID->"fb993b67-9616-4ee4-9991-e8d51c58184c"],
Cell[249594, 7355, 688, 16, 30, "Input",ExpressionUUID->"b48ab1eb-e8f2-4a4a-b72b-8c1f0cc2f8b8"],
Cell[250285, 7373, 304, 9, 49, "Input",ExpressionUUID->"204129e9-9ec0-42a4-9220-e6d8dc401b9d"],
Cell[250592, 7384, 761, 16, 49, "Input",ExpressionUUID->"558cfb6d-ef63-4d81-818b-e33a7e80221a"],
Cell[CellGroupData[{
Cell[251378, 7404, 765, 15, 30, "Input",ExpressionUUID->"385d9cae-2bba-477c-b7b5-b957c1ea806a"],
Cell[252146, 7421, 745, 21, 34, "Output",ExpressionUUID->"97e2f43a-3a49-4ed0-ad00-9be22292a42e"]
}, Open  ]],
Cell[252906, 7445, 378, 7, 73, "Input",ExpressionUUID->"59f4694e-10f9-4617-9cc8-8f75b0900c49"],
Cell[CellGroupData[{
Cell[253309, 7456, 1136, 33, 72, "Input",ExpressionUUID->"e2c0656d-d036-4b5f-b912-05bc80fc9104"],
Cell[254448, 7491, 1309, 41, 61, "Output",ExpressionUUID->"26285467-1e3e-4716-b111-3657382d1d11"]
}, Open  ]],
Cell[CellGroupData[{
Cell[255794, 7537, 210, 3, 30, "Input",ExpressionUUID->"04387773-739b-4f16-a0d2-1e72d5de57db"],
Cell[256007, 7542, 2267, 55, 121, "Output",ExpressionUUID->"d9d92ff1-085c-4bf8-b0a2-ef1f419cc236"]
}, Open  ]],
Cell[CellGroupData[{
Cell[258311, 7602, 2099, 48, 77, "Input",ExpressionUUID->"d30dfde5-c276-4a9d-ace1-76506cf6d88b"],
Cell[260413, 7652, 1887, 56, 60, "Output",ExpressionUUID->"bbb91854-ed0c-4020-8420-31d15f083196"]
}, Open  ]],
Cell[262315, 7711, 1979, 55, 56, "Input",ExpressionUUID->"414fc202-ce15-42d6-b793-fa00f72d56ab"],
Cell[264297, 7768, 552, 13, 52, "Input",ExpressionUUID->"c89e0602-c851-413b-9091-161e6a1bf354"],
Cell[264852, 7783, 848, 27, 30, "Input",ExpressionUUID->"5c202389-d2ac-46fa-b5a5-30fc09713359"],
Cell[265703, 7812, 335, 7, 52, "Input",ExpressionUUID->"cf8dc6e2-6168-41c6-b41a-d634cf235b79"],
Cell[CellGroupData[{
Cell[266063, 7823, 4084, 102, 148, "Input",ExpressionUUID->"0323ac2f-40b2-4c0d-9a7d-142a1b701981"],
Cell[270150, 7927, 423, 10, 34, "Output",ExpressionUUID->"b5fa3bfb-75dc-42c9-8e06-179a2944dca0"]
}, Open  ]],
Cell[270588, 7940, 3270, 89, 125, "Input",ExpressionUUID->"33394da7-124f-480f-9e7a-9950d8ff3fe6"],
Cell[CellGroupData[{
Cell[273883, 8033, 1876, 53, 54, "Input",ExpressionUUID->"eac0cf92-31dc-456f-8e4f-a802787093a1"],
Cell[275762, 8088, 1877, 53, 57, "Output",ExpressionUUID->"d00f4e4e-1a25-4f8e-ae3f-fafd34b8fa40"]
}, Open  ]],
Cell[CellGroupData[{
Cell[277676, 8146, 1094, 31, 52, "Input",ExpressionUUID->"169be312-56dd-45bc-a3f5-c942a2fb4597"],
Cell[278773, 8179, 726, 22, 53, "Output",ExpressionUUID->"5aaf801e-f86e-4fcc-be55-d0a64112642b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[279536, 8206, 208, 3, 30, "Input",ExpressionUUID->"51e3f225-afea-4b3b-b291-9fc48bc4a042"],
Cell[279747, 8211, 459, 12, 53, "Output",ExpressionUUID->"e3351028-324c-44cc-99d9-eac5759bef05"]
}, Open  ]],
Cell[CellGroupData[{
Cell[280243, 8228, 372, 8, 30, "Input",ExpressionUUID->"b4ecb821-596e-458c-b475-f3e3c0c666ee"],
Cell[280618, 8238, 1765, 49, 55, "Output",ExpressionUUID->"0079b22f-751d-4734-afd5-68a0729a28b9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[282420, 8292, 802, 17, 30, "Input",ExpressionUUID->"77673415-b61e-4dd0-b2e6-3f70729c8295"],
Cell[283225, 8311, 2201, 65, 83, "Output",ExpressionUUID->"6f2d6c69-8422-4250-9d7c-d1a46a37bf55"]
}, Open  ]],
Cell[CellGroupData[{
Cell[285463, 8381, 206, 3, 30, "Input",ExpressionUUID->"033a4d97-2160-48d5-be37-a051cc30fff8"],
Cell[285672, 8386, 269, 7, 45, "Output",ExpressionUUID->"a6192f44-1d69-4e72-b466-caed3f6a1be3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[285978, 8398, 1198, 38, 30, "Input",ExpressionUUID->"71f863f2-519c-49eb-ad97-fc42f60090e5"],
Cell[287179, 8438, 744, 20, 54, "Output",ExpressionUUID->"ce79fc86-0ea7-44a1-9825-4af6b871adf6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[287960, 8463, 1152, 31, 56, "Input",ExpressionUUID->"109ce624-cce5-4b2c-8063-0e17760f1334"],
Cell[289115, 8496, 2334, 68, 67, "Output",ExpressionUUID->"03c34d69-b0cf-4f26-bf08-6749027759d6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[291486, 8569, 1093, 30, 56, "Input",ExpressionUUID->"c2ea9429-cb44-4ff7-ba65-85f7442f4c26"],
Cell[292582, 8601, 1357, 39, 55, "Output",ExpressionUUID->"b5bba0fe-d788-4a1b-bcb4-9f31be7698e4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[293976, 8645, 1373, 44, 30, "Input",ExpressionUUID->"272a7f4f-adc7-49f8-9995-8adffccf665a"],
Cell[295352, 8691, 804, 24, 54, "Output",ExpressionUUID->"9d990bf9-3f42-4352-856a-3ffc5f36f9e1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[296193, 8720, 1240, 33, 52, "Input",ExpressionUUID->"9e68f909-299b-4f68-af69-d5329e92ec20"],
Cell[297436, 8755, 1470, 41, 54, "Output",ExpressionUUID->"068ea942-edb3-4d91-9955-ae401ac00dc6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[298943, 8801, 1250, 33, 52, "Input",ExpressionUUID->"c8a3b52a-5395-4cda-82e8-8a8d25abe6bd"],
Cell[300196, 8836, 2272, 66, 65, "Output",ExpressionUUID->"023cf413-c668-4e77-8ed5-c21c89762e22"]
}, Open  ]],
Cell[CellGroupData[{
Cell[302505, 8907, 1307, 43, 30, "Input",ExpressionUUID->"a3db8592-f7f7-41b0-ac48-0ec72cee4152"],
Cell[303815, 8952, 828, 25, 54, "Output",ExpressionUUID->"2b02d18a-93cf-4cf8-b98b-d34a0110e101"]
}, Open  ]],
Cell[CellGroupData[{
Cell[304680, 8982, 1342, 36, 52, "Input",ExpressionUUID->"ef5fff28-0a5b-40e9-a8fd-68f72eb90b79"],
Cell[306025, 9020, 1446, 41, 54, "Output",ExpressionUUID->"670beea1-552b-45c3-a6c8-f59d20bca488"]
}, Open  ]],
Cell[CellGroupData[{
Cell[307508, 9066, 1048, 30, 52, "Input",ExpressionUUID->"61be4839-4c0f-4ae1-ab56-336286909500"],
Cell[308559, 9098, 641, 19, 52, "Output",ExpressionUUID->"89fdb873-74ec-46c2-b8ce-5a6897202b18"]
}, Open  ]],
Cell[CellGroupData[{
Cell[309237, 9122, 208, 3, 30, "Input",ExpressionUUID->"509a16a4-4a44-4024-b77a-1d240300c6be"],
Cell[309448, 9127, 502, 13, 54, "Output",ExpressionUUID->"7fdb9b8d-8914-4ad0-8aef-e6bf811088c3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[309987, 9145, 973, 28, 30, "Input",ExpressionUUID->"e23362bf-e9b4-4ef9-8e28-058674320e1a"],
Cell[310963, 9175, 579, 17, 55, "Output",ExpressionUUID->"8963c7ff-166b-4093-a9ba-1849be0f5022"]
}, Open  ]],
Cell[CellGroupData[{
Cell[311579, 9197, 208, 3, 30, "Input",ExpressionUUID->"50f09dee-36b5-4589-b29e-2766cba844d4"],
Cell[311790, 9202, 561, 15, 55, "Output",ExpressionUUID->"e7326b49-74d4-4125-9c3e-97b25f2d0c19"]
}, Open  ]],
Cell[CellGroupData[{
Cell[312388, 9222, 858, 25, 30, "Input",ExpressionUUID->"db7e0ae3-10aa-4535-9478-e3879d419525"],
Cell[313249, 9249, 576, 17, 55, "Output",ExpressionUUID->"6b9cc579-dbec-4ee1-aa1d-f9bdcbf7cc46"]
}, Open  ]],
Cell[CellGroupData[{
Cell[313862, 9271, 207, 3, 30, "Input",ExpressionUUID->"99ba2f77-c4a9-47ed-b6e7-aab2e7d8d3b4"],
Cell[314072, 9276, 559, 15, 55, "Output",ExpressionUUID->"368c5995-8a15-44a7-8722-c234563953b1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[314668, 9296, 1143, 34, 52, "Input",ExpressionUUID->"7a0e1a49-b694-43ac-900b-8edc6355b2ef"],
Cell[315814, 9332, 759, 25, 55, "Output",ExpressionUUID->"b17f7e38-badf-4072-94d7-edca4e5acbd7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[316610, 9362, 210, 4, 30, "Input",ExpressionUUID->"91949695-8d45-4b19-bb06-0470a5c9e202"],
Cell[316823, 9368, 477, 14, 55, "Output",ExpressionUUID->"89bc7ed8-51d1-44bf-91dd-618541edb0b7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[317337, 9387, 1143, 33, 52, "Input",ExpressionUUID->"4b2d9a31-dff4-40f2-a8a4-e97ad92d179c"],
Cell[318483, 9422, 728, 23, 53, "Output",ExpressionUUID->"5c208fee-79de-424d-ac90-64c5e9613735"]
}, Open  ]],
Cell[CellGroupData[{
Cell[319248, 9450, 209, 4, 30, "Input",ExpressionUUID->"3befd2ab-6129-48ba-8c70-7eb34c6f6efb"],
Cell[319460, 9456, 456, 13, 53, "Output",ExpressionUUID->"b4d33aef-cdfb-4252-81c1-308f2f19e5f3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[319953, 9474, 772, 24, 30, "Input",ExpressionUUID->"a6d6ac4f-f3d7-45fb-bec9-b53f46f90d8d"],
Cell[320728, 9500, 649, 20, 54, "Output",ExpressionUUID->"623cb2ec-b9c9-472f-a880-a007718a1192"]
}, Open  ]],
Cell[CellGroupData[{
Cell[321414, 9525, 218, 5, 30, "Input",ExpressionUUID->"008111af-7934-4b81-8e7e-f92241b5fa5c"],
Cell[321635, 9532, 174, 4, 51, "Output",ExpressionUUID->"8ac09ba1-6cb9-47d5-858f-151db9efa31b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[321846, 9541, 824, 26, 30, "Input",ExpressionUUID->"d77683fb-f5d0-43c5-a9ee-9c48ff144e3d"],
Cell[322673, 9569, 758, 24, 54, "Output",ExpressionUUID->"25b59c9c-afff-4b87-8507-04668575dea8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[323468, 9598, 1029, 30, 56, "Input",ExpressionUUID->"7a8a43a5-f2b3-46b6-b0c2-af1fa826d2dd"],
Cell[324500, 9630, 1361, 40, 55, "Output",ExpressionUUID->"3e142a8d-8f54-47a5-8306-3535d5c1df7c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[325898, 9675, 1117, 33, 52, "Input",ExpressionUUID->"6a697d00-0cf6-4953-bbf8-718e0fc0554b"],
Cell[327018, 9710, 605, 18, 55, "Output",ExpressionUUID->"19b85f35-5ea4-4c81-86b8-6014721d13e8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[327660, 9733, 218, 4, 30, "Input",ExpressionUUID->"f37c1b70-4671-4fcd-ad5e-0adb2686c2dc"],
Cell[327881, 9739, 537, 15, 53, "Output",ExpressionUUID->"0ecd15bc-b697-4e5e-94f2-085532c899d0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[328455, 9759, 1069, 31, 52, "Input",ExpressionUUID->"731c6846-a669-48a4-9e17-1f75524b3400"],
Cell[329527, 9792, 580, 18, 55, "Output",ExpressionUUID->"2817a1da-941c-4704-82ba-1a04b53a91a0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[330144, 9815, 214, 4, 30, "Input",ExpressionUUID->"c8203e85-bb2c-4405-8f82-10f0e6d6b21e"],
Cell[330361, 9821, 508, 15, 53, "Output",ExpressionUUID->"b748b4e8-c0bb-4afa-b914-f759b8a74982"]
}, Open  ]],
Cell[CellGroupData[{
Cell[330906, 9841, 602, 16, 30, "Input",ExpressionUUID->"16eaeb0b-b52e-443c-a442-31ce6c6d7109"],
Cell[331511, 9859, 1020, 31, 54, "Output",ExpressionUUID->"0c289efd-d060-4636-905b-e2dfd71e7cd2"]
}, Open  ]],
Cell[332546, 9893, 408, 9, 73, "Input",ExpressionUUID->"61f9f3cc-91c2-4467-af26-c5f1fc046c6c"],
Cell[CellGroupData[{
Cell[332979, 9906, 3263, 83, 149, "Input",ExpressionUUID->"e76f5a33-5914-483f-8f8f-30601a27b9fd"],
Cell[336245, 9991, 3151, 83, 62, "Output",ExpressionUUID->"c72ec603-d92d-4c5b-acba-8805b9910ebf"]
}, Open  ]],
Cell[339411, 10077, 2304, 68, 72, "Input",ExpressionUUID->"521cd013-c876-4a23-a448-9db228a20511"],
Cell[CellGroupData[{
Cell[341740, 10149, 1215, 34, 52, "Input",ExpressionUUID->"1df43e2b-7836-4c63-8c05-add0bc50c43c"],
Cell[342958, 10185, 959, 29, 55, "Output",ExpressionUUID->"a76bb739-a4fa-4f86-be5a-217121d29b28"]
}, Open  ]]
}
]
*)

