(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[    275975,       7793]
NotebookOptionsPosition[    257166,       7490]
NotebookOutlinePosition[    257503,       7505]
CellTagsIndexPosition[    257460,       7502]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Trying", " ", "to", " ", "compute", " ", "differential", " ", "of", " ", 
     "g"}], "-", 
    RowBox[{"h", "*", "gdot", " ", "for", " ", "Kepler"}], "-", " ", 
    RowBox[{"Drift", " ", 
     RowBox[{"problem", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Note", ":", "  ", 
     RowBox[{"below", "  ", "d"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", "*", "g2"}], "+", 
         RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}], " ", 
      "\[IndentingNewLine]", "r"}], " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
       RowBox[{"k", " ", "g2", "\[IndentingNewLine]", "h"}]}], " ", "=", " ", 
      
      RowBox[{
       RowBox[{
        RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
        RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
        RowBox[{"k", " ", "g3", "\[IndentingNewLine]", "g0"}]}], " ", "=", 
       " ", 
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2", " ", "\[IndentingNewLine]", "g3"}]}], " ",
         "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"s", "-", "g1"}], ")"}], "/", "beta"}], " ", 
           "\[IndentingNewLine]", "g0", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g1", "^", "2"}]}], " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"-", "g2"}], "\[IndentingNewLine]", 
            RowBox[{"g0", "^", "2"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"g1", "^", "2"}], " ", "beta"}]}], " ", "=", " ", 
          RowBox[{
           RowBox[{"1", "\[IndentingNewLine]", "zeta"}], " ", "=", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}]}]}]}]}]}]}], 
   "\[IndentingNewLine]", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
  3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
  3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
  3.776616360243341*^9, 3.776616389763185*^9}, {3.776616473018384*^9, 
  3.7766164790371*^9}, {3.7766184896047897`*^9, 3.776618505548366*^9}, {
  3.776621800709702*^9, 3.776621801524394*^9}, {3.7766222281334877`*^9, 
  3.7766222316924543`*^9}},ExpressionUUID->"53329b6c-a80c-45ac-ae62-\
f6fb243392bd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgamma", " ", "=", " ", 
  RowBox[{
   FractionBox["sqb", "r"], " ", 
   RowBox[{"(", 
    RowBox[{"dh", " ", "+", "  ", 
     RowBox[{
      FractionBox["dk", "r0"], 
      RowBox[{"(", 
       RowBox[{"d", "-", " ", 
        RowBox[{"r0", " ", "g3"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"k", " ", "d"}], "+", 
           RowBox[{"g1", " ", 
            SuperscriptBox["r0", "2"]}]}], ")"}], 
         FractionBox["x0", 
          SuperscriptBox["r0", "3"]]}], "+", 
        RowBox[{"g2", " ", "v0"}]}], ")"}]}], "-", 
     RowBox[{"dv0", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", "  ", "v0"}], " ", "+", " ", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
   3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
   3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
   3.776616360243341*^9, 3.776616389763185*^9}, {3.776616473018384*^9, 
   3.7766164790371*^9}, 3.776947613784926*^9, 3.776947903230813*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"48462b44-b891-42a8-998f-37b74e902302"],

Cell[BoxData[
 FractionBox[
  RowBox[{"sqb", " ", 
   RowBox[{"(", 
    RowBox[{"dh", "+", 
     FractionBox[
      RowBox[{"dk", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
     RowBox[{"dv0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", " ", "v0"}], "+", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g2", " ", "v0"}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
         SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"]], "Output",
 CellChangeTimes->{3.776202160614881*^9, 3.7766164810276527`*^9, 
  3.777120836364489*^9, 3.777128409880335*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"007fec1e-964d-47af-8413-174e6262f253"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr", " ", "=", " ", 
  RowBox[{
   RowBox[{
    FractionBox["dgamma", "sqb"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"zeta", " ", "g1"}], "+", 
      RowBox[{"eta", " ", "g0"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dk", 
     RowBox[{"beta", " ", "r0", " "}]], 
    RowBox[{"(", 
     RowBox[{"r0", "-", "r", "-", 
      RowBox[{"k", " ", "g2"}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["1", 
        RowBox[{"beta", " ", 
         SuperscriptBox["r0", "3"]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", 
          RowBox[{"(", 
           RowBox[{"r", "+", 
            RowBox[{"k", " ", "g2"}]}], ")"}]}], "-", 
         RowBox[{"zeta", " ", "r0", " ", "g0"}]}], ")"}], "x0"}], " ", "+", 
      " ", 
      RowBox[{"g1", "  ", "v0"}]}], ")"}]}], " ", "+", " ", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "k", " ", "g2"}]}], ")"}], " ", 
       FractionBox["v0", "beta"]}], " ", "+", " ", 
      RowBox[{"g1", " ", "x0"}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776198428651246*^9, 3.7761985237438927`*^9}, {
   3.7766163976826477`*^9, 3.776616471914287*^9}, 3.777120822002948*^9},
 CellLabel->"In[2]:=",ExpressionUUID->"ec64950c-8ed3-4bc5-92a5-293069313a0b"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}]}], 
   RowBox[{"beta", " ", "r0"}]], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], "beta"], 
     "+", 
     RowBox[{"g1", " ", "x0"}]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"dh", "+", 
      FractionBox[
       RowBox[{"dk", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
      RowBox[{"dv0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
      RowBox[{"dx0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "v0"}], "+", 
     FractionBox[
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776202167353901*^9, 3.7766164851357393`*^9, 
  3.777120836499813*^9, 3.77712841050222*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"e6ef562f-a206-4d0b-9f13-3ec202582435"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dbeta", " ", "=", " ", 
  RowBox[{
   RowBox[{"2", "*", 
    RowBox[{"dk", "/", "r0"}]}], "-", 
   RowBox[{"2", "*", 
    RowBox[{"k", "/", 
     RowBox[{"r0", "^", "3"}]}], "*", " ", 
    RowBox[{"(", 
     RowBox[{"dx0", " ", "*", " ", "x0"}], ")"}]}], " ", "-", " ", 
   RowBox[{"2", "*", "v0", " ", "*", " ", "dv0"}]}]}]], "Input",
 CellChangeTimes->{{3.776198629796771*^9, 3.776198668928054*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"95296aac-8480-48bf-b720-90060933f9ed"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", "dk"}], "r0"], "-", 
  RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
  FractionBox[
   RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
   SuperscriptBox["r0", "3"]]}]], "Output",
 CellChangeTimes->{3.776198669836025*^9, 3.7762021775425386`*^9, 
  3.7766164927868137`*^9, 3.777120837655175*^9, 3.77712841209348*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"123d8237-46b4-48b0-8974-34ffbab55809"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr0", " ", "=", " ", 
  RowBox[{"dx0", " ", "*", " ", 
   RowBox[{"x0", " ", "/", " ", "r0"}]}]}]], "Input",
 CellChangeTimes->{{3.776198724170291*^9, 3.776198736866087*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"6e130959-e5af-4389-aed5-d86ced425512"],

Cell[BoxData[
 FractionBox[
  RowBox[{"dx0", " ", "x0"}], "r0"]], "Output",
 CellChangeTimes->{3.7771208393034163`*^9, 3.777128413408222*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"406115b4-8f74-46dc-acaf-b876b2b2a5aa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"deta", " ", "=", " ", 
   RowBox[{
    RowBox[{"dx0", " ", "v0"}], " ", "+", " ", 
    RowBox[{"dv0", " ", "x0"}]}]}]}]], "Input",
 CellChangeTimes->{{3.77662697323173*^9, 3.776626983079431*^9}, 
   3.777120845559733*^9},
 CellLabel->"In[5]:=",ExpressionUUID->"91ea3aee-9af1-4a5e-ae59-754efdc1399b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dx0", " ", "v0"}], "+", 
  RowBox[{"dv0", " ", "x0"}]}]], "Output",
 CellChangeTimes->{3.776626984182922*^9, 3.777120846964405*^9, 
  3.777128415516337*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"a56b79d7-6bdf-40ad-9a00-6e9f7f1e5bfd"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{" ", 
   RowBox[{
    RowBox[{"Now", " ", "for", " ", "d", " ", 
     RowBox[{"(", 
      RowBox[{"g", "-", 
       RowBox[{"h", "*", "gdot"}]}], ")"}], " ", "for", " ", "drift"}], "-", 
    RowBox[{"last", " ", 
     RowBox[{"case", ":"}]}]}], " ", ")"}]}]], "Input",
 CellChangeTimes->{{3.776258566484967*^9, 3.776258574345611*^9}, {
   3.7762590835501537`*^9, 3.7762590836374397`*^9}, {3.776259116907651*^9, 
   3.7762591197329206`*^9}, 3.776521078478303*^9, {3.776616498984494*^9, 
   3.776616512695982*^9}, {3.776621813852808*^9, 3.776621816450893*^9}, {
   3.776623330065248*^9, 
   3.776623333440365*^9}},ExpressionUUID->"2d884b31-7a55-4520-bbb8-\
26a9cd31ce07"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgmhgdot", " ", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       RowBox[{" ", 
        SuperscriptBox["r", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"r", " ", "dk"}], " ", "-", 
        RowBox[{"k", " ", "dr"}]}], ")"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"r0", " ", "h2"}], " ", "+", " ", 
      RowBox[{"eta", " ", "h1"}]}], ")"}]}], " ", "+", 
   RowBox[{
    FractionBox["k", "r"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"dr0", " ", "h2"}], " ", "+", " ", 
      RowBox[{"deta", "  ", "h1"}], " ", "+", " ", 
      RowBox[{"dgamma", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"r0", " ", "gamma", " ", 
           RowBox[{"g1", "/", "sqb"}]}], " ", "+", " ", 
          RowBox[{"eta", " ", "h2"}]}], ")"}], "/", "sqb"}]}], " ", "-", " ", 
      
      RowBox[{
       FractionBox["dbeta", "beta"], 
       RowBox[{"(", " ", 
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{"3", "r0", " "}], "2"], "h2"}], " ", "+", 
         RowBox[{"2", " ", "eta", " ", "h1"}]}], ")"}]}]}], " ", 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7762585761216097`*^9, 3.77625860781793*^9}, {
   3.776259100727673*^9, 3.776259100829246*^9}, {3.776616516007222*^9, 
   3.776616703078433*^9}, {3.7766169376542177`*^9, 3.776616947701645*^9}, {
   3.776617978626844*^9, 3.776618092271991*^9}, 3.776619122588566*^9, {
   3.776620059682043*^9, 3.776620073384857*^9}, {3.776620137378751*^9, 
   3.7766201612323627`*^9}, {3.776621807830155*^9, 3.7766218263319063`*^9}, {
   3.77662186031231*^9, 3.7766219246387177`*^9}, {3.776621991356037*^9, 
   3.776622003576355*^9}, {3.7766222365410013`*^9, 3.776622239021265*^9}, {
   3.776626885697908*^9, 3.776626925681683*^9}, {3.776626993831038*^9, 
   3.7766270845907087`*^9}, {3.777128227271606*^9, 3.777128228109974*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"a6c48c41-52a5-424e-8082-2ada96dd916c"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"dx0", " ", "h2", " ", "x0"}], "r0"], "+", 
      RowBox[{"h1", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"dx0", " ", "v0"}], "+", 
         RowBox[{"dv0", " ", "x0"}]}], ")"}]}], "-", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
          FractionBox[
           RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"2", " ", "dk"}], "r0"], "-", 
          RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
          FractionBox[
           RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
           SuperscriptBox["r0", "3"]]}], ")"}]}], "beta"], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "h2"}], "+", 
          FractionBox[
           RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"dh", "+", 
          FractionBox[
           RowBox[{"dk", " ", 
            RowBox[{"(", 
             RowBox[{"d", "-", 
              RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
          RowBox[{"dv0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "v0"}], "+", 
             RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
          RowBox[{"dx0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "v0"}], "+", 
             FractionBox[
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", " ", "k"}], "+", 
                 RowBox[{"g1", " ", 
                  SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
              SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"]}], 
     ")"}]}], "r"], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "h1"}], "+", 
      RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"dk", " ", "r"}], "-", 
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"dk", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}]}], 
          RowBox[{"beta", " ", "r0"}]], "+", 
         RowBox[{"dv0", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g1"}], "+", 
                RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], 
             "beta"], "+", 
            RowBox[{"g1", " ", "x0"}]}], ")"}]}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{"dh", "+", 
             FractionBox[
              RowBox[{"dk", " ", 
               RowBox[{"(", 
                RowBox[{"d", "-", 
                 RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
             RowBox[{"dv0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "v0"}], "+", 
                RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
             RowBox[{"dx0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "v0"}], "+", 
                FractionBox[
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"d", " ", "k"}], "+", 
                    RowBox[{"g1", " ", 
                    SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
                 SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
         RowBox[{"dx0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "v0"}], "+", 
            FractionBox[
             RowBox[{"x0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
                RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
   SuperscriptBox["r", "2"]]}]], "Output",
 CellChangeTimes->{3.776620193624681*^9, 3.776622015180077*^9, 
  3.776627090294258*^9, 3.777120855629693*^9, 3.7771282705573263`*^9, 
  3.777128418493085*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"091b2f2f-9a6f-4851-b1aa-21488748abe7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"dx0", ",", "dv0", ",", "dk", ",", "dh"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.776258616039044*^9, 3.776258625845273*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"c50ee62d-22cf-45d5-85af-1fc4bc50ccb2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h2"}], "+", 
         FractionBox[
          RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "3"]]}], ")"}]}], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"eta", " ", "h1"}], "+", 
       RowBox[{"h2", " ", "r0"}]}], "r"], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
         FractionBox[
          RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}]}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h2"}], "+", 
         FractionBox[
          RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
         FractionBox[
          RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}], " ", "v0"}], 
      RowBox[{"beta", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{"h1", " ", "k", " ", "x0"}], "r"], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], 
          "beta"], "+", 
         RowBox[{"g1", " ", "x0"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h2"}], "+", 
         FractionBox[
          RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "3"]]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"h1", " ", "k", " ", "v0"}], "r"], "+", 
     FractionBox[
      RowBox[{"h2", " ", "k", " ", "x0"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
         FractionBox[
          RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}], " ", "x0"}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h2"}], "+", 
         FractionBox[
          RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "3"]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{"x0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}], 
      SuperscriptBox["r", "2"]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7766201991527157`*^9, 3.776622018508436*^9, 
  3.776627092937994*^9, 3.777120858571217*^9, 3.777128284255829*^9, 
  3.777128421715884*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"4ff85c13-bc84-4a87-85b5-ec7e3529ddf9"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Collect", " ", "x0"}], " ", "&"}], " ", "v0", " ", "in", " ", 
      "dv0"}], " ", "&"}], " ", "dx0", " ", 
    RowBox[{"terms", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"First", ",", " ", 
    RowBox[{"dx0", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776258919746063*^9, 
  3.776258947304412*^9}},ExpressionUUID->"5016d470-2559-42c7-9097-\
a15b73e2e0c2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"h1", " ", "k", " ", "v0"}], "r"], "+", 
     FractionBox[
      RowBox[{"h2", " ", "k", " ", "x0"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
         FractionBox[
          RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}], " ", "x0"}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h2"}], "+", 
         FractionBox[
          RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "3"]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{"x0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}], 
      SuperscriptBox["r", "2"]]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7762589351786823`*^9, 3.7762589524160213`*^9}, 
   3.7766169978896017`*^9, 3.776618164429405*^9, 3.776620099741139*^9, 
   3.7766202080449142`*^9, 3.7766220281409807`*^9, 3.7766271050662613`*^9, 
   3.777120869315412*^9, {3.777128290468533*^9, 3.7771282913885603`*^9}, 
   3.777128434254163*^9},
 CellLabel->"In[8]:=",ExpressionUUID->"86606400-4dcd-4a36-bd1d-3a1e6bba1e6b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"h1", " ", "k"}], "r"], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h2"}], "+", 
         FractionBox[
          RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "3"]]}], ")"}]}], "+", 
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"h2", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
         FractionBox[
          RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h2"}], "+", 
         FractionBox[
          RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776620209111361*^9, 3.776622029274206*^9, 
  3.776627105824101*^9, 3.777120869915127*^9, 3.7771282983514223`*^9, 
  3.7771284349448767`*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"ce12a99b-ccf1-4555-9b32-d1fd5d706668"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Next", ",", " ", 
   RowBox[{"dv0", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776258958098084*^9, 3.77625896130404*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"93376667-ae79-4f2c-bce9-f4e105374de8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
         FractionBox[
          RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}], " ", "v0"}], 
      RowBox[{"beta", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{"h1", " ", "k", " ", "x0"}], "r"], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], 
          "beta"], "+", 
         RowBox[{"g1", " ", "x0"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h2"}], "+", 
         FractionBox[
          RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "3"]]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.776258972640501*^9, 3.7762589774726753`*^9}, 
   3.776617010769013*^9, 3.776618177123947*^9, 3.77662010951578*^9, 
   3.776620216181149*^9, 3.7766220384374237`*^9, 3.776627117272752*^9, 
   3.777120880873858*^9, {3.777128302579722*^9, 3.777128303163563*^9}, 
   3.777128443494215*^9},
 CellLabel->"In[9]:=",ExpressionUUID->"4c137373-3aac-4897-9d22-41fe9976ebba"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g1"}], "+", 
          RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "h1"}], "+", 
          RowBox[{"h2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r", "2"]}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
         FractionBox[
          RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}]}], 
      RowBox[{"beta", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{"d", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h2"}], "+", 
         FractionBox[
          RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"d", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "3"]]}], ")"}]}], "+", 
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"h1", " ", "k"}], "r"], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h2"}], "+", 
         FractionBox[
          RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "3"]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776620217383945*^9, 3.77662203910592*^9, 
  3.776627117848136*^9, 3.7771208814829073`*^9, 3.77712830381389*^9, 
  3.777128444154171*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"5c7b2fd2-e603-4297-aefa-9b395be332b7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Final", " ", "dgmhgdot", " ", 
    RowBox[{"term", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"dgmhgdot", " ", "=", " ", 
   RowBox[{
    RowBox[{"dh", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "h2"}], "+", 
           FractionBox[
            RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
        SuperscriptBox["r", "2"]], "-", 
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "h1"}], "+", 
           RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "g0"}], "+", 
           RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
        SuperscriptBox["r", "3"]]}], ")"}]}], "+", 
    RowBox[{"dk", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], "r"], "-", 
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], 
         " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "h1"}], "+", 
           RowBox[{"h2", " ", "r0"}]}], ")"}]}], 
        RowBox[{"beta", " ", 
         SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
       FractionBox[
        RowBox[{"2", " ", "k", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
           FractionBox[
            RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}]}], 
        RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{"d", "-", 
           RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "h2"}], "+", 
           FractionBox[
            RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
        RowBox[{
         SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
       FractionBox[
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{"d", "-", 
           RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "h1"}], "+", 
           RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "g0"}], "+", 
           RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
        RowBox[{
         SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
    RowBox[{"dv0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "g1"}], "+", 
               RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"eta", " ", "h1"}], "+", 
               RowBox[{"h2", " ", "r0"}]}], ")"}]}], 
            RowBox[{"beta", " ", 
             SuperscriptBox["r", "2"]}]]}], "+", 
          FractionBox[
           RowBox[{"2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
              FractionBox[
               RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}]}], 
           RowBox[{"beta", " ", "r"}]], "-", 
          FractionBox[
           RowBox[{"d", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "h2"}], "+", 
              FractionBox[
               RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
           SuperscriptBox["r", "2"]], "+", 
          FractionBox[
           RowBox[{"d", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "h1"}], "+", 
              RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           SuperscriptBox["r", "3"]]}], ")"}]}], "+", 
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"h1", " ", "k"}], "r"], "-", 
          FractionBox[
           RowBox[{"g1", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "h1"}], "+", 
              RowBox[{"h2", " ", "r0"}]}], ")"}]}], 
           SuperscriptBox["r", "2"]], "-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "h2"}], "+", 
              FractionBox[
               RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
           SuperscriptBox["r", "2"]], "+", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "h1"}], "+", 
              RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           SuperscriptBox["r", "3"]]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{"dx0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"h1", " ", "k"}], "r"], "-", 
          FractionBox[
           RowBox[{"g1", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "h1"}], "+", 
              RowBox[{"h2", " ", "r0"}]}], ")"}]}], 
           SuperscriptBox["r", "2"]], "-", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "h2"}], "+", 
              FractionBox[
               RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
           SuperscriptBox["r", "2"]], "+", 
          FractionBox[
           RowBox[{"g2", " ", "k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "h1"}], "+", 
              RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           SuperscriptBox["r", "3"]]}], ")"}]}], "+", 
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"h2", " ", "k"}], 
           RowBox[{"r", " ", "r0"}]], "+", 
          FractionBox[
           RowBox[{"2", " ", 
            SuperscriptBox["k", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
              FractionBox[
               RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}]}], 
           RowBox[{"beta", " ", "r", " ", 
            SuperscriptBox["r0", "3"]}]], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "+", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "h2"}], "+", 
              FractionBox[
               RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "2"], " ", 
            SuperscriptBox["r0", "3"]}]], "+", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "h1"}], "+", 
              RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "+", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["r", "3"], " ", 
            SuperscriptBox["r0", "3"]}]], "-", 
          FractionBox[
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "h1"}], "+", 
              RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"k", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
              RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
           RowBox[{"beta", " ", 
            SuperscriptBox["r", "2"], " ", 
            SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}]}]}]], "Input",\

 CellChangeTimes->{{3.776258980760725*^9, 3.776258984807379*^9}, {
   3.776259093949028*^9, 3.7762590940371437`*^9}, {3.776542815269114*^9, 
   3.776542828219266*^9}, {3.7766170186672497`*^9, 3.776617024371574*^9}, {
   3.776618198007195*^9, 3.776618198535988*^9}, {3.7766220431277943`*^9, 
   3.7766220455925837`*^9}, 3.776627131934565*^9, {3.77712832369641*^9, 
   3.7771283662444267`*^9}, {3.777128517149831*^9, 3.77712852859328*^9}, {
   3.777128592398947*^9, 3.777128607993618*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"d4d207ae-e603-472b-bd2a-7645ab9a44c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h2"}], "+", 
         FractionBox[
          RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      SuperscriptBox["r", "3"]]}], ")"}]}], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"eta", " ", "h1"}], "+", 
       RowBox[{"h2", " ", "r0"}]}], "r"], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
         FractionBox[
          RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}]}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h2"}], "+", 
         FractionBox[
          RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "h1"}], "+", 
         RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "h1"}], "+", 
             RowBox[{"h2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
            FractionBox[
             RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}]}], 
         RowBox[{"beta", " ", "r"}]], "-", 
        FractionBox[
         RowBox[{"d", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "h2"}], "+", 
            FractionBox[
             RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
         SuperscriptBox["r", "2"]], "+", 
        FractionBox[
         RowBox[{"d", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "h1"}], "+", 
            RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "3"]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"h1", " ", "k"}], "r"], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "h1"}], "+", 
            RowBox[{"h2", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]], "-", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "h2"}], "+", 
            FractionBox[
             RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
         SuperscriptBox["r", "2"]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "h1"}], "+", 
            RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "3"]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"h1", " ", "k"}], "r"], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "h1"}], "+", 
            RowBox[{"h2", " ", "r0"}]}], ")"}]}], 
         SuperscriptBox["r", "2"]], "-", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "h2"}], "+", 
            FractionBox[
             RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
         SuperscriptBox["r", "2"]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "h1"}], "+", 
            RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         SuperscriptBox["r", "3"]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"h2", " ", "k"}], 
         RowBox[{"r", " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "eta", " ", "h1"}], "+", 
            FractionBox[
             RowBox[{"3", " ", "h2", " ", "r0"}], "2"]}], ")"}]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "h2"}], "+", 
            FractionBox[
             RowBox[{"g1", " ", "gamma", " ", "r0"}], "sqb"]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "h1"}], "+", 
            RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "3"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "h1"}], "+", 
            RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.77712836804954*^9, 3.777128449214769*^9, 
  3.777128529498314*^9, 3.777128610757312*^9},
 CellLabel->"Out[35]=",ExpressionUUID->"f288b571-f368-42d1-852f-bad5a0e3e672"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"c1", "=", 
    RowBox[{"d", "-", 
     RowBox[{"r0", " ", "g3"}]}]}], "\n", 
   RowBox[{"c2", " ", "=", " ", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], " ", "+", " ", 
     RowBox[{"g1", " ", "zeta"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"c3", "=", 
    RowBox[{
     RowBox[{"d", " ", "k"}], "+", 
     RowBox[{"g1", " ", 
      SuperscriptBox["r0", "2"]}]}]}], "\n", 
   RowBox[{"c15", "=", 
    RowBox[{
     RowBox[{"eta", " ", "h1"}], "+", 
     RowBox[{"h2", " ", "r0"}]}]}], "\n", 
   RowBox[{"c16", "=", 
    RowBox[{
     RowBox[{"eta", " ", "h2"}], "+", 
     RowBox[{"g1", "  ", "r0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"beta", " ", "g3"}], " ", "+", " ", "g1"}], ")"}]}]}]}], "\n", 
   RowBox[{"c17", "=", 
    RowBox[{"r0", "-", "r", "-", 
     RowBox[{"g2", " ", "k"}]}]}], "\n", 
   RowBox[{"c18", "=", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"2", "g2", " ", "k"}]}]}], "\n", 
   RowBox[{"c19", "=", 
    RowBox[{
     RowBox[{"4", "eta", " ", "h1"}], "+", 
     RowBox[{"3", "h2", " ", "r0"}]}]}], "\[IndentingNewLine]", 
   "\n"}]}]], "Input",
 CellChangeTimes->{{3.7771209707530117`*^9, 3.7771209789550047`*^9}, {
  3.77712104321526*^9, 3.777121051568653*^9}, {3.777121098231024*^9, 
  3.7771211030459757`*^9}, {3.777121147121893*^9, 3.777121150698913*^9}, {
  3.777121208578219*^9, 3.777121212705339*^9}, {3.777121298406386*^9, 
  3.777121313846427*^9}, {3.777121394091579*^9, 3.77712141849713*^9}, {
  3.777128307403812*^9, 3.777128308154512*^9}, {3.7779119486363497`*^9, 
  3.777911955513338*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"e02dea29-e385-4877-ac38-3d2c0bae8f47"],

Cell[BoxData[
 RowBox[{"d", "-", 
  RowBox[{"g3", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.777121622897648*^9, 3.7771283101965446`*^9, 
  3.777128454019761*^9, 3.777128531475016*^9, 3.777128612489856*^9, 
  3.777909225583555*^9, 3.777911956145331*^9, 3.778001578088252*^9, 
  3.778117333356748*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"d7ca75b8-d403-4174-ba18-422fa1c1d812"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g0"}], "+", 
  RowBox[{"g1", " ", "zeta"}]}]], "Output",
 CellChangeTimes->{3.777121622897648*^9, 3.7771283101965446`*^9, 
  3.777128454019761*^9, 3.777128531475016*^9, 3.777128612489856*^9, 
  3.777909225583555*^9, 3.777911956145331*^9, 3.778001578088252*^9, 
  3.778117333358451*^9},
 CellLabel->"Out[35]=",ExpressionUUID->"4d71ebce-b3d7-4b73-b7a9-bde956d98ea2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", " ", "k"}], "+", 
  RowBox[{"g1", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.777121622897648*^9, 3.7771283101965446`*^9, 
  3.777128454019761*^9, 3.777128531475016*^9, 3.777128612489856*^9, 
  3.777909225583555*^9, 3.777911956145331*^9, 3.778001578088252*^9, 
  3.7781173333599377`*^9},
 CellLabel->"Out[36]=",ExpressionUUID->"822aadc9-8d08-4c3f-b1f7-ae5a18ac93af"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "h1"}], "+", 
  RowBox[{"h2", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.777121622897648*^9, 3.7771283101965446`*^9, 
  3.777128454019761*^9, 3.777128531475016*^9, 3.777128612489856*^9, 
  3.777909225583555*^9, 3.777911956145331*^9, 3.778001578088252*^9, 
  3.778117333361433*^9},
 CellLabel->"Out[37]=",ExpressionUUID->"c346ff59-b957-48c6-8b1d-6e3a12850f20"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "h2"}], "+", 
  RowBox[{"g1", " ", 
   RowBox[{"(", 
    RowBox[{"g1", "+", 
     RowBox[{"beta", " ", "g3"}]}], ")"}], " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.777121622897648*^9, 3.7771283101965446`*^9, 
  3.777128454019761*^9, 3.777128531475016*^9, 3.777128612489856*^9, 
  3.777909225583555*^9, 3.777911956145331*^9, 3.778001578088252*^9, 
  3.7781173333630247`*^9},
 CellLabel->"Out[38]=",ExpressionUUID->"d9447fdb-3938-4067-810b-a1a39ba533fb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}]], "Output",
 CellChangeTimes->{3.777121622897648*^9, 3.7771283101965446`*^9, 
  3.777128454019761*^9, 3.777128531475016*^9, 3.777128612489856*^9, 
  3.777909225583555*^9, 3.777911956145331*^9, 3.778001578088252*^9, 
  3.7781173333647337`*^9},
 CellLabel->"Out[39]=",ExpressionUUID->"37264df5-78cd-4e21-b3ae-eaf9f169e012"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g1"}], "+", 
  RowBox[{"2", " ", "g2", " ", "k"}]}]], "Output",
 CellChangeTimes->{3.777121622897648*^9, 3.7771283101965446`*^9, 
  3.777128454019761*^9, 3.777128531475016*^9, 3.777128612489856*^9, 
  3.777909225583555*^9, 3.777911956145331*^9, 3.778001578088252*^9, 
  3.778117333366304*^9},
 CellLabel->"Out[40]=",ExpressionUUID->"206e4f18-5b62-493d-8aee-35e4235a3bab"],

Cell[BoxData[
 RowBox[{
  RowBox[{"4", " ", "eta", " ", "h1"}], "+", 
  RowBox[{"3", " ", "h2", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.777121622897648*^9, 3.7771283101965446`*^9, 
  3.777128454019761*^9, 3.777128531475016*^9, 3.777128612489856*^9, 
  3.777909225583555*^9, 3.777911956145331*^9, 3.778001578088252*^9, 
  3.7781173333678207`*^9},
 CellLabel->"Out[41]=",ExpressionUUID->"a21972ad-5f23-4e7d-9f25-ea6d01c9ad2d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"dgmhgdot2", " ", "=", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"k", " ", "dh", " "}], 
     SuperscriptBox["r", "3"]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"r", " ", "c16"}], "-", 
      RowBox[{"c15", " ", "c2"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dk", "r"], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"k", " ", "c1", " ", "c16"}], 
       RowBox[{"r", " ", "r0"}]], "+", "c15", "-", 
      FractionBox[
       RowBox[{"k", " ", "c17", " ", "c15"}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", "c19"}], 
       RowBox[{"beta", "  ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", "c1", " ", "c15", " ", "c2"}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "v0"}], 
        SuperscriptBox["r", "2"]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "d"}], " ", "c16"}], "-", 
         FractionBox[
          RowBox[{"c18", " ", "c15"}], 
          RowBox[{"beta", " "}]], "+", 
         FractionBox[
          RowBox[{" ", 
           RowBox[{"r", " ", "c19"}]}], "beta"], "+", 
         FractionBox[
          RowBox[{"d", " ", "c15", " ", "c2"}], "r"]}], ")"}]}], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "x0"}], 
        SuperscriptBox["r", "2"]], " ", 
       RowBox[{"(", " ", 
        RowBox[{
         RowBox[{"h1", " ", "r"}], "-", 
         RowBox[{"g2", " ", "c16"}], "-", 
         RowBox[{"g1", " ", "c15"}], "+", 
         FractionBox[
          RowBox[{"g2", " ", "c15", " ", "c2"}], "r"]}], ")"}]}]}], ")"}]}], 
   "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "v0"}], 
        SuperscriptBox["r", "2"]], " ", 
       RowBox[{"(", " ", 
        RowBox[{
         RowBox[{"h1", " ", "r"}], "-", 
         RowBox[{"g2", " ", "c16"}], "-", 
         RowBox[{"g1", " ", "c15"}], "+", 
         FractionBox[
          RowBox[{"g2", " ", "c15", " ", "c2"}], "r"]}], ")"}]}], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "x0"}], 
        RowBox[{"r", " ", "r0"}]], " ", 
       RowBox[{"(", 
        RowBox[{"h2", "+", 
         FractionBox[
          RowBox[{"k", " ", "c19"}], 
          RowBox[{"beta", "  ", 
           SuperscriptBox["r0", "2"]}]], "-", 
         FractionBox[
          RowBox[{"c16", " ", "c3"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]], "+", 
         FractionBox[
          RowBox[{"c15", " ", "c3", " ", "c2"}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "2"]}]], "-", 
         FractionBox[
          RowBox[{"c15", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "2"]}]]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776258995599614*^9, 3.776259029056012*^9}, {
   3.7762590959366198`*^9, 3.77625909602941*^9}, {3.776617017203174*^9, 
   3.776617069848213*^9}, {3.776618193679949*^9, 3.776618218045624*^9}, 
   3.776619113105009*^9, 3.776620118155706*^9, {3.776620229689068*^9, 
   3.776620250008428*^9}, {3.7766220472934933`*^9, 3.7766220952342052`*^9}, {
   3.7766271218845882`*^9, 3.776627178704714*^9}, {3.777120887190915*^9, 
   3.777120924841381*^9}, {3.777120995873706*^9, 3.7771210353996897`*^9}, {
   3.777121109133533*^9, 3.777121131870777*^9}, {3.777121215553647*^9, 
   3.777121286518984*^9}, {3.77712132194501*^9, 3.77712137881979*^9}, {
   3.7771214285610323`*^9, 3.777121556538164*^9}, {3.7771216071489153`*^9, 
   3.7771216211932507`*^9}, {3.77712166672849*^9, 3.77712173587598*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"71c53a07-8e97-43ef-b6c9-30d71d21b7fa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TeXForm", "[", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"k", " ", "dh", " "}], 
     SuperscriptBox["r", "3"]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"r", " ", "c16"}], "-", 
      RowBox[{"c15", " ", "c2"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dk", "r"], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"k", " ", "c1", " ", "c16"}], 
       RowBox[{"r", " ", "r0"}]], "+", "c15", "-", 
      FractionBox[
       RowBox[{"k", " ", "c17", " ", "c15"}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", "c19"}], 
       RowBox[{"beta", "  ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", "c1", " ", "c15", " ", "c2"}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "v0"}], 
        SuperscriptBox["r", "2"]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "d"}], " ", "c16"}], "-", 
         FractionBox[
          RowBox[{"c18", " ", "c15"}], 
          RowBox[{"beta", " "}]], "+", 
         FractionBox[
          RowBox[{" ", 
           RowBox[{"r", " ", "c19"}]}], "beta"], "+", 
         FractionBox[
          RowBox[{"d", " ", "c15", " ", "c2"}], "r"]}], ")"}]}], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "x0"}], 
        SuperscriptBox["r", "2"]], " ", 
       RowBox[{"(", " ", 
        RowBox[{
         RowBox[{"h1", " ", "r"}], "-", 
         RowBox[{"g2", " ", "c16"}], "-", 
         RowBox[{"g1", " ", "c15"}], "+", 
         FractionBox[
          RowBox[{"g2", " ", "c15", " ", "c2"}], "r"]}], ")"}]}]}], ")"}]}], 
   "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "v0"}], 
        SuperscriptBox["r", "2"]], " ", 
       RowBox[{"(", " ", 
        RowBox[{
         RowBox[{"h1", " ", "r"}], "-", 
         RowBox[{"g2", " ", "c16"}], "-", 
         RowBox[{"g1", " ", "c15"}], "+", 
         FractionBox[
          RowBox[{"g2", " ", "c15", " ", "c2"}], "r"]}], ")"}]}], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"k", " ", "x0"}], 
        RowBox[{"r", " ", "r0"}]], " ", 
       RowBox[{"(", 
        RowBox[{"h2", "+", 
         FractionBox[
          RowBox[{"k", " ", "c19"}], 
          RowBox[{"beta", "  ", 
           SuperscriptBox["r0", "2"]}]], "-", 
         FractionBox[
          RowBox[{"c16", " ", "c3"}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "2"]}]], "+", 
         FractionBox[
          RowBox[{"c15", " ", "c3", " ", "c2"}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "2"]}]], "-", 
         FractionBox[
          RowBox[{"c15", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "2"]}]]}], ")"}]}]}], ")"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7766271365958757`*^9, 3.7766271366017313`*^9}, {
  3.777316140665717*^9, 3.777316148098185*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"f5180bf8-ecbd-4df5-a51e-7520cd5ab05b"],

Cell["\<\
\\frac{\\text{dk} \\left(-\\frac{\\text{c15} \\text{c17} k}{\\beta  r \
\\text{r0}}-\\frac{\\text{c19} k}{\\beta  \\text{r0}}-\\frac{\\text{c1} \
\\text{c15} \\text{c2} k}{r^2
   \\text{r0}}+\\frac{\\text{c1} \\text{c16} k}{r \
\\text{r0}}+\\text{c15}\\right)}{r}+\\text{dv0} \\left(\\frac{k \\text{v0} \
\\left(-\\frac{\\text{c15} \\text{c18}}{\\beta
   }+\\frac{\\text{c19} r}{\\beta }+\\frac{\\text{c15} \\text{c2} \
d}{r}-\\text{c16} d\\right)}{r^2}+\\frac{k \\text{x0} \
\\left(\\frac{\\text{c15} \\text{c2} \\text{g2}}{r}-\\text{c15}
   \\text{g1}-\\text{c16} \\text{g2}+\\text{h1} \
r\\right)}{r^2}\\right)+\\text{dx0} \\left(\\frac{k \\text{x0} \
\\left(-\\frac{\\text{c15} (k (\\text{g2} k+r)-\\text{g0} \\text{r0} \\zeta
   )}{\\beta  r \\text{r0}^2}+\\frac{\\text{c19} k}{\\beta  \
\\text{r0}^2}+\\frac{\\text{c15} \\text{c2} \\text{c3}}{r^2 \
\\text{r0}^2}-\\frac{\\text{c16} \\text{c3}}{r
   \\text{r0}^2}+\\text{h2}\\right)}{r \\text{r0}}+\\frac{k \\text{v0} \
\\left(\\frac{\\text{c15} \\text{c2} \\text{g2}}{r}-\\text{c15} \
\\text{g1}-\\text{c16} \\text{g2}+\\text{h1}
   r\\right)}{r^2}\\right)+\\frac{\\text{dh} k (\\text{c16} r-\\text{c15} \
\\text{c2})}{r^3}\
\>", "Output",
 CellChangeTimes->{3.777316148877708*^9},
 CellLabel->
  "Out[7]//TeXForm=",ExpressionUUID->"04c50a10-4aee-4151-8e3e-3f19f5ba2e71"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Revised", " ", "expression", " ", "for", " ", "d", 
    RowBox[{"(", 
     RowBox[{"g", "-", 
      RowBox[{"h", "*", "gdot"}]}], ")"}]}], ":"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7766190859099903`*^9, 3.776619098908731*^9}, {
  3.776622060391039*^9, 3.776622061350966*^9}, {3.7766271415789003`*^9, 
  3.776627146939456*^9}},ExpressionUUID->"737a2b71-af6e-49a2-8fb6-\
9769070ef2d4"],

Cell[BoxData[
 RowBox[{"dgmhgdot", " ", "-", "dgmhgdot2"}]], "Input",
 CellChangeTimes->{{3.776622103415494*^9, 3.7766221660285597`*^9}, 
   3.776627139954582*^9, {3.776627188121719*^9, 3.776627270511063*^9}, 
   3.7767373646527147`*^9, {3.7771209047966843`*^9, 3.77712090611465*^9}, {
   3.777121626686675*^9, 3.777121629905428*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"0d694713-5b03-4982-b4f9-2a9b50a5f345"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7771216318319607`*^9, 3.777121633511589*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"a67b980e-55f8-4a08-9d06-b4a7788763d2"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7771216337981443`*^9, 3.777121868384429*^9, 
  3.777128381616062*^9, 3.777128465310831*^9, 3.777128542938634*^9, 
  3.7771286193293*^9},
 CellLabel->"Out[46]=",ExpressionUUID->"45a6d038-d7f2-492b-bcd1-79446806c8ed"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Look", " ", "into", " ", "cancelling", " ", "leading"}], "-", 
    RowBox[{
    "order", " ", "terms", " ", "derivative", " ", "with", " ", "respect", 
     " ", "to", " ", "k", " ", "in", " ", "g"}], "-", 
    RowBox[{
     RowBox[{"h", " ", "\\", "dot"}], " ", 
     RowBox[{"g", ":"}]}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.777909126353709*^9, 
  3.777909158010405*^9}},ExpressionUUID->"a46711ac-65c6-4829-91fb-\
6405e4ad26f3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               FractionBox["1", 
                RowBox[{"r", " ", "r0"}]], 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  RowBox[{" ", 
                   RowBox[{"c1", " ", "c16"}]}], 
                  RowBox[{"r", " "}]], "-", 
                 FractionBox[
                  RowBox[{" ", 
                   RowBox[{"c17", " ", "c15"}]}], 
                  RowBox[{"beta", " ", "r", " "}]], "-", 
                 FractionBox[
                  RowBox[{" ", "c19"}], "beta"], "-", 
                 FractionBox[
                  RowBox[{" ", 
                   RowBox[{"c1", " ", "c15", " ", "c2"}]}], 
                  SuperscriptBox["r", "2"]]}], ")"}]}], "/.", " ", 
              RowBox[{"d", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"h", "+", 
                  RowBox[{"eta", "*", "g2"}], "+", 
                  RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
                "beta"}]}]}], "  ", "/.", " ", 
             RowBox[{"h", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
               RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
               RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"r", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
              RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
           RowBox[{"zeta", " ", "\[Rule]", " ", 
            RowBox[{"k", "-", 
             RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
          RowBox[{"h1", " ", "\[Rule]", " ", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", " ", 
            RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h2", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
           RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"1", "-", " ", 
          RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"sqb", " ", "\[Rule]", " ", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "9"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777909170896988*^9, 3.777909205271556*^9}, {
  3.777909247121236*^9, 3.777909274858975*^9}, {3.777909411570483*^9, 
  3.777909416192054*^9}, {3.777919969986628*^9, 3.777919970248692*^9}},
 CellLabel->
  "In[273]:=",ExpressionUUID->"86d1a864-7d22-426f-bb4c-c6b6d158ded5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"4", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"15", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{"3", " ", "eta", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"8", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"1365", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"784", " ", "k", " ", "r0"}], "+", 
       RowBox[{"628", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"2520", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "1050"}], " ", 
        SuperscriptBox["eta", "3"]}], "+", 
       RowBox[{"1114", " ", "eta", " ", "k", " ", "r0"}], "-", 
       RowBox[{"813", " ", "beta", " ", "eta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"1440", " ", 
     SuperscriptBox["beta", "4"], " ", 
     SuperscriptBox["r0", "4"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"28350", " ", 
        SuperscriptBox["eta", "4"]}], "-", 
       RowBox[{"43974", " ", 
        SuperscriptBox["eta", "2"], " ", "k", " ", "r0"}], "+", 
       RowBox[{"31353", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{"8064", " ", 
        SuperscriptBox["k", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"13144", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "+", 
       RowBox[{"5240", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "4"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "9"]}], 
    RowBox[{"30240", " ", 
     SuperscriptBox["beta", 
      RowBox[{"9", "/", "2"}]], " ", 
     SuperscriptBox["r0", "5"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "10"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 10, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[4, 15] $CellContext`beta^Rational[-5, 2]/$CellContext`r0, 
    Rational[-3, 
      8] $CellContext`beta^(-3) $CellContext`eta $CellContext`r0^(-2), 
    Rational[1, 2520] $CellContext`beta^Rational[-7, 2] $CellContext`r0^(-3) (
     1365 $CellContext`eta^2 - 784 $CellContext`k $CellContext`r0 + 
     628 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 
      1440] $CellContext`beta^(-4) $CellContext`r0^(-4) ((-1050) \
$CellContext`eta^3 + 1114 $CellContext`eta $CellContext`k $CellContext`r0 - 
     813 $CellContext`beta $CellContext`eta $CellContext`r0^2), 
    Rational[1, 30240] $CellContext`beta^
     Rational[-9, 2] $CellContext`r0^(-5) (28350 $CellContext`eta^4 - 
     43974 $CellContext`eta^2 $CellContext`k $CellContext`r0 + 
     31353 $CellContext`beta $CellContext`eta^2 $CellContext`r0^2 + 
     8064 $CellContext`k^2 $CellContext`r0^2 - 
     13144 $CellContext`beta $CellContext`k $CellContext`r0^3 + 
     5240 $CellContext`beta^2 $CellContext`r0^4)}, 5, 10, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.7779092537669497`*^9, 3.777909275841894*^9}, 
   3.7779094167672033`*^9, 3.777919970780851*^9},
 CellLabel->
  "Out[273]=",ExpressionUUID->"8985ede8-70a7-4106-871c-25dc819df236"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.777909245415791*^9, 
  3.777909245426029*^9}},ExpressionUUID->"878bda98-d741-4562-9619-\
13c15bb7c0f0"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", ",", " ", 
   RowBox[{"examine", " ", "each", " ", 
    RowBox[{"term", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777909307506473*^9, 3.7779093131059723`*^9}},
 CellLabel->
  "In[138]:=",ExpressionUUID->"df524ed0-b4a0-47da-b22d-493b5b1dc27f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               FractionBox["1", 
                RowBox[{"r", " ", "r0"}]], 
               RowBox[{"(", 
                FractionBox[
                 RowBox[{" ", 
                  RowBox[{"c1", " ", "c16"}]}], 
                 RowBox[{"r", " "}]], ")"}]}], "/.", " ", 
              RowBox[{"d", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"h", "+", 
                  RowBox[{"eta", "*", "g2"}], "+", 
                  RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
                "beta"}]}]}], "  ", "/.", " ", 
             RowBox[{"h", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
               RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
               RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"r", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
              RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
           RowBox[{"zeta", " ", "\[Rule]", " ", 
            RowBox[{"k", "-", 
             RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
          RowBox[{"h1", " ", "\[Rule]", " ", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", " ", 
            RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h2", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
           RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"1", "-", " ", 
          RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"sqb", " ", "\[Rule]", " ", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.777909318924122*^9, {3.777909427303061*^9, 3.777909432325068*^9}},
 CellLabel->
  "In[143]:=",ExpressionUUID->"e5b41157-c9dc-4252-a9ac-5a97b2f96300"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "3"], 
    RowBox[{
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{"2", " ", "eta", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"3", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"4", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"3", " ", "k", " ", "r0"}], "+", 
       RowBox[{"3", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"6", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "3"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"120", " ", 
          SuperscriptBox["eta", "2"]}], "-", 
         RowBox[{"150", " ", "k", " ", "r0"}], "+", 
         RowBox[{"131", " ", "beta", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"180", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "4"], " ", 
       SuperscriptBox["r0", "4"]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {$CellContext`beta^Rational[-5, 2]/$CellContext`r0, 
    Rational[-2, 
      3] $CellContext`beta^(-3) $CellContext`eta $CellContext`r0^(-2), 
    Rational[1, 6] $CellContext`beta^Rational[-7, 2] $CellContext`r0^(-3) (
     4 $CellContext`eta^2 - 3 $CellContext`k $CellContext`r0 + 
     3 $CellContext`beta $CellContext`r0^2), 
    Rational[-1, 
      180] $CellContext`beta^(-4) $CellContext`eta $CellContext`r0^(-4) (
     120 $CellContext`eta^2 - 150 $CellContext`k $CellContext`r0 + 
     131 $CellContext`beta $CellContext`r0^2)}, 3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7779093195241528`*^9, 3.777909432745132*^9},
 CellLabel->
  "Out[143]=",ExpressionUUID->"fe596e7f-2334-4664-b84b-a90119f9788e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              FractionBox["1", 
               RowBox[{"r", " ", "r0"}]], 
              RowBox[{"(", 
               RowBox[{"-", 
                FractionBox[
                 RowBox[{" ", 
                  RowBox[{"c17", " ", "c15"}]}], 
                 RowBox[{"beta", " ", "r", " "}]]}], ")"}]}], "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.77790933232477*^9},
 CellLabel->
  "In[140]:=",ExpressionUUID->"38ea7874-b411-4c27-935d-bdce51318a13"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"eta", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"3", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "7"}], " ", 
        SuperscriptBox["eta", "2"]}], "+", 
       RowBox[{"4", " ", "k", " ", "r0"}], "-", 
       RowBox[{"2", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"12", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"300", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"330", " ", "k", " ", "r0"}], "+", 
       RowBox[{"193", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"360", " ", 
     SuperscriptBox["beta", "4"], " ", 
     SuperscriptBox["r0", "4"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 
      3] $CellContext`beta^(-3) $CellContext`eta $CellContext`r0^(-2), 
    Rational[1, 12] $CellContext`beta^
     Rational[-7, 2] $CellContext`r0^(-3) ((-7) $CellContext`eta^2 + 
     4 $CellContext`k $CellContext`r0 - 
     2 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 
      360] $CellContext`beta^(-4) $CellContext`eta $CellContext`r0^(-4) (
     300 $CellContext`eta^2 - 330 $CellContext`k $CellContext`r0 + 
     193 $CellContext`beta $CellContext`r0^2)}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7779093328172703`*^9},
 CellLabel->
  "Out[140]=",ExpressionUUID->"9af0fd31-4dd5-4c99-a339-f1734955f7da"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              FractionBox["1", 
               RowBox[{"r", " ", "r0"}]], 
              RowBox[{"(", 
               RowBox[{"-", 
                FractionBox[
                 RowBox[{" ", "c19"}], "beta"]}], ")"}]}], "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.777909367080678*^9},
 CellLabel->
  "In[141]:=",ExpressionUUID->"ecf87cf4-5f5e-4036-a259-e8bbb6952991"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "3"], 
     RowBox[{
      SuperscriptBox["beta", 
       RowBox[{"5", "/", "2"}]], " ", "r0"}]]}], "+", 
   FractionBox[
    RowBox[{"2", " ", "eta", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"3", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "20"}], " ", 
        SuperscriptBox["eta", "2"]}], "+", 
       RowBox[{"15", " ", "k", " ", "r0"}], "-", 
       RowBox[{"12", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"30", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"60", " ", 
        SuperscriptBox["eta", "3"]}], "-", 
       RowBox[{"75", " ", "eta", " ", "k", " ", "r0"}], "+", 
       RowBox[{"53", " ", "beta", " ", "eta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"90", " ", 
     SuperscriptBox["beta", "4"], " ", 
     SuperscriptBox["r0", "4"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {-$CellContext`beta^Rational[-5, 2]/$CellContext`r0, 
    Rational[2, 
      3] $CellContext`beta^(-3) $CellContext`eta $CellContext`r0^(-2), 
    Rational[1, 30] $CellContext`beta^
     Rational[-7, 2] $CellContext`r0^(-3) ((-20) $CellContext`eta^2 + 
     15 $CellContext`k $CellContext`r0 - 
     12 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 90] $CellContext`beta^(-4) $CellContext`r0^(-4) (
     60 $CellContext`eta^3 - 
     75 $CellContext`eta $CellContext`k $CellContext`r0 + 
     53 $CellContext`beta $CellContext`eta $CellContext`r0^2)}, 3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.77790936763546*^9},
 CellLabel->
  "Out[141]=",ExpressionUUID->"49ca50cc-de55-49e4-a194-ea012072eb03"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               FractionBox["1", 
                RowBox[{"r", " ", "r0"}]], 
               RowBox[{"(", 
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{" ", 
                   RowBox[{"c1", " ", "c15", " ", "c2"}]}], 
                  SuperscriptBox["r", "2"]]}], ")"}]}], "/.", " ", 
              RowBox[{"d", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"h", "+", 
                  RowBox[{"eta", "*", "g2"}], "+", 
                  RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
                "beta"}]}]}], "  ", "/.", " ", 
             RowBox[{"h", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
               RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
               RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"r", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
              RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
           RowBox[{"zeta", " ", "\[Rule]", " ", 
            RowBox[{"k", "-", 
             RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
          RowBox[{"h1", " ", "\[Rule]", " ", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", " ", 
            RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h2", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
           RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"1", "-", " ", 
          RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"sqb", " ", "\[Rule]", " ", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.777909477072047*^9},
 CellLabel->
  "In[144]:=",ExpressionUUID->"cc99937e-6036-4d36-ae4d-04e64f7cd29d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"eta", " ", 
      SuperscriptBox["gamma", "4"]}], 
     RowBox[{"3", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["beta", "3"], " ", 
        SuperscriptBox["r0", "2"]}], ")"}]}]]}], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"7", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"4", " ", "k", " ", "r0"}], "+", 
       RowBox[{"4", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"12", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "3"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"150", " ", 
          SuperscriptBox["eta", "2"]}], "-", 
         RowBox[{"165", " ", "k", " ", "r0"}], "+", 
         RowBox[{"139", " ", "beta", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"180", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "4"], " ", 
       SuperscriptBox["r0", "4"]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 
      3] $CellContext`beta^(-3) $CellContext`eta $CellContext`r0^(-2), 
    Rational[1, 12] $CellContext`beta^Rational[-7, 2] $CellContext`r0^(-3) (
     7 $CellContext`eta^2 - 4 $CellContext`k $CellContext`r0 + 
     4 $CellContext`beta $CellContext`r0^2), 
    Rational[-1, 
      180] $CellContext`beta^(-4) $CellContext`eta $CellContext`r0^(-4) (
     150 $CellContext`eta^2 - 165 $CellContext`k $CellContext`r0 + 
     139 $CellContext`beta $CellContext`r0^2)}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777909477836162*^9},
 CellLabel->
  "Out[144]=",ExpressionUUID->"5d2af547-f6d0-44f2-8adf-59c0bffa436b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "It", " ", "looks", " ", "like", " ", "we", " ", "need", " ", "to", " ", 
    "combine", " ", "the", " ", 
    RowBox[{"gamma", "^", "3"}], " ", "terms", " ", "and", " ", "the", " ", 
    RowBox[{"gamma", "^", "4"}], " ", "terms", " ", "to", " ", "get", " ", 
    "a", " ", 
    RowBox[{"gamma", "^", "5"}], " ", 
    RowBox[{"term", ".", "  ", "First"}]}], ",", " ", 
   RowBox[{
    RowBox[{"gamma", "^", "3"}], ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7779094904950523`*^9, 3.777909515756884*^9}},
 CellLabel->
  "In[145]:=",ExpressionUUID->"468e719a-4101-4fa2-a817-aa4238b4c491"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               FractionBox["1", 
                RowBox[{"r", " ", "r0"}]], 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  RowBox[{" ", 
                   RowBox[{"c1", " ", "c16"}]}], 
                  RowBox[{"r", " "}]], "-", 
                 FractionBox[
                  RowBox[{" ", "c19"}], "beta"]}], ")"}]}], "/.", " ", 
              RowBox[{"d", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"h", "+", 
                  RowBox[{"eta", "*", "g2"}], "+", 
                  RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
                "beta"}]}]}], "  ", "/.", " ", 
             RowBox[{"h", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
               RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
               RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"r", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
              RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
           RowBox[{"zeta", " ", "\[Rule]", " ", 
            RowBox[{"k", "-", 
             RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
          RowBox[{"h1", " ", "\[Rule]", " ", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", " ", 
            RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h2", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
           RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"1", "-", " ", 
          RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"sqb", " ", "\[Rule]", " ", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777909538620432*^9, 3.777909559780974*^9}},
 CellLabel->
  "In[146]:=",ExpressionUUID->"68409971-d333-4d5d-9f15-1225842b4549"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "5"], 
    RowBox[{"10", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{"5", " ", "eta", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"36", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 10] $CellContext`beta^Rational[-5, 2]/$CellContext`r0, 
    Rational[-5, 
      36] $CellContext`beta^(-3) $CellContext`eta $CellContext`r0^(-2)}, 5, 7,
    1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7779095601837597`*^9},
 CellLabel->
  "Out[146]=",ExpressionUUID->"a38f62ee-ee4c-421e-9600-3d54da06408c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               FractionBox["1", 
                RowBox[{"r", " ", "r0"}]], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", 
                  FractionBox[
                   RowBox[{" ", 
                    RowBox[{"c17", " ", "c15"}]}], 
                   RowBox[{"beta", " ", "r", " "}]]}], "-", 
                 FractionBox[
                  RowBox[{" ", 
                   RowBox[{"c1", " ", "c15", " ", "c2"}]}], 
                  SuperscriptBox["r", "2"]]}], ")"}]}], "/.", " ", 
              RowBox[{"d", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"h", "+", 
                  RowBox[{"eta", "*", "g2"}], "+", 
                  RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
                "beta"}]}]}], "  ", "/.", " ", 
             RowBox[{"h", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
               RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
               RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"r", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
              RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
           RowBox[{"zeta", " ", "\[Rule]", " ", 
            RowBox[{"k", "-", 
             RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
          RowBox[{"h1", " ", "\[Rule]", " ", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", " ", 
            RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h2", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
           RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"1", "-", " ", 
          RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"sqb", " ", "\[Rule]", " ", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777909574235668*^9, 3.7779095763723927`*^9}},
 CellLabel->
  "In[147]:=",ExpressionUUID->"2118b575-40a2-426c-9478-d0214ba00782"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "5"], 
    RowBox[{"6", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{"17", " ", "eta", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"72", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 6] $CellContext`beta^Rational[-5, 2]/$CellContext`r0, 
    Rational[-17, 
      72] $CellContext`beta^(-3) $CellContext`eta $CellContext`r0^(-2)}, 5, 7,
    1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777909576940997*^9},
 CellLabel->
  "Out[147]=",ExpressionUUID->"da66a774-749b-426c-b3ed-39e60dd8395c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Find", " ", "\"\<simplification\>\"", " ", "of", " ", 
    RowBox[{"gamma", "^", "3"}], " ", 
    RowBox[{"term", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.7779096240339193`*^9, 3.777909640608898*^9}},
 CellLabel->
  "In[148]:=",ExpressionUUID->"e18c7694-f215-4d35-9c20-3bd994b12e5d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{"r", " ", "r0"}]], 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{" ", 
            RowBox[{"c1", " ", "c16"}]}], 
           RowBox[{"r", " "}]], "-", 
          FractionBox[
           RowBox[{" ", "c19"}], "beta"]}], ")"}]}], "/.", " ", 
       RowBox[{"d", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"h", "+", 
           RowBox[{"eta", "*", "g2"}], "+", 
           RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], 
      "  ", "/.", " ", 
      RowBox[{"h", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
        RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
        RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
     RowBox[{"r", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
       RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
    RowBox[{"zeta", " ", "\[Rule]", " ", 
     RowBox[{"k", "-", 
      RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
   RowBox[{"h1", " ", "\[Rule]", " ", 
    RowBox[{
     SuperscriptBox["g2", "2"], "-", " ", 
     RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
  RowBox[{"h2", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
    RowBox[{"g0", " ", "g3", " "}]}]}]}]], "Input",
 CellLabel->
  "In[183]:=",ExpressionUUID->"5a2d7629-758d-4c20-905a-9ec5d389a1a3"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      RowBox[{"4", " ", "eta", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["g2", "2"], "-", 
         RowBox[{"g1", " ", "g3"}]}], ")"}]}], "+", 
      RowBox[{"3", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "g2"}], "-", 
         RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}]}], "beta"]}], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], "-", 
          RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{"g1", "+", 
          RowBox[{"beta", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "g3"}], " ", "r0"}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
         RowBox[{"3", " ", "g3", " ", "k"}], "+", 
         RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}], 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}]]}], 
  RowBox[{"r0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}]}]]], "Output",
 CellChangeTimes->{3.777909643058342*^9, 3.7779118352076406`*^9, 
  3.777911965201049*^9},
 CellLabel->
  "Out[183]=",ExpressionUUID->"b0f7eaf9-3eaa-4224-872d-acf7971d5e54"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Together", "[", 
  FractionBox[
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{"4", " ", "eta", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["g2", "2"], "-", 
          RowBox[{"g1", " ", "g3"}]}], ")"}]}], "+", 
       RowBox[{"3", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], "-", 
          RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}]}], "beta"]}], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], "-", 
           RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
        RowBox[{"g1", " ", 
         RowBox[{"(", 
          RowBox[{"g1", "+", 
           RowBox[{"beta", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "g3"}], " ", "r0"}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
          RowBox[{"3", " ", "g3", " ", "k"}], "+", 
          RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}], 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}]]}], 
   RowBox[{"r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]], "]"}]], "Input",
 CellChangeTimes->{{3.777911850716559*^9, 3.7779118555099993`*^9}, {
   3.77791190580632*^9, 3.7779119126914263`*^9}, 3.7779119757893143`*^9},
 CellLabel->
  "In[184]:=",ExpressionUUID->"cee69f53-3c9a-4ad4-ac77-22c156881d0c"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"beta", " ", "r0", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}], "2"]}]], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     SuperscriptBox["eta", "2"], " ", "g1", " ", 
     SuperscriptBox["g2", "2"]}], "+", 
    RowBox[{"4", " ", 
     SuperscriptBox["eta", "2"], " ", 
     SuperscriptBox["g1", "2"], " ", "g3"}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["eta", "2"], " ", "g0", " ", "g2", " ", "g3"}], "-", 
    RowBox[{"4", " ", "eta", " ", 
     SuperscriptBox["g2", "3"], " ", "k"}], "+", 
    RowBox[{"7", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "k"}], "-", 
    RowBox[{"3", " ", "eta", " ", "g0", " ", 
     SuperscriptBox["g3", "2"], " ", "k"}], "-", 
    RowBox[{"4", " ", "eta", " ", "g0", " ", 
     SuperscriptBox["g2", "2"], " ", "r0"}], "+", 
    RowBox[{"6", " ", "eta", " ", "g0", " ", "g1", " ", "g3", " ", "r0"}], 
    "+", 
    RowBox[{"beta", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "r0"}], 
    "+", 
    RowBox[{"beta", " ", "eta", " ", "g0", " ", 
     SuperscriptBox["g3", "2"], " ", "r0"}], "-", 
    RowBox[{"3", " ", "g1", " ", 
     SuperscriptBox["g2", "2"], " ", "k", " ", "r0"}], "+", 
    RowBox[{"3", " ", 
     SuperscriptBox["g1", "2"], " ", "g3", " ", "k", " ", "r0"}], "+", 
    RowBox[{"3", " ", "g0", " ", "g2", " ", "g3", " ", "k", " ", "r0"}], "+", 
    
    RowBox[{"3", " ", "beta", " ", "g1", " ", 
     SuperscriptBox["g3", "2"], " ", "k", " ", "r0"}], "+", 
    RowBox[{
     SuperscriptBox["g1", "3"], " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{"3", " ", "g0", " ", "g1", " ", "g2", " ", 
     SuperscriptBox["r0", "2"]}], "+", 
    RowBox[{"3", " ", 
     SuperscriptBox["g0", "2"], " ", "g3", " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{
     SuperscriptBox["beta", "2"], " ", "g1", " ", 
     SuperscriptBox["g3", "2"], " ", 
     SuperscriptBox["r0", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7779118558294163`*^9, 3.777911913775434*^9, 
  3.777911976629857*^9},
 CellLabel->
  "Out[184]=",ExpressionUUID->"93cb2196-dc22-42a9-b41c-2388275d2538"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       SuperscriptBox["eta", "2"], " ", "g1", " ", 
       SuperscriptBox["g2", "2"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["eta", "2"], " ", 
       SuperscriptBox["g1", "2"], " ", "g3"}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["eta", "2"], " ", "g0", " ", "g2", " ", "g3"}], "-", 
      RowBox[{"4", " ", "eta", " ", 
       SuperscriptBox["g2", "3"], " ", "k"}], "+", 
      RowBox[{"7", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "k"}], 
      "-", 
      RowBox[{"3", " ", "eta", " ", "g0", " ", 
       SuperscriptBox["g3", "2"], " ", "k"}], "-", 
      RowBox[{"4", " ", "eta", " ", "g0", " ", 
       SuperscriptBox["g2", "2"], " ", "r0"}], "+", 
      RowBox[{"6", " ", "eta", " ", "g0", " ", "g1", " ", "g3", " ", "r0"}], 
      "+", 
      RowBox[{
      "beta", " ", "eta", " ", "g1", " ", "g2", " ", "g3", " ", "r0"}], "+", 
      RowBox[{"beta", " ", "eta", " ", "g0", " ", 
       SuperscriptBox["g3", "2"], " ", "r0"}], "-", 
      RowBox[{"3", " ", "g1", " ", 
       SuperscriptBox["g2", "2"], " ", "k", " ", "r0"}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["g1", "2"], " ", "g3", " ", "k", " ", "r0"}], "+", 
      RowBox[{"3", " ", "g0", " ", "g2", " ", "g3", " ", "k", " ", "r0"}], 
      "+", 
      RowBox[{"3", " ", "beta", " ", "g1", " ", 
       SuperscriptBox["g3", "2"], " ", "k", " ", "r0"}], "+", 
      RowBox[{
       SuperscriptBox["g1", "3"], " ", 
       SuperscriptBox["r0", "2"]}], "-", 
      RowBox[{"3", " ", "g0", " ", "g1", " ", "g2", " ", 
       SuperscriptBox["r0", "2"]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["g0", "2"], " ", "g3", " ", 
       SuperscriptBox["r0", "2"]}], "-", 
      RowBox[{
       SuperscriptBox["beta", "2"], " ", "g1", " ", 
       SuperscriptBox["g3", "2"], " ", 
       SuperscriptBox["r0", "2"]}]}], ")"}], ",", 
    RowBox[{"{", 
     RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7779119206014433`*^9, 3.777911931338285*^9}, {
  3.777911983158175*^9, 3.7779119911937437`*^9}},
 CellLabel->
  "In[186]:=",ExpressionUUID->"c73369af-305f-49be-bd96-2ce54da78508"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["eta", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "g1", " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"4", " ", 
      SuperscriptBox["g1", "2"], " ", "g3"}], "-", 
     RowBox[{"2", " ", "g0", " ", "g2", " ", "g3"}]}], ")"}]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", 
      SuperscriptBox["g2", "3"]}], "+", 
     RowBox[{"7", " ", "g1", " ", "g2", " ", "g3"}], "-", 
     RowBox[{"3", " ", "g0", " ", 
      SuperscriptBox["g3", "2"]}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "g0", " ", 
         SuperscriptBox["g2", "2"]}], "+", 
        RowBox[{"6", " ", "g0", " ", "g1", " ", "g3"}], "+", 
        RowBox[{"beta", " ", "g1", " ", "g2", " ", "g3"}], "+", 
        RowBox[{"beta", " ", "g0", " ", 
         SuperscriptBox["g3", "2"]}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "3"}], " ", "g1", " ", 
         SuperscriptBox["g2", "2"]}], "+", 
        RowBox[{"3", " ", 
         SuperscriptBox["g1", "2"], " ", "g3"}], "+", 
        RowBox[{"3", " ", "g0", " ", "g2", " ", "g3"}], "+", 
        RowBox[{"3", " ", "beta", " ", "g1", " ", 
         SuperscriptBox["g3", "2"]}]}], ")"}], " ", "k"}]}], ")"}], " ", 
   "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["g1", "3"], "-", 
     RowBox[{"3", " ", "g0", " ", "g1", " ", "g2"}], "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["g0", "2"], " ", "g3"}], "-", 
     RowBox[{
      SuperscriptBox["beta", "2"], " ", "g1", " ", 
      SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{
  3.777911931678413*^9, {3.777911983846634*^9, 3.777911992645671*^9}},
 CellLabel->
  "Out[186]=",ExpressionUUID->"b1acc06f-47b7-4813-81af-6c0e7278aa76"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Expand", " ", "the", " ", "numerator", " ", "of", " ", 
   RowBox[{"gamma", "^", "3"}], " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.77790983335245*^9, 3.777909839866478*^9}},
 CellLabel->
  "In[152]:=",ExpressionUUID->"33bc5506-35d9-424d-99cd-40b4dd4207dc"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", ",", " ", 
   RowBox[{
    RowBox[{"combine", " ", "&"}], " ", "simplify", " ", 
    RowBox[{"terms", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7779098568267*^9, 3.777909865937667*^9}},
 CellLabel->
  "In[154]:=",ExpressionUUID->"60c80cf8-ae42-4fe1-a8ac-b417c71b574c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   SuperscriptBox["eta", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g3", " ", "g2"}], "-", " ", 
     RowBox[{"g1", " ", "h1"}]}], ")"}]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", "g3", " ", "h2"}], "-", 
     RowBox[{"4", " ", "g2", " ", "h1"}]}], ")"}], " ", "k"}], "+", 
  RowBox[{"r0", " ", "eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "g0", " ", "h6"}], "+", 
     RowBox[{"beta", " ", "g3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "+", " ", 
        RowBox[{"g0", " ", "g3"}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "h6"}], 
      RowBox[{"(", 
       RowBox[{"g1", "+", 
        RowBox[{"beta", " ", "g3"}]}], ")"}]}], "+", 
     RowBox[{"g2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "g3"}], "-", "h2"}], ")"}]}]}], " ", ")"}], " ", "r0", 
   " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"h7", "-", 
     RowBox[{
      SuperscriptBox["beta", "2"], " ", "g1", " ", 
      SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{
  3.777909902674038*^9, {3.777909936669148*^9, 3.7779101504193974`*^9}, {
   3.777910195674412*^9, 3.777910331903522*^9}, 3.777910370176182*^9, {
   3.777910408540414*^9, 3.777910483801302*^9}, {3.77791093327872*^9, 
   3.777910938614253*^9}, {3.7779109823825912`*^9, 3.777911175375383*^9}, {
   3.777911295208004*^9, 3.777911354244392*^9}, {3.777911418633527*^9, 
   3.777911425810606*^9}, 3.777911476114159*^9, {3.777912012978203*^9, 
   3.777912055685907*^9}, {3.777912160420967*^9, 3.777912367517723*^9}, {
   3.777912409611539*^9, 3.777912669499048*^9}, {3.777912752774948*^9, 
   3.777912806663*^9}, {3.7779129132990513`*^9, 3.7779130225399647`*^9}, {
   3.777916881233305*^9, 
   3.777916881592619*^9}},ExpressionUUID->"f5315b7f-b984-49fb-ab63-\
7c3012540fde"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "See", " ", "if", " ", "we", " ", "got", " ", "numerator", " ", "of", " ", 
    
    RowBox[{"gamma", "^", "3"}], " ", "term", " ", 
    RowBox[{"correct", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.77791162030755*^9, 3.7779116343145514`*^9}},
 CellLabel->
  "In[161]:=",ExpressionUUID->"3fd2a269-4db8-4498-81c5-4afee3c1a633"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{"2", " ", 
              SuperscriptBox["eta", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g3", " ", "g2"}], "-", " ", 
                RowBox[{"g1", " ", "h1"}]}], ")"}]}], "+", 
             RowBox[{"eta", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"3", " ", "g3", " ", "h2"}], "-", 
                RowBox[{"4", " ", "g2", " ", "h1"}]}], ")"}], " ", "k"}], "+", 
             RowBox[{"r0", " ", "eta", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "2"}], " ", "g0", " ", "h6"}], "+", 
                RowBox[{"beta", " ", "g3", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g1", " ", "g2"}], "+", " ", 
                   RowBox[{"g0", " ", "g3"}]}], ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "h6"}], 
                 RowBox[{"(", 
                  RowBox[{"g1", "+", 
                   RowBox[{"beta", " ", "g3"}]}], ")"}]}], "+", 
                RowBox[{"g2", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", "g3"}], "-", "h2"}], ")"}]}]}], " ", ")"}], 
              " ", "r0", " ", "k"}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"h7", "-", 
                RowBox[{
                 SuperscriptBox["beta", "2"], " ", "g1", " ", 
                 SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
              SuperscriptBox["r0", "2"]}]}], 
            RowBox[{"beta", " ", "r0", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g1"}], "+", 
                RowBox[{"g2", " ", "k"}], "+", 
                RowBox[{"g0", " ", "r0"}]}], ")"}], "2"]}]], " ", "/.", " ", 
           RowBox[{"h7", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"g1", " ", "g2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"2", " ", "g0"}]}], ")"}]}], " ", "+", " ", 
             RowBox[{"3", " ", 
              SuperscriptBox["g0", "2"], " ", "g3"}]}]}]}], " ", "/.", 
          RowBox[{"h6", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"2", " ", 
             SuperscriptBox["g2", "2"]}], "-", 
            RowBox[{"3", "g1", " ", "g3"}]}]}]}], "/.", " ", 
         RowBox[{"d", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"h", "+", 
             RowBox[{"eta", "*", "g2"}], "+", 
             RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], 
        "  ", "/.", " ", 
        RowBox[{"h", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
          RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"r", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
         RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
         RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"zeta", " ", "\[Rule]", " ", 
       RowBox[{"k", "-", 
        RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
     RowBox[{"h1", " ", "\[Rule]", " ", 
      RowBox[{
       SuperscriptBox["g2", "2"], "-", " ", 
       RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
    RowBox[{"h2", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
      RowBox[{"g0", " ", "g3"}]}]}]}], "  ", "/.", " ", 
   RowBox[{"sqb", " ", "\[Rule]", " ", 
    RowBox[{"Sqrt", "[", "beta", "]"}]}]}], " ", "/.", " ", 
  RowBox[{"g0", " ", "\[Rule]", " ", 
   RowBox[{"1", "-", 
    RowBox[{"beta", " ", "g2"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777911467605605*^9, 3.777911537053104*^9}, {
   3.7779116581461563`*^9, 3.777911674777144*^9}, 3.777911707578669*^9, {
   3.777916855755391*^9, 3.777916894628034*^9}},
 CellLabel->
  "In[222]:=",ExpressionUUID->"adc7b474-b2d7-43a1-adf2-eb35c6c85577"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"beta", " ", "r0", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "r0"}]}], ")"}], "2"]}]], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", 
     SuperscriptBox["eta", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g2", " ", "g3"}], "-", 
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["g2", "2"], "-", 
          RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{"eta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "g2", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["g2", "2"], "-", 
          RowBox[{"g1", " ", "g3"}]}], ")"}]}], "+", 
       RowBox[{"3", " ", "g3", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", 
             RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3"}]}], ")"}]}]}], 
      ")"}], " ", "k"}], "+", 
    RowBox[{"eta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"beta", " ", "g2"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", 
           SuperscriptBox["g2", "2"]}], "-", 
          RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}]}], "+", 
       RowBox[{"beta", " ", "g3", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", 
             RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3"}]}], ")"}]}]}], 
      ")"}], " ", "r0"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{"g1", "+", 
           RowBox[{"beta", " ", "g3"}]}], ")"}]}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", 
           SuperscriptBox["g2", "2"]}], "-", 
          RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}]}], "+", 
       RowBox[{"g2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "g1"}], " ", "g2"}], "+", 
          RowBox[{"2", " ", "g3"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", 
             RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3"}]}], ")"}]}]}], 
      ")"}], " ", "k", " ", "r0"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g1", " ", "g2", " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{"1", "-", 
             RowBox[{"beta", " ", "g2"}]}], ")"}]}]}], ")"}]}], "+", 
       RowBox[{"3", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"beta", " ", "g2"}]}], ")"}], "2"], " ", "g3"}], "-", 
       RowBox[{
        SuperscriptBox["beta", "2"], " ", "g1", " ", 
        SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
     SuperscriptBox["r0", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.777911708285722*^9, 3.77791689559159*^9},
 CellLabel->
  "Out[222]=",ExpressionUUID->"592d7e70-f097-4fc8-a65e-533a74bb42e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               FractionBox["1", 
                RowBox[{"r", " ", "r0"}]], 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  RowBox[{" ", 
                   RowBox[{"c1", " ", "c16"}]}], 
                  RowBox[{"r", " "}]], "-", 
                 FractionBox[
                  RowBox[{" ", "c19"}], "beta"]}], ")"}]}], " ", "-", " ", 
              FractionBox[
               RowBox[{
                RowBox[{"2", " ", 
                 SuperscriptBox["eta", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g3", " ", "g2"}], "-", " ", 
                   RowBox[{"g1", " ", "h1"}]}], ")"}]}], "+", 
                RowBox[{"eta", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"3", " ", "g3", " ", "h2"}], "-", 
                   RowBox[{"4", " ", "g2", " ", "h1"}]}], ")"}], " ", "k"}], 
                "+", 
                RowBox[{"r0", " ", "eta", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"beta", " ", "g3", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", " ", "g2"}], "+", " ", 
                    RowBox[{"g0", " ", "g3"}]}], ")"}]}], "-", 
                   RowBox[{"2", " ", "g0", " ", "h6"}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "h6"}], 
                    RowBox[{"(", 
                    RowBox[{"g1", "+", 
                    RowBox[{"beta", " ", "g3"}]}], ")"}]}], "+", 
                   RowBox[{"g2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", "g3"}], "-", "h2"}], ")"}]}]}], " ", ")"}], 
                 " ", "r0", " ", "k"}], "+", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"h7", "-", 
                   RowBox[{
                    SuperscriptBox["beta", "2"], " ", "g1", " ", 
                    SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
                 SuperscriptBox["r0", "2"]}]}], 
               RowBox[{"beta", " ", "r0", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"eta", " ", "g1"}], "+", 
                   RowBox[{"g2", " ", "k"}], "+", 
                   RowBox[{"g0", " ", "r0"}]}], ")"}], "2"]}]]}], "  ", "/.", 
             " ", 
             RowBox[{"h7", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"g1", " ", "g2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"2", " ", "g0"}]}], ")"}]}], " ", "+", " ", 
               RowBox[{"3", " ", 
                SuperscriptBox["g0", "2"], " ", "g3"}]}]}]}], " ", "/.", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", " ", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"h1", " ", "\[Rule]", " ", 
        RowBox[{
         SuperscriptBox["g2", "2"], "-", " ", 
         RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
      RowBox[{"h2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
        RowBox[{"g0", " ", "g3"}]}]}]}], "  ", "/.", " ", 
     RowBox[{"sqb", " ", "\[Rule]", " ", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}], " ", "/.", " ", 
    RowBox[{"g0", " ", "\[Rule]", " ", 
     RowBox[{"1", "-", 
      RowBox[{"beta", " ", "g2"}]}]}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.7779168482016993`*^9, 3.777916848825349*^9}, {
  3.777916933204783*^9, 3.777916945518463*^9}, {3.7779170305245132`*^9, 
  3.777917033799273*^9}},ExpressionUUID->"ef780798-8bc5-4dab-b36c-\
6e78d7a5058d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"beta", " ", "r0", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"g2", " ", "k"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "r0"}]}], ")"}], 
       "2"]}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       SuperscriptBox["eta", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "g3"}], "-", 
         RowBox[{"g1", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", 
            RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], " ", "g2", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", 
            RowBox[{"g1", " ", "g3"}]}], ")"}]}], "+", 
         RowBox[{"3", " ", "g3", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "g2"}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "-", 
               RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3"}]}], ")"}]}]}],
         ")"}], " ", "k"}], "+", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"beta", " ", "g2"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             SuperscriptBox["g2", "2"]}], "-", 
            RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}]}], "+", 
         RowBox[{"beta", " ", "g3", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "g2"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "-", 
               RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3"}]}], ")"}]}]}],
         ")"}], " ", "r0"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{"g1", "+", 
             RowBox[{"beta", " ", "g3"}]}], ")"}]}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             SuperscriptBox["g2", "2"]}], "-", 
            RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}]}], "+", 
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "g1"}], " ", "g2"}], "+", 
            RowBox[{"2", " ", "g3"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "-", 
               RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3"}]}], ")"}]}]}],
         ")"}], " ", "k", " ", "r0"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "g2", " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{"1", "-", 
               RowBox[{"beta", " ", "g2"}]}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "-", 
             RowBox[{"beta", " ", "g2"}]}], ")"}], "2"], " ", "g3"}], "-", 
         RowBox[{
          SuperscriptBox["beta", "2"], " ", "g1", " ", 
          SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
       SuperscriptBox["r0", "2"]}]}], ")"}]}]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{"4", " ", "eta", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["g2", "2"], "-", 
          RowBox[{"g1", " ", "g3"}]}], ")"}]}], "+", 
       RowBox[{"3", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", 
             RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3"}]}], ")"}], " ", 
        "r0"}]}], "beta"]}], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3"}]}], ")"}]}], 
        "+", 
        RowBox[{"g1", " ", 
         RowBox[{"(", 
          RowBox[{"g1", "+", 
           RowBox[{"beta", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "g3"}], " ", "r0"}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
          RowBox[{"3", " ", "g3", " ", "k"}], "+", 
          RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}], 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "r0"}]}]]}], 
   RowBox[{"r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "r0"}]}], 
     ")"}]}]]}]], "Output",
 CellChangeTimes->{3.777916946705296*^9},
 CellLabel->
  "Out[223]=",ExpressionUUID->"96852bc6-36ac-4497-88aa-a04574bf910c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777916947348126*^9, 3.777916949747959*^9}},
 CellLabel->
  "In[224]:=",ExpressionUUID->"a914af84-7c72-4fd1-b1de-fcd00bad6f46"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["g1", "2"], "-", "g2", " ", "-", "g0g2"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      SuperscriptBox["eta", "2"], " ", "g3"}], "+", 
     RowBox[{"g1", " ", 
      SuperscriptBox["r0", "2"]}]}], ")"}]}], 
  RowBox[{"beta", " ", "r0", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", "r0", "+", 
      RowBox[{"g2", " ", 
       RowBox[{"(", 
        RowBox[{"k", "-", 
         RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], "2"]}]]], "Input",
 CellChangeTimes->{{3.7779169708928413`*^9, 
  3.777917001434451*^9}},ExpressionUUID->"2c63927c-c710-4a7e-a17f-\
e8bc6af09d1b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777911710999022*^9, 3.777911712124342*^9}},
 CellLabel->
  "In[167]:=",ExpressionUUID->"c48c3e6f-2be5-4825-ab14-b4ca612e6acc"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
      RowBox[{"3", " ", "g3", " ", "k"}], "+", 
      RowBox[{"g1", " ", "r0"}], "-", 
      RowBox[{"beta", " ", "g3", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1", " ", "g2"}], "+", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3"}], "+", 
      RowBox[{"g1", " ", 
       RowBox[{"(", 
        RowBox[{"g1", "+", 
         RowBox[{"beta", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], " ", "eta", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["g2", "2"], "-", 
         RowBox[{"g1", " ", "g3"}]}], ")"}]}], "-", 
      RowBox[{"3", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "g2"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3"}]}], ")"}], " ", 
       "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", "r0", "+", 
      RowBox[{"g2", " ", 
       RowBox[{"(", 
        RowBox[{"k", "-", 
         RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}], 
  RowBox[{"beta", " ", "r0", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", "r0", "+", 
      RowBox[{"g2", " ", 
       RowBox[{"(", 
        RowBox[{"k", "-", 
         RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], "2"]}]]], "Output",
 CellChangeTimes->{3.77791171256614*^9},
 CellLabel->
  "Out[167]=",ExpressionUUID->"4eaad8c4-6b21-40b2-a8ca-ee959a650745"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Expand", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777911757973267*^9, 3.777911759236291*^9}},
 CellLabel->
  "In[168]:=",ExpressionUUID->"e1fe18a0-06d8-47a1-976e-4abef6cacf63"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.77791176159717*^9, 3.7779117638760843`*^9}},
 CellLabel->
  "In[169]:=",ExpressionUUID->"cbc97594-24a9-4566-85ed-7e959167b263"],

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7779117818076363`*^9, 3.7779117885017033`*^9}},
 CellLabel->
  "In[170]:=",ExpressionUUID->"af022604-4529-4512-b792-78770f833874"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"g2", " ", "g1", 
       RowBox[{"(", 
        RowBox[{"1", " ", "-", 
         RowBox[{"2", "g0"}]}], ")"}]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["g0", "2"], " ", "g3"}]}], " ", "/.", " ", 
     RowBox[{"g0", " ", "\[Rule]", " ", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sin", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777913043785334*^9, 3.777913086793557*^9}, {
  3.77791313847637*^9, 3.777913142433794*^9}},
 CellLabel->
  "In[189]:=",ExpressionUUID->"dbc8d9fd-d846-43f1-9ddc-50f8f9e064ce"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"3", " ", 
    SuperscriptBox[
     RowBox[{"Cos", "[", "gamma", "]"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{"gamma", "-", 
      RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}], 
   SuperscriptBox["beta", 
    RowBox[{"3", "/", "2"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"2", " ", 
       RowBox[{"Cos", "[", "gamma", "]"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sin", "[", "gamma", "]"}]}], 
   SuperscriptBox["beta", 
    RowBox[{"3", "/", "2"}]]]}]], "Output",
 CellChangeTimes->{{3.777913078285694*^9, 3.7779130872584467`*^9}, 
   3.777913142974852*^9},
 CellLabel->
  "Out[189]=",ExpressionUUID->"c3775b95-a25c-4bcd-bd4a-ffb3bc321dc2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"3", " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "gamma", "]"}], "2"], " ", 
   RowBox[{"(", 
    RowBox[{"gamma", "-", 
     RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"2", " ", 
      RowBox[{"Cos", "[", "gamma", "]"}]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
   RowBox[{"Sin", "[", "gamma", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.777913145251737*^9, 3.77791314671414*^9}, {
  3.777913368568263*^9, 3.7779133794299393`*^9}},
 CellLabel->
  "In[191]:=",ExpressionUUID->"8a026b4b-4e05-4440-b026-9ea689539fda"],

Cell[BoxData[
 RowBox[{
  RowBox[{"3", " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "gamma", "]"}], "2"], " ", 
   RowBox[{"(", 
    RowBox[{"gamma", "-", 
     RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"2", " ", 
      RowBox[{"Cos", "[", "gamma", "]"}]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], " ", 
   RowBox[{"Sin", "[", "gamma", "]"}]}]}]], "Output",
 CellChangeTimes->{3.77791314704688*^9, 3.777913380205298*^9},
 CellLabel->
  "Out[191]=",ExpressionUUID->"a19d484c-4a49-43fd-88fe-2a9c61677b68"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Expand", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777913381789422*^9, 3.777913383332201*^9}},
 CellLabel->
  "In[192]:=",ExpressionUUID->"12915e2b-2ae6-4993-b420-aa802ebca892"],

Cell[BoxData[
 RowBox[{
  RowBox[{"3", 
   RowBox[{"Cos", "[", "gamma", "]"}], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"gamma", " ", 
      RowBox[{"Cos", "[", "gamma", "]"}]}], "-", 
     RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}], "+", 
  SuperscriptBox[
   RowBox[{"Sin", "[", "gamma", "]"}], "3"]}]], "Input",
 CellChangeTimes->{{3.7779134286534767`*^9, 
  3.777913463403455*^9}},ExpressionUUID->"60fc12e7-ce6f-4086-a857-\
852ef1e1ee7c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"g2", " ", "g1", 
       RowBox[{"(", 
        RowBox[{"1", " ", "-", 
         RowBox[{"2", "g0"}]}], ")"}]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["g0", "2"], " ", "g3"}]}], " ", "/.", " ", 
     RowBox[{"g0", " ", "\[Rule]", " ", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sinh", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"-", "beta"}], "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"-", "beta"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777913501492249*^9, 3.7779135139957867`*^9}},
 CellLabel->
  "In[193]:=",ExpressionUUID->"a3462755-d982-46e5-b5ea-fb07ef42d3c8"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"3", " ", 
    SuperscriptBox[
     RowBox[{"Cosh", "[", "gamma", "]"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{"gamma", "-", 
      RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"-", "beta"}]], " ", "beta"}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"2", " ", 
       RowBox[{"Cosh", "[", "gamma", "]"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sinh", "[", "gamma", "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"-", "beta"}]], " ", "beta"}]]}]], "Output",
 CellChangeTimes->{3.777913514767161*^9},
 CellLabel->
  "Out[193]=",ExpressionUUID->"792fa322-62bd-4940-9572-6533b415e8c7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{
   RowBox[{"3", " ", 
    SuperscriptBox[
     RowBox[{"Cosh", "[", "gamma", "]"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{"gamma", "-", 
      RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"2", " ", 
       RowBox[{"Cosh", "[", "gamma", "]"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Cosh", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sinh", "[", "gamma", "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777913519796979*^9, 3.7779135355872803`*^9}},
 CellLabel->
  "In[194]:=",ExpressionUUID->"009bf874-3920-4a82-b40f-08e0cc19707b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"3", " ", 
   RowBox[{"Cosh", "[", "gamma", "]"}], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"gamma", " ", 
      RowBox[{"Cosh", "[", "gamma", "]"}]}], "-", 
     RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}]}], "-", 
  SuperscriptBox[
   RowBox[{"Sinh", "[", "gamma", "]"}], "3"], " "}]], "Input",
 CellChangeTimes->{{3.777913592209903*^9, 
  3.777913677206215*^9}},ExpressionUUID->"dec3562a-807a-41fe-9cdf-\
3ff8f1f64f5b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SeriesCoefficient", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", 
       RowBox[{"Cos", "[", "gamma", "]"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"gamma", " ", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}], "+", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "gamma", "]"}], "3"], "-", 
      RowBox[{
       SuperscriptBox["gamma", "5"], "/", "10"}]}], ")"}], "/", 
    SuperscriptBox["gamma", "7"]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777914680692465*^9, 3.777914697762332*^9}, {
  3.7779148710389023`*^9, 3.7779148763157587`*^9}, {3.777914947136495*^9, 
  3.777914953626079*^9}},
 CellLabel->
  "In[206]:=",ExpressionUUID->"bcd2c2de-bc5a-4479-af72-6991cdda4ba3"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {"0", 
        RowBox[{
         RowBox[{"n", "\[Equal]", 
          RowBox[{"-", "7"}]}], "||", 
         RowBox[{"n", "\[Equal]", 
          RowBox[{"-", "6"}]}], "||", 
         RowBox[{"n", "\[Equal]", 
          RowBox[{"-", "2"}]}]}]},
       {
        FractionBox[
         RowBox[{"3", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "\[ImaginaryI]"}], ")"}], "n"], "+", 
            SuperscriptBox["\[ImaginaryI]", "n"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["2", 
                RowBox[{"8", "+", "n"}]], "+", 
               SuperscriptBox["3", 
                RowBox[{"6", "+", "n"}]]}], ")"}], " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"6", "+", "n"}], ")"}], "!"}]}], "-", 
            RowBox[{
             SuperscriptBox["2", 
              RowBox[{"7", "+", "n"}]], " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"7", "+", "n"}], ")"}], "!"}]}]}], ")"}]}], 
         RowBox[{"8", " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"6", "+", "n"}], ")"}], "!"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"7", "+", "n"}], ")"}], "!"}]}]], 
        RowBox[{
         RowBox[{
          RowBox[{"-", "6"}], "<", "n", "<", 
          RowBox[{"-", "2"}]}], "||", 
         RowBox[{"n", ">", 
          RowBox[{"-", "2"}]}]}]},
       {"0", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}},
      Selectable->True]}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False,
  StripWrapperBoxes->True]], "Output",
 CellChangeTimes->{3.7779146983389997`*^9, 3.7779148772068853`*^9, 
  3.777914954399208*^9},
 CellLabel->
  "Out[206]=",ExpressionUUID->"eb3c11e3-ae8b-4ced-b4a9-ccfce3c12767"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", 
       RowBox[{"Cos", "[", "gamma", "]"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"gamma", " ", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}]}], "+", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "gamma", "]"}], "3"], "-", 
      RowBox[{
       SuperscriptBox["gamma", "5"], "/", "10"}]}], ")"}], "/", 
    SuperscriptBox["gamma", "7"]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "15"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7779147304305964`*^9, 3.7779147754664717`*^9}, {
  3.7779148518791*^9, 3.7779148609803047`*^9}, {3.777915018615185*^9, 
  3.777915022204224*^9}},
 CellLabel->
  "In[208]:=",ExpressionUUID->"64edcea4-75c9-4be3-98fe-04df342ec684"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox["11", "840"], "-", 
   FractionBox[
    RowBox[{"31", " ", 
     SuperscriptBox["gamma", "2"]}], "5040"], "+", 
   FractionBox[
    RowBox[{"5077", " ", 
     SuperscriptBox["gamma", "4"]}], "6652800"], "-", 
   FractionBox[
    RowBox[{"27583", " ", 
     SuperscriptBox["gamma", "6"]}], "518918400"], "+", 
   FractionBox[
    RowBox[{"181541", " ", 
     SuperscriptBox["gamma", "8"]}], "72648576000"], "-", 
   FractionBox[
    RowBox[{"128377", " ", 
     SuperscriptBox["gamma", "10"]}], "1482030950400"], "+", 
   FractionBox[
    RowBox[{"47313449", " ", 
     SuperscriptBox["gamma", "12"]}], "20274183401472000"], "-", 
   FractionBox[
    RowBox[{"23937073", " ", 
     SuperscriptBox["gamma", "14"]}], "473064279367680000"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "16"],
    SeriesData[$CellContext`gamma, 0, {}, 0, 16, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
    Rational[11, 840], 0, 
    Rational[-31, 5040], 0, 
    Rational[5077, 6652800], 0, 
    Rational[-27583, 518918400], 0, 
    Rational[181541, 72648576000], 0, 
    Rational[-128377, 1482030950400], 0, 
    Rational[47313449, 20274183401472000], 0, 
    Rational[-23937073, 473064279367680000]}, 0, 16, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.777914733086005*^9, 3.777914776144541*^9}, 
   3.777914864982841*^9, 3.777915023551112*^9},
 CellLabel->
  "Out[208]=",ExpressionUUID->"908f3e56-9cba-4c52-bbf0-5cae93067a5d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SeriesCoefficient", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", 
       RowBox[{"Cosh", "[", "gamma", "]"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"gamma", " ", 
          RowBox[{"Cosh", "[", "gamma", "]"}]}], "-", 
         RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}]}], "-", 
      SuperscriptBox[
       RowBox[{"Sinh", "[", "gamma", "]"}], "3"], "-", 
      RowBox[{
       SuperscriptBox["gamma", "5"], "/", "10"}]}], ")"}], "/", 
    SuperscriptBox["gamma", "7"]}], " ", ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.777914795156661*^9, {3.777914896982383*^9, 3.7779149372667627`*^9}},
 CellLabel->
  "In[205]:=",ExpressionUUID->"4bf0b7b5-6814-4c3d-b3cf-ce2a3e8f7dd0"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {"0", 
        RowBox[{
         RowBox[{"n", "\[Equal]", 
          RowBox[{"-", "7"}]}], "||", 
         RowBox[{"n", "\[Equal]", 
          RowBox[{"-", "6"}]}], "||", 
         RowBox[{"n", "\[Equal]", 
          RowBox[{"-", "2"}]}]}]},
       {
        RowBox[{"-", 
         FractionBox[
          RowBox[{"3", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], "n"]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox["2", 
                 RowBox[{"8", "+", "n"}]], "+", 
                SuperscriptBox["3", 
                 RowBox[{"6", "+", "n"}]]}], ")"}], " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"6", "+", "n"}], ")"}], "!"}]}], "-", 
             RowBox[{
              SuperscriptBox["2", 
               RowBox[{"7", "+", "n"}]], " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"7", "+", "n"}], ")"}], "!"}]}]}], ")"}]}], 
          RowBox[{"8", " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"6", "+", "n"}], ")"}], "!"}], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"7", "+", "n"}], ")"}], "!"}]}]]}], 
        RowBox[{
         RowBox[{
          RowBox[{"-", "6"}], "<", "n", "<", 
          RowBox[{"-", "2"}]}], "||", 
         RowBox[{"n", ">", 
          RowBox[{"-", "2"}]}]}]},
       {"0", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}},
      Selectable->True]}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False,
  StripWrapperBoxes->True]], "Output",
 CellChangeTimes->{3.777914796120585*^9, 3.777914902418437*^9, 
  3.7779149382327337`*^9},
 CellLabel->
  "Out[205]=",ExpressionUUID->"3bae45d1-8110-4146-9e16-5b04e6afd5ad"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", 
       RowBox[{"Cosh", "[", "gamma", "]"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"gamma", " ", 
          RowBox[{"Cosh", "[", "gamma", "]"}]}], "-", 
         RowBox[{"Sinh", "[", "gamma", "]"}]}], ")"}]}], "-", 
      SuperscriptBox[
       RowBox[{"Sinh", "[", "gamma", "]"}], "3"], " ", "-", 
      RowBox[{
       SuperscriptBox["gamma", "5"], "/", "10"}]}], ")"}], "/", 
    SuperscriptBox["gamma", "7"]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "15"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777914805106237*^9, 3.777914807332179*^9}, {
  3.777914907415257*^9, 3.777914912044272*^9}, {3.777914988954265*^9, 
  3.777914993907111*^9}},
 CellLabel->
  "In[207]:=",ExpressionUUID->"f0eff98f-e09a-4638-8658-8e5e56f2e92c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox["11", "840"]}], "-", 
   FractionBox[
    RowBox[{"31", " ", 
     SuperscriptBox["gamma", "2"]}], "5040"], "-", 
   FractionBox[
    RowBox[{"5077", " ", 
     SuperscriptBox["gamma", "4"]}], "6652800"], "-", 
   FractionBox[
    RowBox[{"27583", " ", 
     SuperscriptBox["gamma", "6"]}], "518918400"], "-", 
   FractionBox[
    RowBox[{"181541", " ", 
     SuperscriptBox["gamma", "8"]}], "72648576000"], "-", 
   FractionBox[
    RowBox[{"128377", " ", 
     SuperscriptBox["gamma", "10"]}], "1482030950400"], "-", 
   FractionBox[
    RowBox[{"47313449", " ", 
     SuperscriptBox["gamma", "12"]}], "20274183401472000"], "-", 
   FractionBox[
    RowBox[{"23937073", " ", 
     SuperscriptBox["gamma", "14"]}], "473064279367680000"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "16"],
    SeriesData[$CellContext`gamma, 0, {}, 0, 16, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
    Rational[-11, 840], 0, 
    Rational[-31, 5040], 0, 
    Rational[-5077, 6652800], 0, 
    Rational[-27583, 518918400], 0, 
    Rational[-181541, 72648576000], 0, 
    Rational[-128377, 1482030950400], 0, 
    Rational[-47313449, 20274183401472000], 0, 
    Rational[-23937073, 473064279367680000]}, 0, 16, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777914807832594*^9, 3.777914912427608*^9, 
  3.777914994480014*^9},
 CellLabel->
  "Out[207]=",ExpressionUUID->"d4f2afee-0fcd-4a2e-8c29-60be7d81248b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"1", "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"7", "+", 
       RowBox[{"2", "n"}]}], ")"}], 
     RowBox[{"2", "^", 
      RowBox[{"(", 
       RowBox[{"7", "+", 
        RowBox[{"2", " ", "n"}]}], ")"}]}]}]}], ")"}], "*", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"3", "^", 
     RowBox[{"(", 
      RowBox[{"6", "+", 
       RowBox[{"2", " ", "n"}]}], ")"}]}], "+", 
    RowBox[{"2", "^", 
     RowBox[{"(", 
      RowBox[{"8", "+", 
       RowBox[{"2", " ", "n"}]}], ")"}]}], "-", "1"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.7779151977960052`*^9, 3.7779152183532543`*^9}},
 CellLabel->
  "In[209]:=",ExpressionUUID->"c2deefeb-9d3a-403e-b14a-317ea4568aa3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    SuperscriptBox["2", 
     RowBox[{"8", "+", 
      RowBox[{"2", " ", "n"}]}]], "+", 
    SuperscriptBox["3", 
     RowBox[{"6", "+", 
      RowBox[{"2", " ", "n"}]}]]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "-", 
    RowBox[{
     SuperscriptBox["2", 
      RowBox[{"7", "+", 
       RowBox[{"2", " ", "n"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{"7", "+", 
       RowBox[{"2", " ", "n"}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7779152188022137`*^9},
 CellLabel->
  "Out[209]=",ExpressionUUID->"351dceb7-7c00-4c38-b224-c70fadf435fc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777915219746973*^9, 3.7779152208421593`*^9}},
 CellLabel->
  "In[210]:=",ExpressionUUID->"9291c4bb-7fa3-4117-99fe-0c72736c05f2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "1"}], "+", 
  RowBox[{"7", " ", 
   SuperscriptBox["2", 
    RowBox[{"7", "+", 
     RowBox[{"2", " ", "n"}]}]]}], "+", 
  SuperscriptBox["2", 
   RowBox[{"8", "+", 
    RowBox[{"2", " ", "n"}]}]], "-", 
  RowBox[{"7", " ", 
   SuperscriptBox["2", 
    RowBox[{"15", "+", 
     RowBox[{"4", " ", "n"}]}]]}], "+", 
  SuperscriptBox["3", 
   RowBox[{"6", "+", 
    RowBox[{"2", " ", "n"}]}]], "-", 
  RowBox[{"7", " ", 
   SuperscriptBox["2", 
    RowBox[{"7", "+", 
     RowBox[{"2", " ", "n"}]}]], " ", 
   SuperscriptBox["3", 
    RowBox[{"6", "+", 
     RowBox[{"2", " ", "n"}]}]]}], "+", 
  RowBox[{
   SuperscriptBox["2", 
    RowBox[{"8", "+", 
     RowBox[{"2", " ", "n"}]}]], " ", "n"}], "-", 
  RowBox[{
   SuperscriptBox["2", 
    RowBox[{"16", "+", 
     RowBox[{"4", " ", "n"}]}]], " ", "n"}], "-", 
  RowBox[{
   SuperscriptBox["2", 
    RowBox[{"8", "+", 
     RowBox[{"2", " ", "n"}]}]], " ", 
   SuperscriptBox["3", 
    RowBox[{"6", "+", 
     RowBox[{"2", " ", "n"}]}]], " ", "n"}]}]], "Output",
 CellChangeTimes->{3.77791522112679*^9},
 CellLabel->
  "Out[210]=",ExpressionUUID->"f0428df5-8c48-4f1c-8450-455fab0bcb3f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7779152221946917`*^9, 3.777915223420147*^9}},
 CellLabel->
  "In[211]:=",ExpressionUUID->"2f6f108d-f7d4-4ca6-b54b-108425c736a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["4", 
      RowBox[{"4", "+", "n"}]], "+", 
     SuperscriptBox["9", 
      RowBox[{"3", "+", "n"}]]}], ")"}]}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    RowBox[{"7", " ", 
     SuperscriptBox["2", 
      RowBox[{"7", "+", 
       RowBox[{"2", " ", "n"}]}]]}], "+", 
    RowBox[{
     SuperscriptBox["4", 
      RowBox[{"4", "+", "n"}]], " ", "n"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.777915223708633*^9},
 CellLabel->
  "Out[211]=",ExpressionUUID->"443d6437-7163-443e-b46d-06861c6987a7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"7", "!"}]], "Input",
 CellChangeTimes->{{3.777915519363674*^9, 3.777915523145276*^9}, {
  3.777915647707512*^9, 3.777915648003036*^9}},
 CellLabel->
  "In[212]:=",ExpressionUUID->"4c599775-915b-4ef1-8f31-c31a53174418"],

Cell[BoxData["5040"], "Output",
 CellChangeTimes->{3.777915648426228*^9},
 CellLabel->
  "Out[212]=",ExpressionUUID->"66fa264a-8529-492d-b604-fba1002cb1b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"3", "^", "6"}], "+", 
    RowBox[{"2", "^", "8"}], "-", "1"}], ")"}], "*", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"7", "*", 
      RowBox[{"2", "^", "7"}]}]}], ")"}], "/", 
   RowBox[{"7", "!"}]}]}]], "Input",
 CellChangeTimes->{{3.7779157069377823`*^9, 3.777915718319971*^9}},
 CellLabel->
  "In[213]:=",ExpressionUUID->"b5bc5e35-f3b4-4b8a-9bd6-57aa85d892e4"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox["7339", "42"]}]], "Output",
 CellChangeTimes->{3.7779157193690767`*^9},
 CellLabel->
  "Out[213]=",ExpressionUUID->"46a1f836-d077-442d-9eaf-2558d9728371"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"-", "\[ImaginaryI]"}], ")"}], "n"], "+", 
      SuperscriptBox["\[ImaginaryI]", "n"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["2", 
          RowBox[{"8", "+", "n"}]], "+", 
         SuperscriptBox["3", 
          RowBox[{"6", "+", "n"}]]}], ")"}], " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"6", "+", "n"}], ")"}], "!"}]}], "-", 
      RowBox[{
       SuperscriptBox["2", 
        RowBox[{"7", "+", "n"}]], " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"7", "+", "n"}], ")"}], "!"}]}]}], ")"}]}], 
   RowBox[{"8", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"6", "+", "n"}], ")"}], "!"}], " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"7", "+", "n"}], ")"}], "!"}]}]], " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "0"}]}]], "Input",
 CellChangeTimes->{{3.777915928813019*^9, 3.777915930467436*^9}},
 CellLabel->
  "In[214]:=",ExpressionUUID->"7e456e2c-59aa-4532-b897-a2259c5baad5"],

Cell[BoxData[
 FractionBox["11", "840"]], "Output",
 CellChangeTimes->{3.777915930819021*^9},
 CellLabel->
  "Out[214]=",ExpressionUUID->"a326046a-798e-484b-b1a1-e2d964432395"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"6", "!"}]], "Input",
 CellChangeTimes->{{3.777915951183169*^9, 3.777915952870685*^9}},
 CellLabel->
  "In[215]:=",ExpressionUUID->"f7f569c9-b17f-4992-9b83-650efc1a8e2e"],

Cell[BoxData["720"], "Output",
 CellChangeTimes->{3.777915953431716*^9},
 CellLabel->
  "Out[215]=",ExpressionUUID->"8bbc7eb2-3849-4acf-baf0-d80374869b54"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"7", "!"}]], "Input",
 CellChangeTimes->{{3.777915957751834*^9, 3.777915958718027*^9}},
 CellLabel->
  "In[216]:=",ExpressionUUID->"a17fbe83-1b99-432a-8b4f-3cf7e9037666"],

Cell[BoxData["5040"], "Output",
 CellChangeTimes->{3.777915959147462*^9},
 CellLabel->
  "Out[216]=",ExpressionUUID->"265e7fbd-649c-4f2d-81e6-1a006b4404ee"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", "^", "6"}], "-", "1"}], ")"}], "-", 
     RowBox[{
      RowBox[{"2", "^", "7"}], "*", "5"}]}], ")"}], "/", 
   RowBox[{"7", "!"}]}], "*", 
  RowBox[{"3", "/", "4"}]}]], "Input",
 CellChangeTimes->{{3.777915973910777*^9, 3.777916005491231*^9}, {
  3.777916137508224*^9, 3.77791613947392*^9}},
 CellLabel->
  "In[221]:=",ExpressionUUID->"1e83c296-ef0d-4cae-a023-b8dc1c4e97b8"],

Cell[BoxData[
 FractionBox["11", "840"]], "Output",
 CellChangeTimes->{{3.777915980746117*^9, 3.7779160059982843`*^9}, 
   3.7779161400512743`*^9},
 CellLabel->
  "Out[221]=",ExpressionUUID->"31e4117f-f6c4-4a5d-8ca4-2776b34caba5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Plug", " ", 
    RowBox[{"gamma", "^", "3"}], " ", "term", " ", "into", " ", "full", " ", 
    "dk", " ", "term", " ", "to", " ", "see", " ", "if", " ", "we", " ", 
    "are", " ", "on", " ", "the", " ", "right", " ", 
    RowBox[{"track", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  FractionBox["1", 
                   RowBox[{"r", " ", "r0"}]], 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["eta", "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g3", " ", "g2"}], "-", " ", 
                    RowBox[{"g1", " ", "h1"}]}], ")"}]}], "+", 
                    RowBox[{"eta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", " ", "g3", " ", "h2"}], "-", 
                    RowBox[{"4", " ", "g2", " ", "h1"}]}], ")"}], " ", "k"}], 
                    "+", 
                    RowBox[{"r0", " ", "eta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"beta", " ", "g3", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", " ", "g2"}], "+", " ", 
                    RowBox[{"g0", " ", "g3"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", "g0", " ", "h6"}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "h6"}], 
                    RowBox[{"(", 
                    RowBox[{"g1", "+", 
                    RowBox[{"beta", " ", "g3"}]}], ")"}]}], "+", 
                    RowBox[{"g2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", "g3"}], "-", "h2"}], ")"}]}]}], " ", ")"}], 
                    " ", "r0", " ", "k"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"h7", "-", 
                    RowBox[{
                    SuperscriptBox["beta", "2"], " ", "g1", " ", 
                    SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
                    SuperscriptBox["r0", "2"]}]}], 
                    RowBox[{"beta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"eta", " ", "g1"}], "+", 
                    RowBox[{"g2", " ", "k"}], "+", 
                    RowBox[{"g0", " ", "r0"}]}], ")"}]}]], " ", ")"}], "-", 
                    FractionBox[
                    RowBox[{" ", 
                    RowBox[{"c17", " ", "c15"}]}], 
                    RowBox[{"beta", " ", "r", " "}]], "-", 
                    FractionBox[
                    RowBox[{" ", 
                    RowBox[{"c1", " ", "c15", " ", "c2"}]}], 
                    SuperscriptBox["r", "2"]]}], ")"}]}], "/.", " ", 
                 RowBox[{"h7", " ", "\[Rule]", " ", 
                  RowBox[{
                   RowBox[{"g1", " ", "g2", " ", 
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"2", " ", "g0"}]}], ")"}]}], " ", "+", " ", 
                   RowBox[{"3", " ", 
                    SuperscriptBox["g0", "2"], " ", "g3"}]}]}]}], " ", "/.", 
                RowBox[{"h6", " ", "\[Rule]", " ", 
                 RowBox[{
                  RowBox[{"2", " ", 
                   SuperscriptBox["g2", "2"]}], "-", 
                  RowBox[{"3", "g1", " ", "g3"}]}]}]}], "/.", " ", 
               RowBox[{"d", " ", "\[Rule]", " ", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"h", "+", 
                   RowBox[{"eta", "*", "g2"}], "+", 
                   RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
                 "beta"}]}]}], "  ", "/.", " ", 
              RowBox[{"h", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
                RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
                RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
             RowBox[{"r", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
               RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
               RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
            RowBox[{"zeta", " ", "\[Rule]", " ", 
             RowBox[{"k", "-", 
              RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
           RowBox[{"h1", " ", "\[Rule]", " ", 
            RowBox[{
             SuperscriptBox["g2", "2"], "-", " ", 
             RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
          RowBox[{"h2", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
            RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"g0", " ", "\[Rule]", " ", 
          RowBox[{"1", "-", " ", 
           RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g1", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"Sin", "[", "gamma", "]"}], "/", 
          RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g2", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], 
      " ", "/.", " ", 
      RowBox[{"g3", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"gamma", "-", 
           RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"sqb", " ", "\[Rule]", " ", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777917046006177*^9, 3.777917108665608*^9}, {
  3.777917143774802*^9, 3.777917146500597*^9}},
 CellLabel->
  "In[227]:=",ExpressionUUID->"903fd82e-66b3-4dde-b6b7-19046cae9560"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"4", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"15", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{"3", " ", "eta", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"8", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[4, 15] $CellContext`beta^Rational[-5, 2]/$CellContext`r0, 
    Rational[-3, 
      8] $CellContext`beta^(-3) $CellContext`eta $CellContext`r0^(-2)}, 5, 7, 
   1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.777917090448139*^9, 3.777917109608383*^9}, 
   3.777917150312286*^9},
 CellLabel->
  "Out[227]=",ExpressionUUID->"fb3da40f-9420-45a8-8af4-6fe6d2ac6ca8"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", ",", " ", 
   RowBox[{"simplify", " ", 
    RowBox[{"gamma", "^", "4"}], " ", 
    RowBox[{"term", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7779171730757437`*^9, 3.777917178944718*^9}},
 CellLabel->
  "In[228]:=",ExpressionUUID->"0a010d8a-a33d-4770-b0ce-1868a7e2e39c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               FractionBox["1", 
                RowBox[{"r", " ", "r0"}]], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", 
                  FractionBox[
                   RowBox[{" ", 
                    RowBox[{"c17", " ", "c15"}]}], 
                   RowBox[{"beta", " ", "r", " "}]]}], "-", 
                 FractionBox[
                  RowBox[{" ", 
                   RowBox[{"c1", " ", "c15", " ", "c2"}]}], 
                  SuperscriptBox["r", "2"]]}], ")"}]}], " ", "/.", 
              RowBox[{"d", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"h", "+", 
                  RowBox[{"eta", "*", "g2"}], "+", 
                  RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
                "beta"}]}]}], "  ", "/.", " ", 
             RowBox[{"h", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
               RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
               RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"r", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
              RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
           RowBox[{"zeta", " ", "\[Rule]", " ", 
            RowBox[{"k", "-", 
             RowBox[{"beta", " ", "r0"}]}]}]}], "  ", "/.", " ", 
          RowBox[{"h1", " ", "\[Rule]", " ", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", " ", 
            RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h2", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
           RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"1", "-", " ", 
          RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"sqb", " ", "\[Rule]", " ", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777917180003272*^9, 3.7779172573557167`*^9}},
 CellLabel->
  "In[233]:=",ExpressionUUID->"19e10508-1177-4422-8894-9161883aed13"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "5"], 
    RowBox[{"6", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{"17", " ", "eta", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"72", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 6] $CellContext`beta^Rational[-5, 2]/$CellContext`r0, 
    Rational[-17, 
      72] $CellContext`beta^(-3) $CellContext`eta $CellContext`r0^(-2)}, 5, 7,
    1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.777917205401053*^9, 3.7779172585286283`*^9}},
 CellLabel->
  "Out[233]=",ExpressionUUID->"7554af23-09a3-44a1-abf3-7d94ae74e96c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Rewriting", " ", 
   RowBox[{"gamma", "^", "4"}], " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777917390700841*^9, 
  3.777917397466275*^9}},ExpressionUUID->"cdd5ef65-4e92-4dc8-988c-\
9e235cbd9b17"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["c15", 
    RowBox[{"beta", " ", 
     SuperscriptBox["r", "3"], " ", "r0"}]]}], 
  RowBox[{"(", " ", 
   RowBox[{
    RowBox[{"c17", " ", "r"}], " ", "+", " ", 
    RowBox[{"c1", " ", "c2", " ", "beta"}]}], " ", ")"}]}]], "Input",
 CellChangeTimes->{{3.7779172787709093`*^9, 3.777917319421549*^9}},
 CellLabel->
  "In[234]:=",ExpressionUUID->"b8d9af63-3dc8-4f9d-a2f9-36e8a6fb43a9"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "h1"}], "+", 
      RowBox[{"h2", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"r", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}]}], 
      "+", 
      RowBox[{"beta", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}]}], ")"}]}], 
   RowBox[{"beta", " ", 
    SuperscriptBox["r", "3"], " ", "r0"}]]}]], "Output",
 CellChangeTimes->{3.777917324178446*^9},
 CellLabel->
  "Out[234]=",ExpressionUUID->"94403157-42c8-4272-aaaa-53a64d7305d0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Expanding", " ", "term", " ", "in", " ", 
   RowBox[{"parentheses", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7779174014199753`*^9, 3.777917409985901*^9}},
 CellLabel->
  "In[240]:=",ExpressionUUID->"c7cd3ac5-8991-47cb-ab39-71bcedf6eb94"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"c17", " ", "r"}], " ", "+", " ", 
      RowBox[{"c1", " ", "c2", " ", "beta"}]}], "    ", "/.", 
     RowBox[{"d", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", "*", "g2"}], "+", 
         RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], "  ",
     "/.", " ", 
    RowBox[{"h", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
      RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
      RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
   RowBox[{"r", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
     RowBox[{"k", " ", "g2"}]}]}]}], "  ", "/.", " ", 
  RowBox[{"zeta", " ", "\[Rule]", " ", 
   RowBox[{"k", "-", 
    RowBox[{"beta", " ", "r0"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777917329517815*^9, 3.7779173662273417`*^9}},
 CellLabel->
  "In[238]:=",ExpressionUUID->"59d9f10f-e760-42de-b479-aeed0146ea7a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "eta"}], " ", "g1"}], "-", 
     RowBox[{"2", " ", "g2", " ", "k"}], "+", "r0", "-", 
     RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{"beta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"g1", " ", 
      RowBox[{"(", 
       RowBox[{"k", "-", 
        RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g3"}], " ", "r0"}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
       RowBox[{"3", " ", "g3", " ", "k"}], "+", 
       RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.777917329854496*^9, 3.777917366573868*^9}},
 CellLabel->
  "Out[238]=",ExpressionUUID->"5fca201c-5019-49a0-99d5-a8b2bf6caba3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "eta"}], " ", "g1"}], "-", 
       RowBox[{"2", " ", "g2", " ", "k"}], "+", "r0", "-", 
       RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}], "+", 
    RowBox[{"beta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "g3"}], " ", "r0"}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
         RowBox[{"3", " ", "g3", " ", "k"}], "+", 
         RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777917344102412*^9, 3.777917355614503*^9}, 
   3.777918426542521*^9},
 CellLabel->
  "In[253]:=",ExpressionUUID->"69cd5119-2782-411b-a4a8-5a08f822667a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["eta", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["g1", "2"]}], "+", 
     RowBox[{"2", " ", "g0", " ", "g2"}]}], ")"}]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g1"}], " ", "g2"}], "+", 
     RowBox[{"3", " ", "g0", " ", "g3"}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{"g1", "-", 
        RowBox[{"g0", " ", "g1"}], "-", 
        RowBox[{"2", " ", "beta", " ", "g1", " ", "g2"}], "-", 
        RowBox[{"beta", " ", "g0", " ", "g3"}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g1", "2"], "+", "g2", "-", 
        RowBox[{"3", " ", "g0", " ", "g2"}], "-", 
        RowBox[{"4", " ", "beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
      "k"}]}], ")"}], " ", "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"g0", "-", 
     SuperscriptBox["g0", "2"], "-", 
     RowBox[{"beta", " ", 
      SuperscriptBox["g1", "2"]}], "+", 
     RowBox[{
      SuperscriptBox["beta", "2"], " ", "g1", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.7779188719996653`*^9},
 CellLabel->
  "Out[253]=",ExpressionUUID->"1dcf4f3a-6bfb-4764-a7db-061e57e72a97"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "beta"}], " ", 
    SuperscriptBox["eta", "2"], " ", 
    SuperscriptBox["g2", "2"]}], "+", 
   RowBox[{"eta", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "h2"}], "+", 
      RowBox[{"2", " ", "g0", " ", "g3"}]}], ")"}], " ", "k"}], " ", "-", 
   RowBox[{"h6", " ", 
    SuperscriptBox["k", "2"]}], "-", " ", 
   RowBox[{"r0", " ", "eta", " ", "beta", " ", 
    RowBox[{"(", " ", 
     RowBox[{"h2", "+", 
      RowBox[{"2", "g0", " ", "g3"}]}], ")"}]}], "+", 
   RowBox[{"2", "beta", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "h1"}], "-", 
      SuperscriptBox["g2", "2"]}], ")"}], "r0", "  ", "k"}], "+", 
   RowBox[{"beta", 
    RowBox[{"(", " ", 
     RowBox[{
      RowBox[{"beta", " ", "g1", " ", "g3"}], "-", "g2"}], ")"}], " ", 
    SuperscriptBox["r0", "2"]}]}]}]], "Input",
 CellChangeTimes->{{3.777918438256908*^9, 3.777918506790072*^9}, {
  3.777918538923192*^9, 
  3.7779188938773317`*^9}},ExpressionUUID->"93381515-822f-4af3-81fb-\
da40ad4975bb"],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{
  3.777918430750407*^9},ExpressionUUID->"f1a8964f-3f2d-4393-822b-\
8a16a7c7fe49"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", ",", " ", 
   RowBox[{
   "simplify", " ", "the", " ", "numerator", " ", "of", " ", "the", " ", 
    RowBox[{"gamma", "^", "4"}], " ", 
    RowBox[{"term", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777917376917398*^9, 
  3.777917387234571*^9}},ExpressionUUID->"2307e081-368f-49b4-a8a8-\
4146faab7268"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "beta"}], " ", 
   SuperscriptBox["eta", "2"], " ", 
   SuperscriptBox["g2", "2"]}], "-", 
  RowBox[{"eta", " ", "k", " ", "h3"}], "-", 
  RowBox[{"h6", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"r0", " ", "eta", " ", "beta", " ", "h2"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"h1", "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"]}]}], ")"}], " ", "beta", " ", "r0", " ", 
   "k"}], "+", 
  RowBox[{"beta", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"beta", " ", "g1", " ", "g3"}], "-", "g2"}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{{3.777917422218171*^9, 3.777917518396378*^9}, {
  3.777917562646975*^9, 3.7779176649785757`*^9}, {3.777917740016032*^9, 
  3.7779177455695057`*^9}, {3.777917782194363*^9, 3.777917826069956*^9}, {
  3.7779178608456573`*^9, 3.777917881924488*^9}, {3.777917919379971*^9, 
  3.777917963453157*^9}, {3.7779179952939043`*^9, 
  3.777918148487872*^9}},ExpressionUUID->"5d74db93-bf7d-4b00-8489-\
4c0bb8388879"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox["1", 
            RowBox[{"r", " ", "r0"}]], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               RowBox[{" ", 
                RowBox[{"c17", " ", "c15"}]}], 
               RowBox[{"beta", " ", "r", " "}]]}], "-", 
             FractionBox[
              RowBox[{" ", 
               RowBox[{"c1", " ", "c15", " ", "c2"}]}], 
              SuperscriptBox["r", "2"]]}], ")"}]}], " ", "+", 
          RowBox[{
           FractionBox["c15", 
            RowBox[{"beta", " ", 
             SuperscriptBox["r", "3"], " ", "r0"}]], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "beta"}], " ", 
              SuperscriptBox["eta", "2"], " ", 
              SuperscriptBox["g2", "2"]}], "+", 
             RowBox[{"eta", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "h2"}], "+", 
                RowBox[{"2", " ", "g0", " ", "g3"}]}], ")"}], " ", "k"}], " ",
              "-", 
             RowBox[{"h6", " ", 
              SuperscriptBox["k", "2"]}], "-", " ", 
             RowBox[{"r0", " ", "eta", " ", "beta", " ", 
              RowBox[{"(", " ", 
               RowBox[{"h2", "+", 
                RowBox[{"2", "g0", " ", "g3"}]}], ")"}]}], "+", 
             RowBox[{"2", "beta", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "h1"}], "-", 
                SuperscriptBox["g2", "2"]}], ")"}], "r0", "  ", "k"}], "+", 
             RowBox[{"beta", 
              RowBox[{"(", " ", 
               RowBox[{
                RowBox[{"beta", " ", "g1", " ", "g3"}], "-", "g2"}], ")"}], 
              " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}]}], "  ", "/.", 
         RowBox[{"h6", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"2", " ", 
            SuperscriptBox["g2", "2"]}], "-", 
           RowBox[{"3", "g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h3", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"3", " ", "g3"}]}]}]}], "/.", 
       RowBox[{"d", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"h", "+", 
           RowBox[{"eta", "*", "g2"}], "+", 
           RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], 
      "  ", "/.", " ", 
      RowBox[{"h", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
        RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
        RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
     RowBox[{"r", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
       RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
    RowBox[{"zeta", " ", "\[Rule]", " ", 
     RowBox[{"k", "-", 
      RowBox[{"beta", " ", "r0"}]}]}]}], "  ", "/.", " ", 
   RowBox[{"h1", " ", "\[Rule]", " ", 
    RowBox[{
     SuperscriptBox["g2", "2"], "-", " ", 
     RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
  RowBox[{"h2", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
    RowBox[{"g0", " ", "g3", " "}]}]}]}]], "Input",
 CellChangeTimes->{{3.7779181817251387`*^9, 3.777918232515469*^9}, {
   3.777918320637574*^9, 3.777918335770747*^9}, 3.777918451318018*^9, 
   3.777918917873155*^9, 3.777919027697812*^9},
 CellLabel->
  "In[257]:=",ExpressionUUID->"265166b8-2be6-46f2-bdd5-bca43b623518"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["g2", "2"], "-", 
         RowBox[{"g1", " ", "g3"}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "g2"}], "-", 
         RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "beta"}], " ", 
       SuperscriptBox["eta", "2"], " ", 
       SuperscriptBox["g2", "2"]}], "+", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g1"}], " ", "g2"}], "+", 
         RowBox[{"3", " ", "g0", " ", "g3"}]}], ")"}], " ", "k"}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          SuperscriptBox["g2", "2"]}], "-", 
         RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}], " ", 
       SuperscriptBox["k", "2"]}], "-", 
      RowBox[{"beta", " ", "eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "g2"}], "+", 
         RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}], "+", 
      RowBox[{"2", " ", "beta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox["g2", "2"]}], "+", 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", 
            RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}], " ", "k", " ", 
       "r0"}], "+", 
      RowBox[{"beta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "g2"}], "+", 
         RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
       SuperscriptBox["r0", "2"]}]}], ")"}]}], 
   RowBox[{"beta", " ", "r0", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}], "3"]}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "eta"}], " ", "g1"}], "-", 
         RowBox[{"2", " ", "g2", " ", "k"}], "+", "r0", "-", 
         RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", 
            RowBox[{"g1", " ", "g3"}]}], ")"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "g2"}], "-", 
            RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"g2", " ", "k"}], "+", 
         RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}], "-", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", 
           RowBox[{"g1", " ", "g3"}]}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], "-", 
           RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", "g0"}], "+", 
        RowBox[{"g1", " ", 
         RowBox[{"(", 
          RowBox[{"k", "-", 
           RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "g3"}], " ", "r0"}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
          RowBox[{"3", " ", "g3", " ", "k"}], "+", 
          RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", "g1"}], "+", 
        RowBox[{"g2", " ", "k"}], "+", 
        RowBox[{"g0", " ", "r0"}]}], ")"}], "2"]]}], 
   RowBox[{"r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{3.777918452846065*^9, 3.777918919066288*^9, 
  3.777919028705825*^9},
 CellLabel->
  "Out[257]=",ExpressionUUID->"aac591f4-46a3-4429-8780-05ea24a53e6f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777918453747294*^9, 3.777918454745262*^9}},
 CellLabel->
  "In[258]:=",ExpressionUUID->"f6a240b5-07c0-4202-9513-f5a26eb05bf9"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"eta", " ", "g1", " ", "g3"}], "+", 
     RowBox[{"g1", " ", "g2", " ", "r0"}], "-", 
     RowBox[{"g0", " ", "g3", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["eta", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g1", "2"], "-", 
        RowBox[{"g2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "g0"}], "+", 
           RowBox[{"beta", " ", "g2"}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{"eta", " ", "g1", " ", 
      RowBox[{"(", "0", ")"}], " ", "r0"}], "+", 
     RowBox[{"r0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "beta", " ", 
         SuperscriptBox["g2", "2"], " ", "k"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "g0"}], ")"}], " ", "g0", " ", "r0"}], 
        "+", 
        RowBox[{"g2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "k"}], "+", 
           RowBox[{"3", " ", "g0", " ", "k"}], "-", 
           RowBox[{"beta", " ", "r0"}]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["g1", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "k"}], "+", 
           RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
  RowBox[{"beta", " ", "r0", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}], "3"]}]]], "Input",
 CellChangeTimes->{{3.777919039876947*^9, 
  3.777919039886498*^9}},ExpressionUUID->"0bf8be6d-1b13-436e-a794-\
e8f4561070d8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Collect", "[", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["eta", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["g1", "2"], "-", 
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g0"}], "+", 
            RowBox[{"beta", " ", "g2"}]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"eta", " ", "g1", " ", 
       RowBox[{"(", "0", ")"}], " ", "r0"}], "+", 
      RowBox[{"r0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "beta", " ", 
          SuperscriptBox["g2", "2"], " ", "k"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "g0"}], ")"}], " ", "g0", " ", "r0"}], 
         "+", 
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "k"}], "+", 
            RowBox[{"3", " ", "g0", " ", "k"}], "-", 
            RowBox[{"beta", " ", "r0"}]}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["g1", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "k"}], "+", 
            RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}], ")"}], ",", 
    RowBox[{"{", 
     RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}], " ", "/.", " ", 
  RowBox[{"g0", " ", "\[Rule]", " ", 
   RowBox[{"1", "-", 
    RowBox[{"beta", " ", "g2"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777918930071932*^9, 3.777918936653644*^9}, {
  3.777919059961619*^9, 3.7779190855368843`*^9}},
 CellLabel->
  "In[261]:=",ExpressionUUID->"9ec01f08-b3b5-4911-8ab1-68246743399f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["eta", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["g1", "2"], "-", 
     RowBox[{"g2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"beta", " ", "g2"}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"beta", " ", "g2"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
  
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["g1", "2"]}], "-", "g2", "+", 
     RowBox[{"2", " ", "beta", " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"3", " ", "g2", " ", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"beta", " ", "g2"}]}], ")"}]}]}], ")"}], " ", "k", " ", 
   "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"beta", " ", 
      SuperscriptBox["g1", "2"]}], "-", 
     RowBox[{"beta", " ", "g2"}], "-", 
     RowBox[{"beta", " ", "g2", " ", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"beta", " ", "g2"}]}], ")"}]}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{
  3.777918936987404*^9, {3.777919060544137*^9, 3.777919085932817*^9}},
 CellLabel->
  "Out[261]=",ExpressionUUID->"61320c05-1274-4da9-88ad-f0fb51287a50"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777919087426619*^9, 3.777919088457358*^9}},
 CellLabel->
  "In[262]:=",ExpressionUUID->"514afb84-a497-434e-b4ad-fe9f8b6d402f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox["g1", "2"], "+", 
    RowBox[{"g2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", 
       RowBox[{"beta", " ", "g2"}]}], ")"}]}]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox["eta", "2"], "+", 
    RowBox[{"r0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "k"}], "+", 
       RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.777919088716353*^9},
 CellLabel->
  "Out[262]=",ExpressionUUID->"1d502a82-833b-48da-8cf2-0ef7140b1166"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g1", "2"], "-", "g2", "-", 
  RowBox[{"g2", " ", "g0"}]}]], "Input",
 CellChangeTimes->{{3.7779191012488203`*^9, 
  3.777919116855586*^9}},ExpressionUUID->"444fea3b-fcfc-4858-9ac9-\
0a34dd4b25f9"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", " ", 
   RowBox[{"we", "'"}], "ve", " ", "expanded", " ", "both", " ", "the", " ", 
   RowBox[{"gamma", "^", "3"}], " ", "and", " ", 
   RowBox[{"gamma", "^", "4"}], " ", 
   RowBox[{"terms", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777919133617063*^9, 3.777919142783224*^9}},
 CellLabel->
  "In[263]:=",ExpressionUUID->"f1d5fa42-1079-4d85-b9ff-060e36755b50"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 FractionBox["1", 
                  RowBox[{"beta", " ", 
                   SuperscriptBox["r", "3"], " ", "r0"}]], 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"r", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["eta", "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g3", " ", "g2"}], "-", " ", 
                    RowBox[{"g1", " ", "h1"}]}], ")"}]}], "+", 
                    RowBox[{"eta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", " ", "g3", " ", "h2"}], "-", 
                    RowBox[{"4", " ", "g2", " ", "h1"}]}], ")"}], " ", "k"}], 
                    "+", 
                    RowBox[{"r0", " ", "eta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"beta", " ", "g3", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", " ", "g2"}], "+", " ", 
                    RowBox[{"g0", " ", "g3"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", "g0", " ", "h6"}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "h6"}], 
                    RowBox[{"(", 
                    RowBox[{"g1", "+", 
                    RowBox[{"beta", " ", "g3"}]}], ")"}]}], "+", 
                    RowBox[{"g2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", "g3"}], "-", "h2"}], ")"}]}]}], " ", ")"}], 
                    " ", "r0", " ", "k"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"h7", "-", 
                    RowBox[{
                    SuperscriptBox["beta", "2"], " ", "g1", " ", 
                    SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
                    SuperscriptBox["r0", "2"]}]}], " ", ")"}]}], "-", 
                   RowBox[{"c15", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "beta"}], " ", 
                    SuperscriptBox["eta", "2"], " ", 
                    SuperscriptBox["g2", "2"]}], "+", 
                    RowBox[{"eta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "h2"}], "+", 
                    RowBox[{"2", " ", "g0", " ", "g3"}]}], ")"}], " ", "k"}], 
                    " ", "-", 
                    RowBox[{"h6", " ", 
                    SuperscriptBox["k", "2"]}], "-", " ", 
                    RowBox[{"r0", " ", "eta", " ", "beta", " ", 
                    RowBox[{"(", " ", 
                    RowBox[{"h2", "+", 
                    RowBox[{"2", "g0", " ", "g3"}]}], ")"}]}], "+", 
                    RowBox[{"2", "beta", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "h1"}], "-", 
                    SuperscriptBox["g2", "2"]}], ")"}], "r0", "  ", "k"}], 
                    "+", 
                    RowBox[{"beta", 
                    RowBox[{"(", " ", 
                    RowBox[{
                    RowBox[{"beta", " ", "g1", " ", "g3"}], "-", "g2"}], 
                    ")"}], " ", 
                    SuperscriptBox["r0", "2"]}]}], ")"}]}]}], ")"}]}], "/.", 
                " ", 
                RowBox[{"h7", " ", "\[Rule]", " ", 
                 RowBox[{
                  RowBox[{"g1", " ", "g2", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"2", " ", "g0"}]}], ")"}]}], " ", "+", " ", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["g0", "2"], " ", "g3"}]}]}]}], " ", "/.", 
               RowBox[{"h6", " ", "\[Rule]", " ", 
                RowBox[{
                 RowBox[{"2", " ", 
                  SuperscriptBox["g2", "2"]}], "-", 
                 RowBox[{"3", "g1", " ", "g3"}]}]}]}], "/.", " ", 
              RowBox[{"d", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"h", "+", 
                  RowBox[{"eta", "*", "g2"}], "+", 
                  RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
                "beta"}]}]}], "  ", "/.", " ", 
             RowBox[{"h", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
               RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
               RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
            RowBox[{"r", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
              RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
           RowBox[{"zeta", " ", "\[Rule]", " ", 
            RowBox[{"k", "-", 
             RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
          RowBox[{"h1", " ", "\[Rule]", " ", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", " ", 
            RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h2", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
           RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"1", "-", " ", 
          RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"sqb", " ", "\[Rule]", " ", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "9"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777919156410618*^9, 3.7779191922628307`*^9}, {
   3.777919329608432*^9, 3.777919350062035*^9}, {3.777919386567658*^9, 
   3.7779193868303337`*^9}, 3.777919825629505*^9, {3.7779198697110853`*^9, 
   3.777919959193862*^9}, {3.777919996150445*^9, 3.7779200030030622`*^9}},
 CellLabel->
  "In[274]:=",ExpressionUUID->"82792f18-5825-416f-a311-3f0581668dca"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"4", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"15", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{"3", " ", "eta", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"8", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"1365", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"784", " ", "k", " ", "r0"}], "+", 
       RowBox[{"628", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"2520", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "3"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"1050", " ", 
          SuperscriptBox["eta", "2"]}], "-", 
         RowBox[{"1114", " ", "k", " ", "r0"}], "+", 
         RowBox[{"813", " ", "beta", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"1440", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "4"], " ", 
       SuperscriptBox["r0", "4"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"28350", " ", 
        SuperscriptBox["eta", "4"]}], "-", 
       RowBox[{"43974", " ", 
        SuperscriptBox["eta", "2"], " ", "k", " ", "r0"}], "+", 
       RowBox[{"31353", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{"8064", " ", 
        SuperscriptBox["k", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"13144", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "+", 
       RowBox[{"5240", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "4"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "9"]}], 
    RowBox[{"30240", " ", 
     SuperscriptBox["beta", 
      RowBox[{"9", "/", "2"}]], " ", 
     SuperscriptBox["r0", "5"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "10"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 10, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[4, 15] $CellContext`beta^Rational[-5, 2]/$CellContext`r0, 
    Rational[-3, 
      8] $CellContext`beta^(-3) $CellContext`eta $CellContext`r0^(-2), 
    Rational[1, 2520] $CellContext`beta^Rational[-7, 2] $CellContext`r0^(-3) (
     1365 $CellContext`eta^2 - 784 $CellContext`k $CellContext`r0 + 
     628 $CellContext`beta $CellContext`r0^2), 
    Rational[-1, 
      1440] $CellContext`beta^(-4) $CellContext`eta $CellContext`r0^(-4) (
     1050 $CellContext`eta^2 - 1114 $CellContext`k $CellContext`r0 + 
     813 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 30240] $CellContext`beta^
     Rational[-9, 2] $CellContext`r0^(-5) (28350 $CellContext`eta^4 - 
     43974 $CellContext`eta^2 $CellContext`k $CellContext`r0 + 
     31353 $CellContext`beta $CellContext`eta^2 $CellContext`r0^2 + 
     8064 $CellContext`k^2 $CellContext`r0^2 - 
     13144 $CellContext`beta $CellContext`k $CellContext`r0^3 + 
     5240 $CellContext`beta^2 $CellContext`r0^4)}, 5, 10, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.77791935077766*^9, 3.777919387398554*^9, 3.7779198271118317`*^9, 
   3.7779199181168633`*^9, {3.777919955914089*^9, 3.777919959697146*^9}, 
   3.777920003881927*^9},
 CellLabel->
  "Out[274]=",ExpressionUUID->"13b9714f-9a5d-4f82-9273-8ddaa276666f"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.777919379053651*^9, 3.777919384308239*^9}, 
   3.777919978487234*^9},ExpressionUUID->"eb4a8be1-f801-4d68-aa65-\
dff4990e1892"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                FractionBox["1", 
                 RowBox[{"r", " ", "r0"}]], 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   RowBox[{" ", 
                    RowBox[{"c1", " ", "c16"}]}], 
                   RowBox[{"r", " "}]], "-", 
                  FractionBox[
                   RowBox[{" ", 
                    RowBox[{"c17", " ", "c15"}]}], 
                   RowBox[{"beta", " ", "r", " "}]], "-", 
                  FractionBox[
                   RowBox[{" ", "c19"}], "beta"], "-", 
                  FractionBox[
                   RowBox[{" ", 
                    RowBox[{"c1", " ", "c15", " ", "c2"}]}], 
                   SuperscriptBox["r", "2"]]}], ")"}]}], " ", "-", " ", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox["1", 
                  RowBox[{"beta", " ", 
                   SuperscriptBox["r", "3"], " ", "r0"}]], 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"r", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["eta", "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g3", " ", "g2"}], "-", " ", 
                    RowBox[{"g1", " ", "h1"}]}], ")"}]}], "+", 
                    RowBox[{"eta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", " ", "g3", " ", "h2"}], "-", 
                    RowBox[{"4", " ", "g2", " ", "h1"}]}], ")"}], " ", "k"}], 
                    "+", 
                    RowBox[{"r0", " ", "eta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"beta", " ", "g3", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", " ", "g2"}], "+", " ", 
                    RowBox[{"g0", " ", "g3"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", "g0", " ", "h6"}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "h6"}], 
                    RowBox[{"(", 
                    RowBox[{"g1", "+", 
                    RowBox[{"beta", " ", "g3"}]}], ")"}]}], "+", 
                    RowBox[{"g2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", "g3"}], "-", "h2"}], ")"}]}]}], " ", ")"}], 
                    " ", "r0", " ", "k"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"h7", "-", 
                    RowBox[{
                    SuperscriptBox["beta", "2"], " ", "g1", " ", 
                    SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
                    SuperscriptBox["r0", "2"]}]}], " ", ")"}]}], "-", 
                   RowBox[{"c15", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "beta"}], " ", 
                    SuperscriptBox["eta", "2"], " ", 
                    SuperscriptBox["g2", "2"]}], "+", 
                    RowBox[{"eta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "h2"}], "+", 
                    RowBox[{"2", " ", "g0", " ", "g3"}]}], ")"}], " ", "k"}], 
                    " ", "-", 
                    RowBox[{"h6", " ", 
                    SuperscriptBox["k", "2"]}], "-", " ", 
                    RowBox[{"r0", " ", "eta", " ", "beta", " ", 
                    RowBox[{"(", " ", 
                    RowBox[{"h2", "+", 
                    RowBox[{"2", "g0", " ", "g3"}]}], ")"}]}], "+", 
                    RowBox[{"2", "beta", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "h1"}], "-", 
                    SuperscriptBox["g2", "2"]}], ")"}], "r0", "  ", "k"}], 
                    "+", 
                    RowBox[{"beta", 
                    RowBox[{"(", " ", 
                    RowBox[{
                    RowBox[{"beta", " ", "g1", " ", "g3"}], "-", "g2"}], 
                    ")"}], " ", 
                    SuperscriptBox["r0", "2"]}]}], ")"}]}]}], ")"}]}], 
                ")"}]}], "/.", " ", 
              RowBox[{"h7", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"g1", " ", "g2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"2", " ", "g0"}]}], ")"}]}], " ", "+", " ", 
                RowBox[{"3", " ", 
                 SuperscriptBox["g0", "2"], " ", "g3"}]}]}]}], " ", "/.", 
             RowBox[{"h6", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"2", " ", 
                SuperscriptBox["g2", "2"]}], "-", 
               RowBox[{"3", "g1", " ", "g3"}]}]}]}], "/.", " ", 
            RowBox[{"d", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"h", "+", 
                RowBox[{"eta", "*", "g2"}], "+", 
                RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
              "beta"}]}]}], "  ", "/.", " ", 
           RowBox[{"h", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
             RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
          RowBox[{"r", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
            RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
         RowBox[{"zeta", " ", "\[Rule]", " ", 
          RowBox[{"k", "-", 
           RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h1", " ", "\[Rule]", " ", 
         RowBox[{
          SuperscriptBox["g2", "2"], "-", " ", 
          RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"h2", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
         RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g0", " ", "\[Rule]", " ", 
       RowBox[{"1", "-", " ", 
        RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g1", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "gamma", "]"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g2", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
    " ", 
   RowBox[{"g3", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"gamma", "-", 
        RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
  RowBox[{"sqb", " ", "\[Rule]", " ", 
   RowBox[{"Sqrt", "[", "beta", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7780015537742558`*^9, 3.7780015615057898`*^9}, {
  3.778001599499022*^9, 3.778001616724964*^9}},
 CellLabel->
  "In[357]:=",ExpressionUUID->"9a398aa7-a5ea-466d-8fbd-2e467cb70738"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.778001619676239*^9, 3.778001621644342*^9}},
 CellLabel->
  "In[358]:=",ExpressionUUID->"6b320247-9b79-43a9-91d6-1e52d5127dd7"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.778001621887969*^9},
 CellLabel->
  "Out[358]=",ExpressionUUID->"2f866706-a4df-4e3d-8df3-9d0852f1ee30"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.778001564671391*^9, 
  3.778001566525075*^9}},ExpressionUUID->"d1bd78c0-e098-4645-8e63-\
7b0556112c4a"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Work", " ", "on", " ", 
   RowBox[{"dv0", ".", "v0"}], " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.778117270480092*^9, 3.778117275669566*^9}, {
  3.7781174581032133`*^9, 
  3.778117458452935*^9}},ExpressionUUID->"e8f8b9b1-dc6d-4c67-a2d0-\
7a4e859fdf65"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                FractionBox[
                 RowBox[{"k", " ", "v0"}], 
                 SuperscriptBox["r", "2"]], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    FractionBox["1", "beta"], 
                    RowBox[{"(", " ", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["eta", "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", " ", "h1"}], "-", 
                    RowBox[{"g2", " ", "g3"}]}], ")"}]}], "+", 
                    RowBox[{"eta", " ", "k", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", "g2", " ", "h1"}], "-", 
                    RowBox[{"3", " ", "h2", " ", "g3"}]}], ")"}]}], "+", 
                    RowBox[{"r0", " ", "eta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", "g0", " ", "h1"}], "-", 
                    RowBox[{"2", " ", "g1", " ", "g3"}]}], " ", ")"}]}], "+", 
                    
                    RowBox[{"3", "r0", " ", "k", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"g1", "+", 
                    RowBox[{"beta", " ", "g3"}]}], ")"}], "h1"}], "-", 
                    RowBox[{"g3", " ", "g2"}]}], ")"}]}], " ", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g0", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", " ", "g2"}], "-", 
                    RowBox[{"3", "g0", " ", "g3"}]}], ")"}]}], "-", 
                    RowBox[{"beta", " ", "g1", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["g2", "2"], "+", 
                    RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}], 
                    SuperscriptBox["r0", "2"]}]}], ")"}]}], ")"}], "+", 
                  RowBox[{
                   FractionBox["c15", 
                    RowBox[{"beta", " ", "r"}]], 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", " ", "beta"}], " ", 
                    SuperscriptBox["g2", "2"], " ", 
                    SuperscriptBox["eta", "2"]}], "+", 
                    RowBox[{"eta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "g1"}], " ", "g2"}], "+", 
                    RowBox[{"3", " ", "g0", " ", "g3"}]}], ")"}], " ", "k"}], 
                    "-", 
                    RowBox[{"h6", " ", 
                    SuperscriptBox["k", "2"]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], "  ", "eta", " ", "g1", " ", "g2"}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["g2", "2"], "-", 
                    RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}], " ", 
                    "k"}]}], ")"}], " ", "beta", " ", "r0"}], "-", 
                    RowBox[{"beta", " ", 
                    SuperscriptBox["g1", "2"], " ", 
                    SuperscriptBox["r0", "2"]}]}], ")"}]}]}], ")"}]}], ")"}], 
              "/.", " ", 
              RowBox[{"h6", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"2", " ", 
                 RowBox[{"g2", "^", "2"}]}], "-", 
                RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], " ", "/.", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.77811727708661*^9, 3.778117294112233*^9}, 
   3.7781173266059027`*^9, {3.778117360533641*^9, 3.7781174001930733`*^9}, {
   3.778117462470706*^9, 3.778117491188815*^9}, {3.778117542970717*^9, 
   3.7781176077541933`*^9}, 3.7781183347771683`*^9, {3.778118384980049*^9, 
   3.778118393333744*^9}, {3.778118431686782*^9, 3.778118467880189*^9}, {
   3.7781185200571404`*^9, 3.778118700715032*^9}, {3.7781187494578657`*^9, 
   3.7781188329557533`*^9}, {3.778119610191146*^9, 3.77811961968288*^9}},
 CellLabel->"In[91]:=",ExpressionUUID->"e314cf52-2407-4348-b15e-78b2c86690f1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", 
      RowBox[{"(", 
       RowBox[{"k", " ", "v0"}], ")"}], " ", 
      SuperscriptBox["gamma", "5"]}], 
     RowBox[{"5", " ", 
      SuperscriptBox["beta", 
       RowBox[{"5", "/", "2"}]]}]]}], "+", 
   FractionBox[
    RowBox[{"eta", " ", "k", " ", "v0", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{
     SuperscriptBox["beta", "3"], " ", "r0"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-3, 5] $CellContext`beta^
     Rational[-5, 
       2] $CellContext`k $CellContext`v0, $CellContext`beta^(-3) \
$CellContext`eta $CellContext`k $CellContext`r0^(-1) $CellContext`v0}, 5, 7, 
   1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.778117340706365*^9, 3.778117396061256*^9, 3.778117466247406*^9, {
   3.77811754486269*^9, 3.7781176121573753`*^9}, 3.778118338921484*^9, {
   3.778118405364531*^9, 3.778118433255849*^9}, {3.7781185108304453`*^9, 
   3.778118615017345*^9}, {3.7781186532412767`*^9, 3.778118682883047*^9}, 
   3.7781187534626007`*^9, 3.778118794042375*^9, {3.77811882524444*^9, 
   3.778118833975168*^9}, 3.778119620211671*^9},
 CellLabel->"Out[91]=",ExpressionUUID->"b6e79174-9584-4fa4-9db6-1909bce11d37"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Work", " ", "on", " ", "this", " ", "term", " ", 
   RowBox[{"first", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.778117640591825*^9, 3.778117644682769*^9}},
 CellLabel->"In[56]:=",ExpressionUUID->"99ebafeb-99fc-4528-94f4-fecbf97aa260"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{" ", 
         RowBox[{"r", " ", "c19"}]}], "beta"], "-", 
       RowBox[{"d", " ", "c16"}]}], " ", "/.", " ", 
      RowBox[{"h2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
        RowBox[{"g0", " ", "g3"}]}]}]}], "/.", " ", 
     RowBox[{"h1", " ", "\[Rule]", " ", 
      RowBox[{
       SuperscriptBox["g2", "2"], "-", " ", 
       RowBox[{"g1", " ", "g3"}]}]}]}], "/.", " ", 
    RowBox[{"d", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"h", "+", 
        RowBox[{"eta", "*", "g2"}], "+", 
        RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], "  ", 
   "/.", " ", 
   RowBox[{"h", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
     RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
  RowBox[{"r", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
    RowBox[{"k", " ", "g2"}]}]}]}]], "Input",
 CellChangeTimes->{{3.77811764631584*^9, 3.778117679118423*^9}},
 CellLabel->"In[59]:=",ExpressionUUID->"5282850a-b895-46b9-a9e0-73c9a512edd8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
       RowBox[{"3", " ", "g3", " ", "k"}], "+", 
       RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], "-", 
          RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{"g1", "+", 
          RowBox[{"beta", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}]}], 
    "beta"]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "eta", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["g2", "2"], "-", 
         RowBox[{"g1", " ", "g3"}]}], ")"}]}], "+", 
      RowBox[{"3", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "g2"}], "-", 
         RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}]}], 
   "beta"]}]], "Output",
 CellChangeTimes->{{3.778117656796199*^9, 3.778117679590742*^9}},
 CellLabel->"Out[59]=",ExpressionUUID->"4afe0b3a-93c4-4481-b106-bf122428526e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"4", " ", "eta", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["g2", "2"], "-", 
          RowBox[{"g1", " ", "g3"}]}], ")"}]}], "+", 
       RowBox[{"3", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], "-", 
          RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
       RowBox[{"3", " ", "g3", " ", "k"}], "+", 
       RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], "-", 
          RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{"g1", "+", 
          RowBox[{"beta", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778117686766492*^9, 3.778117721378083*^9}},
 CellLabel->"In[61]:=",ExpressionUUID->"c2b6e57b-c430-4c16-95e5-f238dec8c103"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["eta", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "g2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "-", 
        RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
     RowBox[{"4", " ", "g1", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", 
        RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "3"}], " ", "g3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "-", 
        RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
     RowBox[{"4", " ", "g2", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", 
        RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", "g1", " ", "g2", " ", 
         RowBox[{"(", 
          RowBox[{"g1", "+", 
           RowBox[{"beta", " ", "g3"}]}], ")"}]}], "+", 
        RowBox[{"2", " ", "g1", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], "-", 
           RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
        RowBox[{"4", " ", "g0", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", 
           RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "3"}], " ", "g1", " ", "g3", " ", 
         RowBox[{"(", 
          RowBox[{"g1", "+", 
           RowBox[{"beta", " ", "g3"}]}], ")"}]}], "+", 
        RowBox[{"3", " ", "g2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], "-", 
           RowBox[{"g0", " ", "g3"}]}], ")"}]}]}], ")"}], " ", "k"}]}], ")"}],
    " ", "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["g1", "2"]}], " ", 
      RowBox[{"(", 
       RowBox[{"g1", "+", 
        RowBox[{"beta", " ", "g3"}]}], ")"}]}], "+", 
     RowBox[{"3", " ", "g0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "-", 
        RowBox[{"g0", " ", "g3"}]}], ")"}]}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.778117721839859*^9},
 CellLabel->"Out[61]=",ExpressionUUID->"4c292fe4-8395-4d1d-8732-f5774c66294f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.778117727011956*^9, 3.7781177280693893`*^9}},
 CellLabel->"In[62]:=",ExpressionUUID->"4e4ed496-0be0-41c4-a4da-a7ebf587409a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   SuperscriptBox["eta", "2"], " ", "g2", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "g2"}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"2", "+", "g0"}], ")"}], "g3"}]}], ")"}]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", 
      SuperscriptBox["g2", "3"], " ", "k"}], "+", 
     RowBox[{"4", " ", "g0", " ", 
      SuperscriptBox["g2", "2"], " ", "r0"}], "-", 
     RowBox[{"g1", " ", "g2", " ", "g3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"7", " ", "k"}], "+", 
        RowBox[{"2", " ", "beta", " ", "r0"}]}], ")"}]}], "+", 
     RowBox[{"3", " ", "g0", " ", "g3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g3", " ", "k"}], "-", 
        RowBox[{"2", " ", "g1", " ", "r0"}]}], ")"}]}]}], ")"}]}], "-", 
  RowBox[{"r0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["g1", "3"], " ", "r0"}], "+", 
     RowBox[{
      SuperscriptBox["g1", "2"], " ", "g3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", "k"}], "+", 
        RowBox[{"beta", " ", "r0"}]}], ")"}]}], "+", 
     RowBox[{"3", " ", "g0", " ", "g3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g2", " ", "k"}], "+", 
        RowBox[{"g0", " ", "r0"}]}], ")"}]}], "-", 
     RowBox[{"3", " ", "g1", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["g2", "2"], " ", "k"}], "-", 
        RowBox[{"beta", " ", 
         SuperscriptBox["g3", "2"], " ", "k"}], "+", 
        RowBox[{"g0", " ", "g2", " ", "r0"}]}], ")"}]}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.778117745756011*^9, 
  3.778117820471574*^9}},ExpressionUUID->"0f7d2a8a-1c05-40c8-a82b-\
d84dd64c7354"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.778117708657898*^9, 
  3.77811771979405*^9}},ExpressionUUID->"27c9ff16-860c-4095-a50c-\
cd64cec52e8b"],

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778117892921007*^9, 3.778117898130884*^9}},
 CellLabel->"In[63]:=",ExpressionUUID->"c1059762-99ec-45b6-b745-07774d562696"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   SuperscriptBox["eta", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["g1", "2"], " ", "g3"}], "+", 
     RowBox[{"g0", " ", "g2", " ", "g3"}]}], ")"}]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", "g2", " ", "h1"}], "-", 
     RowBox[{"3", " ", "h2", " ", "g3"}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", "g0", " ", "h1"}], "-", 
        RowBox[{"2", " ", "g1", " ", "g3"}]}], " ", ")"}]}], "+", 
     RowBox[{"3", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"g1", "+", 
           RowBox[{"beta", " ", "g3"}]}], ")"}], " ", "h1"}], "-", 
        RowBox[{"g3", " ", "g2"}]}], ")"}], " ", "k"}]}], ")"}], " ", "r0"}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["g1", "3"]}], "+", 
     RowBox[{"3", " ", "g0", " ", "h2"}], "-", 
     RowBox[{"beta", " ", 
      SuperscriptBox["g1", "2"], " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{{3.778117908707553*^9, 
  3.7781182771247663`*^9}},ExpressionUUID->"dc212215-367a-48b2-9e4a-\
b3671ab4925f"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", " ", "work", " ", "on", " ", "this", " ", "other", " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.778119358498917*^9, 3.7781193630810204`*^9}},
 CellLabel->"In[85]:=",ExpressionUUID->"1886e415-b6c8-4841-868b-fcf08c90c468"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"d", " ", "c2"}], "r"], "-", 
     FractionBox[
      RowBox[{"c18", " "}], 
      RowBox[{"beta", " "}]]}], "/.", " ", 
    RowBox[{"d", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"h", "+", 
        RowBox[{"eta", "*", "g2"}], "+", 
        RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], "  ", 
   "/.", " ", 
   RowBox[{"h", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
     RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
  RowBox[{"r", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
    RowBox[{"k", " ", "g2"}]}]}]}]], "Input",
 CellChangeTimes->{3.778119379570446*^9},
 CellLabel->"In[86]:=",ExpressionUUID->"3075b9e0-4a36-4394-a9db-e5680120df52"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"2", " ", "g2", " ", "k"}]}], "beta"]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
      RowBox[{"3", " ", "g3", " ", "k"}], "+", 
      RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
   RowBox[{"beta", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{3.778119380118161*^9},
 CellLabel->"Out[86]=",ExpressionUUID->"3e459917-1bb1-43da-9fab-2e7a8529f819"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
       RowBox[{"3", " ", "g3", " ", "k"}], "+", 
       RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}]}], 
   RowBox[{"beta", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]], "/.", " ", 
  RowBox[{"zeta", " ", "\[Rule]", " ", 
   RowBox[{"k", "-", 
    RowBox[{"beta", " ", "r0", " "}]}]}]}]], "Input",
 CellChangeTimes->{{3.778119391073304*^9, 3.7781194324182673`*^9}},
 CellLabel->"In[89]:=",ExpressionUUID->"7d54a88b-bf29-42e2-b475-d0ab206c319b"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}]}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
      RowBox[{"3", " ", "g3", " ", "k"}], "+", 
      RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", 
       RowBox[{"(", 
        RowBox[{"k", "-", 
         RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}], 
  RowBox[{"beta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}]}]]], "Output",
 CellChangeTimes->{{3.778119416721246*^9, 3.778119433095357*^9}},
 CellLabel->"Out[89]=",ExpressionUUID->"a106c30b-93bf-4c9a-9b44-a45a60c3d4d3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", "g1"}], "+", 
        RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}]}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
       RowBox[{"3", " ", "g3", " ", "k"}], "+", 
       RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778119441904483*^9, 3.7781194482223186`*^9}},
 CellLabel->"In[90]:=",ExpressionUUID->"f43ccea8-0fdc-4aa8-96dc-bcd88fa5ff49"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", " ", "beta"}], " ", 
   SuperscriptBox["g2", "2"], " ", 
   SuperscriptBox["eta", "2"]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g1"}], " ", "g2"}], "+", 
     RowBox[{"3", " ", "g0", " ", "g3"}]}], ")"}], " ", "k"}], "-", 
  RowBox[{"h6", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], "  ", "eta", " ", "g1", " ", "g2"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", 
        RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}], " ", "k"}]}], ")"}], 
   " ", "beta", " ", "r0"}], "-", 
  RowBox[{"beta", " ", 
   SuperscriptBox["g1", "2"], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{{3.7781194543510113`*^9, 3.7781194799494333`*^9}, {
  3.7781195173038673`*^9, 
  3.778119589689101*^9}},ExpressionUUID->"6b6c56ed-d9b3-4e07-8e95-\
21f53a215a7d"]
},
WindowSize->{1108, 761},
WindowMargins->{{24, Automatic}, {Automatic, 0}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[400, 13, 2590, 65, 220, "Input",ExpressionUUID->"53329b6c-a80c-45ac-ae62-f6fb243392bd"],
Cell[CellGroupData[{
Cell[3015, 82, 1276, 33, 50, "Input",ExpressionUUID->"48462b44-b891-42a8-998f-37b74e902302"],
Cell[4294, 117, 990, 29, 68, "Output",ExpressionUUID->"007fec1e-964d-47af-8413-174e6262f253"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5321, 151, 1432, 43, 91, "Input",ExpressionUUID->"ec64950c-8ed3-4bc5-92a5-293069313a0b"],
Cell[6756, 196, 2091, 67, 113, "Output",ExpressionUUID->"e6ef562f-a206-4d0b-9f13-3ec202582435"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8884, 268, 503, 12, 30, "Input",ExpressionUUID->"95296aac-8480-48bf-b720-90060933f9ed"],
Cell[9390, 282, 451, 10, 53, "Output",ExpressionUUID->"123d8237-46b4-48b0-8974-34ffbab55809"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9878, 297, 276, 5, 30, "Input",ExpressionUUID->"6e130959-e5af-4389-aed5-d86ced425512"],
Cell[10157, 304, 219, 4, 52, "Output",ExpressionUUID->"406115b4-8f74-46dc-acaf-b876b2b2a5aa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10413, 313, 357, 8, 52, "Input",ExpressionUUID->"91ea3aee-9af1-4a5e-ae59-754efdc1399b"],
Cell[10773, 323, 269, 6, 34, "Output",ExpressionUUID->"a56b79d7-6bdf-40ad-9a00-6e9f7f1e5bfd"]
}, Open  ]],
Cell[11057, 332, 709, 16, 30, "Input",ExpressionUUID->"2d884b31-7a55-4520-bbb8-26a9cd31ce07"],
Cell[CellGroupData[{
Cell[11791, 352, 2006, 50, 90, "Input",ExpressionUUID->"a6c48c41-52a5-424e-8082-2ada96dd916c"],
Cell[13800, 404, 4861, 139, 271, "Output",ExpressionUUID->"091b2f2f-9a6f-4851-b1aa-21488748abe7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18698, 548, 305, 7, 30, "Input",ExpressionUUID->"c50ee62d-22cf-45d5-85af-1fc4bc50ccb2"],
Cell[19006, 557, 7077, 219, 496, "Output",ExpressionUUID->"4ff85c13-bc84-4a87-85b5-ec7e3529ddf9"]
}, Open  ]],
Cell[26098, 779, 522, 15, 52, "Input",ExpressionUUID->"5016d470-2559-42c7-9097-a15b73e2e0c2"],
Cell[CellGroupData[{
Cell[26645, 798, 3107, 89, 188, "Input",ExpressionUUID->"86606400-4dcd-4a36-bd1d-3a1e6bba1e6b"],
Cell[29755, 889, 3294, 101, 200, "Output",ExpressionUUID->"ce12a99b-ccf1-4555-9b32-d1fd5d706668"]
}, Open  ]],
Cell[33064, 993, 257, 5, 30, "Input",ExpressionUUID->"93376667-ae79-4f2c-bce9-f4e105374de8"],
Cell[CellGroupData[{
Cell[33346, 1002, 2296, 66, 134, "Input",ExpressionUUID->"4c137373-3aac-4897-9d22-41fe9976ebba"],
Cell[35645, 1070, 2608, 79, 137, "Output",ExpressionUUID->"5c7b2fd2-e603-4297-aefa-9b395be332b7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38290, 1154, 9678, 268, 559, "Input",ExpressionUUID->"d4d207ae-e603-472b-bd2a-7645ab9a44c9"],
Cell[47971, 1424, 8608, 257, 460, "Output",ExpressionUUID->"f288b571-f368-42d1-852f-bad5a0e3e672"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56616, 1686, 1723, 45, 241, "Input",ExpressionUUID->"e02dea29-e385-4877-ac38-3d2c0bae8f47"],
Cell[58342, 1733, 383, 7, 34, "Output",ExpressionUUID->"d7ca75b8-d403-4174-ba18-422fa1c1d812"],
Cell[58728, 1742, 411, 8, 34, "Output",ExpressionUUID->"4d71ebce-b3d7-4b73-b7a9-bde956d98ea2"],
Cell[59142, 1752, 433, 9, 34, "Output",ExpressionUUID->"822aadc9-8d08-4c3f-b1f7-ae5a18ac93af"],
Cell[59578, 1763, 409, 8, 34, "Output",ExpressionUUID->"c346ff59-b957-48c6-8b1d-6e3a12850f20"],
Cell[59990, 1773, 501, 11, 34, "Output",ExpressionUUID->"d9447fdb-3938-4067-810b-a1a39ba533fb"],
Cell[60494, 1786, 414, 8, 34, "Output",ExpressionUUID->"37264df5-78cd-4e21-b3ae-eaf9f169e012"],
Cell[60911, 1796, 418, 8, 34, "Output",ExpressionUUID->"206e4f18-5b62-493d-8aee-35e4235a3bab"],
Cell[61332, 1806, 431, 8, 34, "Output",ExpressionUUID->"a21972ad-5f23-4e7d-9f25-ea6d01c9ad2d"]
}, Open  ]],
Cell[61778, 1817, 4175, 114, 135, "Input",ExpressionUUID->"71c53a07-8e97-43ef-b6c9-30d71d21b7fa"],
Cell[CellGroupData[{
Cell[65978, 1935, 3489, 106, 135, "Input",ExpressionUUID->"f5180bf8-ecbd-4df5-a51e-7520cd5ab05b"],
Cell[69470, 2043, 1337, 24, 153, "Output",ExpressionUUID->"04c50a10-4aee-4151-8e3e-3f19f5ba2e71"]
}, Open  ]],
Cell[70822, 2070, 451, 10, 30, "Input",ExpressionUUID->"737a2b71-af6e-49a2-8fb6-9769070ef2d4"],
Cell[71276, 2082, 413, 6, 30, "Input",ExpressionUUID->"0d694713-5b03-4982-b4f9-2a9b50a5f345"],
Cell[CellGroupData[{
Cell[71714, 2092, 208, 3, 30, "Input",ExpressionUUID->"a67b980e-55f8-4a08-9d06-b4a7788763d2"],
Cell[71925, 2097, 265, 4, 34, "Output",ExpressionUUID->"45a6d038-d7f2-492b-bcd1-79446806c8ed"]
}, Open  ]],
Cell[72205, 2104, 560, 13, 73, "Input",ExpressionUUID->"a46711ac-65c6-4829-91fb-6405e4ad26f3"],
Cell[CellGroupData[{
Cell[72790, 2121, 3565, 89, 148, "Input",ExpressionUUID->"86d1a864-7d22-426f-bb4c-c6b6d158ded5"],
Cell[76358, 2212, 3696, 96, 109, "Output",ExpressionUUID->"8985ede8-70a7-4106-871c-25dc819df236"]
}, Open  ]],
Cell[80069, 2311, 152, 3, 30, "Input",ExpressionUUID->"878bda98-d741-4562-9619-13c15bb7c0f0"],
Cell[80224, 2316, 308, 7, 30, "Input",ExpressionUUID->"df524ed0-b4a0-47da-b22d-493b5b1dc27f"],
Cell[CellGroupData[{
Cell[80557, 2327, 2985, 77, 127, "Input",ExpressionUUID->"e5b41157-c9dc-4252-a9ac-5a97b2f96300"],
Cell[83545, 2406, 2340, 66, 62, "Output",ExpressionUUID->"fe596e7f-2334-4664-b84b-a90119f9788e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[85922, 2477, 2803, 74, 127, "Input",ExpressionUUID->"38ea7874-b411-4c27-935d-bdce51318a13"],
Cell[88728, 2553, 1989, 56, 57, "Output",ExpressionUUID->"9af0fd31-4dd5-4c99-a339-f1734955f7da"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90754, 2614, 2720, 72, 127, "Input",ExpressionUUID->"ecf87cf4-5f5e-4036-a259-e8bbb6952991"],
Cell[93477, 2688, 2248, 63, 57, "Output",ExpressionUUID->"49ca50cc-de55-49e4-a194-ea012072eb03"]
}, Open  ]],
Cell[CellGroupData[{
Cell[95762, 2756, 2989, 77, 127, "Input",ExpressionUUID->"cc99937e-6036-4d36-ae4d-04e64f7cd29d"],
Cell[98754, 2835, 2134, 61, 62, "Output",ExpressionUUID->"5d2af547-f6d0-44f2-8adf-59c0bffa436b"]
}, Open  ]],
Cell[100903, 2899, 657, 15, 52, "Input",ExpressionUUID->"468e719a-4101-4fa2-a817-aa4238b4c491"],
Cell[CellGroupData[{
Cell[101585, 2918, 3076, 79, 127, "Input",ExpressionUUID->"68409971-d333-4d5d-9f15-1225842b4549"],
Cell[104664, 2999, 976, 29, 60, "Output",ExpressionUUID->"a38f62ee-ee4c-421e-9600-3d54da06408c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105677, 3033, 3218, 82, 127, "Input",ExpressionUUID->"2118b575-40a2-426c-9478-d0214ba00782"],
Cell[108898, 3117, 974, 29, 60, "Output",ExpressionUUID->"da66a774-749b-426c-b3ed-39e60dd8395c"]
}, Open  ]],
Cell[109887, 3149, 379, 8, 52, "Input",ExpressionUUID->"e18c7694-f215-4d35-9c20-3bd994b12e5d"],
Cell[CellGroupData[{
Cell[110291, 3161, 1615, 47, 71, "Input",ExpressionUUID->"5a2d7629-758d-4c20-905a-9ec5d389a1a3"],
Cell[111909, 3210, 1602, 51, 74, "Output",ExpressionUUID->"b0f7eaf9-3eaa-4224-872d-acf7971d5e54"]
}, Open  ]],
Cell[CellGroupData[{
Cell[113548, 3266, 1734, 52, 72, "Input",ExpressionUUID->"cee69f53-3c9a-4ad4-ac77-22c156881d0c"],
Cell[115285, 3320, 2284, 57, 100, "Output",ExpressionUUID->"93cb2196-dc22-42a9-b41c-2388275d2538"]
}, Open  ]],
Cell[CellGroupData[{
Cell[117606, 3382, 2308, 54, 98, "Input",ExpressionUUID->"c73369af-305f-49be-bd96-2ce54da78508"],
Cell[119917, 3438, 2066, 60, 83, "Output",ExpressionUUID->"b1acc06f-47b7-4813-81af-6c0e7278aa76"]
}, Open  ]],
Cell[121998, 3501, 338, 7, 30, "Input",ExpressionUUID->"33bc5506-35d9-424d-99cd-40b4dd4207dc"],
Cell[122339, 3510, 334, 8, 30, "Input",ExpressionUUID->"60c80cf8-ae42-4fe1-a8ac-b417c71b574c"],
Cell[122676, 3520, 2033, 55, 54, "Input",ExpressionUUID->"f5315b7f-b984-49fb-ab63-7c3012540fde"],
Cell[124712, 3577, 423, 10, 52, "Input",ExpressionUUID->"3fd2a269-4db8-4498-81c5-4afee3c1a633"],
Cell[CellGroupData[{
Cell[125160, 3591, 4373, 111, 119, "Input",ExpressionUUID->"adc7b474-b2d7-43a1-adf2-eb35c6c85577"],
Cell[129536, 3704, 3497, 110, 125, "Output",ExpressionUUID->"592d7e70-f097-4fc8-a65e-533a74bb42e5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[133070, 3819, 5111, 126, 206, "Input",ExpressionUUID->"ef780798-8bc5-4dab-b36c-6e78d7a5058d"],
Cell[138184, 3947, 5596, 175, 189, "Output",ExpressionUUID->"96852bc6-36ac-4497-88aa-a04574bf910c"]
}, Open  ]],
Cell[143795, 4125, 210, 4, 30, "Input",ExpressionUUID->"a914af84-7c72-4fd1-b1de-fcd00bad6f46"],
Cell[144008, 4131, 739, 23, 56, "Input",ExpressionUUID->"2c63927c-c710-4a7e-a17f-e8bc6af09d1b"],
Cell[CellGroupData[{
Cell[144772, 4158, 210, 4, 30, "Input",ExpressionUUID->"c48c3e6f-2be5-4825-ab14-b4ca612e6acc"],
Cell[144985, 4164, 1864, 59, 60, "Output",ExpressionUUID->"4eaad8c4-6b21-40b2-a8ca-ee959a650745"]
}, Open  ]],
Cell[146864, 4226, 208, 4, 30, "Input",ExpressionUUID->"e1fe18a0-06d8-47a1-976e-4abef6cacf63"],
Cell[147075, 4232, 211, 4, 30, "Input",ExpressionUUID->"cbc97594-24a9-4566-85ed-7e959167b263"],
Cell[147289, 4238, 298, 7, 30, "Input",ExpressionUUID->"af022604-4529-4512-b792-78770f833874"],
Cell[CellGroupData[{
Cell[147612, 4249, 1212, 35, 52, "Input",ExpressionUUID->"dbc8d9fd-d846-43f1-9ddc-50f8f9e064ce"],
Cell[148827, 4286, 841, 26, 55, "Output",ExpressionUUID->"c3775b95-a25c-4bcd-bd4a-ffb3bc321dc2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[149705, 4317, 699, 20, 30, "Input",ExpressionUUID->"8a026b4b-4e05-4440-b026-9ea689539fda"],
Cell[150407, 4339, 647, 19, 34, "Output",ExpressionUUID->"a19d484c-4a49-43fd-88fe-2a9c61677b68"]
}, Open  ]],
Cell[151069, 4361, 208, 4, 30, "Input",ExpressionUUID->"12915e2b-2ae6-4993-b420-aa802ebca892"],
Cell[151280, 4367, 448, 13, 30, "Input",ExpressionUUID->"60fc12e7-ce6f-4086-a857-852ef1e1ee7c"],
Cell[CellGroupData[{
Cell[151753, 4384, 1212, 36, 52, "Input",ExpressionUUID->"a3462755-d982-46e5-b5ea-fb07ef42d3c8"],
Cell[152968, 4422, 817, 27, 57, "Output",ExpressionUUID->"792fa322-62bd-4940-9572-6533b415e8c7"]
}, Open  ]],
Cell[153800, 4452, 703, 20, 33, "Input",ExpressionUUID->"009bf874-3920-4a82-b40f-08e0cc19707b"],
Cell[154506, 4474, 460, 13, 30, "Input",ExpressionUUID->"dec3562a-807a-41fe-9cdf-3ff8f1f64f5b"],
Cell[CellGroupData[{
Cell[154991, 4491, 890, 24, 33, "Input",ExpressionUUID->"bcd2c2de-bc5a-4479-af72-6991cdda4ba3"],
Cell[155884, 4517, 2932, 88, 87, "Output",ExpressionUUID->"eb3c11e3-ae8b-4ced-b4a9-ccfce3c12767"]
}, Open  ]],
Cell[CellGroupData[{
Cell[158853, 4610, 880, 24, 33, "Input",ExpressionUUID->"64edcea4-75c9-4be3-98fe-04df342ec684"],
Cell[159736, 4636, 1544, 43, 54, "Output",ExpressionUUID->"908f3e56-9cba-4c52-bbf0-5cae93067a5d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[161317, 4684, 829, 23, 33, "Input",ExpressionUUID->"4bf0b7b5-6814-4c3d-b3cf-ce2a3e8f7dd0"],
Cell[162149, 4709, 2929, 88, 87, "Output",ExpressionUUID->"3bae45d1-8110-4146-9e16-5b04e6afd5ad"]
}, Open  ]],
Cell[CellGroupData[{
Cell[165115, 4802, 890, 24, 33, "Input",ExpressionUUID->"f0eff98f-e09a-4638-8658-8e5e56f2e92c"],
Cell[166008, 4828, 1543, 44, 97, "Output",ExpressionUUID->"d4f2afee-0fcd-4a2e-8c29-60be7d81248b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[167588, 4877, 724, 24, 30, "Input",ExpressionUUID->"c2deefeb-9d3a-403e-b14a-317ea4568aa3"],
Cell[168315, 4903, 647, 22, 37, "Output",ExpressionUUID->"351dceb7-7c00-4c38-b224-c70fadf435fc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[168999, 4930, 210, 4, 30, "Input",ExpressionUUID->"9291c4bb-7fa3-4117-99fe-0c72736c05f2"],
Cell[169212, 4936, 1176, 41, 34, "Output",ExpressionUUID->"f0428df5-8c48-4f1c-8450-455fab0bcb3f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[170425, 4982, 212, 4, 30, "Input",ExpressionUUID->"2f6f108d-f7d4-4ca6-b54b-108425c736a8"],
Cell[170640, 4988, 644, 22, 37, "Output",ExpressionUUID->"443d6437-7163-443e-b46d-06861c6987a7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[171321, 5015, 242, 5, 30, "Input",ExpressionUUID->"4c599775-915b-4ef1-8f31-c31a53174418"],
Cell[171566, 5022, 156, 3, 34, "Output",ExpressionUUID->"66fa264a-8529-492d-b604-fba1002cb1b8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[171759, 5030, 451, 14, 30, "Input",ExpressionUUID->"b5bc5e35-f3b4-4b8a-9bd6-57aa85d892e4"],
Cell[172213, 5046, 197, 5, 50, "Output",ExpressionUUID->"46a1f836-d077-442d-9eaf-2558d9728371"]
}, Open  ]],
Cell[CellGroupData[{
Cell[172447, 5056, 1209, 39, 54, "Input",ExpressionUUID->"7e456e2c-59aa-4532-b897-a2259c5baad5"],
Cell[173659, 5097, 176, 4, 51, "Output",ExpressionUUID->"a326046a-798e-484b-b1a1-e2d964432395"]
}, Open  ]],
Cell[CellGroupData[{
Cell[173872, 5106, 193, 4, 30, "Input",ExpressionUUID->"f7f569c9-b17f-4992-9b83-650efc1a8e2e"],
Cell[174068, 5112, 155, 3, 34, "Output",ExpressionUUID->"8bbc7eb2-3849-4acf-baf0-d80374869b54"]
}, Open  ]],
Cell[CellGroupData[{
Cell[174260, 5120, 193, 4, 30, "Input",ExpressionUUID->"a17fbe83-1b99-432a-8b4f-3cf7e9037666"],
Cell[174456, 5126, 156, 3, 34, "Output",ExpressionUUID->"265e7fbd-649c-4f2d-81e6-1a006b4404ee"]
}, Open  ]],
Cell[CellGroupData[{
Cell[174649, 5134, 494, 15, 30, "Input",ExpressionUUID->"1e83c296-ef0d-4cae-a023-b8dc1c4e97b8"],
Cell[175146, 5151, 230, 5, 51, "Output",ExpressionUUID->"31e4117f-f6c4-4a5d-8ca4-2776b34caba5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[175413, 5161, 6565, 154, 253, "Input",ExpressionUUID->"903fd82e-66b3-4dde-b6b7-19046cae9560"],
Cell[181981, 5317, 1048, 31, 60, "Output",ExpressionUUID->"fb3da40f-9420-45a8-8af4-6fe6d2ac6ca8"]
}, Open  ]],
Cell[183044, 5351, 335, 8, 30, "Input",ExpressionUUID->"0a010d8a-a33d-4770-b0ce-1868a7e2e39c"],
Cell[CellGroupData[{
Cell[183404, 5363, 3219, 82, 127, "Input",ExpressionUUID->"19e10508-1177-4422-8894-9161883aed13"],
Cell[186626, 5447, 1000, 29, 60, "Output",ExpressionUUID->"7554af23-09a3-44a1-abf3-7d94ae74e96c"]
}, Open  ]],
Cell[187641, 5479, 278, 7, 30, "Input",ExpressionUUID->"cdd5ef65-4e92-4dc8-988c-9e235cbd9b17"],
Cell[CellGroupData[{
Cell[187944, 5490, 437, 12, 49, "Input",ExpressionUUID->"b8d9af63-3dc8-4f9d-a2f9-36e8a6fb43a9"],
Cell[188384, 5504, 852, 28, 53, "Output",ExpressionUUID->"94403157-42c8-4272-aaaa-53a64d7305d0"]
}, Open  ]],
Cell[189251, 5535, 296, 6, 30, "Input",ExpressionUUID->"c7cd3ac5-8991-47cb-ab39-71bcedf6eb94"],
Cell[CellGroupData[{
Cell[189572, 5545, 1099, 30, 52, "Input",ExpressionUUID->"59d9f10f-e760-42de-b479-aeed0146ea7a"],
Cell[190674, 5577, 1053, 33, 52, "Output",ExpressionUUID->"5fca201c-5019-49a0-99d5-a8b2bf6caba3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[191764, 5615, 1256, 38, 77, "Input",ExpressionUUID->"69cd5119-2782-411b-a4a8-5a08f822667a"],
Cell[193023, 5655, 1593, 50, 60, "Output",ExpressionUUID->"1dcf4f3a-6bfb-4764-a7db-061e57e72a97"]
}, Open  ]],
Cell[194631, 5708, 1098, 31, 75, "Input",ExpressionUUID->"93381515-822f-4af3-81fb-da40ad4975bb"],
Cell[195732, 5741, 147, 3, 52, "Input",ExpressionUUID->"f1a8964f-3f2d-4393-822b-8a16a7c7fe49"],
Cell[195882, 5746, 367, 9, 30, "Input",ExpressionUUID->"2307e081-368f-49b4-a8a8-4146faab7268"],
Cell[196252, 5757, 1058, 27, 33, "Input",ExpressionUUID->"5d74db93-bf7d-4b00-8489-4c0bb8388879"],
Cell[CellGroupData[{
Cell[197335, 5788, 3707, 98, 117, "Input",ExpressionUUID->"265166b8-2be6-46f2-bdd5-bca43b623518"],
Cell[201045, 5888, 4392, 138, 167, "Output",ExpressionUUID->"aac591f4-46a3-4429-8780-05ea24a53e6f"]
}, Open  ]],
Cell[205452, 6029, 210, 4, 30, "Input",ExpressionUUID->"f6a240b5-07c0-4202-9513-f5a26eb05bf9"],
Cell[205665, 6035, 1805, 55, 100, "Input",ExpressionUUID->"0bf8be6d-1b13-436e-a794-e8f4561070d8"],
Cell[CellGroupData[{
Cell[207495, 6094, 1671, 48, 56, "Input",ExpressionUUID->"9ec01f08-b3b5-4911-8ab1-68246743399f"],
Cell[209169, 6144, 1280, 42, 37, "Output",ExpressionUUID->"61320c05-1274-4da9-88ad-f0fb51287a50"]
}, Open  ]],
Cell[CellGroupData[{
Cell[210486, 6191, 210, 4, 30, "Input",ExpressionUUID->"514afb84-a497-434e-b4ad-fe9f8b6d402f"],
Cell[210699, 6197, 592, 20, 37, "Output",ExpressionUUID->"1d502a82-833b-48da-8cf2-0ef7140b1166"]
}, Open  ]],
Cell[211306, 6220, 238, 6, 30, "Input",ExpressionUUID->"444fea3b-fcfc-4858-9ac9-0a34dd4b25f9"],
Cell[211547, 6228, 424, 9, 30, "Input",ExpressionUUID->"f1d5fa42-1079-4d85-b9ff-060e36755b50"],
Cell[CellGroupData[{
Cell[211996, 6241, 7140, 168, 219, "Input",ExpressionUUID->"82792f18-5825-416f-a311-3f0581668dca"],
Cell[219139, 6411, 3821, 101, 109, "Output",ExpressionUUID->"13b9714f-9a5d-4f82-9273-8ddaa276666f"]
}, Open  ]],
Cell[222975, 6515, 175, 3, 30, "Input",ExpressionUUID->"eb4a8be1-f801-4d68-aa65-dff4990e1892"],
Cell[223153, 6520, 7540, 183, 221, "Input",ExpressionUUID->"9a398aa7-a5ea-466d-8fbd-2e467cb70738"],
Cell[CellGroupData[{
Cell[230718, 6707, 210, 4, 30, "Input",ExpressionUUID->"6b320247-9b79-43a9-91d6-1e52d5127dd7"],
Cell[230931, 6713, 153, 3, 34, "Output",ExpressionUUID->"2f866706-a4df-4e3d-8df3-9d0852f1ee30"]
}, Open  ]],
Cell[231099, 6719, 152, 3, 30, "Input",ExpressionUUID->"d1bd78c0-e098-4645-8e63-7b0556112c4a"],
Cell[231254, 6724, 334, 8, 30, "Input",ExpressionUUID->"e8f8b9b1-dc6d-4c67-a2d0-7a4e859fdf65"],
Cell[CellGroupData[{
Cell[231613, 6736, 6836, 161, 226, "Input",ExpressionUUID->"e314cf52-2407-4348-b15e-78b2c86690f1"],
Cell[238452, 6899, 1425, 36, 55, "Output",ExpressionUUID->"b6e79174-9584-4fa4-9db6-1909bce11d37"]
}, Open  ]],
Cell[239892, 6938, 292, 5, 30, "Input",ExpressionUUID->"99ebafeb-99fc-4528-94f4-fecbf97aa260"],
Cell[CellGroupData[{
Cell[240209, 6947, 1322, 37, 71, "Input",ExpressionUUID->"5282850a-b895-46b9-a9e0-73c9a512edd8"],
Cell[241534, 6986, 1354, 43, 56, "Output",ExpressionUUID->"4afe0b3a-93c4-4481-b106-bf122428526e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[242925, 7034, 1415, 42, 56, "Input",ExpressionUUID->"c2b6e57b-c430-4c16-95e5-f238dec8c103"],
Cell[244343, 7078, 2559, 82, 83, "Output",ExpressionUUID->"4c292fe4-8395-4d1d-8732-f5774c66294f"]
}, Open  ]],
Cell[246917, 7163, 208, 3, 30, "Input",ExpressionUUID->"4e4ed496-0be0-41c4-a4da-a7ebf587409a"],
Cell[247128, 7168, 1767, 53, 56, InheritFromParent,ExpressionUUID->"0f7d2a8a-1c05-40c8-a82b-d84dd64c7354"],
Cell[248898, 7223, 151, 3, 30, "Input",ExpressionUUID->"27c9ff16-860c-4095-a50c-cd64cec52e8b"],
Cell[249052, 7228, 290, 6, 30, "Input",ExpressionUUID->"c1059762-99ec-45b6-b745-07774d562696"],
Cell[249345, 7236, 1388, 44, 56, InheritFromParent,ExpressionUUID->"dc212215-367a-48b2-9e4a-b3671ab4925f"],
Cell[250736, 7282, 306, 5, 30, "Input",ExpressionUUID->"1886e415-b6c8-4841-868b-fcf08c90c468"],
Cell[CellGroupData[{
Cell[251067, 7291, 960, 28, 49, "Input",ExpressionUUID->"3075b9e0-4a36-4394-a9db-e5680120df52"],
Cell[252030, 7321, 805, 25, 54, "Output",ExpressionUUID->"3e459917-1bb1-43da-9fab-2e7a8529f819"]
}, Open  ]],
Cell[CellGroupData[{
Cell[252872, 7351, 1132, 34, 51, "Input",ExpressionUUID->"7d54a88b-bf29-42e2-b475-d0ab206c319b"],
Cell[254007, 7387, 1092, 34, 54, "Output",ExpressionUUID->"a106c30b-93bf-4c9a-9b44-a45a60c3d4d3"]
}, Open  ]],
Cell[255114, 7424, 1047, 31, 30, "Input",ExpressionUUID->"f43ccea8-0fdc-4aa8-96dc-bcd88fa5ff49"],
Cell[256164, 7457, 998, 31, 33, InheritFromParent,ExpressionUUID->"6b6c56ed-d9b3-4e07-8e95-21f53a215a7d"]
}
]
*)

