(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[    359499,      10273]
NotebookOptionsPosition[    339751,       9959]
NotebookOutlinePosition[    340088,       9974]
CellTagsIndexPosition[    340045,       9971]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{
  3.777046193262038*^9},ExpressionUUID->"6b8e2350-0309-4df2-8199-\
28d0609f26d6"],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{
  3.777046193262038*^9},ExpressionUUID->"6b8e2350-0309-4df2-8199-\
28d0609f26d6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Trying", " ", "to", " ", "compute", " ", "differential", " ", "of", " ", 
     "f"}], "-", "1", "-", 
    RowBox[{"h", "*", "fdot", " ", "for", " ", "Kepler"}], "-", " ", 
    RowBox[{"Drift", " ", 
     RowBox[{"problem", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Note", ":", "  ", 
     RowBox[{"below", "  ", "d"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", "*", "g2"}], "+", 
         RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}], " ", 
      "\[IndentingNewLine]", "r"}], " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
       RowBox[{"k", " ", "g2", "\[IndentingNewLine]", "h"}]}], " ", "=", " ", 
      
      RowBox[{
       RowBox[{
        RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
        RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
        RowBox[{"k", " ", "g3", "\[IndentingNewLine]", "g0"}]}], " ", "=", 
       " ", 
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2", " ", "\[IndentingNewLine]", "g3"}]}], " ",
         "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"s", "-", "g1"}], ")"}], "/", "beta"}], " ", 
           "\[IndentingNewLine]", "g0", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g1", "^", "2"}]}], " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"-", "g2"}], "\[IndentingNewLine]", 
            RowBox[{"g0", "^", "2"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"g1", "^", "2"}], " ", "beta"}]}], " ", "=", " ", 
          RowBox[{
           RowBox[{"1", "\[IndentingNewLine]", "zeta"}], " ", "=", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}]}]}]}]}]}]}], 
   "\[IndentingNewLine]", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
  3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
  3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
  3.776616360243341*^9, 3.776616389763185*^9}, {3.776616473018384*^9, 
  3.7766164790371*^9}, {3.7766184896047897`*^9, 
  3.776618505548366*^9}},ExpressionUUID->"53329b6c-a80c-45ac-ae62-\
f6fb243392bd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgamma", " ", "=", " ", 
  RowBox[{
   FractionBox["sqb", "r"], " ", 
   RowBox[{"(", 
    RowBox[{"dh", " ", "+", "  ", 
     RowBox[{
      FractionBox["dk", "r0"], 
      RowBox[{"(", 
       RowBox[{"d", "-", " ", 
        RowBox[{"r0", " ", "g3"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"k", " ", "d"}], "+", 
           RowBox[{"g1", " ", 
            SuperscriptBox["r0", "2"]}]}], ")"}], 
         FractionBox["x0", 
          SuperscriptBox["r0", "3"]]}], "+", 
        RowBox[{"g2", " ", "v0"}]}], ")"}]}], "-", 
     RowBox[{"dv0", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", "  ", "v0"}], " ", "+", " ", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
   3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
   3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
   3.776616360243341*^9, 3.776616389763185*^9}, {3.776616473018384*^9, 
   3.7766164790371*^9}, 3.776947632081208*^9, 3.7769478776715317`*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"48462b44-b891-42a8-998f-37b74e902302"],

Cell[BoxData[
 FractionBox[
  RowBox[{"sqb", " ", 
   RowBox[{"(", 
    RowBox[{"dh", "+", 
     FractionBox[
      RowBox[{"dk", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
     RowBox[{"dv0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", " ", "v0"}], "+", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g2", " ", "v0"}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
         SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"]], "Output",
 CellChangeTimes->{3.776202160614881*^9, 3.7766164810276527`*^9, 
  3.777046244665285*^9, 3.7771187206590023`*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"8db55ecc-8814-4135-88c4-67d5f0686424"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr", " ", "=", " ", 
  RowBox[{
   RowBox[{
    FractionBox["dgamma", "sqb"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"zeta", " ", "g1"}], "+", 
      RowBox[{"eta", " ", "g0"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dk", 
     RowBox[{"beta", " ", "r0", " "}]], 
    RowBox[{"(", 
     RowBox[{"r0", "-", "r", "-", 
      RowBox[{"k", " ", "g2"}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["1", 
        RowBox[{"beta", " ", 
         SuperscriptBox["r0", "3"]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", 
          RowBox[{"(", 
           RowBox[{"r", "+", 
            RowBox[{"k", " ", "g2"}]}], ")"}]}], "-", 
         RowBox[{"zeta", " ", "r0", " ", "g0"}]}], ")"}], "x0"}], " ", "+", 
      " ", 
      RowBox[{"g1", "  ", "v0"}]}], ")"}]}], " ", "+", " ", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "k", " ", "g2"}]}], ")"}], " ", 
       FractionBox["v0", "beta"]}], " ", "+", " ", 
      RowBox[{"g1", " ", "x0"}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776198428651246*^9, 3.7761985237438927`*^9}, {
   3.7766163976826477`*^9, 3.776616471914287*^9}, 3.777046226908575*^9},
 CellLabel->"In[2]:=",ExpressionUUID->"ec64950c-8ed3-4bc5-92a5-293069313a0b"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}]}], 
   RowBox[{"beta", " ", "r0"}]], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], "beta"], 
     "+", 
     RowBox[{"g1", " ", "x0"}]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"dh", "+", 
      FractionBox[
       RowBox[{"dk", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
      RowBox[{"dv0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
      RowBox[{"dx0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "v0"}], "+", 
     FractionBox[
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776202167353901*^9, 3.7766164851357393`*^9, 
  3.777046246190269*^9, 3.777118721740559*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"ebefe9b9-e235-4da4-96cf-36f540c114e3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dbeta", " ", "=", " ", 
  RowBox[{
   RowBox[{"2", "*", 
    RowBox[{"dk", "/", "r0"}]}], "-", 
   RowBox[{"2", "*", 
    RowBox[{"k", "/", 
     RowBox[{"r0", "^", "3"}]}], "*", " ", 
    RowBox[{"(", 
     RowBox[{"dx0", " ", "*", " ", "x0"}], ")"}]}], " ", "-", " ", 
   RowBox[{"2", "*", "v0", " ", "*", " ", "dv0"}]}]}]], "Input",
 CellChangeTimes->{{3.776198629796771*^9, 3.776198668928054*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"95296aac-8480-48bf-b720-90060933f9ed"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", "dk"}], "r0"], "-", 
  RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
  FractionBox[
   RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
   SuperscriptBox["r0", "3"]]}]], "Output",
 CellChangeTimes->{3.776198669836025*^9, 3.7762021775425386`*^9, 
  3.7766164927868137`*^9, 3.777046248951951*^9, 3.777118730962187*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"a17f2a6e-ad8b-42d3-aa68-3eddf98914b6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr0", " ", "=", " ", 
  RowBox[{"dx0", " ", "*", " ", 
   RowBox[{"x0", " ", "/", " ", "r0"}]}]}]], "Input",
 CellChangeTimes->{{3.776198724170291*^9, 3.776198736866087*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"6e130959-e5af-4389-aed5-d86ced425512"],

Cell[BoxData[
 FractionBox[
  RowBox[{"dx0", " ", "x0"}], "r0"]], "Output",
 CellChangeTimes->{3.776198740240225*^9, 3.776202183604251*^9, 
  3.776616494745343*^9, 3.777046250797785*^9, 3.777118736803234*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"bdfbb573-556a-4f0c-91b5-6ac32f905278"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{" ", 
   RowBox[{
    RowBox[{"Now", " ", "for", " ", "d", " ", 
     RowBox[{"(", 
      RowBox[{"f", "-", "1", "-", 
       RowBox[{"h", " ", "fdot"}]}], ")"}], " ", "for", " ", "drift"}], "-", 
    RowBox[{"last", " ", 
     RowBox[{"case", ":"}]}]}], " ", ")"}]}]], "Input",
 CellChangeTimes->{{3.776258566484967*^9, 3.776258574345611*^9}, {
   3.7762590835501537`*^9, 3.7762590836374397`*^9}, {3.776259116907651*^9, 
   3.7762591197329206`*^9}, 3.776521078478303*^9, {3.776616498984494*^9, 
   3.776616512695982*^9}},ExpressionUUID->"2d884b31-7a55-4520-bbb8-\
26a9cd31ce07"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dfm1mhfdot", " ", "=", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{"r0", " ", 
      SuperscriptBox["r", "2"]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"r", " ", "dk"}], " ", "-", 
      RowBox[{"k", " ", "dr"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g2", " ", "r0"}], " ", "-", " ", 
      RowBox[{"k", " ", "h1"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["k", "r"], 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g1", " ", "dgamma"}], "sqb"], "-", 
      RowBox[{
       FractionBox["dbeta", "beta"], "g2"}], " ", "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["dk", "r0"], "-", 
         FractionBox[
          RowBox[{"k", " ", "dr0", " "}], 
          SuperscriptBox["r0", "2"]]}], ")"}], "h1"}], " ", "-", 
      RowBox[{
       FractionBox["k", "r0"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          FractionBox["h2", "sqb"], "dgamma"}], "-", 
         RowBox[{
          FractionBox[
           RowBox[{"2", " ", "dbeta"}], "beta"], "h1"}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7762585761216097`*^9, 3.77625860781793*^9}, {
   3.776259100727673*^9, 3.776259100829246*^9}, {3.776616516007222*^9, 
   3.776616703078433*^9}, {3.7766169376542177`*^9, 3.776616947701645*^9}, {
   3.776617978626844*^9, 3.776618092271991*^9}, 3.776619122588566*^9, {
   3.776620059682043*^9, 3.776620073384857*^9}, {3.776620137378751*^9, 
   3.7766201612323627`*^9}, {3.776623048793311*^9, 3.776623048842722*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"a6c48c41-52a5-424e-8082-2ada96dd916c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "r"], 
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"g2", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"2", " ", "dk"}], "r0"], "-", 
           RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
           FractionBox[
            RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
            SuperscriptBox["r0", "3"]]}], ")"}]}], "beta"]}], "-", 
      RowBox[{"h1", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["dk", "r0"], "-", 
         FractionBox[
          RowBox[{"dx0", " ", "k", " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], "+", 
      FractionBox[
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{"dh", "+", 
          FractionBox[
           RowBox[{"dk", " ", 
            RowBox[{"(", 
             RowBox[{"d", "-", 
              RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
          RowBox[{"dv0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "v0"}], "+", 
             RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
          RowBox[{"dx0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "v0"}], "+", 
             FractionBox[
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", " ", "k"}], "+", 
                 RowBox[{"g1", " ", 
                  SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
              SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"2", " ", "h1", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"2", " ", "dk"}], "r0"], "-", 
               RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
               FractionBox[
                RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
                SuperscriptBox["r0", "3"]]}], ")"}]}], "beta"]}], "+", 
          FractionBox[
           RowBox[{"h2", " ", 
            RowBox[{"(", 
             RowBox[{"dh", "+", 
              FractionBox[
               RowBox[{"dk", " ", 
                RowBox[{"(", 
                 RowBox[{"d", "-", 
                  RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
              RowBox[{"dv0", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", " ", "v0"}], "+", 
                 RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
              RowBox[{"dx0", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"g2", " ", "v0"}], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"d", " ", "k"}], "+", 
                    RowBox[{"g1", " ", 
                    SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
                  SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"]}], 
         ")"}]}], "r0"]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SuperscriptBox["r", "2"], " ", "r0"}]], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "h1"}], " ", "k"}], "+", 
      RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"dk", " ", "r"}], "-", 
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"dk", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}]}], 
          RowBox[{"beta", " ", "r0"}]], "+", 
         RowBox[{"dv0", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g1"}], "+", 
                RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], 
             "beta"], "+", 
            RowBox[{"g1", " ", "x0"}]}], ")"}]}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{"dh", "+", 
             FractionBox[
              RowBox[{"dk", " ", 
               RowBox[{"(", 
                RowBox[{"d", "-", 
                 RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
             RowBox[{"dv0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "v0"}], "+", 
                RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
             RowBox[{"dx0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "v0"}], "+", 
                FractionBox[
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"d", " ", "k"}], "+", 
                    RowBox[{"g1", " ", 
                    SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
                 SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
         RowBox[{"dx0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "v0"}], "+", 
            FractionBox[
             RowBox[{"x0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
                RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Output",
 CellChangeTimes->{3.776620193624681*^9, 3.776623061126111*^9, 
  3.7770462586187887`*^9, 3.777051295364431*^9, 3.777119005556288*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"38996fdd-651c-4277-ae21-efa85a998f6b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"dx0", ",", "dv0", ",", "dk", ",", "dh"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.776258616039044*^9, 3.776258625845273*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"c50ee62d-22cf-45d5-85af-1fc4bc50ccb2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "k"}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"4", " ", "h1", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "k"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"h1", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "h1"}], " ", "k"}], "+", 
       RowBox[{"g2", " ", "r0"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "k", " ", "v0"}], 
      RowBox[{"beta", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{"4", " ", "h1", " ", 
       SuperscriptBox["k", "2"], " ", "v0"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], 
          "beta"], "+", 
         RowBox[{"g1", " ", "x0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "3"], " ", "x0"}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "4"]}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", 
       SuperscriptBox["k", "2"], " ", "x0"}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{"h1", " ", 
       SuperscriptBox["k", "2"], " ", "x0"}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{"x0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7766201991527157`*^9, 3.7766230661278133`*^9, 
  3.77704626825769*^9, 3.777051297506824*^9, 3.777119010126226*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"ce91bbb7-847e-4706-b2c5-8ab590ad38d7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Collect", " ", "x0"}], " ", "&"}], " ", "v0", " ", "in", " ", 
      "dv0"}], " ", "&"}], " ", "dx0", " ", 
    RowBox[{"terms", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"First", ",", " ", 
    RowBox[{"dx0", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776258919746063*^9, 
  3.776258947304412*^9}},ExpressionUUID->"5016d470-2559-42c7-9097-\
a15b73e2e0c2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "3"], " ", "x0"}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "4"]}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", 
       SuperscriptBox["k", "2"], " ", "x0"}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{"h1", " ", 
       SuperscriptBox["k", "2"], " ", "x0"}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{"x0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7762589351786823`*^9, 3.7762589524160213`*^9}, 
   3.7766169978896017`*^9, 3.776618164429405*^9, 3.776620099741139*^9, 
   3.7766202080449142`*^9, 3.7766230875293007`*^9, 3.777046308359079*^9},
 CellLabel->"In[7]:=",ExpressionUUID->"86606400-4dcd-4a36-bd1d-3a1e6bba1e6b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g1", " ", "g2", " ", "k"}], 
       SuperscriptBox["r", "2"]]}], "+", 
     FractionBox[
      RowBox[{"g2", " ", "h2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "3"]}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "4"]}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{"h1", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "4"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776620209111361*^9, 3.776623088335967*^9, 
  3.7770463090779877`*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"bf0a6582-47f2-44df-b4bc-47e2a00ce439"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Next", ",", " ", 
   RowBox[{"dv0", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776258958098084*^9, 3.77625896130404*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"93376667-ae79-4f2c-bce9-f4e105374de8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "k", " ", "v0"}], 
      RowBox[{"beta", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{"4", " ", "h1", " ", 
       SuperscriptBox["k", "2"], " ", "v0"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], 
          "beta"], "+", 
         RowBox[{"g1", " ", "x0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.776258972640501*^9, 3.7762589774726753`*^9}, 
   3.776617010769013*^9, 3.776618177123947*^9, 3.77662010951578*^9, 
   3.776620216181149*^9, 3.776623078818287*^9, {3.7770462929752073`*^9, 
   3.777046317293231*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"4c137373-3aac-4897-9d22-41fe9976ebba"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"d", " ", "g1", " ", "k"}], 
       SuperscriptBox["r", "2"]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "k"}], 
      RowBox[{"beta", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{"d", " ", "h2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"4", " ", "h1", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"d", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g1", " ", "g2", " ", "k"}], 
       SuperscriptBox["r", "2"]]}], "+", 
     FractionBox[
      RowBox[{"g2", " ", "h2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776620217383945*^9, 3.776623079594092*^9, 
  3.7770463179451838`*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"5208d4ae-9cec-4351-a186-0183944f9c8c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Final", " ", "dfm1mhfdot", " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776258980760725*^9, 3.776258984807379*^9}, {
  3.776259093949028*^9, 3.7762590940371437`*^9}, {3.776542815269114*^9, 
  3.776542828219266*^9}, {3.7766170186672497`*^9, 3.776617024371574*^9}, {
  3.776618198007195*^9, 
  3.776618198535988*^9}},ExpressionUUID->"d4d207ae-e603-472b-bd2a-\
7645ab9a44c9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dfm1mhfdot", " ", "=", 
  RowBox[{
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g1", " ", "k"}], 
       SuperscriptBox["r", "2"]], "-", 
      FractionBox[
       RowBox[{"h2", " ", 
        SuperscriptBox["k", "2"]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "2"]}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "2"]}]], "-", 
      FractionBox[
       RowBox[{"2", " ", "g2", " ", "k"}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"h1", " ", "k"}], 
       RowBox[{"r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "h1"}], " ", "k"}], "+", 
        RowBox[{"g2", " ", "r0"}]}], 
       RowBox[{"r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox["r0", "2"]}]], "-", 
      FractionBox[
       RowBox[{"h2", " ", 
        SuperscriptBox["k", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox["r0", "2"]}]], "+", 
      FractionBox[
       RowBox[{"g1", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "3"], " ", 
        SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"d", " ", "g1", " ", "k"}], 
           SuperscriptBox["r", "2"]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", "g2", " ", "k"}], 
          RowBox[{"beta", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", "h2", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"4", " ", "h1", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g1", " ", "g2", " ", "k"}], 
           SuperscriptBox["r", "2"]]}], "+", 
         FractionBox[
          RowBox[{"g2", " ", "h2", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}]}], ")"}]}], "+", 
   
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g1", " ", "g2", " ", "k"}], 
           SuperscriptBox["r", "2"]]}], "+", 
         FractionBox[
          RowBox[{"g2", " ", "h2", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "h1", " ", 
            SuperscriptBox["k", "3"]}], 
           RowBox[{"beta", " ", "r", " ", 
            SuperscriptBox["r0", "4"]}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", "g2", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox[
          RowBox[{"h1", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox[
          RowBox[{"h2", " ", 
           SuperscriptBox["k", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776258995599614*^9, 3.776259029056012*^9}, {
   3.7762590959366198`*^9, 3.77625909602941*^9}, {3.776617017203174*^9, 
   3.776617069848213*^9}, {3.776618193679949*^9, 3.776618218045624*^9}, 
   3.776619113105009*^9, 3.776620118155706*^9, {3.776620229689068*^9, 
   3.776620250008428*^9}, {3.776623104381906*^9, 3.776623124265459*^9}, {
   3.77704633166483*^9, 3.7770463458379*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"71c53a07-8e97-43ef-b6c9-30d71d21b7fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "k"}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"4", " ", "h1", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "k"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"h1", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "h1"}], " ", "k"}], "+", 
       RowBox[{"g2", " ", "r0"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "g1", " ", "k"}], 
          SuperscriptBox["r", "2"]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "g2", " ", "k"}], 
         RowBox[{"beta", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"4", " ", "h1", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g1", " ", "g2", " ", "k"}], 
          SuperscriptBox["r", "2"]]}], "+", 
        FractionBox[
         RowBox[{"g2", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g1", " ", "g2", " ", "k"}], 
          SuperscriptBox["r", "2"]]}], "+", 
        FractionBox[
         RowBox[{"g2", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", "h1", " ", 
           SuperscriptBox["k", "3"]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "4"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "g2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"h1", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"h2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776620251526433*^9, 3.776623126546146*^9, 
  3.777046347158668*^9, 3.777119042391272*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"f45c6936-9662-49ec-9856-605f4435759e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Revised", " ", "expression", " ", "for", " ", "d", 
    RowBox[{"(", 
     RowBox[{"f", "-", "1", "-", 
      RowBox[{"h", " ", "fdot"}]}], ")"}]}], ":"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7766190859099903`*^9, 
  3.776619098908731*^9}},ExpressionUUID->"737a2b71-af6e-49a2-8fb6-\
9769070ef2d4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"c1", "=", 
    RowBox[{"d", "-", 
     RowBox[{"r0", " ", "g3"}]}]}], "\n", 
   RowBox[{"c2", "=", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"g1", " ", "zeta"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"c3", "=", 
    RowBox[{
     RowBox[{"d", " ", "k"}], "+", 
     RowBox[{"g1", " ", 
      SuperscriptBox["r0", "2"]}]}]}], "\n", 
   RowBox[{"c14", "=", 
    RowBox[{
     RowBox[{"r0", " ", "g2"}], "-", 
     RowBox[{"k", " ", "h1"}]}]}], "\n", 
   RowBox[{"c17", "=", 
    RowBox[{"r0", "-", "r", "-", 
     RowBox[{"g2", " ", "k"}]}]}], "\n", 
   RowBox[{"c18", "=", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"2", " ", "g2", " ", "k"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"c23", " ", "=", " ", 
    RowBox[{
     RowBox[{"h2", " ", "k"}], " ", "-", " ", 
     RowBox[{"r0", " ", "g1"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.77704660087945*^9, 3.7770466200267677`*^9}, {
  3.777046996336483*^9, 3.777047003600148*^9}, {3.777047393376198*^9, 
  3.777047415332081*^9}, {3.777048264217287*^9, 3.777048269880295*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"91ab92d8-9507-4b23-90cf-42efcb27b1a1"],

Cell[BoxData[
 RowBox[{"d", "-", 
  RowBox[{"g3", " ", "r0"}]}]], "Output",
 CellChangeTimes->{
  3.777048135934217*^9, 3.7770482712684298`*^9, 3.777119083592701*^9, {
   3.7778994731720333`*^9, 3.777899482262589*^9}},
 CellLabel->"Out[1]=",ExpressionUUID->"4b06fc5a-4109-46b4-a19e-77d2f71c4d8f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g0"}], "+", 
  RowBox[{"g1", " ", "zeta"}]}]], "Output",
 CellChangeTimes->{
  3.777048135934217*^9, 3.7770482712684298`*^9, 3.777119083592701*^9, {
   3.7778994731720333`*^9, 3.777899482266089*^9}},
 CellLabel->"Out[2]=",ExpressionUUID->"5e84f7bb-2216-4e72-b457-0f30a75567ce"],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", " ", "k"}], "+", 
  RowBox[{"g1", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{
  3.777048135934217*^9, 3.7770482712684298`*^9, 3.777119083592701*^9, {
   3.7778994731720333`*^9, 3.77789948226763*^9}},
 CellLabel->"Out[3]=",ExpressionUUID->"0b1a3d4d-e564-4342-9912-0671924461ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "h1"}], " ", "k"}], "+", 
  RowBox[{"g2", " ", "r0"}]}]], "Output",
 CellChangeTimes->{
  3.777048135934217*^9, 3.7770482712684298`*^9, 3.777119083592701*^9, {
   3.7778994731720333`*^9, 3.777899482269188*^9}},
 CellLabel->"Out[4]=",ExpressionUUID->"162829fd-9cda-4afa-9962-62090ae546f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}]], "Output",
 CellChangeTimes->{
  3.777048135934217*^9, 3.7770482712684298`*^9, 3.777119083592701*^9, {
   3.7778994731720333`*^9, 3.77789948227092*^9}},
 CellLabel->"Out[5]=",ExpressionUUID->"7ace380e-2b18-4879-b4ea-e9cecfa8362a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g1"}], "+", 
  RowBox[{"2", " ", "g2", " ", "k"}]}]], "Output",
 CellChangeTimes->{
  3.777048135934217*^9, 3.7770482712684298`*^9, 3.777119083592701*^9, {
   3.7778994731720333`*^9, 3.777899482272499*^9}},
 CellLabel->"Out[6]=",ExpressionUUID->"83be9852-d35a-49b1-aa79-2582b781039a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"h2", " ", "k"}], "-", 
  RowBox[{"g1", " ", "r0"}]}]], "Output",
 CellChangeTimes->{
  3.777048135934217*^9, 3.7770482712684298`*^9, 3.777119083592701*^9, {
   3.7778994731720333`*^9, 3.777899482274016*^9}},
 CellLabel->"Out[7]=",ExpressionUUID->"6fb91625-bd4d-4682-821c-dbf9cfd0afb7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     RowBox[{"4", " ", "h1", " ", 
      SuperscriptBox["k", "2"]}], 
     RowBox[{"beta", " ", "r", " ", 
      SuperscriptBox["r0", "2"]}]], "-", 
    FractionBox[
     RowBox[{"2", " ", "g2", " ", "k"}], 
     RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
    FractionBox[
     RowBox[{"h1", " ", "k"}], 
     RowBox[{"r", " ", "r0"}]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "h1"}], " ", "k"}], "+", 
      RowBox[{"g2", " ", "r0"}]}], 
     RowBox[{"r", " ", "r0"}]], "-", 
    FractionBox[
     RowBox[{"k", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h1"}], " ", "k"}], "+", 
        RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
     RowBox[{"beta", " ", 
      SuperscriptBox["r", "2"], " ", 
      SuperscriptBox["r0", "2"]}]], "-", 
    FractionBox[
     RowBox[{"h2", " ", 
      SuperscriptBox["k", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"d", "-", 
        RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
     RowBox[{
      SuperscriptBox["r", "2"], " ", 
      SuperscriptBox["r0", "2"]}]], "+", 
    FractionBox[
     RowBox[{"g1", " ", "k", " ", 
      RowBox[{"(", 
       RowBox[{"d", "-", 
        RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
     RowBox[{
      SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
    FractionBox[
     RowBox[{"k", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h1"}], " ", "k"}], "+", 
        RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"d", "-", 
        RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", "g0"}], "+", 
        RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
     RowBox[{
      SuperscriptBox["r", "3"], " ", 
      SuperscriptBox["r0", "2"]}]]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.777119148547268*^9, 
  3.777119149397727*^9}},ExpressionUUID->"aa55b9af-4033-4b14-b4d7-\
6f46d4109338"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dfm1mhfdot2", " ", "=", 
  RowBox[{
   RowBox[{
    FractionBox["dh", 
     SuperscriptBox["r", "2"]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", "k"}], "-", 
      FractionBox[
       RowBox[{"h2", " ", 
        SuperscriptBox["k", "2"]}], "r0"], "-", 
      FractionBox[
       RowBox[{"k", " ", "c14", " ", "c2"}], 
       RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dk", 
     RowBox[{"r", " ", "r0"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "2"]}], 
       RowBox[{"beta", " ", "r0"}]], "-", 
      RowBox[{"k", " ", "h1"}], "-", 
      FractionBox[
       RowBox[{"2", " ", "g2", " ", "k"}], 
       RowBox[{"beta", " "}]], "+", "c14", "-", 
      FractionBox[
       RowBox[{"k", " ", "c14", " ", "c17", " "}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"k", 
        RowBox[{"(", 
         RowBox[{"g1", " ", "-", 
          RowBox[{"k", " ", "h2"}]}], ")"}], " ", "c1"}], 
       RowBox[{"r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", "c14", " ", "c1", " ", "c2"}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{
    FractionBox[
     RowBox[{"k", " ", "dv0"}], 
     RowBox[{"r0", " ", 
      SuperscriptBox["r", "2"]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["v0", "beta"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"r", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "r0"}], " ", "-", 
            RowBox[{"4", " ", "h1", " ", "k"}]}], ")"}]}], "+", 
         RowBox[{"d", "  ", "beta", " ", "c23"}], "-", 
         RowBox[{"c18", " ", "c14"}], "+", 
         FractionBox[
          RowBox[{"d", " ", "beta", " ", "c14", " ", "c2"}], "r"]}], ")"}]}], 
      "+", 
      RowBox[{"x0", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"h2", " ", "g2"}], "+", 
            RowBox[{"g1", " ", "h1"}]}], ")"}]}], "-", 
         RowBox[{"2", "r0", " ", "g1", " ", "g2"}], " ", "+", 
         FractionBox[
          RowBox[{"g2", " ", "c14", " ", "c2"}], "r"]}], ")"}]}]}], ")"}]}], 
   "+", 
   RowBox[{
    FractionBox[
     RowBox[{"k", " ", "dx0"}], 
     RowBox[{
      SuperscriptBox["r", "2"], "r0"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", 
       RowBox[{"(", " ", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h2"}], "+", 
            RowBox[{"g1", " ", "h1"}]}], ")"}]}], "-", 
         RowBox[{"2", "g1", " ", "g2", " ", "r0"}], "+", 
         FractionBox[
          RowBox[{"g2", " ", "c14", " ", "c2"}], "r"]}], ")"}]}], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"x0", " "}], 
        RowBox[{"beta", " ", "r", " ", 
         SuperscriptBox["r0", "3"]}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", "h1", " ", 
          SuperscriptBox["r", "2"], " ", "r0", " ", 
          RowBox[{"(", 
           RowBox[{"beta", "-", 
            FractionBox[
             RowBox[{"2", "k"}], "r0"]}], ")"}]}], "+", 
         RowBox[{"beta", " ", "c3", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"r", " ", "c23"}], "+", 
            RowBox[{"c14", " ", "c2"}]}], ")"}]}], "+", 
         RowBox[{"c14", " ", "r", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", 
             RowBox[{"(", 
              RowBox[{"r", "-", 
               RowBox[{"g2", " ", "k"}]}], ")"}]}], "+", " ", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776618747190886*^9, 3.7766187962868557`*^9}, {
   3.776618864012754*^9, 3.776619053834703*^9}, {3.776619101892602*^9, 
   3.776619110950803*^9}, {3.776619191067894*^9, 3.77661927302089*^9}, {
   3.7766193459784603`*^9, 3.776619357058489*^9}, {3.776619833609288*^9, 
   3.776619925462152*^9}, 3.776620122115419*^9, {3.776620262177127*^9, 
   3.7766203520776854`*^9}, {3.776623137075754*^9, 3.776623233287178*^9}, {
   3.777046350088826*^9, 3.777046423917327*^9}, {3.7770464555583563`*^9, 
   3.777046467830433*^9}, {3.777046532755209*^9, 3.777046597761901*^9}, {
   3.777046714392606*^9, 3.777046749528872*^9}, {3.777046825871044*^9, 
   3.777046979234511*^9}, {3.7770470573262033`*^9, 3.777047064170298*^9}, {
   3.77704712914056*^9, 3.777047237856758*^9}, {3.7770472720658503`*^9, 
   3.777047364054055*^9}, {3.777047480590691*^9, 3.777047549579108*^9}, {
   3.777047592516123*^9, 3.777047639450409*^9}, {3.777047670224207*^9, 
   3.7770476754057207`*^9}, {3.777048040957264*^9, 3.777048092477085*^9}, {
   3.7770481918548317`*^9, 3.777048224761718*^9}, {3.777048274121707*^9, 
   3.7770482853510923`*^9}, {3.777048321807618*^9, 3.777048476236085*^9}, {
   3.777048510114871*^9, 3.777048530266306*^9}, {3.7770486593198357`*^9, 
   3.7770486849760647`*^9}, {3.777048785192967*^9, 3.777048785550406*^9}, {
   3.777048881146254*^9, 3.77704892487068*^9}, {3.777049003908394*^9, 
   3.777049020251327*^9}, {3.7770490569343433`*^9, 3.777049129733665*^9}, {
   3.777051342623516*^9, 3.7770514414044123`*^9}, {3.777051480584944*^9, 
   3.7770515387630167`*^9}, {3.777051752066124*^9, 3.77705180085056*^9}, {
   3.777051839373564*^9, 3.777051874525782*^9}, {3.777051914899572*^9, 
   3.777051929959476*^9}, {3.777051965246253*^9, 3.777052000231707*^9}, {
   3.777052045859363*^9, 3.777052047905987*^9}, {3.7770522490513477`*^9, 
   3.777052319593055*^9}, {3.777052381410162*^9, 3.777052398919929*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"4321d870-f29f-4814-817c-fee11a6a61b8"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", "k"}], "-", 
      FractionBox[
       RowBox[{"h2", " ", 
        SuperscriptBox["k", "2"]}], "r0"], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]]}], ")"}]}], 
   SuperscriptBox["r", "2"]], "+", 
  FractionBox[
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", "g2", " ", "k"}], "beta"]}], "-", 
      RowBox[{"2", " ", "h1", " ", "k"}], "+", 
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "2"]}], 
       RowBox[{"beta", " ", "r0"}]], "+", 
      RowBox[{"g2", " ", "r0"}], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{"g1", "-", 
          RowBox[{"h2", " ", "k"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], 
   RowBox[{"r", " ", "r0"}]], "+", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SuperscriptBox["r", "2"], " ", "r0"}]], 
   RowBox[{"dv0", " ", "k", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"beta", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"h2", " ", "k"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], "+", 
          RowBox[{"r", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "4"}], " ", "h1", " ", "k"}], "+", 
             RowBox[{"2", " ", "g2", " ", "r0"}]}], ")"}]}], "+", 
          FractionBox[
           RowBox[{"beta", " ", "d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "h1"}], " ", "k"}], "+", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], 
       "beta"], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h1"}], "+", 
            RowBox[{"g2", " ", "h2"}]}], ")"}], " ", "k"}], "-", 
         RowBox[{"2", " ", "g1", " ", "g2", " ", "r0"}], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}]}], 
     ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SuperscriptBox["r", "2"], " ", "r0"}]], 
   RowBox[{"dx0", " ", "k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h1"}], "+", 
            RowBox[{"g2", " ", "h2"}]}], ")"}], " ", "k"}], "-", 
         RowBox[{"2", " ", "g1", " ", "g2", " ", "r0"}], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"beta", " ", "r", " ", 
         SuperscriptBox["r0", "3"]}]], 
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"h1", " ", "k", " ", 
           SuperscriptBox["r", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"beta", "-", 
             FractionBox[
              RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", "r0"}], "+", 
          RowBox[{"r", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "g2"}], " ", "k"}], "+", "r"}], ")"}]}], "+", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], "+", 
          RowBox[{"beta", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"r", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"h2", " ", "k"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "h1"}], " ", "k"}], "+", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}]}], ")"}]}]}], 
         ")"}]}]}]}], ")"}]}]}]}]], "Output",
 CellChangeTimes->{3.7771190870113153`*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"93d805b2-d363-435e-b297-67a973e20ecb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dfm1mhfdot", "-", "dfm1mhfdot2"}]], "Input",
 CellChangeTimes->{{3.7770481411570797`*^9, 3.777048149342802*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"e02c3643-07cb-4869-9757-bd019ee75903"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "k"}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", "k"}], "-", 
      FractionBox[
       RowBox[{"h2", " ", 
        SuperscriptBox["k", "2"]}], "r0"], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]]}], ")"}]}], 
   SuperscriptBox["r", "2"]], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"4", " ", "h1", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "k"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"h1", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "h1"}], " ", "k"}], "+", 
       RowBox[{"g2", " ", "r0"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", "g2", " ", "k"}], "beta"]}], "-", 
      RowBox[{"2", " ", "h1", " ", "k"}], "+", 
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "2"]}], 
       RowBox[{"beta", " ", "r0"}]], "+", 
      RowBox[{"g2", " ", "r0"}], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{"g1", "-", 
          RowBox[{"h2", " ", "k"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], 
   RowBox[{"r", " ", "r0"}]], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SuperscriptBox["r", "2"], " ", "r0"}]], 
   RowBox[{"dv0", " ", "k", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"beta", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"h2", " ", "k"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], "+", 
          RowBox[{"r", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "4"}], " ", "h1", " ", "k"}], "+", 
             RowBox[{"2", " ", "g2", " ", "r0"}]}], ")"}]}], "+", 
          FractionBox[
           RowBox[{"beta", " ", "d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "h1"}], " ", "k"}], "+", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], 
       "beta"], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h1"}], "+", 
            RowBox[{"g2", " ", "h2"}]}], ")"}], " ", "k"}], "-", 
         RowBox[{"2", " ", "g1", " ", "g2", " ", "r0"}], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}]}], 
     ")"}]}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "g1", " ", "k"}], 
          SuperscriptBox["r", "2"]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "g2", " ", "k"}], 
         RowBox[{"beta", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"4", " ", "h1", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g1", " ", "g2", " ", "k"}], 
          SuperscriptBox["r", "2"]]}], "+", 
        FractionBox[
         RowBox[{"g2", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g1", " ", "g2", " ", "k"}], 
          SuperscriptBox["r", "2"]]}], "+", 
        FractionBox[
         RowBox[{"g2", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", "h1", " ", 
           SuperscriptBox["k", "3"]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "4"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "g2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"h1", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"h2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SuperscriptBox["r", "2"], " ", "r0"}]], 
   RowBox[{"dx0", " ", "k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h1"}], "+", 
            RowBox[{"g2", " ", "h2"}]}], ")"}], " ", "k"}], "-", 
         RowBox[{"2", " ", "g1", " ", "g2", " ", "r0"}], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"beta", " ", "r", " ", 
         SuperscriptBox["r0", "3"]}]], 
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"h1", " ", "k", " ", 
           SuperscriptBox["r", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"beta", "-", 
             FractionBox[
              RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", "r0"}], "+", 
          RowBox[{"r", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "g2"}], " ", "k"}], "+", "r"}], ")"}]}], "+", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], "+", 
          RowBox[{"beta", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"r", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"h2", " ", "k"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "h1"}], " ", "k"}], "+", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}]}], ")"}]}]}], 
         ")"}]}]}]}], ")"}]}]}]}]], "Output",
 CellChangeTimes->{3.77711908984304*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"8279582f-f739-4578-bba4-8dde3a8aedf7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777048154734131*^9, 3.777048155845096*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"fede4484-8d1f-46f2-9df2-d64a9830e6b1"],

Cell[BoxData[
 FractionBox[
  RowBox[{"dk", " ", "g1", " ", "k", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "r0"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"d", "-", 
     RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
  RowBox[{
   SuperscriptBox["r", "2"], " ", 
   SuperscriptBox["r0", "2"]}]]], "Output",
 CellChangeTimes->{3.777048156151433*^9, 3.7770481987131367`*^9, 
  3.777048743794833*^9, 3.7770487923281393`*^9, 3.7770489807523623`*^9, 
  3.77705145815289*^9, 3.777052109783736*^9, 3.777119092940567*^9},
 CellLabel->"Out[17]=",ExpressionUUID->"71991028-0bb1-4bf9-b92b-83368a16941d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Trying", " ", "to", " ", "compute", " ", "differential", " ", "of", " ", 
     "f"}], "-", "1", "-", 
    RowBox[{"h", "*", "fdot", " ", "for", " ", "Kepler"}], "-", " ", 
    RowBox[{"Drift", " ", 
     RowBox[{"problem", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Note", ":", "  ", 
     RowBox[{"below", "  ", "d"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", "*", "g2"}], "+", 
         RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}], " ", 
      "\[IndentingNewLine]", "r"}], " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
       RowBox[{"k", " ", "g2", "\[IndentingNewLine]", "h"}]}], " ", "=", " ", 
      
      RowBox[{
       RowBox[{
        RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
        RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
        RowBox[{"k", " ", "g3", "\[IndentingNewLine]", "g0"}]}], " ", "=", 
       " ", 
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2", " ", "\[IndentingNewLine]", "g3"}]}], " ",
         "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"s", "-", "g1"}], ")"}], "/", "beta"}], " ", 
           "\[IndentingNewLine]", "g0", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g1", "^", "2"}]}], " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"-", "g2"}], "\[IndentingNewLine]", 
            RowBox[{"g0", "^", "2"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"g1", "^", "2"}], " ", "beta"}]}], " ", "=", " ", 
          RowBox[{
           RowBox[{"1", "\[IndentingNewLine]", "zeta"}], " ", "=", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}]}]}]}]}]}]}], 
   "\[IndentingNewLine]", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
  3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
  3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
  3.776616360243341*^9, 3.776616389763185*^9}, {3.776616473018384*^9, 
  3.7766164790371*^9}, {3.7766184896047897`*^9, 
  3.776618505548366*^9}},ExpressionUUID->"53329b6c-a80c-45ac-ae62-\
f6fb243392bd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dgamma", " ", "=", " ", 
  RowBox[{
   FractionBox["sqb", "r"], " ", 
   RowBox[{"(", 
    RowBox[{"dh", " ", "+", "  ", 
     RowBox[{
      FractionBox["dk", "r0"], 
      RowBox[{"(", 
       RowBox[{"d", "-", " ", 
        RowBox[{"r0", " ", "g3"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"k", " ", "d"}], "+", 
           RowBox[{"g1", " ", 
            SuperscriptBox["r0", "2"]}]}], ")"}], 
         FractionBox["x0", 
          SuperscriptBox["r0", "3"]]}], "+", 
        RowBox[{"g2", " ", "v0"}]}], ")"}]}], "-", 
     RowBox[{"dv0", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", "  ", "v0"}], " ", "+", " ", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
   3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
   3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
   3.776616360243341*^9, 3.776616389763185*^9}, {3.776616473018384*^9, 
   3.7766164790371*^9}, 3.776947632081208*^9, 3.7769478776715317`*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"48462b44-b891-42a8-998f-37b74e902302"],

Cell[BoxData[
 FractionBox[
  RowBox[{"sqb", " ", 
   RowBox[{"(", 
    RowBox[{"dh", "+", 
     FractionBox[
      RowBox[{"dk", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
     RowBox[{"dv0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", " ", "v0"}], "+", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g2", " ", "v0"}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
         SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"]], "Output",
 CellChangeTimes->{3.776202160614881*^9, 3.7766164810276527`*^9, 
  3.777046244665285*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"798c0e57-0f25-44c6-9e84-a28027278d29"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr", " ", "=", " ", 
  RowBox[{
   RowBox[{
    FractionBox["dgamma", "sqb"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"zeta", " ", "g1"}], "+", 
      RowBox[{"eta", " ", "g0"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dk", 
     RowBox[{"beta", " ", "r0", " "}]], 
    RowBox[{"(", 
     RowBox[{"r0", "-", "r", "-", 
      RowBox[{"k", " ", "g2"}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["1", 
        RowBox[{"beta", " ", 
         SuperscriptBox["r0", "3"]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", 
          RowBox[{"(", 
           RowBox[{"r", "+", 
            RowBox[{"k", " ", "g2"}]}], ")"}]}], "-", 
         RowBox[{"zeta", " ", "r0", " ", "g0"}]}], ")"}], "x0"}], " ", "+", 
      " ", 
      RowBox[{"g1", "  ", "v0"}]}], ")"}]}], " ", "+", " ", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "k", " ", "g2"}]}], ")"}], " ", 
       FractionBox["v0", "beta"]}], " ", "+", " ", 
      RowBox[{"g1", " ", "x0"}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776198428651246*^9, 3.7761985237438927`*^9}, {
   3.7766163976826477`*^9, 3.776616471914287*^9}, 3.777046226908575*^9},
 CellLabel->"In[2]:=",ExpressionUUID->"ec64950c-8ed3-4bc5-92a5-293069313a0b"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}]}], 
   RowBox[{"beta", " ", "r0"}]], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], "beta"], 
     "+", 
     RowBox[{"g1", " ", "x0"}]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"dh", "+", 
      FractionBox[
       RowBox[{"dk", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
      RowBox[{"dv0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
      RowBox[{"dx0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "v0"}], "+", 
     FractionBox[
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776202167353901*^9, 3.7766164851357393`*^9, 
  3.777046246190269*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"0da36afe-3ffb-4657-b038-690bcf188d71"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dbeta", " ", "=", " ", 
  RowBox[{
   RowBox[{"2", "*", 
    RowBox[{"dk", "/", "r0"}]}], "-", 
   RowBox[{"2", "*", 
    RowBox[{"k", "/", 
     RowBox[{"r0", "^", "3"}]}], "*", " ", 
    RowBox[{"(", 
     RowBox[{"dx0", " ", "*", " ", "x0"}], ")"}]}], " ", "-", " ", 
   RowBox[{"2", "*", "v0", " ", "*", " ", "dv0"}]}]}]], "Input",
 CellChangeTimes->{{3.776198629796771*^9, 3.776198668928054*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"95296aac-8480-48bf-b720-90060933f9ed"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", "dk"}], "r0"], "-", 
  RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
  FractionBox[
   RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
   SuperscriptBox["r0", "3"]]}]], "Output",
 CellChangeTimes->{3.776198669836025*^9, 3.7762021775425386`*^9, 
  3.7766164927868137`*^9, 3.777046248951951*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"9380a9d8-974d-4a1e-83c8-a233820a0c75"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr0", " ", "=", " ", 
  RowBox[{"dx0", " ", "*", " ", 
   RowBox[{"x0", " ", "/", " ", "r0"}]}]}]], "Input",
 CellChangeTimes->{{3.776198724170291*^9, 3.776198736866087*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"6e130959-e5af-4389-aed5-d86ced425512"],

Cell[BoxData[
 FractionBox[
  RowBox[{"dx0", " ", "x0"}], "r0"]], "Output",
 CellChangeTimes->{3.776198740240225*^9, 3.776202183604251*^9, 
  3.776616494745343*^9, 3.777046250797785*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"aa27bf58-5e5e-4d4c-b447-c36e535e59cc"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{" ", 
   RowBox[{
    RowBox[{"Now", " ", "for", " ", "d", " ", 
     RowBox[{"(", 
      RowBox[{"f", "-", "1", "-", 
       RowBox[{"h", " ", "fdot"}]}], ")"}], " ", "for", " ", "drift"}], "-", 
    RowBox[{"last", " ", 
     RowBox[{"case", ":"}]}]}], " ", ")"}]}]], "Input",
 CellChangeTimes->{{3.776258566484967*^9, 3.776258574345611*^9}, {
   3.7762590835501537`*^9, 3.7762590836374397`*^9}, {3.776259116907651*^9, 
   3.7762591197329206`*^9}, 3.776521078478303*^9, {3.776616498984494*^9, 
   3.776616512695982*^9}},ExpressionUUID->"2d884b31-7a55-4520-bbb8-\
26a9cd31ce07"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dfm1mhfdot", " ", "=", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{"r0", " ", 
      SuperscriptBox["r", "2"]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"r", " ", "dk"}], " ", "-", 
      RowBox[{"k", " ", "dr"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g2", " ", "r0"}], " ", "-", " ", 
      RowBox[{"k", " ", "h1"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["k", "r"], 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g1", " ", "dgamma"}], "sqb"], "-", 
      RowBox[{
       FractionBox["dbeta", "beta"], "g2"}], " ", "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["dk", "r0"], "-", 
         FractionBox[
          RowBox[{"k", " ", "dr0", " "}], 
          SuperscriptBox["r0", "2"]]}], ")"}], "h1"}], " ", "-", 
      RowBox[{
       FractionBox["k", "r0"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          FractionBox["h2", "sqb"], "dgamma"}], "-", 
         RowBox[{
          FractionBox[
           RowBox[{"2", " ", "dbeta"}], "beta"], "h1"}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7762585761216097`*^9, 3.77625860781793*^9}, {
   3.776259100727673*^9, 3.776259100829246*^9}, {3.776616516007222*^9, 
   3.776616703078433*^9}, {3.7766169376542177`*^9, 3.776616947701645*^9}, {
   3.776617978626844*^9, 3.776618092271991*^9}, 3.776619122588566*^9, {
   3.776620059682043*^9, 3.776620073384857*^9}, {3.776620137378751*^9, 
   3.7766201612323627`*^9}, {3.776623048793311*^9, 3.776623048842722*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"a6c48c41-52a5-424e-8082-2ada96dd916c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "r"], 
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"g2", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"2", " ", "dk"}], "r0"], "-", 
           RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
           FractionBox[
            RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
            SuperscriptBox["r0", "3"]]}], ")"}]}], "beta"]}], "-", 
      RowBox[{"h1", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["dk", "r0"], "-", 
         FractionBox[
          RowBox[{"dx0", " ", "k", " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], "+", 
      FractionBox[
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{"dh", "+", 
          FractionBox[
           RowBox[{"dk", " ", 
            RowBox[{"(", 
             RowBox[{"d", "-", 
              RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
          RowBox[{"dv0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "v0"}], "+", 
             RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
          RowBox[{"dx0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "v0"}], "+", 
             FractionBox[
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", " ", "k"}], "+", 
                 RowBox[{"g1", " ", 
                  SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
              SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"2", " ", "h1", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"2", " ", "dk"}], "r0"], "-", 
               RowBox[{"2", " ", "dv0", " ", "v0"}], "-", 
               FractionBox[
                RowBox[{"2", " ", "dx0", " ", "k", " ", "x0"}], 
                SuperscriptBox["r0", "3"]]}], ")"}]}], "beta"]}], "+", 
          FractionBox[
           RowBox[{"h2", " ", 
            RowBox[{"(", 
             RowBox[{"dh", "+", 
              FractionBox[
               RowBox[{"dk", " ", 
                RowBox[{"(", 
                 RowBox[{"d", "-", 
                  RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
              RowBox[{"dv0", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", " ", "v0"}], "+", 
                 RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
              RowBox[{"dx0", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"g2", " ", "v0"}], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"d", " ", "k"}], "+", 
                    RowBox[{"g1", " ", 
                    SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
                  SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"]}], 
         ")"}]}], "r0"]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SuperscriptBox["r", "2"], " ", "r0"}]], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "h1"}], " ", "k"}], "+", 
      RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"dk", " ", "r"}], "-", 
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"dk", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}]}], 
          RowBox[{"beta", " ", "r0"}]], "+", 
         RowBox[{"dv0", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g1"}], "+", 
                RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], 
             "beta"], "+", 
            RowBox[{"g1", " ", "x0"}]}], ")"}]}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{"dh", "+", 
             FractionBox[
              RowBox[{"dk", " ", 
               RowBox[{"(", 
                RowBox[{"d", "-", 
                 RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
             RowBox[{"dv0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", " ", "v0"}], "+", 
                RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
             RowBox[{"dx0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "v0"}], "+", 
                FractionBox[
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"d", " ", "k"}], "+", 
                    RowBox[{"g1", " ", 
                    SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
                 SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
         RowBox[{"dx0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "v0"}], "+", 
            FractionBox[
             RowBox[{"x0", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
                RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
             RowBox[{"beta", " ", 
              SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Output",
 CellChangeTimes->{3.776620193624681*^9, 3.776623061126111*^9, 
  3.7770462586187887`*^9, 3.777051295364431*^9},
 CellLabel->"Out[37]=",ExpressionUUID->"0f231a7d-c2dc-43fa-ae92-8ed490b55b83"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"dx0", ",", "dv0", ",", "dk", ",", "dh"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.776258616039044*^9, 3.776258625845273*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"c50ee62d-22cf-45d5-85af-1fc4bc50ccb2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "k"}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"4", " ", "h1", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "k"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"h1", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "h1"}], " ", "k"}], "+", 
       RowBox[{"g2", " ", "r0"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "k", " ", "v0"}], 
      RowBox[{"beta", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{"4", " ", "h1", " ", 
       SuperscriptBox["k", "2"], " ", "v0"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], 
          "beta"], "+", 
         RowBox[{"g1", " ", "x0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "3"], " ", "x0"}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "4"]}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", 
       SuperscriptBox["k", "2"], " ", "x0"}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{"h1", " ", 
       SuperscriptBox["k", "2"], " ", "x0"}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{"x0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7766201991527157`*^9, 3.7766230661278133`*^9, 
  3.77704626825769*^9, 3.777051297506824*^9},
 CellLabel->"Out[38]=",ExpressionUUID->"2cfd0f53-8a60-43b5-ac76-ec7eea1ee595"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Collect", " ", "x0"}], " ", "&"}], " ", "v0", " ", "in", " ", 
      "dv0"}], " ", "&"}], " ", "dx0", " ", 
    RowBox[{"terms", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"First", ",", " ", 
    RowBox[{"dx0", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776258919746063*^9, 
  3.776258947304412*^9}},ExpressionUUID->"5016d470-2559-42c7-9097-\
a15b73e2e0c2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "3"], " ", "x0"}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "4"]}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", 
       SuperscriptBox["k", "2"], " ", "x0"}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{"h1", " ", 
       SuperscriptBox["k", "2"], " ", "x0"}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "3"]}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{"x0", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7762589351786823`*^9, 3.7762589524160213`*^9}, 
   3.7766169978896017`*^9, 3.776618164429405*^9, 3.776620099741139*^9, 
   3.7766202080449142`*^9, 3.7766230875293007`*^9, 3.777046308359079*^9},
 CellLabel->"In[7]:=",ExpressionUUID->"86606400-4dcd-4a36-bd1d-3a1e6bba1e6b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g1", " ", "g2", " ", "k"}], 
       SuperscriptBox["r", "2"]]}], "+", 
     FractionBox[
      RowBox[{"g2", " ", "h2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "3"]}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "4"]}]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{"h1", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{"r", " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "3"]}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "k"}], "+", 
         RowBox[{"g1", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "4"]}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "4"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776620209111361*^9, 3.776623088335967*^9, 
  3.7770463090779877`*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"bf0a6582-47f2-44df-b4bc-47e2a00ce439"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Next", ",", " ", 
   RowBox[{"dv0", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776258958098084*^9, 3.77625896130404*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"93376667-ae79-4f2c-bce9-f4e105374de8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "k", " ", "v0"}], 
      RowBox[{"beta", " ", "r"}]], "-", 
     FractionBox[
      RowBox[{"4", " ", "h1", " ", 
       SuperscriptBox["k", "2"], " ", "v0"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], 
          "beta"], "+", 
         RowBox[{"g1", " ", "x0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      SuperscriptBox["r", "2"]], "+", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.776258972640501*^9, 3.7762589774726753`*^9}, 
   3.776617010769013*^9, 3.776618177123947*^9, 3.77662010951578*^9, 
   3.776620216181149*^9, 3.776623078818287*^9, {3.7770462929752073`*^9, 
   3.777046317293231*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"4c137373-3aac-4897-9d22-41fe9976ebba"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"d", " ", "g1", " ", "k"}], 
       SuperscriptBox["r", "2"]]}], "+", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "k"}], 
      RowBox[{"beta", " ", "r"}]], "+", 
     FractionBox[
      RowBox[{"d", " ", "h2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"4", " ", "h1", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"d", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"g1", " ", "g2", " ", "k"}], 
       SuperscriptBox["r", "2"]]}], "+", 
     FractionBox[
      RowBox[{"g2", " ", "h2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{"g2", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776620217383945*^9, 3.776623079594092*^9, 
  3.7770463179451838`*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"5208d4ae-9cec-4351-a186-0183944f9c8c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Final", " ", "dfm1mhfdot", " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776258980760725*^9, 3.776258984807379*^9}, {
  3.776259093949028*^9, 3.7762590940371437`*^9}, {3.776542815269114*^9, 
  3.776542828219266*^9}, {3.7766170186672497`*^9, 3.776617024371574*^9}, {
  3.776618198007195*^9, 
  3.776618198535988*^9}},ExpressionUUID->"d4d207ae-e603-472b-bd2a-\
7645ab9a44c9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dfm1mhfdot", " ", "=", 
  RowBox[{
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"g1", " ", "k"}], 
       SuperscriptBox["r", "2"]], "-", 
      FractionBox[
       RowBox[{"h2", " ", 
        SuperscriptBox["k", "2"]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "2"]}], 
       RowBox[{"beta", " ", "r", " ", 
        SuperscriptBox["r0", "2"]}]], "-", 
      FractionBox[
       RowBox[{"2", " ", "g2", " ", "k"}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"h1", " ", "k"}], 
       RowBox[{"r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "h1"}], " ", "k"}], "+", 
        RowBox[{"g2", " ", "r0"}]}], 
       RowBox[{"r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox["r0", "2"]}]], "-", 
      FractionBox[
       RowBox[{"h2", " ", 
        SuperscriptBox["k", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox["r0", "2"]}]], "+", 
      FractionBox[
       RowBox[{"g1", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "3"], " ", 
        SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"d", " ", "g1", " ", "k"}], 
           SuperscriptBox["r", "2"]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", "g2", " ", "k"}], 
          RowBox[{"beta", " ", "r"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", "h2", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"4", " ", "h1", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"d", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g1", " ", "g2", " ", "k"}], 
           SuperscriptBox["r", "2"]]}], "+", 
         FractionBox[
          RowBox[{"g2", " ", "h2", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}]}], ")"}]}], "+", 
   
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"g1", " ", "g2", " ", "k"}], 
           SuperscriptBox["r", "2"]]}], "+", 
         FractionBox[
          RowBox[{"g2", " ", "h2", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{"g2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "h1", " ", 
            SuperscriptBox["k", "3"]}], 
           RowBox[{"beta", " ", "r", " ", 
            SuperscriptBox["r0", "4"]}]]}], "+", 
         FractionBox[
          RowBox[{"2", " ", "g2", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox[
          RowBox[{"h1", " ", 
           SuperscriptBox["k", "2"]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox[
          RowBox[{"h2", " ", 
           SuperscriptBox["k", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"g1", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "3"]}]], "+", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox["r", "3"], " ", 
           SuperscriptBox["r0", "4"]}]], "-", 
         FractionBox[
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776258995599614*^9, 3.776259029056012*^9}, {
   3.7762590959366198`*^9, 3.77625909602941*^9}, {3.776617017203174*^9, 
   3.776617069848213*^9}, {3.776618193679949*^9, 3.776618218045624*^9}, 
   3.776619113105009*^9, 3.776620118155706*^9, {3.776620229689068*^9, 
   3.776620250008428*^9}, {3.776623104381906*^9, 3.776623124265459*^9}, {
   3.77704633166483*^9, 3.7770463458379*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"71c53a07-8e97-43ef-b6c9-30d71d21b7fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "k"}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"4", " ", "h1", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "k"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"h1", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "h1"}], " ", "k"}], "+", 
       RowBox[{"g2", " ", "r0"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "g1", " ", "k"}], 
          SuperscriptBox["r", "2"]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "g2", " ", "k"}], 
         RowBox[{"beta", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"4", " ", "h1", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g1", " ", "g2", " ", "k"}], 
          SuperscriptBox["r", "2"]]}], "+", 
        FractionBox[
         RowBox[{"g2", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g1", " ", "g2", " ", "k"}], 
          SuperscriptBox["r", "2"]]}], "+", 
        FractionBox[
         RowBox[{"g2", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", "h1", " ", 
           SuperscriptBox["k", "3"]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "4"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "g2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"h1", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"h2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776620251526433*^9, 3.776623126546146*^9, 
  3.777046347158668*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"11b81da4-e26a-423f-b1a9-5e96243cbdb1"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Revised", " ", "expression", " ", "for", " ", "d", 
    RowBox[{"(", 
     RowBox[{"f", "-", "1", "-", 
      RowBox[{"h", " ", "fdot"}]}], ")"}]}], ":"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7766190859099903`*^9, 
  3.776619098908731*^9}},ExpressionUUID->"737a2b71-af6e-49a2-8fb6-\
9769070ef2d4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"c1", "=", 
    RowBox[{"d", "-", 
     RowBox[{"r0", " ", "g3"}]}]}], "\n", 
   RowBox[{"c2", "=", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"g1", " ", "zeta"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"c3", "=", 
    RowBox[{
     RowBox[{"d", " ", "k"}], "+", 
     RowBox[{"g1", " ", 
      SuperscriptBox["r0", "2"]}]}]}], "\n", 
   RowBox[{"c14", "=", 
    RowBox[{
     RowBox[{"r0", " ", "g2"}], "-", 
     RowBox[{"k", " ", "h1"}]}]}], "\n", 
   RowBox[{"c17", "=", 
    RowBox[{"r0", "-", "r", "-", 
     RowBox[{"g2", " ", "k"}]}]}], "\n", 
   RowBox[{"c18", "=", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"2", " ", "g2", " ", "k"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"c23", " ", "=", " ", 
    RowBox[{
     RowBox[{"h2", " ", "k"}], " ", "-", " ", 
     RowBox[{"r0", " ", "g1"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.77704660087945*^9, 3.7770466200267677`*^9}, {
  3.777046996336483*^9, 3.777047003600148*^9}, {3.777047393376198*^9, 
  3.777047415332081*^9}, {3.777048264217287*^9, 3.777048269880295*^9}},
 CellLabel->
  "In[187]:=",ExpressionUUID->"91ab92d8-9507-4b23-90cf-42efcb27b1a1"],

Cell[BoxData[
 RowBox[{"d", "-", 
  RowBox[{"g3", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.777048135934217*^9, 3.7770482712684298`*^9, 
  3.778034291660984*^9},
 CellLabel->
  "Out[187]=",ExpressionUUID->"3d551d09-f38b-4070-9278-bec65ea6328a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g0"}], "+", 
  RowBox[{"g1", " ", "zeta"}]}]], "Output",
 CellChangeTimes->{3.777048135934217*^9, 3.7770482712684298`*^9, 
  3.7780342916628*^9},
 CellLabel->
  "Out[188]=",ExpressionUUID->"3228bc45-dc3c-4885-a15e-0cc82ea2d4a9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", " ", "k"}], "+", 
  RowBox[{"g1", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.777048135934217*^9, 3.7770482712684298`*^9, 
  3.7780342916654587`*^9},
 CellLabel->
  "Out[189]=",ExpressionUUID->"3374a59f-afbc-4733-9177-f73cdf2ec958"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "h1"}], " ", "k"}], "+", 
  RowBox[{"g2", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.777048135934217*^9, 3.7770482712684298`*^9, 
  3.7780342916678143`*^9},
 CellLabel->
  "Out[190]=",ExpressionUUID->"494533d3-b1a9-4f1b-a76e-ea133c686e48"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}]], "Output",
 CellChangeTimes->{3.777048135934217*^9, 3.7770482712684298`*^9, 
  3.7780342916693907`*^9},
 CellLabel->
  "Out[191]=",ExpressionUUID->"5e650227-99a3-4495-952b-ccad009fd301"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g1"}], "+", 
  RowBox[{"2", " ", "g2", " ", "k"}]}]], "Output",
 CellChangeTimes->{3.777048135934217*^9, 3.7770482712684298`*^9, 
  3.7780342916709633`*^9},
 CellLabel->
  "Out[192]=",ExpressionUUID->"a7297e56-13a8-47e6-a4f9-964d5d5e03cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"h2", " ", "k"}], "-", 
  RowBox[{"g1", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.777048135934217*^9, 3.7770482712684298`*^9, 
  3.778034291672592*^9},
 CellLabel->
  "Out[193]=",ExpressionUUID->"99e0f935-79c2-412e-9450-93dfe1e704d1"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.777119329023163*^9, 3.777119330701213*^9}, {
  3.7771194136750507`*^9, 
  3.77711941532977*^9}},ExpressionUUID->"33422313-391a-4ddb-a83f-\
5184bef61a6d"],

Cell[BoxData[
 RowBox[{"dfm1mhfdot2", " ", "=", 
  RowBox[{
   RowBox[{
    FractionBox["dh", 
     SuperscriptBox["r", "2"]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", "k"}], "-", 
      FractionBox[
       RowBox[{"h2", " ", 
        SuperscriptBox["k", "2"]}], "r0"], "-", 
      FractionBox[
       RowBox[{"k", " ", "c14", " ", "c2"}], 
       RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dk", 
     RowBox[{"r", " ", "r0"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "2"]}], 
       RowBox[{"beta", " ", "r0"}]], "-", 
      RowBox[{"k", " ", "h1"}], "-", 
      FractionBox[
       RowBox[{"2", " ", "g2", " ", "k"}], 
       RowBox[{"beta", " "}]], "+", "c14", "-", 
      FractionBox[
       RowBox[{"k", " ", "c14", " ", "c17", " "}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"k", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "r0"}], " ", "-", 
          RowBox[{"k", " ", "h2"}]}], ")"}], " ", "c1"}], 
       RowBox[{"r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", "c14", " ", "c1", " ", "c2"}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{
    FractionBox[
     RowBox[{"k", " ", "dv0"}], 
     RowBox[{"r0", " ", 
      SuperscriptBox["r", "2"]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["v0", "beta"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"r", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "g2", " ", "r0"}], " ", "-", 
            RowBox[{"4", " ", "h1", " ", "k"}]}], ")"}]}], "+", 
         RowBox[{"d", "  ", "beta", " ", "c23"}], "-", 
         RowBox[{"c18", " ", "c14"}], "+", 
         FractionBox[
          RowBox[{"d", " ", "beta", " ", "c14", " ", "c2"}], "r"]}], ")"}]}], 
      "+", 
      RowBox[{"x0", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"h2", " ", "g2"}], "+", 
            RowBox[{"g1", " ", "h1"}]}], ")"}]}], "-", 
         RowBox[{"2", "r0", " ", "g1", " ", "g2"}], " ", "+", 
         FractionBox[
          RowBox[{"g2", " ", "c14", " ", "c2"}], "r"]}], ")"}]}]}], ")"}]}], 
   "+", 
   RowBox[{
    FractionBox[
     RowBox[{"k", " ", "dx0"}], 
     RowBox[{
      SuperscriptBox["r", "2"], "r0"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", 
       RowBox[{"(", " ", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "h2"}], "+", 
            RowBox[{"g1", " ", "h1"}]}], ")"}]}], "-", 
         RowBox[{"2", "g1", " ", "g2", " ", "r0"}], "+", 
         FractionBox[
          RowBox[{"g2", " ", "c14", " ", "c2"}], "r"]}], ")"}]}], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"x0", " "}], 
        RowBox[{"beta", " ", "r", " ", 
         SuperscriptBox["r0", "3"]}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", "h1", " ", 
          SuperscriptBox["r", "2"], " ", "r0", " ", 
          RowBox[{"(", 
           RowBox[{"beta", "-", 
            FractionBox[
             RowBox[{"2", "k"}], "r0"]}], ")"}]}], "+", 
         RowBox[{"beta", " ", "c3", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"r", " ", "c23"}], "+", 
            RowBox[{"c14", " ", "c2"}]}], ")"}]}], "+", 
         RowBox[{"c14", " ", "r", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", 
             RowBox[{"(", 
              RowBox[{"r", "-", 
               RowBox[{"g2", " ", "k"}]}], ")"}]}], "+", " ", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776618747190886*^9, 3.7766187962868557`*^9}, {
   3.776618864012754*^9, 3.776619053834703*^9}, {3.776619101892602*^9, 
   3.776619110950803*^9}, {3.776619191067894*^9, 3.77661927302089*^9}, {
   3.7766193459784603`*^9, 3.776619357058489*^9}, {3.776619833609288*^9, 
   3.776619925462152*^9}, 3.776620122115419*^9, {3.776620262177127*^9, 
   3.7766203520776854`*^9}, {3.776623137075754*^9, 3.776623233287178*^9}, {
   3.777046350088826*^9, 3.777046423917327*^9}, {3.7770464555583563`*^9, 
   3.777046467830433*^9}, {3.777046532755209*^9, 3.777046597761901*^9}, {
   3.777046714392606*^9, 3.777046749528872*^9}, {3.777046825871044*^9, 
   3.777046979234511*^9}, {3.7770470573262033`*^9, 3.777047064170298*^9}, {
   3.77704712914056*^9, 3.777047237856758*^9}, {3.7770472720658503`*^9, 
   3.777047364054055*^9}, {3.777047480590691*^9, 3.777047549579108*^9}, {
   3.777047592516123*^9, 3.777047639450409*^9}, {3.777047670224207*^9, 
   3.7770476754057207`*^9}, {3.777048040957264*^9, 3.777048092477085*^9}, {
   3.7770481918548317`*^9, 3.777048224761718*^9}, {3.777048274121707*^9, 
   3.7770482853510923`*^9}, {3.777048321807618*^9, 3.777048476236085*^9}, {
   3.777048510114871*^9, 3.777048530266306*^9}, {3.7770486593198357`*^9, 
   3.7770486849760647`*^9}, {3.777048785192967*^9, 3.777048785550406*^9}, {
   3.777048881146254*^9, 3.77704892487068*^9}, {3.777049003908394*^9, 
   3.777049020251327*^9}, {3.7770490569343433`*^9, 3.777049129733665*^9}, {
   3.777051342623516*^9, 3.7770514414044123`*^9}, {3.777051480584944*^9, 
   3.7770515387630167`*^9}, {3.777051752066124*^9, 3.77705180085056*^9}, {
   3.777051839373564*^9, 3.777051874525782*^9}, {3.777051914899572*^9, 
   3.777051929959476*^9}, {3.777051965246253*^9, 3.777052000231707*^9}, {
   3.777052045859363*^9, 3.777052047905987*^9}, {3.7770522490513477`*^9, 
   3.777052319593055*^9}, {3.777052381410162*^9, 3.777052398919929*^9}, {
   3.7771194086346188`*^9, 3.777119408972628*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"4321d870-f29f-4814-817c-fee11a6a61b8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"TeXForm", "[", 
   RowBox[{
    RowBox[{
     FractionBox["dh", 
      SuperscriptBox["r", "2"]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g1", " ", "k"}], "-", 
       FractionBox[
        RowBox[{"h2", " ", 
         SuperscriptBox["k", "2"]}], "r0"], "-", 
       FractionBox[
        RowBox[{"k", " ", "c14", " ", "c2"}], 
        RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
    RowBox[{
     FractionBox["dk", 
      RowBox[{"r", " ", "r0"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"4", " ", "h1", " ", 
         SuperscriptBox["k", "2"]}], 
        RowBox[{"beta", " ", "r0"}]], "-", 
       RowBox[{"k", " ", "h1"}], "-", 
       FractionBox[
        RowBox[{"2", " ", "g2", " ", "k"}], 
        RowBox[{"beta", " "}]], "+", "c14", "-", 
       FractionBox[
        RowBox[{"k", " ", "c14", " ", "c17", " "}], 
        RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
       FractionBox[
        RowBox[{"k", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "r0"}], " ", "-", 
           RowBox[{"k", " ", "h2"}]}], ")"}], " ", "c1"}], 
        RowBox[{"r", " ", "r0"}]], "-", 
       FractionBox[
        RowBox[{"k", " ", "c14", " ", "c1", " ", "c2"}], 
        RowBox[{
         SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], "+", 
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", "dv0"}], 
      RowBox[{"r0", " ", 
       SuperscriptBox["r", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["v0", "beta"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"r", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "g2", " ", "r0"}], " ", "-", 
             RowBox[{"4", " ", "h1", " ", "k"}]}], ")"}]}], "+", 
          RowBox[{"d", "  ", "beta", " ", "c23"}], "-", 
          RowBox[{"c18", " ", "c14"}], "+", 
          FractionBox[
           RowBox[{"d", " ", "beta", " ", "c14", " ", "c2"}], "r"]}], ")"}]}],
        "+", 
       RowBox[{"x0", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"h2", " ", "g2"}], "+", 
             RowBox[{"g1", " ", "h1"}]}], ")"}]}], "-", 
          RowBox[{"2", "r0", " ", "g1", " ", "g2"}], " ", "+", 
          FractionBox[
           RowBox[{"g2", " ", "c14", " ", "c2"}], "r"]}], ")"}]}]}], ")"}]}], 
    "+", 
    RowBox[{
     FractionBox[
      RowBox[{"k", " ", "dx0"}], 
      RowBox[{
       SuperscriptBox["r", "2"], "r0"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"v0", 
        RowBox[{"(", " ", 
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "h2"}], "+", 
             RowBox[{"g1", " ", "h1"}]}], ")"}]}], "-", 
          RowBox[{"2", "g1", " ", "g2", " ", "r0"}], "+", 
          FractionBox[
           RowBox[{"g2", " ", "c14", " ", "c2"}], "r"]}], ")"}]}], "+", 
       RowBox[{
        FractionBox[
         RowBox[{"x0", " "}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"k", " ", "h1", " ", 
           SuperscriptBox["r", "2"], " ", "r0", " ", 
           RowBox[{"(", 
            RowBox[{"beta", "-", 
             FractionBox[
              RowBox[{"2", "k"}], "r0"]}], ")"}]}], "+", 
          RowBox[{"beta", " ", "c3", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"r", " ", "c23"}], "+", 
             RowBox[{"c14", " ", "c2"}]}], ")"}]}], "+", 
          RowBox[{"c14", " ", "r", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", 
              RowBox[{"(", 
               RowBox[{"r", "-", 
                RowBox[{"g2", " ", "k"}]}], ")"}]}], "+", " ", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}]}], ")"}]}]}], 
      ")"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777316025111103*^9, 3.777316038949564*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"276170f5-94e3-4e59-a0d8-6141133c8cb9"],

Cell["\<\
\\frac{\\text{dk} \\left(-\\frac{\\text{c14} \\text{c17} k}{\\beta  r \
\\text{r0}}-\\frac{2 \\text{g2} k}{\\beta }+\\frac{4
   \\text{h1} k^2}{\\beta  \\text{r0}}-\\frac{\\text{c1} \\text{c14} \
\\text{c2} k}{r^2 \\text{r0}}+\\frac{\\text{c1} k
   (\\text{g1} \\text{r0}-\\text{h2} k)}{r \\text{r0}}+\\text{c14}-\\text{h1} \
k\\right)}{r \\text{r0}}+\\frac{\\text{dv0} k
   \\left(\\frac{\\text{v0} \\left(\\frac{\\beta  \\text{c14} \\text{c2} \
d}{r}+\\beta  \\text{c23} d-\\text{c14} \\text{c18}+r (2
   \\text{g2} \\text{r0}-4 \\text{h1} k)\\right)}{\\beta }+\\text{x0} \\left(\
\\frac{\\text{c14} \\text{c2} \\text{g2}}{r}+k
   (\\text{g1} \\text{h1}+\\text{g2} \\text{h2})-2 \\text{g1} \\text{g2} \
\\text{r0}\\right)\\right)}{r^2
   \\text{r0}}+\\frac{\\text{dx0} k \\left(\\frac{\\text{x0} \\left(\\beta  \
\\text{c3} (\\text{c14} \\text{c2}+\\text{c23}
   r)+\\text{h1} k r^2 \\text{r0} \\left(\\beta -\\frac{2 \
k}{\\text{r0}}\\right)+\\text{c14} r (\\text{g0} \\text{r0} \\zeta +k
   (r-\\text{g2} k))\\right)}{\\beta  r \\text{r0}^3}+\\text{v0} \
\\left(\\frac{\\text{c14} \\text{c2} \\text{g2}}{r}+k
   (\\text{g1} \\text{h1}+\\text{g2} \\text{h2})-2 \\text{g1} \\text{g2} \
\\text{r0}\\right)\\right)}{r^2
   \\text{r0}}+\\frac{\\text{dh} \\left(-\\frac{\\text{c14} \\text{c2} k}{r \
\\text{r0}}+\\text{g1} k-\\frac{\\text{h2}
   k^2}{\\text{r0}}\\right)}{r^2}\
\>", "Output",
 CellChangeTimes->{
  3.777119419960515*^9, {3.777316030713002*^9, 3.777316039485297*^9}},
 CellLabel->
  "Out[6]//TeXForm=",ExpressionUUID->"da59c358-c398-406d-942d-095986ed96bf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dfm1mhfdot", "-", "dfm1mhfdot2"}]], "Input",
 CellChangeTimes->{{3.7770481411570797`*^9, 3.777048149342802*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"e02c3643-07cb-4869-9757-bd019ee75903"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dh", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"g1", " ", "k"}], 
      SuperscriptBox["r", "2"]], "-", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g1", " ", "k"}], "-", 
      FractionBox[
       RowBox[{"h2", " ", 
        SuperscriptBox["k", "2"]}], "r0"], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]]}], ")"}]}], 
   SuperscriptBox["r", "2"]], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"4", " ", "h1", " ", 
       SuperscriptBox["k", "2"]}], 
      RowBox[{"beta", " ", "r", " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"2", " ", "g2", " ", "k"}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"h1", " ", "k"}], 
      RowBox[{"r", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "h1"}], " ", "k"}], "+", 
       RowBox[{"g2", " ", "r0"}]}], 
      RowBox[{"r", " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "-", 
     FractionBox[
      RowBox[{"h2", " ", 
       SuperscriptBox["k", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", 
       SuperscriptBox["r0", "2"]}]], "+", 
     FractionBox[
      RowBox[{"g1", " ", "k", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
     FractionBox[
      RowBox[{"k", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "h1"}], " ", "k"}], "+", 
         RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["r0", "2"]}]]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", "g2", " ", "k"}], "beta"]}], "-", 
      RowBox[{"2", " ", "h1", " ", "k"}], "+", 
      FractionBox[
       RowBox[{"4", " ", "h1", " ", 
        SuperscriptBox["k", "2"]}], 
       RowBox[{"beta", " ", "r0"}]], "+", 
      RowBox[{"g2", " ", "r0"}], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
       RowBox[{"beta", " ", "r", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h2"}], " ", "k"}], "+", 
          RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]], "-", 
      FractionBox[
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "h1"}], " ", "k"}], "+", 
          RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox["r", "2"], " ", "r0"}]]}], ")"}]}], 
   RowBox[{"r", " ", "r0"}]], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SuperscriptBox["r", "2"], " ", "r0"}]], 
   RowBox[{"dv0", " ", "k", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"v0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"beta", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"h2", " ", "k"}], "-", 
             RowBox[{"g1", " ", "r0"}]}], ")"}]}], "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g1"}], "+", 
             RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}]}], "+", 
          RowBox[{"r", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "4"}], " ", "h1", " ", "k"}], "+", 
             RowBox[{"2", " ", "g2", " ", "r0"}]}], ")"}]}], "+", 
          FractionBox[
           RowBox[{"beta", " ", "d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "h1"}], " ", "k"}], "+", 
              RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], 
       "beta"], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h1"}], "+", 
            RowBox[{"g2", " ", "h2"}]}], ")"}], " ", "k"}], "-", 
         RowBox[{"2", " ", "g1", " ", "g2", " ", "r0"}], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}]}], 
     ")"}]}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"d", " ", "g1", " ", "k"}], 
          SuperscriptBox["r", "2"]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "g2", " ", "k"}], 
         RowBox[{"beta", " ", "r"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"4", " ", "h1", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{"beta", " ", "r", " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"d", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g1", " ", "g2", " ", "k"}], 
          SuperscriptBox["r", "2"]]}], "+", 
        FractionBox[
         RowBox[{"g2", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"g1", " ", "g2", " ", "k"}], 
          SuperscriptBox["r", "2"]]}], "+", 
        FractionBox[
         RowBox[{"g2", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", "r0"}]], "+", 
        FractionBox[
         RowBox[{"g2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", "r0"}]]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", "h1", " ", 
           SuperscriptBox["k", "3"]}], 
          RowBox[{"beta", " ", "r", " ", 
           SuperscriptBox["r0", "4"]}]]}], "+", 
        FractionBox[
         RowBox[{"2", " ", "g2", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{"beta", " ", "r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"h1", " ", 
          SuperscriptBox["k", "2"]}], 
         RowBox[{"r", " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"h2", " ", 
          SuperscriptBox["k", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"g1", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "3"]}]], "+", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox["r0", "4"]}]], "-", 
        FractionBox[
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "h1"}], " ", "k"}], "+", 
            RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
            RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r", "2"], " ", 
          SuperscriptBox["r0", "4"]}]]}], ")"}]}]}], ")"}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SuperscriptBox["r", "2"], " ", "r0"}]], 
   RowBox[{"dx0", " ", "k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "h1"}], "+", 
            RowBox[{"g2", " ", "h2"}]}], ")"}], " ", "k"}], "-", 
         RowBox[{"2", " ", "g1", " ", "g2", " ", "r0"}], "+", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"beta", " ", "r", " ", 
         SuperscriptBox["r0", "3"]}]], 
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"h1", " ", "k", " ", 
           SuperscriptBox["r", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"beta", "-", 
             FractionBox[
              RowBox[{"2", " ", "k"}], "r0"]}], ")"}], " ", "r0"}], "+", 
          RowBox[{"r", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "h1"}], " ", "k"}], "+", 
             RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"k", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "g2"}], " ", "k"}], "+", "r"}], ")"}]}], "+", 
             RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], "+", 
          RowBox[{"beta", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"r", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"h2", " ", "k"}], "-", 
                RowBox[{"g1", " ", "r0"}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "h1"}], " ", "k"}], "+", 
                RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"eta", " ", "g0"}], "+", 
                RowBox[{"g1", " ", "zeta"}]}], ")"}]}]}], ")"}]}]}], 
         ")"}]}]}]}], ")"}]}]}]}]], "Output",
 CellChangeTimes->{3.777119256411951*^9, 3.7771194242063313`*^9},
 CellLabel->"Out[21]=",ExpressionUUID->"a8a101f9-c71f-44b5-89d1-fddb970ae33e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777048154734131*^9, 3.777048155845096*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"fede4484-8d1f-46f2-9df2-d64a9830e6b1"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.777048156151433*^9, 3.7770481987131367`*^9, 
  3.777048743794833*^9, 3.7770487923281393`*^9, 3.7770489807523623`*^9, 
  3.77705145815289*^9, 3.777052109783736*^9, 3.7771192588005667`*^9, 
  3.777119426060656*^9},
 CellLabel->"Out[22]=",ExpressionUUID->"ca632bec-0ffe-437d-beb2-79d30889e82a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "See", " ", "if", " ", "we", " ", "can", " ", "find", " ", "which", " ", 
   "terms", " ", "cancel", " ", "in", " ", "the", " ", "mass", " ", 
   "derivative", " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7778994145763702`*^9, 3.777899429001958*^9}},
 CellLabel->
  "In[146]:=",ExpressionUUID->"90527861-0697-4050-bd32-37ebbaf390e3"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"First", ",", " ", 
    RowBox[{
    "do", " ", "series", " ", "expansion", " ", "of", " ", "the", " ", 
     "entire", " ", 
     RowBox[{"term", ":"}]}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{
  3.777899445551306*^9, {3.77789988935359*^9, 
   3.777899901913719*^9}},ExpressionUUID->"2b59264e-4f28-4701-bc97-\
695da387d829"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              FractionBox[
               RowBox[{"4", " ", "h1", " ", "k"}], 
               RowBox[{"beta", " ", "r0"}]], "-", " ", "h1", "+", 
              FractionBox[
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"g1", " ", "r0"}], " ", "-", 
                  RowBox[{"k", " ", "h2"}]}], ")"}], " ", "c1"}], 
               RowBox[{"r", " ", "r0"}]], "-", 
              FractionBox[
               RowBox[{"2", " ", "g2", " "}], 
               RowBox[{"beta", " "}]], "-", 
              RowBox[{
               FractionBox["c14", 
                RowBox[{"r", " ", "r0"}]], 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  RowBox[{"  ", "c17", " "}], 
                  RowBox[{"beta", " "}]], "+", 
                 FractionBox[
                  RowBox[{"  ", 
                   RowBox[{"c1", " ", "c2"}]}], "r"]}], ")"}]}]}], " ", "/.", 
             " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777899432842029*^9, 3.77789944366539*^9}, {
  3.777899493925888*^9, 3.777899540500348*^9}, {3.7778996575527678`*^9, 
  3.777899707285532*^9}, {3.7778999042829123`*^9, 3.77789995978237*^9}, {
  3.777902493852702*^9, 3.777902537450769*^9}, {3.777902759043831*^9, 
  3.777902760304099*^9}},
 CellLabel->"In[57]:=",ExpressionUUID->"85ba9264-fb06-41c4-86ef-6e792aaa7dfc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "4"], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "2"]}]], "-", 
   FractionBox[
    RowBox[{"eta", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"4", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"5", "/", "2"}]], " ", "r0"}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"21", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"23", " ", "k", " ", "r0"}], "+", 
       RowBox[{"12", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"72", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 4] $CellContext`beta^(-2), 
    Rational[-1, 4] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta/$CellContext`r0, 
    Rational[1, 72] $CellContext`beta^(-3) $CellContext`r0^(-2) (
     21 $CellContext`eta^2 - 23 $CellContext`k $CellContext`r0 + 
     12 $CellContext`beta $CellContext`r0^2)}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.7778999515793257`*^9, 3.777899960322797*^9}, {
  3.77790275271509*^9, 3.777902761137974*^9}},
 CellLabel->"Out[57]=",ExpressionUUID->"4ff72b57-c24b-40f5-bbd6-88552766ae59"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", " ", "expand", " ", "individual", " ", 
   RowBox[{"terms", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777899969323607*^9, 
  3.7778999759457617`*^9}},ExpressionUUID->"7f18ec60-33f3-4fbc-a981-\
9037c4f90e1e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             FractionBox[
              RowBox[{"4", " ", "h1", " ", "k"}], 
              RowBox[{"beta", " ", "r0"}]], " ", "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.777899983146991*^9},
 CellLabel->"In[18]:=",ExpressionUUID->"bfb6260a-2236-4d9b-9550-ae268ba4bace"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"3", " ", 
     SuperscriptBox["beta", "3"], " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"45", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", "r0"}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 3] $CellContext`beta^(-3) $CellContext`k/$CellContext`r0, 0, 
    Rational[-1, 45] $CellContext`beta^(-3) $CellContext`k/$CellContext`r0}, 
   4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777899985292841*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"361f4d8d-0ff0-460e-a513-f0ba66603cb7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"-", " ", "h1"}], "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777900003827031*^9, 3.777900006009405*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"2dd98b1a-929f-44af-b89b-c2c559b252b9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "4"], 
     RowBox[{"12", " ", 
      SuperscriptBox["beta", "2"]}]]}], "+", 
   FractionBox[
    SuperscriptBox["gamma", "6"], 
    RowBox[{"180", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 12] $CellContext`beta^(-2), 0, 
    Rational[1, 180] $CellContext`beta^(-2)}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7779000068287983`*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"67e339c2-438a-4b7c-8a57-aaf25bcf4d11"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               RowBox[{"2", " ", "g2", " "}], 
               RowBox[{"beta", " "}]]}], " ", "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777900018690282*^9, 3.777900020681231*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"a7da25ae-8599-49e4-9f16-926b1d6f4f81"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "2"], 
     SuperscriptBox["beta", "2"]]}], "+", 
   FractionBox[
    SuperscriptBox["gamma", "4"], 
    RowBox[{"12", " ", 
     SuperscriptBox["beta", "2"]}]], "-", 
   FractionBox[
    SuperscriptBox["gamma", "6"], 
    RowBox[{"360", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 2, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {(-1) $CellContext`beta^(-2), 0, Rational[1, 12] $CellContext`beta^(-2),
     0, Rational[-1, 360] $CellContext`beta^(-2)}, 2, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7779000213904*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"125dc2c7-b8f5-45f2-9b18-0193745052ff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               RowBox[{" ", 
                RowBox[{"c14", " ", "c17", " "}]}], 
               RowBox[{"beta", " ", "r", " ", "r0"}]]}], " ", "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777900070068647*^9, 3.777900074691421*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"8028a242-5121-44b2-8f0b-728489f1f45b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"eta", " ", 
     SuperscriptBox["gamma", "3"]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        SuperscriptBox["eta", "2"]}], "+", 
       RowBox[{"2", " ", "k", " ", "r0"}], "-", 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"12", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"20", " ", "k", " ", "r0"}], "+", 
       RowBox[{"9", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", 
      RowBox[{"7", "/", "2"}]], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "12"}], " ", 
        SuperscriptBox["eta", "4"]}], "+", 
       RowBox[{"26", " ", 
        SuperscriptBox["eta", "2"], " ", "k", " ", "r0"}], "-", 
       RowBox[{"13", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"8", " ", 
        SuperscriptBox["k", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{"8", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "-", 
       RowBox[{"2", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "4"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", "4"], " ", 
     SuperscriptBox["r0", "4"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 2] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta/$CellContext`r0, 
    Rational[1, 
      4] $CellContext`beta^(-3) $CellContext`r0^(-2) ((-2) $CellContext`eta^2 + 
     2 $CellContext`k $CellContext`r0 - $CellContext`beta $CellContext`r0^2), 
    Rational[1, 24] $CellContext`beta^
     Rational[-7, 2] $CellContext`eta $CellContext`r0^(-3) (
     12 $CellContext`eta^2 - 20 $CellContext`k $CellContext`r0 + 
     9 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 
      24] $CellContext`beta^(-4) $CellContext`r0^(-4) ((-12) \
$CellContext`eta^4 + 26 $CellContext`eta^2 $CellContext`k $CellContext`r0 - 
     13 $CellContext`beta $CellContext`eta^2 $CellContext`r0^2 - 
     8 $CellContext`k^2 $CellContext`r0^2 + 
     8 $CellContext`beta $CellContext`k $CellContext`r0^3 - 
     2 $CellContext`beta^2 $CellContext`r0^4)}, 3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777900075155533*^9},
 CellLabel->"Out[21]=",ExpressionUUID->"f48497e6-190d-4eb9-a4e2-274033d28f60"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             FractionBox[
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"g1", " ", "r0"}], " ", "-", 
                 RowBox[{"k", " ", "h2"}]}], ")"}], " ", "c1"}], 
              RowBox[{"r", " ", "r0"}]], " ", "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7779000967580967`*^9, 3.777900100565352*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"f936d82d-5835-42be-80a1-3d3ecd5a0fd9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "2"], 
    SuperscriptBox["beta", "2"]], "-", 
   FractionBox[
    RowBox[{"k", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"3", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "3"], " ", "r0"}], ")"}]}]], "-", 
   FractionBox[
    RowBox[{"eta", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"12", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"5", "/", "2"}]], " ", "r0"}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"15", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"16", " ", "k", " ", "r0"}], "+", 
       RowBox[{"7", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"180", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 2, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {$CellContext`beta^(-2), 0, 
    Rational[-1, 3] $CellContext`beta^(-3) $CellContext`k/$CellContext`r0, 
    Rational[-1, 12] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta/$CellContext`r0, 
    Rational[1, 180] $CellContext`beta^(-3) $CellContext`r0^(-2) (
     15 $CellContext`eta^2 - 16 $CellContext`k $CellContext`r0 + 
     7 $CellContext`beta $CellContext`r0^2)}, 2, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777900101629219*^9},
 CellLabel->"Out[22]=",ExpressionUUID->"4eb540b1-8f55-4209-b9af-3d286213386d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               RowBox[{" ", 
                RowBox[{"c14", " ", "c1", " ", "c2"}]}], 
               RowBox[{
                SuperscriptBox["r", "2"], " ", "r0"}]]}], " ", "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.7779001213362293`*^9},
 CellLabel->"In[23]:=",ExpressionUUID->"8193e7c6-9e6f-422f-9bfd-c54d41e38663"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"eta", " ", 
      SuperscriptBox["gamma", "3"]}], 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["beta", 
         RowBox[{"5", "/", "2"}]], " ", "r0"}], ")"}]}]]}], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["eta", "2"], "-", 
       RowBox[{"k", " ", "r0"}], "+", 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"12", " ", 
          SuperscriptBox["eta", "2"]}], "-", 
         RowBox[{"20", " ", "k", " ", "r0"}], "+", 
         RowBox[{"13", " ", "beta", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"24", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"7", "/", "2"}]], " ", 
       SuperscriptBox["r0", "3"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"12", " ", 
        SuperscriptBox["eta", "4"]}], "-", 
       RowBox[{"26", " ", 
        SuperscriptBox["eta", "2"], " ", "k", " ", "r0"}], "+", 
       RowBox[{"18", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{"8", " ", 
        SuperscriptBox["k", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"13", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "+", 
       RowBox[{"5", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "4"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", "4"], " ", 
     SuperscriptBox["r0", "4"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 2] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta/$CellContext`r0, 
    Rational[1, 
      2] $CellContext`beta^(-3) $CellContext`r0^(-2) ($CellContext`eta^2 - \
$CellContext`k $CellContext`r0 + $CellContext`beta $CellContext`r0^2), 
    Rational[-1, 24] $CellContext`beta^
     Rational[-7, 2] $CellContext`eta $CellContext`r0^(-3) (
     12 $CellContext`eta^2 - 20 $CellContext`k $CellContext`r0 + 
     13 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 24] $CellContext`beta^(-4) $CellContext`r0^(-4) (
     12 $CellContext`eta^4 - 
     26 $CellContext`eta^2 $CellContext`k $CellContext`r0 + 
     18 $CellContext`beta $CellContext`eta^2 $CellContext`r0^2 + 
     8 $CellContext`k^2 $CellContext`r0^2 - 
     13 $CellContext`beta $CellContext`k $CellContext`r0^3 + 
     5 $CellContext`beta^2 $CellContext`r0^4)}, 3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.777900122024194*^9},
 CellLabel->"Out[23]=",ExpressionUUID->"5c7f3e2e-b669-4120-859f-64658e171f71"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"So", ",", " ", 
    RowBox[{"first", " ", "we", " ", "need", " ", "to", " ", "combine", " ", 
     RowBox[{"gamma", "^", "2"}], " ", 
     RowBox[{"terms", ":"}]}]}], "*)"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.777900134167498*^9, 
  3.7779001442941523`*^9}},ExpressionUUID->"396106c4-e967-42eb-84fd-\
0a1f9a4e5a5e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "r0"}], " ", "-", 
            RowBox[{"k", " ", "h2"}]}], ")"}], " ", "c1"}], 
         RowBox[{"r", " ", "r0"}]], "-", 
        FractionBox[
         RowBox[{"2", " ", "g2", " "}], 
         RowBox[{"beta", " "}]]}], " ", "/.", " ", 
       RowBox[{"d", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"h", "+", 
           RowBox[{"eta", "*", "g2"}], "+", 
           RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], 
      "  ", "/.", " ", 
      RowBox[{"h", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
        RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
        RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
     RowBox[{"r", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
       RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
    RowBox[{"zeta", " ", "\[Rule]", " ", 
     RowBox[{"k", "-", 
      RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
   RowBox[{"h1", " ", "\[Rule]", " ", 
    RowBox[{
     SuperscriptBox["g2", "2"], "-", " ", 
     RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
  RowBox[{"h2", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
    RowBox[{"g0", " ", "g3", "  "}]}]}]}]], "Input",
 CellChangeTimes->{{3.777900161662116*^9, 3.777900168004629*^9}, 
   3.777903576717898*^9, 3.777903648405603*^9},
 CellLabel->"In[74]:=",ExpressionUUID->"777e1aca-3b66-4cbf-9f21-55648fdcb2fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"2", " ", "g2"}], "beta"]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], "-", 
          RowBox[{"g0", " ", "g3"}]}], ")"}]}], " ", "k"}], "+", 
      RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g3"}], " ", "r0"}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
        RowBox[{"3", " ", "g3", " ", "k"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}], 
   RowBox[{"r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{3.777900170631324*^9, 3.7779035780661373`*^9, 
  3.777903649614695*^9},
 CellLabel->"Out[74]=",ExpressionUUID->"c6fe4d19-e004-4916-8781-6db678c84d17"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Together", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777903587003879*^9, 3.7779035887400846`*^9}},
 CellLabel->"In[75]:=",ExpressionUUID->"dad4969e-d7db-40b5-9427-972918dba1f8"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"beta", " ", "r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", "eta", " ", "g1", " ", 
     SuperscriptBox["g2", "2"], " ", "k"}], "+", 
    RowBox[{"2", " ", "eta", " ", "g0", " ", "g2", " ", "g3", " ", "k"}], "-", 
    RowBox[{"3", " ", "g1", " ", "g2", " ", "g3", " ", 
     SuperscriptBox["k", "2"]}], "+", 
    RowBox[{"3", " ", "g0", " ", 
     SuperscriptBox["g3", "2"], " ", 
     SuperscriptBox["k", "2"]}], "-", 
    RowBox[{
     SuperscriptBox["g1", "2"], " ", "g2", " ", "k", " ", "r0"}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["g2", "2"], " ", "k", " ", "r0"}], "+", 
    RowBox[{"3", " ", "g1", " ", "g3", " ", "k", " ", "r0"}], "+", 
    RowBox[{"g0", " ", "g1", " ", "g3", " ", "k", " ", "r0"}], "+", 
    RowBox[{"beta", " ", "g1", " ", "g2", " ", "g3", " ", "k", " ", "r0"}], 
    "-", 
    RowBox[{"beta", " ", "g0", " ", 
     SuperscriptBox["g3", "2"], " ", "k", " ", "r0"}], "+", 
    RowBox[{
     SuperscriptBox["g1", "2"], " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{"2", " ", "g0", " ", "g2", " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{"beta", " ", "g1", " ", "g3", " ", 
     SuperscriptBox["r0", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.777903589227335*^9, 3.777903651944063*^9},
 CellLabel->"Out[75]=",ExpressionUUID->"09b3074d-548c-490b-88e8-45e6bf795d54"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", 
             RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3"}]}], ")"}]}], 
       " ", "k"}], "+", 
      RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g3"}], " ", "beta", " ", "r0"}], "+", 
      RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
      RowBox[{"3", " ", "g3", " ", "k"}], "+", 
      RowBox[{"g1", " ", "r0"}]}], ")"}]}], "-", 
   RowBox[{"2", " ", "r0", " ", "g2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "r0"}]}], ")"}]}]}], 
  RowBox[{"r0", " ", "beta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "r0"}]}], 
    ")"}]}]]], "Input",
 CellChangeTimes->{{3.777900177998032*^9, 3.777900219309086*^9}},
 CellLabel->"In[63]:=",ExpressionUUID->"61abd3ba-15ce-4d42-adb3-971d75e0c8e7"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], " ", "g2", " ", "r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "r0"}]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g1"}], " ", "g2"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3"}]}], ")"}], " ", 
       "k"}], "+", 
      RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
      RowBox[{"3", " ", "g3", " ", "k"}], "+", 
      RowBox[{"g1", " ", "r0"}], "-", 
      RowBox[{"beta", " ", "g3", " ", "r0"}]}], ")"}]}]}], 
  RowBox[{"beta", " ", "r0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "r0"}]}], 
    ")"}]}]]], "Output",
 CellChangeTimes->{3.777900222446446*^9, 3.777902964531754*^9},
 CellLabel->"Out[63]=",ExpressionUUID->"82c48157-0c80-42b2-92d3-2bb29a47a087"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", "eta", " ", "g1", " ", 
     SuperscriptBox["g2", "2"], " ", "k"}], "+", 
    RowBox[{"2", " ", "eta", " ", "g0", " ", "g2", " ", "g3", " ", "k"}], "-", 
    RowBox[{"3", " ", "g1", " ", "g2", " ", "g3", " ", 
     SuperscriptBox["k", "2"]}], "+", 
    RowBox[{"3", " ", "g0", " ", 
     SuperscriptBox["g3", "2"], " ", 
     SuperscriptBox["k", "2"]}], "-", 
    RowBox[{
     SuperscriptBox["g1", "2"], " ", "g2", " ", "k", " ", "r0"}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["g2", "2"], " ", "k", " ", "r0"}], "+", 
    RowBox[{"3", " ", "g1", " ", "g3", " ", "k", " ", "r0"}], "+", 
    RowBox[{"g0", " ", "g1", " ", "g3", " ", "k", " ", "r0"}], "+", 
    RowBox[{"beta", " ", "g1", " ", "g2", " ", "g3", " ", "k", " ", "r0"}], 
    "-", 
    RowBox[{"beta", " ", "g0", " ", 
     SuperscriptBox["g3", "2"], " ", "k", " ", "r0"}], "+", 
    RowBox[{
     SuperscriptBox["g1", "2"], " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{"2", " ", "g0", " ", "g2", " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{"beta", " ", "g1", " ", "g3", " ", 
     SuperscriptBox["r0", "2"]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.77790023031602*^9, 3.777900235802596*^9}, 
   3.777902975511305*^9, 3.777903603360244*^9, 3.777903660149791*^9},
 CellLabel->"In[76]:=",ExpressionUUID->"0f8afe40-97a7-4fc9-81f8-a48649a537ce"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "g1", " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"2", " ", "g0", " ", "g2", " ", "g3"}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "3"}], " ", "g1", " ", "g2", " ", "g3"}], "+", 
     RowBox[{"3", " ", "g0", " ", 
      SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["g1", "2"]}], " ", "g2"}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"3", " ", "g1", " ", "g3"}], "+", 
     RowBox[{"g0", " ", "g1", " ", "g3"}], "+", 
     RowBox[{"beta", " ", "g1", " ", "g2", " ", "g3"}], "-", 
     RowBox[{"beta", " ", "g0", " ", 
      SuperscriptBox["g3", "2"]}]}], ")"}], " ", "k", " ", "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["g1", "2"], "-", 
     RowBox[{"2", " ", "g0", " ", "g2"}], "-", 
     RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.777900236125906*^9, 3.7779029771936274`*^9, 
  3.777903604288219*^9, 3.7779036607922697`*^9},
 CellLabel->"Out[76]=",ExpressionUUID->"2b289cf2-fa28-4602-ab1b-65b1f8a51845"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Simplify", " ", "this", " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777902980309805*^9, 3.7779029840756893`*^9}},
 CellLabel->"In[65]:=",ExpressionUUID->"b1a7a8af-8c3d-4ce5-a181-d0c178d798bf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", "eta", " ", "k", " ", "g2", " ", "h2"}], " ", "-", 
  RowBox[{"3", "h2", " ", "g3", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "h6"}], "-", 
     RowBox[{"g1", " ", "h2"}], "+", 
     RowBox[{"beta", " ", "g3", " ", "h2"}]}], ")"}], " ", "k", " ", "r0"}], 
  "+", 
  RowBox[{"h1", " ", "beta", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{{3.777903674002758*^9, 
  3.7779038991606903`*^9}},ExpressionUUID->"2ef742eb-0241-4808-b200-\
4154cc3cf317"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "eta", "  ", "g2"}], "+", 
      RowBox[{"3", " ", "g3", " ", "k"}]}], " ", ")"}]}], " ", "h2", " ", 
   "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "h6"}], "-", 
     RowBox[{"g1", " ", "h2"}], "+", 
     RowBox[{"beta", " ", "g3", " ", "h2"}]}], ")"}], " ", "k", " ", "r0"}], 
  "+", 
  RowBox[{"h1", " ", "beta", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{{3.7779030133045473`*^9, 3.777903215038927*^9}, {
  3.7779032599410963`*^9, 
  3.777903305183461*^9}},ExpressionUUID->"58abe927-9d0c-41e9-9604-\
6bfbcd78dc1b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", "eta", " ", "g2", " ", "h2", " ", "k"}], "-", 
  RowBox[{"3", " ", "g3", " ", "h2", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "h6"}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"g1", " ", "-", " ", 
        RowBox[{"beta", " ", "g3"}]}], ")"}], "h2"}]}], ")"}], " ", "k", " ", 
   "r0"}], "+", " ", 
  RowBox[{"h1", " ", "beta", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{{3.777900257571988*^9, 3.777900429155645*^9}, {
   3.777900577164003*^9, 3.777900729795521*^9}, {3.777900775900016*^9, 
   3.7779007763952007`*^9}, {3.777900808118217*^9, 3.777900810462235*^9}, 
   3.7779010230842743`*^9, {3.777903222885783*^9, 
   3.7779032235897303`*^9}},ExpressionUUID->"9d96a7a4-d1f5-47ac-801c-\
b3645991aac4"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "The", " ", "k", " ", "r0", " ", "term", " ", "may", " ", "be", " ", 
    "higher", " ", 
    RowBox[{"order", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.7779008262956667`*^9, 3.777900835144195*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"a3bbb777-642d-45a6-b7de-a7650657ed4d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", "eta", " ", "g2", " ", "h2", " ", "k"}], 
           "+", 
           RowBox[{"3", " ", "g3", " ", "h2", " ", 
            SuperscriptBox["k", "2"]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "h6"}], "-", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"g1", " ", "-", " ", 
                 RowBox[{"beta", " ", "g3"}]}], ")"}], "h2"}]}], ")"}], " ", 
            "k", " ", "r0"}], "+", " ", 
           RowBox[{"h1", " ", "beta", " ", 
            SuperscriptBox["r0", "2"]}]}], "/.", " ", 
          RowBox[{"h1", " ", "\[Rule]", " ", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", " ", 
            RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h2", " ", "\[Rule]", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
           RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h6", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"2", " ", 
           SuperscriptBox["g2", "2"]}], "-", 
          RowBox[{"3", "g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777900840986189*^9, 3.777900903123026*^9}, {
   3.777900934225484*^9, 3.777900934853916*^9}, {3.777900982896817*^9, 
   3.7779010188946238`*^9}, 3.777903979391692*^9},
 CellLabel->"In[79]:=",ExpressionUUID->"4c4b0ea5-9804-4861-8c6c-98ebec35dd15"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "k", " ", "r0"}], "+", 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"12", " ", 
     SuperscriptBox["beta", "2"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", "k"}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"3", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"60", " ", 
        SuperscriptBox["k", "2"]}], "+", 
       RowBox[{"43", " ", "beta", " ", "k", " ", "r0"}], "-", 
       RowBox[{"2", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"360", " ", 
     SuperscriptBox["beta", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 
      12] $CellContext`beta^(-2) ((-4) $CellContext`k $CellContext`r0 + \
$CellContext`beta $CellContext`r0^2), 
    Rational[-1, 3] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta $CellContext`k, 
    Rational[1, 360] $CellContext`beta^(-3) (60 $CellContext`k^2 + 
     43 $CellContext`beta $CellContext`k $CellContext`r0 - 
     2 $CellContext`beta^2 $CellContext`r0^2)}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.7779009836340446`*^9, 3.777901019917794*^9}, 
   3.7779039803637667`*^9},
 CellLabel->"Out[79]=",ExpressionUUID->"32bcf3b3-e91e-4e4f-81d9-91f3c9b39b7d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Okay", ",", " ", 
    RowBox[{
    "so", " ", "this", " ", "intermediate", " ", "result", " ", "combining", 
     " ", "the", " ", 
     RowBox[{"gamma", "^", "2"}], " ", "terms", " ", 
     RowBox[{"is", ":"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{"2", " ", "g2", " "}], 
      RowBox[{"beta", " "}]]}], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "r0"}], " ", "-", 
        RowBox[{"k", " ", "h2"}]}], ")"}], " ", "c1"}], 
     RowBox[{"r", " ", "r0"}]]}], " ", "=", " ", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "eta", " ", "g2", " ", "h2", " ", "k"}], "-", 
     RowBox[{"3", " ", "g3", " ", "h2", " ", 
      SuperscriptBox["k", "2"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"h6", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"g1", " ", "-", " ", 
           RowBox[{"beta", " ", "g3"}]}], ")"}], "h2"}]}], ")"}], " ", "k", 
      " ", "r0"}], "+", " ", 
     RowBox[{"h1", " ", "beta", " ", 
      SuperscriptBox["r0", "2"]}]}], 
    RowBox[{"r0", " ", "r", " ", "beta"}]]}]}]], "Input",
 CellChangeTimes->{{3.777901087570135*^9, 3.777901182132126*^9}, 
   3.77790335511406*^9},ExpressionUUID->"1a540d21-449a-4377-b866-\
cb4cb3f1c67b"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"This", " ", "has", " ", "a", " ", 
    RowBox[{"gamma", "^", "4"}], " ", "dependence"}], ",", " ", 
   RowBox[{"but", " ", "might", " ", "cancel", " ", "with", " ", "other", " ", 
    RowBox[{"gamma", "^", "4"}], " ", 
    RowBox[{"terms", "."}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777901186764865*^9, 3.7779012049201*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"97ec569d-3fe2-4f10-b9fc-6caa440ab76f"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Next", ",", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"handle", " ", 
      RowBox[{"gamma", "^", "3"}], " ", "terms"}], " ", "-", " ", 
     RowBox[{"together", " ", "these", " ", "are", " ", "order", " ", 
      RowBox[{"gamma", "^", "4"}]}]}], ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777901206729589*^9, 3.777901222557848*^9}, {
  3.777902050836972*^9, 
  3.7779020694122*^9}},ExpressionUUID->"f41bb87b-aa09-4b3d-b1f3-393896b78d13"],

Cell[BoxData[
 RowBox[{"c14", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{"  ", "c17", " "}], 
      RowBox[{"beta", " ", "r", " ", "r0"}]]}], "-", 
    FractionBox[
     RowBox[{"  ", 
      RowBox[{"c1", " ", "c2"}]}], 
     RowBox[{
      SuperscriptBox["r", "2"], " ", "r0"}]]}], " ", ")"}]}]], "Input",
 CellChangeTimes->{{3.777901245419169*^9, 3.7779012526761627`*^9}, {
  3.7779014036016903`*^9, 3.777901431830965*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"9b04eafa-6763-45ba-b7a1-4124a4f13594"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g2", " ", "r0"}], "-", 
     RowBox[{"h1", " ", "k"}]}], ")"}]}], " ", 
  RowBox[{"(", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"r0", "-", 
        RowBox[{"g2", " ", "k"}], "-", "r"}], ")"}], "r"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"h", "+", 
        RowBox[{"eta", " ", "g2"}], "+", 
        RowBox[{"2", "k", " ", "g3"}], "-", 
        RowBox[{"g3", " ", "beta", " ", "r0"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", "g0"}], "+", 
        RowBox[{"g1", " ", 
         RowBox[{"(", 
          RowBox[{"k", " ", "-", " ", 
           RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}], 
    RowBox[{"beta", " ", 
     SuperscriptBox["r", "2"], " ", "r0"}]], ")"}]}]], "Input",
 CellChangeTimes->{{3.777901442095017*^9, 
  3.777901587782592*^9}},ExpressionUUID->"5cf46e70-8240-4b9c-968e-\
4cb8cb3772c2"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Expand", " ", "the", " ", 
   RowBox[{"numerator", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777901597223613*^9, 
  3.777901605091392*^9}},ExpressionUUID->"9542dae2-a8cf-4c5a-a50a-\
a2ed9f3a878c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"r0", "-", 
       RowBox[{"g2", " ", "k"}], "-", "r"}], ")"}], "r"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"h", "+", 
       RowBox[{"eta", " ", "g2"}], "+", 
       RowBox[{"2", "k", " ", "g3"}], "-", 
       RowBox[{"g3", " ", "beta", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", 
        RowBox[{"(", 
         RowBox[{"k", " ", "-", " ", 
          RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}], " ", "/.", " ", 
   RowBox[{"r", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
     RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
  RowBox[{"h", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
    RowBox[{"k", " ", "g3"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777901611124789*^9, 3.777901626922448*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"9707f737-c37f-4b7b-8b32-04e3d21bc692"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "eta"}], " ", "g1"}], "-", 
     RowBox[{"2", " ", "g2", " ", "k"}], "+", "r0", "-", 
     RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
     RowBox[{"3", " ", "g3", " ", "k"}], "+", 
     RowBox[{"g1", " ", "r0"}], "-", 
     RowBox[{"beta", " ", "g3", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"g1", " ", 
      RowBox[{"(", 
       RowBox[{"k", "-", 
        RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7779016274851017`*^9},
 CellLabel->"Out[46]=",ExpressionUUID->"5b1ef29d-b4ef-4c47-85e1-5999ff7bf661"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7779016308687077`*^9, 3.777901639218775*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"c082a03c-361f-4d4a-bfd2-870a318aff9f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["eta", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["g1", "2"]}], "+", 
     RowBox[{"2", " ", "g0", " ", "g2"}]}], ")"}]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g1"}], " ", "g2"}], "+", 
     RowBox[{"3", " ", "g0", " ", "g3"}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{"g1", "-", 
        RowBox[{"g0", " ", "g1"}], "-", 
        RowBox[{"2", " ", "beta", " ", "g1", " ", "g2"}], "-", 
        RowBox[{"beta", " ", "g0", " ", "g3"}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g1", "2"], "+", "g2", "-", 
        RowBox[{"3", " ", "g0", " ", "g2"}], "-", 
        RowBox[{"4", " ", "beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
      "k"}]}], ")"}], " ", "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"g0", "-", 
     SuperscriptBox["g0", "2"], "-", 
     RowBox[{"beta", " ", 
      SuperscriptBox["g1", "2"]}], "+", 
     RowBox[{
      SuperscriptBox["beta", "2"], " ", "g1", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.777901639524481*^9},
 CellLabel->"Out[47]=",ExpressionUUID->"19b0cbc3-7b49-4b66-a4ae-ede4cdbea22c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", " ", 
    SuperscriptBox["eta", "2"]}], " ", "beta", " ", 
   SuperscriptBox["g2", "2"]}], "+", 
  RowBox[{"k", " ", "eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", "g0", " ", "g3"}], "-", 
     RowBox[{"g1", " ", "g2"}]}], ")"}]}], "-", " ", 
  RowBox[{
   SuperscriptBox["k", "2"], "h6"}], "-", 
  RowBox[{"eta", " ", "r0", " ", "beta", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "g2"}], "+", 
     RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
  RowBox[{"2", 
   RowBox[{"(", 
    RowBox[{"h1", "-", " ", 
     RowBox[{"g1", " ", "g3"}]}], ")"}], " ", "beta", " ", "k", " ", "r0"}], 
  "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"g2", "-", 
     RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}], " ", "beta", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{{3.777901656890472*^9, 3.777901801682706*^9}, {
  3.777901840033326*^9, 3.7779019626447973`*^9}, {3.777902357680112*^9, 
  3.777902368391852*^9}},ExpressionUUID->"f77f2971-8791-4263-bf78-\
14df85810c01"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.7779022138471622`*^9, 
  3.777902229069729*^9}},ExpressionUUID->"9458a564-5791-4c54-9087-\
0dd00356395b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"c14", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"  ", "c17", " "}], 
                  RowBox[{"beta", " ", "r", " ", "r0"}]]}], "-", 
                FractionBox[
                 RowBox[{"  ", 
                  RowBox[{"c1", " ", "c2"}]}], 
                 RowBox[{
                  SuperscriptBox["r", "2"], " ", "r0"}]]}], " ", ")"}]}], "/.",
              " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777902429352498*^9, 3.77790245618561*^9}},
 CellLabel->"In[52]:=",ExpressionUUID->"cf795ab8-7b06-4e99-badf-f04aa5326e91"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "4"], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "2"]}]], "-", 
   FractionBox[
    RowBox[{"eta", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"6", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"5", "/", "2"}]], " ", "r0"}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"5", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"5", " ", "k", " ", "r0"}], "+", 
       RowBox[{"3", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 4] $CellContext`beta^(-2), 
    Rational[-1, 6] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta/$CellContext`r0, 
    Rational[1, 24] $CellContext`beta^(-3) $CellContext`r0^(-2) (
     5 $CellContext`eta^2 - 5 $CellContext`k $CellContext`r0 + 
     3 $CellContext`beta $CellContext`r0^2)}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7779024567862873`*^9},
 CellLabel->"Out[52]=",ExpressionUUID->"0884e17d-d9b7-4597-a704-5c314514ce68"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Check", " ", "to", " ", "see", " ", "that", " ", "we", " ", "are", " ", 
   "on", " ", "the", " ", "right", " ", 
   RowBox[{"track", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.77790255203286*^9, 3.777902558511572*^9}},
 CellLabel->"In[53]:=",ExpressionUUID->"794355f4-1f80-4f24-8c81-9a4c7214a857"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               FractionBox[
                RowBox[{"4", " ", "h1", " ", "k"}], 
                RowBox[{"beta", " ", "r0"}]], "-", " ", "h1", "+", 
               FractionBox[
                RowBox[{" ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", "eta", " ", "k", " ", "g2", " ", 
                    "h2"}], " ", "-", 
                   RowBox[{"3", "h2", " ", "g3", " ", 
                    SuperscriptBox["k", "2"]}], "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "h6"}], "-", 
                    RowBox[{"g1", " ", "h2"}], "+", 
                    RowBox[{"beta", " ", "g3", " ", "h2"}]}], ")"}], " ", "k",
                     " ", "r0"}], "+", 
                   RowBox[{"h1", " ", "beta", " ", 
                    SuperscriptBox["r0", "2"]}]}], ")"}]}], 
                RowBox[{"beta", " ", "r0", " ", "r"}]], "-", 
               RowBox[{
                FractionBox["c14", 
                 RowBox[{"beta", " ", 
                  SuperscriptBox["r", "2"], " ", "r0"}]], 
                RowBox[{"(", " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", " ", 
                    SuperscriptBox["eta", "2"]}], " ", "beta", " ", 
                   SuperscriptBox["g2", "2"]}], "+", 
                  RowBox[{"k", " ", "eta", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", " ", "g0", " ", "g3"}], "-", 
                    RowBox[{"g1", " ", "g2"}]}], ")"}]}], "-", " ", 
                  RowBox[{
                   SuperscriptBox["k", "2"], "h6"}], "-", 
                  RowBox[{"eta", " ", "r0", " ", "beta", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", " ", "g2"}], "+", 
                    RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
                  RowBox[{"2", 
                   RowBox[{"(", 
                    RowBox[{"h1", "-", " ", 
                    RowBox[{"g1", " ", "g3"}]}], ")"}], " ", "beta", " ", "k",
                    " ", "r0"}], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"g2", "-", 
                    RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
                   "beta", " ", 
                   SuperscriptBox["r0", "2"]}]}], " ", ")"}]}]}], " ", "/.", 
              " ", 
              RowBox[{"h6", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"2", " ", 
                 SuperscriptBox["g2", "2"]}], "-", 
                RowBox[{"3", "g1", " ", "g3"}]}]}]}], "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7779025902768383`*^9, 3.7779026799020367`*^9}, {
  3.7779027125282993`*^9, 3.7779027164763403`*^9}, {3.777902782235702*^9, 
  3.777902782713235*^9}, {3.777904018171669*^9, 3.777904034905229*^9}},
 CellLabel->"In[83]:=",ExpressionUUID->"45535f52-a41b-4ef1-89cd-3e97e77b269c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "4"], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "2"]}]], "-", 
   FractionBox[
    RowBox[{"eta", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"4", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"5", "/", "2"}]], " ", "r0"}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"21", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"23", " ", "k", " ", "r0"}], "+", 
       RowBox[{"12", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"72", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[1, 4] $CellContext`beta^(-2), 
    Rational[-1, 4] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta/$CellContext`r0, 
    Rational[1, 72] $CellContext`beta^(-3) $CellContext`r0^(-2) (
     21 $CellContext`eta^2 - 23 $CellContext`k $CellContext`r0 + 
     12 $CellContext`beta $CellContext`r0^2)}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.777902687169948*^9, 3.7779027169991703`*^9}, 
   3.777902783896037*^9, {3.777904020268691*^9, 3.777904035432858*^9}},
 CellLabel->"Out[83]=",ExpressionUUID->"3736f7ca-756c-47ab-a911-c5bac6fac715"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"It", "'"}], "s", " ", "interesting", " ", "that", " ", "the", " ",
    "entire", " ", "term", " ", "has", " ", "leading", " ", "order", " ", 
   "that", " ", "equals", " ", "the", " ", "c14", " ", "leading", " ", 
   RowBox[{"order", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777904104313326*^9, 3.777904122182966*^9}},
 CellLabel->"In[84]:=",ExpressionUUID->"49abb116-6021-436e-adc7-4b7e8d4d889c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              FractionBox[
               RowBox[{" ", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"4", " ", "k"}], "-", 
                    RowBox[{"beta", " ", "r0"}]}], ")"}], 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
                    RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
                    RowBox[{"k", " ", "g2"}]}], ")"}], " ", "h1"}], "+", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", "eta", " ", "k", " ", "g2", " ", 
                    "h2"}], " ", "-", 
                   RowBox[{"3", "h2", " ", "g3", " ", 
                    SuperscriptBox["k", "2"]}], "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "h6"}], "-", 
                    RowBox[{"g1", " ", "h2"}], "+", 
                    RowBox[{"beta", " ", "g3", " ", "h2"}]}], ")"}], " ", "k",
                     " ", "r0"}], "+", 
                   RowBox[{"h1", " ", "beta", " ", 
                    SuperscriptBox["r0", "2"]}]}], ")"}]}]}], 
               RowBox[{"beta", " ", "r0", " ", "r"}]], " ", "/.", " ", 
              RowBox[{"h6", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"2", " ", 
                 SuperscriptBox["g2", "2"]}], "-", 
                RowBox[{"3", "g1", " ", "g3"}]}]}]}], "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777904132119735*^9, 3.777904257275473*^9}, {
   3.7779042902149057`*^9, 3.777904292779254*^9}, 3.777904324230646*^9, {
   3.777905441880601*^9, 3.777905442151009*^9}},
 CellLabel->
  "In[102]:=",ExpressionUUID->"34a8f003-ac37-4433-b9d6-dec34dcb1b0f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"eta", " ", 
      SuperscriptBox["gamma", "5"]}], 
     RowBox[{"12", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["beta", 
         RowBox[{"5", "/", "2"}]], " ", "r0"}], ")"}]}]]}], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"6", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"8", " ", "k", " ", "r0"}], "+", 
       RowBox[{"3", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"72", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"30", " ", 
          SuperscriptBox["eta", "2"]}], "-", 
         RowBox[{"49", " ", "k", " ", "r0"}], "+", 
         RowBox[{"23", " ", "beta", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"360", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"7", "/", "2"}]], " ", 
       SuperscriptBox["r0", "3"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"120", " ", 
        SuperscriptBox["eta", "4"]}], "-", 
       RowBox[{"256", " ", 
        SuperscriptBox["eta", "2"], " ", "k", " ", "r0"}], "+", 
       RowBox[{"132", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{"80", " ", 
        SuperscriptBox["k", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"86", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "+", 
       RowBox[{"21", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "4"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"1440", " ", 
     SuperscriptBox["beta", "4"], " ", 
     SuperscriptBox["r0", "4"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 12] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta/$CellContext`r0, 
    Rational[1, 72] $CellContext`beta^(-3) $CellContext`r0^(-2) (
     6 $CellContext`eta^2 - 8 $CellContext`k $CellContext`r0 + 
     3 $CellContext`beta $CellContext`r0^2), 
    Rational[-1, 360] $CellContext`beta^
     Rational[-7, 2] $CellContext`eta $CellContext`r0^(-3) (
     30 $CellContext`eta^2 - 49 $CellContext`k $CellContext`r0 + 
     23 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 1440] $CellContext`beta^(-4) $CellContext`r0^(-4) (
     120 $CellContext`eta^4 - 
     256 $CellContext`eta^2 $CellContext`k $CellContext`r0 + 
     132 $CellContext`beta $CellContext`eta^2 $CellContext`r0^2 + 
     80 $CellContext`k^2 $CellContext`r0^2 - 
     86 $CellContext`beta $CellContext`k $CellContext`r0^3 + 
     21 $CellContext`beta^2 $CellContext`r0^4)}, 5, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.777904136491849*^9, 3.777904165050112*^9}, 
   3.77790425883116*^9, 3.777904325311673*^9, 3.77790544256738*^9},
 CellLabel->
  "Out[102]=",ExpressionUUID->"84c4a9cd-2111-4147-8204-8d37ef74a99a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Combine", " ", "these", " ", "terms"}], ",", " ", 
   RowBox[{"and", " ", "expand", " ", "the", " ", 
    RowBox[{"numerator", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.777904337869872*^9, 3.7779043475160723`*^9}, {
  3.77790753277878*^9, 
  3.777907533848247*^9}},ExpressionUUID->"b0f1e79c-8f45-43ac-bb15-\
03543d712d3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", "k"}], "-", 
     RowBox[{"beta", " ", "r0"}]}], ")"}], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
     RowBox[{"k", " ", "g2"}]}], ")"}], " ", "h1"}], "+", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", "eta", " ", "k", " ", "g2", " ", "h2"}], " ", 
    "-", 
    RowBox[{"3", "h2", " ", "g3", " ", 
     SuperscriptBox["k", "2"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "h6"}], "-", 
       RowBox[{"g1", " ", "h2"}], "+", 
       RowBox[{"beta", " ", "g3", " ", "h2"}]}], ")"}], " ", "k", " ", "r0"}],
     "+", 
    RowBox[{"h1", " ", "beta", " ", 
     SuperscriptBox["r0", "2"]}]}], ")"}]}]], "Input",
 CellLabel->"In[91]:=",ExpressionUUID->"4b8d3cb0-d865-44fa-bce5-cfe85afe85bf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", "eta", " ", "g2", " ", "h2", " ", "k"}], 
         "-", 
         RowBox[{"3", " ", "g3", " ", "h2", " ", 
          SuperscriptBox["k", "2"]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "g1"}], " ", "h2"}], "+", 
            RowBox[{"beta", " ", "g3", " ", "h2"}], "-", "h6"}], ")"}], " ", 
          "k", " ", "r0"}], "+", 
         RowBox[{"beta", " ", "h1", " ", 
          SuperscriptBox["r0", "2"]}], "+", 
         RowBox[{"h1", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", " ", "k"}], "-", 
            RowBox[{"beta", " ", "r0"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g1"}], "+", 
            RowBox[{"g2", " ", "k"}], "+", 
            RowBox[{"g0", " ", "r0"}]}], ")"}]}]}], "/.", "  ", 
        RowBox[{"h6", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"2", " ", 
           SuperscriptBox["g2", "2"]}], "-", 
          RowBox[{"3", "g1", " ", "g3"}]}]}]}], "/.", " ", 
       RowBox[{"d", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"h", "+", 
           RowBox[{"eta", "*", "g2"}], "+", 
           RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], 
      "  ", "/.", " ", 
      RowBox[{"h", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
        RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
        RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
     RowBox[{"r", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
       RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
    RowBox[{"zeta", " ", "\[Rule]", " ", 
     RowBox[{"k", "-", 
      RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
   RowBox[{"h1", " ", "\[Rule]", " ", 
    RowBox[{
     SuperscriptBox["g2", "2"], "-", " ", 
     RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
  RowBox[{"h2", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
    RowBox[{"g0", " ", "g3", " "}]}]}]}]], "Input",
 CellChangeTimes->{{3.777904365181107*^9, 3.777904365381549*^9}, {
  3.77790441095632*^9, 3.777904411338849*^9}},
 CellLabel->"In[95]:=",ExpressionUUID->"aa9893de-075c-4b02-b5e2-34d13a0a0f7b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", "eta", " ", "g2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "g2"}], "-", 
     RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "k"}], "-", 
  RowBox[{"3", " ", "g3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "g2"}], "-", 
     RowBox[{"g0", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"3", " ", "g1", " ", "g3"}], "-", 
     RowBox[{"g1", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "-", 
        RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
     RowBox[{"beta", " ", "g3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "-", 
        RowBox[{"g0", " ", "g3"}]}], ")"}]}]}], ")"}], " ", "k", " ", "r0"}], 
  "+", 
  RowBox[{"beta", " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["g2", "2"], "-", 
     RowBox[{"g1", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["g2", "2"], "-", 
     RowBox[{"g1", " ", "g3"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", "k"}], "-", 
     RowBox[{"beta", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.777904365927833*^9, 3.777904411891596*^9},
 CellLabel->"Out[95]=",ExpressionUUID->"819c4c01-335e-4619-9e1d-ee11e6ca475d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", " ", "eta", ",", " ", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7779043678539352`*^9, 3.77790437747508*^9}},
 CellLabel->"In[96]:=",ExpressionUUID->"94e67158-c068-403d-8de7-705a0aa8c220"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "g2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "-", 
        RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
     RowBox[{"4", " ", "g1", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", 
        RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "3"}], " ", "g3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "-", 
        RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
     RowBox[{"4", " ", "g2", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", 
        RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "beta"}], " ", "eta", " ", "g1", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", 
        RowBox[{"g1", " ", "g3"}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         SuperscriptBox["g2", "2"]}], "+", 
        RowBox[{"3", " ", "g1", " ", "g3"}], "-", 
        RowBox[{"g1", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], "-", 
           RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
        RowBox[{"beta", " ", "g3", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], "-", 
           RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
        RowBox[{"4", " ", "g0", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", 
           RowBox[{"g1", " ", "g3"}]}], ")"}]}], "-", 
        RowBox[{"beta", " ", "g2", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", 
           RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}], " ", "k"}]}], ")"}],
    " ", "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"beta", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", 
        RowBox[{"g1", " ", "g3"}]}], ")"}]}], "-", 
     RowBox[{"beta", " ", "g0", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", 
        RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.777904377797268*^9, 3.777904413823148*^9},
 CellLabel->"Out[96]=",ExpressionUUID->"97b9d544-ecf5-4078-ae04-2a5236dc9e98"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777904391371388*^9, 3.777904393347699*^9}},
 CellLabel->"In[97]:=",ExpressionUUID->"7fe82987-82b9-425d-aa84-0d7ea7817bac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g2", "3"], " ", "k", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", "k"}], "-", 
     RowBox[{"beta", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g2", "2"], " ", "r0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "k"}], "+", 
     RowBox[{"4", " ", "g0", " ", "k"}], "+", 
     RowBox[{"beta", " ", "r0"}], "-", 
     RowBox[{"beta", " ", "g0", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{"g3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", "k"}], "-", 
     RowBox[{"beta", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g0", " ", "g3", " ", "k"}], "+", 
     RowBox[{"g1", " ", "r0"}], "-", 
     RowBox[{"g0", " ", "g1", " ", "r0"}]}], ")"}]}], "-", 
  RowBox[{"g1", " ", "g2", " ", "k", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"7", " ", "g3", " ", "k"}], "+", 
     RowBox[{"g1", " ", "r0"}], "-", 
     RowBox[{"2", " ", "beta", " ", "g3", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "g0", " ", "g2", " ", "g3", " ", "k"}], "+", 
     RowBox[{"g1", " ", 
      SuperscriptBox["g2", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "k"}], "-", 
        RowBox[{"beta", " ", "r0"}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["g1", "2"], " ", "g3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "k"}], "+", 
        RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.7779043937167587`*^9, 3.7779044170315857`*^9}},
 CellLabel->"Out[97]=",ExpressionUUID->"1d37813e-b3c7-4758-abf6-2ce0506d1d60"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7779043952847137`*^9, 3.7779044247300787`*^9}},
 CellLabel->"In[98]:=",ExpressionUUID->"a02d48c7-af28-4d0b-8f36-8c8a126b26c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "g1", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"4", " ", 
      SuperscriptBox["g1", "2"], " ", "g3"}], "+", 
     RowBox[{"2", " ", "g0", " ", "g2", " ", "g3"}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", 
      SuperscriptBox["g2", "3"]}], "-", 
     RowBox[{"7", " ", "g1", " ", "g2", " ", "g3"}], "+", 
     RowBox[{"3", " ", "g0", " ", 
      SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "beta"}], " ", "g1", " ", 
         SuperscriptBox["g2", "2"]}], "+", 
        RowBox[{"beta", " ", 
         SuperscriptBox["g1", "2"], " ", "g3"}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox["g1", "2"]}], " ", "g2"}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["g2", "2"]}], "+", 
        RowBox[{"4", " ", "g0", " ", 
         SuperscriptBox["g2", "2"]}], "-", 
        RowBox[{"beta", " ", 
         SuperscriptBox["g2", "3"]}], "+", 
        RowBox[{"3", " ", "g1", " ", "g3"}], "-", 
        RowBox[{"3", " ", "g0", " ", "g1", " ", "g3"}], "+", 
        RowBox[{"2", " ", "beta", " ", "g1", " ", "g2", " ", "g3"}], "-", 
        RowBox[{"beta", " ", "g0", " ", 
         SuperscriptBox["g3", "2"]}]}], ")"}], " ", "k"}]}], ")"}], " ", 
   "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"beta", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"beta", " ", "g0", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"beta", " ", "g1", " ", "g3"}], "+", 
     RowBox[{"beta", " ", "g0", " ", "g1", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.777904425194436*^9},
 CellLabel->"Out[98]=",ExpressionUUID->"06d173d7-ae76-4703-a33f-9900c52154a8"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", "eta", " ", "k", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "h1"}], "-", 
     RowBox[{"g3", " ", "g2"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", "g2", " ", "h1"}], "-", 
     RowBox[{"3", " ", "g3", " ", "h2"}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "-", 
  RowBox[{"eta", " ", "r0", " ", "beta", " ", "g1", " ", "h1"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", "g2", " ", "h1"}], "+", " ", 
     RowBox[{"g3", " ", "h2"}]}], ")"}], " ", "beta", " ", "k", " ", "r0"}], 
  " ", "+", 
  RowBox[{"g2", " ", "h1", " ", 
   SuperscriptBox["beta", "2"], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{{3.77790446734848*^9, 3.7779050437161407`*^9}, {
  3.777905075552306*^9, 3.777905093655184*^9}, {3.777905164097805*^9, 
  3.777905261152602*^9}, {3.777905291198534*^9, 3.777905329421138*^9}, {
  3.777905461199234*^9, 3.777905580368891*^9}, {3.777907916596498*^9, 
  3.777907944000597*^9}, {3.7779080080517607`*^9, 3.777908187498539*^9}, {
  3.777908232835413*^9, 
  3.777908582524005*^9}},ExpressionUUID->"56945e5c-1dc4-45aa-b095-\
f67304737638"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              FractionBox["1", 
               RowBox[{"beta", " ", "r0", " ", "r"}]], 
              RowBox[{"(", " ", 
               RowBox[{
                RowBox[{"2", " ", "eta", " ", "k", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g1", " ", "h1"}], "-", 
                   RowBox[{"g3", " ", "g2"}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "g2", " ", "h1"}], "-", 
                   RowBox[{"3", " ", "g3", " ", "h2"}]}], ")"}], " ", 
                 SuperscriptBox["k", "2"]}], "-", 
                RowBox[{"eta", " ", "r0", " ", "beta", " ", "g1", " ", "h1"}],
                 "+", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "g2", " ", "h1"}], "+", " ", 
                   RowBox[{"g3", " ", "h2"}]}], ")"}], " ", "beta", " ", "k", 
                 " ", "r0"}], "+", 
                RowBox[{"g2", " ", "h1", " ", 
                 SuperscriptBox["beta", "2"], " ", 
                 SuperscriptBox["r0", "2"]}]}], ")"}], " ", "/.", " ", 
              RowBox[{"h6", " ", "\[Rule]", " ", 
               RowBox[{
                RowBox[{"2", " ", 
                 SuperscriptBox["g2", "2"]}], "-", 
                RowBox[{"3", "g1", " ", "g3"}]}]}]}], "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], "  ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"zeta", " ", "\[Rule]", " ", 
           RowBox[{"k", "-", 
            RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h1", " ", "\[Rule]", " ", 
          RowBox[{
           SuperscriptBox["g2", "2"], "-", " ", 
           RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"h2", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"1", "-", " ", 
         RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.7779053821495132`*^9, {3.777905422878137*^9, 3.777905433399272*^9}, 
   3.777908200479508*^9, 3.77790859325667*^9},
 CellLabel->
  "In[120]:=",ExpressionUUID->"95cc6626-7e53-466d-b106-9467ffa99961"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"eta", " ", 
      SuperscriptBox["gamma", "5"]}], 
     RowBox[{"12", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["beta", 
         RowBox[{"5", "/", "2"}]], " ", "r0"}], ")"}]}]]}], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"6", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"8", " ", "k", " ", "r0"}], "+", 
       RowBox[{"3", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"72", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"30", " ", 
          SuperscriptBox["eta", "2"]}], "-", 
         RowBox[{"49", " ", "k", " ", "r0"}], "+", 
         RowBox[{"23", " ", "beta", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "7"]}], 
    RowBox[{"360", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"7", "/", "2"}]], " ", 
       SuperscriptBox["r0", "3"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"120", " ", 
        SuperscriptBox["eta", "4"]}], "-", 
       RowBox[{"256", " ", 
        SuperscriptBox["eta", "2"], " ", "k", " ", "r0"}], "+", 
       RowBox[{"132", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{"80", " ", 
        SuperscriptBox["k", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"86", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "+", 
       RowBox[{"21", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "4"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "8"]}], 
    RowBox[{"1440", " ", 
     SuperscriptBox["beta", "4"], " ", 
     SuperscriptBox["r0", "4"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "9"],
    SeriesData[$CellContext`gamma, 0, {}, 5, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 12] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta/$CellContext`r0, 
    Rational[1, 72] $CellContext`beta^(-3) $CellContext`r0^(-2) (
     6 $CellContext`eta^2 - 8 $CellContext`k $CellContext`r0 + 
     3 $CellContext`beta $CellContext`r0^2), 
    Rational[-1, 360] $CellContext`beta^
     Rational[-7, 2] $CellContext`eta $CellContext`r0^(-3) (
     30 $CellContext`eta^2 - 49 $CellContext`k $CellContext`r0 + 
     23 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 1440] $CellContext`beta^(-4) $CellContext`r0^(-4) (
     120 $CellContext`eta^4 - 
     256 $CellContext`eta^2 $CellContext`k $CellContext`r0 + 
     132 $CellContext`beta $CellContext`eta^2 $CellContext`r0^2 + 
     80 $CellContext`k^2 $CellContext`r0^2 - 
     86 $CellContext`beta $CellContext`k $CellContext`r0^3 + 
     21 $CellContext`beta^2 $CellContext`r0^4)}, 5, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.777907285232725*^9, {3.7779075631551857`*^9, 3.7779075649451637`*^9}, 
   3.7779082214617023`*^9, 3.777908594735487*^9},
 CellLabel->
  "Out[120]=",ExpressionUUID->"cd7a20c6-6158-4b67-b1a7-773ade2545e7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", ",", " ", 
   RowBox[{"putting", " ", "this", " ", "all", " ", 
    RowBox[{"together", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7779072758428907`*^9, 3.777907281417066*^9}},
 CellLabel->
  "In[103]:=",ExpressionUUID->"7dd24355-90cd-4bb0-b493-0409df73d253"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"4", " ", "h1", " ", "k"}], 
                RowBox[{"beta", " ", "r0"}]], "-", " ", "h1", "+", 
               FractionBox[
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"g1", " ", "r0"}], " ", "-", 
                   RowBox[{"k", " ", "h2"}]}], ")"}], " ", "c1"}], 
                RowBox[{"r", " ", "r0"}]], "-", 
               FractionBox[
                RowBox[{"2", " ", "g2", " "}], 
                RowBox[{"beta", " "}]], "-", 
               RowBox[{
                FractionBox["c14", 
                 RowBox[{"r", " ", "r0"}]], 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   RowBox[{"  ", "c17", " "}], 
                   RowBox[{"beta", " "}]], "+", 
                  FractionBox[
                   RowBox[{"  ", 
                    RowBox[{"c1", " ", "c2"}]}], "r"]}], ")"}]}]}], ")"}], 
             "-", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                FractionBox["1", 
                 RowBox[{"beta", " ", "r0", " ", "r"}]], 
                RowBox[{"(", " ", 
                 RowBox[{
                  RowBox[{"2", " ", "eta", " ", "k", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", " ", "h1"}], "-", 
                    RowBox[{"g3", " ", "g2"}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", "g2", " ", "h1"}], "-", 
                    RowBox[{"3", " ", "g3", " ", "h2"}]}], ")"}], " ", 
                   SuperscriptBox["k", "2"]}], "-", 
                  RowBox[{
                  "eta", " ", "r0", " ", "beta", " ", "g1", " ", "h1"}], "+", 
                  
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "g2", " ", "h1"}], "+", " ", 
                    RowBox[{"g3", " ", "h2"}]}], ")"}], " ", "beta", " ", "k",
                    " ", "r0"}], " ", "+", 
                  RowBox[{"g2", " ", "h1", " ", 
                   SuperscriptBox["beta", "2"], " ", 
                   SuperscriptBox["r0", "2"]}]}], ")"}]}], "-", 
               RowBox[{
                FractionBox["c14", 
                 RowBox[{"beta", " ", 
                  SuperscriptBox["r", "2"], " ", "r0"}]], 
                RowBox[{"(", " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", " ", 
                    SuperscriptBox["eta", "2"]}], " ", "beta", " ", 
                   SuperscriptBox["g2", "2"]}], "+", 
                  RowBox[{"k", " ", "eta", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", " ", "g0", " ", "g3"}], "-", 
                    RowBox[{"g1", " ", "g2"}]}], ")"}]}], "-", " ", 
                  RowBox[{
                   SuperscriptBox["k", "2"], "h6"}], "-", 
                  RowBox[{"eta", " ", "r0", " ", "beta", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g1", " ", "g2"}], "+", 
                    RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
                  RowBox[{"2", 
                   RowBox[{"(", 
                    RowBox[{"h1", "-", " ", 
                    RowBox[{"g1", " ", "g3"}]}], ")"}], " ", "beta", " ", "k",
                    " ", "r0"}], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"g2", "-", 
                    RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
                   "beta", " ", 
                   SuperscriptBox["r0", "2"]}]}], " ", ")"}]}]}], " ", 
              ")"}]}], " ", "/.", 
            RowBox[{"h6", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"2", " ", 
               SuperscriptBox["g2", "2"]}], "-", 
              RowBox[{"3", "g1", " ", "g3"}]}]}]}], "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           "  ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"zeta", " ", "\[Rule]", " ", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
       RowBox[{"h1", " ", "\[Rule]", " ", 
        RowBox[{
         SuperscriptBox["g2", "2"], "-", " ", 
         RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
      RowBox[{"h2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
        RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g0", " ", "\[Rule]", " ", 
      RowBox[{"1", "-", " ", 
       RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sin", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
    RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7779073156192837`*^9, 3.777907331753721*^9}, 
   3.7779074031930532`*^9, 3.7779074778301153`*^9, {3.7779077200469*^9, 
   3.7779077675862827`*^9}, 3.7779086165510817`*^9},
 CellLabel->
  "In[121]:=",ExpressionUUID->"4e9c3e1d-756b-46fe-a85c-b3926ad2549f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7779077698818502`*^9, 3.777907771849421*^9}},
 CellLabel->
  "In[122]:=",ExpressionUUID->"44f02ce9-7fce-42b2-92b8-6ef52d480229"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.777907772122645*^9, 3.77790862132052*^9},
 CellLabel->
  "Out[122]=",ExpressionUUID->"0921f869-6300-42e2-b49b-219b40df4931"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "So", " ", "our", " ", "new", " ", "expression", " ", "for", " ", "the", 
   " ", "k", " ", "derivative", " ", "term", " ", "is", " ", 
   RowBox[{"this", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7779077835381613`*^9, 3.777907790895979*^9}},
 CellLabel->
  "In[115]:=",ExpressionUUID->"6823db22-c30d-4c87-823f-26f95c7b5dcf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"beta", " ", "r0", " ", 
    SuperscriptBox["r", "2"]}]], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"r", 
     RowBox[{"(", " ", 
      RowBox[{
       RowBox[{"2", " ", "eta", " ", "k", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "h1"}], "-", 
          RowBox[{"g3", " ", "g2"}]}], ")"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"4", " ", "g2", " ", "h1"}], "-", 
          RowBox[{"3", " ", "g3", " ", "h2"}]}], ")"}], " ", 
        SuperscriptBox["k", "2"]}], "-", 
       RowBox[{"eta", " ", "r0", " ", "beta", " ", "g1", " ", "h1"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g3", " ", "h2"}], "-", 
          RowBox[{"4", " ", "g2", " ", "h1"}]}], ")"}], " ", "beta", " ", "k",
         " ", "r0"}], "+", 
       RowBox[{"g2", " ", "h1", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}]}], "-", 
    RowBox[{"c14", 
     RowBox[{"(", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"-", " ", 
         SuperscriptBox["eta", "2"]}], " ", "beta", " ", 
        SuperscriptBox["g2", "2"]}], "+", 
       RowBox[{"k", " ", "eta", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", "g0", " ", "g3"}], "-", 
          RowBox[{"g1", " ", "g2"}]}], ")"}]}], "-", " ", 
       RowBox[{
        SuperscriptBox["k", "2"], "h6"}], "-", 
       RowBox[{"eta", " ", "r0", " ", "beta", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g1", " ", "g2"}], "+", 
          RowBox[{"g0", " ", "g3"}]}], ")"}]}], "+", 
       RowBox[{"2", 
        RowBox[{"(", 
         RowBox[{"h1", "-", " ", 
          RowBox[{"g1", " ", "g3"}]}], ")"}], " ", "beta", " ", "k", " ", 
        "r0"}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"g2", "-", 
          RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}], " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], " ", ")"}]}]}], " ", ")"}]}]], "Input",\

 CellChangeTimes->{{3.777907804321919*^9, 3.77790780985525*^9}, {
  3.7779086254310703`*^9, 
  3.777908671366146*^9}},ExpressionUUID->"659cc175-2bf5-4c6e-aebb-\
ce18e5fa3ac9"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"beta", " ", "r", " ", "r0"}]], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", "eta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "g3"}], "+", 
       RowBox[{"g1", " ", "h1"}]}], ")"}], " ", "k"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"4", " ", "g2", " ", "h1"}], "-", 
       RowBox[{"3", " ", "g3", " ", "h2"}]}], ")"}], " ", 
     SuperscriptBox["k", "2"]}], "-", 
    RowBox[{"beta", " ", "eta", " ", "g1", " ", "h1", " ", "r0"}], "+", 
    RowBox[{"beta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "g2", " ", "h1"}], "+", 
       RowBox[{"g3", " ", "h2"}]}], ")"}], " ", "k", " ", "r0"}], "+", 
    RowBox[{
     SuperscriptBox["beta", "2"], " ", "g2", " ", "h1", " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{
     FractionBox["1", "r"], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "h1"}], " ", "k"}], "+", 
        RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "beta"}], " ", 
         SuperscriptBox["eta", "2"], " ", 
         SuperscriptBox["g2", "2"]}], "+", 
        RowBox[{"eta", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "g1"}], " ", "g2"}], "+", 
           RowBox[{"3", " ", "g0", " ", "g3"}]}], ")"}], " ", "k"}], "-", 
        RowBox[{"h6", " ", 
         SuperscriptBox["k", "2"]}], "-", 
        RowBox[{"beta", " ", "eta", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], "+", 
           RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}], "+", 
        RowBox[{"2", " ", "beta", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "g1"}], " ", "g3"}], "+", "h1"}], ")"}], " ", "k", 
         " ", "r0"}], "-", 
        RowBox[{"beta", " ", 
         RowBox[{"(", 
          RowBox[{"g2", "-", 
           RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
         SuperscriptBox["r0", "2"]}]}], ")"}]}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.777907810932053*^9, 3.777908628155065*^9},
 CellLabel->
  "Out[123]=",ExpressionUUID->"6fc68671-6a37-484a-ac01-5df9f8e8919f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777907826289016*^9, 3.777907827568564*^9}},
 CellLabel->
  "In[124]:=",ExpressionUUID->"d7122383-4014-4ae4-a803-c334e6fec45c"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"beta", " ", "r", " ", "r0"}]], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", "eta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "g3"}], "+", 
       RowBox[{"g1", " ", "h1"}]}], ")"}], " ", "k"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"4", " ", "g2", " ", "h1"}], "-", 
       RowBox[{"3", " ", "g3", " ", "h2"}]}], ")"}], " ", 
     SuperscriptBox["k", "2"]}], "-", 
    RowBox[{"beta", " ", "eta", " ", "g1", " ", "h1", " ", "r0"}], "+", 
    RowBox[{"beta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "g2", " ", "h1"}], "+", 
       RowBox[{"g3", " ", "h2"}]}], ")"}], " ", "k", " ", "r0"}], "+", 
    RowBox[{
     SuperscriptBox["beta", "2"], " ", "g2", " ", "h1", " ", 
     SuperscriptBox["r0", "2"]}], "+", 
    RowBox[{
     FractionBox["1", "r"], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"h1", " ", "k"}], "-", 
        RowBox[{"g2", " ", "r0"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "k"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "g1", " ", "g2"}], "-", 
           RowBox[{"3", " ", "eta", " ", "g0", " ", "g3"}], "+", 
           RowBox[{"h6", " ", "k"}]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["beta", "2"], " ", "g1", " ", "g3", " ", 
         SuperscriptBox["r0", "2"]}], "-", 
        RowBox[{"beta", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox["eta", "2"], " ", 
            SuperscriptBox["g2", "2"]}], "+", 
           RowBox[{"eta", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g1", " ", "g2"}], "+", 
              RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}], "+", 
           RowBox[{"r0", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "g1", " ", "g3", " ", "k"}], "-", 
              RowBox[{"2", " ", "h1", " ", "k"}], "+", 
              RowBox[{"g2", " ", "r0"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.7779078280457277`*^9, 3.777908631152933*^9},
 CellLabel->
  "Out[124]=",ExpressionUUID->"fd258893-1bd7-43b5-945b-f24e4ea06b3e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Examine", " ", "dv0", " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.778034302048394*^9, 3.77803430659042*^9}},
 CellLabel->
  "In[194]:=",ExpressionUUID->"1f20e9f6-cf9d-4431-b194-9e9f0d5fbde7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  FractionBox["v0", "beta"], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"r", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "g2", " ", "r0"}], " ", "-", 
                    RowBox[{"4", " ", "h1", " ", "k"}]}], ")"}]}], "+", 
                    RowBox[{"d", "  ", "beta", " ", "c23"}], "-", 
                    RowBox[{"c18", " ", "c14"}], "+", 
                    FractionBox[
                    RowBox[{"d", " ", "beta", " ", "c14", " ", "c2"}], "r"]}],
                    ")"}]}], "+", 
                 RowBox[{"x0", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"k", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"h2", " ", "g2"}], "+", 
                    RowBox[{"g1", " ", "h1"}]}], ")"}]}], "-", 
                    RowBox[{"2", "r0", " ", "g1", " ", "g2"}], " ", "+", 
                    FractionBox[
                    RowBox[{"g2", " ", "c14", " ", "c2"}], "r"]}], ")"}]}]}], 
                ")"}], " ", "/.", " ", 
               RowBox[{"h6", " ", "\[Rule]", " ", 
                RowBox[{
                 RowBox[{"2", " ", 
                  SuperscriptBox["g2", "2"]}], "-", 
                 RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
              RowBox[{"zeta", " ", "\[Rule]", " ", 
               RowBox[{"k", "-", 
                RowBox[{"beta", " ", "r0"}]}]}]}], "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], " ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], "  ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"h1", " ", "\[Rule]", " ", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", " ", 
            RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h2", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
           RowBox[{"g0", " ", "g3"}]}]}]}], "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"Cos", "[", "gamma", "]"}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.778034310686822*^9, 3.77803434264671*^9}, 
   3.778034380577197*^9, {3.778034429354486*^9, 3.778034429455597*^9}, {
   3.778035540993877*^9, 3.77803556329922*^9}},
 CellLabel->
  "In[232]:=",ExpressionUUID->"2435b9a1-ba44-44b6-ac47-1b6d293a8222"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"r0", " ", "x0", " ", 
      SuperscriptBox["gamma", "3"]}], 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]]}], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "3"}], " ", 
        SuperscriptBox["r0", "2"], " ", "v0"}], "+", 
       RowBox[{"eta", " ", "x0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["eta", "2"]}], "+", 
       RowBox[{"2", " ", "k", " ", "r0"}]}], ")"}], " ", "x0", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "3"}], " ", 
           SuperscriptBox["eta", "2"]}], "+", 
          RowBox[{"8", " ", "k", " ", "r0"}]}], ")"}], " ", "v0"}], 
       RowBox[{"24", " ", 
        SuperscriptBox["beta", "3"]}]], "+", 
      FractionBox[
       RowBox[{"eta", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"6", " ", 
           SuperscriptBox["eta", "2"]}], "-", 
          RowBox[{"10", " ", "k", " ", "r0"}], "+", 
          RowBox[{"5", " ", "beta", " ", 
           SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
       RowBox[{"24", " ", 
        SuperscriptBox["beta", "3"], " ", 
        SuperscriptBox["r0", "2"]}]]}], ")"}], " ", 
    SuperscriptBox["gamma", "6"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {-$CellContext`beta^Rational[-3, 2] $CellContext`r0 $CellContext`x0, 
    Rational[1, 
      4] $CellContext`beta^(-2) ((-3) $CellContext`r0^2 $CellContext`v0 + \
$CellContext`eta $CellContext`x0), 
    Rational[1, 4] $CellContext`beta^
     Rational[-5, 2] $CellContext`r0^(-1) (-$CellContext`eta^2 + 
     2 $CellContext`k $CellContext`r0) $CellContext`x0, 
    Rational[1, 24] $CellContext`beta^(-3) ((-3) $CellContext`eta^2 + 
      8 $CellContext`k $CellContext`r0) $CellContext`v0 + 
    Rational[1, 
       24] $CellContext`beta^(-3) $CellContext`eta $CellContext`r0^(-2) (
      6 $CellContext`eta^2 - 10 $CellContext`k $CellContext`r0 + 
      5 $CellContext`beta $CellContext`r0^2) $CellContext`x0}, 3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.77803434300725*^9, 3.7780343816969013`*^9, 3.778034429962079*^9, {
   3.7780355421631413`*^9, 3.77803556379005*^9}},
 CellLabel->
  "Out[232]=",ExpressionUUID->"d2d1c358-1bc6-4898-b9e6-77bdda947862"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 FractionBox["v0", "beta"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", "eta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"g2", " ", "g3"}], "-", 
                    RowBox[{"g1", " ", "h1"}]}], ")"}], " ", "k"}], "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", " ", "g3", " ", "h2"}], "-", 
                    RowBox[{"4", "h1", " ", "g2"}]}], ")"}], " ", 
                    SuperscriptBox["k", "2"]}], "+", 
                   RowBox[{"beta", " ", "g2", " ", "r0", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", " ", "h1", " ", "k"}], " ", "-", 
                    RowBox[{"g2", " ", "r0"}]}], ")"}]}], "+", 
                   RowBox[{
                    FractionBox["c14", "r"], 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "beta"}], " ", 
                    SuperscriptBox["g2", "2"], " ", 
                    SuperscriptBox["eta", "2"]}], "+", 
                    RowBox[{"eta", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "g0", " ", "g3"}], "-", "h2"}], ")"}], 
                    " ", "k"}], "-", 
                    RowBox[{"h6", " ", 
                    SuperscriptBox["k", "2"]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "eta", " ", "g1", " ", "g2"}], 
                    "+", 
                    RowBox[{"k", 
                    RowBox[{"(", 
                    RowBox[{"h1", "-", 
                    RowBox[{"2", " ", "g1", " ", "g3"}]}], ")"}]}]}], ")"}], 
                    " ", "beta", " ", "r0"}], "-", 
                    RowBox[{"beta", " ", 
                    SuperscriptBox["g1", "2"], " ", 
                    SuperscriptBox["r0", "2"]}]}], " ", ")"}]}]}], ")"}]}], 
                ")"}], " ", "/.", " ", 
               RowBox[{"h6", " ", "\[Rule]", " ", 
                RowBox[{
                 RowBox[{"2", " ", 
                  SuperscriptBox["g2", "2"]}], "-", 
                 RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
              RowBox[{"zeta", " ", "\[Rule]", " ", 
               RowBox[{"k", "-", 
                RowBox[{"beta", " ", "r0"}]}]}]}], "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], " ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], "  ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"h1", " ", "\[Rule]", " ", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", " ", 
            RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h2", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
           RowBox[{"g0", " ", "g3"}]}]}]}], "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"Cos", "[", "gamma", "]"}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.77803444433578*^9, 3.778034513886096*^9}, {
   3.77803515606831*^9, 3.778035187555132*^9}, {3.778035314891843*^9, 
   3.778035330210374*^9}, 3.7780355201769743`*^9, {3.7780355655336857`*^9, 
   3.778035565611274*^9}},
 CellLabel->
  "In[233]:=",ExpressionUUID->"76b400a8-725a-413d-9fa2-af49ea32b036"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["r0", "2"], " ", "v0"}], ")"}], " ", 
      SuperscriptBox["gamma", "4"]}], 
     RowBox[{"4", " ", 
      SuperscriptBox["beta", "2"]}]]}], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "3"}], " ", 
        SuperscriptBox["eta", "2"]}], "+", 
       RowBox[{"8", " ", "k", " ", "r0"}]}], ")"}], " ", "v0", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-3, 4] $CellContext`beta^(-2) $CellContext`r0^2 $CellContext`v0, 
    0, Rational[1, 24] $CellContext`beta^(-3) ((-3) $CellContext`eta^2 + 
     8 $CellContext`k $CellContext`r0) $CellContext`v0}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.778034452320396*^9, {3.77803449960813*^9, 3.778034520238584*^9}, {
   3.778035177695874*^9, 3.778035199604251*^9}, 3.778035523022976*^9, 
   3.778035566059518*^9},
 CellLabel->
  "Out[233]=",ExpressionUUID->"566abf56-589c-417b-ad3f-9f748f53241b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"r", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "g2", " ", "r0"}], " ", "-", 
          RowBox[{"4", " ", "h1", " ", "k"}]}], ")"}]}], "+", 
       RowBox[{"d", "  ", "beta", " ", "c23"}]}], " ", "/.", " ", 
      RowBox[{"h1", " ", "\[Rule]", " ", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", " ", 
        RowBox[{"g1", " ", "g3"}]}]}]}], "/.", " ", 
     RowBox[{"h2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
       RowBox[{"g0", " ", "g3"}]}]}]}], " ", "/.", " ", 
    RowBox[{"d", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"h", "+", 
        RowBox[{"eta", "*", "g2"}], "+", 
        RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
    " ", 
   RowBox[{"h", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
     RowBox[{"k", " ", "g3"}]}]}]}], "  ", "/.", " ", 
  RowBox[{"r", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
    RowBox[{"k", " ", "g2"}]}]}]}]], "Input",
 CellChangeTimes->{{3.778034533822917*^9, 3.778034569683381*^9}},
 CellLabel->
  "In[209]:=",ExpressionUUID->"fa84965a-105d-432a-97fd-2a40d16b6fd4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "-", 
        RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "k"}], "-", 
     RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
     RowBox[{"3", " ", "g3", " ", "k"}], "+", 
     RowBox[{"g1", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", 
        RowBox[{"g1", " ", "g3"}]}], ")"}], " ", "k"}], "+", 
     RowBox[{"2", " ", "g2", " ", "r0"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.778034545626346*^9, 3.7780345701076183`*^9}},
 CellLabel->
  "Out[209]=",ExpressionUUID->"d2341ce0-4992-4a50-ad8f-8d64ea097185"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7780345738845377`*^9, 3.7780345791865664`*^9}},
 CellLabel->
  "In[210]:=",ExpressionUUID->"fb89b68b-a2e1-4f0b-ab80-7b666845101e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "g2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "-", 
        RowBox[{"g0", " ", "g3"}]}], ")"}]}], "-", 
     RowBox[{"4", " ", "g1", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", 
        RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", "g3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "-", 
        RowBox[{"g0", " ", "g3"}]}], ")"}]}], "-", 
     RowBox[{"4", " ", "g2", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", 
        RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"3", " ", "g1", " ", "g3"}], "+", 
     RowBox[{"g1", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "-", 
        RowBox[{"g0", " ", "g3"}]}], ")"}]}], "-", 
     RowBox[{"4", " ", "g0", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g2", "2"], "-", 
        RowBox[{"g1", " ", "g3"}]}], ")"}]}]}], ")"}], " ", "k", " ", "r0"}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["g1", "2"]}], "+", 
     RowBox[{"2", " ", "g0", " ", "g2"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.778034579450447*^9},
 CellLabel->
  "Out[210]=",ExpressionUUID->"6bdd174e-8256-4567-86d1-521578696817"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.778034602951599*^9, 3.778034604606312*^9}},
 CellLabel->
  "In[211]:=",ExpressionUUID->"14736685-2de7-477e-ab1d-bab53ff156d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", "eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g1"}], " ", 
      SuperscriptBox["g2", "2"]}], "+", " ", 
     RowBox[{
      SuperscriptBox["g1", "2"], " ", "g3"}], "+", 
     RowBox[{"g3", " ", "g2"}]}], ")"}], " ", "k"}], "-", 
  RowBox[{"4", " ", 
   SuperscriptBox["g2", "3"], " ", 
   SuperscriptBox["k", "2"]}], "-", 
  RowBox[{"3", " ", "g0", " ", 
   SuperscriptBox["g3", "2"], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"2", " ", "g0"}]}], ")"}], " ", 
   SuperscriptBox["g2", "2"], " ", "k", " ", "r0"}], "-", 
  RowBox[{"3", " ", "g1", " ", "g3", " ", "k", " ", "r0"}], "+", 
  RowBox[{"3", " ", "g0", " ", "g1", " ", "g3", " ", "k", " ", "r0"}], "-", 
  RowBox[{
   SuperscriptBox["g1", "2"], " ", 
   SuperscriptBox["r0", "2"]}], "+", 
  RowBox[{"g2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"7", " ", "g1", " ", "g3", " ", 
      SuperscriptBox["k", "2"]}], "+", 
     RowBox[{
      SuperscriptBox["g1", "2"], " ", "k", " ", "r0"}], "+", 
     RowBox[{"2", " ", "g0", " ", 
      SuperscriptBox["r0", "2"]}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.7780346186191177`*^9, 
  3.778034642656081*^9}},ExpressionUUID->"2821fbe1-3461-4feb-93d7-\
23b5a9d1a439"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778034684915153*^9, 3.778034690535019*^9}},
 CellLabel->
  "In[212]:=",ExpressionUUID->"24cb7a1f-93df-4ed5-9af9-e97bc5ddb856"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", "eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g1"}], " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox["g1", "2"], " ", "g3"}], "-", 
     RowBox[{"g0", " ", "g2", " ", "g3"}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", 
      SuperscriptBox["g2", "3"]}], "+", 
     RowBox[{"7", " ", "g1", " ", "g2", " ", "g3"}], "-", 
     RowBox[{"3", " ", "g0", " ", 
      SuperscriptBox["g3", "2"]}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["g1", "2"], " ", "g2"}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"2", " ", "g0"}]}], ")"}], " ", 
      SuperscriptBox["g2", "2"]}], "-", 
     RowBox[{"3", " ", "g1", " ", "g3"}], "+", 
     RowBox[{"3", " ", "g0", " ", "g1", " ", "g3"}]}], ")"}], " ", "k", " ", 
   "r0"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["g1", "2"]}], "+", 
     RowBox[{"2", " ", "g0", " ", "g2"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.778034690799933*^9},
 CellLabel->
  "Out[212]=",ExpressionUUID->"391fb4c0-7bb7-4c7c-9bcc-459e05ea0288"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", "eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g2", " ", "g3"}], "-", 
     RowBox[{"g1", " ", "h1"}]}], ")"}], " ", "k"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", "g3", " ", "h2"}], "-", 
     RowBox[{"4", "h1", " ", "g2"}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"beta", " ", "g2", " ", "r0", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", "h1", " ", "k"}], " ", "-", 
     RowBox[{"g2", " ", "r0"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.7780347133581877`*^9, 
  3.778035142846754*^9}},ExpressionUUID->"c2f25b3d-2755-4e35-88ff-\
c8c888399667"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Now", " ", "for", " ", "the", " ", "next", " ", 
    RowBox[{"term", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.7780352122602386`*^9, 3.7780352163189907`*^9}},
 CellLabel->
  "In[220]:=",ExpressionUUID->"67988d59-eb42-43b5-ac31-b16f408ab839"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"d", " ", "beta", "  ", "c2"}], "-", 
       RowBox[{"r", " ", "c18"}]}], " ", "/.", " ", 
      RowBox[{"zeta", " ", "\[Rule]", " ", 
       RowBox[{"k", "-", 
        RowBox[{"beta", " ", "r0"}]}]}]}], "/.", " ", 
     RowBox[{"d", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", "*", "g2"}], "+", 
         RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"h", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
      RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
      RowBox[{"k", " ", "g3"}]}]}]}], "  ", "/.", " ", 
   RowBox[{"r", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
     RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
  RowBox[{"h1", " ", "\[Rule]", " ", 
   RowBox[{
    SuperscriptBox["g2", "2"], "-", " ", 
    RowBox[{"g1", " ", "g3", " "}]}]}]}]], "Input",
 CellChangeTimes->{{3.7780352270947437`*^9, 3.778035280056498*^9}, 
   3.778035339821398*^9},
 CellLabel->
  "In[227]:=",ExpressionUUID->"155a6454-70f1-4d3c-b49d-8e0ab0307520"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}]}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
     RowBox[{"3", " ", "g3", " ", "k"}], "+", 
     RowBox[{"g1", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"g1", " ", 
      RowBox[{"(", 
       RowBox[{"k", "-", 
        RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.778035280792098*^9, 3.778035340559535*^9},
 CellLabel->
  "Out[227]=",ExpressionUUID->"01926593-09ef-489e-971a-4c6786cc54b2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r0", ",", "eta", ",", "k"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7780353495870132`*^9, 3.7780353561201763`*^9}},
 CellLabel->
  "In[229]:=",ExpressionUUID->"fd8ce2e7-d032-450d-bc4a-901733b15151"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "beta"}], " ", 
   SuperscriptBox["g2", "2"], " ", 
   SuperscriptBox["eta", "2"]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "g0", " ", "g3"}], "-", "h2"}], ")"}], " ", "k"}], "-", 
  RowBox[{"h6", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "eta", " ", "g1", " ", "g2"}], "+", 
     RowBox[{"k", 
      RowBox[{"(", 
       RowBox[{"h1", "-", 
        RowBox[{"2", " ", "g1", " ", "g3"}]}], ")"}]}]}], ")"}], " ", "beta", 
   " ", "r0"}], "-", 
  RowBox[{"beta", " ", 
   SuperscriptBox["g1", "2"], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Input",
 CellChangeTimes->{{3.77803536294525*^9, 
  3.778035514013691*^9}},ExpressionUUID->"c5e42b64-85d3-4651-99fa-\
9c405c18408e"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.778035252143578*^9, 3.778035255133943*^9}, 
   3.778035360568244*^9},ExpressionUUID->"522dbb12-dc49-4254-9866-\
2426a0da808a"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Next", ",", " ", 
   RowBox[{"working", " ", "on", " ", 
    RowBox[{"dv0", ".", "x0"}], " ", 
    RowBox[{"term", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.778035598829451*^9, 3.778035608251849*^9}},
 CellLabel->
  "In[234]:=",ExpressionUUID->"e012e4f4-c199-493d-aaa3-7c6f53f2479c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"x0", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"k", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"h2", " ", "g2"}], "+", 
                    RowBox[{"g1", " ", "h1"}]}], ")"}]}], "+", 
                   FractionBox[
                    RowBox[{"g2", " ", "c14", " ", "c2"}], "r"], "-", 
                   RowBox[{"2", "r0", " ", "g1", " ", "g2"}]}], " ", ")"}]}], 
                ")"}], " ", "/.", " ", 
               RowBox[{"h6", " ", "\[Rule]", " ", 
                RowBox[{
                 RowBox[{"2", " ", 
                  SuperscriptBox["g2", "2"]}], "-", 
                 RowBox[{"3", " ", "g1", " ", "g3"}]}]}]}], "/.", " ", 
              RowBox[{"zeta", " ", "\[Rule]", " ", 
               RowBox[{"k", "-", 
                RowBox[{"beta", " ", "r0"}]}]}]}], "/.", " ", 
             RowBox[{"d", " ", "\[Rule]", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"eta", "*", "g2"}], "+", 
                 RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", 
               "beta"}]}]}], " ", "/.", " ", 
            RowBox[{"h", " ", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
              RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
              RowBox[{"k", " ", "g3"}]}]}]}], "  ", "/.", " ", 
           RowBox[{"r", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
             RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
             RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
          RowBox[{"h1", " ", "\[Rule]", " ", 
           RowBox[{
            SuperscriptBox["g2", "2"], "-", " ", 
            RowBox[{"g1", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"h2", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"g1", " ", "g2"}], " ", "-", " ", 
           RowBox[{"g0", " ", "g3"}]}]}]}], "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"Cos", "[", "gamma", "]"}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.7780356198858337`*^9, 3.7780356542222157`*^9}},
 CellLabel->"",ExpressionUUID->"b2732058-b776-4499-a3ae-6d04634b0f17"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"r0", " ", "x0", " ", 
      SuperscriptBox["gamma", "3"]}], 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]]}], "+", 
   FractionBox[
    RowBox[{"eta", " ", "x0", " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["eta", "2"]}], "+", 
       RowBox[{"2", " ", "k", " ", "r0"}]}], ")"}], " ", "x0", " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"4", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", "r0"}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"6", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"10", " ", "k", " ", "r0"}], "+", 
       RowBox[{"5", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0", " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {-$CellContext`beta^Rational[-3, 2] $CellContext`r0 $CellContext`x0, 
    Rational[1, 4] $CellContext`beta^(-2) $CellContext`eta $CellContext`x0, 
    Rational[1, 4] $CellContext`beta^
     Rational[-5, 2] $CellContext`r0^(-1) (-$CellContext`eta^2 + 
     2 $CellContext`k $CellContext`r0) $CellContext`x0, 
    Rational[1, 
      24] $CellContext`beta^(-3) $CellContext`eta $CellContext`r0^(-2) (
     6 $CellContext`eta^2 - 10 $CellContext`k $CellContext`r0 + 
     5 $CellContext`beta $CellContext`r0^2) $CellContext`x0}, 3, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.778035622314877*^9},
 CellLabel->
  "Out[235]=",ExpressionUUID->"1e98bc29-fb35-4031-b27f-f7d9fc89acb9"]
}, Open  ]]
},
WindowSize->{1082, 546},
WindowMargins->{{91, Automatic}, {Automatic, 0}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[400, 13, 147, 3, 52, "Input",ExpressionUUID->"6b8e2350-0309-4df2-8199-28d0609f26d6"],
Cell[550, 18, 147, 3, 52, "Input",ExpressionUUID->"6b8e2350-0309-4df2-8199-28d0609f26d6"],
Cell[700, 23, 2501, 64, 220, "Input",ExpressionUUID->"53329b6c-a80c-45ac-ae62-f6fb243392bd"],
Cell[CellGroupData[{
Cell[3226, 91, 1278, 33, 50, "Input",ExpressionUUID->"48462b44-b891-42a8-998f-37b74e902302"],
Cell[4507, 126, 992, 29, 68, "Output",ExpressionUUID->"8db55ecc-8814-4135-88c4-67d5f0686424"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5536, 160, 1432, 43, 91, "Input",ExpressionUUID->"ec64950c-8ed3-4bc5-92a5-293069313a0b"],
Cell[6971, 205, 2092, 67, 113, "Output",ExpressionUUID->"ebefe9b9-e235-4da4-96cf-36f540c114e3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9100, 277, 503, 12, 30, "Input",ExpressionUUID->"95296aac-8480-48bf-b720-90060933f9ed"],
Cell[9606, 291, 452, 10, 53, "Output",ExpressionUUID->"a17f2a6e-ad8b-42d3-aa68-3eddf98914b6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10095, 306, 276, 5, 30, "Input",ExpressionUUID->"6e130959-e5af-4389-aed5-d86ced425512"],
Cell[10374, 313, 286, 5, 52, "Output",ExpressionUUID->"bdfbb573-556a-4f0c-91b5-6ac32f905278"]
}, Open  ]],
Cell[10675, 321, 619, 14, 30, "Input",ExpressionUUID->"2d884b31-7a55-4520-bbb8-26a9cd31ce07"],
Cell[CellGroupData[{
Cell[11319, 339, 1653, 46, 51, "Input",ExpressionUUID->"a6c48c41-52a5-424e-8082-2ada96dd916c"],
Cell[12975, 387, 6170, 175, 496, "Output",ExpressionUUID->"38996fdd-651c-4277-ae21-efa85a998f6b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19182, 567, 305, 7, 30, "Input",ExpressionUUID->"c50ee62d-22cf-45d5-85af-1fc4bc50ccb2"],
Cell[19490, 576, 8047, 254, 428, "Output",ExpressionUUID->"ce91bbb7-847e-4706-b2c5-8ab590ad38d7"]
}, Open  ]],
Cell[27552, 833, 522, 15, 52, "Input",ExpressionUUID->"5016d470-2559-42c7-9097-a15b73e2e0c2"],
Cell[CellGroupData[{
Cell[28099, 852, 3479, 103, 188, "Input",ExpressionUUID->"86606400-4dcd-4a36-bd1d-3a1e6bba1e6b"],
Cell[31581, 957, 3589, 114, 157, "Output",ExpressionUUID->"bf0a6582-47f2-44df-b4bc-47e2a00ce439"]
}, Open  ]],
Cell[35185, 1074, 257, 5, 30, "Input",ExpressionUUID->"93376667-ae79-4f2c-bce9-f4e105374de8"],
Cell[CellGroupData[{
Cell[35467, 1083, 2354, 70, 127, "Input",ExpressionUUID->"4c137373-3aac-4897-9d22-41fe9976ebba"],
Cell[37824, 1155, 2645, 83, 103, "Output",ExpressionUUID->"5208d4ae-9cec-4351-a186-0183944f9c8c"]
}, Open  ]],
Cell[40484, 1241, 452, 9, 30, "Input",ExpressionUUID->"d4d207ae-e603-472b-bd2a-7645ab9a44c9"],
Cell[CellGroupData[{
Cell[40961, 1254, 10138, 296, 386, "Input",ExpressionUUID->"71c53a07-8e97-43ef-b6c9-30d71d21b7fa"],
Cell[51102, 1552, 9527, 291, 388, "Output",ExpressionUUID->"f45c6936-9662-49ec-9856-605f4435759e"]
}, Open  ]],
Cell[60644, 1846, 364, 9, 30, "Input",ExpressionUUID->"737a2b71-af6e-49a2-8fb6-9769070ef2d4"],
Cell[CellGroupData[{
Cell[61033, 1859, 1221, 33, 178, "Input",ExpressionUUID->"91ab92d8-9507-4b23-90cf-42efcb27b1a1"],
Cell[62257, 1894, 296, 6, 34, "Output",ExpressionUUID->"4b06fc5a-4109-46b4-a19e-77d2f71c4d8f"],
Cell[62556, 1902, 324, 7, 34, "Output",ExpressionUUID->"5e84f7bb-2216-4e72-b457-0f30a75567ce"],
Cell[62883, 1911, 343, 8, 34, "Output",ExpressionUUID->"0b1a3d4d-e564-4342-9912-0671924461ea"],
Cell[63229, 1921, 339, 8, 34, "Output",ExpressionUUID->"162829fd-9cda-4afa-9962-62090ae546f1"],
Cell[63571, 1931, 324, 7, 34, "Output",ExpressionUUID->"7ace380e-2b18-4879-b4ea-e9cecfa8362a"],
Cell[63898, 1940, 331, 7, 34, "Output",ExpressionUUID->"83be9852-d35a-49b1-aa79-2582b781039a"],
Cell[64232, 1949, 320, 7, 34, "Output",ExpressionUUID->"6fb91625-bd4d-4682-821c-dbf9cfd0afb7"]
}, Open  ]],
Cell[64567, 1959, 2158, 70, 121, "Input",ExpressionUUID->"aa55b9af-4033-4b14-b4d7-6f46d4109338"],
Cell[CellGroupData[{
Cell[66750, 2033, 5816, 145, 222, "Input",ExpressionUUID->"4321d870-f29f-4814-817c-fee11a6a61b8"],
Cell[72569, 2180, 7241, 218, 312, "Output",ExpressionUUID->"93d805b2-d363-435e-b297-67a973e20ecb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[79847, 2403, 215, 3, 30, "Input",ExpressionUUID->"e02c3643-07cb-4869-9757-bd019ee75903"],
Cell[80065, 2408, 16546, 505, 648, "Output",ExpressionUUID->"8279582f-f739-4578-bba4-8dde3a8aedf7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[96648, 2918, 206, 3, 30, "Input",ExpressionUUID->"fede4484-8d1f-46f2-9df2-d64a9830e6b1"],
Cell[96857, 2923, 611, 15, 53, "Output",ExpressionUUID->"71991028-0bb1-4bf9-b92b-83368a16941d"]
}, Open  ]],
Cell[97483, 2941, 2501, 64, 220, "Input",ExpressionUUID->"53329b6c-a80c-45ac-ae62-f6fb243392bd"],
Cell[CellGroupData[{
Cell[100009, 3009, 1278, 33, 50, "Input",ExpressionUUID->"48462b44-b891-42a8-998f-37b74e902302"],
Cell[101290, 3044, 968, 29, 68, "Output",ExpressionUUID->"798c0e57-0f25-44c6-9e84-a28027278d29"]
}, Open  ]],
Cell[CellGroupData[{
Cell[102295, 3078, 1432, 43, 91, "Input",ExpressionUUID->"ec64950c-8ed3-4bc5-92a5-293069313a0b"],
Cell[103730, 3123, 2070, 67, 113, "Output",ExpressionUUID->"0da36afe-3ffb-4657-b038-690bcf188d71"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105837, 3195, 503, 12, 30, "Input",ExpressionUUID->"95296aac-8480-48bf-b720-90060933f9ed"],
Cell[106343, 3209, 430, 10, 53, "Output",ExpressionUUID->"9380a9d8-974d-4a1e-83c8-a233820a0c75"]
}, Open  ]],
Cell[CellGroupData[{
Cell[106810, 3224, 276, 5, 30, "Input",ExpressionUUID->"6e130959-e5af-4389-aed5-d86ced425512"],
Cell[107089, 3231, 264, 5, 52, "Output",ExpressionUUID->"aa27bf58-5e5e-4d4c-b447-c36e535e59cc"]
}, Open  ]],
Cell[107368, 3239, 619, 14, 30, "Input",ExpressionUUID->"2d884b31-7a55-4520-bbb8-26a9cd31ce07"],
Cell[CellGroupData[{
Cell[108012, 3257, 1654, 46, 51, "Input",ExpressionUUID->"a6c48c41-52a5-424e-8082-2ada96dd916c"],
Cell[109669, 3305, 6149, 175, 496, "Output",ExpressionUUID->"0f231a7d-c2dc-43fa-ae92-8ed490b55b83"]
}, Open  ]],
Cell[CellGroupData[{
Cell[115855, 3485, 306, 7, 30, "Input",ExpressionUUID->"c50ee62d-22cf-45d5-85af-1fc4bc50ccb2"],
Cell[116164, 3494, 8026, 254, 428, "Output",ExpressionUUID->"2cfd0f53-8a60-43b5-ac76-ec7eea1ee595"]
}, Open  ]],
Cell[124205, 3751, 522, 15, 52, "Input",ExpressionUUID->"5016d470-2559-42c7-9097-a15b73e2e0c2"],
Cell[CellGroupData[{
Cell[124752, 3770, 3479, 103, 188, "Input",ExpressionUUID->"86606400-4dcd-4a36-bd1d-3a1e6bba1e6b"],
Cell[128234, 3875, 3589, 114, 157, "Output",ExpressionUUID->"bf0a6582-47f2-44df-b4bc-47e2a00ce439"]
}, Open  ]],
Cell[131838, 3992, 257, 5, 30, "Input",ExpressionUUID->"93376667-ae79-4f2c-bce9-f4e105374de8"],
Cell[CellGroupData[{
Cell[132120, 4001, 2354, 70, 127, "Input",ExpressionUUID->"4c137373-3aac-4897-9d22-41fe9976ebba"],
Cell[134477, 4073, 2645, 83, 103, "Output",ExpressionUUID->"5208d4ae-9cec-4351-a186-0183944f9c8c"]
}, Open  ]],
Cell[137137, 4159, 452, 9, 30, "Input",ExpressionUUID->"d4d207ae-e603-472b-bd2a-7645ab9a44c9"],
Cell[CellGroupData[{
Cell[137614, 4172, 10138, 296, 386, "Input",ExpressionUUID->"71c53a07-8e97-43ef-b6c9-30d71d21b7fa"],
Cell[147755, 4470, 9505, 291, 388, "Output",ExpressionUUID->"11b81da4-e26a-423f-b1a9-5e96243cbdb1"]
}, Open  ]],
Cell[157275, 4764, 364, 9, 30, "Input",ExpressionUUID->"737a2b71-af6e-49a2-8fb6-9769070ef2d4"],
Cell[CellGroupData[{
Cell[157664, 4777, 1226, 34, 178, "Input",ExpressionUUID->"91ab92d8-9507-4b23-90cf-42efcb27b1a1"],
Cell[158893, 4813, 249, 6, 34, "Output",ExpressionUUID->"3d551d09-f38b-4070-9278-bec65ea6328a"],
Cell[159145, 4821, 275, 7, 34, "Output",ExpressionUUID->"3228bc45-dc3c-4885-a15e-0cc82ea2d4a9"],
Cell[159423, 4830, 299, 8, 34, "Output",ExpressionUUID->"3374a59f-afbc-4733-9177-f73cdf2ec958"],
Cell[159725, 4840, 294, 8, 34, "Output",ExpressionUUID->"494533d3-b1a9-4f1b-a76e-ea133c686e48"],
Cell[160022, 4850, 280, 7, 34, "Output",ExpressionUUID->"5e650227-99a3-4495-952b-ccad009fd301"],
Cell[160305, 4859, 286, 7, 34, "Output",ExpressionUUID->"a7297e56-13a8-47e6-a4f9-964d5d5e03cf"],
Cell[160594, 4868, 273, 7, 34, "Output",ExpressionUUID->"99e0f935-79c2-412e-9450-93dfe1e704d1"]
}, Open  ]],
Cell[160882, 4878, 202, 4, 30, "Input",ExpressionUUID->"33422313-391a-4ddb-a83f-5184bef61a6d"],
Cell[161087, 4884, 5900, 147, 222, "Input",ExpressionUUID->"4321d870-f29f-4814-817c-fee11a6a61b8"],
Cell[CellGroupData[{
Cell[167012, 5035, 4147, 122, 244, "Input",ExpressionUUID->"276170f5-94e3-4e59-a0d8-6141133c8cb9"],
Cell[171162, 5159, 1581, 28, 243, "Output",ExpressionUUID->"da59c358-c398-406d-942d-095986ed96bf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[172780, 5192, 215, 3, 30, "Input",ExpressionUUID->"e02c3643-07cb-4869-9757-bd019ee75903"],
Cell[172998, 5197, 16630, 507, 648, "Output",ExpressionUUID->"a8a101f9-c71f-44b5-89d1-fddb970ae33e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[189665, 5709, 206, 3, 30, "Input",ExpressionUUID->"fede4484-8d1f-46f2-9df2-d64a9830e6b1"],
Cell[189874, 5714, 341, 5, 34, "Output",ExpressionUUID->"ca632bec-0ffe-437d-beb2-79d30889e82a"]
}, Open  ]],
Cell[190230, 5722, 415, 9, 30, "Input",ExpressionUUID->"90527861-0697-4050-bd32-37ebbaf390e3"],
Cell[190648, 5733, 413, 11, 52, "Input",ExpressionUUID->"2b59264e-4f28-4701-bc97-695da387d829"],
Cell[CellGroupData[{
Cell[191086, 5748, 3737, 94, 149, "Input",ExpressionUUID->"85ba9264-fb06-41c4-86ef-6e792aaa7dfc"],
Cell[194826, 5844, 1564, 43, 62, "Output",ExpressionUUID->"4ff72b57-c24b-40f5-bbd6-88552766ae59"]
}, Open  ]],
Cell[196405, 5890, 271, 6, 30, "Input",ExpressionUUID->"7f18ec60-33f3-4fbc-a981-9037c4f90e1e"],
Cell[CellGroupData[{
Cell[196701, 5900, 2600, 67, 128, "Input",ExpressionUUID->"bfb6260a-2236-4d9b-9550-ae268ba4bace"],
Cell[199304, 5969, 919, 26, 60, "Output",ExpressionUUID->"361f4d8d-0ff0-460e-a513-f0ba66603cb7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[200260, 6000, 2537, 65, 98, "Input",ExpressionUUID->"2dd98b1a-929f-44af-b89b-c2c559b252b9"],
Cell[202800, 6067, 763, 22, 55, "Output",ExpressionUUID->"67e339c2-438a-4b7c-8a57-aaf25bcf4d11"]
}, Open  ]],
Cell[CellGroupData[{
Cell[203600, 6094, 2645, 68, 127, "Input",ExpressionUUID->"a7da25ae-8599-49e4-9f16-926b1d6f4f81"],
Cell[206248, 6164, 881, 25, 55, "Output",ExpressionUUID->"125dc2c7-b8f5-45f2-9b18-0193745052ff"]
}, Open  ]],
Cell[CellGroupData[{
Cell[207166, 6194, 2696, 69, 127, "Input",ExpressionUUID->"8028a242-5121-44b2-8f0b-728489f1f45b"],
Cell[209865, 6265, 3175, 85, 104, "Output",ExpressionUUID->"f48497e6-190d-4eb9-a4e2-274033d28f60"]
}, Open  ]],
Cell[CellGroupData[{
Cell[213077, 6355, 2770, 71, 128, "Input",ExpressionUUID->"f936d82d-5835-42be-80a1-3d3ecd5a0fd9"],
Cell[215850, 6428, 1729, 49, 62, "Output",ExpressionUUID->"4eb540b1-8f55-4209-b9af-3d286213386d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[217616, 6482, 2704, 70, 129, "Input",ExpressionUUID->"8193e7c6-9e6f-422f-9bfd-c54d41e38663"],
Cell[220323, 6554, 3263, 89, 109, "Output",ExpressionUUID->"5c7f3e2e-b669-4120-859f-64658e171f71"]
}, Open  ]],
Cell[223601, 6646, 395, 9, 52, "Input",ExpressionUUID->"396106c4-e967-42eb-84fd-0a1f9a4e5a5e"],
Cell[CellGroupData[{
Cell[224021, 6659, 1756, 48, 72, "Input",ExpressionUUID->"777e1aca-3b66-4cbf-9f21-55648fdcb2fa"],
Cell[225780, 6709, 1044, 33, 61, "Output",ExpressionUUID->"c6fe4d19-e004-4916-8781-6db678c84d17"]
}, Open  ]],
Cell[CellGroupData[{
Cell[226861, 6747, 208, 3, 30, "Input",ExpressionUUID->"dad4969e-d7db-40b5-9427-972918dba1f8"],
Cell[227072, 6752, 1580, 38, 77, "Output",ExpressionUUID->"09b3074d-548c-490b-88e8-45e6bf795d54"]
}, Open  ]],
Cell[CellGroupData[{
Cell[228689, 6795, 1403, 44, 51, "Input",ExpressionUUID->"61abd3ba-15ce-4d42-adb3-971d75e0c8e7"],
Cell[230095, 6841, 1395, 44, 54, "Output",ExpressionUUID->"82c48157-0c80-42b2-92d3-2bb29a47a087"]
}, Open  ]],
Cell[CellGroupData[{
Cell[231527, 6890, 1521, 34, 56, "Input",ExpressionUUID->"0f8afe40-97a7-4fc9-81f8-a48649a537ce"],
Cell[233051, 6926, 1389, 39, 60, "Output",ExpressionUUID->"2b289cf2-fa28-4602-ab1b-65b1f8a51845"]
}, Open  ]],
Cell[234455, 6968, 273, 5, 30, "Input",ExpressionUUID->"b1a7a8af-8c3d-4ce5-a181-d0c178d798bf"],
Cell[234731, 6975, 593, 17, 30, "Input",ExpressionUUID->"2ef742eb-0241-4808-b200-4154cc3cf317"],
Cell[235327, 6994, 680, 21, 30, "Input",ExpressionUUID->"58abe927-9d0c-41e9-9604-6bfbcd78dc1b"],
Cell[236010, 7017, 864, 22, 30, "Input",ExpressionUUID->"9d96a7a4-d1f5-47ac-801c-b3645991aac4"],
Cell[236877, 7041, 375, 8, 52, "Input",ExpressionUUID->"a3bbb777-642d-45a6-b7de-a7650657ed4d"],
Cell[CellGroupData[{
Cell[237277, 7053, 2486, 65, 98, "Input",ExpressionUUID->"4c4b0ea5-9804-4861-8c6c-98ebec35dd15"],
Cell[239766, 7120, 1829, 52, 57, "Output",ExpressionUUID->"32bcf3b3-e91e-4e4f-81d9-91f3c9b39b7d"]
}, Open  ]],
Cell[241610, 7175, 1402, 41, 73, "Input",ExpressionUUID->"1a540d21-449a-4377-b866-cb4cb3f1c67b"],
Cell[243015, 7218, 474, 9, 30, "Input",ExpressionUUID->"97ec569d-3fe2-4f10-b9fc-6caa440ab76f"],
Cell[243492, 7229, 497, 11, 30, "Input",ExpressionUUID->"f41bb87b-aa09-4b3d-b1f3-393896b78d13"],
Cell[243992, 7242, 540, 15, 49, "Input",ExpressionUUID->"9b04eafa-6763-45ba-b7a1-4124a4f13594"],
Cell[244535, 7259, 986, 31, 50, "Input",ExpressionUUID->"5cf46e70-8240-4b9c-968e-4cb8cb3772c2"],
Cell[245524, 7292, 254, 6, 30, "Input",ExpressionUUID->"9542dae2-a8cf-4c5a-a50a-a2ed9f3a878c"],
Cell[CellGroupData[{
Cell[245803, 7302, 1152, 32, 52, "Input",ExpressionUUID->"9707f737-c37f-4b7b-8b32-04e3d21bc692"],
Cell[246958, 7336, 955, 29, 34, "Output",ExpressionUUID->"5b1ef29d-b4ef-4c47-85e1-5999ff7bf661"]
}, Open  ]],
Cell[CellGroupData[{
Cell[247950, 7370, 292, 6, 30, "Input",ExpressionUUID->"c082a03c-361f-4d4a-bfd2-870a318aff9f"],
Cell[248245, 7378, 1587, 49, 60, "Output",ExpressionUUID->"19b0cbc3-7b49-4b66-a4ae-ede4cdbea22c"]
}, Open  ]],
Cell[249847, 7430, 1065, 31, 30, "Input",ExpressionUUID->"f77f2971-8791-4263-bf78-14df85810c01"],
Cell[250915, 7463, 154, 3, 30, "Input",ExpressionUUID->"9458a564-5791-4c54-9087-0dd00356395b"],
Cell[CellGroupData[{
Cell[251094, 7470, 2974, 77, 129, "Input",ExpressionUUID->"cf795ab8-7b06-4e99-badf-f04aa5326e91"],
Cell[254071, 7549, 1486, 42, 62, "Output",ExpressionUUID->"0884e17d-d9b7-4597-a704-5c314514ce68"]
}, Open  ]],
Cell[255572, 7594, 358, 7, 30, "Input",ExpressionUUID->"794355f4-1f80-4f24-8c81-9a4c7214a857"],
Cell[CellGroupData[{
Cell[255955, 7605, 5422, 129, 219, "Input",ExpressionUUID->"45535f52-a41b-4ef1-89cd-3e97e77b269c"],
Cell[261380, 7736, 1588, 43, 62, "Output",ExpressionUUID->"3736f7ca-756c-47ab-a911-c5bac6fac715"]
}, Open  ]],
Cell[262983, 7782, 468, 8, 30, "Input",ExpressionUUID->"49abb116-6021-436e-adc7-4b7e8d4d889c"],
Cell[CellGroupData[{
Cell[263476, 7794, 4211, 103, 153, "Input",ExpressionUUID->"34a8f003-ac37-4433-b9d6-dec34dcb1b0f"],
Cell[267690, 7899, 3437, 92, 109, "Output",ExpressionUUID->"84c4a9cd-2111-4147-8204-8d37ef74a99a"]
}, Open  ]],
Cell[271142, 7994, 394, 9, 30, "Input",ExpressionUUID->"b0f1e79c-8f45-43ac-bb15-03543d712d3d"],
Cell[271539, 8005, 919, 28, 33, "Input",ExpressionUUID->"4b8d3cb0-d865-44fa-bce5-cfe85afe85bf"],
Cell[CellGroupData[{
Cell[272483, 8037, 2529, 68, 73, "Input",ExpressionUUID->"aa9893de-075c-4b02-b5e2-34d13a0a0f7b"],
Cell[275015, 8107, 1652, 53, 60, "Output",ExpressionUUID->"819c4c01-335e-4619-9e1d-ee11e6ca475d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[276704, 8165, 301, 6, 30, "Input",ExpressionUUID->"94e67158-c068-403d-8de7-705a0aa8c220"],
Cell[277008, 8173, 2643, 83, 83, "Output",ExpressionUUID->"97b9d544-ecf5-4078-ae04-2a5236dc9e98"]
}, Open  ]],
Cell[CellGroupData[{
Cell[279688, 8261, 206, 3, 30, "Input",ExpressionUUID->"7fe82987-82b9-425d-aa84-0d7ea7817bac"],
Cell[279897, 8266, 1735, 51, 58, "Output",ExpressionUUID->"1d37813e-b3c7-4758-abf6-2ce0506d1d60"]
}, Open  ]],
Cell[CellGroupData[{
Cell[281669, 8322, 294, 6, 30, "Input",ExpressionUUID->"a02d48c7-af28-4d0b-8f36-8c8a126b26c5"],
Cell[281966, 8330, 2075, 59, 83, "Output",ExpressionUUID->"06d173d7-ae76-4703-a33f-9900c52154a8"]
}, Open  ]],
Cell[284056, 8392, 1220, 31, 30, "Input",ExpressionUUID->"56945e5c-1dc4-45aa-b095-f67304737638"],
Cell[CellGroupData[{
Cell[285301, 8427, 4024, 100, 148, "Input",ExpressionUUID->"95cc6626-7e53-466d-b106-9467ffa99961"],
Cell[289328, 8529, 3448, 93, 109, "Output",ExpressionUUID->"cd7a20c6-6158-4b67-b1a7-773ade2545e7"]
}, Open  ]],
Cell[292791, 8625, 324, 7, 30, "Input",ExpressionUUID->"7dd24355-90cd-4bb0-b493-0409df73d253"],
Cell[293118, 8634, 6556, 162, 212, "Input",ExpressionUUID->"4e9c3e1d-756b-46fe-a85c-b3926ad2549f"],
Cell[CellGroupData[{
Cell[299699, 8800, 212, 4, 30, "Input",ExpressionUUID->"44f02ce9-7fce-42b2-92b8-6ef52d480229"],
Cell[299914, 8806, 174, 3, 34, "Output",ExpressionUUID->"0921f869-6300-42e2-b49b-219b40df4931"]
}, Open  ]],
Cell[300103, 8812, 385, 8, 30, "Input",ExpressionUUID->"6823db22-c30d-4c87-823f-26f95c7b5dcf"],
Cell[CellGroupData[{
Cell[300513, 8824, 2225, 64, 75, "Input",ExpressionUUID->"659cc175-2bf5-4c6e-aebb-ce18e5fa3ac9"],
Cell[302741, 8890, 2342, 68, 87, "Output",ExpressionUUID->"6fc68671-6a37-484a-ac01-5df9f8e8919f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[305120, 8963, 210, 4, 30, "Input",ExpressionUUID->"d7122383-4014-4ae4-a803-c334e6fec45c"],
Cell[305333, 8969, 2347, 67, 87, "Output",ExpressionUUID->"fd258893-1bd7-43b5-945b-f24e4ea06b3e"]
}, Open  ]],
Cell[307695, 9039, 272, 6, 30, "Input",ExpressionUUID->"1f20e9f6-cf9d-4431-b194-9e9f0d5fbde7"],
Cell[CellGroupData[{
Cell[307992, 9049, 4137, 101, 149, "Input",ExpressionUUID->"2435b9a1-ba44-44b6-ac47-1b6d293a8222"],
Cell[312132, 9152, 2911, 81, 107, "Output",ExpressionUUID->"d2d1c358-1bc6-4898-b9e6-77bdda947862"]
}, Open  ]],
Cell[CellGroupData[{
Cell[315080, 9238, 5197, 125, 186, "Input",ExpressionUUID->"76b400a8-725a-413d-9fa2-af49ea32b036"],
Cell[320280, 9365, 1361, 38, 57, "Output",ExpressionUUID->"566abf56-589c-417b-ad3f-9f748f53241b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[321678, 9408, 1433, 40, 52, "Input",ExpressionUUID->"fa84965a-105d-432a-97fd-2a40d16b6fd4"],
Cell[323114, 9450, 1035, 33, 37, "Output",ExpressionUUID->"d2341ce0-4992-4a50-ad8f-8d64ea097185"]
}, Open  ]],
Cell[CellGroupData[{
Cell[324186, 9488, 298, 7, 30, "Input",ExpressionUUID->"fb89b68b-a2e1-4f0b-ab80-7b666845101e"],
Cell[324487, 9497, 1675, 55, 60, "Output",ExpressionUUID->"6bdd174e-8256-4567-86d1-521578696817"]
}, Open  ]],
Cell[326177, 9555, 210, 4, 30, "Input",ExpressionUUID->"14736685-2de7-477e-ab1d-bab53ff156d1"],
Cell[326390, 9561, 1332, 38, 56, InheritFromParent,ExpressionUUID->"2821fbe1-3461-4feb-93d7-23b5a9d1a439"],
Cell[CellGroupData[{
Cell[327747, 9603, 294, 7, 30, "Input",ExpressionUUID->"24cb7a1f-93df-4ed5-9af9-e97bc5ddb856"],
Cell[328044, 9612, 1367, 43, 60, "Output",ExpressionUUID->"391fb4c0-7bb7-4c7c-9bcc-459e05ea0288"]
}, Open  ]],
Cell[329426, 9658, 667, 20, 30, "Input",ExpressionUUID->"c2f25b3d-2755-4e35-88ff-c8c888399667"],
Cell[330096, 9680, 336, 7, 52, "Input",ExpressionUUID->"67988d59-eb42-43b5-ac31-b16f408ab839"],
Cell[CellGroupData[{
Cell[330457, 9691, 1291, 36, 52, "Input",ExpressionUUID->"155a6454-70f1-4d3c-b49d-8e0ab0307520"],
Cell[331751, 9729, 880, 28, 34, "Output",ExpressionUUID->"01926593-09ef-489e-971a-4c6786cc54b2"]
}, Open  ]],
Cell[332646, 9760, 298, 7, 30, "Input",ExpressionUUID->"fd8ce2e7-d032-450d-bc4a-901733b15151"],
Cell[332947, 9769, 852, 27, 30, InheritFromParent,ExpressionUUID->"c5e42b64-85d3-4651-99fa-9c405c18408e"],
Cell[333802, 9798, 175, 3, 30, "Input",ExpressionUUID->"522dbb12-dc49-4254-9866-2426a0da808a"],
Cell[333980, 9803, 343, 8, 30, "Input",ExpressionUUID->"e012e4f4-c199-493d-aaa3-7c6f53f2479c"],
Cell[CellGroupData[{
Cell[334348, 9815, 3332, 83, 145, "Input",ExpressionUUID->"b2732058-b776-4499-a3ae-6d04634b0f17"],
Cell[337683, 9900, 2052, 56, 57, "Output",ExpressionUUID->"1e98bc29-fb35-4031-b27f-f7d9fc89acb9"]
}, Open  ]]
}
]
*)

