(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    109674,       3234]
NotebookOptionsPosition[    100430,       3075]
NotebookOutlinePosition[    100766,       3090]
CellTagsIndexPosition[    100723,       3087]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Trying", " ", "to", " ", "compute", " ", "differentials", " ", "of", " ",
      "r", " ", "needed", " ", "in", " ", "Drift"}], " ", "+", " ", 
    RowBox[{"Kepler", " ", 
     RowBox[{"problem", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Note", ":", "  ", 
     RowBox[{"below", "  ", "d"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", "*", "g2"}], "+", 
         RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}], 
      "\[IndentingNewLine]", "r"}], " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
       RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
       RowBox[{"k", " ", "g2", "\[IndentingNewLine]", "h"}]}], " ", "=", " ", 
      
      RowBox[{
       RowBox[{
        RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
        RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
        RowBox[{"k", " ", "g3", "\[IndentingNewLine]", "g0"}]}], " ", "=", 
       " ", 
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2", " ", "\[IndentingNewLine]", "g3"}]}], " ",
         "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"s", "-", "g1"}], ")"}], "/", "beta"}], " ", 
           "\[IndentingNewLine]", "g0", " ", "g2"}], " ", "-", " ", 
          RowBox[{"g1", "^", "2"}]}], " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"-", "g2"}], "\[IndentingNewLine]", 
            RowBox[{"g0", "^", "2"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"g1", "^", "2"}], " ", "beta"}]}], " ", "=", " ", 
          RowBox[{
           RowBox[{"1", "\[IndentingNewLine]", "zeta"}], " ", "=", " ", 
           RowBox[{
            RowBox[{"k", "-", 
             RowBox[{"beta", " ", "r0", "\[IndentingNewLine]", "h1"}]}], " ", 
            "=", " ", 
            RowBox[{
             RowBox[{"g2", "^", "2"}], " ", "-", " ", 
             RowBox[{"g1", " ", "g3"}]}]}]}]}]}]}]}]}]}]}], 
   "\[IndentingNewLine]", " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
  3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
  3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
  3.7766111002427273`*^9, 3.776611150430565*^9}, {3.776615220729578*^9, 
  3.776615226632469*^9}},ExpressionUUID->"53329b6c-a80c-45ac-ae62-\
f6fb243392bd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"dgamma", " ", "=", " ", 
   RowBox[{
    FractionBox["sqb", "r"], " ", 
    RowBox[{"(", 
     RowBox[{"dh", " ", "+", "  ", 
      RowBox[{
       FractionBox["dk", "r0"], 
       RowBox[{"(", 
        RowBox[{"d", "-", " ", 
         RowBox[{"r0", " ", "g3"}]}], ")"}]}], "-", 
      RowBox[{"dx0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"k", " ", "d"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], 
          FractionBox["x0", 
           SuperscriptBox["r0", "3"]]}], "+", 
         RowBox[{"g2", " ", "v0"}]}], ")"}]}], "-", 
      RowBox[{"dv0", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", "  ", "v0"}], " ", "+", " ", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776198140701968*^9, 3.776198320251252*^9}, {
   3.776202145270097*^9, 3.776202149610155*^9}, {3.776215247114793*^9, 
   3.776215248410046*^9}, {3.7764526048178797`*^9, 3.776452608298151*^9}, {
   3.7766111002427273`*^9, 3.776611150430565*^9}, {3.776947448922698*^9, 
   3.7769475706666107`*^9}, 3.7769479213124027`*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"e5f914b2-2bf0-439b-99e7-b7d2a93687e8"],

Cell[BoxData[
 FractionBox[
  RowBox[{"sqb", " ", 
   RowBox[{"(", 
    RowBox[{"dh", "+", 
     FractionBox[
      RowBox[{"dk", " ", 
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
     RowBox[{"dv0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", " ", "v0"}], "+", 
        RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
     RowBox[{"dx0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g2", " ", "v0"}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "k"}], "+", 
            RowBox[{"g1", " ", 
             SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
         SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}]}], "r"]], "Output",
 CellChangeTimes->{3.776202160614881*^9, 3.776611155025895*^9, 
  3.776947577965641*^9, 3.776981074271501*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"666ae5c6-74f7-420b-9ac0-d403cfd3414a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Corrected", " ", "expression", " ", "for", " ", 
   RowBox[{"dr", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7769079972173853`*^9, 3.7769080070235157`*^9}, {
  3.776981087867612*^9, 
  3.77698109317844*^9}},ExpressionUUID->"2f6f7e0a-c2ad-49e5-8b90-\
c04b02c368c6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr", " ", "=", " ", 
  RowBox[{
   RowBox[{
    FractionBox["dgamma", "sqb"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"zeta", " ", "g1"}], "+", 
      RowBox[{"eta", " ", "g0"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["dk", 
     RowBox[{"beta", " ", "r0", " "}]], 
    RowBox[{"(", 
     RowBox[{"r0", "-", "r", "-", 
      RowBox[{"k", " ", "g2"}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["1", 
        RowBox[{"beta", " ", 
         SuperscriptBox["r0", "3"]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", 
          RowBox[{"(", 
           RowBox[{"r", "+", 
            RowBox[{"k", " ", "g2"}]}], ")"}]}], "-", 
         RowBox[{"zeta", " ", "r0", " ", "g0"}]}], ")"}], "x0"}], " ", "+", 
      " ", 
      RowBox[{"g1", "  ", "v0"}]}], ")"}]}], " ", "+", " ", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "k", " ", "g2"}]}], ")"}], " ", 
       FractionBox["v0", "beta"]}], " ", "+", " ", 
      RowBox[{"g1", " ", "x0"}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776198428651246*^9, 3.7761985237438927`*^9}, {
  3.776610948519197*^9, 3.7766109842635393`*^9}, {3.776980614943009*^9, 
  3.7769807709687023`*^9}, {3.77698979185677*^9, 3.77698979194238*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"ec64950c-8ed3-4bc5-92a5-293069313a0b"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], ")"}]}], 
   RowBox[{"beta", " ", "r0"}]], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], "beta"], 
     "+", 
     RowBox[{"g1", " ", "x0"}]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"dh", "+", 
      FractionBox[
       RowBox[{"dk", " ", 
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}]}], "r0"], "-", 
      RowBox[{"dv0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}]}], "-", 
      RowBox[{"dx0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "v0"}], "+", 
     FractionBox[
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776981096164591*^9, 3.776989800332011*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"3770f022-6acc-4f7f-a219-ed754408e3e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"dx0", ",", "dv0", ",", "dk", ",", "dh"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.776611166372304*^9, 3.776611177466592*^9}, {
   3.77661154142327*^9, 3.776611543580521*^9}, 3.776980791711628*^9},
 CellLabel->"In[17]:=",ExpressionUUID->"c4b0219d-ef0f-4a85-945c-de2fde90772c"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
      RowBox[{"beta", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], "beta"], 
     "+", 
     RowBox[{"g1", " ", "x0"}], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "v0"}], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
     FractionBox[
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.776981119875231*^9, 3.776989803198127*^9},
 CellLabel->"Out[17]=",ExpressionUUID->"29f840c4-488b-432b-9973-45ca2eb6707e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Collect", " ", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}], " ", "in", " ", "dx0", " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776980816800394*^9, 3.776980829345234*^9}},
 CellLabel->"In[33]:=",ExpressionUUID->"a0dc16c1-4e69-452c-8e92-3882ad81c7a0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g1", " ", "v0"}], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g2", " ", "v0"}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", "x0"}], 
          SuperscriptBox["r0", "3"]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
     FractionBox[
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
         RowBox[{"g0", " ", "r0", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.776980836089396*^9, 3.776980843776411*^9}, 
   3.776981130977736*^9, 3.7769898288843613`*^9},
 CellLabel->"In[18]:=",ExpressionUUID->"6fc80348-8701-42b8-941c-aba055c6950d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{"g1", "-", 
     FractionBox[
      RowBox[{"g2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], "+", 
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"d", " ", "k"}], "+", 
          RowBox[{"g1", " ", 
           SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{"r", " ", 
        SuperscriptBox["r0", "3"]}]]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"k", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
       RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
      RowBox[{"beta", " ", 
       SuperscriptBox["r0", "3"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7769808441174*^9, 3.776981132209041*^9, 
  3.776989829541298*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"e37154ef-e2e0-406d-862d-8ae2948c20c2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Collect", " ", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}], " ", "in", " ", "dv0", " ", 
   RowBox[{"term", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7769808469526777`*^9, 3.776980853520301*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"507dd5b7-ef16-44eb-8611-1dc7859ff397"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g1"}], "+", 
         RowBox[{"2", " ", "g2", " ", "k"}]}], ")"}], " ", "v0"}], "beta"], 
     "+", 
     RowBox[{"g1", " ", "x0"}], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "v0"}], "+", 
         RowBox[{"g2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", "v0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.776980860015231*^9, 3.776980864240988*^9}, 
   3.776981142031208*^9, 3.776989838235632*^9},
 CellLabel->"In[19]:=",ExpressionUUID->"1c537293-a305-4491-a817-7d634f355c31"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v0", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"2", " ", "g2", " ", "k"}]}], "beta"], "-", 
     FractionBox[
      RowBox[{"d", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], "+", 
  RowBox[{"x0", " ", 
   RowBox[{"(", 
    RowBox[{"g1", "-", 
     FractionBox[
      RowBox[{"g2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}]}]], "Output",\

 CellChangeTimes->{3.7769808645784397`*^9, 3.776981144321385*^9, 
  3.7769898389411583`*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"2609cb88-9c8e-498e-a159-839bc823a6f8"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"New", " ", 
    RowBox[{"expression", ":"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.7769808682304697`*^9, 3.776980878881391*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"1a4c8f3a-b75b-48ed-beb7-b2cf30e7c278"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr", " ", "=", " ", 
  RowBox[{
   FractionBox[
    RowBox[{"dh", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g0"}], "+", 
       RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
       RowBox[{"beta", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{"d", "-", 
          RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"eta", " ", "g0"}], "+", 
          RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
       RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"eta", " ", "g1"}], "+", 
           RowBox[{"2", " ", "g2", " ", "k"}]}], "beta"], "-", 
         FractionBox[
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{"g1", "-", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}]}], 
     ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{"g1", "-", 
         FractionBox[
          RowBox[{"g2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "k"}], "+", 
              RowBox[{"g1", " ", 
               SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"eta", " ", "g0"}], "+", 
              RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "3"]}]]}], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"k", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
           RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776980879667281*^9, 3.776980908613246*^9}, {
  3.776981154298074*^9, 3.7769811736567287`*^9}, {3.776989875644188*^9, 
  3.7769898928966627`*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"7265319b-5e94-4716-964b-84c370c87f44"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
      RowBox[{"beta", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"eta", " ", "g1"}], "+", 
          RowBox[{"2", " ", "g2", " ", "k"}]}], "beta"], "-", 
        FractionBox[
         RowBox[{"d", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{"g1", "-", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}]}], 
    ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{"g1", "-", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "3"]}]]}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.776980909776886*^9, {3.776981165493477*^9, 3.776981174287348*^9}, 
   3.776989894386208*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"ab49fdcb-57cc-4dfd-a1c2-131b436807eb"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Write", " ", "in", " ", "a", " ", "simpler", " ", 
   RowBox[{"form", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.776908224848393*^9, 
  3.7769082293276587`*^9}},ExpressionUUID->"465f61e6-4806-4c84-b46a-\
d0212f95aef1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"c1", " ", "=", " ", 
  RowBox[{"d", "-", 
   RowBox[{"r0", "*", "g3"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c2", " ", "=", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"eta", " ", "g0"}], "+", 
    RowBox[{"g1", " ", "zeta"}]}], ")"}]}]}], "Input",
 CellChangeTimes->{{3.776980964911682*^9, 3.776980965808964*^9}, {
  3.776981367272853*^9, 3.7769813770275927`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"35128fa6-b90d-44dc-8a05-73b192494862"],

Cell[BoxData[
 RowBox[{"d", "-", 
  RowBox[{"g3", " ", "r0"}]}]], "Output",
 CellChangeTimes->{3.7769813784722757`*^9, 3.7769899751924047`*^9, 
  3.77800961847906*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"7f0084e7-45c4-44b4-a9d3-64047bd33f7e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g0"}], "+", 
  RowBox[{"g1", " ", "zeta"}]}]], "Output",
 CellChangeTimes->{3.7769813784722757`*^9, 3.7769899751924047`*^9, 
  3.7780096184809313`*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"55dbcfdc-5b11-474a-8d88-781ad787b649"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"eta", " ", "g0"}], "+", 
  RowBox[{"g1", " ", "zeta"}]}], "\[IndentingNewLine]", 
 RowBox[{"c3", " ", "=", " ", 
  RowBox[{
   RowBox[{"d", "*", "k"}], "+", 
   RowBox[{"g1", "*", 
    RowBox[{"r0", "^", "2"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"c17", " ", "=", " ", 
  RowBox[{"r0", "-", "r", "-", 
   RowBox[{"g2", "*", "k"}]}]}], "\n", 
 RowBox[{"c18", "=", 
  RowBox[{
   RowBox[{"eta", "*", "g1"}], "+", 
   RowBox[{"2", "*", "g2", "*", "k"}]}]}], "\n"}], "Input",
 CellChangeTimes->{{3.776981269570302*^9, 3.776981289027836*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"2a714c0a-26b6-4af3-b4b4-84624d8dd831"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g0"}], "+", 
  RowBox[{"g1", " ", "zeta"}]}]], "Output",
 CellChangeTimes->{3.776981290526432*^9, 3.7769899779940357`*^9, 
  3.778009619923193*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"6e3e5910-2e21-4243-b36f-0b1ae27c673a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", " ", "k"}], "+", 
  RowBox[{"g1", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.776981290526432*^9, 3.7769899779940357`*^9, 
  3.7780096199249573`*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"47f3aa61-866f-45c2-9a0a-9ad6a7cce5f2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}]], "Output",
 CellChangeTimes->{3.776981290526432*^9, 3.7769899779940357`*^9, 
  3.7780096199268417`*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"dc203eb4-12f2-46d5-9d65-727805327026"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eta", " ", "g1"}], "+", 
  RowBox[{"2", " ", "g2", " ", "k"}]}]], "Output",
 CellChangeTimes->{3.776981290526432*^9, 3.7769899779940357`*^9, 
  3.778009619928537*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"32f2d053-5982-42c5-89a5-aa3afa450edb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c20", " ", "=", " ", 
  RowBox[{
   RowBox[{"k", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
   RowBox[{"g0", " ", "r0", " ", "zeta"}]}]}]], "Input",
 CellChangeTimes->{{3.7769899031242228`*^9, 3.776989904028264*^9}, {
  3.776990169610669*^9, 3.7769901807499933`*^9}},
 CellLabel->"In[39]:=",ExpressionUUID->"96b6ff65-6634-497a-8de9-0d0d83da9948"],

Cell[BoxData[
 RowBox[{
  RowBox[{"k", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
  RowBox[{"g0", " ", "r0", " ", "zeta"}]}]], "Output",
 CellChangeTimes->{3.776990181388533*^9},
 CellLabel->"Out[39]=",ExpressionUUID->"539de3a3-7523-4f52-80a4-1c3f656961a8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr2", " ", "=", " ", 
  RowBox[{
   FractionBox[
    RowBox[{"dh", " ", "c2"}], "r"], "+", 
   RowBox[{"dk", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["c17", 
       RowBox[{"beta", " ", "r0"}]], "+", 
      FractionBox[
       RowBox[{"c1", " ", "c2"}], 
       RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
   RowBox[{"dv0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["c18", "beta"], "-", 
         FractionBox[
          RowBox[{"d", " ", "c2"}], "r"]}], ")"}]}], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{"g1", "-", 
         FractionBox[
          RowBox[{"g2", " ", "c2"}], "r"]}], ")"}]}]}], ")"}]}], "+", 
   RowBox[{"dx0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"v0", " ", 
       RowBox[{"(", 
        RowBox[{"g1", "-", 
         FractionBox[
          RowBox[{"g2", " ", "c2"}], "r"]}], ")"}]}], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"c3", " ", "c2"}], 
           RowBox[{"r", " ", 
            SuperscriptBox["r0", "3"]}]]}], "+", 
         FractionBox["c20", 
          RowBox[{"beta", " ", 
           SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.776907987161613*^9, 3.776907987928801*^9}, {
  3.776908235538952*^9, 3.776908503236662*^9}, {3.776980914281434*^9, 
  3.7769809194852037`*^9}, {3.7769809507285852`*^9, 3.7769810098374653`*^9}, {
  3.776981178265608*^9, 3.77698126114564*^9}, {3.776981296876474*^9, 
  3.776981308404113*^9}, {3.77698147338277*^9, 3.776981475732955*^9}, {
  3.7769815205125027`*^9, 3.776981536007019*^9}, {3.776981596160056*^9, 
  3.7769815989917917`*^9}, {3.776981722832906*^9, 3.776981764944449*^9}, {
  3.7769900390816307`*^9, 3.77699003943073*^9}, {3.776990105714625*^9, 
  3.776990199340623*^9}},
 CellLabel->"In[40]:=",ExpressionUUID->"4ad8ae13-624c-4edc-add5-8945550baa52"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"dh", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"], "+", 
  RowBox[{"dk", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
      RowBox[{"beta", " ", "r0"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"d", "-", 
         RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"eta", " ", "g0"}], "+", 
         RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
      RowBox[{"r", " ", "r0"}]]}], ")"}]}], "+", 
  RowBox[{"dv0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"eta", " ", "g1"}], "+", 
          RowBox[{"2", " ", "g2", " ", "k"}]}], "beta"], "-", 
        FractionBox[
         RowBox[{"d", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{"g1", "-", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}]}], 
    ")"}]}], "+", 
  RowBox[{"dx0", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"v0", " ", 
      RowBox[{"(", 
       RowBox[{"g1", "-", 
        FractionBox[
         RowBox[{"g2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"eta", " ", "g0"}], "+", 
            RowBox[{"g1", " ", "zeta"}]}], ")"}]}], "r"]}], ")"}]}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "k"}], "+", 
             RowBox[{"g1", " ", 
              SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"r", " ", 
           SuperscriptBox["r0", "3"]}]]}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g2", " ", "k"}], "+", "r"}], ")"}]}], "-", 
          RowBox[{"g0", " ", "r0", " ", "zeta"}]}], 
         RowBox[{"beta", " ", 
          SuperscriptBox["r0", "3"]}]]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.776981185730463*^9, 3.776981309448174*^9, {3.7769899682586613`*^9, 
   3.7769899806078997`*^9}, 3.776990041456863*^9, 3.776990200173183*^9},
 CellLabel->"Out[40]=",ExpressionUUID->"71e24d8e-6fd7-41ca-adee-032d8e0030ad"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dr", " ", "-", " ", "dr2"}]], "Input",
 CellChangeTimes->{{3.776989908029278*^9, 3.776989910966408*^9}},
 CellLabel->"In[41]:=",ExpressionUUID->"bed2008b-362d-4933-ad8c-fe8df2f4d579"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.776989931524377*^9, 3.776989982840201*^9, 
  3.7769900433504953`*^9, 3.776990202317072*^9},
 CellLabel->"Out[41]=",ExpressionUUID->"9317a971-879f-42ab-94f3-7cc1d1a9fd97"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"See", " ", "if", " ", "I", " ", 
    RowBox[{"can", "'"}], "t", " ", "simplify", " ", "dk", " ", 
    RowBox[{"term", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                RowBox[{
                 RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
               RowBox[{"beta", " ", "r0"}]], "+", 
              FractionBox[
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"d", "-", 
                  RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"eta", " ", "g0"}], "+", 
                  RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
               RowBox[{"r", " ", "r0"}]]}], ")"}], " ", "/.", " ", 
            RowBox[{"zeta", " ", "\[Rule]", " ", 
             RowBox[{"k", " ", "-", " ", 
              RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
           RowBox[{"d", " ", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"h", "+", 
               RowBox[{"eta", "*", "g2"}], "+", 
               RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}],
           " ", "/.", " ", 
          RowBox[{"h", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
            RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
            RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
         RowBox[{"r", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
           RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
        RowBox[{"g0", " ", "\[Rule]", " ", 
         RowBox[{"Cos", "[", "gamma", "]"}]}]}], " ", "/.", " ", 
       RowBox[{"g1", " ", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "gamma", "]"}], "/", 
         RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
      RowBox[{"g2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g3", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gamma", "-", 
          RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
       RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7776849137589273`*^9, 3.777684921190878*^9}, {
  3.778009503086513*^9, 3.7780095400601597`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"e51d915d-5efd-4b6c-866e-d405aaaeb9bb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "2"], 
     RowBox[{"2", " ", "beta"}]]}], "-", 
   FractionBox[
    RowBox[{"eta", " ", 
     SuperscriptBox["gamma", "3"]}], 
    RowBox[{"6", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"3", "/", "2"}]], " ", "r0"}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        SuperscriptBox["eta", "2"]}], "+", 
       RowBox[{"2", " ", "k", " ", "r0"}], "-", 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"24", " ", 
     SuperscriptBox["beta", "2"], " ", 
     SuperscriptBox["r0", "2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"10", " ", 
        SuperscriptBox["eta", "3"]}], "-", 
       RowBox[{"18", " ", "eta", " ", "k", " ", "r0"}], "+", 
       RowBox[{"11", " ", "beta", " ", "eta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"120", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "60"}], " ", 
        SuperscriptBox["eta", "4"]}], "+", 
       RowBox[{"138", " ", 
        SuperscriptBox["eta", "2"], " ", "k", " ", "r0"}], "-", 
       RowBox[{"86", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"48", " ", 
        SuperscriptBox["k", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{"74", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "-", 
       RowBox[{"27", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "4"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"720", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "4"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 2, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 2]/$CellContext`beta, 
    Rational[-1, 6] $CellContext`beta^
     Rational[-3, 2] $CellContext`eta/$CellContext`r0, 
    Rational[1, 
      24] $CellContext`beta^(-2) $CellContext`r0^(-2) ((-2) \
$CellContext`eta^2 + 
     2 $CellContext`k $CellContext`r0 - $CellContext`beta $CellContext`r0^2), 
    Rational[1, 120] $CellContext`beta^Rational[-5, 2] $CellContext`r0^(-3) (
     10 $CellContext`eta^3 - 
     18 $CellContext`eta $CellContext`k $CellContext`r0 + 
     11 $CellContext`beta $CellContext`eta $CellContext`r0^2), 
    Rational[1, 
      720] $CellContext`beta^(-3) $CellContext`r0^(-4) ((-60) \
$CellContext`eta^4 + 138 $CellContext`eta^2 $CellContext`k $CellContext`r0 - 
     86 $CellContext`beta $CellContext`eta^2 $CellContext`r0^2 - 
     48 $CellContext`k^2 $CellContext`r0^2 + 
     74 $CellContext`beta $CellContext`k $CellContext`r0^3 - 
     27 $CellContext`beta^2 $CellContext`r0^4)}, 2, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.778009540353994*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"16ef7ff4-b10c-46d0-a144-c1dcce0c9795"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
        RowBox[{"beta", " ", "r0"}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{"d", "-", 
           RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"eta", " ", "g0"}], "+", 
           RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
        RowBox[{"r", " ", "r0"}]]}], ")"}], " ", "/.", " ", 
     RowBox[{"zeta", " ", "\[Rule]", " ", 
      RowBox[{"k", " ", "-", " ", 
       RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
    RowBox[{"d", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"h", "+", 
        RowBox[{"eta", "*", "g2"}], "+", 
        RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
    " ", 
   RowBox[{"h", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
     RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
  RowBox[{"r", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
    RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
    RowBox[{"k", " ", "g2"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777684929887364*^9, 3.777684972831088*^9}},
 CellLabel->
  "In[115]:=",ExpressionUUID->"dde0987e-5893-4b60-9997-a7036c644bc5"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "eta"}], " ", "g1"}], "-", 
    RowBox[{"2", " ", "g2", " ", "k"}], "+", "r0", "-", 
    RowBox[{"g0", " ", "r0"}]}], 
   RowBox[{"beta", " ", "r0"}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", 
       RowBox[{"(", 
        RowBox[{"k", "-", 
         RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g3"}], " ", "r0"}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
        RowBox[{"3", " ", "g3", " ", "k"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}], 
   RowBox[{"r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{3.777684973721045*^9},
 CellLabel->
  "Out[115]=",ExpressionUUID->"4e528249-bf3f-46a1-bbbe-4fd2ea190eb6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "eta"}], " ", "g1"}], "-", 
      RowBox[{"2", " ", "g2", " ", "k"}], "+", "r0", "-", 
      RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}], 
   RowBox[{"beta", " ", "r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"beta", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", 
       RowBox[{"(", 
        RowBox[{"k", "-", 
         RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g3"}], " ", "r0"}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
        RowBox[{"3", " ", "g3", " ", "k"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}], 
   RowBox[{"beta", " ", "r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}]], "Input",
 CellChangeTimes->{{3.777684985675267*^9, 3.777685014643011*^9}},
 CellLabel->
  "In[116]:=",ExpressionUUID->"b1361dc9-8acf-43f2-b35f-015781a7e929"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "eta"}], " ", "g1"}], "-", 
    RowBox[{"2", " ", "g2", " ", "k"}], "+", "r0", "-", 
    RowBox[{"g0", " ", "r0"}]}], 
   RowBox[{"beta", " ", "r0"}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", 
       RowBox[{"(", 
        RowBox[{"k", "-", 
         RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g3"}], " ", "r0"}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
        RowBox[{"3", " ", "g3", " ", "k"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}], 
   RowBox[{"r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{3.777685017983901*^9},
 CellLabel->
  "Out[116]=",ExpressionUUID->"9c3ba387-d018-4421-83ae-b19f6ed1d6dc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Together", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "eta"}], " ", "g1"}], "-", 
       RowBox[{"2", " ", "g2", " ", "k"}], "+", "r0", "-", 
       RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}], 
    RowBox[{"beta", " ", "r0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{" ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", "g0"}], "+", 
        RowBox[{"g1", " ", 
         RowBox[{"(", 
          RowBox[{"k", "-", 
           RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "g3"}], " ", "beta", " ", "r0"}], "+", 
        RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
        RowBox[{"3", " ", "g3", " ", "k"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], 
    RowBox[{"beta", " ", "r0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}], "]"}]], "Input",
 CellChangeTimes->{{3.77768503912249*^9, 3.777685052547681*^9}},
 CellLabel->
  "In[117]:=",ExpressionUUID->"a28ebeb5-b47c-4aa0-80fb-c2be45adfd29"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"beta", " ", "r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["eta", "2"]}], " ", 
     SuperscriptBox["g1", "2"]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["eta", "2"], " ", "g0", " ", "g2"}], "-", 
    RowBox[{"eta", " ", "g1", " ", "g2", " ", "k"}], "+", 
    RowBox[{"3", " ", "eta", " ", "g0", " ", "g3", " ", "k"}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["g2", "2"], " ", 
     SuperscriptBox["k", "2"]}], "+", 
    RowBox[{"3", " ", "g1", " ", "g3", " ", 
     SuperscriptBox["k", "2"]}], "+", 
    RowBox[{"eta", " ", "g1", " ", "r0"}], "-", 
    RowBox[{"eta", " ", "g0", " ", "g1", " ", "r0"}], "-", 
    RowBox[{"2", " ", "beta", " ", "eta", " ", "g1", " ", "g2", " ", "r0"}], 
    "-", 
    RowBox[{"beta", " ", "eta", " ", "g0", " ", "g3", " ", "r0"}], "+", 
    RowBox[{
     SuperscriptBox["g1", "2"], " ", "k", " ", "r0"}], "+", 
    RowBox[{"g2", " ", "k", " ", "r0"}], "-", 
    RowBox[{"3", " ", "g0", " ", "g2", " ", "k", " ", "r0"}], "-", 
    RowBox[{"4", " ", "beta", " ", "g1", " ", "g3", " ", "k", " ", "r0"}], 
    "+", 
    RowBox[{"g0", " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{
     SuperscriptBox["g0", "2"], " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{"beta", " ", 
     SuperscriptBox["g1", "2"], " ", 
     SuperscriptBox["r0", "2"]}], "+", 
    RowBox[{
     SuperscriptBox["beta", "2"], " ", "g1", " ", "g3", " ", 
     SuperscriptBox["r0", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7776850529956017`*^9},
 CellLabel->
  "Out[117]=",ExpressionUUID->"ef0abb71-0d48-414d-8388-66e53c41a364"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777685055193334*^9, 3.777685056505374*^9}},
 CellLabel->
  "In[118]:=",ExpressionUUID->"403558c3-5405-4c45-b37b-15d6b3d05060"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"beta", " ", "r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["eta", "2"]}], " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["g1", "2"], "-", 
       RowBox[{"2", " ", "g0", " ", "g2"}]}], ")"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["g2", "2"], " ", 
     SuperscriptBox["k", "2"]}], "+", 
    RowBox[{"3", " ", "g1", " ", "g3", " ", 
     SuperscriptBox["k", "2"]}], "+", 
    RowBox[{
     SuperscriptBox["g1", "2"], " ", "k", " ", "r0"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"3", " ", "g0"}]}], ")"}], " ", "g2", " ", "k", " ", "r0"}], 
    "-", 
    RowBox[{"4", " ", "beta", " ", "g1", " ", "g3", " ", "k", " ", "r0"}], 
    "+", 
    RowBox[{"g0", " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{
     SuperscriptBox["g0", "2"], " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{"beta", " ", 
     SuperscriptBox["g1", "2"], " ", 
     SuperscriptBox["r0", "2"]}], "+", 
    RowBox[{
     SuperscriptBox["beta", "2"], " ", "g1", " ", "g3", " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{"eta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "g0"}], ")"}], " ", "g1", " ", "r0"}], "+", 
       RowBox[{"g0", " ", "g3", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "3"}], " ", "k"}], "+", 
          RowBox[{"beta", " ", "r0"}]}], ")"}]}], "+", 
       RowBox[{"g1", " ", "g2", " ", 
        RowBox[{"(", 
         RowBox[{"k", "+", 
          RowBox[{"2", " ", "beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.777685056826105*^9},
 CellLabel->
  "Out[118]=",ExpressionUUID->"cd185f65-d9b0-47fb-ac0c-7a843a95e4b4"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.777685059337322*^9, 
  3.777685061424241*^9}},ExpressionUUID->"49a95502-6a91-44b2-b215-\
7fef75f3a2f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["eta", "2"]}], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["g1", "2"], "-", 
         RowBox[{"2", " ", "g0", " ", "g2"}]}], ")"}]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["g2", "2"], " ", 
       SuperscriptBox["k", "2"]}], "+", 
      RowBox[{"3", " ", "g1", " ", "g3", " ", 
       SuperscriptBox["k", "2"]}], "+", 
      RowBox[{
       SuperscriptBox["g1", "2"], " ", "k", " ", "r0"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"3", " ", "g0"}]}], ")"}], " ", "g2", " ", "k", " ", "r0"}], 
      "-", 
      RowBox[{"4", " ", "beta", " ", "g1", " ", "g3", " ", "k", " ", "r0"}], 
      "+", 
      RowBox[{"g0", " ", 
       SuperscriptBox["r0", "2"]}], "-", 
      RowBox[{
       SuperscriptBox["g0", "2"], " ", 
       SuperscriptBox["r0", "2"]}], "-", 
      RowBox[{"beta", " ", 
       SuperscriptBox["g1", "2"], " ", 
       SuperscriptBox["r0", "2"]}], "+", 
      RowBox[{
       SuperscriptBox["beta", "2"], " ", "g1", " ", "g3", " ", 
       SuperscriptBox["r0", "2"]}], "-", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "g0"}], ")"}], " ", "g1", " ", "r0"}], 
         "+", 
         RowBox[{"g0", " ", "g3", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "3"}], " ", "k"}], "+", 
            RowBox[{"beta", " ", "r0"}]}], ")"}]}], "+", 
         RowBox[{"g1", " ", "g2", " ", 
          RowBox[{"(", 
           RowBox[{"k", "+", 
            RowBox[{"2", " ", "beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}], 
     ")"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"eta", "^", "2"}], ",", " ", 
      RowBox[{"k", "^", "2"}], ",", " ", "k", ",", " ", 
      RowBox[{"k", " ", "r0"}], ",", " ", 
      RowBox[{"r0", "^", "2"}], ",", " ", "eta"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.777685065074316*^9, 3.777685083720541*^9}, 
   3.77800912979519*^9},ExpressionUUID->"a911f544-7ddd-4477-b32b-\
003214c3974d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", " ", "beta"}], " ", 
    SuperscriptBox["eta", "2"], " ", 
    SuperscriptBox["g2", "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", "g1", " ", "g3"}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["g2", "2"]}]}], ")"}], " ", 
    SuperscriptBox["k", "2"]}], "+", 
   RowBox[{"2", " ", "beta", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["g2", "2"], "-", 
      RowBox[{"2", " ", "g1", " ", "g3"}]}], ")"}], " ", "k", " ", "r0"}], 
   "+", 
   RowBox[{"beta", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "g2"}], "+", 
      RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
    SuperscriptBox["r0", "2"]}], "+", 
   RowBox[{"eta", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", "g0", " ", "g3"}], "-", 
         RowBox[{"g1", " ", "g2"}]}], ")"}], " ", "k"}], "-", 
      RowBox[{"beta", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g1", " ", "g2"}], "+", 
         RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}]}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Further", " ", "simplification", " ", "of", " ", "this", " ", 
    RowBox[{"formula", ":"}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"-", " ", "beta"}], " ", 
   SuperscriptBox["eta", "2"], " ", 
   SuperscriptBox["g2", "2"]}], "-", 
  RowBox[{"h6", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"2", " ", "beta", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["g2", "2"], "-", 
     RowBox[{"2", " ", "g1", " ", "g3"}]}], ")"}], " ", "k", " ", "r0"}], "+", 
  RowBox[{"beta", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "g2"}], "+", 
     RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "g0", " ", "g3"}], "-", "h2"}], ")"}], " ", "eta", " ",
    "k"}], "-", 
  RowBox[{"beta", 
   RowBox[{"(", 
    RowBox[{"h2", "+", 
     RowBox[{"2", "g0", " ", "g3"}]}], ")"}], " ", "eta", " ", 
   "r0"}]}]}], "Input",
 CellChangeTimes->{{3.777685115891197*^9, 3.777685169561141*^9}, {
  3.777685209739406*^9, 3.777685284024404*^9}, {3.777685336422902*^9, 
  3.7776854110042458`*^9}, {3.7776854807012043`*^9, 3.777685506546547*^9}, {
  3.778009131093635*^9, 3.7780091667601643`*^9}, {3.778009264621517*^9, 
  3.778009270502434*^9}, {3.778009328079262*^9, 
  3.7780093474702168`*^9}},ExpressionUUID->"9bf17d1b-9add-4996-b705-\
efe7c4b6bee7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "beta"}], " ", 
   SuperscriptBox["eta", "2"], " ", 
   SuperscriptBox["g2", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      SuperscriptBox["g2", "2"]}], "+", 
     RowBox[{"3", " ", "g1", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"2", " ", "beta", " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["g2", "2"], "-", 
     RowBox[{"2", " ", "g1", " ", "g3"}]}], ")"}], " ", "k", " ", "r0"}], "+", 
  RowBox[{"beta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "g2"}], "+", 
     RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
   SuperscriptBox["r0", "2"]}], "+", 
  RowBox[{"eta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "g1"}], " ", "g2"}], "+", 
        RowBox[{"3", " ", "g0", " ", "g3"}]}], ")"}], " ", "k"}], "-", 
     RowBox[{"beta", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g1", " ", "g2"}], "+", 
        RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.778009145253677*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"b4fcf4e9-8a23-48a6-9818-3bf890de6ab0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", " ", "beta"}], " ", 
       SuperscriptBox["eta", "2"], " ", 
       SuperscriptBox["g2", "2"]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", "g1", " ", "g3"}], "-", 
         RowBox[{"2", " ", 
          SuperscriptBox["g2", "2"]}]}], ")"}], " ", 
       SuperscriptBox["k", "2"]}], "+", 
      RowBox[{"2", " ", "beta", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["g2", "2"], "-", 
         RowBox[{"2", " ", "g1", " ", "g3"}]}], ")"}], " ", "k", " ", "r0"}], 
      "+", 
      RowBox[{"beta", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "g2"}], "+", 
         RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
       SuperscriptBox["r0", "2"]}], "+", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"3", " ", "g0", " ", "g3"}], "-", 
            RowBox[{"g1", " ", "g2"}]}], ")"}], " ", "k"}], "-", 
         RowBox[{"beta", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"g1", " ", "g2"}], "+", 
            RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "r0"}]}], ")"}]}]}], " ",
      "/.", " ", 
     RowBox[{"g0", " ", "\[Rule]", " ", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}]}]}], " ", "/.", " ", 
    RowBox[{"g1", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"Sin", "[", "gamma", "]"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
   RowBox[{"g2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", "/.",
   " ", 
  RowBox[{"g3", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gamma", "-", 
       RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", 
     RowBox[{"Sqrt", "[", "beta", "]"}]}], "/", "beta"}]}]}]], "Input",
 CellChangeTimes->{{3.777685519075734*^9, 3.777685591854784*^9}},
 CellLabel->
  "In[120]:=",ExpressionUUID->"40bcf25e-315c-48ed-883e-b0c699cec7df"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"Out", "[", "120", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777685751774185*^9, 3.777685755148509*^9}, {
  3.7776858105887213`*^9, 3.7776858177774687`*^9}},
 CellLabel->
  "In[125]:=",ExpressionUUID->"7972035a-9f7e-466b-917f-88e2a6275e9b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      SuperscriptBox["r0", "2"], " ", 
      SuperscriptBox["gamma", "2"]}], "2"]}], "-", 
   FractionBox[
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"eta", " ", "r0"}], ")"}], " ", 
     SuperscriptBox["gamma", "3"]}], 
    RowBox[{"3", " ", 
     SqrtBox["beta"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "6"}], " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"4", " ", "k", " ", "r0"}], "+", 
       RowBox[{"5", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"24", " ", "beta"}]], "+", 
   FractionBox[
    RowBox[{"eta", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "9"}], " ", "k"}], "+", 
       RowBox[{"13", " ", "beta", " ", "r0"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"60", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"30", " ", "beta", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"18", " ", 
        SuperscriptBox["k", "2"]}], "+", 
       RowBox[{"44", " ", "beta", " ", "k", " ", "r0"}], "-", 
       RowBox[{"27", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"720", " ", 
     SuperscriptBox["beta", "2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 2, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
   Rational[-1, 2] $CellContext`r0^2, 
    Rational[-2, 3] $CellContext`beta^
     Rational[-1, 2] $CellContext`eta $CellContext`r0, 
    Rational[1, 24] $CellContext`beta^(-1) ((-6) $CellContext`eta^2 - 
     4 $CellContext`k $CellContext`r0 + 
     5 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 60] $CellContext`beta^
     Rational[-3, 2] $CellContext`eta ((-9) $CellContext`k + 
     13 $CellContext`beta $CellContext`r0), 
    Rational[1, 720] $CellContext`beta^(-2) (
     30 $CellContext`beta $CellContext`eta^2 - 18 $CellContext`k^2 + 
     44 $CellContext`beta $CellContext`k $CellContext`r0 - 
     27 $CellContext`beta^2 $CellContext`r0^2)}, 2, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.777685755563775*^9, {3.777685811214389*^9, 3.777685818174213*^9}},
 CellLabel->
  "Out[125]=",ExpressionUUID->"4b24ffd2-1590-4db1-8c32-3edb387a1530"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"2", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "2"]}], 
    SuperscriptBox["beta", "2"]]}], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"(", 
     RowBox[{"gamma", "-", 
      RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sin", "[", "gamma", "]"}]}], 
   SuperscriptBox["beta", "2"]]}]], "Input",
 CellLabel->
  "In[126]:=",ExpressionUUID->"d866cb59-f099-488e-86d0-5acb2e2b2fa1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"2", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "2"]}], 
    SuperscriptBox["beta", "2"]]}], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"(", 
     RowBox[{"gamma", "-", 
      RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], " ", 
    RowBox[{"Sin", "[", "gamma", "]"}]}], 
   SuperscriptBox["beta", "2"]]}]], "Output",
 CellChangeTimes->{3.777685908669372*^9},
 CellLabel->
  "Out[126]=",ExpressionUUID->"e3351912-0137-4406-928b-390394f85273"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TrigReduce", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777685909245676*^9, 3.777685911525016*^9}},
 CellLabel->
  "In[127]:=",ExpressionUUID->"a4ac245f-8857-4caf-bc9c-593d3b13aac2"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "9"}], "+", 
   RowBox[{"8", " ", 
    RowBox[{"Cos", "[", "gamma", "]"}]}], "+", 
   RowBox[{"Cos", "[", 
    RowBox[{"2", " ", "gamma"}], "]"}], "+", 
   RowBox[{"6", " ", "gamma", " ", 
    RowBox[{"Sin", "[", "gamma", "]"}]}]}], 
  RowBox[{"2", " ", 
   SuperscriptBox["beta", "2"]}]]], "Output",
 CellChangeTimes->{3.77768591185262*^9},
 CellLabel->
  "Out[127]=",ExpressionUUID->"eb4c6435-951d-40c8-b045-1cff71cce1ba"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"Out", "[", "127", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777685923485613*^9, 3.777685936301553*^9}},
 CellLabel->
  "In[129]:=",ExpressionUUID->"3c5dd138-7285-4d13-9878-70b7b5cfde4d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["gamma", "6"], 
     RowBox[{"40", " ", 
      SuperscriptBox["beta", "2"]}]]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 6, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {Rational[-1, 40] $CellContext`beta^(-2)},
    6, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.777685928625319*^9, 3.777685936639697*^9}},
 CellLabel->
  "Out[129]=",ExpressionUUID->"a400562a-4a86-4955-bef3-ad1f6d719d37"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", " ", "beta"}], " ", 
     SuperscriptBox["eta", "2"], " ", 
     SuperscriptBox["g2", "2"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", "g1", " ", "g3"}], "-", 
       RowBox[{"2", " ", 
        SuperscriptBox["g2", "2"]}]}], ")"}], " ", 
     SuperscriptBox["k", "2"]}], "+", 
    RowBox[{"2", " ", "beta", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["g2", "2"], "-", 
       RowBox[{"2", " ", "g1", " ", "g3"}]}], ")"}], " ", "k", " ", "r0"}], 
    "+", 
    RowBox[{"beta", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "g2"}], "+", 
       RowBox[{"beta", " ", "g1", " ", "g3"}]}], ")"}], " ", 
     SuperscriptBox["r0", "2"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", "g0", " ", "g3"}], "-", 
       RowBox[{"g1", " ", "g2"}]}], ")"}], " ", "eta", " ", "k"}], "-", 
    RowBox[{"beta", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"g1", " ", "g2"}], "+", 
       RowBox[{"g0", " ", "g3"}]}], ")"}], " ", "eta", " ", "r0"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"g1", " ", "g3"}], ",", " ", 
     SuperscriptBox["g2", "2"], ",", " ", 
     RowBox[{"g0", " ", "g3"}], ",", " ", 
     RowBox[{"g1", " ", "g2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777686117875078*^9, 3.777686157720667*^9}},
 CellLabel->
  "In[130]:=",ExpressionUUID->"4ee06fd5-1098-4c0c-937b-45dd7dbcd037"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "beta"}], " ", "g2", " ", 
   SuperscriptBox["r0", "2"]}], "+", 
  RowBox[{"g1", " ", "g2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "eta"}], " ", "k"}], "-", 
     RowBox[{"beta", " ", "eta", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{"g0", " ", "g3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", "eta", " ", "k"}], "-", 
     RowBox[{"beta", " ", "eta", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g2", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "beta"}], " ", 
      SuperscriptBox["eta", "2"]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["k", "2"]}], "+", 
     RowBox[{"2", " ", "beta", " ", "k", " ", "r0"}]}], ")"}]}], "+", 
  RowBox[{"g1", " ", "g3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", 
      SuperscriptBox["k", "2"]}], "-", 
     RowBox[{"4", " ", "beta", " ", "k", " ", "r0"}], "+", 
     RowBox[{
      SuperscriptBox["beta", "2"], " ", 
      SuperscriptBox["r0", "2"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.777686158062347*^9},
 CellLabel->
  "Out[130]=",ExpressionUUID->"51f7997d-097a-4c96-a79f-ff3af9fbf8fc"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "beta"}], " ", "g2", " ", 
   SuperscriptBox["r0", "2"]}], "-", 
  RowBox[{"eta", " ", "g1", " ", "g2", " ", 
   RowBox[{"(", " ", 
    RowBox[{"k", "+", 
     RowBox[{"beta", "  ", "r0"}]}], ")"}]}], "+", 
  RowBox[{"eta", " ", "g0", " ", "g3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "k"}], "+", "zeta"}], ")"}]}], "-", 
  RowBox[{
   SuperscriptBox["g2", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"beta", " ", 
      SuperscriptBox["eta", "2"]}], "+", 
     RowBox[{"2", " ", "k", " ", "zeta"}]}], ")"}]}], "+", 
  RowBox[{"g1", " ", "g3", " ", "zeta", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", "k"}], "-", 
     RowBox[{"beta", " ", "r0"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.777686182309923*^9, 3.777686204845096*^9}, {
  3.777686298907946*^9, 
  3.777686382763752*^9}},ExpressionUUID->"4b6aa8b7-2cef-4f3d-b0d9-\
a9fc057fba50"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "g2"}], " ", "k"}], "-", "r", "+", "r0"}], 
          RowBox[{"beta", " ", "r0"}]], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{"d", "-", 
             RowBox[{"g3", " ", "r0"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"eta", " ", "g0"}], "+", 
             RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
          RowBox[{"r", " ", "r0"}]]}], ")"}], " ", "-", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "beta"}], " ", "g2", " ", 
           SuperscriptBox["r0", "2"]}], "-", 
          RowBox[{"eta", " ", "g1", " ", "g2", " ", 
           RowBox[{"(", " ", 
            RowBox[{"k", "+", 
             RowBox[{"beta", "  ", "r0"}]}], ")"}]}], "+", 
          RowBox[{"eta", " ", "g0", " ", "g3", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "k"}], "+", "zeta"}], ")"}]}], "-", 
          RowBox[{
           SuperscriptBox["g2", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"beta", " ", 
              SuperscriptBox["eta", "2"]}], "+", 
             RowBox[{"2", " ", "k", " ", "zeta"}]}], ")"}]}], "+", 
          RowBox[{"g1", " ", "g3", " ", "zeta", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"3", " ", "k"}], "-", 
             RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"beta", " ", "r", " ", "r0"}], ")"}]}]}], " ", "/.", " ", 
      RowBox[{"zeta", " ", "\[Rule]", " ", 
       RowBox[{"k", " ", "-", " ", 
        RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
     RowBox[{"d", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"eta", "*", "g2"}], "+", 
         RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"h", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
      RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
      RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
   RowBox[{"r", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
     RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
     RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
  RowBox[{"g0", " ", "\[Rule]", " ", 
   RowBox[{"1", "-", 
    RowBox[{"beta", " ", "g2"}]}]}]}]], "Input",
 CellChangeTimes->{{3.777686404299817*^9, 3.777686472045621*^9}},
 CellLabel->
  "In[137]:=",ExpressionUUID->"90d4b59e-fb75-419d-993a-e3fe90469951"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "eta"}], " ", "g1"}], "-", 
    RowBox[{"2", " ", "g2", " ", "k"}], "+", "r0", "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "r0"}]}], 
   RowBox[{"beta", " ", "r0"}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}], ")"}]}], "+", 
      RowBox[{"g1", " ", 
       RowBox[{"(", 
        RowBox[{"k", "-", 
         RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g3"}], " ", "r0"}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
        RowBox[{"3", " ", "g3", " ", "k"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], "beta"]}], ")"}]}], 
   RowBox[{"r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "r0"}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "beta"}], " ", "g2", " ", 
     SuperscriptBox["r0", "2"]}], "+", 
    RowBox[{"eta", " ", 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "g3", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", "k"}], "-", 
       RowBox[{"beta", " ", "r0"}]}], ")"}]}], "+", 
    RowBox[{"g1", " ", "g3", " ", 
     RowBox[{"(", 
      RowBox[{"k", "-", 
       RowBox[{"beta", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", "k"}], "-", 
       RowBox[{"beta", " ", "r0"}]}], ")"}]}], "-", 
    RowBox[{"eta", " ", "g1", " ", "g2", " ", 
     RowBox[{"(", 
      RowBox[{"k", "+", 
       RowBox[{"beta", " ", "r0"}]}], ")"}]}], "-", 
    RowBox[{
     SuperscriptBox["g2", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"beta", " ", 
        SuperscriptBox["eta", "2"]}], "+", 
       RowBox[{"2", " ", "k", " ", 
        RowBox[{"(", 
         RowBox[{"k", "-", 
          RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]}], 
   RowBox[{"beta", " ", "r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"beta", " ", "g2"}]}], ")"}], " ", "r0"}]}], 
     ")"}]}]]}]], "Output",
 CellChangeTimes->{
  3.777686418654869*^9, {3.777686452196862*^9, 3.77768647240173*^9}},
 CellLabel->
  "Out[137]=",ExpressionUUID->"1a695dc6-59cc-48a0-a39a-73a783fec76d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777686420124097*^9, 3.7776864224510803`*^9}},
 CellLabel->
  "In[138]:=",ExpressionUUID->"8f0ceb9d-8f46-4eb8-834f-30d2587c354a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{"(", "0", ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["eta", "2"], "+", 
      RowBox[{"r0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "k"}], "+", 
         RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}], 
   RowBox[{"beta", " ", "r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", "r0", "+", 
      RowBox[{"g2", " ", 
       RowBox[{"(", 
        RowBox[{"k", "-", 
         RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}]}]]}]], "Input",
 CellChangeTimes->{{3.777686491029738*^9, 3.7776865515877113`*^9}},
 CellLabel->
  "In[139]:=",ExpressionUUID->"d0217afd-068b-4b89-9ddf-7055cec71f74"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.77768655204382*^9},
 CellLabel->
  "Out[139]=",ExpressionUUID->"677d4a4b-93d6-4674-aecf-cc935406d9be"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "eta"}], " ", "g1"}], "-", 
     RowBox[{"2", " ", "g2", " ", "k"}], "+", "r0", "-", 
     RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g1"}], "+", 
     RowBox[{"g2", " ", "k"}], "+", 
     RowBox[{"g0", " ", "r0"}]}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777687391037816*^9, 3.777687396491106*^9}},
 CellLabel->
  "In[154]:=",ExpressionUUID->"e18a2432-fcf2-49b0-b974-ecee93b85e1e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    SuperscriptBox["eta", "2"]}], " ", 
   SuperscriptBox["g1", "2"]}], "-", 
  RowBox[{"3", " ", "eta", " ", "g1", " ", "g2", " ", "k"}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["g2", "2"], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"eta", " ", "g1", " ", "r0"}], "-", 
  RowBox[{"2", " ", "eta", " ", "g0", " ", "g1", " ", "r0"}], "+", 
  RowBox[{"g2", " ", "k", " ", "r0"}], "-", 
  RowBox[{"3", " ", "g0", " ", "g2", " ", "k", " ", "r0"}], "+", 
  RowBox[{"g0", " ", 
   SuperscriptBox["r0", "2"]}], "-", 
  RowBox[{
   SuperscriptBox["g0", "2"], " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{{3.777687387693191*^9, 3.777687396877709*^9}},
 CellLabel->
  "Out[154]=",ExpressionUUID->"9f69bb1c-f456-43cf-a972-21216b0066a5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"eta", " ", "g0"}], "+", 
     RowBox[{"g1", " ", 
      RowBox[{"(", 
       RowBox[{"k", "-", 
        RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g3"}], " ", "beta", " ", "r0"}], "+", 
     RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
     RowBox[{"3", " ", "g3", " ", "k"}], "+", 
     RowBox[{"g1", " ", "r0"}]}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.777687408652051*^9, 3.777687411594843*^9}},
 CellLabel->
  "In[155]:=",ExpressionUUID->"322441a2-d507-4584-b10f-e7387c945d7d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   SuperscriptBox["eta", "2"], " ", "g0", " ", "g2"}], "+", 
  RowBox[{"2", " ", "eta", " ", "g1", " ", "g2", " ", "k"}], "+", 
  RowBox[{"3", " ", "eta", " ", "g0", " ", "g3", " ", "k"}], "+", 
  RowBox[{"3", " ", "g1", " ", "g3", " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{"eta", " ", "g0", " ", "g1", " ", "r0"}], "-", 
  RowBox[{"2", " ", "beta", " ", "eta", " ", "g1", " ", "g2", " ", "r0"}], 
  "-", 
  RowBox[{"beta", " ", "eta", " ", "g0", " ", "g3", " ", "r0"}], "+", 
  RowBox[{
   SuperscriptBox["g1", "2"], " ", "k", " ", "r0"}], "-", 
  RowBox[{"4", " ", "beta", " ", "g1", " ", "g3", " ", "k", " ", "r0"}], "-", 
  
  RowBox[{"beta", " ", 
   SuperscriptBox["g1", "2"], " ", 
   SuperscriptBox["r0", "2"]}], "+", 
  RowBox[{
   SuperscriptBox["beta", "2"], " ", "g1", " ", "g3", " ", 
   SuperscriptBox["r0", "2"]}]}]], "Output",
 CellChangeTimes->{3.777687412117281*^9},
 CellLabel->
  "Out[155]=",ExpressionUUID->"25070f57-60e5-4716-b71a-d3f3a0804bc2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Together", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "eta"}], " ", "g1"}], "-", 
       RowBox[{"2", " ", "g2", " ", "k"}], "+", "r0", "-", 
       RowBox[{"g0", " ", "r0"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}], 
    RowBox[{"beta", " ", "r0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{" ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"eta", " ", "g0"}], "+", 
        RowBox[{"g1", " ", 
         RowBox[{"(", 
          RowBox[{"k", "-", 
           RowBox[{"beta", " ", "r0"}]}], ")"}]}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "eta", " ", "g2"}], "+", 
        RowBox[{"g1", " ", "r0"}]}], ")"}]}]}], 
    RowBox[{"beta", " ", "r0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}], "]"}]], "Input",
 CellChangeTimes->{{3.777687510061418*^9, 3.7776875130444317`*^9}},
 CellLabel->
  "In[156]:=",ExpressionUUID->"6b55d851-b692-40aa-aa80-934e40dd8906"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"beta", " ", "r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["eta", "2"]}], " ", 
     SuperscriptBox["g1", "2"]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["eta", "2"], " ", "g0", " ", "g2"}], "-", 
    RowBox[{"eta", " ", "g1", " ", "g2", " ", "k"}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["g2", "2"], " ", 
     SuperscriptBox["k", "2"]}], "+", 
    RowBox[{"eta", " ", "g1", " ", "r0"}], "-", 
    RowBox[{"eta", " ", "g0", " ", "g1", " ", "r0"}], "-", 
    RowBox[{"2", " ", "beta", " ", "eta", " ", "g1", " ", "g2", " ", "r0"}], 
    "+", 
    RowBox[{
     SuperscriptBox["g1", "2"], " ", "k", " ", "r0"}], "+", 
    RowBox[{"g2", " ", "k", " ", "r0"}], "-", 
    RowBox[{"3", " ", "g0", " ", "g2", " ", "k", " ", "r0"}], "+", 
    RowBox[{"g0", " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{
     SuperscriptBox["g0", "2"], " ", 
     SuperscriptBox["r0", "2"]}], "-", 
    RowBox[{"beta", " ", 
     SuperscriptBox["g1", "2"], " ", 
     SuperscriptBox["r0", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.777687517009561*^9},
 CellLabel->
  "Out[156]=",ExpressionUUID->"44195201-3820-4c23-ba0d-3683ee3c1147"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.777687518812541*^9, 3.7776875220123863`*^9}},
 CellLabel->
  "In[157]:=",ExpressionUUID->"2f90a405-0fe0-4461-b3e3-e46f6ec2e48d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"g2", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["eta", "2"], "-", 
          RowBox[{"2", " ", "k", " ", "r0"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{"1", "-", "g0"}], ")"}]}], "+", 
       RowBox[{
        SuperscriptBox["r0", "2"], " ", "beta"}], "+", 
       RowBox[{"2", " ", "g2", " ", 
        SuperscriptBox["k", "2"]}], "+", 
       RowBox[{"eta", " ", "g1", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "k"}], " ", "-", " ", "zeta"}], ")"}]}]}], ")"}]}], 
    RowBox[{"beta", " ", "r0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}], "+", 
  FractionBox[
   RowBox[{" ", 
    RowBox[{"c2", " ", "g3", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", "k"}], " ", "+", " ", "zeta"}], ")"}]}]}], 
   RowBox[{"beta", " ", "r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}]], "Input",
 CellChangeTimes->{{3.777687530380013*^9, 3.777687879159095*^9}, {
  3.777687917823903*^9, 3.777687936560802*^9}, {3.777688030089779*^9, 
  3.77768808941852*^9}, {3.777688120826095*^9, 3.777688145831245*^9}, {
  3.777688482070126*^9, 3.77768848317271*^9}},
 CellLabel->
  "In[169]:=",ExpressionUUID->"089c7967-d829-4960-8c3b-ac7440dba937"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"g2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "g2", " ", 
        SuperscriptBox["k", "2"]}], "+", 
       RowBox[{"beta", " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", "g0"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["eta", "2"], "-", 
          RowBox[{"2", " ", "k", " ", "r0"}]}], ")"}]}], "+", 
       RowBox[{"eta", " ", "g1", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "k"}], "-", "zeta"}], ")"}]}]}], ")"}]}], 
    RowBox[{"beta", " ", "r0", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"eta", " ", "g1"}], "+", 
       RowBox[{"g2", " ", "k"}], "+", 
       RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}], "+", 
  FractionBox[
   RowBox[{"g3", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "k"}], "+", "zeta"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g0"}], "+", 
      RowBox[{"g1", " ", "zeta"}]}], ")"}]}], 
   RowBox[{"beta", " ", "r0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"eta", " ", "g1"}], "+", 
      RowBox[{"g2", " ", "k"}], "+", 
      RowBox[{"g0", " ", "r0"}]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{3.7776881538407297`*^9, 3.777688490673962*^9},
 CellLabel->
  "Out[169]=",ExpressionUUID->"04c21d6f-72e6-4f05-9a0c-43a8c383b6f5"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.777688503819888*^9, 
  3.777688505516943*^9}},ExpressionUUID->"a9391bbf-0595-4347-93de-\
9768c56a7c44"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g2", " ", 
   RowBox[{"(", " ", 
    RowBox[{
     RowBox[{"2", " ", "k", " ", 
      RowBox[{"(", " ", 
       RowBox[{"r", "-", "r0"}], ")"}]}], "+", 
     RowBox[{"beta", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["r0", "2"], "+", " ", 
        RowBox[{
         SuperscriptBox["eta", "2"], "  ", "g2"}]}], ")"}]}], "-", 
     RowBox[{"zeta", " ", "eta", " ", "g1"}]}], "  ", ")"}]}], " ", "+", " ", 
  
  RowBox[{"c2", " ", "g3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", "k"}], " ", "+", " ", "zeta"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.777688537729327*^9, 3.777688637404704*^9}, {
  3.777688674215783*^9, 3.777688691421794*^9}, {3.7776887302369337`*^9, 
  3.777688769013385*^9}, {3.777688800681633*^9, 3.777688808864553*^9}, {
  3.777688999751025*^9, 
  3.777689048570714*^9}},ExpressionUUID->"1729bf4d-eb59-470c-9804-\
7b824d5b5969"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sin", "[", "gamma", "]"}], "-", 
    RowBox[{"gamma", "*", 
     RowBox[{"Cos", "[", "gamma", "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7780094123132277`*^9, 3.778009422111005*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"85af6a6a-b58d-4675-ba69-688be6c33959"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "3"], "3"], "-", 
   FractionBox[
    SuperscriptBox["gamma", "5"], "30"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "6"],
    SeriesData[$CellContext`gamma, 0, {}, 3, 6, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
    Rational[1, 3], 0, 
    Rational[-1, 30]}, 3, 6, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.778009422326097*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"92c59ee2-e927-4c3d-ae97-b7547f699306"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"2", "-", 
    RowBox[{"2", "*", 
     RowBox[{"Cos", "[", "gamma", "]"}]}], "-", 
    RowBox[{"gamma", "*", 
     RowBox[{"Sin", "[", "gamma", "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7780094602625647`*^9, 3.778009467117646*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"1501d5c2-e601-4b11-b146-c7575c97b387"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox["gamma", "4"], "12"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "6"],
    SeriesData[$CellContext`gamma, 0, {}, 4, 6, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 0, {
    Rational[1, 12]}, 4, 6, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.778009467385152*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"409e154c-42da-4f46-adf7-c38a9339e3ba"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", " ", "work", " ", "on", " ", "dv0", " ", 
   RowBox[{"terms", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.778009582579817*^9, 3.7780095912255507`*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"ec1b11da-dbc2-472e-b188-f2789fe3fec0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             FractionBox["c18", "beta"], "-", 
             FractionBox[
              RowBox[{"d", " ", "c2"}], "r"]}], ")"}], "/.", " ", 
           RowBox[{"zeta", " ", "\[Rule]", " ", 
            RowBox[{"k", " ", "-", " ", 
             RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
          RowBox[{"d", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"h", "+", 
              RowBox[{"eta", "*", "g2"}], "+", 
              RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], 
         " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"Cos", "[", "gamma", "]"}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7780095966980953`*^9, 3.7780096082197123`*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"d35742dd-005a-48b9-a996-58efb006793a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"r0", " ", 
     SuperscriptBox["gamma", "2"]}], "beta"], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"3", " ", "k", " ", "r0"}], "+", 
       RowBox[{"2", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"12", " ", 
     SuperscriptBox["beta", "2"], " ", "r0"}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"5", " ", 
          SuperscriptBox["eta", "2"]}], "-", 
         RowBox[{"8", " ", "k", " ", "r0"}], "+", 
         RowBox[{"5", " ", "beta", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"20", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", 
        RowBox[{"5", "/", "2"}]], " ", 
       SuperscriptBox["r0", "2"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"90", " ", 
        SuperscriptBox["eta", "4"]}], "-", 
       RowBox[{"189", " ", 
        SuperscriptBox["eta", "2"], " ", "k", " ", "r0"}], "+", 
       RowBox[{"120", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{"54", " ", 
        SuperscriptBox["k", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"84", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "+", 
       RowBox[{"31", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "4"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"360", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 2, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {$CellContext`beta^(-1) $CellContext`r0, 0, 
    Rational[1, 12] $CellContext`beta^(-2) $CellContext`r0^(-1) (
     3 $CellContext`eta^2 - 3 $CellContext`k $CellContext`r0 + 
     2 $CellContext`beta $CellContext`r0^2), 
    Rational[-1, 20] $CellContext`beta^
     Rational[-5, 2] $CellContext`eta $CellContext`r0^(-2) (
     5 $CellContext`eta^2 - 8 $CellContext`k $CellContext`r0 + 
     5 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 360] $CellContext`beta^(-3) $CellContext`r0^(-3) (
     90 $CellContext`eta^4 - 
     189 $CellContext`eta^2 $CellContext`k $CellContext`r0 + 
     120 $CellContext`beta $CellContext`eta^2 $CellContext`r0^2 + 
     54 $CellContext`k^2 $CellContext`r0^2 - 
     84 $CellContext`beta $CellContext`k $CellContext`r0^3 + 
     31 $CellContext`beta^2 $CellContext`r0^4)}, 2, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.778009608923917*^9, 3.77800962246436*^9}},
 CellLabel->"Out[13]=",ExpressionUUID->"d4ade39a-f624-44e9-8274-8a53f3e68dd0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"g1", "-", 
             FractionBox[
              RowBox[{"g2", " ", "c2"}], "r"]}], ")"}], "/.", " ", 
           RowBox[{"zeta", " ", "\[Rule]", " ", 
            RowBox[{"k", " ", "-", " ", 
             RowBox[{"beta", " ", "r0"}]}]}]}], " ", "/.", " ", 
          RowBox[{"d", " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"h", "+", 
              RowBox[{"eta", "*", "g2"}], "+", 
              RowBox[{"2", "*", "k", "*", "g3"}]}], ")"}], "/", "beta"}]}]}], 
         " ", "/.", " ", 
         RowBox[{"h", " ", "\[Rule]", " ", 
          RowBox[{
           RowBox[{"r0", " ", "g1"}], " ", "+", " ", 
           RowBox[{"eta", " ", "g2"}], " ", "+", " ", 
           RowBox[{"k", " ", "g3"}]}]}]}], " ", "/.", " ", 
        RowBox[{"r", " ", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"r0", " ", "g0"}], " ", "+", " ", 
          RowBox[{"eta", " ", "g1"}], " ", "+", " ", 
          RowBox[{"k", " ", "g2"}]}]}]}], " ", "/.", " ", 
       RowBox[{"g0", " ", "\[Rule]", " ", 
        RowBox[{"Cos", "[", "gamma", "]"}]}]}], " ", "/.", " ", 
      RowBox[{"g1", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "gamma", "]"}], "/", 
        RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], " ", "/.", " ", 
     RowBox[{"g2", " ", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "gamma", "]"}]}], ")"}], "/", "beta"}]}]}], " ", 
    "/.", " ", 
    RowBox[{"g3", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"gamma", "-", 
         RowBox[{"Sin", "[", "gamma", "]"}]}], ")"}], "/", "beta"}], "/", 
      RowBox[{"Sqrt", "[", "beta", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"gamma", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.778009652575923*^9, 3.778009657135393*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"2c474767-c8ab-4076-ab69-93b5eb60b292"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox["gamma", 
    SqrtBox["beta"]], "-", 
   FractionBox[
    RowBox[{"eta", " ", 
     SuperscriptBox["gamma", "2"]}], 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"beta", " ", "r0"}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", 
        SuperscriptBox["eta", "2"]}], "-", 
       RowBox[{"3", " ", "k", " ", "r0"}], "+", 
       RowBox[{"2", " ", "beta", " ", 
        SuperscriptBox["r0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "3"]}], 
    RowBox[{"6", " ", 
     SuperscriptBox["beta", 
      RowBox[{"3", "/", "2"}]], " ", 
     SuperscriptBox["r0", "2"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"eta", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"12", " ", 
          SuperscriptBox["eta", "2"]}], "-", 
         RowBox[{"18", " ", "k", " ", "r0"}], "+", 
         RowBox[{"11", " ", "beta", " ", 
          SuperscriptBox["r0", "2"]}]}], ")"}]}], ")"}], " ", 
     SuperscriptBox["gamma", "4"]}], 
    RowBox[{"24", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["beta", "2"], " ", 
       SuperscriptBox["r0", "3"]}], ")"}]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"60", " ", 
        SuperscriptBox["eta", "4"]}], "-", 
       RowBox[{"120", " ", 
        SuperscriptBox["eta", "2"], " ", "k", " ", "r0"}], "+", 
       RowBox[{"75", " ", "beta", " ", 
        SuperscriptBox["eta", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{"30", " ", 
        SuperscriptBox["k", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"45", " ", "beta", " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "+", 
       RowBox[{"16", " ", 
        SuperscriptBox["beta", "2"], " ", 
        SuperscriptBox["r0", "4"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "5"]}], 
    RowBox[{"120", " ", 
     SuperscriptBox["beta", 
      RowBox[{"5", "/", "2"}]], " ", 
     SuperscriptBox["r0", "4"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "360"}], " ", 
        SuperscriptBox["eta", "5"]}], "+", 
       RowBox[{"900", " ", 
        SuperscriptBox["eta", "3"], " ", "k", " ", "r0"}], "-", 
       RowBox[{"570", " ", "beta", " ", 
        SuperscriptBox["eta", "3"], " ", 
        SuperscriptBox["r0", "2"]}], "-", 
       RowBox[{"450", " ", "eta", " ", 
        SuperscriptBox["k", "2"], " ", 
        SuperscriptBox["r0", "2"]}], "+", 
       RowBox[{"630", " ", "beta", " ", "eta", " ", "k", " ", 
        SuperscriptBox["r0", "3"]}], "-", 
       RowBox[{"211", " ", 
        SuperscriptBox["beta", "2"], " ", "eta", " ", 
        SuperscriptBox["r0", "4"]}]}], ")"}], " ", 
     SuperscriptBox["gamma", "6"]}], 
    RowBox[{"720", " ", 
     SuperscriptBox["beta", "3"], " ", 
     SuperscriptBox["r0", "5"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "gamma", "]"}], "7"],
    SeriesData[$CellContext`gamma, 0, {}, 1, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`gamma, 
   0, {$CellContext`beta^Rational[-1, 2], 
    Rational[-1, 2] $CellContext`beta^(-1) $CellContext`eta/$CellContext`r0, 
    Rational[1, 6] $CellContext`beta^Rational[-3, 2] $CellContext`r0^(-2) (
     3 $CellContext`eta^2 - 3 $CellContext`k $CellContext`r0 + 
     2 $CellContext`beta $CellContext`r0^2), 
    Rational[-1, 
      24] $CellContext`beta^(-2) $CellContext`eta $CellContext`r0^(-3) (
     12 $CellContext`eta^2 - 18 $CellContext`k $CellContext`r0 + 
     11 $CellContext`beta $CellContext`r0^2), 
    Rational[1, 120] $CellContext`beta^Rational[-5, 2] $CellContext`r0^(-4) (
     60 $CellContext`eta^4 - 
     120 $CellContext`eta^2 $CellContext`k $CellContext`r0 + 
     75 $CellContext`beta $CellContext`eta^2 $CellContext`r0^2 + 
     30 $CellContext`k^2 $CellContext`r0^2 - 
     45 $CellContext`beta $CellContext`k $CellContext`r0^3 + 
     16 $CellContext`beta^2 $CellContext`r0^4), 
    Rational[1, 
      720] $CellContext`beta^(-3) $CellContext`r0^(-5) ((-360) \
$CellContext`eta^5 + 900 $CellContext`eta^3 $CellContext`k $CellContext`r0 - 
     570 $CellContext`beta $CellContext`eta^3 $CellContext`r0^2 - 
     450 $CellContext`eta $CellContext`k^2 $CellContext`r0^2 + 
     630 $CellContext`beta $CellContext`eta $CellContext`k $CellContext`r0^3 - 
     211 $CellContext`beta^2 $CellContext`eta $CellContext`r0^4)}, 1, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.778009657718514*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"7f5aea8c-3ef9-4aff-bc05-899d311c187e"]
}, Open  ]]
},
WindowSize->{1168, 448},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 2626, 67, 241, "Input",ExpressionUUID->"53329b6c-a80c-45ac-ae62-f6fb243392bd"],
Cell[CellGroupData[{
Cell[3209, 91, 1324, 34, 72, "Input",ExpressionUUID->"e5f914b2-2bf0-439b-99e7-b7d2a93687e8"],
Cell[4536, 127, 988, 29, 68, "Output",ExpressionUUID->"666ae5c6-74f7-420b-9ac0-d403cfd3414a"]
}, Open  ]],
Cell[5539, 159, 321, 7, 30, "Input",ExpressionUUID->"2f6f7e0a-c2ad-49e5-8b90-c04b02c368c6"],
Cell[CellGroupData[{
Cell[5885, 170, 1505, 44, 51, "Input",ExpressionUUID->"ec64950c-8ed3-4bc5-92a5-293069313a0b"],
Cell[7393, 216, 2044, 66, 113, "Output",ExpressionUUID->"3770f022-6acc-4f7f-a219-ed754408e3e5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9474, 287, 377, 8, 30, "Input",ExpressionUUID->"c4b0219d-ef0f-4a85-945c-de2fde90772c"],
Cell[9854, 297, 2462, 80, 132, "Output",ExpressionUUID->"29f840c4-488b-432b-9973-45ca2eb6707e"]
}, Open  ]],
Cell[12331, 380, 341, 7, 30, "Input",ExpressionUUID->"a0dc16c1-4e69-452c-8e92-3882ad81c7a0"],
Cell[CellGroupData[{
Cell[12697, 391, 1285, 38, 92, "Input",ExpressionUUID->"6fc80348-8701-42b8-941c-aba055c6950d"],
Cell[13985, 431, 1229, 39, 60, "Output",ExpressionUUID->"e37154ef-e2e0-406d-862d-8ae2948c20c2"]
}, Open  ]],
Cell[15229, 473, 343, 7, 30, "Input",ExpressionUUID->"507dd5b7-ef16-44eb-8611-1dc7859ff397"],
Cell[CellGroupData[{
Cell[15597, 484, 901, 27, 49, "Input",ExpressionUUID->"1c537293-a305-4491-a817-7d634f355c31"],
Cell[16501, 513, 846, 27, 52, "Output",ExpressionUUID->"2609cb88-9c8e-498e-a159-839bc823a6f8"]
}, Open  ]],
Cell[17362, 543, 299, 6, 52, "Input",ExpressionUUID->"1a4c8f3a-b75b-48ed-beb7-b2cf30e7c278"],
Cell[CellGroupData[{
Cell[17686, 553, 3066, 94, 139, "Input",ExpressionUUID->"7265319b-5e94-4716-964b-84c370c87f44"],
Cell[20755, 649, 2894, 93, 141, "Output",ExpressionUUID->"ab49fdcb-57cc-4dfd-a1c2-131b436807eb"]
}, Open  ]],
Cell[23664, 745, 275, 6, 30, "Input",ExpressionUUID->"465f61e6-4806-4c84-b46a-d0212f95aef1"],
Cell[CellGroupData[{
Cell[23964, 755, 471, 11, 52, "Input",ExpressionUUID->"35128fa6-b90d-44dc-8a05-73b192494862"],
Cell[24438, 768, 245, 5, 34, "Output",ExpressionUUID->"7f0084e7-45c4-44b4-a9d3-64047bd33f7e"],
Cell[24686, 775, 276, 6, 34, "Output",ExpressionUUID->"55dbcfdc-5b11-474a-8d88-781ad787b649"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24999, 786, 654, 17, 115, "Input",ExpressionUUID->"2a714c0a-26b6-4af3-b4b4-84624d8dd831"],
Cell[25656, 805, 272, 6, 34, "Output",ExpressionUUID->"6e3e5910-2e21-4243-b36f-0b1ae27c673a"],
Cell[25931, 813, 295, 7, 34, "Output",ExpressionUUID->"47f3aa61-866f-45c2-9a0a-9ad6a7cce5f2"],
Cell[26229, 822, 276, 6, 34, "Output",ExpressionUUID->"dc203eb4-12f2-46d5-9d65-727805327026"],
Cell[26508, 830, 280, 6, 34, "Output",ExpressionUUID->"32f2d053-5982-42c5-89a5-aa3afa450edb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26825, 841, 424, 10, 30, "Input",ExpressionUUID->"96b6ff65-6634-497a-8de9-0d0d83da9948"],
Cell[27252, 853, 308, 8, 34, "Output",ExpressionUUID->"539de3a3-7523-4f52-80a4-1c3f656961a8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27597, 866, 2020, 55, 50, "Input",ExpressionUUID->"4ad8ae13-624c-4edc-add5-8945550baa52"],
Cell[29620, 923, 2942, 93, 141, "Output",ExpressionUUID->"71e24d8e-6fd7-41ca-adee-032d8e0030ad"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32599, 1021, 207, 3, 30, "Input",ExpressionUUID->"bed2008b-362d-4933-ad8c-fe8df2f4d579"],
Cell[32809, 1026, 220, 3, 34, "Output",ExpressionUUID->"9317a971-879f-42ab-94f3-7cc1d1a9fd97"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33066, 1034, 3026, 77, 170, "Input",ExpressionUUID->"e51d915d-5efd-4b6c-866e-d405aaaeb9bb"],
Cell[36095, 1113, 3421, 93, 109, "Output",ExpressionUUID->"16ef7ff4-b10c-46d0-a144-c1dcce0c9795"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39553, 1211, 1513, 44, 72, "Input",ExpressionUUID->"dde0987e-5893-4b60-9997-a7036c644bc5"],
Cell[41069, 1257, 1081, 35, 61, "Output",ExpressionUUID->"4e528249-bf3f-46a1-bbbe-4fd2ea190eb6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42187, 1297, 1495, 47, 59, "Input",ExpressionUUID->"b1361dc9-8acf-43f2-b35f-015781a7e929"],
Cell[43685, 1346, 1081, 35, 61, "Output",ExpressionUUID->"9c3ba387-d018-4421-83ae-b19f6ed1d6dc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44803, 1386, 1553, 47, 51, "Input",ExpressionUUID->"a28ebeb5-b47c-4aa0-80fb-c2be45adfd29"],
Cell[46359, 1435, 1837, 48, 77, "Output",ExpressionUUID->"ef0abb71-0d48-414d-8388-66e53c41a364"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48233, 1488, 210, 4, 30, "Input",ExpressionUUID->"403558c3-5405-4c45-b37b-15d6b3d05060"],
Cell[48446, 1494, 2041, 63, 77, "Output",ExpressionUUID->"cd185f65-d9b0-47fb-ac0c-7a843a95e4b4"]
}, Open  ]],
Cell[50502, 1560, 152, 3, 30, "Input",ExpressionUUID->"49a95502-6a91-44b2-b215-7fef75f3a2f9"],
Cell[50657, 1565, 2279, 66, 77, "Input",ExpressionUUID->"a911f544-7ddd-4477-b32b-003214c3974d"],
Cell[CellGroupData[{
Cell[52961, 1635, 2611, 77, 98, "Input",ExpressionUUID->"9bf17d1b-9add-4996-b705-efe7c4b6bee7"],
Cell[55575, 1714, 1280, 41, 37, "Output",ExpressionUUID->"b4fcf4e9-8a23-48a6-9818-3bf890de6ab0"]
}, Open  ]],
Cell[56870, 1758, 2176, 65, 54, "Input",ExpressionUUID->"40bcf25e-315c-48ed-883e-b0c699cec7df"],
Cell[CellGroupData[{
Cell[59071, 1827, 380, 9, 30, "Input",ExpressionUUID->"7972035a-9f7e-466b-917f-88e2a6275e9b"],
Cell[59454, 1838, 2672, 76, 106, "Output",ExpressionUUID->"4b24ffd2-1590-4db1-8c32-3edb387a1530"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62163, 1919, 560, 18, 52, "Input",ExpressionUUID->"d866cb59-f099-488e-86d0-5acb2e2b2fa1"],
Cell[62726, 1939, 603, 19, 55, "Output",ExpressionUUID->"e3351912-0137-4406-928b-390394f85273"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63366, 1963, 212, 4, 30, "Input",ExpressionUUID->"a4ac245f-8857-4caf-bc9c-593d3b13aac2"],
Cell[63581, 1969, 479, 14, 53, "Output",ExpressionUUID->"eb4c6435-951d-40c8-b045-1cff71cce1ba"]
}, Open  ]],
Cell[CellGroupData[{
Cell[64097, 1988, 327, 8, 30, "Input",ExpressionUUID->"3c5dd138-7285-4d13-9878-70b7b5cfde4d"],
Cell[64427, 1998, 621, 18, 55, "Output",ExpressionUUID->"a400562a-4a86-4955-bef3-ad1f6d719d37"]
}, Open  ]],
Cell[CellGroupData[{
Cell[65085, 2021, 1499, 45, 56, "Input",ExpressionUUID->"4ee06fd5-1098-4c0c-937b-45dd7dbcd037"],
Cell[66587, 2068, 1204, 37, 37, "Output",ExpressionUUID->"51f7997d-097a-4c96-a79f-ff3af9fbf8fc"]
}, Open  ]],
Cell[67806, 2108, 942, 28, 33, "Input",ExpressionUUID->"4b6aa8b7-2cef-4f3d-b0d9-a9fc057fba50"],
Cell[CellGroupData[{
Cell[68773, 2140, 2796, 77, 116, "Input",ExpressionUUID->"90d4b59e-fb75-419d-993a-e3fe90469951"],
Cell[71572, 2219, 2774, 90, 109, "Output",ExpressionUUID->"1a695dc6-59cc-48a0-a39a-73a783fec76d"]
}, Open  ]],
Cell[74361, 2312, 212, 4, 30, "Input",ExpressionUUID->"8f0ceb9d-8f46-4eb8-834f-30d2587c354a"],
Cell[CellGroupData[{
Cell[74598, 2320, 739, 23, 55, "Input",ExpressionUUID->"d0217afd-068b-4b89-9ddf-7055cec71f74"],
Cell[75340, 2345, 152, 3, 34, "Output",ExpressionUUID->"677d4a4b-93d6-4674-aecf-cc935406d9be"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75529, 2353, 560, 16, 30, "Input",ExpressionUUID->"e18a2432-fcf2-49b0-b974-ecee93b85e1e"],
Cell[76092, 2371, 817, 21, 34, "Output",ExpressionUUID->"9f69bb1c-f456-43cf-a972-21216b0066a5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76946, 2397, 660, 19, 30, "Input",ExpressionUUID->"322441a2-d507-4584-b10f-e7387c945d7d"],
Cell[77609, 2418, 1023, 24, 56, "Output",ExpressionUUID->"25070f57-60e5-4716-b71a-d3f3a0804bc2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78669, 2447, 1427, 44, 51, "Input",ExpressionUUID->"6b55d851-b692-40aa-aa80-934e40dd8906"],
Cell[80099, 2493, 1408, 39, 77, "Output",ExpressionUUID->"44195201-3820-4c23-ba0d-3683ee3c1147"]
}, Open  ]],
Cell[81522, 2535, 212, 4, 30, "Input",ExpressionUUID->"2f90a405-0fe0-4461-b3e3-e46f6ec2e48d"],
Cell[CellGroupData[{
Cell[81759, 2543, 1545, 45, 55, "Input",ExpressionUUID->"089c7967-d829-4960-8c3b-ac7440dba937"],
Cell[83307, 2590, 1453, 45, 58, "Output",ExpressionUUID->"04c21d6f-72e6-4f05-9a0c-43a8c383b6f5"]
}, Open  ]],
Cell[84775, 2638, 152, 3, 30, "Input",ExpressionUUID->"a9391bbf-0595-4347-93de-9768c56a7c44"],
Cell[84930, 2643, 918, 25, 33, "Input",ExpressionUUID->"1729bf4d-eb59-470c-9804-7b824d5b5969"],
Cell[CellGroupData[{
Cell[85873, 2672, 417, 10, 30, "Input",ExpressionUUID->"85af6a6a-b58d-4675-ba69-688be6c33959"],
Cell[86293, 2684, 578, 17, 54, "Output",ExpressionUUID->"92c59ee2-e927-4c3d-ae97-b7547f699306"]
}, Open  ]],
Cell[CellGroupData[{
Cell[86908, 2706, 453, 11, 30, "Input",ExpressionUUID->"1501d5c2-e601-4b11-b146-c7575c97b387"],
Cell[87364, 2719, 491, 14, 53, "Output",ExpressionUUID->"409e154c-42da-4f46-adf7-c38a9339e3ba"]
}, Open  ]],
Cell[87870, 2736, 291, 5, 30, "Input",ExpressionUUID->"ec1b11da-dbc2-472e-b188-f2789fe3fec0"],
Cell[CellGroupData[{
Cell[88186, 2745, 2216, 58, 128, "Input",ExpressionUUID->"d35742dd-005a-48b9-a996-58efb006793a"],
Cell[90405, 2805, 3111, 82, 109, "Output",ExpressionUUID->"d4ade39a-f624-44e9-8274-8a53f3e68dd0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93553, 2892, 2177, 57, 124, "Input",ExpressionUUID->"2c474767-c8ab-4076-ab69-93b5eb60b292"],
Cell[95733, 2951, 4681, 121, 190, "Output",ExpressionUUID->"7f5aea8c-3ef9-4aff-bc05-899d311c187e"]
}, Open  ]]
}
]
*)

